diff -pruN 1.6.1+git20170613-2/CHANGELOG.md 2.0.0-3/CHANGELOG.md
--- 1.6.1+git20170613-2/CHANGELOG.md	2017-06-03 16:42:55.000000000 +0000
+++ 2.0.0-3/CHANGELOG.md	2018-08-23 16:26:20.000000000 +0000
@@ -1,5 +1,71 @@
 # Version history
 
+## 2.0.0 (08/23/2018)
+### Breaking changes
+* library functions now accept iterators prototyped as `f(v, k, ...)` instead of `f(k, v, ...)`.
+It improves the benefits of chaning and helps writting a clear functional-style code.
+Library functions affected with this breaking change are : 
+`each`, `eachi`,`countf`, `map`, `reduceby`, `select`, `reject`, `all`, `groupBy`, `countBy`, 
+`selectWhile`, `dropWhile`, `findIndex`, `findLastIndex`, `chunk`.
+* `reduceby` is now prototyped as `reduceby(t, f, pred, state)` instead of `reduceby(t, f, state, pred)`.
+* `times` is now prototyped as `times(iter, n, ...)` instead of `times(iter, n, ...)`.
+* `bindAll` was renamed to `bindall`
+* `functions` no longer accept optional `sort` third arguments
+* `sliding` was renamed to `overlapping`
+* Improved `range` to handle negative progressions and start the count from 1.
+* `memoize` no longer takes a `hash` function.
+
+### Other changes
+* Made `shift` a default library function, and `pop` its alias.
+* Moved `shuffle` from table function to array functions
+* Made `iterator` to accept an extra optional arg `n`
+
+### Additions
+
+#### Added support for operators
+* Arithmetic operators : `add`, `sub`, `mul`, `div`, `mod`, `exp`, `pow` (alias to `exp`), `unm`, `neg` (alias to `unm`), `floordiv`, `intdiv`
+* Relational operators : `eq`, `neq`, `lt`, `gt`, `le`, `ge`
+* Logical operators : `land`, `lor`, `lnot`
+* Concatenation operator : `concat`
+* Length operator : `length`, `len` (alias to `length`)
+
+#### Added functions
+* Added `adjust` in table functions
+* Added `xprod` in array functions
+* Added `prepend` in array functions
+* Added `zeros` in array functions
+* Added `ones` in array functions
+* Added `vector` in array functions
+* Added `aperture` in array functions
+* Added `sum` in array functions
+* Added `product` in array functions
+* Added `mean` in array functions
+* Added `median` in array functions
+* Added `powerset` in array functions
+* Added `zipWith` in array functions
+* Added `pairwise` in array functions
+* Added `applySpec` in utility functions
+* Added `nthArg` in utility functions
+* Added `cond` in utility functions
+* Added `castArray` in utility functions
+* Added `unary` in utility functions
+* Added `ary` in utility functions
+* Added `rearg` in utility functions
+* Added `unfold` in utility functions
+* Added `converge` in utility functions
+* Added `path` in object functions
+
+#### Added function aliases
+* Added `update` as alias to `adjust`
+* Added `always` as alias to `constant`
+* Added `intersperse` as alias to `interpose`
+* Added `sliding` as alias to `aperture`
+* Added `tabulate` as alias to `array`
+* Added `matches` as alias to `isEqual`
+* Added `average` as alias to `mean`
+* Added `nAry` as alias to `ary`
+* Added `transposeWith` as alias to `zipWith`
+
 ## 1.6.1 (04/27/17)
 
 * Added `_.array`
diff -pruN 1.6.1+git20170613-2/debian/changelog 2.0.0-3/debian/changelog
--- 1.6.1+git20170613-2/debian/changelog	2018-05-18 05:33:52.000000000 +0000
+++ 2.0.0-3/debian/changelog	2018-09-12 10:12:22.000000000 +0000
@@ -1,3 +1,24 @@
+lua-moses (2.0.0-3) unstable; urgency=medium
+
+  * lua-moses 2.0.0 Breaks lua-torch-nn (<= 0~20171002-g8726825+dfsg-3)
+    (Closes: #907791)
+
+ -- Mo Zhou <cdluminate@gmail.com>  Wed, 12 Sep 2018 10:12:22 +0000
+
+lua-moses (2.0.0-2) unstable; urgency=medium
+
+  * Upload to unstable.
+
+ -- Mo Zhou <cdluminate@gmail.com>  Fri, 31 Aug 2018 16:34:19 +0000
+
+lua-moses (2.0.0-1) experimental; urgency=medium
+
+  * New upstream version 2.0.0
+  * Bump Standards-Version to 4.2.1 (no change).
+  * Refresh copyright. Refer to the lincense as "Expat" instead of "MIT".
+
+ -- Mo Zhou <cdluminate@gmail.com>  Mon, 27 Aug 2018 13:57:01 +0000
+
 lua-moses (1.6.1+git20170613-2) unstable; urgency=medium
 
   * Packaging repo was moved to Science Team (Salsa).
diff -pruN 1.6.1+git20170613-2/debian/control 2.0.0-3/debian/control
--- 1.6.1+git20170613-2/debian/control	2018-05-18 05:33:52.000000000 +0000
+++ 2.0.0-3/debian/control	2018-09-12 10:11:19.000000000 +0000
@@ -4,7 +4,7 @@ Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Mo Zhou <cdluminate@gmail.com>
 Build-Depends: debhelper (>= 11), dh-lua
-Standards-Version: 4.1.4
+Standards-Version: 4.2.1
 Homepage: https://yonaba.github.com/Moses/
 Vcs-Git: https://salsa.debian.org/science-team/lua-moses.git
 Vcs-Browser: https://salsa.debian.org/science-team/lua-moses
@@ -13,6 +13,7 @@ Package: lua-moses
 Architecture: all
 Multi-Arch: foreign
 Depends: ${misc:Depends}
+Breaks: lua-torch-nn (<= 0~20171002-g8726825+dfsg-3),
 XB-Lua-Versions: ${lua:Versions}
 Description: Utility library for functional programming in Lua
  A Lua utility-belt library for functional programming. It complements
diff -pruN 1.6.1+git20170613-2/debian/copyright 2.0.0-3/debian/copyright
--- 1.6.1+git20170613-2/debian/copyright	2018-05-18 05:33:52.000000000 +0000
+++ 2.0.0-3/debian/copyright	2018-08-27 13:54:16.000000000 +0000
@@ -4,22 +4,13 @@ Source: https://yonaba.github.io/Moses/
 
 Files: *
 Copyright: 2012-2017 Roland Yonaba.
-License: MIT
-
-Files: doc/ldoc.css
-Copyright: 2010, Yahoo! Inc.
-License: BSD-3-Clause-YUI
-# The author declared the BSD license but the license page does not exist
-# any more: https://developer.yahoo.com/yui/license.html
-# The license link on the page http://developer.yahoo.com/yui points
-# to a BSD-3-Clause license: https://github.com/yui/yui3/blob/master/LICENSE.md
-# The following BSD-3-Clause is copied from that license.
+License: Expat
 
 Files: debian/*
 Copyright: 2017 Mo Zhou <cdluminate@gmail.com>
-License: MIT
+License: Expat
 
-License: MIT
+License: Expat
  Permission is hereby granted, free of charge, to any person obtaining a
  copy of this software and associated documentation files (the
  "Software"), to deal in the Software without restriction, including
@@ -38,28 +29,3 @@ License: MIT
  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
-
-License: BSD-3-Clause-YUI
- Redistribution and use of this software in source and binary forms, with or
- without modification, are permitted provided that the following conditions are
- met:
- .
-   * Redistributions of source code must retain the above copyright notice, this
-     list of conditions and the following disclaimer.
-   * Redistributions in binary form must reproduce the above copyright notice,
-     this list of conditions and the following disclaimer in the documentation
-     and/or other materials provided with the distribution.
-   * Neither the name of Yahoo! Inc. nor the names of YUI's contributors may be
-     used to endorse or promote products derived from this software without
-     specific prior written permission of Yahoo! Inc.
- .
- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
- ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
- WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
- DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
- ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
- (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
- LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
- ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
- (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
- SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
diff -pruN 1.6.1+git20170613-2/doc/index.html 2.0.0-3/doc/index.html
--- 1.6.1+git20170613-2/doc/index.html	2017-06-03 16:42:55.000000000 +0000
+++ 2.0.0-3/doc/index.html	2018-08-23 16:26:20.000000000 +0000
@@ -4,7 +4,7 @@
 <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
 <head>
     <title>Moses documentation</title>
-    <link rel="stylesheet" href="ldoc.css" type="text/css" />
+    <link rel="stylesheet" href="ldoc_fixed.css" type="text/css" />
 </head>
 <body>
 
@@ -29,6 +29,7 @@
 
 <h2>Contents</h2>
 <ul>
+<li><a href="#Operator_functions">Operator functions </a></li>
 <li><a href="#Table_functions">Table functions </a></li>
 <li><a href="#Array_functions">Array functions </a></li>
 <li><a href="#Utility_functions">Utility functions </a></li>
@@ -40,9 +41,9 @@
 <ul class="nowrap">
   <li><strong>moses</strong></li>
 </ul>
-<h2>Topics</h2>
-<ul class="">
-  <li><a href="topics/tutorial.md.html">tutorial</a></li>
+<h2>Manual</h2>
+<ul class="nowrap">
+  <li><a href="manual/tutorial.md.html">tutorial</a></li>
 </ul>
 
 </div>
@@ -52,105 +53,177 @@
 <h1>Module <code>moses</code></h1>
 <p>Utility-belt library for functional programming in Lua (<a href="http://github.com/Yonaba/Moses">source</a>)</p>
 <p>
+
 </p>
     <h3>Info:</h3>
     <ul>
-        <li><strong>Copyright</strong>: 2012-2017</li>
-        <li><strong>Release</strong>: 1.6.1</li>
+        <li><strong>Copyright</strong>: 2012-2018</li>
+        <li><strong>Release</strong>: 2.0.0</li>
         <li><strong>License</strong>: <a href="http://www.opensource.org/licenses/mit-license.php">MIT</a></li>
         <li><strong>Author</strong>: <a href="http://github.com/Yonaba">Roland Yonaba</a></li>
     </ul>
 
 
-<h2><a href="#Table_functions">Table functions </a></h2>
+<h2><a href="#Operator_functions">Operator functions </a></h2>
 <table class="function_list">
 	<tr>
-	<td class="name" nowrap><a href="#clear">clear (t)</a></td>
-	<td class="summary">Clears a table.</td>
+	<td class="name" nowrap><a href="#operator.add">operator.add (a, b)</a></td>
+	<td class="summary">Returns a + b.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#each">each (t, f[, ...])</a></td>
-	<td class="summary">Iterates on key-value pairs, calling <code>f (k, v)</code> at every step.</td>
+	<td class="name" nowrap><a href="#operator.concat">operator.concat (a, b)</a></td>
+	<td class="summary">Returns concatenation of a and b.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#eachi">eachi (t, f[, ...])</a></td>
-	<td class="summary">Iterates on integer key-value pairs, calling <code>f(k, v)</code> every step.</td>
+	<td class="name" nowrap><a href="#operator.div">operator.div (a, b)</a></td>
+	<td class="summary">Returns a / b.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#at">at (t, ...)</a></td>
-	<td class="summary">Collects values at given keys and return them wrapped in an array.</td>
+	<td class="name" nowrap><a href="#operator.eq">operator.eq (a, b)</a></td>
+	<td class="summary">Checks if a equals b.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#count">count (t[, value])</a></td>
-	<td class="summary">Counts occurrences of a given value in a table.</td>
+	<td class="name" nowrap><a href="#operator.exp">operator.exp (a, b)</a></td>
+	<td class="summary">Returns a ^ b.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#countf">countf (t, f[, ...])</a></td>
-	<td class="summary">Counts occurrences validating a predicate.</td>
+	<td class="name" nowrap><a href="#operator.floordiv">operator.floordiv (a, b)</a></td>
+	<td class="summary">Performs floor division (//) between <code>a</code> and <code>b</code>.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#cycle">cycle (t, n)</a></td>
-	<td class="summary">Loops <code>n</code> times through a table.</td>
+	<td class="name" nowrap><a href="#operator.ge">operator.ge (a, b)</a></td>
+	<td class="summary">Returns logical a and b.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#map">map (t, f[, ...])</a></td>
-	<td class="summary">Maps <code>f (k, v)</code> on key-value pairs, collects and returns the results.</td>
+	<td class="name" nowrap><a href="#operator.ge">operator.ge (a, b)</a></td>
+	<td class="summary">Checks if a is greater or equal to b.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#reduce">reduce (t, f[, state])</a></td>
-	<td class="summary">Reduces a table, left-to-right.</td>
+	<td class="name" nowrap><a href="#operator.gt">operator.gt (a, b)</a></td>
+	<td class="summary">Checks if a is strictly greater than b.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#reduceby">reduceby (t, f, state, pred[, ...])</a></td>
-	<td class="summary">Reduces values in a table passing a given predicate.</td>
+	<td class="name" nowrap><a href="#operator.intdiv">operator.intdiv (a, b)</a></td>
+	<td class="summary">Performs integer division between <code>a</code> and <code>b</code>.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#reduceRight">reduceRight (t, f[, state])</a></td>
-	<td class="summary">Reduces a table, right-to-left.</td>
+	<td class="name" nowrap><a href="#operator.le">operator.le (a, b)</a></td>
+	<td class="summary">Checks if a is less or equal to b.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#mapReduce">mapReduce (t, f[, state])</a></td>
-	<td class="summary">Reduces a table while saving intermediate states.</td>
+	<td class="name" nowrap><a href="#operator.length">operator.length (a)</a></td>
+	<td class="summary">Returns the length of a.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#mapReduceRight">mapReduceRight (t, f[, state])</a></td>
-	<td class="summary">Reduces a table while saving intermediate states.</td>
+	<td class="name" nowrap><a href="#operator.lnot">operator.lnot (a)</a></td>
+	<td class="summary">Returns logical not a.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#include">include (t, value)</a></td>
-	<td class="summary">Performs a linear search for a value in a table.</td>
+	<td class="name" nowrap><a href="#operator.lor">operator.lor (a, b)</a></td>
+	<td class="summary">Returns logical a or b.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#detect">detect (t, value)</a></td>
-	<td class="summary">Performs a linear search for a value in a table.</td>
+	<td class="name" nowrap><a href="#operator.lt">operator.lt (a, b)</a></td>
+	<td class="summary">Checks if a is strictly less than b.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#where">where (t, props)</a></td>
-	<td class="summary">Returns all values having specified keys <code>props</code>.</td>
+	<td class="name" nowrap><a href="#operator.mod">operator.mod (a, b)</a></td>
+	<td class="summary">Returns a % b.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#findWhere">findWhere (t, props)</a></td>
-	<td class="summary">Returns the first value having specified keys <code>props</code>.</td>
+	<td class="name" nowrap><a href="#operator.mul">operator.mul (a, b)</a></td>
+	<td class="summary">Returns a * b.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#select">select (t, f[, ...])</a></td>
-	<td class="summary">Selects and returns values passing an iterator test.</td>
+	<td class="name" nowrap><a href="#operator.neq">operator.neq (a, b)</a></td>
+	<td class="summary">Checks if a not equals b.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#reject">reject (t, f[, ...])</a></td>
-	<td class="summary">Clones a table while dropping values passing an iterator test.</td>
+	<td class="name" nowrap><a href="#operator.sub">operator.sub (a, b)</a></td>
+	<td class="summary">Returns a - b.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#operator.unm">operator.unm (a)</a></td>
+	<td class="summary">Returns -a.</td>
+	</tr>
+</table>
+<h2><a href="#Table_functions">Table functions </a></h2>
+<table class="function_list">
+	<tr>
+	<td class="name" nowrap><a href="#adjust">adjust (t, key, f[, ...])</a></td>
+	<td class="summary">Adjusts the value at a given key using a function or a value.</td>
 	</tr>
 	<tr>
 	<td class="name" nowrap><a href="#all">all (t, f[, ...])</a></td>
 	<td class="summary">Checks if all values in a table are passing an iterator test.</td>
 	</tr>
 	<tr>
+	<td class="name" nowrap><a href="#at">at (t, ...)</a></td>
+	<td class="summary">Collects values at given keys and return them wrapped in an array.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#clear">clear (t)</a></td>
+	<td class="summary">Clears a table.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#containsKeys">containsKeys (t, other)</a></td>
+	<td class="summary">Checks if all the keys of <code>other</code> table exists in table <code>t</code>.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#count">count (t[, val])</a></td>
+	<td class="summary">Counts occurrences of a given value in a table.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#countBy">countBy (t, iter[, ...])</a></td>
+	<td class="summary">Groups values in a collection and counts them.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#countf">countf (t, f[, ...])</a></td>
+	<td class="summary">Counts the number of values passing a predicate test.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#cycle">cycle (t[, n])</a></td>
+	<td class="summary">Loops <code>n</code> times through a table.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#detect">detect (t, value)</a></td>
+	<td class="summary">Performs a linear search for a value in a table.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#each">each (t, f[, ...])</a></td>
+	<td class="summary">Iterates on key-value pairs, calling <code>f (v, k)</code> at every step.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#eachi">eachi (t, f[, ...])</a></td>
+	<td class="summary">Iterates on integer key-value pairs, calling <code>f(v, k)</code> every step.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#findWhere">findWhere (t, props)</a></td>
+	<td class="summary">Returns the first value having specified keys <code>props</code>.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#groupBy">groupBy (t, iter[, ...])</a></td>
+	<td class="summary">Splits a table into subsets groups.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#include">include (t, value)</a></td>
+	<td class="summary">Performs a linear search for a value in a table.</td>
+	</tr>
+	<tr>
 	<td class="name" nowrap><a href="#invoke">invoke (t, method[, ...])</a></td>
 	<td class="summary">Invokes a method on each value in a table.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#pluck">pluck (t, key)</a></td>
-	<td class="summary">Extracts values in a table having a given key.</td>
+	<td class="name" nowrap><a href="#map">map (t, f[, ...])</a></td>
+	<td class="summary">Maps <code>f (v, k)</code> on value-key pairs, collects and returns the results.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#mapReduce">mapReduce (t, f[, state])</a></td>
+	<td class="summary">Reduces a table while saving intermediate states.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#mapReduceRight">mapReduceRight (t, f[, state])</a></td>
+	<td class="summary">Reduces a table while saving intermediate states.</td>
 	</tr>
 	<tr>
 	<td class="name" nowrap><a href="#max">max (t[, transform[, ...]])</a></td>
@@ -161,87 +234,95 @@
 	<td class="summary">Returns the min value in a collection.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#shuffle">shuffle (t[, seed])</a></td>
-	<td class="summary">Returns a shuffled copy of a given collection.</td>
+	<td class="name" nowrap><a href="#pluck">pluck (t, key)</a></td>
+	<td class="summary">Extracts values in a table having a given key.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#same">same (a, b)</a></td>
-	<td class="summary">Checks if two tables are the same.</td>
+	<td class="name" nowrap><a href="#reduce">reduce (t, f[, state])</a></td>
+	<td class="summary">Reduces a table, left-to-right.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#sort">sort (t[, comp])</a></td>
-	<td class="summary">Sorts a table, in-place.</td>
+	<td class="name" nowrap><a href="#reduceRight">reduceRight (t, f[, state])</a></td>
+	<td class="summary">Reduces a table, right-to-left.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#sortBy">sortBy (t[, transform[, comp]])</a></td>
-	<td class="summary">Sorts a table in-place using a transform.</td>
+	<td class="name" nowrap><a href="#reduceby">reduceby (t, f, pred[, state[, ...]])</a></td>
+	<td class="summary">Reduces values in a table passing a given predicate.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#groupBy">groupBy (t, iter[, ...])</a></td>
-	<td class="summary">Splits a table into subsets groups.</td>
+	<td class="name" nowrap><a href="#reject">reject (t, f[, ...])</a></td>
+	<td class="summary">Clones a table while dropping values passing an iterator test.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#countBy">countBy (t, iter[, ...])</a></td>
-	<td class="summary">Groups values in a collection and counts them.</td>
+	<td class="name" nowrap><a href="#same">same (a, b)</a></td>
+	<td class="summary">Checks if two tables are the same.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#sameKeys">sameKeys (tA, tB)</a></td>
+	<td class="summary">Checks if both given tables have the same keys.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#select">select (t, f[, ...])</a></td>
+	<td class="summary">Selects and returns values passing an iterator test.</td>
 	</tr>
 	<tr>
 	<td class="name" nowrap><a href="#size">size ([...])</a></td>
 	<td class="summary">Counts the number of values in a collection.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#containsKeys">containsKeys (t, other)</a></td>
-	<td class="summary">Checks if all the keys of <code>other</code> table exists in table <code>t</code>.</td>
+	<td class="name" nowrap><a href="#sort">sort (t[, comp])</a></td>
+	<td class="summary">Sorts a table, in-place.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#sameKeys">sameKeys (tA, tB)</a></td>
-	<td class="summary">Checks if both given tables have the same keys.</td>
+	<td class="name" nowrap><a href="#sortBy">sortBy (t[, transform[, comp]])</a></td>
+	<td class="summary">Sorts a table in-place using a transform.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#where">where (t, props)</a></td>
+	<td class="summary">Returns all values having specified keys <code>props</code>.</td>
 	</tr>
 </table>
 <h2><a href="#Array_functions">Array functions </a></h2>
 <table class="function_list">
 	<tr>
-	<td class="name" nowrap><a href="#sample">sample (array[, n[, seed]])</a></td>
-	<td class="summary">Samples <code>n</code> random values from an array.</td>
+	<td class="name" nowrap><a href="#addTop">addTop (array, ...)</a></td>
+	<td class="summary">Adds all passed-in values at the top of an array.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#sampleProb">sampleProb (array, prob[, seed])</a></td>
-	<td class="summary">Return elements from a sequence with a given probability.</td>
+	<td class="name" nowrap><a href="#aperture">aperture (array[, n])</a></td>
+	<td class="summary">Iterator returning sliding partitions of an array.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#toArray">toArray (...)</a></td>
-	<td class="summary">Converts a list of arguments to an array.</td>
+	<td class="name" nowrap><a href="#append">append (array, other)</a></td>
+	<td class="summary">Clones array and appends values from another array.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#find">find (array, value[, from])</a></td>
-	<td class="summary">Looks for the first occurrence of a given value in an array.</td>
+	<td class="name" nowrap><a href="#chunk">chunk (array, f[, ...])</a></td>
+	<td class="summary">Chunks together consecutive values.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#reverse">reverse (array)</a></td>
-	<td class="summary">Returns an array where values are in reverse order.</td>
+	<td class="name" nowrap><a href="#compact">compact (array)</a></td>
+	<td class="summary">Returns all truthy values (removes <code>falses</code> and <code>nils</code>).</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#fill">fill (array, value[, i[, j]])</a></td>
-	<td class="summary">Replaces elements in a given array with a given value.</td>
+	<td class="name" nowrap><a href="#concat">concat (array[, sep[, i[, j]]])</a></td>
+	<td class="summary">Concatenates values in a given array.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#selectWhile">selectWhile (array, f[, ...])</a></td>
-	<td class="summary">Collects values from a given array.</td>
+	<td class="name" nowrap><a href="#difference">difference (array, another)</a></td>
+	<td class="summary">Returns values from an array not present in all passed-in args.</td>
 	</tr>
 	<tr>
 	<td class="name" nowrap><a href="#dropWhile">dropWhile (array, f[, ...])</a></td>
 	<td class="summary">Collects values from a given array.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#sortedIndex">sortedIndex (array, the[, comp[, sort]])</a></td>
-	<td class="summary">Returns the index at which a value should be inserted.</td>
-	</tr>
-	<tr>
-	<td class="name" nowrap><a href="#indexOf">indexOf (array, value)</a></td>
-	<td class="summary">Returns the index of the first occurence of value in an array.</td>
+	<td class="name" nowrap><a href="#fill">fill (array, value[, i[, j]])</a></td>
+	<td class="summary">Replaces elements in a given array with a given value.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#lastIndexOf">lastIndexOf (array, value)</a></td>
-	<td class="summary">Returns the index of the last occurrence of value in an array.</td>
+	<td class="name" nowrap><a href="#find">find (array, value[, from])</a></td>
+	<td class="summary">Looks for the first occurrence of a given value in an array.</td>
 	</tr>
 	<tr>
 	<td class="name" nowrap><a href="#findIndex">findIndex (array, predicate[, ...])</a></td>
@@ -252,187 +333,215 @@
 	<td class="summary">Returns the last index at which a predicate returns true.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#addTop">addTop (array, ...)</a></td>
-	<td class="summary">Adds all passed-in values at the top of an array.</td>
-	</tr>
-	<tr>
-	<td class="name" nowrap><a href="#push">push (array, ...)</a></td>
-	<td class="summary">Pushes all passed-in values at the end of an array.</td>
+	<td class="name" nowrap><a href="#first">first (array[, n])</a></td>
+	<td class="summary">Returns the first N values in an array.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#pop">pop (array[, n])</a></td>
-	<td class="summary">Removes and returns the values at the top of a given array.</td>
+	<td class="name" nowrap><a href="#flatten">flatten (array[, shallow])</a></td>
+	<td class="summary">Flattens a nested array.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#unshift">unshift (array[, n])</a></td>
-	<td class="summary">Removes and returns the values at the end of a given array.</td>
+	<td class="name" nowrap><a href="#indexOf">indexOf (array, value)</a></td>
+	<td class="summary">Returns the index of the first occurrence of value in an array.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#pull">pull (array, ...)</a></td>
-	<td class="summary">Removes all provided values in a given array.</td>
+	<td class="name" nowrap><a href="#initial">initial (array[, n])</a></td>
+	<td class="summary">Returns all values in an array excluding the last N values.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#removeRange">removeRange (array[, start[, finish]])</a></td>
-	<td class="summary">Removes values at index within the range <code>[start, finish]</code>.</td>
+	<td class="name" nowrap><a href="#interleave">interleave (...)</a></td>
+	<td class="summary">Interleaves arrays.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#chunk">chunk (array, f[, ...])</a></td>
-	<td class="summary">Chunks together consecutive values.</td>
+	<td class="name" nowrap><a href="#interpose">interpose (array, value)</a></td>
+	<td class="summary">Interposes value in-between consecutive pair of values in array.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#slice">slice (array[, start[, finish]])</a></td>
-	<td class="summary">Slices values indexed within <code>[start, finish]</code> range.</td>
+	<td class="name" nowrap><a href="#intersection">intersection (array, ...)</a></td>
+	<td class="summary">Returns the  intersection of all passed-in arrays.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#first">first (array[, n])</a></td>
-	<td class="summary">Returns the first N values in an array.</td>
+	<td class="name" nowrap><a href="#invert">invert (array)</a></td>
+	<td class="summary">Swaps keys with values.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#initial">initial (array[, n])</a></td>
-	<td class="summary">Returns all values in an array excluding the last N values.</td>
+	<td class="name" nowrap><a href="#isunique">isunique (array)</a></td>
+	<td class="summary">Checks if a given array contains distinct values.</td>
 	</tr>
 	<tr>
 	<td class="name" nowrap><a href="#last">last (array[, n])</a></td>
 	<td class="summary">Returns the last N values in an array.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#rest">rest (array[, index])</a></td>
-	<td class="summary">Removes all values before index.</td>
+	<td class="name" nowrap><a href="#lastIndexOf">lastIndexOf (array, value)</a></td>
+	<td class="summary">Returns the index of the last occurrence of value in an array.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#nth">nth (array, index)</a></td>
-	<td class="summary">Returns the value at a given index.</td>
+	<td class="name" nowrap><a href="#mean">mean (array)</a></td>
+	<td class="summary">Returns the mean of an array of numbers.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#compact">compact (array)</a></td>
-	<td class="summary">Removes all falsy (false and nil) values.</td>
+	<td class="name" nowrap><a href="#median">median (array)</a></td>
+	<td class="summary">Returns the median of an array of numbers.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#flatten">flatten (array[, shallow])</a></td>
-	<td class="summary">Flattens a nested array.</td>
+	<td class="name" nowrap><a href="#nth">nth (array, index)</a></td>
+	<td class="summary">Returns the value at a given index.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#difference">difference (array, another)</a></td>
-	<td class="summary">Returns values from an array not present in all passed-in args.</td>
+	<td class="name" nowrap><a href="#ones">ones (n)</a></td>
+	<td class="summary">Returns an array of <code>n</code> 1's.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#union">union (...)</a></td>
-	<td class="summary">Returns the duplicate-free union of all passed in arrays.</td>
+	<td class="name" nowrap><a href="#overlapping">overlapping (array[, n[, pads]])</a></td>
+	<td class="summary">Iterator returning overlapping partitions of an array.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#intersection">intersection (array, ...)</a></td>
-	<td class="summary">Returns the  intersection of all passed-in arrays.</td>
+	<td class="name" nowrap><a href="#pairwise">pairwise (array)</a></td>
+	<td class="summary">Iterator returning sliding pairs of an array.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#symmetricDifference">symmetricDifference (array, array2)</a></td>
-	<td class="summary">Performs a symmetric difference.</td>
+	<td class="name" nowrap><a href="#partition">partition (array[, n[, pads]])</a></td>
+	<td class="summary">Iterator returning partitions of an array.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#unique">unique (array)</a></td>
-	<td class="summary">Produces a duplicate-free version of a given array.</td>
+	<td class="name" nowrap><a href="#permutation">permutation (array)</a></td>
+	<td class="summary">Iterator returning the permutations of an array.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#isunique">isunique (array)</a></td>
-	<td class="summary">Checks if a given array contains distinct values.</td>
+	<td class="name" nowrap><a href="#powerset">powerset (array)</a></td>
+	<td class="summary">Returns the powerset of array values.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#zip">zip (...)</a></td>
-	<td class="summary">Merges values of each of the passed-in arrays in subsets.</td>
+	<td class="name" nowrap><a href="#prepend">prepend (array, ...)</a></td>
+	<td class="summary">Adds all passed-in values at the top of an array.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#append">append (array, other)</a></td>
-	<td class="summary">Clones <a href="index.html#array">array</a> and appends <code>other</code> values.</td>
+	<td class="name" nowrap><a href="#product">product (array)</a></td>
+	<td class="summary">Returns the product of array values.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#interleave">interleave (...)</a></td>
-	<td class="summary">Interleaves arrays.</td>
+	<td class="name" nowrap><a href="#pull">pull (array, ...)</a></td>
+	<td class="summary">Removes all provided values in a given array.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#interpose">interpose (value, array)</a></td>
-	<td class="summary">Interposes value in-between consecutive pair of values in <a href="index.html#array">array</a>.</td>
+	<td class="name" nowrap><a href="#push">push (array, ...)</a></td>
+	<td class="summary">Pushes all passed-in values at the end of an array.</td>
 	</tr>
 	<tr>
 	<td class="name" nowrap><a href="#range">range ([from[, to[, step]]])</a></td>
 	<td class="summary">Produces a flexible list of numbers.</td>
 	</tr>
 	<tr>
+	<td class="name" nowrap><a href="#removeRange">removeRange (array[, start[, finish]])</a></td>
+	<td class="summary">Removes values at an index within the range <code>[start, finish]</code>.</td>
+	</tr>
+	<tr>
 	<td class="name" nowrap><a href="#rep">rep (value, n)</a></td>
 	<td class="summary">Creates an array list of <code>n</code> values, repeated.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#partition">partition (array[, n[, pad]])</a></td>
-	<td class="summary">Iterator returning partitions of an array.</td>
+	<td class="name" nowrap><a href="#rest">rest (array[, index])</a></td>
+	<td class="summary">Returns all values after index.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#sliding.">sliding. (array[, n[, pad]])</a></td>
-	<td class="summary">Iterator returning sliding partitions of an array.</td>
+	<td class="name" nowrap><a href="#reverse">reverse (array)</a></td>
+	<td class="summary">Returns an array where values are in reverse order.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#permutation">permutation (array)</a></td>
-	<td class="summary">Iterator returning the permutations of an array.</td>
+	<td class="name" nowrap><a href="#sample">sample (array[, n[, seed]])</a></td>
+	<td class="summary">Samples <code>n</code> random values from an array.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#invert">invert (array)</a></td>
-	<td class="summary">Swaps keys with values.</td>
+	<td class="name" nowrap><a href="#sampleProb">sampleProb (array, prob[, seed])</a></td>
+	<td class="summary">Return elements from a sequence with a given probability.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#concat">concat (array[, sep[, i[, j]]])</a></td>
-	<td class="summary">Concatenates values in a given array.</td>
+	<td class="name" nowrap><a href="#selectWhile">selectWhile (array, f[, ...])</a></td>
+	<td class="summary">Collects values from a given array.</td>
 	</tr>
-</table>
-<h2><a href="#Utility_functions">Utility functions </a></h2>
-<table class="function_list">
 	<tr>
-	<td class="name" nowrap><a href="#noop">noop ()</a></td>
-	<td class="summary">The no-operation function.</td>
+	<td class="name" nowrap><a href="#shift">shift (array[, n])</a></td>
+	<td class="summary">Removes and returns the values at the top of a given array.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#identity">identity (value)</a></td>
-	<td class="summary">Returns the passed-in value.</td>
+	<td class="name" nowrap><a href="#shuffle">shuffle (array[, seed])</a></td>
+	<td class="summary">Returns a shuffled copy of a given array.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#constant">constant (value)</a></td>
-	<td class="summary">Creates a constant function which returns the same output on every call.</td>
+	<td class="name" nowrap><a href="#slice">slice (array[, start[, finish]])</a></td>
+	<td class="summary">Slices values indexed within <code>[start, finish]</code> range.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#memoize">memoize (f[, hash])</a></td>
-	<td class="summary">Memoizes a given function by caching the computed result.</td>
+	<td class="name" nowrap><a href="#sortedIndex">sortedIndex (array, the[, comp[, sort]])</a></td>
+	<td class="summary">Returns the index at which a value should be inserted.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#once">once (f)</a></td>
-	<td class="summary">Returns a version of <code>f</code> that runs only once.</td>
+	<td class="name" nowrap><a href="#sum">sum (array)</a></td>
+	<td class="summary">Returns the sum of array values.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#before">before (f, count)</a></td>
-	<td class="summary">Returns a version of <code>f</code> that will run no more than <a href="index.html#count">count</a> times.</td>
+	<td class="name" nowrap><a href="#symmetricDifference">symmetricDifference (array, array2)</a></td>
+	<td class="summary">Performs a symmetric difference.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#after">after (f, count)</a></td>
-	<td class="summary">Returns a version of <code>f</code> that runs on the <code>count-th</code> call.</td>
+	<td class="name" nowrap><a href="#toArray">toArray (...)</a></td>
+	<td class="summary">Converts a list of arguments to an array.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#compose">compose (...)</a></td>
-	<td class="summary">Composes functions.</td>
+	<td class="name" nowrap><a href="#union">union (...)</a></td>
+	<td class="summary">Returns the duplicate-free union of all passed in arrays.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#pipe">pipe (value, ...)</a></td>
-	<td class="summary">Pipes a value through a series of functions.</td>
+	<td class="name" nowrap><a href="#unique">unique (array)</a></td>
+	<td class="summary">Produces a duplicate-free version of a given array.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#complement">complement (f)</a></td>
-	<td class="summary">Returns the logical complement of a given function.</td>
+	<td class="name" nowrap><a href="#unshift">unshift (array[, n])</a></td>
+	<td class="summary">Removes and returns the values at the end of a given array.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#juxtapose">juxtapose (value, ...)</a></td>
-	<td class="summary">Calls a sequence of passed-in functions with the same argument.</td>
+	<td class="name" nowrap><a href="#vector">vector (value, n)</a></td>
+	<td class="summary">Returns an array of <code>n</code> times a given value.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#wrap">wrap (f, wrapper)</a></td>
-	<td class="summary">Wraps <code>f</code> inside of the <code>wrapper</code> function.</td>
+	<td class="name" nowrap><a href="#xprod">xprod (array, array2)</a></td>
+	<td class="summary">Returns all possible pairs built from given arrays.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#times">times (n, iter, ...)</a></td>
-	<td class="summary">Runs <code>iter</code> function <code>n</code> times.</td>
+	<td class="name" nowrap><a href="#zeros">zeros (n)</a></td>
+	<td class="summary">Returns an array of <code>n</code> zeros.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#zip">zip (...)</a></td>
+	<td class="summary">Merges values of each of the passed-in arrays in subsets.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#zipWith">zipWith (f, ...)</a></td>
+	<td class="summary">Merges values using a given function.</td>
+	</tr>
+</table>
+<h2><a href="#Utility_functions">Utility functions </a></h2>
+<table class="function_list">
+	<tr>
+	<td class="name" nowrap><a href="#after">after (f, count)</a></td>
+	<td class="summary">Returns a version of <code>f</code> that runs on the <code>count-th</code> call.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#applySpec">applySpec (specs)</a></td>
+	<td class="summary">Returns a function which applies <code>specs</code> on args.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#array">array (...)</a></td>
+	<td class="summary">Iterates over an iterator and returns its values in an array.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#ary">ary (f[, n])</a></td>
+	<td class="summary">Returns a function which accepts up to <code>n</code> args.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#before">before (f, count)</a></td>
+	<td class="summary">Returns a version of <code>f</code> that will run no more than <em>count</em> times.</td>
 	</tr>
 	<tr>
 	<td class="name" nowrap><a href="#bind">bind (f, v)</a></td>
@@ -443,34 +552,82 @@
 	<td class="summary">Binds <code>v</code> to be the second argument to <code>f</code>.</td>
 	</tr>
 	<tr>
+	<td class="name" nowrap><a href="#bindall">bindall (obj, ...)</a></td>
+	<td class="summary">Binds methods to object.</td>
+	</tr>
+	<tr>
 	<td class="name" nowrap><a href="#bindn">bindn (f, ...)</a></td>
-	<td class="summary">Binds <code>&hellip;</code> to be the N-first arguments to function <code>f</code>.</td>
+	<td class="summary">Binds <code>...</code> to be the N-first arguments to function <code>f</code>.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#bindAll">bindAll (obj, ...)</a></td>
-	<td class="summary">Binds methods to object.</td>
+	<td class="name" nowrap><a href="#castArray">castArray (value)</a></td>
+	<td class="summary">Casts vaue as an array if it is not one.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#uniqueId">uniqueId ([template[, ...]])</a></td>
-	<td class="summary">Generates an unique ID for the current session.</td>
+	<td class="name" nowrap><a href="#complement">complement (f)</a></td>
+	<td class="summary">Returns the logical complement of a given function.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#iterator">iterator (f, x)</a></td>
-	<td class="summary">Produces an iterator which repeatedly apply a function <code>f</code> onto an input.</td>
+	<td class="name" nowrap><a href="#compose">compose (...)</a></td>
+	<td class="summary">Composes functions.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#array">array (...)</a></td>
-	<td class="summary">Iterates an iterator and returns its values in an array.</td>
+	<td class="name" nowrap><a href="#cond">cond (conds)</a></td>
+	<td class="summary">Returns a function which iterate over a set of conditions.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#constant">constant (value)</a></td>
+	<td class="summary">Creates a constant function which returns the same output on every call.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#converge">converge (f, g, h)</a></td>
+	<td class="summary">Converges two functions into one.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#curry">curry (f[, n_args])</a></td>
+	<td class="summary">Curries a function.</td>
 	</tr>
 	<tr>
 	<td class="name" nowrap><a href="#flip">flip (f)</a></td>
 	<td class="summary">Creates a function of <code>f</code> with arguments flipped in reverse order.</td>
 	</tr>
 	<tr>
+	<td class="name" nowrap><a href="#identity">identity (value)</a></td>
+	<td class="summary">Returns the passed-in value.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#iterator">iterator (f, value[, n])</a></td>
+	<td class="summary">Produces an iterator which repeatedly apply a function <code>f</code> onto an input.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#juxtapose">juxtapose (value, ...)</a></td>
+	<td class="summary">Calls a sequence of passed-in functions with the same argument.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#memoize">memoize (f)</a></td>
+	<td class="summary">Memoizes a given function by caching the computed result.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#noop">noop ()</a></td>
+	<td class="summary">The no operation function.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#nthArg">nthArg (n)</a></td>
+	<td class="summary">Returns a function that gets the nth argument.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#once">once (f)</a></td>
+	<td class="summary">Returns a version of <code>f</code> that runs only once.</td>
+	</tr>
+	<tr>
 	<td class="name" nowrap><a href="#over">over (...)</a></td>
 	<td class="summary">Creates a function that runs transforms on all arguments it receives.</td>
 	</tr>
 	<tr>
+	<td class="name" nowrap><a href="#overArgs">overArgs (f, ...)</a></td>
+	<td class="summary">Creates a function that invokes <code>f</code> with its arguments transformed.</td>
+	</tr>
+	<tr>
 	<td class="name" nowrap><a href="#overEvery">overEvery (...)</a></td>
 	<td class="summary">Creates a validation function.</td>
 	</tr>
@@ -479,10 +636,6 @@
 	<td class="summary">Creates a validation function.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#overArgs">overArgs (f, ...)</a></td>
-	<td class="summary">Creates a function that invokes <code>f</code> with its arguments transformed.</td>
-	</tr>
-	<tr>
 	<td class="name" nowrap><a href="#partial">partial (f, ...)</a></td>
 	<td class="summary">Partially apply a function by filling in any number of its arguments.</td>
 	</tr>
@@ -491,43 +644,47 @@
 	<td class="summary">Similar to <a href="index.html#partial">partial</a>, but from the right.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#curry">curry (f[, n_args])</a></td>
-	<td class="summary">Curries a function.</td>
+	<td class="name" nowrap><a href="#pipe">pipe (value, ...)</a></td>
+	<td class="summary">Pipes a value through a series of functions.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#rearg">rearg (f, indexes)</a></td>
+	<td class="summary">Returns a function which runs with arguments rearranged.</td>
 	</tr>
 	<tr>
 	<td class="name" nowrap><a href="#time">time (f[, ...])</a></td>
-	<td class="summary">Returns the execution time of <code>f (&hellip;)</code> and its returned values.</td>
+	<td class="summary">Returns the execution time of <code>f (...)</code> and its returned values.</td>
 	</tr>
-</table>
-<h2><a href="#Object_functions">Object functions </a></h2>
-<table class="function_list">
 	<tr>
-	<td class="name" nowrap><a href="#keys">keys (obj)</a></td>
-	<td class="summary">Returns the keys of the object properties.</td>
+	<td class="name" nowrap><a href="#times">times (iter[, n[, ...]])</a></td>
+	<td class="summary">Runs <code>iter</code> function <code>n</code> times.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#values">values (obj)</a></td>
-	<td class="summary">Returns the values of the object properties.</td>
+	<td class="name" nowrap><a href="#unary">unary (f)</a></td>
+	<td class="summary">Returns a function which accepts up to one arg.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#kvpairs">kvpairs (obj)</a></td>
-	<td class="summary">Converts keys and values a an array-list of [k, v].</td>
+	<td class="name" nowrap><a href="#unfold">unfold (f, seed)</a></td>
+	<td class="summary">Builds a list from a seed value.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#toObj">toObj (kvpairs)</a></td>
-	<td class="summary">Converts an array list of <a href="index.html#kvpairs">kvpairs</a> to an object.</td>
+	<td class="name" nowrap><a href="#uniqueId">uniqueId ([template[, ...]])</a></td>
+	<td class="summary">Generates an unique ID for the current session.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#property">property (key)</a></td>
-	<td class="summary">Returns a function that will return the key property of any passed-in object.</td>
+	<td class="name" nowrap><a href="#wrap">wrap (f, wrapper)</a></td>
+	<td class="summary">Wraps <code>f</code> inside of the <code>wrapper</code> function.</td>
 	</tr>
+</table>
+<h2><a href="#Object_functions">Object functions </a></h2>
+<table class="function_list">
 	<tr>
-	<td class="name" nowrap><a href="#propertyOf">propertyOf (obj)</a></td>
-	<td class="summary">Returns a function which will return the value of an object property.</td>
+	<td class="name" nowrap><a href="#chain">chain (value)</a></td>
+	<td class="summary">Returns a wrapped object.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#toBoolean">toBoolean (value)</a></td>
-	<td class="summary">Converts any given value to a boolean</td>
+	<td class="name" nowrap><a href="#clone">clone (obj[, shallow])</a></td>
+	<td class="summary">Clones a given object properties.</td>
 	</tr>
 	<tr>
 	<td class="name" nowrap><a href="#extend">extend (destObj, ...)</a></td>
@@ -538,116 +695,1480 @@
 	<td class="summary">Returns a sorted list of all methods names found in an object.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#clone">clone (obj[, shallow])</a></td>
-	<td class="summary">Clones a given object properties.</td>
+	<td class="name" nowrap><a href="#has">has (obj, key)</a></td>
+	<td class="summary">Checks if a given object implements a property.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#tap">tap (obj, f[, ...])</a></td>
-	<td class="summary">Invokes interceptor with the object, and then returns object.</td>
+	<td class="name" nowrap><a href="#import">import ([context[, noConflict]])</a></td>
+	<td class="summary">Imports all library functions into a context.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#has">has (obj, key)</a></td>
-	<td class="summary">Checks if a given object implements a property.</td>
+	<td class="name" nowrap><a href="#isArray">isArray (obj)</a></td>
+	<td class="summary">Checks if the given argument is an array.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#pick">pick (obj, ...)</a></td>
-	<td class="summary">Returns an object copy having white-listed properties.</td>
+	<td class="name" nowrap><a href="#isBoolean">isBoolean (obj)</a></td>
+	<td class="summary">Checks if the given argument is a boolean.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#omit">omit (obj, ...)</a></td>
-	<td class="summary">Returns an object copy without black-listed properties.</td>
+	<td class="name" nowrap><a href="#isCallable">isCallable (obj)</a></td>
+	<td class="summary">Checks if the given argument is callable.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#template">template (obj[, template])</a></td>
-	<td class="summary">Applies a template to an object, preserving non-nil properties.</td>
+	<td class="name" nowrap><a href="#isEmpty">isEmpty ([obj])</a></td>
+	<td class="summary">Checks if the given pbject is empty.</td>
 	</tr>
 	<tr>
 	<td class="name" nowrap><a href="#isEqual">isEqual (objA, objB[, useMt])</a></td>
 	<td class="summary">Performs a deep comparison test between two objects.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#result">result (obj, method[, ...])</a></td>
-	<td class="summary">Invokes an object method.</td>
-	</tr>
-	<tr>
-	<td class="name" nowrap><a href="#isTable">isTable (t)</a></td>
-	<td class="summary">Checks if the given arg is a table.</td>
+	<td class="name" nowrap><a href="#isFinite">isFinite (obj)</a></td>
+	<td class="summary">Checks if the given argument is a finite number.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#isCallable">isCallable (obj)</a></td>
-	<td class="summary">Checks if the given argument is callable.</td>
+	<td class="name" nowrap><a href="#isFunction">isFunction (obj)</a></td>
+	<td class="summary">Checks if the given argument is a function.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#isArray">isArray (obj)</a></td>
-	<td class="summary">Checks if the given argument is an array.</td>
+	<td class="name" nowrap><a href="#isInteger">isInteger (obj)</a></td>
+	<td class="summary">Checks if the given argument is an integer.</td>
 	</tr>
 	<tr>
 	<td class="name" nowrap><a href="#isIterable">isIterable (obj)</a></td>
 	<td class="summary">Checks if the given object is iterable with <a href="https://www.lua.org/manual/5.1/manual.html#pdf-pairs">pairs</a> (or <a href="https://www.lua.org/manual/5.1/manual.html#pdf-ipairs">ipairs</a>).</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#isEmpty">isEmpty ([obj])</a></td>
-	<td class="summary">Checks if the given pbject is empty.</td>
+	<td class="name" nowrap><a href="#isNaN">isNaN (obj)</a></td>
+	<td class="summary">Checks if the given argument is NaN (see <a href="http://en.wikipedia.org/wiki/NaN">Not-A-Number</a>).</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#isNil">isNil (obj)</a></td>
+	<td class="summary">Checks if the given argument is nil.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#isNumber">isNumber (obj)</a></td>
+	<td class="summary">Checks if the given argument is a number.</td>
 	</tr>
 	<tr>
 	<td class="name" nowrap><a href="#isString">isString (obj)</a></td>
 	<td class="summary">Checks if the given argument is a string.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#isFunction">isFunction (obj)</a></td>
-	<td class="summary">Checks if the given argument is a function.</td>
+	<td class="name" nowrap><a href="#isTable">isTable (t)</a></td>
+	<td class="summary">Checks if the given arg is a table.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#isNil">isNil (obj)</a></td>
-	<td class="summary">Checks if the given argument is nil.</td>
+	<td class="name" nowrap><a href="#keys">keys (obj)</a></td>
+	<td class="summary">Returns the keys of the object properties.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#isNumber">isNumber (obj)</a></td>
-	<td class="summary">Checks if the given argument is a number.</td>
+	<td class="name" nowrap><a href="#kvpairs">kvpairs (obj)</a></td>
+	<td class="summary">Converts key-value pairs to an array-list of <code>[k, v]</code> pairs.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#isNaN">isNaN (obj)</a></td>
-	<td class="summary">Checks if the given argument is NaN (see <a href="http://en.wikipedia.org/wiki/NaN">Not-A-Number</a>).</td>
+	<td class="name" nowrap><a href="#obj:value">obj:value ()</a></td>
+	<td class="summary">Extracts the value of a wrapped object.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#isFinite">isFinite (obj)</a></td>
-	<td class="summary">Checks if the given argument is a finite number.</td>
+	<td class="name" nowrap><a href="#omit">omit (obj, ...)</a></td>
+	<td class="summary">Returns an object copy without black-listed properties.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#isBoolean">isBoolean (obj)</a></td>
-	<td class="summary">Checks if the given argument is a boolean.</td>
+	<td class="name" nowrap><a href="#path">path (obj, ...)</a></td>
+	<td class="summary">Returns the value at a given path in an object.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#isInteger">isInteger (obj)</a></td>
-	<td class="summary">Checks if the given argument is an integer.</td>
+	<td class="name" nowrap><a href="#pick">pick (obj, ...)</a></td>
+	<td class="summary">Returns an object copy having white-listed properties.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#chain">chain (value)</a></td>
-	<td class="summary">Returns a wrapped object.</td>
+	<td class="name" nowrap><a href="#property">property (key)</a></td>
+	<td class="summary">Returns a function that will return the key property of any passed-in object.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#obj:value">obj:value ()</a></td>
-	<td class="summary">Extracts the value of a wrapped object.</td>
+	<td class="name" nowrap><a href="#propertyOf">propertyOf (obj)</a></td>
+	<td class="summary">Returns a function which will return the value of an object property.</td>
 	</tr>
 	<tr>
-	<td class="name" nowrap><a href="#import">import ([context[, noConflict]])</a></td>
-	<td class="summary">Imports all library functions into a context.</td>
+	<td class="name" nowrap><a href="#result">result (obj, method[, ...])</a></td>
+	<td class="summary">Invokes an object method.</td>
 	</tr>
-</table>
+	<tr>
+	<td class="name" nowrap><a href="#tap">tap (obj, f[, ...])</a></td>
+	<td class="summary">Invokes interceptor with the object, and then returns object.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#template">template (obj[, template])</a></td>
+	<td class="summary">Applies a template to an object, preserving non-nil properties.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#toBoolean">toBoolean (value)</a></td>
+	<td class="summary">Converts any given value to a boolean</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#toObj">toObj (kvpairs)</a></td>
+	<td class="summary">Converts an array list of <code>[k,v]</code> pairs to an object.</td>
+	</tr>
+	<tr>
+	<td class="name" nowrap><a href="#values">values (obj)</a></td>
+	<td class="summary">Returns the values of the object properties.</td>
+	</tr>
+</table>
+
+<br/>
+<br/>
+
+
+    <h2 class="section-header "><a name="Operator_functions"></a>Operator functions </h2>
+
+    <dl class="function">
+    <dt>
+    <a name = "operator.add"></a>
+    <strong>operator.add (a, b)</strong>
+    </dt>
+    <dd>
+    Returns a + b.  <em>Aliased as <code>op.add</code></em>.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">a</span>
+         a value
+        </li>
+        <li><span class="parameter">b</span>
+         a value
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        a + b
+    </ol>
+
+
+
+
+</dd>
+    <dt>
+    <a name = "operator.concat"></a>
+    <strong>operator.concat (a, b)</strong>
+    </dt>
+    <dd>
+    Returns concatenation of a and b.  <em>Aliased as <code>op.concat</code></em>.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">a</span>
+         a value
+        </li>
+        <li><span class="parameter">b</span>
+         a value
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        a .. b
+    </ol>
+
+
+
+
+</dd>
+    <dt>
+    <a name = "operator.div"></a>
+    <strong>operator.div (a, b)</strong>
+    </dt>
+    <dd>
+    Returns a / b.  <em>Aliased as <code>op.div</code></em>.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">a</span>
+         a value
+        </li>
+        <li><span class="parameter">b</span>
+         a value
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        a / b
+    </ol>
+
+
+
+
+</dd>
+    <dt>
+    <a name = "operator.eq"></a>
+    <strong>operator.eq (a, b)</strong>
+    </dt>
+    <dd>
+    Checks if a equals b.  <em>Aliased as <code>op.eq</code></em>.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">a</span>
+         a value
+        </li>
+        <li><span class="parameter">b</span>
+         a value
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        a == b
+    </ol>
+
+
+
+
+</dd>
+    <dt>
+    <a name = "operator.exp"></a>
+    <strong>operator.exp (a, b)</strong>
+    </dt>
+    <dd>
+    Returns a ^ b.  <em>Aliased as <code>op.exp</code>, <code>op.pow</code></em>.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">a</span>
+         a value
+        </li>
+        <li><span class="parameter">b</span>
+         a value
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        a ^ b
+    </ol>
+
+
+
+
+</dd>
+    <dt>
+    <a name = "operator.floordiv"></a>
+    <strong>operator.floordiv (a, b)</strong>
+    </dt>
+    <dd>
+    Performs floor division (//) between <code>a</code> and <code>b</code>.  It rounds the quotient towards minus infinity.
+ <em>Aliased as <code>op.floordiv</code></em>.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">a</span>
+         a value
+        </li>
+        <li><span class="parameter">b</span>
+         a value
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        a // b
+    </ol>
+
+
+
+
+</dd>
+    <dt>
+    <a name = "operator.ge"></a>
+    <strong>operator.ge (a, b)</strong>
+    </dt>
+    <dd>
+    Returns logical a and b.  <em>Aliased as <code>op.land</code></em>.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">a</span>
+         a value
+        </li>
+        <li><span class="parameter">b</span>
+         a value
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        a and b
+    </ol>
+
+
+
+
+</dd>
+    <dt>
+    <a name = "operator.ge"></a>
+    <strong>operator.ge (a, b)</strong>
+    </dt>
+    <dd>
+    Checks if a is greater or equal to b.  <em>Aliased as <code>op.ge</code></em>.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">a</span>
+         a value
+        </li>
+        <li><span class="parameter">b</span>
+         a value
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        a >= b
+    </ol>
+
+
+
+
+</dd>
+    <dt>
+    <a name = "operator.gt"></a>
+    <strong>operator.gt (a, b)</strong>
+    </dt>
+    <dd>
+    Checks if a is strictly greater than b.  <em>Aliased as <code>op.gt</code></em>.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">a</span>
+         a value
+        </li>
+        <li><span class="parameter">b</span>
+         a value
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        a > b
+    </ol>
+
+
+
+
+</dd>
+    <dt>
+    <a name = "operator.intdiv"></a>
+    <strong>operator.intdiv (a, b)</strong>
+    </dt>
+    <dd>
+    Performs integer division between <code>a</code> and <code>b</code>.  <em>Aliased as <code>op.intdiv</code></em>.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">a</span>
+         a value
+        </li>
+        <li><span class="parameter">b</span>
+         a value
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        a / b
+    </ol>
+
+
+
+
+</dd>
+    <dt>
+    <a name = "operator.le"></a>
+    <strong>operator.le (a, b)</strong>
+    </dt>
+    <dd>
+    Checks if a is less or equal to b.  <em>Aliased as <code>op.le</code></em>.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">a</span>
+         a value
+        </li>
+        <li><span class="parameter">b</span>
+         a value
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        a &lt;= b
+    </ol>
+
+
+
+
+</dd>
+    <dt>
+    <a name = "operator.length"></a>
+    <strong>operator.length (a)</strong>
+    </dt>
+    <dd>
+    Returns the length of a.  <em>Aliased as <code>op.len</code></em>.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">a</span>
+         a value
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+
+<h1>a</h1>
+
+    </ol>
+
+
+
+
+</dd>
+    <dt>
+    <a name = "operator.lnot"></a>
+    <strong>operator.lnot (a)</strong>
+    </dt>
+    <dd>
+    Returns logical not a.  <em>Aliased as <code>op.lnot</code></em>.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">a</span>
+         a value
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        not a
+    </ol>
+
+
+
+
+</dd>
+    <dt>
+    <a name = "operator.lor"></a>
+    <strong>operator.lor (a, b)</strong>
+    </dt>
+    <dd>
+    Returns logical a or b.  <em>Aliased as <code>op.lor</code></em>.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">a</span>
+         a value
+        </li>
+        <li><span class="parameter">b</span>
+         a value
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        a or b
+    </ol>
+
+
+
+
+</dd>
+    <dt>
+    <a name = "operator.lt"></a>
+    <strong>operator.lt (a, b)</strong>
+    </dt>
+    <dd>
+    Checks if a is strictly less than b.  <em>Aliased as <code>op.lt</code></em>.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">a</span>
+         a value
+        </li>
+        <li><span class="parameter">b</span>
+         a value
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        a &lt; b
+    </ol>
+
+
+
+
+</dd>
+    <dt>
+    <a name = "operator.mod"></a>
+    <strong>operator.mod (a, b)</strong>
+    </dt>
+    <dd>
+    Returns a % b.  <em>Aliased as <code>op.mod</code></em>.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">a</span>
+         a value
+        </li>
+        <li><span class="parameter">b</span>
+         a value
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        a % b
+    </ol>
+
+
+
+
+</dd>
+    <dt>
+    <a name = "operator.mul"></a>
+    <strong>operator.mul (a, b)</strong>
+    </dt>
+    <dd>
+    Returns a * b.  <em>Aliased as <code>op.mul</code></em>.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">a</span>
+         a value
+        </li>
+        <li><span class="parameter">b</span>
+         a value
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        a * b
+    </ol>
+
+
+
+
+</dd>
+    <dt>
+    <a name = "operator.neq"></a>
+    <strong>operator.neq (a, b)</strong>
+    </dt>
+    <dd>
+    Checks if a not equals b.  <em>Aliased as <code>op.neq</code></em>.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">a</span>
+         a value
+        </li>
+        <li><span class="parameter">b</span>
+         a value
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        a ~= b
+    </ol>
+
+
+
+
+</dd>
+    <dt>
+    <a name = "operator.sub"></a>
+    <strong>operator.sub (a, b)</strong>
+    </dt>
+    <dd>
+    Returns a - b.  <em>Aliased as <code>op.sub</code></em>.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">a</span>
+         a value
+        </li>
+        <li><span class="parameter">b</span>
+         a value
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        a - b
+    </ol>
+
+
+
+
+</dd>
+    <dt>
+    <a name = "operator.unm"></a>
+    <strong>operator.unm (a)</strong>
+    </dt>
+    <dd>
+    Returns -a.  <em>Aliased as <code>op.unm</code>, <code>op.neg</code></em>.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">a</span>
+         a value
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        -a
+    </ol>
+
+
+
+
+</dd>
+</dl>
+    <h2 class="section-header "><a name="Table_functions"></a>Table functions </h2>
+
+    <dl class="function">
+    <dt>
+    <a name = "adjust"></a>
+    <strong>adjust (t, key, f[, ...])</strong>
+    </dt>
+    <dd>
+    Adjusts the value at a given key using a function or a value.  In case <code>f</code> is a function,
+ it should be prototyped <code>f(v, ...)</code>. It does not mutate the given table, but rather
+ returns a new array. In case the given <code>key</code> does not exist in <code>t</code>, it throws an error.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">t</span>
+         a table
+        </li>
+        <li><span class="parameter">key</span>
+         a key
+        </li>
+        <li><span class="parameter">f</span>
+         a function, prototyped as <code>f(v, ...)</code> or a value
+        </li>
+        <li><span class="parameter">...</span>
+         Optional args to be passed to <code>f</code>
+         (<em>optional</em>)
+        </li>
+    </ul>
+
+
+
+
+
+</dd>
+    <dt>
+    <a name = "all"></a>
+    <strong>all (t, f[, ...])</strong>
+    </dt>
+    <dd>
+    Checks if all values in a table are passing an iterator test.
+ <br/><em>Aliased as <code>every</code></em>
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">t</span>
+         a table
+        </li>
+        <li><span class="parameter">f</span>
+         an iterator function, prototyped as <code>f (v, k, ...)</code>
+        </li>
+        <li><span class="parameter">...</span>
+         Optional args to be passed to <code>f</code>
+         (<em>optional</em>)
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        <code>true</code> if all values passes the predicate, <code>false</code> otherwise
+    </ol>
+
+
+
+
+</dd>
+    <dt>
+    <a name = "at"></a>
+    <strong>at (t, ...)</strong>
+    </dt>
+    <dd>
+    Collects values at given keys and return them wrapped in an array.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">t</span>
+         a table
+        </li>
+        <li><span class="parameter">...</span>
+         A variable number of keys to collect values
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        an array-list of values
+    </ol>
+
+
+
+
+</dd>
+    <dt>
+    <a name = "clear"></a>
+    <strong>clear (t)</strong>
+    </dt>
+    <dd>
+    Clears a table.  All its values become nil.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">t</span>
+         a table
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        the given table, cleared.
+    </ol>
+
+
+
+
+</dd>
+    <dt>
+    <a name = "containsKeys"></a>
+    <strong>containsKeys (t, other)</strong>
+    </dt>
+    <dd>
+    Checks if all the keys of <code>other</code> table exists in table <code>t</code>.  It does not
+ compares values. The test is not commutative, i.e table <code>t</code> may contains keys
+ not existing in <code>other</code>.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">t</span>
+         a table
+        </li>
+        <li><span class="parameter">other</span>
+         another table
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        <code>true</code> or <code>false</code>
+    </ol>
+
+
+    <h3>See also:</h3>
+    <ul>
+         <a href="index.html#sameKeys">sameKeys</a>
+    </ul>
+
+
+</dd>
+    <dt>
+    <a name = "count"></a>
+    <strong>count (t[, val])</strong>
+    </dt>
+    <dd>
+    Counts occurrences of a given value in a table.  Uses <a href="index.html#isEqual">isEqual</a> to compare values.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">t</span>
+         a table
+        </li>
+        <li><span class="parameter">val</span>
+         a value to be searched in the table. If not given, the <a href="index.html#size">size</a> of the table will be returned
+         (<em>optional</em>)
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        the count of occurrences of the given value
+    </ol>
+
+
+    <h3>See also:</h3>
+    <ul>
+         <li><a href="index.html#countf">countf</a></li>
+         <li><a href="index.html#size">size</a></li>
+    </ul>
+
+
+</dd>
+    <dt>
+    <a name = "countBy"></a>
+    <strong>countBy (t, iter[, ...])</strong>
+    </dt>
+    <dd>
+    Groups values in a collection and counts them.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">t</span>
+         a table
+        </li>
+        <li><span class="parameter">iter</span>
+         an iterator function, prototyped as <code>iter (v, k, ...)</code>
+        </li>
+        <li><span class="parameter">...</span>
+         Optional args to be passed to <code>iter</code>
+         (<em>optional</em>)
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        a table of subsets groups names paired with their count
+    </ol>
+
+
+
+
+</dd>
+    <dt>
+    <a name = "countf"></a>
+    <strong>countf (t, f[, ...])</strong>
+    </dt>
+    <dd>
+    Counts the number of values passing a predicate test.  Same as <a href="index.html#count">count</a>, but uses an iterator.
+ Returns the count for values passing the test <code>f (v, k, ...)</code>
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">t</span>
+         a table
+        </li>
+        <li><span class="parameter">f</span>
+         an iterator function, prototyped as <code>f (v, k, ...)</code>
+        </li>
+        <li><span class="parameter">...</span>
+         Optional args to be passed to <code>f</code>
+         (<em>optional</em>)
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        the count of values validating the predicate
+    </ol>
+
+
+    <h3>See also:</h3>
+    <ul>
+         <li><a href="index.html#count">count</a></li>
+         <li><a href="index.html#size">size</a></li>
+    </ul>
+
+
+</dd>
+    <dt>
+    <a name = "cycle"></a>
+    <strong>cycle (t[, n])</strong>
+    </dt>
+    <dd>
+    Loops <code>n</code> times through a table.  In case <code>n</code> is omitted, it will loop forever.
+ In case <code>n</code> is lower or equal to 0, it returns an empty function.
+ <br/><em>Aliased as <code>loop</code></em>.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">t</span>
+         a table
+        </li>
+        <li><span class="parameter">n</span>
+         the number of loops
+         (<em>optional</em>)
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        an iterator function yielding value-key pairs from the passed-in table.
+    </ol>
+
+
+
+
+</dd>
+    <dt>
+    <a name = "detect"></a>
+    <strong>detect (t, value)</strong>
+    </dt>
+    <dd>
+    Performs a linear search for a value in a table.  Returns the key of the value if found.
+ The given value can be a function prototyped as <code>f (v, value)</code> which should return true when
+ any v in the table equals the value being searched. This function is similar to <a href="index.html#find">find</a>,
+ which is mostly meant to work with array.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">t</span>
+         a table
+        </li>
+        <li><span class="parameter">value</span>
+         a value to search for
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        the key of the value when found or <strong>nil</strong>
+    </ol>
+
+
+    <h3>See also:</h3>
+    <ul>
+         <li><a href="index.html#include">include</a></li>
+         <li><a href="index.html#find">find</a></li>
+    </ul>
+
+
+</dd>
+    <dt>
+    <a name = "each"></a>
+    <strong>each (t, f[, ...])</strong>
+    </dt>
+    <dd>
+    Iterates on key-value pairs, calling <code>f (v, k)</code> at every step.
+ <br/><em>Aliased as <code>forEach</code></em>.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">t</span>
+         a table
+        </li>
+        <li><span class="parameter">f</span>
+         a function, prototyped as <code>f (v, k, ...)</code>
+        </li>
+        <li><span class="parameter">...</span>
+         Optional args to be passed to <code>f</code>
+         (<em>optional</em>)
+        </li>
+    </ul>
+
+
+
+    <h3>See also:</h3>
+    <ul>
+         <a href="index.html#eachi">eachi</a>
+    </ul>
+
+
+</dd>
+    <dt>
+    <a name = "eachi"></a>
+    <strong>eachi (t, f[, ...])</strong>
+    </dt>
+    <dd>
+    Iterates on integer key-value pairs, calling <code>f(v, k)</code> every step. <br/>
+ Only applies to values located at integer keys. The table can be a sparse array.
+ Iteration will start from the lowest integer key found to the highest one.
+ <br/><em>Aliased as <code>forEachi</code></em>.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">t</span>
+         a table
+        </li>
+        <li><span class="parameter">f</span>
+         a function, prototyped as <code>f (v, k, ...)</code>
+        </li>
+        <li><span class="parameter">...</span>
+         Optional args to be passed to <code>f</code>
+         (<em>optional</em>)
+        </li>
+    </ul>
+
+
+
+    <h3>See also:</h3>
+    <ul>
+         <a href="index.html#each">each</a>
+    </ul>
+
+
+</dd>
+    <dt>
+    <a name = "findWhere"></a>
+    <strong>findWhere (t, props)</strong>
+    </dt>
+    <dd>
+    Returns the first value having specified keys <code>props</code>.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">t</span>
+         a table
+        </li>
+        <li><span class="parameter">props</span>
+         a set of keys
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        a value from the passed-in table
+    </ol>
+
+
+    <h3>See also:</h3>
+    <ul>
+         <a href="index.html#where">where</a>
+    </ul>
+
+
+</dd>
+    <dt>
+    <a name = "groupBy"></a>
+    <strong>groupBy (t, iter[, ...])</strong>
+    </dt>
+    <dd>
+    Splits a table into subsets groups.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">t</span>
+         a table
+        </li>
+        <li><span class="parameter">iter</span>
+         an iterator function, prototyped as <code>iter (v, k, ...)</code>
+        </li>
+        <li><span class="parameter">...</span>
+         Optional args to be passed to <code>iter</code>
+         (<em>optional</em>)
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        a table of subsets groups
+    </ol>
+
+
+
+
+</dd>
+    <dt>
+    <a name = "include"></a>
+    <strong>include (t, value)</strong>
+    </dt>
+    <dd>
+    Performs a linear search for a value in a table.  It does not work for nested tables.
+ The given value can be a function prototyped as <code>f (v, value)</code> which should return true when
+ any v in the table equals the value being searched.
+ <br/><em>Aliased as <code>any</code>, <code>some</code>, <code>contains</code></em>
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">t</span>
+         a table
+        </li>
+        <li><span class="parameter">value</span>
+         a value to search for
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        a boolean : <code>true</code> when found, <code>false</code> otherwise
+    </ol>
+
+
+    <h3>See also:</h3>
+    <ul>
+         <a href="index.html#detect">detect</a>
+    </ul>
+
+
+</dd>
+    <dt>
+    <a name = "invoke"></a>
+    <strong>invoke (t, method[, ...])</strong>
+    </dt>
+    <dd>
+    Invokes a method on each value in a table.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">t</span>
+         a table
+        </li>
+        <li><span class="parameter">method</span>
+         a function, prototyped as <code>f (v, ...)</code>
+        </li>
+        <li><span class="parameter">...</span>
+         Optional args to be passed to <code>method</code>
+         (<em>optional</em>)
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        the result of the call <code>f (v, ...)</code>
+    </ol>
+
+
+    <h3>See also:</h3>
+    <ul>
+         <a href="index.html#pluck">pluck</a>
+    </ul>
+
+
+</dd>
+    <dt>
+    <a name = "map"></a>
+    <strong>map (t, f[, ...])</strong>
+    </dt>
+    <dd>
+    Maps <code>f (v, k)</code> on value-key pairs, collects and returns the results.
+ <br/><em>Aliased as <code>collect</code></em>.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">t</span>
+         a table
+        </li>
+        <li><span class="parameter">f</span>
+          an iterator function, prototyped as <code>f (v, k, ...)</code>
+        </li>
+        <li><span class="parameter">...</span>
+         Optional args to be passed to <code>f</code>
+         (<em>optional</em>)
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        a table of results
+    </ol>
+
+
+
+
+</dd>
+    <dt>
+    <a name = "mapReduce"></a>
+    <strong>mapReduce (t, f[, state])</strong>
+    </dt>
+    <dd>
+    Reduces a table while saving intermediate states.  Folds the table left-to-right
+ using a given iterator and an initial state. The iterator takes a state and a value,
+ and returns a new state. The result is an array of intermediate states.
+ <br/><em>Aliased as <code>mapr</code></em>
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">t</span>
+         a table
+        </li>
+        <li><span class="parameter">f</span>
+         an iterator function, prototyped as <code>f (state, value)</code>
+        </li>
+        <li><span class="parameter">state</span>
+         an initial state of reduction. Defaults to the first value in the table.
+         (<em>optional</em>)
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        an array of states
+    </ol>
+
+
+    <h3>See also:</h3>
+    <ul>
+         <a href="index.html#mapReduceRight">mapReduceRight</a>
+    </ul>
+
+
+</dd>
+    <dt>
+    <a name = "mapReduceRight"></a>
+    <strong>mapReduceRight (t, f[, state])</strong>
+    </dt>
+    <dd>
+    Reduces a table while saving intermediate states.  Folds the table right-to-left
+ using a given iterator and an initial state. The iterator takes a state and a value,
+ and returns a new state. The result is an array of intermediate states.
+ <br/><em>Aliased as <code>maprr</code></em>
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">t</span>
+         a table
+        </li>
+        <li><span class="parameter">f</span>
+         an iterator function, prototyped as <code>f (state, value)</code>
+        </li>
+        <li><span class="parameter">state</span>
+         an initial state of reduction. Defaults to the last value in the table.
+         (<em>optional</em>)
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        an array of states
+    </ol>
+
+
+    <h3>See also:</h3>
+    <ul>
+         <a href="index.html#mapReduce">mapReduce</a>
+    </ul>
+
+
+</dd>
+    <dt>
+    <a name = "max"></a>
+    <strong>max (t[, transform[, ...]])</strong>
+    </dt>
+    <dd>
+    Returns the max value in a collection.  If a <code>transform</code> function is passed, it will
+ be used to evaluate values by which all objects will be sorted.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">t</span>
+         a table
+        </li>
+        <li><span class="parameter">transform</span>
+         a transformation function, prototyped as <code>transform (v, ...)</code>, defaults to <a href="index.html#identity">identity</a>
+         (<em>optional</em>)
+        </li>
+        <li><span class="parameter">...</span>
+         Optional args to be passed to <code>transform</code>
+         (<em>optional</em>)
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        the max value found
+    </ol>
+
+
+    <h3>See also:</h3>
+    <ul>
+         <a href="index.html#min">min</a>
+    </ul>
+
+
+</dd>
+    <dt>
+    <a name = "min"></a>
+    <strong>min (t[, transform[, ...]])</strong>
+    </dt>
+    <dd>
+    Returns the min value in a collection.  If a <code>transform</code> function is passed, it will
+ be used to evaluate values by which all objects will be sorted.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">t</span>
+         a table
+        </li>
+        <li><span class="parameter">transform</span>
+         a transformation function, prototyped as <code>transform (v, ...)</code>, defaults to <a href="index.html#identity">identity</a>
+         (<em>optional</em>)
+        </li>
+        <li><span class="parameter">...</span>
+         Optional args to be passed to <code>transform</code>
+         (<em>optional</em>)
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        the min value found
+    </ol>
+
+
+    <h3>See also:</h3>
+    <ul>
+         <a href="index.html#max">max</a>
+    </ul>
+
+
+</dd>
+    <dt>
+    <a name = "pluck"></a>
+    <strong>pluck (t, key)</strong>
+    </dt>
+    <dd>
+    Extracts values in a table having a given key.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">t</span>
+         a table
+        </li>
+        <li><span class="parameter">key</span>
+         a key, will be used to index in each value: <code>value[key]</code>
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        an array of values having the given key
+    </ol>
+
+
+
+
+</dd>
+    <dt>
+    <a name = "reduce"></a>
+    <strong>reduce (t, f[, state])</strong>
+    </dt>
+    <dd>
+    Reduces a table, left-to-right.  Folds the table from the first element to the last element
+ to a single value, using a given iterator and an initial state.
+ The iterator takes a state and a value and returns a new state.
+ <br/><em>Aliased as <code>inject</code>, <code>foldl</code></em>.
 
-<br/>
-<br/>
 
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">t</span>
+         a table
+        </li>
+        <li><span class="parameter">f</span>
+         an iterator function, prototyped as <code>f (state, value)</code>
+        </li>
+        <li><span class="parameter">state</span>
+         an initial state of reduction. Defaults to the first value in the table.
+         (<em>optional</em>)
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
 
-    <h2 class="section-header "><a name="Table_functions"></a>Table functions </h2>
+        the final state of reduction
+    </ol>
 
-    <dl class="function">
+
+    <h3>See also:</h3>
+    <ul>
+         <li><a href="index.html#reduceRight">reduceRight</a></li>
+         <li><a href="index.html#reduceby">reduceby</a></li>
+    </ul>
+
+
+</dd>
     <dt>
-    <a name = "clear"></a>
-    <strong>clear (t)</strong>
+    <a name = "reduceRight"></a>
+    <strong>reduceRight (t, f[, state])</strong>
     </dt>
     <dd>
-    Clears a table.  All its values become nil.
+    Reduces a table, right-to-left.  Folds the table from the last element to the first element
+ to single value, using a given iterator and an initial state.
+ The iterator takes a state and a value, and returns a new state.
+ <br/><em>Aliased as <code>injectr</code>, <code>foldr</code></em>.
 
 
     <h3>Parameters:</h3>
@@ -655,25 +2176,36 @@
         <li><span class="parameter">t</span>
          a table
         </li>
+        <li><span class="parameter">f</span>
+         an iterator function, prototyped as <code>f (state, value)</code>
+        </li>
+        <li><span class="parameter">state</span>
+         an initial state of reduction. Defaults to the last value in the table.
+         (<em>optional</em>)
+        </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        the given table, cleared.
+        the final state of reduction
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <a href="index.html#reduce">reduce</a>
+    </ul>
 
 
 </dd>
     <dt>
-    <a name = "each"></a>
-    <strong>each (t, f[, ...])</strong>
+    <a name = "reduceby"></a>
+    <strong>reduceby (t, f, pred[, state[, ...]])</strong>
     </dt>
     <dd>
-    Iterates on key-value pairs, calling <code>f (k, v)</code> at every step.
- <br/><em>Aliased as <code>forEach</code></em>.
+    Reduces values in a table passing a given predicate.  Folds the table left-to-right, considering
+ only values validating a given predicate.
 
 
     <h3>Parameters:</h3>
@@ -682,32 +2214,42 @@
          a table
         </li>
         <li><span class="parameter">f</span>
-         a function, prototyped as <code>f (k, v, &hellip;)</code>
+         an iterator function, prototyped as <code>f (state, value)</code>
+        </li>
+        <li><span class="parameter">pred</span>
+         a predicate function <code>pred (v, k, ...)</code> to select values to be considered for reduction
+        </li>
+        <li><span class="parameter">state</span>
+         an initial state of reduction. Defaults to the first value in the table of selected values.
+         (<em>optional</em>)
         </li>
         <li><span class="parameter">...</span>
-         Optional args to be passed to <code>f</code>
+         optional args to be passed to <code>pred</code>
          (<em>optional</em>)
         </li>
     </ul>
 
+    <h3>Returns:</h3>
+    <ol>
+
+        the final state of reduction
+    </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <a href="index.html#eachi">eachi</a>
+         <a href="index.html#reduce">reduce</a>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "eachi"></a>
-    <strong>eachi (t, f[, ...])</strong>
+    <a name = "reject"></a>
+    <strong>reject (t, f[, ...])</strong>
     </dt>
     <dd>
-    Iterates on integer key-value pairs, calling <code>f(k, v)</code> every step.<br/>
- Only applies to values located at integer keys. The table can be a sparse array.
- Iteration will start from the lowest integer key found to the highest one.
- <br/><em>Aliased as <code>forEachi</code></em>.
+    Clones a table while dropping values passing an iterator test.
+ <br/><em>Aliased as <code>discard</code></em>
 
 
     <h3>Parameters:</h3>
@@ -716,7 +2258,7 @@
          a table
         </li>
         <li><span class="parameter">f</span>
-         a function, prototyped as <code>f (k, v, &hellip;)</code>
+         an iterator function, prototyped as <code>f (v, k, ...)</code>
         </li>
         <li><span class="parameter">...</span>
          Optional args to be passed to <code>f</code>
@@ -724,37 +2266,43 @@
         </li>
     </ul>
 
+    <h3>Returns:</h3>
+    <ol>
+
+        the remaining values
+    </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <a href="index.html#each">each</a>
+         <a href="index.html#select">select</a>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "at"></a>
-    <strong>at (t, ...)</strong>
+    <a name = "same"></a>
+    <strong>same (a, b)</strong>
     </dt>
     <dd>
-    Collects values at given keys and return them wrapped in an array.
+    Checks if two tables are the same.  It compares if both tables features the same values,
+ but not necessarily at the same keys.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">t</span>
+        <li><span class="parameter">a</span>
          a table
         </li>
-        <li><span class="parameter">...</span>
-         A variable number of keys to collect values
+        <li><span class="parameter">b</span>
+         another table
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        an array-list of values
+        <code>true</code> or <code>false</code>
     </ol>
 
 
@@ -762,46 +2310,44 @@
 
 </dd>
     <dt>
-    <a name = "count"></a>
-    <strong>count (t[, value])</strong>
+    <a name = "sameKeys"></a>
+    <strong>sameKeys (tA, tB)</strong>
     </dt>
     <dd>
-    Counts occurrences of a given value in a table.  Uses <a href="index.html#isEqual">isEqual</a> to compare values.
+    Checks if both given tables have the same keys.  It does not compares values.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">t</span>
+        <li><span class="parameter">tA</span>
          a table
         </li>
-        <li><span class="parameter">value</span>
-         a value to be searched in the table. If not given, the <a href="index.html#size">size</a> of the table will be returned
-         (<em>optional</em>)
+        <li><span class="parameter">tB</span>
+         another table
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        the count of occurrences of the given value
+        <code>true</code> or <code>false</code>
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <li><a href="index.html#countf">countf</a></li>
-         <li><a href="index.html#size">size</a></li>
+         <a href="index.html#containsKeys">containsKeys</a>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "countf"></a>
-    <strong>countf (t, f[, ...])</strong>
+    <a name = "select"></a>
+    <strong>select (t, f[, ...])</strong>
     </dt>
     <dd>
-    Counts occurrences validating a predicate.  Same as <a href="index.html#count">count</a>, but uses an iterator.
- Returns the count for values passing the test <code>f (k, v, &hellip;)</code>
+    Selects and returns values passing an iterator test.
+ <br/><em>Aliased as <code>filter</code></em>.
 
 
     <h3>Parameters:</h3>
@@ -810,7 +2356,7 @@
          a table
         </li>
         <li><span class="parameter">f</span>
-         an iterator function, prototyped as <code>f (k, v, &hellip;)</code>
+         an iterator function, prototyped as <code>f (v, k, ...)</code>
         </li>
         <li><span class="parameter">...</span>
          Optional args to be passed to <code>f</code>
@@ -821,26 +2367,55 @@
     <h3>Returns:</h3>
     <ol>
 
-        the count of values validating the predicate
+        the selected values
+    </ol>
+
+
+    <h3>See also:</h3>
+    <ul>
+         <a href="index.html#reject">reject</a>
+    </ul>
+
+
+</dd>
+    <dt>
+    <a name = "size"></a>
+    <strong>size ([...])</strong>
+    </dt>
+    <dd>
+    Counts the number of values in a collection.  If being passed more than one argument
+ it will return the count of all passed-in arguments.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">...</span>
+         Optional variable number of arguments
+         (<em>optional</em>)
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        a count
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
          <li><a href="index.html#count">count</a></li>
-         <li><a href="index.html#size">size</a></li>
+         <li><a href="index.html#countf">countf</a></li>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "cycle"></a>
-    <strong>cycle (t, n)</strong>
+    <a name = "sort"></a>
+    <strong>sort (t[, comp])</strong>
     </dt>
     <dd>
-    Loops <code>n</code> times through a table.  In case <code>n</code> is omitted, it will loop forever.
- In case <code>n</code> is lower or equal to 0, it returns an empty function.
- <br/><em>Aliased as <code>loop</code></em>.
+    Sorts a table, in-place.  If a comparison function is given, it will be used to sort values.
 
 
     <h3>Parameters:</h3>
@@ -848,75 +2423,151 @@
         <li><span class="parameter">t</span>
          a table
         </li>
-        <li><span class="parameter">n</span>
-         the number of loops
+        <li><span class="parameter">comp</span>
+         a comparison function prototyped as <code>comp (a, b)</code>, defaults to <tt>&lt;</tt> operator.
+         (<em>optional</em>)
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        the given table, sorted.
+    </ol>
+
+
+    <h3>See also:</h3>
+    <ul>
+         <a href="index.html#sortBy">sortBy</a>
+    </ul>
+
+
+</dd>
+    <dt>
+    <a name = "sortBy"></a>
+    <strong>sortBy (t[, transform[, comp]])</strong>
+    </dt>
+    <dd>
+    Sorts a table in-place using a transform.  Values are ranked in a custom order of the results of
+ running <code>transform (v)</code> on all values. <code>transform</code> may also be a string name property  sort by.
+ <code>comp</code> is a comparison function.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">t</span>
+         a table
+        </li>
+        <li><span class="parameter">transform</span>
+         a <code>transform</code> function to sort elements prototyped as <code>transform (v)</code>. Defaults to <a href="index.html#identity">identity</a>
+         (<em>optional</em>)
+        </li>
+        <li><span class="parameter">comp</span>
+         a comparison function, defaults to the <code>&lt;</code> operator
+         (<em>optional</em>)
+        </li>
+    </ul>
+
+    <h3>Returns:</h3>
+    <ol>
+
+        a new array of sorted values
+    </ol>
+
+
+    <h3>See also:</h3>
+    <ul>
+         <a href="index.html#sort">sort</a>
+    </ul>
+
+
+</dd>
+    <dt>
+    <a name = "where"></a>
+    <strong>where (t, props)</strong>
+    </dt>
+    <dd>
+    Returns all values having specified keys <code>props</code>.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">t</span>
+         a table
+        </li>
+        <li><span class="parameter">props</span>
+         a set of keys
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        an iterator function yielding key-value pairs from the passed-in table.
+        an array of values from the passed-in table
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <a href="index.html#findWhere">findWhere</a>
+    </ul>
+
 
+</dd>
+</dl>
+    <h2 class="section-header "><a name="Array_functions"></a>Array functions </h2>
 
-</dd>
+    <dl class="function">
     <dt>
-    <a name = "map"></a>
-    <strong>map (t, f[, ...])</strong>
+    <a name = "addTop"></a>
+    <strong>addTop (array, ...)</strong>
     </dt>
     <dd>
-    Maps <code>f (k, v)</code> on key-value pairs, collects and returns the results.
- <br/><em>Aliased as <code>collect</code></em>.
+    Adds all passed-in values at the top of an array.  The last elements will bubble to the
+ top of the given array.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">t</span>
-         a table
-        </li>
-        <li><span class="parameter">f</span>
-          an iterator function, prototyped as <code>f (k, v, &hellip;)</code>
+        <li><span class="parameter">array</span>
+         an array
         </li>
         <li><span class="parameter">...</span>
-         Optional args to be passed to <code>f</code>
-         (<em>optional</em>)
+         a variable number of arguments
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a table of results
+        the passed-in array with new values added
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <li><a href="index.html#prepend">prepend</a></li>
+         <li><a href="index.html#push">push</a></li>
+    </ul>
 
 
 </dd>
     <dt>
-    <a name = "reduce"></a>
-    <strong>reduce (t, f[, state])</strong>
+    <a name = "aperture"></a>
+    <strong>aperture (array[, n])</strong>
     </dt>
     <dd>
-    Reduces a table, left-to-right.  Folds the table from the first element to the last element
- to a single value, using a given iterator and an initial state.
- The iterator takes a state and a value and returns a new state.
- <br/><em>Aliased as <code>inject</code>, <code>foldl</code></em>.
+    Iterator returning sliding partitions of an array.
+ <br/><em>Aliased as <code>sliding</code></em>
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">t</span>
-         a table
-        </li>
-        <li><span class="parameter">f</span>
-         an iterator function, prototyped as <code>f (state, value)</code>
+        <li><span class="parameter">array</span>
+         an array
         </li>
-        <li><span class="parameter">state</span>
-         an initial state of reduction. Defaults to the first value in the table.
+        <li><span class="parameter">n</span>
+         the size of partitions. Defaults to 2 (and then behaves like <a href="index.html#pairwise">pairwise</a>)
          (<em>optional</em>)
         </li>
     </ul>
@@ -924,82 +2575,67 @@
     <h3>Returns:</h3>
     <ol>
 
-        the final state of reduction
+        an iterator function
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <li><a href="index.html#reduceRight">reduceRight</a></li>
-         <li><a href="index.html#reduceby">reduceby</a></li>
+         <li><a href="index.html#partition">partition</a></li>
+         <li><a href="index.html#overlapping">overlapping</a></li>
+         <li><a href="index.html#pairwise">pairwise</a></li>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "reduceby"></a>
-    <strong>reduceby (t, f, state, pred[, ...])</strong>
+    <a name = "append"></a>
+    <strong>append (array, other)</strong>
     </dt>
     <dd>
-    Reduces values in a table passing a given predicate.  Folds the table left-to-right, considering
- only values validating a given predicate.
+    Clones array and appends values from another array.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">t</span>
-         a table
-        </li>
-        <li><span class="parameter">f</span>
-         an iterator function, prototyped as <code>f (state, value)</code>
-        </li>
-        <li><span class="parameter">state</span>
-         an initial state of reduction.
-        </li>
-        <li><span class="parameter">pred</span>
-         a predicate function <code>pred (k, v, &hellip;)</code> to select values to be considered for reduction
+        <li><span class="parameter">array</span>
+         an array
         </li>
-        <li><span class="parameter">...</span>
-         optional args to be passed to <code>pred</code>
-         (<em>optional</em>)
+        <li><span class="parameter">other</span>
+         an array
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        the final state of reduction
+        a new array
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <a href="index.html#reduce">reduce</a>
-    </ul>
 
 
 </dd>
     <dt>
-    <a name = "reduceRight"></a>
-    <strong>reduceRight (t, f[, state])</strong>
+    <a name = "chunk"></a>
+    <strong>chunk (array, f[, ...])</strong>
     </dt>
     <dd>
-    Reduces a table, right-to-left.  Folds the table from the last element to the first element
- to single value, using a given iterator and an initial state.
- The iterator takes a state and a value, and returns a new state.
- <br/><em>Aliased as <code>injectr</code>, <code>foldr</code></em>.
+    Chunks together consecutive values.  Values are chunked on the basis of the return
+ value of a provided predicate <code>f (k, v, ...)</code>. Consecutive elements which return
+ the same value are chunked together. Leaves the first argument untouched if it is not an array.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">t</span>
-         a table
+        <li><span class="parameter">array</span>
+         an array
         </li>
         <li><span class="parameter">f</span>
-         an iterator function, prototyped as <code>f (state, value)</code>
+         an iterator function prototyped as <code>f (v, k, ...)</code>
         </li>
-        <li><span class="parameter">state</span>
-         an initial state of reduction. Defaults to the last value in the table.
+        <li><span class="parameter">...</span>
+         Optional args to be passed to <code>f</code>
          (<em>optional</em>)
         </li>
     </ul>
@@ -1007,77 +2643,68 @@
     <h3>Returns:</h3>
     <ol>
 
-        the final state of reduction
+        a table of chunks (arrays)
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <a href="index.html#reduce">reduce</a>
+         <a href="index.html#zip">zip</a>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "mapReduce"></a>
-    <strong>mapReduce (t, f[, state])</strong>
+    <a name = "compact"></a>
+    <strong>compact (array)</strong>
     </dt>
     <dd>
-    Reduces a table while saving intermediate states.  Folds the table left-to-right
- using a given iterator and an initial state. The iterator takes a state and a value,
- and returns a new state. The result is an array of intermediate states.
- <br/><em>Aliased as <code>mapr</code></em>
+    Returns all truthy values (removes <code>falses</code> and <code>nils</code>).
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">t</span>
-         a table
-        </li>
-        <li><span class="parameter">f</span>
-         an iterator function, prototyped as <code>f (state, value)</code>
-        </li>
-        <li><span class="parameter">state</span>
-         an initial state of reduction. Defaults to the first value in the table.
-         (<em>optional</em>)
+        <li><span class="parameter">array</span>
+         an array
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        an array of states
+        a new array
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <a href="index.html#mapReduceRight">mapReduceRight</a>
-    </ul>
 
 
 </dd>
     <dt>
-    <a name = "mapReduceRight"></a>
-    <strong>mapReduceRight (t, f[, state])</strong>
+    <a name = "concat"></a>
+    <strong>concat (array[, sep[, i[, j]]])</strong>
     </dt>
     <dd>
-    Reduces a table while saving intermediate states.  Folds the table right-to-left
- using a given iterator and an initial state. The iterator takes a state and a value,
- and returns a new state. The result is an array of intermediate states.
- <br/><em>Aliased as <code>maprr</code></em>
+    Concatenates values in a given array.  Handles booleans as well. If <code>sep</code> string is
+ passed, it will be used as a separator. Passing <code>i</code> and <code>j</code> will result in concatenating
+ only values within <code>[i, j]</code> range.
+ <br/><em>Aliased as <code>join</code></em>
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">t</span>
-         a table
+        <li><span class="parameter">array</span>
+         a given array
         </li>
-        <li><span class="parameter">f</span>
-         an iterator function, prototyped as <code>f (state, value)</code>
+        <li><span class="parameter">sep</span>
+         a separator string, defaults to the empty string <code>&apos;&apos;</code>.
+         (<em>optional</em>)
         </li>
-        <li><span class="parameter">state</span>
-         an initial state of reduction. Defaults to the last value in the table.
+        <li><span class="parameter">i</span>
+         the starting index, defaults to 1.
+         (<em>optional</em>)
+        </li>
+        <li><span class="parameter">j</span>
+         the final index, defaults to the array length.
          (<em>optional</em>)
         </li>
     </ul>
@@ -1085,169 +2712,179 @@
     <h3>Returns:</h3>
     <ol>
 
-        an array of states
+        a string
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <a href="index.html#mapReduce">mapReduce</a>
-    </ul>
 
 
 </dd>
     <dt>
-    <a name = "include"></a>
-    <strong>include (t, value)</strong>
+    <a name = "difference"></a>
+    <strong>difference (array, another)</strong>
     </dt>
     <dd>
-    Performs a linear search for a value in a table.  It does not work for nested tables.
- The given value can be a function prototyped as <code>f (v, value)</code> which should return true when
- any v in the table equals the value being searched.
- <br/><em>Aliased as <code>any</code>, <code>some</code>, <code>contains</code></em>
+    Returns values from an array not present in all passed-in args.
+ <br/><em>Aliased as <code>without</code> and <code>diff</code></em>
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">t</span>
-         a table
+        <li><span class="parameter">array</span>
+         an array
         </li>
-        <li><span class="parameter">value</span>
-         a value to search for
+        <li><span class="parameter">another</span>
+         array
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a boolean : <code>true</code> when found, <code>false</code> otherwise
+        a new array
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <a href="index.html#detect">detect</a>
+         <li><a href="index.html#union">union</a></li>
+         <li><a href="index.html#intersection">intersection</a></li>
+         <li><a href="index.html#symmetricDifference">symmetricDifference</a></li>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "detect"></a>
-    <strong>detect (t, value)</strong>
+    <a name = "dropWhile"></a>
+    <strong>dropWhile (array, f[, ...])</strong>
     </dt>
     <dd>
-    Performs a linear search for a value in a table.  Returns the key of the value if found.
- The given value can be a function prototyped as <code>f (v, value)</code> which should return true when
- any v in the table equals the value being searched.
+    Collects values from a given array.  The passed-in array should not be sparse.
+ This function collects values as long as they do not satisfy a given predicate and returns on the first truthy test.
+ <br/><em>Aliased as <code>rejectWhile</code></em>
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">t</span>
-         a table
+        <li><span class="parameter">array</span>
+         an array
         </li>
-        <li><span class="parameter">value</span>
-         a value to search for
+        <li><span class="parameter">f</span>
+         an iterator function prototyped as <code>f (v, k, ...)</code>
+        </li>
+        <li><span class="parameter">...</span>
+         Optional args to be passed to <code>f</code>
+         (<em>optional</em>)
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        the key of the value when found or <strong>nil</strong>
+        a new table containing all values collected
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <a href="index.html#include">include</a>
+         <a href="index.html#selectWhile">selectWhile</a>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "where"></a>
-    <strong>where (t, props)</strong>
+    <a name = "fill"></a>
+    <strong>fill (array, value[, i[, j]])</strong>
     </dt>
     <dd>
-    Returns all values having specified keys <code>props</code>.
+    Replaces elements in a given array with a given value.  In case <code>i</code> and <code>j</code> are given
+ it will only replaces values at indexes between <code>[i,j]</code>. In case <code>j</code> is greater than the array
+ size, it will append new values, increasing the array size.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">t</span>
-         a table
+        <li><span class="parameter">array</span>
+         an array
         </li>
-        <li><span class="parameter">props</span>
-         a set of keys
+        <li><span class="parameter">value</span>
+         a value
+        </li>
+        <li><span class="parameter">i</span>
+         the index from which to start replacing values. Defaults to 1.
+         (<em>optional</em>)
+        </li>
+        <li><span class="parameter">j</span>
+         the index where to stop replacing values. Defaults to the array size.
+         (<em>optional</em>)
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        an array of values from the passed-in table
+        the original array with values changed
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <a href="index.html#findWhere">findWhere</a>
-    </ul>
 
 
 </dd>
     <dt>
-    <a name = "findWhere"></a>
-    <strong>findWhere (t, props)</strong>
+    <a name = "find"></a>
+    <strong>find (array, value[, from])</strong>
     </dt>
     <dd>
-    Returns the first value having specified keys <code>props</code>.
+    Looks for the first occurrence of a given value in an array.  Returns the value index if found.
+ Uses <a href="index.html#isEqual">isEqual</a> to compare values.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">t</span>
-         a table
+        <li><span class="parameter">array</span>
+         an array of values
         </li>
-        <li><span class="parameter">props</span>
-         a set of keys
+        <li><span class="parameter">value</span>
+         a value to lookup for
+        </li>
+        <li><span class="parameter">from</span>
+         the index from where the search will start. Defaults to 1.
+         (<em>optional</em>)
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a value from the passed-in table
+        the index of the value if found in the array, <code>nil</code> otherwise.
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <a href="index.html#where">where</a>
+         <a href="index.html#detect">detect</a>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "select"></a>
-    <strong>select (t, f[, ...])</strong>
+    <a name = "findIndex"></a>
+    <strong>findIndex (array, predicate[, ...])</strong>
     </dt>
     <dd>
-    Selects and returns values passing an iterator test.
- <br/><em>Aliased as <code>filter</code></em>.
+    Returns the first index at which a predicate returns true.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">t</span>
-         a table
+        <li><span class="parameter">array</span>
+         an array
         </li>
-        <li><span class="parameter">f</span>
-         an iterator function, prototyped as <code>f (k, v, &hellip;)</code>
+        <li><span class="parameter">predicate</span>
+         a predicate function prototyped as <code>predicate (v, k, ...)</code>
         </li>
         <li><span class="parameter">...</span>
-         Optional args to be passed to <code>f</code>
+         optional arguments to <code>pred</code>
          (<em>optional</em>)
         </li>
     </ul>
@@ -1255,36 +2892,35 @@
     <h3>Returns:</h3>
     <ol>
 
-        the selected values
+        the index found or <strong>nil</strong>
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <a href="index.html#reject">reject</a>
+         <a href="index.html#findLastIndex">findLastIndex</a>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "reject"></a>
-    <strong>reject (t, f[, ...])</strong>
+    <a name = "findLastIndex"></a>
+    <strong>findLastIndex (array, predicate[, ...])</strong>
     </dt>
     <dd>
-    Clones a table while dropping values passing an iterator test.
- <br/><em>Aliased as <code>discard</code></em>
+    Returns the last index at which a predicate returns true.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">t</span>
-         a table
+        <li><span class="parameter">array</span>
+         an array
         </li>
-        <li><span class="parameter">f</span>
-         an iterator function, prototyped as <code>f (k, v, &hellip;)</code>
+        <li><span class="parameter">predicate</span>
+         a predicate function prototyped as <code>predicate (k, v, ...)</code>
         </li>
         <li><span class="parameter">...</span>
-         Optional args to be passed to <code>f</code>
+         optional arguments to <code>pred</code>
          (<em>optional</em>)
         </li>
     </ul>
@@ -1292,36 +2928,33 @@
     <h3>Returns:</h3>
     <ol>
 
-        the remaining values
+        the index found or <strong>nil</strong>
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <a href="index.html#select">select</a>
+         <a href="index.html#findIndex">findIndex</a>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "all"></a>
-    <strong>all (t, f[, ...])</strong>
+    <a name = "first"></a>
+    <strong>first (array[, n])</strong>
     </dt>
     <dd>
-    Checks if all values in a table are passing an iterator test.
- <br/><em>Aliased as <code>every</code></em>
+    Returns the first N values in an array.
+ <br/><em>Aliased as <code>head</code>, <code>take</code> </em>
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">t</span>
-         a table
-        </li>
-        <li><span class="parameter">f</span>
-         an iterator function, prototyped as <code>f (k, v, &hellip;)</code>
+        <li><span class="parameter">array</span>
+         an array
         </li>
-        <li><span class="parameter">...</span>
-         Optional args to be passed to <code>f</code>
+        <li><span class="parameter">n</span>
+         the number of values to be collected, defaults to 1.
          (<em>optional</em>)
         </li>
     </ul>
@@ -1329,31 +2962,34 @@
     <h3>Returns:</h3>
     <ol>
 
-        <code>true</code> if all values passes the predicate, <code>false</code> otherwise
+        a new array
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <li><a href="index.html#initial">initial</a></li>
+         <li><a href="index.html#last">last</a></li>
+         <li><a href="index.html#rest">rest</a></li>
+    </ul>
 
 
 </dd>
     <dt>
-    <a name = "invoke"></a>
-    <strong>invoke (t, method[, ...])</strong>
+    <a name = "flatten"></a>
+    <strong>flatten (array[, shallow])</strong>
     </dt>
     <dd>
-    Invokes a method on each value in a table.
+    Flattens a nested array.  Passing <code>shallow</code> will only flatten at the first level.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">t</span>
-         a table
-        </li>
-        <li><span class="parameter">method</span>
-         a function, prototyped as <code>f (v, &hellip;)</code>
+        <li><span class="parameter">array</span>
+         an array
         </li>
-        <li><span class="parameter">...</span>
-         Optional args to be passed to <code>method</code>
+        <li><span class="parameter">shallow</span>
+         specifies the flattening depth. Defaults to <code>false</code>.`
          (<em>optional</em>)
         </li>
     </ul>
@@ -1361,65 +2997,60 @@
     <h3>Returns:</h3>
     <ol>
 
-        the result of the call <code>f (v, &hellip;)</code>
+        a flattened array
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <a href="index.html#pluck">pluck</a>
-    </ul>
 
 
 </dd>
     <dt>
-    <a name = "pluck"></a>
-    <strong>pluck (t, key)</strong>
+    <a name = "indexOf"></a>
+    <strong>indexOf (array, value)</strong>
     </dt>
     <dd>
-    Extracts values in a table having a given key.
+    Returns the index of the first occurrence of value in an array.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">t</span>
-         a table
+        <li><span class="parameter">array</span>
+         an array
         </li>
-        <li><span class="parameter">key</span>
-         a key, will be used to index in each value: <code>value[key]</code>
+        <li><span class="parameter">value</span>
+         the value to search for
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        an array of values having the given key
+        the index of the passed-in value
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <a href="index.html#lastIndexOf">lastIndexOf</a>
+    </ul>
 
 
 </dd>
     <dt>
-    <a name = "max"></a>
-    <strong>max (t[, transform[, ...]])</strong>
+    <a name = "initial"></a>
+    <strong>initial (array[, n])</strong>
     </dt>
     <dd>
-    Returns the max value in a collection.  If an transformation function is passed, it will
- be used to evaluate values by which all objects will be sorted.
+    Returns all values in an array excluding the last N values.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">t</span>
-         a table
-        </li>
-        <li><span class="parameter">transform</span>
-         a transformation function, prototyped as <code>transform (v, &hellip;)</code>, defaults to <a href="index.html#identity">identity</a>
-         (<em>optional</em>)
+        <li><span class="parameter">array</span>
+         an array
         </li>
-        <li><span class="parameter">...</span>
-         Optional args to be passed to <code>transform</code>
+        <li><span class="parameter">n</span>
+         the number of values to be left, defaults to the array length.
          (<em>optional</em>)
         </li>
     </ul>
@@ -1427,204 +3058,190 @@
     <h3>Returns:</h3>
     <ol>
 
-        the max value found
+        a new array
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <a href="index.html#min">min</a>
+         <li><a href="index.html#first">first</a></li>
+         <li><a href="index.html#last">last</a></li>
+         <li><a href="index.html#rest">rest</a></li>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "min"></a>
-    <strong>min (t[, transform[, ...]])</strong>
+    <a name = "interleave"></a>
+    <strong>interleave (...)</strong>
     </dt>
     <dd>
-    Returns the min value in a collection.  If an transformation function is passed, it will
- be used to evaluate values by which all objects will be sorted.
+    Interleaves arrays.  It returns a single array made of values from all
+ passed in arrays in their given order, interleaved.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">t</span>
-         a table
-        </li>
-        <li><span class="parameter">transform</span>
-         a transformation function, prototyped as <code>transform (v, &hellip;)</code>, defaults to <a href="index.html#identity">identity</a>
-         (<em>optional</em>)
-        </li>
         <li><span class="parameter">...</span>
-         Optional args to be passed to <code>transform</code>
-         (<em>optional</em>)
+         a variable list of arrays
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        the min value found
+        a new array
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <a href="index.html#max">max</a>
+         <a href="index.html#interpose">interpose</a>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "shuffle"></a>
-    <strong>shuffle (t[, seed])</strong>
+    <a name = "interpose"></a>
+    <strong>interpose (array, value)</strong>
     </dt>
     <dd>
-    Returns a shuffled copy of a given collection.  If a seed is provided, it will
- be used to init the pseudo random number generator (using <a href="https://www.lua.org/manual/5.1/manual.html#pdf-math.randomseed">math.randomseed</a>).
+    Interposes value in-between consecutive pair of values in array.
+ <br/><em>Aliased as <code>intersperse</code></em>
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">t</span>
-         a table
+        <li><span class="parameter">array</span>
+         an array
         </li>
-        <li><span class="parameter">seed</span>
-         a seed
-         (<em>optional</em>)
+        <li><span class="parameter">value</span>
+         a value
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a shuffled copy of the given table
+        a new array
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <a href="index.html#interleave">interleave</a>
+    </ul>
 
 
 </dd>
     <dt>
-    <a name = "same"></a>
-    <strong>same (a, b)</strong>
+    <a name = "intersection"></a>
+    <strong>intersection (array, ...)</strong>
     </dt>
     <dd>
-    Checks if two tables are the same.  It compares if both tables features the same values,
- but not necessarily at the same keys.
+    Returns the  intersection of all passed-in arrays.
+ Each value in the result is present in each of the passed-in arrays.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">a</span>
-         a table
+        <li><span class="parameter">array</span>
+         an array
         </li>
-        <li><span class="parameter">b</span>
-         another table
+        <li><span class="parameter">...</span>
+         a variable number of array arguments
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        <code>true</code> or <code>false</code>
+        a new array
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <li><a href="index.html#difference">difference</a></li>
+         <li><a href="index.html#union">union</a></li>
+         <li><a href="index.html#symmetricDifference">symmetricDifference</a></li>
+    </ul>
 
 
 </dd>
     <dt>
-    <a name = "sort"></a>
-    <strong>sort (t[, comp])</strong>
+    <a name = "invert"></a>
+    <strong>invert (array)</strong>
     </dt>
     <dd>
-    Sorts a table, in-place.  If a comparison function is given, it will be used to sort values.
+    Swaps keys with values.  Produces a new array where previous keys are now values,
+ while previous values are now keys.
+ <br/><em>Aliased as <code>mirror</code></em>
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">t</span>
-         a table
-        </li>
-        <li><span class="parameter">comp</span>
-         a comparison function prototyped as <code>comp (a, b)</code>, defaults to <tt>&lt;</tt> operator.
-         (<em>optional</em>)
+        <li><span class="parameter">array</span>
+         a given array
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        the initial table, sorted.
+        a new array
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <a href="index.html#sortBy">sortBy</a>
-    </ul>
 
 
 </dd>
     <dt>
-    <a name = "sortBy"></a>
-    <strong>sortBy (t[, transform[, comp]])</strong>
+    <a name = "isunique"></a>
+    <strong>isunique (array)</strong>
     </dt>
     <dd>
-    Sorts a table in-place using a transform.  Values are ranked in a custom order of the results of
- running <code>transform (v)</code> on all values. <code>transform</code> may also be a string name property  sort by.
- <code>comp</code> is a comparison function.
+    Checks if a given array contains distinct values.  Such an array is made of distinct elements,
+ which only occur once in this array.
+ <br/><em>Aliased as <code>isuniq</code></em>
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">t</span>
-         a table
-        </li>
-        <li><span class="parameter">transform</span>
-         a <code>transform</code> function to sort elements prototyped as <code>transform (v)</code>. Defaults to <a href="index.html#identity">identity</a>
-         (<em>optional</em>)
-        </li>
-        <li><span class="parameter">comp</span>
-         a comparision function, defaults to the <code>&lt;</code> operator
-         (<em>optional</em>)
+        <li><span class="parameter">array</span>
+         an array
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a new array of sorted values
+        <code>true</code> if the given array is unique, <code>false</code> otherwise.
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <a href="index.html#sort">sort</a>
+         <a href="index.html#unique">unique</a>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "groupBy"></a>
-    <strong>groupBy (t, iter[, ...])</strong>
+    <a name = "last"></a>
+    <strong>last (array[, n])</strong>
     </dt>
     <dd>
-    Splits a table into subsets groups.
+    Returns the last N values in an array.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">t</span>
-         a table
-        </li>
-        <li><span class="parameter">iter</span>
-         an iterator function, prototyped as <code>iter (k, v, &hellip;)</code>
+        <li><span class="parameter">array</span>
+         an array
         </li>
-        <li><span class="parameter">...</span>
-         Optional args to be passed to <code>iter</code>
+        <li><span class="parameter">n</span>
+         the number of values to be collected, defaults to the array length.
          (<em>optional</em>)
         </li>
     </ul>
@@ -1632,194 +3249,180 @@
     <h3>Returns:</h3>
     <ol>
 
-        a table of subsets groups
+        a new array
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <li><a href="index.html#first">first</a></li>
+         <li><a href="index.html#initial">initial</a></li>
+         <li><a href="index.html#rest">rest</a></li>
+    </ul>
 
 
 </dd>
     <dt>
-    <a name = "countBy"></a>
-    <strong>countBy (t, iter[, ...])</strong>
+    <a name = "lastIndexOf"></a>
+    <strong>lastIndexOf (array, value)</strong>
     </dt>
     <dd>
-    Groups values in a collection and counts them.
+    Returns the index of the last occurrence of value in an array.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">t</span>
-         a table
-        </li>
-        <li><span class="parameter">iter</span>
-         an iterator function, prototyped as <code>iter (k, v, &hellip;)</code>
+        <li><span class="parameter">array</span>
+         an array
         </li>
-        <li><span class="parameter">...</span>
-         Optional args to be passed to <code>iter</code>
-         (<em>optional</em>)
+        <li><span class="parameter">value</span>
+         the value to search for
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a table of subsets groups names paired with their count
+        the index of the last occurrence of the passed-in value or <strong>nil</strong>
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <a href="index.html#indexOf">indexOf</a>
+    </ul>
 
 
 </dd>
     <dt>
-    <a name = "size"></a>
-    <strong>size ([...])</strong>
+    <a name = "mean"></a>
+    <strong>mean (array)</strong>
     </dt>
     <dd>
-    Counts the number of values in a collection.  If being passed more than one argument
- it will return the count of all passed-in arguments.
+    Returns the mean of an array of numbers.
+ <br/><em>Aliased as <code>average</code></em>
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">...</span>
-         Optional variable number of arguments
-         (<em>optional</em>)
+        <li><span class="parameter">array</span>
+         an array of numbers
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a count
+        a number
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <li><a href="index.html#count">count</a></li>
-         <li><a href="index.html#countf">countf</a></li>
+         <li><a href="index.html#sum">sum</a></li>
+         <li><a href="index.html#product">product</a></li>
+         <li><a href="index.html#median">median</a></li>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "containsKeys"></a>
-    <strong>containsKeys (t, other)</strong>
+    <a name = "median"></a>
+    <strong>median (array)</strong>
     </dt>
     <dd>
-    Checks if all the keys of <code>other</code> table exists in table <code>t</code>.  It does not
- compares values. The test is not commutative, i.e table <code>t</code> may contains keys
- not existing in <code>other</code>.
+    Returns the median of an array of numbers.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">t</span>
-         a table
-        </li>
-        <li><span class="parameter">other</span>
-         another table
+        <li><span class="parameter">array</span>
+         an array of numbers
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        <code>true</code> or <code>false</code>
+        a number
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <a href="index.html#sameKeys">sameKeys</a>
+         <li><a href="index.html#sum">sum</a></li>
+         <li><a href="index.html#product">product</a></li>
+         <li><a href="index.html#mean">mean</a></li>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "sameKeys"></a>
-    <strong>sameKeys (tA, tB)</strong>
+    <a name = "nth"></a>
+    <strong>nth (array, index)</strong>
     </dt>
     <dd>
-    Checks if both given tables have the same keys.  It does not compares values.
+    Returns the value at a given index.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">tA</span>
-         a table
+        <li><span class="parameter">array</span>
+         an array
         </li>
-        <li><span class="parameter">tB</span>
-         another table
+        <li><span class="parameter">index</span>
+         an index
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        <code>true</code> or <code>false</code>
+        the value at the given index
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <a href="index.html#containsKeys">containsKeys</a>
-    </ul>
 
 
 </dd>
-</dl>
-    <h2 class="section-header "><a name="Array_functions"></a>Array functions </h2>
-
-    <dl class="function">
     <dt>
-    <a name = "sample"></a>
-    <strong>sample (array[, n[, seed]])</strong>
+    <a name = "ones"></a>
+    <strong>ones (n)</strong>
     </dt>
     <dd>
-    Samples <code>n</code> random values from an array.  If <code>n</code> is not specified, returns a single element.
- It uses internally <a href="index.html#shuffle">shuffle</a> to shuffle the array before sampling values. If <code>seed</code> is passed,
- it will be used for shuffling.
+    Returns an array of <code>n</code> 1's.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">array</span>
-         an array
-        </li>
         <li><span class="parameter">n</span>
-         a number of elements to be sampled. Defaults to 1.
-         (<em>optional</em>)
-        </li>
-        <li><span class="parameter">seed</span>
-         an optional seed for shuffling
-         (<em>optional</em>)
+         a number
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        an array of selected values or a single value when <code>n</code> == 1
+        an array
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <a href="index.html#sampleProb">sampleProb</a>
+         <li><a href="index.html#zeros">zeros</a></li>
+         <li><a href="index.html#vector">vector</a></li>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "sampleProb"></a>
-    <strong>sampleProb (array, prob[, seed])</strong>
+    <a name = "overlapping"></a>
+    <strong>overlapping (array[, n[, pads]])</strong>
     </dt>
     <dd>
-    Return elements from a sequence with a given probability.  It considers each value independently.
- Providing a seed will result in deterministic sampling. Given the same seed it will return the same sample
- every time.
+    Iterator returning overlapping partitions of an array. <br/>
+ If the last subsequence has lower elements than <code>n</code> and <code>pad</code> is
+ supplied, it will be adjusted to <code>n</code> elements with <code>pad</code> value.
 
 
     <h3>Parameters:</h3>
@@ -1827,11 +3430,12 @@
         <li><span class="parameter">array</span>
          an array
         </li>
-        <li><span class="parameter">prob</span>
-         a probability for each element in array to be selected
+        <li><span class="parameter">n</span>
+         the size of partitions. Defaults to 2.
+         (<em>optional</em>)
         </li>
-        <li><span class="parameter">seed</span>
-         an optional seed for deterministic sampling
+        <li><span class="parameter">pads</span>
+         a value to adjust the last subsequence to the <code>n</code> elements
          (<em>optional</em>)
         </li>
     </ul>
@@ -1839,61 +3443,68 @@
     <h3>Returns:</h3>
     <ol>
 
-        an array of selected values
+        an iterator function
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <a href="index.html#sample">sample</a>
+         <li><a href="index.html#partition">partition</a></li>
+         <li><a href="index.html#aperture">aperture</a></li>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "toArray"></a>
-    <strong>toArray (...)</strong>
+    <a name = "pairwise"></a>
+    <strong>pairwise (array)</strong>
     </dt>
     <dd>
-    Converts a list of arguments to an array.
+    Iterator returning sliding pairs of an array.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">...</span>
-         a list of arguments
+        <li><span class="parameter">array</span>
+         an array
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        an array of all passed-in args
+        an iterator function
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <a href="index.html#overlapping">overlapping</a>
+    </ul>
 
 
 </dd>
     <dt>
-    <a name = "find"></a>
-    <strong>find (array, value[, from])</strong>
+    <a name = "partition"></a>
+    <strong>partition (array[, n[, pads]])</strong>
     </dt>
     <dd>
-    Looks for the first occurrence of a given value in an array.  Returns the value index if found.
- Uses <a href="index.html#isEqual">isEqual</a> to compare values.
+    Iterator returning partitions of an array.  It returns arrays of length <code>n</code>
+ made of values from the given array. If the last partition has lower elements than <code>n</code> and
+ <code>pad</code> is supplied, it will be adjusted to <code>n</code> of elements with <code>pad</code> value.
 
 
     <h3>Parameters:</h3>
     <ul>
         <li><span class="parameter">array</span>
-         an array of values
+         an array
         </li>
-        <li><span class="parameter">value</span>
-         a value to lookup for
+        <li><span class="parameter">n</span>
+         the size of partitions. Defaults to 1.
+         (<em>optional</em>)
         </li>
-        <li><span class="parameter">from</span>
-         the index from where the search will start. Defaults to 1.
+        <li><span class="parameter">pads</span>
+         a value to adjust the last subsequence to the <code>n</code> elements
          (<em>optional</em>)
         </li>
     </ul>
@@ -1901,19 +3512,25 @@
     <h3>Returns:</h3>
     <ol>
 
-        the index of the value if found in the array, <code>nil</code> otherwise.
+        an iterator function
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <li><a href="index.html#overlapping">overlapping</a></li>
+         <li><a href="index.html#aperture">aperture</a></li>
+    </ul>
 
 
 </dd>
     <dt>
-    <a name = "reverse"></a>
-    <strong>reverse (array)</strong>
+    <a name = "permutation"></a>
+    <strong>permutation (array)</strong>
     </dt>
     <dd>
-    Returns an array where values are in reverse order.  The passed-in array should not be sparse.
+    Iterator returning the permutations of an array.  It returns arrays made of all values
+ from the passed-in array, with values permuted.
 
 
     <h3>Parameters:</h3>
@@ -1926,7 +3543,7 @@
     <h3>Returns:</h3>
     <ol>
 
-        a reversed array
+        an iterator function
     </ol>
 
 
@@ -1934,13 +3551,12 @@
 
 </dd>
     <dt>
-    <a name = "fill"></a>
-    <strong>fill (array, value[, i[, j]])</strong>
+    <a name = "powerset"></a>
+    <strong>powerset (array)</strong>
     </dt>
     <dd>
-    Replaces elements in a given array with a given value.  In case <code>i</code> and <code>j</code> are given
- it will only replaces values at indexes between <code>[i,j]</code>. In case <code>j</code> is greather than the array
- size, it will append new values, increasing the array.
+    Returns the powerset of array values.  For instance, when given the set {1,2,3},
+ returns <code>{{1},{2},{3},{1,2},{2,3},{1,2,3}}</code>.
 
 
     <h3>Parameters:</h3>
@@ -1948,23 +3564,12 @@
         <li><span class="parameter">array</span>
          an array
         </li>
-        <li><span class="parameter">value</span>
-         a value
-        </li>
-        <li><span class="parameter">i</span>
-         the index from which to start replacing values. Defaults to 1.
-         (<em>optional</em>)
-        </li>
-        <li><span class="parameter">j</span>
-         the index where to stop replacing values. Defaults to the array size.
-         (<em>optional</em>)
-        </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        the original array with values changed
+        an array
     </ol>
 
 
@@ -1972,13 +3577,12 @@
 
 </dd>
     <dt>
-    <a name = "selectWhile"></a>
-    <strong>selectWhile (array, f[, ...])</strong>
+    <a name = "prepend"></a>
+    <strong>prepend (array, ...)</strong>
     </dt>
     <dd>
-    Collects values from a given array.  The passed-in array should not be sparse.
- This function collects values as long as they satisfy a given predicate and returns on the first falsy test.
- <br/><em>Aliased as <code>takeWhile</code></em>
+    Adds all passed-in values at the top of an array.  As opposed to <a href="index.html#addTop">addTop</a>, it preserves the order
+ of the passed in elements.
 
 
     <h3>Parameters:</h3>
@@ -1986,57 +3590,45 @@
         <li><span class="parameter">array</span>
          an array
         </li>
-        <li><span class="parameter">f</span>
-         an iterator function prototyped as <code>f (k, v, &hellip;)</code>
-        </li>
         <li><span class="parameter">...</span>
-         Optional args to be passed to <code>f</code>
-         (<em>optional</em>)
+         a variable number of arguments
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a new table containing all values collected
+        the passed-in array with new values added
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <a href="index.html#dropWhile">dropWhile</a>
+         <li><a href="index.html#addTop">addTop</a></li>
+         <li><a href="index.html#push">push</a></li>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "dropWhile"></a>
-    <strong>dropWhile (array, f[, ...])</strong>
+    <a name = "product"></a>
+    <strong>product (array)</strong>
     </dt>
     <dd>
-    Collects values from a given array.  The passed-in array should not be sparse.
- This function collects values as long as they do not satisfy a given predicate and returns on the first truthy test.
- <br/><em>Aliased as <code>rejectWhile</code></em>
+    Returns the product of array values.
 
 
     <h3>Parameters:</h3>
     <ul>
         <li><span class="parameter">array</span>
-         an array
-        </li>
-        <li><span class="parameter">f</span>
-         an iterator function prototyped as <code>f (k,v, &hellip;)</code>
-        </li>
-        <li><span class="parameter">...</span>
-         Optional args to be passed to <code>f</code>
-         (<em>optional</em>)
+         a given array
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a new table containing all values collected
+        the product of array values
     </ol>
 
 
@@ -2044,13 +3636,12 @@
 
 </dd>
     <dt>
-    <a name = "sortedIndex"></a>
-    <strong>sortedIndex (array, the[, comp[, sort]])</strong>
+    <a name = "pull"></a>
+    <strong>pull (array, ...)</strong>
     </dt>
     <dd>
-    Returns the index at which a value should be inserted.  This index is evaluated so
- that it maintains the sort. If a comparison function is passed, it will be used to sort
- values.
+    Removes all provided values in a given array.
+ <br/><em>Aliased as <code>remove</code></em>
 
 
     <h3>Parameters:</h3>
@@ -2058,23 +3649,15 @@
         <li><span class="parameter">array</span>
          an array
         </li>
-        <li><span class="parameter">the</span>
-         value to be inserted
-        </li>
-        <li><span class="parameter">comp</span>
-         an comparison function prototyped as <code>f (a, b)</code>, defaults to <tt>&lt;</tt> operator.
-         (<em>optional</em>)
-        </li>
-        <li><span class="parameter">sort</span>
-         whether or not the passed-in array should be sorted
-         (<em>optional</em>)
+        <li><span class="parameter">...</span>
+         a variable number of values to be removed from the array
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        number the index at which the passed-in value should be inserted
+        the passed-in array with values removed
     </ol>
 
 
@@ -2082,11 +3665,11 @@
 
 </dd>
     <dt>
-    <a name = "indexOf"></a>
-    <strong>indexOf (array, value)</strong>
+    <a name = "push"></a>
+    <strong>push (array, ...)</strong>
     </dt>
     <dd>
-    Returns the index of the first occurence of value in an array.
+    Pushes all passed-in values at the end of an array.
 
 
     <h3>Parameters:</h3>
@@ -2094,63 +3677,69 @@
         <li><span class="parameter">array</span>
          an array
         </li>
-        <li><span class="parameter">value</span>
-         the value to search for
+        <li><span class="parameter">...</span>
+         a variable number of arguments
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        the index of the passed-in value
+        the passed-in array with new added values
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <a href="index.html#lastIndexOf">lastIndexOf</a>
+         <li><a href="index.html#addTop">addTop</a></li>
+         <li><a href="index.html#prepend">prepend</a></li>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "lastIndexOf"></a>
-    <strong>lastIndexOf (array, value)</strong>
+    <a name = "range"></a>
+    <strong>range ([from[, to[, step]]])</strong>
     </dt>
     <dd>
-    Returns the index of the last occurrence of value in an array.
+    Produces a flexible list of numbers.  If one value is passed, will count from 1 to that value,
+ with a default step of 1 (or -1). If two values are passed, will count from the first one to the second one,
+ using a default step of 1 (or -1). A third value passed will be considered a step value.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">array</span>
-         an array
+        <li><span class="parameter">from</span>
+         the initial value of the range
+         (<em>optional</em>)
         </li>
-        <li><span class="parameter">value</span>
-         the value to search for
+        <li><span class="parameter">to</span>
+         the final value of the range
+         (<em>optional</em>)
+        </li>
+        <li><span class="parameter">step</span>
+         the step of count. Defaults to 1 or -1.
+         (<em>optional</em>)
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        the index of the last occurrence of the passed-in value or <strong>nil</strong>
+        a new array of numbers
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <a href="index.html#indexOf">indexOf</a>
-    </ul>
 
 
 </dd>
     <dt>
-    <a name = "findIndex"></a>
-    <strong>findIndex (array, predicate[, ...])</strong>
+    <a name = "removeRange"></a>
+    <strong>removeRange (array[, start[, finish]])</strong>
     </dt>
     <dd>
-    Returns the first index at which a predicate returns true.
+    Removes values at an index within the range <code>[start, finish]</code>.
+ <br/><em>Aliased as <code>rmRange</code>, <code>chop</code></em>
 
 
     <h3>Parameters:</h3>
@@ -2158,11 +3747,12 @@
         <li><span class="parameter">array</span>
          an array
         </li>
-        <li><span class="parameter">predicate</span>
-         a predicate function prototyped as <code>predicate (k, v, &hellip;)</code>
+        <li><span class="parameter">start</span>
+         the lower bound index, defaults to the first index in the array.
+         (<em>optional</em>)
         </li>
-        <li><span class="parameter">...</span>
-         optional arguments to <code>pred</code>
+        <li><span class="parameter">finish</span>
+         the upper bound index, defaults to the array length.
          (<em>optional</em>)
         </li>
     </ul>
@@ -2170,60 +3760,48 @@
     <h3>Returns:</h3>
     <ol>
 
-        the index found or <strong>nil</strong>
+        the passed-in array with values removed
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <a href="index.html#findLastIndex">findLastIndex</a>
-    </ul>
 
 
 </dd>
     <dt>
-    <a name = "findLastIndex"></a>
-    <strong>findLastIndex (array, predicate[, ...])</strong>
+    <a name = "rep"></a>
+    <strong>rep (value, n)</strong>
     </dt>
     <dd>
-    Returns the last index at which a predicate returns true.
+    Creates an array list of <code>n</code> values, repeated.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">array</span>
-         an array
-        </li>
-        <li><span class="parameter">predicate</span>
-         a predicate function prototyped as <code>predicate (k, v, &hellip;)</code>
+        <li><span class="parameter">value</span>
+         a value to be repeated
         </li>
-        <li><span class="parameter">...</span>
-         optional arguments to <code>pred</code>
-         (<em>optional</em>)
+        <li><span class="parameter">n</span>
+         the number of repetitions of value.
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        the index found or <strong>nil</strong>
+        a new array of <code>n</code> values
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <a href="index.html#findIndex">findIndex</a>
-    </ul>
 
 
 </dd>
     <dt>
-    <a name = "addTop"></a>
-    <strong>addTop (array, ...)</strong>
+    <a name = "rest"></a>
+    <strong>rest (array[, index])</strong>
     </dt>
     <dd>
-    Adds all passed-in values at the top of an array.  The last elements will bubble to the
- top of the given array.
+    Returns all values after index.
+ <br/><em>Aliased as <code>tail</code></em>
 
 
     <h3>Parameters:</h3>
@@ -2231,31 +3809,34 @@
         <li><span class="parameter">array</span>
          an array
         </li>
-        <li><span class="parameter">...</span>
-         a variable number of arguments
+        <li><span class="parameter">index</span>
+         an index, defaults to 1
+         (<em>optional</em>)
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        the passed-in array with new values added
+        a new array
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <a href="index.html#push">push</a>
+         <li><a href="index.html#first">first</a></li>
+         <li><a href="index.html#initial">initial</a></li>
+         <li><a href="index.html#last">last</a></li>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "push"></a>
-    <strong>push (array, ...)</strong>
+    <a name = "reverse"></a>
+    <strong>reverse (array)</strong>
     </dt>
     <dd>
-    Pushes all passed-in values at the end of an array.
+    Returns an array where values are in reverse order.  The passed-in array should not be sparse.
 
 
     <h3>Parameters:</h3>
@@ -2263,32 +3844,26 @@
         <li><span class="parameter">array</span>
          an array
         </li>
-        <li><span class="parameter">...</span>
-         a variable number of arguments
-        </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        the passed-in array with new added values
+        a reversed array
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <a href="index.html#addTop">addTop</a>
-    </ul>
 
 
 </dd>
     <dt>
-    <a name = "pop"></a>
-    <strong>pop (array[, n])</strong>
+    <a name = "sample"></a>
+    <strong>sample (array[, n[, seed]])</strong>
     </dt>
     <dd>
-    Removes and returns the values at the top of a given array.
- <br/><em>Aliased as <code>shift</code></em>
+    Samples <code>n</code> random values from an array.  If <code>n</code> is not specified, returns a single element.
+ It uses internally <a href="index.html#shuffle">shuffle</a> to shuffle the array before sampling values. If <code>seed</code> is passed,
+ it will be used for shuffling.
 
 
     <h3>Parameters:</h3>
@@ -2297,7 +3872,11 @@
          an array
         </li>
         <li><span class="parameter">n</span>
-         the number of values to be popped. Defaults to 1.
+         a number of elements to be sampled. Defaults to 1.
+         (<em>optional</em>)
+        </li>
+        <li><span class="parameter">seed</span>
+         an optional seed for shuffling
          (<em>optional</em>)
         </li>
     </ul>
@@ -2305,23 +3884,25 @@
     <h3>Returns:</h3>
     <ol>
 
-        the popped values
+        an array of selected values
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <a href="index.html#unshift">unshift</a>
+         <a href="index.html#sampleProb">sampleProb</a>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "unshift"></a>
-    <strong>unshift (array[, n])</strong>
+    <a name = "sampleProb"></a>
+    <strong>sampleProb (array, prob[, seed])</strong>
     </dt>
     <dd>
-    Removes and returns the values at the end of a given array.
+    Return elements from a sequence with a given probability.  It considers each value independently.
+ Providing a seed will result in deterministic sampling. Given the same seed it will return the same sample
+ every time.
 
 
     <h3>Parameters:</h3>
@@ -2329,8 +3910,11 @@
         <li><span class="parameter">array</span>
          an array
         </li>
-        <li><span class="parameter">n</span>
-         the number of values to be unshifted. Defaults to 1.
+        <li><span class="parameter">prob</span>
+         a probability for each element in array to be selected
+        </li>
+        <li><span class="parameter">seed</span>
+         an optional seed for deterministic sampling
          (<em>optional</em>)
         </li>
     </ul>
@@ -2338,24 +3922,25 @@
     <h3>Returns:</h3>
     <ol>
 
-        the values
+        an array of selected values
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <a href="index.html#pop">pop</a>
+         <a href="index.html#sample">sample</a>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "pull"></a>
-    <strong>pull (array, ...)</strong>
+    <a name = "selectWhile"></a>
+    <strong>selectWhile (array, f[, ...])</strong>
     </dt>
     <dd>
-    Removes all provided values in a given array.
- <br/><em>Aliased as <code>remove</code></em>
+    Collects values from a given array.  The passed-in array should not be sparse.
+ This function collects values as long as they satisfy a given predicate and returns on the first falsy test.
+ <br/><em>Aliased as <code>takeWhile</code></em>
 
 
     <h3>Parameters:</h3>
@@ -2363,28 +3948,36 @@
         <li><span class="parameter">array</span>
          an array
         </li>
+        <li><span class="parameter">f</span>
+         an iterator function prototyped as <code>f (v, k, ...)</code>
+        </li>
         <li><span class="parameter">...</span>
-         a variable number of values to be removed from the array
+         Optional args to be passed to <code>f</code>
+         (<em>optional</em>)
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        the passed-in array with values removed
+        a new table containing all values collected
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <a href="index.html#dropWhile">dropWhile</a>
+    </ul>
 
 
 </dd>
     <dt>
-    <a name = "removeRange"></a>
-    <strong>removeRange (array[, start[, finish]])</strong>
+    <a name = "shift"></a>
+    <strong>shift (array[, n])</strong>
     </dt>
     <dd>
-    Removes values at index within the range <code>[start, finish]</code>.
- <br/><em>Aliased as <code>rmRange</code>, <code>chop</code></em>
+    Removes and returns the values at the top of a given array.
+ <br/><em>Aliased as <code>pop</code></em>
 
 
     <h3>Parameters:</h3>
@@ -2392,12 +3985,8 @@
         <li><span class="parameter">array</span>
          an array
         </li>
-        <li><span class="parameter">start</span>
-         the lower bound index, defaults to the first index in the array.
-         (<em>optional</em>)
-        </li>
-        <li><span class="parameter">finish</span>
-         the upper bound index, defaults to the array length.
+        <li><span class="parameter">n</span>
+         the number of values to be popped. Defaults to 1.
          (<em>optional</em>)
         </li>
     </ul>
@@ -2405,21 +3994,24 @@
     <h3>Returns:</h3>
     <ol>
 
-        the passed-in array with values removed
+        the popped values
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <a href="index.html#unshift">unshift</a>
+    </ul>
 
 
 </dd>
     <dt>
-    <a name = "chunk"></a>
-    <strong>chunk (array, f[, ...])</strong>
+    <a name = "shuffle"></a>
+    <strong>shuffle (array[, seed])</strong>
     </dt>
     <dd>
-    Chunks together consecutive values.  Values are chunked on the basis of the return
- value of a provided predicate <code>f (k, v, &hellip;)</code>. Consecutive elements which return
- the same value are chunked together. Leaves the first argument untouched if it is not an array.
+    Returns a shuffled copy of a given array.  If a seed is provided, it will
+ be used to init the built-in pseudo random number generator (using <a href="https://www.lua.org/manual/5.1/manual.html#pdf-math.randomseed">math.randomseed</a>).
 
 
     <h3>Parameters:</h3>
@@ -2427,11 +4019,8 @@
         <li><span class="parameter">array</span>
          an array
         </li>
-        <li><span class="parameter">f</span>
-         an iterator function prototyped as <code>f (k, v, &hellip;)</code>
-        </li>
-        <li><span class="parameter">...</span>
-         Optional args to be passed to <code>f</code>
+        <li><span class="parameter">seed</span>
+         a seed
          (<em>optional</em>)
         </li>
     </ul>
@@ -2439,14 +4028,10 @@
     <h3>Returns:</h3>
     <ol>
 
-        a table of chunks (arrays)
+        a shuffled copy of the given array
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <a href="index.html#zip">zip</a>
-    </ul>
 
 
 </dd>
@@ -2456,7 +4041,7 @@
     </dt>
     <dd>
     Slices values indexed within <code>[start, finish]</code> range.
- <br/><em>Aliased as <code>_.sub</code></em>
+ <br/><em>Aliased as <code>M.sub</code></em>
 
 
     <h3>Parameters:</h3>
@@ -2485,12 +4070,13 @@
 
 </dd>
     <dt>
-    <a name = "first"></a>
-    <strong>first (array[, n])</strong>
+    <a name = "sortedIndex"></a>
+    <strong>sortedIndex (array, the[, comp[, sort]])</strong>
     </dt>
     <dd>
-    Returns the first N values in an array.
- <br/><em>Aliased as <code>head</code>, <code>take</code></em>
+    Returns the index at which a value should be inserted.  This index is evaluated so
+ that it maintains the sort. If a comparison function is passed, it will be used to sort
+ values.
 
 
     <h3>Parameters:</h3>
@@ -2498,43 +4084,15 @@
         <li><span class="parameter">array</span>
          an array
         </li>
-        <li><span class="parameter">n</span>
-         the number of values to be collected, defaults to 1.
-         (<em>optional</em>)
+        <li><span class="parameter">the</span>
+         value to be inserted
         </li>
-    </ul>
-
-    <h3>Returns:</h3>
-    <ol>
-
-        a new array
-    </ol>
-
-
-    <h3>See also:</h3>
-    <ul>
-         <li><a href="index.html#initial">initial</a></li>
-         <li><a href="index.html#last">last</a></li>
-         <li><a href="index.html#rest">rest</a></li>
-    </ul>
-
-
-</dd>
-    <dt>
-    <a name = "initial"></a>
-    <strong>initial (array[, n])</strong>
-    </dt>
-    <dd>
-    Returns all values in an array excluding the last N values.
-
-
-    <h3>Parameters:</h3>
-    <ul>
-        <li><span class="parameter">array</span>
-         an array
+        <li><span class="parameter">comp</span>
+         an comparison function prototyped as <code>f (a, b)</code>, defaults to <tt>&lt;</tt> operator.
+         (<em>optional</em>)
         </li>
-        <li><span class="parameter">n</span>
-         the number of values to be left, defaults to the array length.
+        <li><span class="parameter">sort</span>
+         whether or not the passed-in array should be sorted
          (<em>optional</em>)
         </li>
     </ul>
@@ -2542,61 +4100,46 @@
     <h3>Returns:</h3>
     <ol>
 
-        a new array
+        number the index at which the passed-in value should be inserted
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <li><a href="index.html#first">first</a></li>
-         <li><a href="index.html#last">last</a></li>
-         <li><a href="index.html#rest">rest</a></li>
-    </ul>
 
 
 </dd>
     <dt>
-    <a name = "last"></a>
-    <strong>last (array[, n])</strong>
+    <a name = "sum"></a>
+    <strong>sum (array)</strong>
     </dt>
     <dd>
-    Returns the last N values in an array.
+    Returns the sum of array values.
 
 
     <h3>Parameters:</h3>
     <ul>
         <li><span class="parameter">array</span>
-         an array
-        </li>
-        <li><span class="parameter">n</span>
-         the number of values to be collected, defaults to the array length.
-         (<em>optional</em>)
+         a given array
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a new array
+        the sum of array values
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <li><a href="index.html#first">first</a></li>
-         <li><a href="index.html#initial">initial</a></li>
-         <li><a href="index.html#rest">rest</a></li>
-    </ul>
 
 
 </dd>
     <dt>
-    <a name = "rest"></a>
-    <strong>rest (array[, index])</strong>
+    <a name = "symmetricDifference"></a>
+    <strong>symmetricDifference (array, array2)</strong>
     </dt>
     <dd>
-    Removes all values before index.
- <br/><em>Aliased as <code>tail</code></em>
+    Performs a symmetric difference.  Returns values from <a href="index.html#array">array</a> not present in <code>array2</code> and also values
+ from <code>array2</code> not present in <a href="index.html#array">array</a>.
+ <br/><em>Aliased as <code>symdiff</code></em>
 
 
     <h3>Parameters:</h3>
@@ -2604,9 +4147,8 @@
         <li><span class="parameter">array</span>
          an array
         </li>
-        <li><span class="parameter">index</span>
-         an index, defaults to 1
-         (<em>optional</em>)
+        <li><span class="parameter">array2</span>
+         another array
         </li>
     </ul>
 
@@ -2619,35 +4161,32 @@
 
     <h3>See also:</h3>
     <ul>
-         <li><a href="index.html#first">first</a></li>
-         <li><a href="index.html#initial">initial</a></li>
-         <li><a href="index.html#last">last</a></li>
+         <li><a href="index.html#difference">difference</a></li>
+         <li><a href="index.html#union">union</a></li>
+         <li><a href="index.html#intersection">intersection</a></li>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "nth"></a>
-    <strong>nth (array, index)</strong>
+    <a name = "toArray"></a>
+    <strong>toArray (...)</strong>
     </dt>
     <dd>
-    Returns the value at a given index.
-
-
-    <h3>Parameters:</h3>
-    <ul>
-        <li><span class="parameter">array</span>
-         an array
-        </li>
-        <li><span class="parameter">index</span>
-         an index
+    Converts a list of arguments to an array.
+
+
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">...</span>
+         a list of arguments
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        the value at the given index
+        an array of all passed-in args
     </ol>
 
 
@@ -2655,17 +4194,17 @@
 
 </dd>
     <dt>
-    <a name = "compact"></a>
-    <strong>compact (array)</strong>
+    <a name = "union"></a>
+    <strong>union (...)</strong>
     </dt>
     <dd>
-    Removes all falsy (false and nil) values.
+    Returns the duplicate-free union of all passed in arrays.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">array</span>
-         an array
+        <li><span class="parameter">...</span>
+         a variable number of arrays arguments
         </li>
     </ul>
 
@@ -2676,15 +4215,22 @@
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <li><a href="index.html#difference">difference</a></li>
+         <li><a href="index.html#intersection">intersection</a></li>
+         <li><a href="index.html#symmetricDifference">symmetricDifference</a></li>
+    </ul>
 
 
 </dd>
     <dt>
-    <a name = "flatten"></a>
-    <strong>flatten (array[, shallow])</strong>
+    <a name = "unique"></a>
+    <strong>unique (array)</strong>
     </dt>
     <dd>
-    Flattens a nested array.  Passing <code>shallow</code> will only flatten at the first level.
+    Produces a duplicate-free version of a given array.
+ <br/><em>Aliased as <code>uniq</code></em>
 
 
     <h3>Parameters:</h3>
@@ -2692,29 +4238,28 @@
         <li><span class="parameter">array</span>
          an array
         </li>
-        <li><span class="parameter">shallow</span>
-         specifies the flattening depth
-         (<em>optional</em>)
-        </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a new array, flattened
+        a new array, duplicate-free
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <a href="index.html#isunique">isunique</a>
+    </ul>
 
 
 </dd>
     <dt>
-    <a name = "difference"></a>
-    <strong>difference (array, another)</strong>
+    <a name = "unshift"></a>
+    <strong>unshift (array[, n])</strong>
     </dt>
     <dd>
-    Returns values from an array not present in all passed-in args.
- <br/><em>Aliased as <code>without</code> and <code>diff</code></em>
+    Removes and returns the values at the end of a given array.
 
 
     <h3>Parameters:</h3>
@@ -2722,239 +4267,242 @@
         <li><span class="parameter">array</span>
          an array
         </li>
-        <li><span class="parameter">another</span>
-         array
+        <li><span class="parameter">n</span>
+         the number of values to be unshifted. Defaults to 1.
+         (<em>optional</em>)
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a new array
+        the values
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <li><a href="index.html#union">union</a></li>
-         <li><a href="index.html#intersection">intersection</a></li>
-         <li><a href="index.html#symmetricDifference">symmetricDifference</a></li>
+         <a href="index.html#shift">shift</a>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "union"></a>
-    <strong>union (...)</strong>
+    <a name = "vector"></a>
+    <strong>vector (value, n)</strong>
     </dt>
     <dd>
-    Returns the duplicate-free union of all passed in arrays.
+    Returns an array of <code>n</code> times a given value.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">...</span>
-         a variable number of arrays arguments
+        <li><span class="parameter">value</span>
+         a value
+        </li>
+        <li><span class="parameter">n</span>
+         a number
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a new array
+        an array
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <li><a href="index.html#difference">difference</a></li>
-         <li><a href="index.html#intersection">intersection</a></li>
-         <li><a href="index.html#symmetricDifference">symmetricDifference</a></li>
+         <li><a href="index.html#zeros">zeros</a></li>
+         <li><a href="index.html#ones">ones</a></li>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "intersection"></a>
-    <strong>intersection (array, ...)</strong>
+    <a name = "xprod"></a>
+    <strong>xprod (array, array2)</strong>
     </dt>
     <dd>
-    Returns the  intersection of all passed-in arrays.
- Each value in the result is present in each of the passed-in arrays.
+    Returns all possible pairs built from given arrays.
 
 
     <h3>Parameters:</h3>
     <ul>
         <li><span class="parameter">array</span>
-         an array
+         a first array
         </li>
-        <li><span class="parameter">...</span>
-         a variable number of array arguments
+        <li><span class="parameter">array2</span>
+         a second array
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a new array
+        an array list of all pairs
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <li><a href="index.html#difference">difference</a></li>
-         <li><a href="index.html#union">union</a></li>
-         <li><a href="index.html#symmetricDifference">symmetricDifference</a></li>
-    </ul>
 
 
 </dd>
     <dt>
-    <a name = "symmetricDifference"></a>
-    <strong>symmetricDifference (array, array2)</strong>
+    <a name = "zeros"></a>
+    <strong>zeros (n)</strong>
     </dt>
     <dd>
-    Performs a symmetric difference.  Returns values from <a href="index.html#array">array</a> not present in <code>array2</code> and also values
- from <code>array2</code> not present in <a href="index.html#array">array</a>.
- <br/><em>Aliased as <code>symdiff</code></em>
+    Returns an array of <code>n</code> zeros.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">array</span>
-         an array
-        </li>
-        <li><span class="parameter">array2</span>
-         another array
+        <li><span class="parameter">n</span>
+         a number
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a new array
+        an array
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <li><a href="index.html#difference">difference</a></li>
-         <li><a href="index.html#union">union</a></li>
-         <li><a href="index.html#intersection">intersection</a></li>
+         <li><a href="index.html#ones">ones</a></li>
+         <li><a href="index.html#vector">vector</a></li>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "unique"></a>
-    <strong>unique (array)</strong>
+    <a name = "zip"></a>
+    <strong>zip (...)</strong>
     </dt>
     <dd>
-    Produces a duplicate-free version of a given array.
- <br/><em>Aliased as <code>uniq</code></em>
+    Merges values of each of the passed-in arrays in subsets.
+ Only values indexed with the same key in the given arrays are merged in the same subset.
+ <br/><em>Aliased as <code>transpose</code></em>
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">array</span>
-         an array
+        <li><span class="parameter">...</span>
+         a variable number of array arguments
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a new array, duplicate-free
+        a new array
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <a href="index.html#isunique">isunique</a>
+         <a href="index.html#zipWith">zipWith</a>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "isunique"></a>
-    <strong>isunique (array)</strong>
+    <a name = "zipWith"></a>
+    <strong>zipWith (f, ...)</strong>
     </dt>
     <dd>
-    Checks if a given array contains distinct values.  Such an array is made of distinct elements,
- which only occur once in this array.
- <br/><em>Aliased as <code>isuniq</code></em>
+    Merges values using a given function.
+ Only values indexed with the same key in the given arrays are merged in the same subset.
+ Function <code>f</code> is used to combine values.
+ <br/><em>Aliased as <code>transposeWith</code></em>
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">array</span>
-         an array
+        <li><span class="parameter">f</span>
+         a function
+        </li>
+        <li><span class="parameter">...</span>
+         a variable number of array arguments
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        <code>true</code> if the given array is unique, <code>false</code> otherwise.
+        a flat array of results
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <a href="index.html#unique">unique</a>
+         <a href="index.html#zip">zip</a>
     </ul>
 
 
 </dd>
+</dl>
+    <h2 class="section-header "><a name="Utility_functions"></a>Utility functions </h2>
+
+    <dl class="function">
     <dt>
-    <a name = "zip"></a>
-    <strong>zip (...)</strong>
+    <a name = "after"></a>
+    <strong>after (f, count)</strong>
     </dt>
     <dd>
-    Merges values of each of the passed-in arrays in subsets.
- Only values indexed with the same key in the given arrays are merged in the same subset.
- <br/><em>Aliased as <code>transpose</code></em>
+    Returns a version of <code>f</code> that runs on the <code>count-th</code> call.
+ Useful when dealing with asynchronous tasks.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">...</span>
-         a variable number of array arguments
+        <li><span class="parameter">f</span>
+         a function
+        </li>
+        <li><span class="parameter">count</span>
+         the number of calls before <code>f</code> will start running.
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a new array
+        a new function
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <li><a href="index.html#once">once</a></li>
+         <li><a href="index.html#before">before</a></li>
+    </ul>
 
 
 </dd>
     <dt>
-    <a name = "append"></a>
-    <strong>append (array, other)</strong>
+    <a name = "applySpec"></a>
+    <strong>applySpec (specs)</strong>
     </dt>
     <dd>
-    Clones <a href="index.html#array">array</a> and appends <code>other</code> values.
+    Returns a function which applies <code>specs</code> on args.  This function produces an object having
+ the same structure than <code>specs</code> by mapping each property to the result of calling its
+ associated function with the supplied arguments
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">array</span>
-         an array
-        </li>
-        <li><span class="parameter">other</span>
-         an array
+        <li><span class="parameter">specs</span>
+         a table
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a new array
+        a function
     </ol>
 
 
@@ -2962,248 +4510,256 @@
 
 </dd>
     <dt>
-    <a name = "interleave"></a>
-    <strong>interleave (...)</strong>
+    <a name = "array"></a>
+    <strong>array (...)</strong>
     </dt>
     <dd>
-    Interleaves arrays.  It returns a single array made of values from all
- passed in arrays in their given order, interleaved.
+    Iterates over an iterator and returns its values in an array.
+ <br/><em>Aliased as <code>tabulate</code></em>.
 
 
     <h3>Parameters:</h3>
     <ul>
         <li><span class="parameter">...</span>
-         a variable list of arrays
+         an iterator function (returning a generator, a state and a value)
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a new array
+        an array of results
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <a href="index.html#interpose">interpose</a>
-    </ul>
 
 
 </dd>
     <dt>
-    <a name = "interpose"></a>
-    <strong>interpose (value, array)</strong>
+    <a name = "ary"></a>
+    <strong>ary (f[, n])</strong>
     </dt>
     <dd>
-    Interposes value in-between consecutive pair of values in <a href="index.html#array">array</a>.
+    Returns a function which accepts up to <code>n</code> args.  It ignores any additional arguments.
+ <br/><em>Aliased as <code>nAry</code></em>.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">value</span>
-         a value
+        <li><span class="parameter">f</span>
+         a function
         </li>
-        <li><span class="parameter">array</span>
-         an array
+        <li><span class="parameter">n</span>
+         a number. Defaults to 1.
+         (<em>optional</em>)
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a new array
+        a function
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <a href="index.html#interleave">interleave</a>
+         <a href="index.html#unary">unary</a>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "range"></a>
-    <strong>range ([from[, to[, step]]])</strong>
+    <a name = "before"></a>
+    <strong>before (f, count)</strong>
     </dt>
     <dd>
-    Produces a flexible list of numbers.  If one positive value is passed, will count from 0 to that value,
- with a default step of 1. If two values are passed, will count from the first one to the second one, with the
- same default step of 1. A third value passed will be considered a step value.
+    Returns a version of <code>f</code> that will run no more than <em>count</em> times.  Next calls will
+ keep yielding the results of the count-th call.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">from</span>
-         the initial value of the range
-         (<em>optional</em>)
-        </li>
-        <li><span class="parameter">to</span>
-         the final value of the range
-         (<em>optional</em>)
+        <li><span class="parameter">f</span>
+         a function
         </li>
-        <li><span class="parameter">step</span>
-         the step of count
-         (<em>optional</em>)
+        <li><span class="parameter">count</span>
+         a count
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a new array of numbers
+        a new function
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <li><a href="index.html#once">once</a></li>
+         <li><a href="index.html#after">after</a></li>
+    </ul>
 
 
 </dd>
     <dt>
-    <a name = "rep"></a>
-    <strong>rep (value, n)</strong>
+    <a name = "bind"></a>
+    <strong>bind (f, v)</strong>
     </dt>
     <dd>
-    Creates an array list of <code>n</code> values, repeated.
+    Binds <code>v</code> to be the first argument to <code>f</code>.  Calling <code>f (...)</code> will result to <code>f (v, ...)</code>.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">value</span>
-         a value to be repeated
+        <li><span class="parameter">f</span>
+         a function
         </li>
-        <li><span class="parameter">n</span>
-         the number of repetitions of value.
+        <li><span class="parameter">v</span>
+         a value
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a new array of <code>n</code> values
+        a function
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <li><a href="index.html#bind2">bind2</a></li>
+         <li><a href="index.html#bindn">bindn</a></li>
+         <li><a href="index.html#bindall">bindall</a></li>
+    </ul>
 
 
 </dd>
     <dt>
-    <a name = "partition"></a>
-    <strong>partition (array[, n[, pad]])</strong>
+    <a name = "bind2"></a>
+    <strong>bind2 (f, v)</strong>
     </dt>
     <dd>
-    Iterator returning partitions of an array.  It returns arrays of length <code>n</code>
- made of values from the given array. If the last partition has lower elements than <code>n</code> and
- <code>pad</code> is supplied, it will be adjusted to <code>n</code> of elements with <code>pad</code> value.
+    Binds <code>v</code> to be the second argument to <code>f</code>.  Calling <code>f (a, ...)</code> will result to <code>f (a, v, ...)</code>.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">array</span>
-         an array
-        </li>
-        <li><span class="parameter">n</span>
-         the size of partitions. Should be greater than 0. Defaults to 1.
-         (<em>optional</em>)
+        <li><span class="parameter">f</span>
+         a function
         </li>
-        <li><span class="parameter">pad</span>
-         a value to adjust the last subsequence to the <code>n</code> elements
-         (<em>optional</em>)
+        <li><span class="parameter">v</span>
+         a value
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        an iterator function
+        a function
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <li><a href="index.html#bind">bind</a></li>
+         <li><a href="index.html#bindn">bindn</a></li>
+         <li><a href="index.html#bindall">bindall</a></li>
+    </ul>
 
 
 </dd>
     <dt>
-    <a name = "sliding."></a>
-    <strong>sliding. (array[, n[, pad]])</strong>
+    <a name = "bindall"></a>
+    <strong>bindall (obj, ...)</strong>
     </dt>
     <dd>
-    Iterator returning sliding partitions of an array.  It returns overlapping subsequences
- of length <code>n</code>. If the last subsequence has lower elements than <code>n</code> and <code>pad</code> is
- supplied, it will be adjusted to <code>n</code> elements with <code>pad</code> value.
+    Binds methods to object.  As such, whenever any of these methods is invoked, it
+ always receives the object as its first argument.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">array</span>
-         an array
-        </li>
-        <li><span class="parameter">n</span>
-         the size of partitions. Should be greater than 1. Defaults to 2.
-         (<em>optional</em>)
+        <li><span class="parameter">obj</span>
+         an abject
         </li>
-        <li><span class="parameter">pad</span>
-         a value to adjust the last subsequence to the <code>n</code> elements
-         (<em>optional</em>)
+        <li><span class="parameter">...</span>
+         a variable number of method names
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        an iterator function
+        the passed-in object with all methods bound to the object itself.
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <li><a href="index.html#bind">bind</a></li>
+         <li><a href="index.html#bind2">bind2</a></li>
+         <li><a href="index.html#bindn">bindn</a></li>
+    </ul>
 
 
 </dd>
     <dt>
-    <a name = "permutation"></a>
-    <strong>permutation (array)</strong>
+    <a name = "bindn"></a>
+    <strong>bindn (f, ...)</strong>
     </dt>
     <dd>
-    Iterator returning the permutations of an array.  It returns arrays made of all values
- from the passed-in array, with values permuted.
+    Binds <code>...</code> to be the N-first arguments to function <code>f</code>. <br/>
+ Calling <code>f (a1, a2, ..., aN)</code> will result to <code>f (..., a1, a2, ...,aN)</code>.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">array</span>
-         an array
+        <li><span class="parameter">f</span>
+         a function
+        </li>
+        <li><span class="parameter">...</span>
+         a variable number of arguments
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        an iterator function
+        a function
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <li><a href="index.html#bind">bind</a></li>
+         <li><a href="index.html#bind2">bind2</a></li>
+         <li><a href="index.html#bindall">bindall</a></li>
+    </ul>
 
 
 </dd>
     <dt>
-    <a name = "invert"></a>
-    <strong>invert (array)</strong>
+    <a name = "castArray"></a>
+    <strong>castArray (value)</strong>
     </dt>
     <dd>
-    Swaps keys with values.  Produces a new array where previous keys are now values,
- while previous values are now keys.
- <br/><em>Aliased as <code>mirror</code></em>
+    Casts vaue as an array if it is not one.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">array</span>
-         a given array
+        <li><span class="parameter">value</span>
+         a value
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a new array
+        an array containing the given value
     </ol>
 
 
@@ -3211,88 +4767,83 @@
 
 </dd>
     <dt>
-    <a name = "concat"></a>
-    <strong>concat (array[, sep[, i[, j]]])</strong>
+    <a name = "complement"></a>
+    <strong>complement (f)</strong>
     </dt>
     <dd>
-    Concatenates values in a given array.  Handles booleans as well. If <code>sep</code> string is
- passed, it will be used as a separator. Passing <code>i</code> and <code>j</code> will result in concatenating
- only values within <code>[i, j]</code> range.
- <br/><em>Aliased as <code>join</code></em>
+    Returns the logical complement of a given function.  For a given input, the returned
+ function will output <code>false</code> if the original function would have returned <code>true</code>,
+ and vice-versa.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">array</span>
-         a given array
-        </li>
-        <li><span class="parameter">sep</span>
-         a separator string, defaults to the empty string <code>&apos;&apos;</code>.
-         (<em>optional</em>)
-        </li>
-        <li><span class="parameter">i</span>
-         the starting index, defaults to 1.
-         (<em>optional</em>)
-        </li>
-        <li><span class="parameter">j</span>
-         the final index, defaults to the array length.
-         (<em>optional</em>)
+        <li><span class="parameter">f</span>
+         a function
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a string
+        the logical complement of the given function <code>f</code>.
     </ol>
 
 
 
 
 </dd>
-</dl>
-    <h2 class="section-header "><a name="Utility_functions"></a>Utility functions </h2>
-
-    <dl class="function">
     <dt>
-    <a name = "noop"></a>
-    <strong>noop ()</strong>
+    <a name = "compose"></a>
+    <strong>compose (...)</strong>
     </dt>
     <dd>
-    The no-operation function.
+    Composes functions.  Each passed-in function consumes the return value of the function that follows.
+ In math terms, composing the functions <code>f</code>, <code>g</code>, and <code>h</code> produces the function <code>f(g(h(...)))</code>.
 
 
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">...</span>
+         a variable number of functions
+        </li>
+    </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        nothing
+        a new function
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <a href="index.html#pipe">pipe</a>
+    </ul>
 
 
 </dd>
     <dt>
-    <a name = "identity"></a>
-    <strong>identity (value)</strong>
+    <a name = "cond"></a>
+    <strong>cond (conds)</strong>
     </dt>
     <dd>
-    Returns the passed-in value.  This function is used internally
- as a default iterator.
+    Returns a function which iterate over a set of conditions.  It invokes each predicate,
+ passing it given values. It returns the value of the corresponding function of the first
+ predicate to return a non-nil value.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">value</span>
-         a value
+        <li><span class="parameter">conds</span>
+         an array list of predicate-function pairs
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        the passed-in value
+        the result of invoking <code>f(...)</code> of the first predicate to return a non-nil value
     </ol>
 
 
@@ -3305,6 +4856,7 @@
     </dt>
     <dd>
     Creates a constant function which returns the same output on every call.
+ <br/><em>Aliased as <code>always</code></em>
 
 
     <h3>Parameters:</h3>
@@ -3325,14 +4877,11 @@
 
 </dd>
     <dt>
-    <a name = "memoize"></a>
-    <strong>memoize (f[, hash])</strong>
+    <a name = "converge"></a>
+    <strong>converge (f, g, h)</strong>
     </dt>
     <dd>
-    Memoizes a given function by caching the computed result.
- Useful for speeding-up slow-running functions. If a <code>hash</code> function is passed,
- it will be used to compute hash keys for a set of input values for caching.
- <br/><em>Aliased as <code>cache</code></em>
+    Converges two functions into one.
 
 
     <h3>Parameters:</h3>
@@ -3340,16 +4889,18 @@
         <li><span class="parameter">f</span>
          a function
         </li>
-        <li><span class="parameter">hash</span>
-         a hash function, defaults to <a href="index.html#identity">identity</a>
-         (<em>optional</em>)
+        <li><span class="parameter">g</span>
+         a function
+        </li>
+        <li><span class="parameter">h</span>
+         a function
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a new function
+        a new version of function f
     </ol>
 
 
@@ -3357,13 +4908,13 @@
 
 </dd>
     <dt>
-    <a name = "once"></a>
-    <strong>once (f)</strong>
+    <a name = "curry"></a>
+    <strong>curry (f[, n_args])</strong>
     </dt>
     <dd>
-    Returns a version of <code>f</code> that runs only once.  Successive calls to <code>f</code>
- will keep yielding the same output, no matter what the passed-in arguments are.
- It can be used to initialize variables.
+    Curries a function.  If the given function <code>f</code> takes multiple arguments, it returns another version of
+ <code>f</code> that takes a single argument (the first of the arguments to the original function) and returns a new
+ function that takes the remainder of the arguments and returns the result.
 
 
     <h3>Parameters:</h3>
@@ -3371,30 +4922,33 @@
         <li><span class="parameter">f</span>
          a function
         </li>
+        <li><span class="parameter">n_args</span>
+         the number of arguments expected for <code>f</code>. Defaults to 2.
+         (<em>optional</em>)
+        </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a new function
+        a curried version of <code>f</code>
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <li><a href="index.html#before">before</a></li>
-         <li><a href="index.html#after">after</a></li>
+         <li><a href="index.html#partial">partial</a></li>
+         <li><a href="index.html#partialRight">partialRight</a></li>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "before"></a>
-    <strong>before (f, count)</strong>
+    <a name = "flip"></a>
+    <strong>flip (f)</strong>
     </dt>
     <dd>
-    Returns a version of <code>f</code> that will run no more than <a href="index.html#count">count</a> times.  Next calls will
- keep yielding the results of the count-th call.
+    Creates a function of <code>f</code> with arguments flipped in reverse order.
 
 
     <h3>Parameters:</h3>
@@ -3402,97 +4956,86 @@
         <li><span class="parameter">f</span>
          a function
         </li>
-        <li><span class="parameter">count</span>
-         a count
-        </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a new function
+        a function
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <li><a href="index.html#once">once</a></li>
-         <li><a href="index.html#after">after</a></li>
-    </ul>
 
 
 </dd>
     <dt>
-    <a name = "after"></a>
-    <strong>after (f, count)</strong>
+    <a name = "identity"></a>
+    <strong>identity (value)</strong>
     </dt>
     <dd>
-    Returns a version of <code>f</code> that runs on the <code>count-th</code> call.
- Useful when dealing with asynchronous tasks.
+    Returns the passed-in value.  This function is used internally
+ as a default iterator.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">f</span>
-         a function
-        </li>
-        <li><span class="parameter">count</span>
-         the number of calls before <code>f</code> will start running.
+        <li><span class="parameter">value</span>
+         a value
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a new function
+        the passed-in value
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <li><a href="index.html#once">once</a></li>
-         <li><a href="index.html#before">before</a></li>
-    </ul>
 
 
 </dd>
     <dt>
-    <a name = "compose"></a>
-    <strong>compose (...)</strong>
+    <a name = "iterator"></a>
+    <strong>iterator (f, value[, n])</strong>
     </dt>
     <dd>
-    Composes functions.  Each passed-in function consumes the return value of the function that follows.
- In math terms, composing the functions <code>f</code>, <code>g</code>, and <code>h</code> produces the function <code>f(g(h(&hellip;)))</code>.
+    Produces an iterator which repeatedly apply a function <code>f</code> onto an input. <br/>
+ Yields <a href="index.html#obj:value">value</a>, then <code>f(value)</code>, then <code>f(f(value))</code>, continuously.
+ <br/><em>Aliased as <code>iter</code></em>.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">...</span>
-         a variable number of functions
+        <li><span class="parameter">f</span>
+         a function
+        </li>
+        <li><span class="parameter">value</span>
+         an initial input to <code>f</code>
+        </li>
+        <li><span class="parameter">n</span>
+         the number of times the iterator should run
+         (<em>optional</em>)
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a new function
+        an iterator function
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <a href="index.html#pipe">pipe</a>
-    </ul>
 
 
 </dd>
     <dt>
-    <a name = "pipe"></a>
-    <strong>pipe (value, ...)</strong>
+    <a name = "juxtapose"></a>
+    <strong>juxtapose (value, ...)</strong>
     </dt>
     <dd>
-    Pipes a value through a series of functions.  In math terms,
- given some functions <code>f</code>, <code>g</code>, and <code>h</code> in that order, it returns <code>f(g(h(value)))</code>.
+    Calls a sequence of passed-in functions with the same argument.
+ Returns a sequence of results.
+ <br/><em>Aliased as <code>juxt</code></em>
 
 
     <h3>Parameters:</h3>
@@ -3508,25 +5051,21 @@
     <h3>Returns:</h3>
     <ol>
 
-        the result of the composition of function calls.
+        a list of results
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <a href="index.html#compose">compose</a>
-    </ul>
 
 
 </dd>
     <dt>
-    <a name = "complement"></a>
-    <strong>complement (f)</strong>
+    <a name = "memoize"></a>
+    <strong>memoize (f)</strong>
     </dt>
     <dd>
-    Returns the logical complement of a given function.  For a given input, the returned
- function will output <code>false</code> if the original function would have returned <code>true</code>,
- and vice-versa.
+    Memoizes a given function by caching the computed result.
+ Useful for speeding-up slow-running functions.
+ <br/><em>Aliased as <code>cache</code></em>
 
 
     <h3>Parameters:</h3>
@@ -3539,37 +5078,7 @@
     <h3>Returns:</h3>
     <ol>
 
-        the logical complement of the given function <code>f</code>.
-    </ol>
-
-
-
-
-</dd>
-    <dt>
-    <a name = "juxtapose"></a>
-    <strong>juxtapose (value, ...)</strong>
-    </dt>
-    <dd>
-    Calls a sequence of passed-in functions with the same argument.
- Returns a sequence of results.
- <br/><em>Aliased as <code>juxt</code></em>
-
-
-    <h3>Parameters:</h3>
-    <ul>
-        <li><span class="parameter">value</span>
-         a value
-        </li>
-        <li><span class="parameter">...</span>
-         a variable number of functions
-        </li>
-    </ul>
-
-    <h3>Returns:</h3>
-    <ol>
-
-        a list of results
+        a new function
     </ol>
 
 
@@ -3577,29 +5086,18 @@
 
 </dd>
     <dt>
-    <a name = "wrap"></a>
-    <strong>wrap (f, wrapper)</strong>
+    <a name = "noop"></a>
+    <strong>noop ()</strong>
     </dt>
     <dd>
-    Wraps <code>f</code> inside of the <code>wrapper</code> function.  It passes <code>f</code> as the first argument to <code>wrapper</code>.
- This allows the wrapper to execute code before and after <code>f</code> runs,
- adjust the arguments, and execute it conditionally.
+    The no operation function.
 
 
-    <h3>Parameters:</h3>
-    <ul>
-        <li><span class="parameter">f</span>
-         a function to be wrapped, prototyped as <code>f (&hellip;)</code>
-        </li>
-        <li><span class="parameter">wrapper</span>
-         a wrapper function, prototyped as <code>wrapper (f, &hellip;)</code>
-        </li>
-    </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        the results
+        nothing
     </ol>
 
 
@@ -3607,30 +5105,25 @@
 
 </dd>
     <dt>
-    <a name = "times"></a>
-    <strong>times (n, iter, ...)</strong>
+    <a name = "nthArg"></a>
+    <strong>nthArg (n)</strong>
     </dt>
     <dd>
-    Runs <code>iter</code> function <code>n</code> times.  Collects the results of each run and returns them in an array.
+    Returns a function that gets the nth argument. <br/>
+ If n is negative, the nth argument from the end is returned.
 
 
     <h3>Parameters:</h3>
     <ul>
         <li><span class="parameter">n</span>
-         the number of times <code>iter</code> should be called
-        </li>
-        <li><span class="parameter">iter</span>
-         an iterator function, prototyped as <code>iter (i, &hellip;)</code>
-        </li>
-        <li><span class="parameter">...</span>
-         args to be passed to <code>iter</code> function
+         a number
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        table an array of results
+        a function
     </ol>
 
 
@@ -3638,11 +5131,13 @@
 
 </dd>
     <dt>
-    <a name = "bind"></a>
-    <strong>bind (f, v)</strong>
+    <a name = "once"></a>
+    <strong>once (f)</strong>
     </dt>
     <dd>
-    Binds <code>v</code> to be the first argument to <code>f</code>.  Calling <code>f (&hellip;)</code> will result to <code>f (v, &hellip;)</code>.
+    Returns a version of <code>f</code> that runs only once.  Successive calls to <code>f</code>
+ will keep yielding the same output, no matter what the passed-in arguments are.
+ It can be used to initialize variables.
 
 
     <h3>Parameters:</h3>
@@ -3650,42 +5145,35 @@
         <li><span class="parameter">f</span>
          a function
         </li>
-        <li><span class="parameter">v</span>
-         a value
-        </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a function
+        a new function
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <li><a href="index.html#bind2">bind2</a></li>
-         <li><a href="index.html#bindn">bindn</a></li>
-         <li><a href="index.html#bindAll">bindAll</a></li>
+         <li><a href="index.html#before">before</a></li>
+         <li><a href="index.html#after">after</a></li>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "bind2"></a>
-    <strong>bind2 (f, v)</strong>
+    <a name = "over"></a>
+    <strong>over (...)</strong>
     </dt>
     <dd>
-    Binds <code>v</code> to be the second argument to <code>f</code>.  Calling <code>f (a, &hellip;)</code> will result to <code>f (a, v, &hellip;)</code>.
+    Creates a function that runs transforms on all arguments it receives.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">f</span>
-         a function
-        </li>
-        <li><span class="parameter">v</span>
-         a value
+        <li><span class="parameter">...</span>
+         a set of functions which will receive all arguments to the returned function
         </li>
     </ul>
 
@@ -3698,20 +5186,20 @@
 
     <h3>See also:</h3>
     <ul>
-         <li><a href="index.html#bind">bind</a></li>
-         <li><a href="index.html#bindn">bindn</a></li>
-         <li><a href="index.html#bindAll">bindAll</a></li>
+         <li><a href="index.html#overEvery">overEvery</a></li>
+         <li><a href="index.html#overSome">overSome</a></li>
+         <li><a href="index.html#overArgs">overArgs</a></li>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "bindn"></a>
-    <strong>bindn (f, ...)</strong>
+    <a name = "overArgs"></a>
+    <strong>overArgs (f, ...)</strong>
     </dt>
     <dd>
-    Binds <code>&hellip;</code> to be the N-first arguments to function <code>f</code>.<br/>
- Calling <code>f (a1, a2, &hellip;, aN)</code> will result to <code>f (&hellip;, a1, a2, &hellip;,aN)</code>.
+    Creates a function that invokes <code>f</code> with its arguments transformed.  1rst arguments will be passed to
+ the 1rst transform, 2nd arg to the 2nd transform, etc. Remaining arguments will not be transformed.
 
 
     <h3>Parameters:</h3>
@@ -3720,101 +5208,98 @@
          a function
         </li>
         <li><span class="parameter">...</span>
-         a variable number of arguments
+         a list of transforms funcs prototyped as <code>f (v)</code>
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a function
+        the result of running <code>f</code> with its transformed arguments
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <li><a href="index.html#bind">bind</a></li>
-         <li><a href="index.html#bind2">bind2</a></li>
-         <li><a href="index.html#bindAll">bindAll</a></li>
+         <li><a href="index.html#over">over</a></li>
+         <li><a href="index.html#overEvery">overEvery</a></li>
+         <li><a href="index.html#overSome">overSome</a></li>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "bindAll"></a>
-    <strong>bindAll (obj, ...)</strong>
+    <a name = "overEvery"></a>
+    <strong>overEvery (...)</strong>
     </dt>
     <dd>
-    Binds methods to object.  As such, whenever any of these methods is invoked, it
- always receives the object as its first argument.
+    Creates a validation function.  The returned function checks if <em>all</em> of the given predicates return
+ truthy when invoked with the arguments it receives.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">obj</span>
-         an abject
-        </li>
         <li><span class="parameter">...</span>
-         a variable number of method names
+         a list of predicate functions
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        the passed-in object with all methods bound to the object itself.
+        a new function
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <li><a href="index.html#bind">bind</a></li>
-         <li><a href="index.html#bind2">bind2</a></li>
-         <li><a href="index.html#bindn">bindn</a></li>
+         <li><a href="index.html#over">over</a></li>
+         <li><a href="index.html#overSome">overSome</a></li>
+         <li><a href="index.html#overArgs">overArgs</a></li>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "uniqueId"></a>
-    <strong>uniqueId ([template[, ...]])</strong>
+    <a name = "overSome"></a>
+    <strong>overSome (...)</strong>
     </dt>
     <dd>
-    Generates an unique ID for the current session.  If given a string <a href="index.html#template">template</a>, it
- will use this template for output formatting. Otherwise, if <a href="index.html#template">template</a> is a function, it
- will evaluate <code>template (id, &hellip;)</code>.
- <br/><em>Aliased as <code>uid</code></em>.
+    Creates a validation function.  The return function checks if <em>any</em> of a given predicates return
+ truthy when invoked with the arguments it receives.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">template</span>
-         either a string or a function template to format the ID
-         (<em>optional</em>)
-        </li>
         <li><span class="parameter">...</span>
-         a variable number of arguments to be passed to <a href="index.html#template">template</a>, in case it is a function.
-         (<em>optional</em>)
+         a list of predicate functions
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        value an ID
+        a new function
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <li><a href="index.html#over">over</a></li>
+         <li><a href="index.html#overEvery">overEvery</a></li>
+         <li><a href="index.html#overArgs">overArgs</a></li>
+    </ul>
 
 
 </dd>
     <dt>
-    <a name = "iterator"></a>
-    <strong>iterator (f, x)</strong>
+    <a name = "partial"></a>
+    <strong>partial (f, ...)</strong>
     </dt>
     <dd>
-    Produces an iterator which repeatedly apply a function <code>f</code> onto an input.<br/>
- Yields x, then f(x), then f(f(x)), continuously.
+    Partially apply a function by filling in any number of its arguments. <br/>
+ One may pass a string <code>&apos;M&apos;</code> as a placeholder in the list of arguments to specify an argument
+ that should not be pre-filled, but left open to be supplied at call-time.
 
 
     <h3>Parameters:</h3>
@@ -3822,84 +5307,108 @@
         <li><span class="parameter">f</span>
          a function
         </li>
-        <li><span class="parameter">x</span>
-         an initial input to <code>f</code>
+        <li><span class="parameter">...</span>
+         a list of partial arguments to <code>f</code>
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        an iterator fnction
- <br/><em>Aliased as <code>iter</code></em>.
+        a new version of function f having some of it original arguments filled
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <li><a href="index.html#partialRight">partialRight</a></li>
+         <li><a href="index.html#curry">curry</a></li>
+    </ul>
 
 
 </dd>
     <dt>
-    <a name = "array"></a>
-    <strong>array (...)</strong>
+    <a name = "partialRight"></a>
+    <strong>partialRight (f, ...)</strong>
     </dt>
     <dd>
-    Iterates an iterator and returns its values in an array.
+    Similar to <a href="index.html#partial">partial</a>, but from the right.
 
 
     <h3>Parameters:</h3>
     <ul>
+        <li><span class="parameter">f</span>
+         a function
+        </li>
         <li><span class="parameter">...</span>
-         an iterator (a function, a table and a value)
+         a list of partial arguments to <code>f</code>
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        an array of results
+        a new version of function f having some of it original arguments filled
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <li><a href="index.html#partialRight">partialRight</a></li>
+         <li><a href="index.html#curry">curry</a></li>
+    </ul>
 
 
 </dd>
     <dt>
-    <a name = "flip"></a>
-    <strong>flip (f)</strong>
+    <a name = "pipe"></a>
+    <strong>pipe (value, ...)</strong>
     </dt>
     <dd>
-    Creates a function of <code>f</code> with arguments flipped in reverse order.
+    Pipes a value through a series of functions.  In math terms,
+ given some functions <code>f</code>, <code>g</code>, and <code>h</code> in that order, it returns <code>f(g(h(value)))</code>.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">f</span>
-         a function
+        <li><span class="parameter">value</span>
+         a value
+        </li>
+        <li><span class="parameter">...</span>
+         a variable number of functions
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a function
+        the result of the composition of function calls.
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <a href="index.html#compose">compose</a>
+    </ul>
 
 
 </dd>
     <dt>
-    <a name = "over"></a>
-    <strong>over (...)</strong>
+    <a name = "rearg"></a>
+    <strong>rearg (f, indexes)</strong>
     </dt>
     <dd>
-    Creates a function that runs transforms on all arguments it receives.
+    Returns a function which runs with arguments rearranged.  Arguments are passed to the
+ returned function in the order of supplied <code>indexes</code> at call-time.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">...</span>
-         a set of functions which will receive all arguments to the returned function
+        <li><span class="parameter">f</span>
+         a function
+        </li>
+        <li><span class="parameter">indexes</span>
+         an array list of indexes
         </li>
     </ul>
 
@@ -3910,86 +5419,77 @@
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <li><a href="index.html#overEvery">overEvery</a></li>
-         <li><a href="index.html#overSome">overSome</a></li>
-         <li><a href="index.html#overArgs">overArgs</a></li>
-    </ul>
 
 
 </dd>
     <dt>
-    <a name = "overEvery"></a>
-    <strong>overEvery (...)</strong>
+    <a name = "time"></a>
+    <strong>time (f[, ...])</strong>
     </dt>
     <dd>
-    Creates a validation function.  The returned function checks if <em>all</em> of the given predicates return
- truthy when invoked with the arguments it receives.
+    Returns the execution time of <code>f (...)</code> and its returned values.
 
 
     <h3>Parameters:</h3>
     <ul>
+        <li><span class="parameter">f</span>
+         a function
+        </li>
         <li><span class="parameter">...</span>
-         a list of predicate functions
+         optional args to <code>f</code>
+         (<em>optional</em>)
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a new function
+        the execution time and the results of <code>f (...)</code>
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <li><a href="index.html#over">over</a></li>
-         <li><a href="index.html#overSome">overSome</a></li>
-         <li><a href="index.html#overArgs">overArgs</a></li>
-    </ul>
 
 
 </dd>
     <dt>
-    <a name = "overSome"></a>
-    <strong>overSome (...)</strong>
+    <a name = "times"></a>
+    <strong>times (iter[, n[, ...]])</strong>
     </dt>
     <dd>
-    Creates a validation function.  The return function checks if <em>any</em> of a given predicates return
- truthy when invoked with the arguments it receives.
+    Runs <code>iter</code> function <code>n</code> times.  Collects the results of each run and returns them in an array.
 
 
     <h3>Parameters:</h3>
     <ul>
+        <li><span class="parameter">iter</span>
+         an iterator function, prototyped as <code>iter (i, ...)</code>
+        </li>
+        <li><span class="parameter">n</span>
+         the number of times <code>iter</code> should be called. Defaults to 1.
+         (<em>optional</em>)
+        </li>
         <li><span class="parameter">...</span>
-         a list of predicate functions
+         args to be passed to <code>iter</code> function
+         (<em>optional</em>)
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a new function
+        table an array of results
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <li><a href="index.html#over">over</a></li>
-         <li><a href="index.html#overEvery">overEvery</a></li>
-         <li><a href="index.html#overArgs">overArgs</a></li>
-    </ul>
 
 
 </dd>
     <dt>
-    <a name = "overArgs"></a>
-    <strong>overArgs (f, ...)</strong>
+    <a name = "unary"></a>
+    <strong>unary (f)</strong>
     </dt>
     <dd>
-    Creates a function that invokes <code>f</code> with its arguments transformed.  1rst arguments will be passed to
- the 1rst transform, 2nd arg to the 2nd transform, etc. Remaining arguments will not be transformed.
+    Returns a function which accepts up to one arg.  It ignores any additional arguments.
 
 
     <h3>Parameters:</h3>
@@ -3997,170 +5497,151 @@
         <li><span class="parameter">f</span>
          a function
         </li>
-        <li><span class="parameter">...</span>
-         a list of transforms funcs prototyped as <code>f (v)</code>
-        </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        the result of running <code>f</code> with its transformed arguments
+        a function
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <li><a href="index.html#over">over</a></li>
-         <li><a href="index.html#overEvery">overEvery</a></li>
-         <li><a href="index.html#overSome">overSome</a></li>
+         <a href="index.html#ary">ary</a>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "partial"></a>
-    <strong>partial (f, ...)</strong>
+    <a name = "unfold"></a>
+    <strong>unfold (f, seed)</strong>
     </dt>
     <dd>
-    Partially apply a function by filling in any number of its arguments.<br/>
- One may pass a string <code>&apos;_&apos;</code> as a placeholder in the list of arguments to specify an argument
- that should not be pre-filled, but left open to be supplied at call-time.
+    Builds a list from a seed value.  Accepts an iterator function, which
+ returns either nil to stop iteration or two values : the value to add to the list
+ of results and the seed to be used in the next call to the iterator function.
 
 
     <h3>Parameters:</h3>
     <ul>
         <li><span class="parameter">f</span>
-         a function
+         an iterator function
         </li>
-        <li><span class="parameter">...</span>
-         a list of partial arguments to <code>f</code>
+        <li><span class="parameter">seed</span>
+         a seed value
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a new version of function f having some of it original arguments filled
+        an array of values
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <li><a href="index.html#partialRight">partialRight</a></li>
-         <li><a href="index.html#curry">curry</a></li>
-    </ul>
 
 
 </dd>
     <dt>
-    <a name = "partialRight"></a>
-    <strong>partialRight (f, ...)</strong>
+    <a name = "uniqueId"></a>
+    <strong>uniqueId ([template[, ...]])</strong>
     </dt>
     <dd>
-    Similar to <a href="index.html#partial">partial</a>, but from the right.
+    Generates an unique ID for the current session.  If given a string <a href="index.html#template">template</a>, it
+ will use this template for output formatting. Otherwise, if <a href="index.html#template">template</a> is a function, it
+ will evaluate <code>template (id, ...)</code>.
+ <br/><em>Aliased as <code>uid</code></em>.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">f</span>
-         a function
+        <li><span class="parameter">template</span>
+         either a string or a function template to format the ID
+         (<em>optional</em>)
         </li>
         <li><span class="parameter">...</span>
-         a list of partial arguments to <code>f</code>
+         a variable number of arguments to be passed to <a href="index.html#template">template</a>, in case it is a function.
+         (<em>optional</em>)
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a new version of function f having some of it original arguments filled
+        value an ID
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <li><a href="index.html#partialRight">partialRight</a></li>
-         <li><a href="index.html#curry">curry</a></li>
-    </ul>
 
 
 </dd>
     <dt>
-    <a name = "curry"></a>
-    <strong>curry (f[, n_args])</strong>
+    <a name = "wrap"></a>
+    <strong>wrap (f, wrapper)</strong>
     </dt>
     <dd>
-    Curries a function.  If the given function <code>f</code> takes multiple arguments, it returns another version of
- <code>f</code> that takes a single argument (the first of the arguments to the original function) and returns a new
- function that takes the remainder of the arguments and returns the result.
+    Wraps <code>f</code> inside of the <code>wrapper</code> function.  It passes <code>f</code> as the first argument to <code>wrapper</code>.
+ This allows the wrapper to execute code before and after <code>f</code> runs,
+ adjust the arguments, and execute it conditionally.
 
 
     <h3>Parameters:</h3>
     <ul>
         <li><span class="parameter">f</span>
-         a function
+         a function to be wrapped, prototyped as <code>f (...)</code>
         </li>
-        <li><span class="parameter">n_args</span>
-         the number of arguments expected for <code>f</code>. Defaults to 2.
-         (<em>optional</em>)
+        <li><span class="parameter">wrapper</span>
+         a wrapper function, prototyped as <code>wrapper (f, ...)</code>
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a curried version of <code>f</code>
+        the results
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <li><a href="index.html#partial">partial</a></li>
-         <li><a href="index.html#partialRight">partialRight</a></li>
-    </ul>
 
 
 </dd>
+</dl>
+    <h2 class="section-header "><a name="Object_functions"></a>Object functions </h2>
+
+    <dl class="function">
     <dt>
-    <a name = "time"></a>
-    <strong>time (f[, ...])</strong>
+    <a name = "chain"></a>
+    <strong>chain (value)</strong>
     </dt>
     <dd>
-    Returns the execution time of <code>f (&hellip;)</code> and its returned values.
+    Returns a wrapped object.  Calling library functions as methods on this object
+ will continue to return wrapped objects until <a href="index.html#obj:value">obj:value</a> is used. Can be aliased as <code>M(value)</code>.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">f</span>
-         a function
-        </li>
-        <li><span class="parameter">...</span>
-         optional args to <code>f</code>
-         (<em>optional</em>)
+        <li><span class="parameter">value</span>
+         a value to be wrapped
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        the execution time and the results of <code>f (&hellip;)</code>
+        a wrapped object
     </ol>
 
 
 
 
 </dd>
-</dl>
-    <h2 class="section-header "><a name="Object_functions"></a>Object functions </h2>
-
-    <dl class="function">
     <dt>
-    <a name = "keys"></a>
-    <strong>keys (obj)</strong>
+    <a name = "clone"></a>
+    <strong>clone (obj[, shallow])</strong>
     </dt>
     <dd>
-    Returns the keys of the object properties.
+    Clones a given object properties.  If <code>shallow</code> is passed will also clone nested array properties.
 
 
     <h3>Parameters:</h3>
@@ -4168,12 +5649,16 @@
         <li><span class="parameter">obj</span>
          an object
         </li>
+        <li><span class="parameter">shallow</span>
+         whether or not nested array-properties should be cloned, defaults to false.
+         (<em>optional</em>)
+        </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        an array
+        a copy of the passed-in object
     </ol>
 
 
@@ -4181,24 +5666,29 @@
 
 </dd>
     <dt>
-    <a name = "values"></a>
-    <strong>values (obj)</strong>
+    <a name = "extend"></a>
+    <strong>extend (destObj, ...)</strong>
     </dt>
     <dd>
-    Returns the values of the object properties.
+    Extends an object properties.  It copies the properties of extra passed-in objects
+ into the destination object, and returns the destination object. The last objects
+ will override properties of the same name.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">obj</span>
-         an object
+        <li><span class="parameter">destObj</span>
+         a destination object
+        </li>
+        <li><span class="parameter">...</span>
+         a list of objects
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        an array
+        the destination object extended
     </ol>
 
 
@@ -4206,100 +5696,99 @@
 
 </dd>
     <dt>
-    <a name = "kvpairs"></a>
-    <strong>kvpairs (obj)</strong>
+    <a name = "functions"></a>
+    <strong>functions ([obj])</strong>
     </dt>
     <dd>
-    Converts keys and values a an array-list of [k, v].
+    Returns a sorted list of all methods names found in an object.  If the given object
+ has a metatable implementing an <code>__index</code> field pointing to another table, will also recurse on this
+ table if <code>recurseMt</code> is provided. If <code>obj</code> is omitted, it defaults to the library functions.
+ <br/><em>Aliased as <code>methods</code></em>.
 
 
     <h3>Parameters:</h3>
     <ul>
         <li><span class="parameter">obj</span>
-         an object
+         an object. Defaults to Moses library functions.
+         (<em>optional</em>)
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        an array list of key-values pairs
+        an array-list of methods names
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <a href="index.html#toObj">toObj</a>
-    </ul>
 
 
 </dd>
     <dt>
-    <a name = "toObj"></a>
-    <strong>toObj (kvpairs)</strong>
+    <a name = "has"></a>
+    <strong>has (obj, key)</strong>
     </dt>
     <dd>
-    Converts an array list of <a href="index.html#kvpairs">kvpairs</a> to an object.  Keys are taken
- from the 1rst column in the <a href="index.html#kvpairs">kvpairs</a> sequence, associated with values in the 2nd
- column
+    Checks if a given object implements a property.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">kvpairs</span>
-         an array-list of <a href="index.html#kvpairs">kvpairs</a>
+        <li><span class="parameter">obj</span>
+         an object
+        </li>
+        <li><span class="parameter">key</span>
+         a key property to be checked
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        an object
+        <code>true</code> or <code>false</code>
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <a href="index.html#kvpairs">kvpairs</a>
-    </ul>
 
 
 </dd>
     <dt>
-    <a name = "property"></a>
-    <strong>property (key)</strong>
+    <a name = "import"></a>
+    <strong>import ([context[, noConflict]])</strong>
     </dt>
     <dd>
-    Returns a function that will return the key property of any passed-in object.
+    Imports all library functions into a context.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">key</span>
-         a key property name
+        <li><span class="parameter">context</span>
+         a context. Defaults to <code>_ENV or </code>_G`` (current environment).
+         (<em>optional</em>)
+        </li>
+        <li><span class="parameter">noConflict</span>
+         if supplied, will not import conflicting functions in the destination context.
+         (<em>optional</em>)
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a function which should accept an object as argument
+        the passed-in context
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <a href="index.html#propertyOf">propertyOf</a>
-    </ul>
 
 
 </dd>
     <dt>
-    <a name = "propertyOf"></a>
-    <strong>propertyOf (obj)</strong>
+    <a name = "isArray"></a>
+    <strong>isArray (obj)</strong>
     </dt>
     <dd>
-    Returns a function which will return the value of an object property.
+    Checks if the given argument is an array.  Assumes <code>obj</code> is an array
+ if is a table with consecutive integer keys starting at 1.
 
 
     <h3>Parameters:</h3>
@@ -4312,36 +5801,32 @@
     <h3>Returns:</h3>
     <ol>
 
-        a function which should accept a key property argument
+        <code>true</code> or <code>false</code>
     </ol>
 
 
-    <h3>See also:</h3>
-    <ul>
-         <a href="index.html#property">property</a>
-    </ul>
 
 
 </dd>
     <dt>
-    <a name = "toBoolean"></a>
-    <strong>toBoolean (value)</strong>
+    <a name = "isBoolean"></a>
+    <strong>isBoolean (obj)</strong>
     </dt>
     <dd>
-    Converts any given value to a boolean
+    Checks if the given argument is a boolean.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">value</span>
-         a value. Can be of any type
+        <li><span class="parameter">obj</span>
+         an object
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        <code>true</code> if value is true, <code>false</code> otherwise (false or nil).
+        <code>true</code> or <code>false</code>
     </ol>
 
 
@@ -4349,29 +5834,25 @@
 
 </dd>
     <dt>
-    <a name = "extend"></a>
-    <strong>extend (destObj, ...)</strong>
+    <a name = "isCallable"></a>
+    <strong>isCallable (obj)</strong>
     </dt>
     <dd>
-    Extends an object properties.  It copies the properties of extra passed-in objects
- into the destination object, and returns the destination object. The last objects
- will override properties of the same name.
+    Checks if the given argument is callable.  Assumes <code>obj</code> is callable if
+ it is either a function or a table having a metatable implementing <code>__call</code> metamethod.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">destObj</span>
-         a destination object
-        </li>
-        <li><span class="parameter">...</span>
-         a list of objects
+        <li><span class="parameter">obj</span>
+         an object
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        the destination object extended
+        <code>true</code> or <code>false</code>
     </ol>
 
 
@@ -4379,20 +5860,19 @@
 
 </dd>
     <dt>
-    <a name = "functions"></a>
-    <strong>functions ([obj])</strong>
+    <a name = "isEmpty"></a>
+    <strong>isEmpty ([obj])</strong>
     </dt>
     <dd>
-    Returns a sorted list of all methods names found in an object.  If the given object
- has a metatable implementing an <code>__index</code> field pointing to another table, will also recurse on this
- table if <code>recurseMt</code> is provided. If <code>obj</code> is omitted, it defaults to the library functions.
- <br/><em>Aliased as <code>methods</code></em>.
+    Checks if the given pbject is empty.  If <code>obj</code> is a string, will return <code>true</code>
+ if <code>#obj == 0</code>. Otherwise, if <code>obj</code> is a table, will return whether or not this table
+ is empty. If <code>obj</code> is <code>nil</code>, it will return true.
 
 
     <h3>Parameters:</h3>
     <ul>
         <li><span class="parameter">obj</span>
-         an object. Defaults to Moses library functions.
+         an object
          (<em>optional</em>)
         </li>
     </ul>
@@ -4400,7 +5880,7 @@
     <h3>Returns:</h3>
     <ol>
 
-        an array-list of methods names
+        <code>true</code> or <code>false</code>
     </ol>
 
 
@@ -4408,20 +5888,27 @@
 
 </dd>
     <dt>
-    <a name = "clone"></a>
-    <strong>clone (obj[, shallow])</strong>
+    <a name = "isEqual"></a>
+    <strong>isEqual (objA, objB[, useMt])</strong>
     </dt>
     <dd>
-    Clones a given object properties.  If <code>shallow</code> is passed will also clone nested array properties.
+    Performs a deep comparison test between two objects.  Can compare strings, functions
+ (by reference), nil, booleans. Compares tables by reference or by values. If <code>useMt</code>
+ is passed, the equality operator <code>==</code> will be used if one of the given objects has a
+ metatable implementing <code>__eq</code>.
+ <br/><em>Aliased as <code>M.compare</code>, <code>M.matches</code></em>
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">obj</span>
+        <li><span class="parameter">objA</span>
          an object
         </li>
-        <li><span class="parameter">shallow</span>
-         whether or not nested array-properties should be cloned, defaults to false.
+        <li><span class="parameter">objB</span>
+         another object
+        </li>
+        <li><span class="parameter">useMt</span>
+         whether or not <code>__eq</code> should be used, defaults to false.
          (<em>optional</em>)
         </li>
     </ul>
@@ -4429,7 +5916,7 @@
     <h3>Returns:</h3>
     <ol>
 
-        a copy of the passed-in object
+        <code>true</code> or <code>false</code>
     </ol>
 
 
@@ -4437,13 +5924,11 @@
 
 </dd>
     <dt>
-    <a name = "tap"></a>
-    <strong>tap (obj, f[, ...])</strong>
+    <a name = "isFinite"></a>
+    <strong>isFinite (obj)</strong>
     </dt>
     <dd>
-    Invokes interceptor with the object, and then returns object.
- The primary purpose of this method is to &ldquo;tap into&rdquo; a method chain, in order to perform operations
- on intermediate results within the chain.
+    Checks if the given argument is a finite number.
 
 
     <h3>Parameters:</h3>
@@ -4451,19 +5936,12 @@
         <li><span class="parameter">obj</span>
          an object
         </li>
-        <li><span class="parameter">f</span>
-         an interceptor function, should be prototyped as <code>f (obj, &hellip;)</code>
-        </li>
-        <li><span class="parameter">...</span>
-         args to be passed to <code>f</code>
-         (<em>optional</em>)
-        </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        the passed-in object
+        <code>true</code> or <code>false</code>
     </ol>
 
 
@@ -4471,11 +5949,11 @@
 
 </dd>
     <dt>
-    <a name = "has"></a>
-    <strong>has (obj, key)</strong>
+    <a name = "isFunction"></a>
+    <strong>isFunction (obj)</strong>
     </dt>
     <dd>
-    Checks if a given object implements a property.
+    Checks if the given argument is a function.
 
 
     <h3>Parameters:</h3>
@@ -4483,9 +5961,6 @@
         <li><span class="parameter">obj</span>
          an object
         </li>
-        <li><span class="parameter">key</span>
-         a key property to be checked
-        </li>
     </ul>
 
     <h3>Returns:</h3>
@@ -4499,12 +5974,11 @@
 
 </dd>
     <dt>
-    <a name = "pick"></a>
-    <strong>pick (obj, ...)</strong>
+    <a name = "isInteger"></a>
+    <strong>isInteger (obj)</strong>
     </dt>
     <dd>
-    Returns an object copy having white-listed properties.
- <br/><em>Aliased as <code>choose</code></em>.
+    Checks if the given argument is an integer.
 
 
     <h3>Parameters:</h3>
@@ -4512,15 +5986,12 @@
         <li><span class="parameter">obj</span>
          an object
         </li>
-        <li><span class="parameter">...</span>
-         a variable number of string keys
-        </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        the filtered object
+        <code>true</code> or <code>false</code>
     </ol>
 
 
@@ -4528,12 +5999,11 @@
 
 </dd>
     <dt>
-    <a name = "omit"></a>
-    <strong>omit (obj, ...)</strong>
+    <a name = "isIterable"></a>
+    <strong>isIterable (obj)</strong>
     </dt>
     <dd>
-    Returns an object copy without black-listed properties.
- <br/><em>Aliased as <code>drop</code></em>.
+    Checks if the given object is iterable with <a href="https://www.lua.org/manual/5.1/manual.html#pdf-pairs">pairs</a> (or <a href="https://www.lua.org/manual/5.1/manual.html#pdf-ipairs">ipairs</a>).
 
 
     <h3>Parameters:</h3>
@@ -4541,15 +6011,12 @@
         <li><span class="parameter">obj</span>
          an object
         </li>
-        <li><span class="parameter">...</span>
-         a variable number of string keys
-        </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        the filtered object
+        <code>true</code> if the object can be iterated with <a href="https://www.lua.org/manual/5.1/manual.html#pdf-pairs">pairs</a> (or <a href="https://www.lua.org/manual/5.1/manual.html#pdf-ipairs">ipairs</a>), <code>false</code> otherwise
     </ol>
 
 
@@ -4557,12 +6024,11 @@
 
 </dd>
     <dt>
-    <a name = "template"></a>
-    <strong>template (obj[, template])</strong>
+    <a name = "isNaN"></a>
+    <strong>isNaN (obj)</strong>
     </dt>
     <dd>
-    Applies a template to an object, preserving non-nil properties.
- <br/><em>Aliased as <code>defaults</code></em>.
+    Checks if the given argument is NaN (see <a href="http://en.wikipedia.org/wiki/NaN">Not-A-Number</a>).
 
 
     <h3>Parameters:</h3>
@@ -4570,46 +6036,35 @@
         <li><span class="parameter">obj</span>
          an object
         </li>
-        <li><span class="parameter">template</span>
-         a template object. Defaults to an empty table <code>{}</code>.
-         (<em>optional</em>)
-        </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        the passed-in object filled
+        <code>true</code> or <code>false</code>
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <a href="index.html#isNumber">isNumber</a>
+    </ul>
 
 
 </dd>
     <dt>
-    <a name = "isEqual"></a>
-    <strong>isEqual (objA, objB[, useMt])</strong>
+    <a name = "isNil"></a>
+    <strong>isNil (obj)</strong>
     </dt>
     <dd>
-    Performs a deep comparison test between two objects.  Can compare strings, functions
- (by reference), nil, booleans. Compares tables by reference or by values. If <code>useMt</code>
- is passed, the equality operator <code>==</code> will be used if one of the given objects has a
- metatable implementing <code>__eq</code>.
- <br/><em>Aliased as <code>_.compare</code></em>
+    Checks if the given argument is nil.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">objA</span>
+        <li><span class="parameter">obj</span>
          an object
         </li>
-        <li><span class="parameter">objB</span>
-         another object
-        </li>
-        <li><span class="parameter">useMt</span>
-         whether or not <code>__eq</code> should be used, defaults to false.
-         (<em>optional</em>)
-        </li>
     </ul>
 
     <h3>Returns:</h3>
@@ -4623,12 +6078,11 @@
 
 </dd>
     <dt>
-    <a name = "result"></a>
-    <strong>result (obj, method[, ...])</strong>
+    <a name = "isNumber"></a>
+    <strong>isNumber (obj)</strong>
     </dt>
     <dd>
-    Invokes an object method.  It passes the object itself as the first argument. if <code>method</code> is not
- callable, will return <code>obj[method]</code>.
+    Checks if the given argument is a number.
 
 
     <h3>Parameters:</h3>
@@ -4636,37 +6090,34 @@
         <li><span class="parameter">obj</span>
          an object
         </li>
-        <li><span class="parameter">method</span>
-         a string key to index in object <code>obj</code>.
-        </li>
-        <li><span class="parameter">...</span>
-         Optional args to be passed to <code>method</code>
-         (<em>optional</em>)
-        </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        the returned value of <code>method (obj, &hellip;)</code> call
+        <code>true</code> or <code>false</code>
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <a href="index.html#isNaN">isNaN</a>
+    </ul>
 
 
 </dd>
     <dt>
-    <a name = "isTable"></a>
-    <strong>isTable (t)</strong>
+    <a name = "isString"></a>
+    <strong>isString (obj)</strong>
     </dt>
     <dd>
-    Checks if the given arg is a table.
+    Checks if the given argument is a string.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">t</span>
-         a value to be tested
+        <li><span class="parameter">obj</span>
+         an object
         </li>
     </ul>
 
@@ -4681,18 +6132,17 @@
 
 </dd>
     <dt>
-    <a name = "isCallable"></a>
-    <strong>isCallable (obj)</strong>
+    <a name = "isTable"></a>
+    <strong>isTable (t)</strong>
     </dt>
     <dd>
-    Checks if the given argument is callable.  Assumes <code>obj</code> is callable if
- it is either a function or a table having a metatable implementing <code>__call</code> metamethod.
+    Checks if the given arg is a table.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">obj</span>
-         an object
+        <li><span class="parameter">t</span>
+         a value to be tested
         </li>
     </ul>
 
@@ -4707,12 +6157,11 @@
 
 </dd>
     <dt>
-    <a name = "isArray"></a>
-    <strong>isArray (obj)</strong>
+    <a name = "keys"></a>
+    <strong>keys (obj)</strong>
     </dt>
     <dd>
-    Checks if the given argument is an array.  Assumes <code>obj</code> is an array
- if is a table with consecutive integer keys starting at 1.
+    Returns the keys of the object properties.
 
 
     <h3>Parameters:</h3>
@@ -4725,7 +6174,7 @@
     <h3>Returns:</h3>
     <ol>
 
-        <code>true</code> or <code>false</code>
+        an array
     </ol>
 
 
@@ -4733,11 +6182,11 @@
 
 </dd>
     <dt>
-    <a name = "isIterable"></a>
-    <strong>isIterable (obj)</strong>
+    <a name = "kvpairs"></a>
+    <strong>kvpairs (obj)</strong>
     </dt>
     <dd>
-    Checks if the given object is iterable with <a href="https://www.lua.org/manual/5.1/manual.html#pdf-pairs">pairs</a> (or <a href="https://www.lua.org/manual/5.1/manual.html#pdf-ipairs">ipairs</a>).
+    Converts key-value pairs to an array-list of <code>[k, v]</code> pairs.
 
 
     <h3>Parameters:</h3>
@@ -4750,35 +6199,30 @@
     <h3>Returns:</h3>
     <ol>
 
-        <code>true</code> if the object can be iterated with <a href="https://www.lua.org/manual/5.1/manual.html#pdf-pairs">pairs</a> (or <a href="https://www.lua.org/manual/5.1/manual.html#pdf-ipairs">ipairs</a>), <code>false</code> otherwise
+        an array list of key-value pairs
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <a href="index.html#toObj">toObj</a>
+    </ul>
 
 
 </dd>
     <dt>
-    <a name = "isEmpty"></a>
-    <strong>isEmpty ([obj])</strong>
+    <a name = "obj:value"></a>
+    <strong>obj:value ()</strong>
     </dt>
     <dd>
-    Checks if the given pbject is empty.  If <code>obj</code> is a string, will return <code>true</code>
- if <code>#obj == 0</code>. Otherwise, if <code>obj</code> is a table, will return whether or not this table
- is empty. If <code>obj</code> is <code>nil</code>, it will return true.
+    Extracts the value of a wrapped object.  Must be called on an chained object (see <a href="index.html#chain">chain</a>).
 
 
-    <h3>Parameters:</h3>
-    <ul>
-        <li><span class="parameter">obj</span>
-         an object
-         (<em>optional</em>)
-        </li>
-    </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        <code>true</code> or <code>false</code>
+        the value previously wrapped
     </ol>
 
 
@@ -4786,11 +6230,12 @@
 
 </dd>
     <dt>
-    <a name = "isString"></a>
-    <strong>isString (obj)</strong>
+    <a name = "omit"></a>
+    <strong>omit (obj, ...)</strong>
     </dt>
     <dd>
-    Checks if the given argument is a string.
+    Returns an object copy without black-listed properties.
+ <br/><em>Aliased as <code>drop</code></em>.
 
 
     <h3>Parameters:</h3>
@@ -4798,12 +6243,15 @@
         <li><span class="parameter">obj</span>
          an object
         </li>
+        <li><span class="parameter">...</span>
+         a variable number of string keys
+        </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        <code>true</code> or <code>false</code>
+        the filtered object
     </ol>
 
 
@@ -4811,11 +6259,12 @@
 
 </dd>
     <dt>
-    <a name = "isFunction"></a>
-    <strong>isFunction (obj)</strong>
+    <a name = "path"></a>
+    <strong>path (obj, ...)</strong>
     </dt>
     <dd>
-    Checks if the given argument is a function.
+    Returns the value at a given path in an object. <br/>
+ Path is given as a vararg list of keys.
 
 
     <h3>Parameters:</h3>
@@ -4823,12 +6272,15 @@
         <li><span class="parameter">obj</span>
          an object
         </li>
+        <li><span class="parameter">...</span>
+         a vararg list of keys
+        </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        <code>true</code> or <code>false</code>
+        a value or nil
     </ol>
 
 
@@ -4836,11 +6288,12 @@
 
 </dd>
     <dt>
-    <a name = "isNil"></a>
-    <strong>isNil (obj)</strong>
+    <a name = "pick"></a>
+    <strong>pick (obj, ...)</strong>
     </dt>
     <dd>
-    Checks if the given argument is nil.
+    Returns an object copy having white-listed properties.
+ <br/><em>Aliased as <code>choose</code></em>.
 
 
     <h3>Parameters:</h3>
@@ -4848,12 +6301,15 @@
         <li><span class="parameter">obj</span>
          an object
         </li>
+        <li><span class="parameter">...</span>
+         a variable number of string keys
+        </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        <code>true</code> or <code>false</code>
+        the filtered object
     </ol>
 
 
@@ -4861,40 +6317,40 @@
 
 </dd>
     <dt>
-    <a name = "isNumber"></a>
-    <strong>isNumber (obj)</strong>
+    <a name = "property"></a>
+    <strong>property (key)</strong>
     </dt>
     <dd>
-    Checks if the given argument is a number.
+    Returns a function that will return the key property of any passed-in object.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">obj</span>
-         an object
+        <li><span class="parameter">key</span>
+         a key property name
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        <code>true</code> or <code>false</code>
+        a function which should accept an object as argument
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <a href="index.html#isNaN">isNaN</a>
+         <a href="index.html#propertyOf">propertyOf</a>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "isNaN"></a>
-    <strong>isNaN (obj)</strong>
+    <a name = "propertyOf"></a>
+    <strong>propertyOf (obj)</strong>
     </dt>
     <dd>
-    Checks if the given argument is NaN (see <a href="http://en.wikipedia.org/wiki/NaN">Not-A-Number</a>).
+    Returns a function which will return the value of an object property.
 
 
     <h3>Parameters:</h3>
@@ -4907,23 +6363,24 @@
     <h3>Returns:</h3>
     <ol>
 
-        <code>true</code> or <code>false</code>
+        a function which should accept a key property argument
     </ol>
 
 
     <h3>See also:</h3>
     <ul>
-         <a href="index.html#isNumber">isNumber</a>
+         <a href="index.html#property">property</a>
     </ul>
 
 
 </dd>
     <dt>
-    <a name = "isFinite"></a>
-    <strong>isFinite (obj)</strong>
+    <a name = "result"></a>
+    <strong>result (obj, method[, ...])</strong>
     </dt>
     <dd>
-    Checks if the given argument is a finite number.
+    Invokes an object method.  It passes the object itself as the first argument. if <code>method</code> is not
+ callable, will return <code>obj[method]</code>.
 
 
     <h3>Parameters:</h3>
@@ -4931,12 +6388,19 @@
         <li><span class="parameter">obj</span>
          an object
         </li>
+        <li><span class="parameter">method</span>
+         a string key to index in object <code>obj</code>.
+        </li>
+        <li><span class="parameter">...</span>
+         Optional args to be passed to <code>method</code>
+         (<em>optional</em>)
+        </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        <code>true</code> or <code>false</code>
+        the returned value of <code>method (obj, ...)</code> call
     </ol>
 
 
@@ -4944,11 +6408,13 @@
 
 </dd>
     <dt>
-    <a name = "isBoolean"></a>
-    <strong>isBoolean (obj)</strong>
+    <a name = "tap"></a>
+    <strong>tap (obj, f[, ...])</strong>
     </dt>
     <dd>
-    Checks if the given argument is a boolean.
+    Invokes interceptor with the object, and then returns object.
+ The primary purpose of this method is to "tap into" a method chain, in order to perform operations
+ on intermediate results within the chain.
 
 
     <h3>Parameters:</h3>
@@ -4956,12 +6422,19 @@
         <li><span class="parameter">obj</span>
          an object
         </li>
+        <li><span class="parameter">f</span>
+         an interceptor function, should be prototyped as <code>f (obj, ...)</code>
+        </li>
+        <li><span class="parameter">...</span>
+         args to be passed to <code>f</code>
+         (<em>optional</em>)
+        </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        <code>true</code> or <code>false</code>
+        the passed-in object
     </ol>
 
 
@@ -4969,11 +6442,12 @@
 
 </dd>
     <dt>
-    <a name = "isInteger"></a>
-    <strong>isInteger (obj)</strong>
+    <a name = "template"></a>
+    <strong>template (obj[, template])</strong>
     </dt>
     <dd>
-    Checks if the given argument is an integer.
+    Applies a template to an object, preserving non-nil properties.
+ <br/><em>Aliased as <code>defaults</code></em>.
 
 
     <h3>Parameters:</h3>
@@ -4981,12 +6455,16 @@
         <li><span class="parameter">obj</span>
          an object
         </li>
+        <li><span class="parameter">template</span>
+         a template object. If <code>nil</code>, leaves <code>obj</code> untouched.
+         (<em>optional</em>)
+        </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        <code>true</code> or <code>false</code>
+        the passed-in object filled
     </ol>
 
 
@@ -4994,25 +6472,24 @@
 
 </dd>
     <dt>
-    <a name = "chain"></a>
-    <strong>chain (value)</strong>
+    <a name = "toBoolean"></a>
+    <strong>toBoolean (value)</strong>
     </dt>
     <dd>
-    Returns a wrapped object.  Calling library functions as methods on this object
- will continue to return wrapped objects until <a href="index.html#obj:value">obj:value</a> is used. Can be aliased as <code>_(value)</code>.
+    Converts any given value to a boolean
 
 
     <h3>Parameters:</h3>
     <ul>
         <li><span class="parameter">value</span>
-         a value to be wrapped
+         a value. Can be of any type
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        a wrapped object
+        <code>true</code> if value is true, <code>false</code> otherwise (false or nil).
     </ol>
 
 
@@ -5020,48 +6497,55 @@
 
 </dd>
     <dt>
-    <a name = "obj:value"></a>
-    <strong>obj:value ()</strong>
+    <a name = "toObj"></a>
+    <strong>toObj (kvpairs)</strong>
     </dt>
     <dd>
-    Extracts the value of a wrapped object.  Must be called on an chained object (see <a href="index.html#chain">chain</a>).
+    Converts an array list of <code>[k,v]</code> pairs to an object.  Keys are taken
+ from the 1rst column in the <code>[k,v]</code> pairs sequence, associated with values in the 2nd
+ column.
 
 
+    <h3>Parameters:</h3>
+    <ul>
+        <li><span class="parameter">kvpairs</span>
+         an array-list of <code>[k,v]</code> pairs
+        </li>
+    </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        the value previously wrapped
+        an object
     </ol>
 
 
+    <h3>See also:</h3>
+    <ul>
+         <a href="index.html#kvpairs">kvpairs</a>
+    </ul>
 
 
 </dd>
     <dt>
-    <a name = "import"></a>
-    <strong>import ([context[, noConflict]])</strong>
+    <a name = "values"></a>
+    <strong>values (obj)</strong>
     </dt>
     <dd>
-    Imports all library functions into a context.
+    Returns the values of the object properties.
 
 
     <h3>Parameters:</h3>
     <ul>
-        <li><span class="parameter">context</span>
-         a context. Defaults to <code>_G</code> (global environment) when not given.
-         (<em>optional</em>)
-        </li>
-        <li><span class="parameter">noConflict</span>
-         if supplied, will not import functions having a key existing in the destination context.
-         (<em>optional</em>)
+        <li><span class="parameter">obj</span>
+         an object
         </li>
     </ul>
 
     <h3>Returns:</h3>
     <ol>
 
-        the passed-in context
+        an array of values
     </ol>
 
 
@@ -5075,7 +6559,7 @@
 </div> <!-- id="main" -->
 <div id="about">
 <i>generated by <a href="http://github.com/stevedonovan/LDoc">LDoc 1.4.6</a></i>
-<i style="float:right;">Last updated 2017-05-03 14:08:34 </i>
+<i style="float:right;">Last updated 2018-08-23 10:16:23 </i>
 </div> <!-- id="about" -->
 </div> <!-- id="container" -->
 </body>
diff -pruN 1.6.1+git20170613-2/doc/ldoc.css 2.0.0-3/doc/ldoc.css
--- 1.6.1+git20170613-2/doc/ldoc.css	2017-06-03 16:42:55.000000000 +0000
+++ 2.0.0-3/doc/ldoc.css	1970-01-01 00:00:00.000000000 +0000
@@ -1,303 +0,0 @@
-/* BEGIN RESET
-
-Copyright (c) 2010, Yahoo! Inc. All rights reserved.
-Code licensed under the BSD License:
-http://developer.yahoo.com/yui/license.html
-version: 2.8.2r1
-*/
-html {
-    color: #000;
-    background: #FFF;
-}
-body,div,dl,dt,dd,ul,ol,li,h1,h2,h3,h4,h5,h6,pre,code,form,fieldset,legend,input,button,textarea,p,blockquote,th,td {
-    margin: 0;
-    padding: 0;
-}
-table {
-    border-collapse: collapse;
-    border-spacing: 0;
-}
-fieldset,img {
-    border: 0;
-}
-address,caption,cite,code,dfn,em,strong,th,var,optgroup {
-    font-style: inherit;
-    font-weight: inherit;
-}
-del,ins {
-    text-decoration: none;
-}
-li {
-    margin-left: 20px;
-}
-caption,th {
-    text-align: left;
-}
-h1,h2,h3,h4,h5,h6 {
-    font-size: 100%;
-    font-weight: bold;
-}
-q:before,q:after {
-    content: '';
-}
-abbr,acronym {
-    border: 0;
-    font-variant: normal;
-}
-sup {
-    vertical-align: baseline;
-}
-sub {
-    vertical-align: baseline;
-}
-legend {
-    color: #000;
-}
-input,button,textarea,select,optgroup,option {
-    font-family: inherit;
-    font-size: inherit;
-    font-style: inherit;
-    font-weight: inherit;
-}
-input,button,textarea,select {*font-size:100%;
-}
-/* END RESET */
-
-body {
-    margin-left: 1em;
-    margin-right: 1em;
-    font-family: arial, helvetica, geneva, sans-serif;
-    background-color: #ffffff; margin: 0px;
-}
-
-code, tt { font-family: monospace; font-size: 1.1em; }
-span.parameter { font-family:monospace; }
-span.parameter:after { content:":"; }
-span.types:before { content:"("; }
-span.types:after { content:")"; }
-.type { font-weight: bold; font-style:italic }
-
-body, p, td, th { font-size: .95em; line-height: 1.2em;}
-
-p, ul { margin: 10px 0 0 0px;}
-
-strong { font-weight: bold;}
-
-em { font-style: italic;}
-
-h1 {
-    font-size: 1.5em;
-    margin: 20px 0 20px 0;
-}
-h2, h3, h4 { margin: 15px 0 10px 0; }
-h2 { font-size: 1.25em; }
-h3 { font-size: 1.15em; }
-h4 { font-size: 1.06em; }
-
-a:link { font-weight: bold; color: #004080; text-decoration: none; }
-a:visited { font-weight: bold; color: #006699; text-decoration: none; }
-a:link:hover { text-decoration: underline; }
-
-hr {
-    color:#cccccc;
-    background: #00007f;
-    height: 1px;
-}
-
-blockquote { margin-left: 3em; }
-
-ul { list-style-type: disc; }
-
-p.name {
-    font-family: "Andale Mono", monospace;
-    padding-top: 1em;
-}
-
-pre {
-    background-color: rgb(245, 245, 245);
-    border: 1px solid #C0C0C0; /* silver */
-    padding: 10px;
-    margin: 10px 0 10px 0;
-    overflow: auto;
-    font-family: "Andale Mono", monospace;
-}
-
-pre.example {
-    font-size: .85em;
-}
-
-table.index { border: 1px #00007f; }
-table.index td { text-align: left; vertical-align: top; }
-
-#container {
-    margin-left: 1em;
-    margin-right: 1em;
-    background-color: #f0f0f0;
-}
-
-#product {
-    text-align: center;
-    border-bottom: 1px solid #cccccc;
-    background-color: #ffffff;
-}
-
-#product big {
-    font-size: 2em;
-}
-
-#main {
-    background-color: #f0f0f0;
-    border-left: 2px solid #cccccc;
-}
-
-#navigation {
-    float: left;
-    width: 14em;
-    vertical-align: top;
-    background-color: #f0f0f0;
-    overflow: visible;
-}
-
-#navigation h2 {
-    background-color:#e7e7e7;
-    font-size:1.1em;
-    color:#000000;
-    text-align: left;
-    padding:0.2em;
-    border-top:1px solid #dddddd;
-    border-bottom:1px solid #dddddd;
-}
-
-#navigation ul
-{
-    font-size:1em;
-    list-style-type: none;
-    margin: 1px 1px 10px 1px;
-}
-
-#navigation li {
-    text-indent: -1em;
-    display: block;
-    margin: 3px 0px 0px 22px;
-}
-
-#navigation li li a {
-    margin: 0px 3px 0px -1em;
-}
-
-#content {
-    margin-left: 14em;
-    padding: 1em;
-    width: 700px;
-    border-left: 2px solid #cccccc;
-    border-right: 2px solid #cccccc;
-    background-color: #ffffff;
-}
-
-#about {
-    clear: both;
-    padding: 5px;
-    border-top: 2px solid #cccccc;
-    background-color: #ffffff;
-}
-
-@media print {
-    body {
-        font: 12pt "Times New Roman", "TimeNR", Times, serif;
-    }
-    a { font-weight: bold; color: #004080; text-decoration: underline; }
-
-    #main {
-        background-color: #ffffff;
-        border-left: 0px;
-    }
-
-    #container {
-        margin-left: 2%;
-        margin-right: 2%;
-        background-color: #ffffff;
-    }
-
-    #content {
-        padding: 1em;
-        background-color: #ffffff;
-    }
-
-    #navigation {
-        display: none;
-    }
-    pre.example {
-        font-family: "Andale Mono", monospace;
-        font-size: 10pt;
-        page-break-inside: avoid;
-    }
-}
-
-table.module_list {
-    border-width: 1px;
-    border-style: solid;
-    border-color: #cccccc;
-    border-collapse: collapse;
-}
-table.module_list td {
-    border-width: 1px;
-    padding: 3px;
-    border-style: solid;
-    border-color: #cccccc;
-}
-table.module_list td.name { background-color: #f0f0f0; min-width: 200px; }
-table.module_list td.summary { width: 100%; }
-
-
-table.function_list {
-    border-width: 1px;
-    border-style: solid;
-    border-color: #cccccc;
-    border-collapse: collapse;
-}
-table.function_list td {
-    border-width: 1px;
-    padding: 3px;
-    border-style: solid;
-    border-color: #cccccc;
-}
-table.function_list td.name { background-color: #f0f0f0; min-width: 200px; }
-table.function_list td.summary { width: 100%; }
-
-ul.nowrap {
-    overflow:auto;
-    white-space:nowrap;
-}
-
-dl.table dt, dl.function dt {border-top: 1px solid #ccc; padding-top: 1em;}
-dl.table dd, dl.function dd {padding-bottom: 1em; margin: 10px 0 0 20px;}
-dl.table h3, dl.function h3 {font-size: .95em;}
-
-/* stop sublists from having initial vertical space */
-ul ul { margin-top: 0px; }
-ol ul { margin-top: 0px; }
-ol ol { margin-top: 0px; }
-ul ol { margin-top: 0px; }
-
-/* make the target distinct; helps when we're navigating to a function */
-a:target + * {
-  background-color: #FF9;
-}
-
-
-/* styles for prettification of source */
-pre .comment { color: #558817; }
-pre .constant { color: #a8660d; }
-pre .escape { color: #844631; }
-pre .keyword { color: #aa5050; font-weight: bold; }
-pre .library { color: #0e7c6b; }
-pre .marker { color: #512b1e; background: #fedc56; font-weight: bold; }
-pre .string { color: #8080ff; }
-pre .number { color: #f8660d; }
-pre .operator { color: #2239a8; font-weight: bold; }
-pre .preprocessor, pre .prepro { color: #a33243; }
-pre .global { color: #800080; }
-pre .user-keyword { color: #800080; }
-pre .prompt { color: #558817; }
-pre .url { color: #272fc2; text-decoration: underline; }
-
diff -pruN 1.6.1+git20170613-2/doc/manual/tutorial.md.html 2.0.0-3/doc/manual/tutorial.md.html
--- 1.6.1+git20170613-2/doc/manual/tutorial.md.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.0-3/doc/manual/tutorial.md.html	2018-08-23 16:26:20.000000000 +0000
@@ -0,0 +1,2869 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
+   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
+<html>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
+<head>
+    <title>Moses documentation</title>
+    <link rel="stylesheet" href="../ldoc_fixed.css" type="text/css" />
+</head>
+<body>
+
+<div id="container">
+
+<div id="product">
+	<div id="product_logo"></div>
+	<div id="product_name"><big><b></b></big></div>
+	<div id="product_description"></div>
+</div> <!-- id="product" -->
+
+
+<div id="main">
+
+
+<!-- Menu -->
+
+<div id="navigation">
+<br/>
+<h1>Moses</h1>
+
+
+<h2>Contents</h2>
+<ul>
+<li><a href="#_a_name__table__Table_functions__a_"><a name='table'>Table functions</a> </a></li>
+<li><a href="#_a_name__array__Array_functions__a_"><a name='array'>Array functions</a> </a></li>
+<li><a href="#_a_name__utility__Utility_functions__a_"><a name='utility'>Utility functions</a> </a></li>
+<li><a href="#_a_name__object__Object_functions__a_"><a name='object'>Object functions</a> </a></li>
+<li><a href="#_a_name__chaining__Chaining__a_"><a name='chaining'>Chaining</a> </a></li>
+<li><a href="#_a_name__import__Import__a_"><a name='import'>Import</a> </a></li>
+</ul>
+
+
+<h2>Manual</h2>
+<ul class="nowrap">
+  <li><strong>tutorial</strong></li>
+</ul>
+<h2>Modules</h2>
+<ul class="nowrap">
+  <li><a href="index.html">moses</a></li>
+</ul>
+
+</div>
+
+<div id="content">
+
+    <em>Moses: a utility-belt library for functional programming in Lua</em></p>
+
+<p><strong>Moses</strong> is a Lua utility library which provides support for functional programming.
+It complements built-in Lua functions, making easier common operations on tables, arrays, lists, collections, objects, and a lot more.
+<br/>
+<br/></p>
+
+<h1><a name='TOC'>Sections</a></h1>
+
+
+<ul>
+    <li><a href="#adding">Adding <em>Moses</em> to your project</a></li>
+    <li><a href="#table">Table functions</a></li>
+    <li><a href="#array">Array functions</a></li>
+    <li><a href="#utility">Utility functions</a></li>
+    <li><a href="#object">Object functions</a></li>
+    <li><a href="#chaining">Chaining</a></li>
+    <li><a href="#import">Import</a>
+    <br/><br/>
+    <h1><a name='adding'>Adding <em>Moses</em> to your project</a></h1></li>
+</ul>
+
+<p>Drop the file <a href="http://github.com/Yonaba/Moses/blob/master/moses.lua">moses.lua</a> into your project and add it to your code with the <em>require</em> function:</p>
+
+
+<pre>
+<span class="keyword">local</span> M = <span class="global">require</span> (<span class="string">"moses"</span>)
+</pre>
+
+
+<p><em>Moses</em> provides a large set of functions that can be classified into four categories:</p>
+
+<ul>
+    <li><a href="#table"><strong>Table functions</strong></a>, which are mostly meant for tables, i.e Lua tables which contains both an array-part and a hash-part,</li>
+    <li><a href="#array"><strong>Array functions</strong></a>, meant for array lists (or sequences),</li>
+    <li><a href="#utility"><strong>Utility functions</strong></a>,</li>
+    <li><a href="#object"><strong>Object functions</strong></a>.</li>
+</ul>
+
+<p><strong><a href="#TOC">[⬆]</a></strong></p>
+
+<p><a name="_a_name__table__Table_functions__a_"></a></p>
+<h2><a name='table'>Table functions</a></h2>
+
+<h3>clear (t)</h3>
+
+<p>Clears a table. All its values becomes nil. Returns the passed-in table.</p>
+
+
+<pre>
+M.clear({<span class="number">1</span>,<span class="number">2</span>,<span class="string">'hello'</span>,<span class="keyword">true</span>}) <span class="comment">-- =&gt; {}</span>
+</pre>
+
+
+<h3>each (t, f [, ...])</h3>
+<p>*Aliases: <code>forEach</code>*.</p>
+
+<p>Iterates over each value-key pair in the passed-in table.</p>
+
+
+<pre>
+M.each({<span class="number">4</span>,<span class="number">2</span>,<span class="number">1</span>},<span class="global">print</span>)
+
+<span class="comment">-- =&gt; 4 1
+</span><span class="comment">-- =&gt; 2 2
+</span><span class="comment">-- =&gt; 1 3</span>
+</pre>
+
+
+<p>The table can be map-like (both array part and hash part).</p>
+
+
+<pre>
+M.each({one = <span class="number">1</span>, two = <span class="number">2</span>, three = <span class="number">3</span>},<span class="global">print</span>)
+
+<span class="comment">-- =&gt; 1 one
+</span><span class="comment">-- =&gt; 2 two
+</span><span class="comment">-- =&gt; 3 three</span>
+</pre>
+
+
+<p>Can index and assign in an outer table or in the passed-in table:</p>
+
+
+<pre>
+t = {<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>}
+M.each(t,<span class="keyword">function</span>(v,i)
+  t[i] = v:rep(<span class="number">2</span>)
+  <span class="global">print</span>(t[i])
+<span class="keyword">end</span>)
+
+<span class="comment">-- =&gt; aa
+</span><span class="comment">-- =&gt; bb
+</span><span class="comment">-- =&gt; cc</span>
+</pre>
+
+
+<h3>eachi (t, f [, ...])</h3>
+<p>*Aliases: <code>forEachi</code>*.</p>
+
+<p>Iterates only on integer keys in an array table. It returns value-key pairs.</p>
+
+
+<pre>
+M.eachi({<span class="number">4</span>,<span class="number">2</span>,<span class="number">1</span>},<span class="global">print</span>)
+
+<span class="comment">-- =&gt; 4 1
+</span><span class="comment">-- =&gt; 2 2
+</span><span class="comment">-- =&gt; 1 3</span>
+</pre>
+
+
+<p>The given array can be sparse, or even have a hash-like part.</p>
+
+
+<pre>
+<span class="keyword">local</span> t = {a = <span class="number">1</span>, b = <span class="number">2</span>, [<span class="number">0</span>] = <span class="number">1</span>, [-<span class="number">1</span>] = <span class="number">6</span>, <span class="number">3</span>, x = <span class="number">4</span>, <span class="number">5</span>}
+M.eachi(t,<span class="global">print</span>)
+
+<span class="comment">-- =&gt; 6 -1
+</span><span class="comment">-- =&gt; 1 0
+</span><span class="comment">-- =&gt; 3 1
+</span><span class="comment">-- =&gt; 5 2</span>
+</pre>
+
+
+<h3>at (t, ...)</h3>
+
+<p>Collects values at given keys and returns them in an array.</p>
+
+
+<pre>
+<span class="keyword">local</span> t = {<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>}
+M.at(t,<span class="number">1</span>,<span class="number">3</span>) <span class="comment">-- =&gt; "{4,6}"
+</span>
+<span class="keyword">local</span> t = {a = <span class="number">4</span>, bb = <span class="keyword">true</span>, ccc = <span class="keyword">false</span>}
+M.at(t,<span class="string">'a'</span>, <span class="string">'ccc'</span>) <span class="comment">-- =&gt; "{4, false}"</span>
+</pre>
+
+
+<h3>adjust (t, key, f [, ...])</h3>
+
+<p>Adjusts the value at a given key using a function or a value. In case <code>f</code> is a function, it should be prototyped <code>f(v, ...)</code>. It does not mutate the given table, but rather returns a new array.</p>
+
+
+<pre>
+<span class="keyword">local</span> t = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>}
+M.adjust(t, <span class="number">2</span>, <span class="global">math</span>.sin) <span class="comment">-- =&gt; {1, 0.90929, 3}
+</span>
+<span class="keyword">local</span> v = {x = <span class="number">1</span>}
+ M.adjust(t, <span class="string">'x'</span>, <span class="number">4</span>) <span class="comment">-- =&gt; {x = 4}</span>
+</pre>
+
+
+<p>In case the given <code>key</code> does not exist in <code>t</code>, it throws an error.</p>
+
+<h3>count (t [, val])</h3>
+
+<p>Counts the number of occurences of a given value in a table.</p>
+
+
+<pre>
+M.count({<span class="number">1</span>,<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">3</span>,<span class="number">3</span>,<span class="number">2</span>,<span class="number">4</span>,<span class="number">3</span>,<span class="number">2</span>},<span class="number">1</span>) <span class="comment">-- =&gt; 2
+</span>M.count({<span class="number">1</span>,<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">3</span>,<span class="number">3</span>,<span class="number">2</span>,<span class="number">4</span>,<span class="number">3</span>,<span class="number">2</span>},<span class="number">2</span>) <span class="comment">-- =&gt; 3
+</span>M.count({<span class="number">1</span>,<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">3</span>,<span class="number">3</span>,<span class="number">2</span>,<span class="number">4</span>,<span class="number">3</span>,<span class="number">2</span>},<span class="number">3</span>) <span class="comment">-- =&gt; 4
+</span>M.count({<span class="keyword">false</span>, <span class="keyword">false</span>, <span class="keyword">true</span>},<span class="keyword">false</span>) <span class="comment">-- =&gt; 2
+</span>M.count({<span class="keyword">false</span>, <span class="keyword">false</span>, <span class="keyword">true</span>},<span class="keyword">true</span>) <span class="comment">-- =&gt; 1</span>
+</pre>
+
+
+<p>Returns the size of the list in case no value was provided.</p>
+
+
+<pre>
+M.count({<span class="number">1</span>,<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">3</span>}) <span class="comment">-- =&gt; 5</span>
+</pre>
+
+
+<h3>countf (t, f [, ...])</h3>
+
+<p>Counts the number of values passing an iterator test.</p>
+
+
+<pre>
+M.countf({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>}, <span class="keyword">function</span>(v)
+  <span class="keyword">return</span> v%<span class="number">2</span>==<span class="number">0</span>
+<span class="keyword">end</span>) <span class="comment">-- =&gt; 3
+</span>
+M.countf({<span class="global">print</span>, <span class="global">pairs</span>, <span class="global">os</span>, <span class="global">assert</span>, <span class="global">ipairs</span>}, <span class="keyword">function</span>(v)
+  <span class="keyword">return</span> <span class="global">type</span>(v)==<span class="string">'function'</span>
+<span class="keyword">end</span>) <span class="comment">-- =&gt; 4</span>
+</pre>
+
+
+<h3>cycle (t [, n = 1])</h3>
+<p>*Aliases: <code>loop</code>*.</p>
+
+<p>Returns a function which iterates on each value-key pair in a given table (similarly to <code>M.each</code>), except that it restarts iterating again <code>n</code> times.
+If <code>n</code> is not provided, it defaults to 1.</p>
+
+
+<pre>
+<span class="keyword">local</span> t = {<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>}
+<span class="keyword">for</span> v <span class="keyword">in</span> M.cycle(t, <span class="number">2</span>) <span class="keyword">do</span>
+  <span class="global">print</span>(v)
+<span class="keyword">end</span>
+
+<span class="comment">-- =&gt; 'a'
+</span><span class="comment">-- =&gt; 'b'
+</span><span class="comment">-- =&gt; 'c'
+</span><span class="comment">-- =&gt; 'a'
+</span><span class="comment">-- =&gt; 'b'
+</span><span class="comment">-- =&gt; 'c'</span>
+</pre>
+
+
+<p>Supports array-like tables and map-like tables.</p>
+
+
+<pre>
+<span class="keyword">local</span> t = {x = <span class="number">1</span>, y = <span class="number">2</span>, z = <span class="number">3</span>}
+<span class="keyword">for</span> v <span class="keyword">in</span> M.cycle(t) <span class="keyword">do</span>
+  <span class="global">print</span>(v)
+<span class="keyword">end</span>
+
+<span class="comment">-- =&gt; 2
+</span><span class="comment">-- =&gt; 1
+</span><span class="comment">-- =&gt; 3</span>
+</pre>
+
+
+<h3>map (t, f [, ...])</h3>
+<p>*Aliases: <code>collect</code>*.</p>
+
+<p>Executes a function on each value in a given array.</p>
+
+
+<pre>
+M.map({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>},<span class="keyword">function</span>(v)
+  <span class="keyword">return</span> v+<span class="number">10</span>
+<span class="keyword">end</span>) <span class="comment">-- =&gt; "{11,12,13}"</span>
+</pre>
+
+
+
+<pre>
+M.map({a = <span class="number">1</span>, b = <span class="number">2</span>},<span class="keyword">function</span>(v, k)
+  <span class="keyword">return</span> k..v
+<span class="keyword">end</span>) <span class="comment">-- =&gt; "{a = 'a1', b = 'b2'}"</span>
+</pre>
+
+
+<p>It also maps both keys and values.</p>
+
+
+<pre>
+M.map({a = <span class="number">1</span>, b = <span class="number">2</span>},<span class="keyword">function</span>(v, k)
+  <span class="keyword">return</span> k..k, v*<span class="number">2</span>
+<span class="keyword">end</span>) <span class="comment">-- =&gt; "{aa = 2, bb = 4}"</span>
+</pre>
+
+
+<h3>reduce (t, f [, state = next(t)])</h3>
+<p>*Aliases: <code>inject</code>, <code>foldl</code>*.</p>
+
+<p>Can sum all values in a table. In case <code>state</code> is not provided, it defaults to the first value in the given table <code>t</code>.</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> add(a,b) <span class="keyword">return</span> a+b <span class="keyword">end</span>
+M.reduce({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>},add) <span class="comment">-- =&gt; 10</span>
+</pre>
+
+
+<p>Or concatenates all values.</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> concat(a,b) <span class="keyword">return</span> a..b <span class="keyword">end</span>
+M.reduce({<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>,<span class="string">'d'</span>},concat) <span class="comment">-- =&gt; abcd   </span>
+</pre>
+
+
+<h3>reduceby (t, f, pred [, state = next(t) [, ...]])</h3>
+
+<p>Reduces a table considering only values matching a predicate.
+For example,let us define a set of values.</p>
+
+
+<pre>
+<span class="keyword">local</span> val = {-<span class="number">1</span>, <span class="number">8</span>, <span class="number">0</span>, -<span class="number">6</span>, <span class="number">3</span>, -<span class="number">1</span>, <span class="number">7</span>, <span class="number">1</span>, -<span class="number">9</span>}
+</pre>
+
+
+<p>And a reduction function which will add up values.</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> add(a,b) <span class="keyword">return</span> a+b <span class="keyword">end</span>
+</pre>
+
+
+<p>We can also define some predicate functions.</p>
+
+
+<pre>
+<span class="comment">-- predicate for negative values
+</span><span class="keyword">local</span> <span class="keyword">function</span> neg(v) <span class="keyword">return</span> v&lt;=<span class="number">0</span> <span class="keyword">end</span>
+
+<span class="comment">-- predicate for positive values
+</span><span class="keyword">local</span> <span class="keyword">function</span> pos(v) <span class="keyword">return</span> v&gt;=<span class="number">0</span> <span class="keyword">end</span>
+</pre>
+
+
+<p>Then we can perform reduction considering only negative or positive values :</p>
+
+
+<pre>
+M.reduceby(val, add, neg) <span class="comment">-- =&gt; -17
+</span>M.reduceby(val, add, pos) <span class="comment">-- =&gt; 19</span>
+</pre>
+
+
+<p>An initial state can be passed in.</p>
+
+
+<pre>
+M.reduceby(val, add, neg, <span class="number">17</span>) <span class="comment">-- =&gt; 0
+</span>M.reduceby(val, add, pos, -<span class="number">19</span>) <span class="comment">-- =&gt; 0</span>
+</pre>
+
+
+<h3>reduceRight (t, f [, state = next(t)])</h3>
+<p>*Aliases: <code>injectr</code>, <code>foldr</code>*.</p>
+
+<p>Similar to <code>M.reduce</code>, but performs from right to left.</p>
+
+
+<pre>
+<span class="keyword">local</span> initial_state = <span class="number">256</span>
+<span class="keyword">local</span> <span class="keyword">function</span> div(a,b) <span class="keyword">return</span> a/b <span class="keyword">end</span>
+M.reduceRight({<span class="number">1</span>,<span class="number">2</span>,<span class="number">4</span>,<span class="number">16</span>},div,initial_state) <span class="comment">-- =&gt; 2</span>
+</pre>
+
+
+<h3>mapReduce (t, f [, state = next(t)])</h3>
+<p>*Aliases: <code>mapr</code>*.</p>
+
+<p>Reduces while saving intermediate states.</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> concat(a,b) <span class="keyword">return</span> a..b <span class="keyword">end</span>
+M.mapReduce({<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>},concat) <span class="comment">-- =&gt; "{'a', 'ab', 'abc'}"</span>
+</pre>
+
+
+<h3>mapReduceRight (t, f [, state = next(t)])</h3>
+<p>*Aliases: <code>maprr</code>*.</p>
+
+<p>Reduces from right to left, while saving intermediate states.</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> concat(a,b) <span class="keyword">return</span> a..b <span class="keyword">end</span>
+M.mapReduceRight({<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>},concat) <span class="comment">-- =&gt; "{'c', 'cb', 'cba'}"</span>
+</pre>
+
+
+<h3>include (t, value)</h3>
+<p>*Aliases: <code>any</code>, <code>some</code>, <code>contains</code>*.</p>
+
+<p>Looks for a value in a table.</p>
+
+
+<pre>
+M.include({<span class="number">6</span>,<span class="number">8</span>,<span class="number">10</span>,<span class="number">16</span>,<span class="number">29</span>},<span class="number">16</span>) <span class="comment">-- =&gt; true
+</span>M.include({<span class="number">6</span>,<span class="number">8</span>,<span class="number">10</span>,<span class="number">16</span>,<span class="number">29</span>},<span class="number">1</span>) <span class="comment">-- =&gt; false
+</span>
+<span class="keyword">local</span> complex_table = {<span class="number">18</span>,{<span class="number">2</span>,{<span class="number">3</span>}}}
+<span class="keyword">local</span> collection = {<span class="number">6</span>,{<span class="number">18</span>,{<span class="number">2</span>,<span class="number">6</span>}},<span class="number">10</span>,{<span class="number">18</span>,{<span class="number">2</span>,{<span class="number">3</span>}}},<span class="number">29</span>}
+M.include(collection, complex_table) <span class="comment">-- =&gt; true</span>
+</pre>
+
+
+<p>Handles iterator functions.</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> isUpper(v) <span class="keyword">return</span> v:upper()== v <span class="keyword">end</span>
+M.include({<span class="string">'a'</span>,<span class="string">'B'</span>,<span class="string">'c'</span>},isUpper) <span class="comment">-- =&gt; true</span>
+</pre>
+
+
+<h3>detect (t, value)</h3>
+
+<p>Returns the index of a value in a table.</p>
+
+
+<pre>
+M.detect({<span class="number">6</span>,<span class="number">8</span>,<span class="number">10</span>,<span class="number">16</span>},<span class="number">8</span>) <span class="comment">-- =&gt; 2
+</span>M.detect({<span class="keyword">nil</span>,<span class="keyword">true</span>,<span class="number">0</span>,<span class="keyword">true</span>,<span class="keyword">true</span>},<span class="keyword">false</span>) <span class="comment">-- =&gt; nil
+</span>
+<span class="keyword">local</span> complex_table = {<span class="number">18</span>,{<span class="number">2</span>,<span class="number">6</span>}}
+<span class="keyword">local</span> collection = {<span class="number">6</span>,{<span class="number">18</span>,{<span class="number">2</span>,<span class="number">6</span>}},<span class="number">10</span>,{<span class="number">18</span>,{<span class="number">2</span>,{<span class="number">3</span>}}},<span class="number">29</span>}
+M.detect(collection, complex_table) <span class="comment">-- =&gt; 2</span>
+</pre>
+
+
+<p>Handles iterator functions.</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> isUpper(v)
+  <span class="keyword">return</span> v:upper()==v
+<span class="keyword">end</span>
+M.detect({<span class="string">'a'</span>,<span class="string">'B'</span>,<span class="string">'c'</span>},isUpper) <span class="comment">-- =&gt; 2</span>
+</pre>
+
+
+<h3>where (t, props)</h3>
+
+<p>Looks through a table and returns all the values that matches all of the key-value pairs listed in <code>props</code>. </p>
+
+
+<pre>
+<span class="keyword">local</span> items = {
+  {height = <span class="number">10</span>, weight = <span class="number">8</span>, price = <span class="number">500</span>},
+  {height = <span class="number">10</span>, weight = <span class="number">15</span>, price = <span class="number">700</span>},
+  {height = <span class="number">15</span>, weight = <span class="number">15</span>, price = <span class="number">3000</span>},
+  {height = <span class="number">10</span>, weight = <span class="number">8</span>, price = <span class="number">3000</span>},
+}
+M.where(items, {height = <span class="number">10</span>}) <span class="comment">-- =&gt; {items[1], items[2], items[4]}
+</span>M.where(items, {weight = <span class="number">15</span>}) <span class="comment">-- =&gt; {items[2], items[3]}
+</span>M.where(items, {prince = <span class="number">3000</span>}) <span class="comment">-- =&gt; {items[3], items[4]}
+</span>M.where(items, {height = <span class="number">10</span>, weight = <span class="number">15</span>, prince = <span class="number">700</span>}) <span class="comment">-- =&gt; {items[2]}</span>
+</pre>
+
+
+<h3>findWhere (t, props)</h3>
+
+<p>Looks through a table and returns the first value found that matches all of the key-value pairs listed in <code>props</code>. </p>
+
+
+<pre>
+<span class="keyword">local</span> a = {a = <span class="number">1</span>, b = <span class="number">2</span>, c = <span class="number">3</span>}
+<span class="keyword">local</span> b = {a = <span class="number">2</span>, b = <span class="number">3</span>, d = <span class="number">4</span>}
+<span class="keyword">local</span> c = {a = <span class="number">3</span>, b = <span class="number">4</span>, e = <span class="number">5</span>}
+M.findWhere({a, b, c}, {a = <span class="number">3</span>, b = <span class="number">4</span>}) == c <span class="comment">-- =&gt; true</span>
+</pre>
+
+
+<h3>select (t, f [, ...])</h3>
+<p>*Aliases: <code>filter</code>*.</p>
+
+<p>Collects values passing a validation test.</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> isEven(v) <span class="keyword">return</span> v%<span class="number">2</span>==<span class="number">0</span> <span class="keyword">end</span>
+<span class="keyword">local</span> <span class="keyword">function</span> isOdd(v) <span class="keyword">return</span> v%<span class="number">2</span>~=<span class="number">0</span> <span class="keyword">end</span>
+
+M.<span class="global">select</span>({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>,<span class="number">7</span>}, isEven) <span class="comment">-- =&gt; "{2,4,6}"
+</span>M.<span class="global">select</span>({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>,<span class="number">7</span>}, isOdd) <span class="comment">-- =&gt; "{1,3,5,7}"</span>
+</pre>
+
+
+<h3>reject (t, f [, ...])</h3>
+<p>*Aliases: <a href="index.html#reject">reject</a>*.</p>
+
+<p>Removes all values failing (returning false or nil) a validation test:</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> isEven(v) <span class="keyword">return</span> v%<span class="number">2</span>==<span class="number">0</span> <span class="keyword">end</span>
+<span class="keyword">local</span> <span class="keyword">function</span> isOdd(v) <span class="keyword">return</span> v%<span class="number">2</span>~=<span class="number">0</span> <span class="keyword">end</span>
+
+M.reject({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>,<span class="number">7</span>}, isEven) <span class="comment">-- =&gt; "{1,3,5,7}"
+</span>M.reject({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>,<span class="number">7</span>}, isOdd) <span class="comment">-- =&gt; "{2,4,6}"</span>
+</pre>
+
+
+<h3>all (t, f [, ...])</h3>
+<p>*Aliases: <code>every</code>*.</p>
+
+<p>Checks whether or not all elements pass a validation test.</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> isEven(v) <span class="keyword">return</span> v%<span class="number">2</span>==<span class="number">0</span> <span class="keyword">end</span>
+M.all({<span class="number">2</span>,<span class="number">4</span>,<span class="number">6</span>}, isEven) <span class="comment">-- =&gt; true</span>
+</pre>
+
+
+<h3>invoke (t, method [, ...])</h3>
+
+<p>Invokes a given function on each value in a table.</p>
+
+
+<pre>
+M.invoke({<span class="string">'a'</span>,<span class="string">'bea'</span>,<span class="string">'cdhza'</span>},<span class="global">string</span>.len) <span class="comment">-- =&gt; "{1,3,5}"</span>
+</pre>
+
+
+<p>Can reference the method of the same name in each value.</p>
+
+
+<pre>
+<span class="keyword">local</span> a, b, c, d = {id = <span class="string">'a'</span>}, {id = <span class="string">'b'</span>}, {id = <span class="string">'c'</span>}, {id = <span class="string">'d'</span>}
+<span class="keyword">local</span> <span class="keyword">function</span> call(self) <span class="keyword">return</span> self.id <span class="keyword">end</span>
+M.invoke({a,b,c,d},call) <span class="comment">-- =&gt; "{'a','b','c','d'}"</span>
+</pre>
+
+
+<h3>pluck (t, property)</h3>
+
+<p>Fetches all values indexed with specific key in a table of objects.</p>
+
+
+<pre>
+<span class="keyword">local</span> peoples = {
+  {name = <span class="string">'John'</span>, age = <span class="number">23</span>},{name = <span class="string">'Peter'</span>, age = <span class="number">17</span>},
+  {name = <span class="string">'Steve'</span>, age = <span class="number">15</span>},{age = <span class="number">33</span>}}
+
+M.pluck(peoples,<span class="string">'age'</span>) <span class="comment">-- =&gt; "{23,17,15,33}"
+</span>M.pluck(peoples,<span class="string">'name'</span>) <span class="comment">-- =&gt; "{'John', 'Peter', 'Steve'}"</span>
+</pre>
+
+
+<h3>max (t [, transform [, ...]])</h3>
+
+<p>Returns the maximum value in a collection.</p>
+
+
+<pre>
+M.max {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>} <span class="comment">-- =&gt; 3
+</span>M.max {<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>} <span class="comment">-- =&gt; 'c'</span>
+</pre>
+
+
+<p>Can take an iterator function to extract a specific property.</p>
+
+
+<pre>
+<span class="keyword">local</span> peoples = {
+  {name = <span class="string">'John'</span>, age = <span class="number">23</span>},{name = <span class="string">'Peter'</span>, age = <span class="number">17</span>},
+  {name = <span class="string">'Steve'</span>, age = <span class="number">15</span>},{age = <span class="number">33</span>}}
+M.max(peoples,<span class="keyword">function</span>(people) <span class="keyword">return</span> people.age <span class="keyword">end</span>) <span class="comment">-- =&gt; 33</span>
+</pre>
+
+
+<h3>min (t [, transform [, ...]])</h3>
+
+<p>Returns the minimum value in a collection.</p>
+
+
+<pre>
+M.min {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>} <span class="comment">-- =&gt; 1
+</span>M.min {<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>} <span class="comment">-- =&gt; 'a'</span>
+</pre>
+
+
+<p>Can take an iterator function to extract a specific property.</p>
+
+
+<pre>
+<span class="keyword">local</span> peoples = {
+  {name = <span class="string">'John'</span>, age = <span class="number">23</span>},{name = <span class="string">'Peter'</span>, age = <span class="number">17</span>},
+  {name = <span class="string">'Steve'</span>, age = <span class="number">15</span>},{age = <span class="number">33</span>}}
+M.min(peoples,<span class="keyword">function</span>(people) <span class="keyword">return</span> people.age <span class="keyword">end</span>) <span class="comment">-- =&gt; 15</span>
+</pre>
+
+
+<h3>same (a, b)</h3>
+
+<p>Tests whether or not all values in each of the passed-in tables exists in both tables.</p>
+
+
+<pre>
+<span class="keyword">local</span> a = {<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>,<span class="string">'d'</span>}
+<span class="keyword">local</span> b = {<span class="string">'b'</span>,<span class="string">'a'</span>,<span class="string">'d'</span>,<span class="string">'c'</span>}
+M.same(a,b) <span class="comment">-- =&gt; true
+</span>
+b[#b+<span class="number">1</span>] = <span class="string">'e'</span>
+M.same(a,b) <span class="comment">-- =&gt; false</span>
+</pre>
+
+
+<h3>sort (t [, comp = math.min])</h3>
+
+<p>Sorts a collection.</p>
+
+
+<pre>
+M.sort({<span class="string">'b'</span>,<span class="string">'a'</span>,<span class="string">'d'</span>,<span class="string">'c'</span>}) <span class="comment">-- =&gt; "{'a','b','c','d'}"</span>
+</pre>
+
+
+<p>Handles custom comparison functions.</p>
+
+
+<pre>
+M.sort({<span class="string">'b'</span>,<span class="string">'a'</span>,<span class="string">'d'</span>,<span class="string">'c'</span>}, <span class="keyword">function</span>(a,b)
+  <span class="keyword">return</span> a:byte() &gt; b:byte()
+<span class="keyword">end</span>) <span class="comment">-- =&gt; "{'d','c','b','a'}"</span>
+</pre>
+
+
+<h3>sortBy (t [, transform [, comp = math.min]])</h3>
+
+<p>Sorts items in a collection based on the result of running a transform function through every item in the collection.</p>
+
+
+<pre>
+<span class="keyword">local</span> r = M.sortBy({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>}, <span class="global">math</span>.sin)
+<span class="global">print</span>(<span class="global">table</span>.concat(r,<span class="string">','</span>))
+
+<span class="comment">-- =&gt; {5,4,3,1,2}</span>
+</pre>
+
+
+<p>The transform function can also be a string name property.</p>
+
+
+<pre>
+<span class="keyword">local</span> people = {
+    {name = <span class="string">'albert'</span>, age = <span class="number">40</span>},
+    {name = <span class="string">'louis'</span>, age = <span class="number">55</span>},
+    {name = <span class="string">'steve'</span>, age = <span class="number">35</span>},
+    {name = <span class="string">'henry'</span>, age = <span class="number">19</span>},
+}
+<span class="keyword">local</span> r = M.sortBy(people, <span class="string">'age'</span>)
+M.each(r, <span class="keyword">function</span>(v) <span class="global">print</span>(v.age, v.name) <span class="keyword">end</span>)
+
+<span class="comment">-- =&gt; 19   henry
+</span><span class="comment">-- =&gt; 35    steve
+</span><span class="comment">-- =&gt; 40    albert
+</span><span class="comment">-- =&gt; 55    louis</span>
+</pre>
+
+
+<p>As seen above, the defaut comparison function is the '&lt;' operator. For example, let us supply a different one to sort the list of people by decreasing age order :</p>
+
+
+<pre>
+<span class="keyword">local</span> people = {
+    {name = <span class="string">'albert'</span>, age = <span class="number">40</span>},
+    {name = <span class="string">'louis'</span>, age = <span class="number">55</span>},
+    {name = <span class="string">'steve'</span>, age = <span class="number">35</span>},
+    {name = <span class="string">'henry'</span>, age = <span class="number">19</span>},
+}
+<span class="keyword">local</span> r = M.sortBy(people, <span class="string">'age'</span>, <span class="keyword">function</span>(a,b) <span class="keyword">return</span> a &gt; b <span class="keyword">end</span>)
+M.each(r, <span class="keyword">function</span>(v) <span class="global">print</span>(v.age, v.name) <span class="keyword">end</span>)
+
+<span class="comment">-- =&gt; 55   louis
+</span><span class="comment">-- =&gt; 40    albert
+</span><span class="comment">-- =&gt; 35    steve
+</span><span class="comment">-- =&gt; 19    henry</span>
+</pre>
+
+
+<p>The <code>transform</code> function defaults to <code>M.indentity</code> and in that case, <code>M.sortBy</code> behaves like <code>M.sort</code>.</p>
+
+
+<pre>
+<span class="keyword">local</span> r = M.sortBy({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>})
+<span class="global">print</span>(<span class="global">table</span>.concat(r,<span class="string">','</span>))
+
+<span class="comment">-- =&gt; {1,2,3,4,5}</span>
+</pre>
+
+
+<h3>groupBy (t, iter [, ...])</h3>
+
+<p>Groups values in a collection depending on their return value when passed to a predicate test.</p>
+
+
+<pre>
+M.groupBy({<span class="number">0</span>,<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>},<span class="keyword">function</span>(v)
+  <span class="keyword">return</span> v%<span class="number">2</span>==<span class="number">0</span> <span class="keyword">and</span> <span class="string">'even'</span> <span class="keyword">or</span> <span class="string">'odd'</span>
+<span class="keyword">end</span>)
+<span class="comment">-- =&gt; "{odd = {1,3,5}, even = {0,2,4,6}}"
+</span>
+M.groupBy({<span class="number">0</span>,<span class="string">'a'</span>,<span class="keyword">true</span>, <span class="keyword">false</span>,<span class="keyword">nil</span>,b,<span class="number">0.5</span>},<span class="global">type</span>)
+<span class="comment">-- =&gt; "{number = {0,0.5}, string = {'a'}, boolean = {true, false}}"        </span>
+</pre>
+
+
+<h3>countBy (t [, iter [, ...]])</h3>
+
+<p>Splits a table in subsets and provide the count for each subset.</p>
+
+
+<pre>
+M.countBy({<span class="number">0</span>,<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>},<span class="keyword">function</span>(v)
+  <span class="keyword">return</span> v%<span class="number">2</span>==<span class="number">0</span> <span class="keyword">and</span> <span class="string">'even'</span> <span class="keyword">or</span> <span class="string">'odd'</span>
+<span class="keyword">end</span>) <span class="comment">-- =&gt; "{odd = 3, even = 4}"</span>
+</pre>
+
+
+<h3>size (...)</h3>
+
+<p>When given a table, provides the count for the very number of values in that table.</p>
+
+
+<pre>
+M.size {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>} <span class="comment">-- =&gt; 3
+</span>M.size {one = <span class="number">1</span>, two = <span class="number">2</span>} <span class="comment">-- =&gt; 2</span>
+</pre>
+
+
+<p>When given a vararg list of arguments, returns the count of these arguments.</p>
+
+
+<pre>
+M.size(<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>) <span class="comment">-- =&gt; 3
+</span>M.size(<span class="string">'a'</span>,<span class="string">'b'</span>,{}, <span class="keyword">function</span>() <span class="keyword">end</span>) <span class="comment">-- =&gt; 4</span>
+</pre>
+
+
+<h3>containsKeys (t, other)</h3>
+
+<p>Checks whether a table has all the keys existing in another table.</p>
+
+
+<pre>
+M.contains({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>},{<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>}) <span class="comment">-- =&gt; true
+</span>M.contains({<span class="number">1</span>,<span class="number">2</span>,<span class="string">'d'</span>,<span class="string">'b'</span>},{<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">5</span>}) <span class="comment">-- =&gt; true
+</span>M.contains({x = <span class="number">1</span>, y = <span class="number">2</span>, z = <span class="number">3</span>},{x = <span class="number">1</span>, y = <span class="number">2</span>}) <span class="comment">-- =&gt; true</span>
+</pre>
+
+
+<h3>sameKeys (tA, tB)</h3>
+
+<p>Checks whether both tables features the same keys:</p>
+
+
+<pre>
+M.sameKeys({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>},{<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>}) <span class="comment">-- =&gt; false
+</span>M.sameKeys({<span class="number">1</span>,<span class="number">2</span>,<span class="string">'d'</span>,<span class="string">'b'</span>},{<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">5</span>}) <span class="comment">-- =&gt; true
+</span>M.sameKeys({x = <span class="number">1</span>, y = <span class="number">2</span>, z = <span class="number">3</span>},{x = <span class="number">1</span>, y = <span class="number">2</span>}) <span class="comment">-- =&gt; false</span>
+</pre>
+
+
+<p><strong><a href="#TOC">[⬆]</a></strong></p>
+
+<p><a name="_a_name__array__Array_functions__a_"></a></p>
+<h2><a name='array'>Array functions</a></h2>
+
+<h3>sample (array [, n = 1 [, seed]])</h3>
+
+<p>Samples <code>n</code> values from array.</p>
+
+
+<pre>
+<span class="keyword">local</span> array = M.range(<span class="number">1</span>,<span class="number">20</span>)
+<span class="keyword">local</span> sample = M.sample(array, <span class="number">3</span>)
+<span class="global">print</span>(<span class="global">table</span>.concat(sample,<span class="string">','</span>))
+
+<span class="comment">-- =&gt; {12,11,15}</span>
+</pre>
+
+
+<p><code>n</code> defaults to 1. In that case, a single value will be returned.</p>
+
+
+<pre>
+<span class="keyword">local</span> array = M.range(<span class="number">1</span>,<span class="number">20</span>)
+<span class="keyword">local</span> sample = M.sample(array)
+<span class="global">print</span>(sample)
+
+<span class="comment">-- =&gt; 12</span>
+</pre>
+
+
+<p>An optional 3rd argument <code>seed</code> can be passed for deterministic random sampling.</p>
+
+<h3>sampleProb (array, prob [, seed])</h3>
+
+<p>Returns an array of values randomly selected from a given array.
+In case <code>seed</code> is provided, it is used for deterministic sampling.</p>
+
+
+<pre>
+<span class="keyword">local</span> array = M.range(<span class="number">1</span>,<span class="number">20</span>)
+<span class="keyword">local</span> sample = M.sampleProb(array, <span class="number">0.2</span>)
+<span class="global">print</span>(<span class="global">table</span>.concat(sample,<span class="string">','</span>))
+
+<span class="comment">-- =&gt; 5,11,12,15
+</span>
+sample = M.sampleProb(array, <span class="number">0.2</span>, <span class="global">os</span>.time())
+<span class="global">print</span>(<span class="global">table</span>.concat(sample,<span class="string">','</span>))
+
+<span class="comment">-- =&gt; 1,6,10,12,15,20 (or similar)</span>
+</pre>
+
+
+<h3>shuffle (array [, seed])</h3>
+
+<p>Shuffles a given array.</p>
+
+
+<pre>
+<span class="keyword">local</span> list = M.shuffle {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>} <span class="comment">-- =&gt; "{3,2,6,4,1,5}"
+</span>M.each(list,<span class="global">print</span>)
+</pre>
+
+
+<h3>toArray (...)</h3>
+
+<p>Converts a vararg list of arguments to an array.</p>
+
+
+<pre>
+M.toArray(<span class="number">1</span>,<span class="number">2</span>,<span class="number">8</span>,<span class="string">'d'</span>,<span class="string">'a'</span>,<span class="number">0</span>) <span class="comment">-- =&gt; "{1,2,8,'d','a',0}"</span>
+</pre>
+
+
+<h3>find (array, value [, from = 1])</h3>
+
+<p>Looks for a value in a given array and returns the position of the first occurence.</p>
+
+
+<pre>
+<span class="keyword">local</span> value = {<span class="number">3</span>}
+M.find({{<span class="number">4</span>},{<span class="number">3</span>},{<span class="number">2</span>},{<span class="number">1</span>}},value) <span class="comment">-- =&gt; 2</span>
+</pre>
+
+
+<p>It can also start the search at a specific position in the array:</p>
+
+
+<pre>
+<span class="comment">-- search value 4 starting from index 3
+</span>M.find({<span class="number">1</span>,<span class="number">4</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>},<span class="number">4</span>,<span class="number">3</span>) <span class="comment">-- =&gt; 5</span>
+</pre>
+
+
+<h3>reverse (array)</h3>
+
+<p>Reverses an array.</p>
+
+
+<pre>
+M.reverse({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="string">'d'</span>}) <span class="comment">-- =&gt; "{'d',3,2,1}"</span>
+</pre>
+
+
+<h3>fill (array, value [, i = 1 [, j = #array]])</h3>
+
+<p>Replaces all elements in a given array with a given value.</p>
+
+
+<pre>
+<span class="keyword">local</span> array = M.range(<span class="number">1</span>,<span class="number">5</span>)
+M.fill(array, <span class="number">0</span>) <span class="comment">-- =&gt; {0,0,0,0,0}</span>
+</pre>
+
+
+<p>It can start replacing value at a specific index.</p>
+
+
+<pre>
+<span class="keyword">local</span> array = M.range(<span class="number">1</span>,<span class="number">5</span>)
+M.fill(array,<span class="number">0</span>,<span class="number">3</span>) <span class="comment">-- =&gt; {1,2,0,0,0}</span>
+</pre>
+
+
+<p>It can replace only values within a specific range.</p>
+
+
+<pre>
+<span class="keyword">local</span> array = M.range(<span class="number">1</span>,<span class="number">5</span>)
+M.fill(array,<span class="number">0</span>,<span class="number">2</span>,<span class="number">4</span>) <span class="comment">-- =&gt; {1,0,0,0,5}</span>
+</pre>
+
+
+<p>In case the upper bound index i greather than the array size, it will enlarge the array.</p>
+
+
+<pre>
+<span class="keyword">local</span> array = M.range(<span class="number">1</span>,<span class="number">5</span>)
+M.fill(array,<span class="number">0</span>,<span class="number">5</span>,<span class="number">10</span>) <span class="comment">-- =&gt; {1,2,3,4,0,0,0,0,0,0}</span>
+</pre>
+
+
+<h3>zeros (n)</h3>
+
+<p>Returns an array of <code>n</code> zeros.</p>
+
+
+<pre>
+M.zeros(<span class="number">4</span>) <span class="comment">-- =&gt; {0,0,0,0}</span>
+</pre>
+
+
+<h3>ones (n)</h3>
+
+<p>Returns an array of <code>n</code> 1's.</p>
+
+
+<pre>
+M.ones(<span class="number">3</span>) <span class="comment">-- =&gt; {1,1,1}</span>
+</pre>
+
+
+<h3>vector (value, n)</h3>
+
+<p>Returns an array of <code>n</code> times a given value.</p>
+
+
+<pre>
+M.vector(<span class="number">10</span>, <span class="number">4</span>) <span class="comment">-- =&gt; {10,10,10,10}</span>
+</pre>
+
+
+<h3>selectWhile (array, f [, ...])</h3>
+<p>*Aliases: <code>takeWhile</code>*.</p>
+
+<p>Collects values as long as they pass a given test. Stops on the first non-passing test.</p>
+
+
+<pre>
+M.selectWhile({<span class="number">2</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">8</span>}, <span class="keyword">function</span>(v)
+  <span class="keyword">return</span> v%<span class="number">2</span>==<span class="number">0</span>
+<span class="keyword">end</span>) <span class="comment">-- =&gt; "{2,4}"</span>
+</pre>
+
+
+<h3>dropWhile (array, f [, ...])</h3>
+<p>*Aliases: <code>rejectWhile</code>*.</p>
+
+<p>Removes values as long as they pass a given test. Stops on the first non-passing test.</p>
+
+
+<pre>
+M.dropWhile({<span class="number">2</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">8</span>}, <span class="keyword">function</span>(v)
+  <span class="keyword">return</span> v%<span class="number">2</span>==<span class="number">0</span>
+<span class="keyword">end</span>) <span class="comment">-- =&gt; "{5,8}"</span>
+</pre>
+
+
+<h3>sortedIndex (array, value [, comp = math.min [, sort = nil]])</h3>
+
+<p>Returns the index at which a value should be inserted to preserve order.</p>
+
+
+<pre>
+M.sortedIndex({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>},<span class="number">4</span>) <span class="comment">-- =&gt; 4</span>
+</pre>
+
+
+<p>Can take a custom comparison functions.</p>
+
+
+<pre>
+<span class="keyword">local</span> comp = <span class="keyword">function</span>(a,b) <span class="keyword">return</span> a&lt;b <span class="keyword">end</span>
+M.sortedIndex({-<span class="number">5</span>,<span class="number">0</span>,<span class="number">4</span>,<span class="number">4</span>},<span class="number">3</span>,comp) <span class="comment">-- =&gt; 3</span>
+</pre>
+
+
+<h3>indexOf (array, value)</h3>
+
+<p>Returns the index of a value in an array.</p>
+
+
+<pre>
+M.indexOf({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>},<span class="number">2</span>) <span class="comment">-- =&gt; 2</span>
+</pre>
+
+
+<h3>lastIndexOf (array, value)</h3>
+
+<p>Returns the index of the last occurence of a given value in an array.</p>
+
+
+<pre>
+M.lastIndexOf({<span class="number">1</span>,<span class="number">2</span>,<span class="number">2</span>,<span class="number">3</span>},<span class="number">2</span>) <span class="comment">-- =&gt; 3</span>
+</pre>
+
+
+<h3>findIndex (array, predicate [, ...])</h3>
+
+<p>Returns the first index at which a predicate passes a truth test.</p>
+
+
+<pre>
+<span class="keyword">local</span> array = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>}
+<span class="keyword">local</span> <span class="keyword">function</span> multipleOf3(v) <span class="keyword">return</span> v%<span class="number">3</span>==<span class="number">0</span> <span class="keyword">end</span>
+M.findIndex(array, multipleOf3) <span class="comment">-- =&gt; 3</span>
+</pre>
+
+
+<h3>findLastIndex (array, predicate [, ...])</h3>
+
+<p>Returns the last index at which a predicate passes a truthy test.</p>
+
+
+<pre>
+<span class="keyword">local</span> array = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>}
+<span class="keyword">local</span> <span class="keyword">function</span> multipleOf3(v) <span class="keyword">return</span> v%<span class="number">3</span>==<span class="number">0</span> <span class="keyword">end</span>
+M.findLastIndex(array, multipleOf3) <span class="comment">-- =&gt; 6</span>
+</pre>
+
+
+<h3>addTop (array, ...)</h3>
+
+<p>Adds given values at the top of an array. The latter values bubbles at the top.</p>
+
+
+<pre>
+<span class="keyword">local</span> array = {<span class="number">1</span>}
+M.addTop(array,<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>) <span class="comment">-- =&gt; "{4,3,2,1,1}"</span>
+</pre>
+
+
+<h3>prepend (array, ...)</h3>
+
+<p>Adds given values at the top of an array, preserving the order at which elements are passed-in.</p>
+
+
+<pre>
+<span class="keyword">local</span> array = {<span class="string">'old_val'</span>}
+M.prepend(array,<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>) <span class="comment">-- =&gt; "{1,2,3,4,'old_val'}"</span>
+</pre>
+
+
+<h3>push (array, ...)</h3>
+
+<p>Adds given values at the end of an array.</p>
+
+
+<pre>
+<span class="keyword">local</span> array = {<span class="number">1</span>}
+M.push(array,<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>) <span class="comment">-- =&gt; "{1,1,2,3,4}"</span>
+</pre>
+
+
+<h3>shift (array [, n = 1])</h3>
+<p>*Aliases: <code>pop</code>*.</p>
+
+<p>Removes and returns the first value in an array.</p>
+
+
+<pre>
+<span class="keyword">local</span> array = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>}
+<span class="keyword">local</span> shift = M.shift(array) <span class="comment">-- =&gt; "shift = 1", "array = {2,3}"</span>
+</pre>
+
+<p>If <code>n</code> is supplied, returns <code>n</code> values.</p>
+
+
+<pre>
+<span class="keyword">local</span> array = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>}
+<span class="keyword">local</span> a, b = M.shift(array, <span class="number">2</span>) <span class="comment">-- =&gt; "a = 1, b = 2", "array = {3,4,5}"</span>
+</pre>
+
+
+<h3>unshift (array [, n = 1])</h3>
+
+<p>Removes and returns the last value in an array.</p>
+
+
+<pre>
+<span class="keyword">local</span> array = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>}
+<span class="keyword">local</span> value = M.unshift(array) <span class="comment">-- =&gt; "value = 3", "array = {1,2}"</span>
+</pre>
+
+
+<h3>pull (array, ...)</h3>
+<p>*Aliases: <code>remove</code>*.</p>
+
+<p>Removes all provided values from a given array.</p>
+
+
+<pre>
+M.pull({<span class="number">1</span>,<span class="number">2</span>,<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">3</span>},<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>) <span class="comment">-- =&gt; "{4}"</span>
+</pre>
+
+
+<h3>removeRange (array [, start = 1 [, finish = #array]])</h3>
+<p>*Aliases: <code>rmRange</code>, <code>M.chop</code>*.</p>
+
+<p>Trims out all values index within a range.</p>
+
+
+<pre>
+<span class="keyword">local</span> array = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>,<span class="number">7</span>,<span class="number">8</span>,<span class="number">9</span>}
+M.removeRange(array, <span class="number">3</span>,<span class="number">8</span>) <span class="comment">-- =&gt; "{1,2,9}"</span>
+</pre>
+
+
+<h3>chunk (array, f [, ...])</h3>
+
+<p>Iterates over an array aggregating consecutive values in subsets tables, on the basis of the return value of <code>f(v, k, ...)</code>. Consecutive elements which return the same value are chunked together.</p>
+
+
+<pre>
+<span class="keyword">local</span> t = {<span class="number">1</span>,<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">3</span>,<span class="number">4</span>}
+M.chunk(t, <span class="keyword">function</span>(v) <span class="keyword">return</span> v%<span class="number">2</span>==<span class="number">0</span> <span class="keyword">end</span>) <span class="comment">-- =&gt; "{{1,1},{2},{3,3},{4}}"</span>
+</pre>
+
+
+<h3>slice (array [, start = 1 [, finish = #array]])</h3>
+<p>*Aliases: <a href="index.html#operator.sub">sub</a>*.</p>
+
+<p>Slices and returns a part of an array.</p>
+
+
+<pre>
+<span class="keyword">local</span> array = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>,<span class="number">7</span>,<span class="number">8</span>,<span class="number">9</span>}
+M.slice(array, <span class="number">3</span>,<span class="number">6</span>) <span class="comment">-- =&gt; "{3,4,5,6}"</span>
+</pre>
+
+
+<h3>first (array [, n = 1])</h3>
+<p>*Aliases: <code>head</code>, <code>M.take</code>*.</p>
+
+<p>Returns the first N elements in an array.</p>
+
+
+<pre>
+<span class="keyword">local</span> array = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>,<span class="number">7</span>,<span class="number">8</span>,<span class="number">9</span>}
+M.first(array,<span class="number">3</span>) <span class="comment">-- =&gt; "{1,2,3}"</span>
+</pre>
+
+
+<h3>initial (array [, n = #array])</h3>
+
+<p>Excludes the last N elements in an array.</p>
+
+
+<pre>
+<span class="keyword">local</span> array = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>,<span class="number">7</span>,<span class="number">8</span>,<span class="number">9</span>}
+M.initial(array,<span class="number">5</span>) <span class="comment">-- =&gt; "{1,2,3,4}"</span>
+</pre>
+
+
+<h3>last (array [, n = #array])</h3>
+<p>*Aliases: <code>skip</code>*.</p>
+
+<p>Returns the last N elements in an array.</p>
+
+
+<pre>
+<span class="keyword">local</span> array = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>,<span class="number">7</span>,<span class="number">8</span>,<span class="number">9</span>}
+M.last(array,<span class="number">3</span>) <span class="comment">-- =&gt; "{7,8,9}"</span>
+</pre>
+
+
+<h3>rest (array [, index = 1])</h3>
+<p>*Aliases: <code>tail</code>*.</p>
+
+<p>Returns all values after <em>index</em>, including the given <em>index</em> itself.</p>
+
+
+<pre>
+<span class="keyword">local</span> array = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>,<span class="number">7</span>,<span class="number">8</span>,<span class="number">9</span>}
+M.rest(array,<span class="number">6</span>) <span class="comment">-- =&gt; "{6,7,8,9}"</span>
+</pre>
+
+
+<h3>nth (array, index)</h3>
+
+<p>Returns the value at <em>index</em>.</p>
+
+
+<pre>
+<span class="keyword">local</span> array = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>}
+M.nth(array,<span class="number">3</span>) <span class="comment">-- =&gt; "3"</span>
+</pre>
+
+
+<h3>compact (array)</h3>
+
+<p>Trims out all falsy values.</p>
+
+
+<pre>
+M.compact {a,<span class="string">'aa'</span>,<span class="keyword">false</span>,<span class="string">'bb'</span>,<span class="keyword">true</span>} <span class="comment">-- =&gt; "{'aa','bb',true}"</span>
+</pre>
+
+
+<h3>flatten (array [, shallow = false])</h3>
+
+<p>Flattens a nested array.</p>
+
+
+<pre>
+M.flatten({<span class="number">1</span>,{<span class="number">2</span>,<span class="number">3</span>},{<span class="number">4</span>,<span class="number">5</span>,{<span class="number">6</span>,<span class="number">7</span>}}}) <span class="comment">-- =&gt; "{1,2,3,4,5,6,7}"</span>
+</pre>
+
+
+<p>When given arg <code>shallow</code>, flatten only at the first level.</p>
+
+
+<pre>
+M.flatten({<span class="number">1</span>,{<span class="number">2</span>},{{<span class="number">3</span>}}},<span class="keyword">true</span>) <span class="comment">-- =&gt; "{1,{2},{{3}}}"</span>
+</pre>
+
+
+<h3>difference (array, array2)</h3>
+<p>*Aliases: <code>without</code>, <code>diff</code>*.</p>
+
+<p>Returns values in the given array not present in a second array.</p>
+
+
+<pre>
+<span class="keyword">local</span> array = {<span class="number">1</span>,<span class="number">2</span>,<span class="string">'a'</span>,<span class="number">4</span>,<span class="number">5</span>}
+M.difference(array,{<span class="number">1</span>,<span class="string">'a'</span>}) <span class="comment">-- =&gt; "{2,4,5}"</span>
+</pre>
+
+
+<h3>union (...)</h3>
+
+<p>Produces a duplicate-free union of all passed-in arrays.</p>
+
+
+<pre>
+<span class="keyword">local</span> A = {<span class="string">'a'</span>}
+<span class="keyword">local</span> B = {<span class="string">'a'</span>,<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>}
+<span class="keyword">local</span> C = {<span class="number">2</span>,<span class="number">10</span>}
+M.union(A,B,C) <span class="comment">-- =&gt; "{'a',1,2,3,10}"</span>
+</pre>
+
+
+<h3>intersection (array, ...)</h3>
+
+<p>Returns the intersection (common-part) of all passed-in arrays:</p>
+
+
+<pre>
+<span class="keyword">local</span> A = {<span class="string">'a'</span>}
+<span class="keyword">local</span> B = {<span class="string">'a'</span>,<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>}
+<span class="keyword">local</span> C = {<span class="number">2</span>,<span class="number">10</span>,<span class="number">1</span>,<span class="string">'a'</span>}
+M.intersection(A,B,C) <span class="comment">-- =&gt; "{'a',2,1}"</span>
+</pre>
+
+
+<h3>symmetricDifference (array, array2)</h3>
+<p>*Aliases: <code>symdiff</code>,<code>xor</code>*.</p>
+
+<p>Returns values in the first array not present in the second and also values in the second array not present in the first one.</p>
+
+
+<pre>
+<span class="keyword">local</span> array = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>}
+<span class="keyword">local</span> array2 = {<span class="number">1</span>,<span class="number">4</span>,<span class="number">5</span>}
+M.symmetricDifference(array, array2) <span class="comment">-- =&gt; "{2,3,4,5}"</span>
+</pre>
+
+
+<h3>unique (array)</h3>
+<p>*Aliases: <code>uniq</code>*.</p>
+
+<p>Makes an array duplicate-free.</p>
+
+
+<pre>
+M.unique {<span class="number">1</span>,<span class="number">1</span>,<span class="number">2</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">4</span>,<span class="number">4</span>,<span class="number">5</span>} <span class="comment">-- =&gt; "{1,2,3,4,5}"</span>
+</pre>
+
+
+<h3>isunique (array)</h3>
+<p>*Aliases: <code>isuniq</code>*.</p>
+
+<p>Checks if a given array contains no duplicate value.</p>
+
+
+<pre>
+M.isunique({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>}) <span class="comment">-- =&gt; true
+</span>M.isunique({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">4</span>}) <span class="comment">-- =&gt; false</span>
+</pre>
+
+
+<h3>zip (...)</h3>
+<p>*Aliases: <code>transpose</code>*.</p>
+
+<p>Zips values from different arrays, on the basis on their common keys.</p>
+
+
+<pre>
+<span class="keyword">local</span> names = {<span class="string">'Bob'</span>,<span class="string">'Alice'</span>,<span class="string">'James'</span>}
+<span class="keyword">local</span> ages = {<span class="number">22</span>, <span class="number">23</span>}
+M.zip(names,ages) <span class="comment">-- =&gt; "{{'Bob',22},{'Alice',23},{'James'}}"</span>
+</pre>
+
+
+<h3>zipWith (f, ...)</h3>
+<p>*Aliases: <code>transposeWith</code>*.</p>
+
+<p>Merges values using a given function. Only values indexed with the same key in the given arrays are merged in the same subset.
+Function <code>f</code> is used to combine values.</p>
+
+
+<pre>
+<span class="keyword">local</span> names = {<span class="string">'Bob'</span>,<span class="string">'Alice'</span>,<span class="string">'James'</span>}; <span class="keyword">local</span> ages = {<span class="number">22</span>, <span class="number">23</span>, <span class="number">25</span>}
+<span class="keyword">local</span> <span class="keyword">function</span> introduce(name, age) <span class="keyword">return</span> <span class="string">'I am '</span>..name..<span class="string">' and I am '</span>..age..<span class="string">' years old.'</span> <span class="keyword">end</span>
+<span class="keyword">local</span> t = M.zipWith(introduce,names,ages)
+<span class="comment">-- =&gt; {
+</span><span class="comment">-- =&gt;  'I am Bob and I am 22 years old.'
+</span><span class="comment">-- =&gt;  'I am Alice and I am 23 years old.'
+</span><span class="comment">-- =&gt;  'I am James and I am 25 years old.'
+</span><span class="comment">-- =&gt; }</span>
+</pre>
+
+
+<h3>append (array, other)</h3>
+
+<p>Appends two arrays.</p>
+
+
+<pre>
+M.append({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>},{<span class="string">'a'</span>,<span class="string">'b'</span>}) <span class="comment">-- =&gt; "{1,2,3,'a','b'}"</span>
+</pre>
+
+
+<h3>interleave (...)</h3>
+
+<p>Interleaves values from passed-in arrays.</p>
+
+
+<pre>
+t1 = {<span class="number">1</span>, <span class="number">2</span>, <span class="number">3</span>}
+t2 = {<span class="string">'a'</span>, <span class="string">'b'</span>, <span class="string">'c'</span>}
+M.interleave(t1, t2) <span class="comment">-- =&gt; "{1,'a',2,'b',3,'c'}"</span>
+</pre>
+
+
+<h3>interpose (array, value)</h3>
+<p>*Aliases: <code>intersperce</code>*.</p>
+
+<p>Interposes a value between consecutive values in an arrays.</p>
+
+
+<pre>
+M.interleave(<span class="string">'a'</span>, {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>}) <span class="comment">-- =&gt; "{1,'a',2,'a',3}"</span>
+</pre>
+
+
+<h3>range ([from [, to [, step]]])</h3>
+
+<p>Generates an arithmetic sequence.</p>
+
+
+<pre>
+M.range(<span class="number">1</span>,<span class="number">4</span>) <span class="comment">-- =&gt; "{1,2,3,4}"</span>
+</pre>
+
+
+<p>In case a single value is provided, it generates a sequence from 1 to that value.</p>
+
+
+<pre>
+M.range(<span class="number">3</span>) <span class="comment">-- =&gt; "{1,2,3}"</span>
+</pre>
+
+
+<p>The incremental step can also be provided as third argument.</p>
+
+
+<pre>
+M.range(<span class="number">0</span>,<span class="number">2</span>,<span class="number">0.7</span>) <span class="comment">-- =&gt; "{0,0.7,1.4}"</span>
+</pre>
+
+
+<p>It also handles negative progressions.</p>
+
+
+<pre>
+M.range(-<span class="number">5</span>) <span class="comment">-- =&gt; "{-1,-2,-3,-4,-5}"
+</span>M.range(<span class="number">5</span>,<span class="number">1</span>) <span class="comment">-- =&gt; "{5,4,3,2,1}"</span>
+</pre>
+
+
+<h3>rep (value, n)</h3>
+
+<p>Generates a list of n repetitions of a value.</p>
+
+
+<pre>
+M.rep(<span class="number">4</span>,<span class="number">3</span>) <span class="comment">-- =&gt; "{4,4,4}"</span>
+</pre>
+
+
+<h3>powerset (array)</h3>
+
+<p>Returns the powerset of an array.</p>
+
+
+<pre>
+M.powerset {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>} <span class="comment">-- =&gt; "{{1},{2},{3},{1,2},{2,3},{1,2,3}}"</span>
+</pre>
+
+
+<h3>partition (array [, n = 1 [, pad]])</h3>
+<p>*Aliases: <code>part</code>*.</p>
+
+<p>Returns an iterator function for partitions of a given array.</p>
+
+
+<pre>
+<span class="keyword">local</span> t = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>}
+<span class="keyword">for</span> p <span class="keyword">in</span> M.partition(t,<span class="number">2</span>) <span class="keyword">do</span>
+  <span class="global">print</span>(<span class="global">table</span>.concat(p, <span class="string">','</span>))
+<span class="keyword">end</span>
+
+<span class="comment">-- =&gt; 1,2
+</span><span class="comment">-- =&gt; 3,4
+</span><span class="comment">-- =&gt; 5,6
+</span>
+<span class="keyword">local</span> t = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>}
+<span class="keyword">for</span> p <span class="keyword">in</span> M.partition(t,<span class="number">4</span>) <span class="keyword">do</span>
+  <span class="global">print</span>(<span class="global">table</span>.concat(p, <span class="string">','</span>))
+<span class="keyword">end</span>
+
+<span class="comment">-- =&gt; 1,2,3,4
+</span><span class="comment">-- =&gt; 5,6</span>
+</pre>
+
+
+<p>In case the last partition has less elements than desired, a 3rd argument can be supplied to adjust the partition size.</p>
+
+
+<pre>
+<span class="keyword">local</span> t = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>}
+<span class="keyword">for</span> p <span class="keyword">in</span> M.partition(t,<span class="number">4</span>,<span class="number">0</span>) <span class="keyword">do</span>
+  <span class="global">print</span>(<span class="global">table</span>.concat(p, <span class="string">','</span>))
+<span class="keyword">end</span>
+
+<span class="comment">-- =&gt; 1,2,3,4
+</span><span class="comment">-- =&gt; 5,6,0,0</span>
+</pre>
+
+
+<h3>overlapping (array [, n = 2 [, pad]])</h3>
+
+<p>Returns an iterator function which provides overlapping subsequences of a given array.</p>
+
+
+<pre>
+<span class="keyword">local</span> t = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>,<span class="number">7</span>}
+<span class="keyword">for</span> p <span class="keyword">in</span> M.overlapping(t,<span class="number">3</span>) <span class="keyword">do</span>
+    <span class="global">print</span>(<span class="global">table</span>.concat(p,<span class="string">','</span>))
+<span class="keyword">end</span>
+
+<span class="comment">-- =&gt; 1,2,3
+</span><span class="comment">-- =&gt; 3,4,5
+</span><span class="comment">-- =&gt; 5,6,7
+</span>
+<span class="keyword">for</span> p <span class="keyword">in</span> M.overlapping(t,<span class="number">4</span>) <span class="keyword">do</span>
+    <span class="global">print</span>(<span class="global">table</span>.concat(p,<span class="string">','</span>))
+<span class="keyword">end</span>
+
+<span class="comment">-- =&gt; 1,2,3,4
+</span><span class="comment">-- =&gt; 4,5,6,7
+</span>
+<span class="keyword">for</span> p <span class="keyword">in</span> M.overlapping(t,<span class="number">5</span>) <span class="keyword">do</span>
+    <span class="global">print</span>(<span class="global">table</span>.concat(p,<span class="string">','</span>))
+<span class="keyword">end</span>
+
+<span class="comment">-- =&gt; 1,2,3,4,5
+</span><span class="comment">-- =&gt; 5,6,7</span>
+</pre>
+
+
+<p>In case the last subsequence wil not match the exact desired length, it can be adjusted with a 3rd argument <code>pad</code>.</p>
+
+
+<pre>
+<span class="keyword">local</span> t = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>,<span class="number">7</span>}
+<span class="keyword">for</span> p <span class="keyword">in</span> M.overlapping(t,<span class="number">5</span>,<span class="number">0</span>) <span class="keyword">do</span>
+    <span class="global">print</span>(<span class="global">table</span>.concat(p,<span class="string">','</span>))
+<span class="keyword">end</span>
+
+<span class="comment">-- =&gt; 1,2,3,4,5
+</span><span class="comment">-- =&gt; 5,6,7,0,0</span>
+</pre>
+
+
+<h3>aperture (array [, n = 2])</h3>
+<p>*Aliases: <code>sliding</code>*.</p>
+
+<p>Returns an iterator function which provides sliding partitions of a given array.</p>
+
+
+<pre>
+<span class="keyword">local</span> t = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>}
+<span class="keyword">for</span> p <span class="keyword">in</span> M.aperture(t,<span class="number">4</span>) <span class="keyword">do</span>
+  <span class="global">print</span>(<span class="global">table</span>.concat(p,<span class="string">','</span>))
+<span class="keyword">end</span>
+
+<span class="comment">-- =&gt; 1,2,3,4
+</span><span class="comment">-- =&gt; 2,3,4,5
+</span>
+<span class="keyword">for</span> p <span class="keyword">in</span> M.aperture(t,<span class="number">3</span>) <span class="keyword">do</span>
+  <span class="global">print</span>(<span class="global">table</span>.concat(p,<span class="string">','</span>))
+<span class="keyword">end</span>
+
+<span class="comment">-- =&gt; 1,2,3
+</span><span class="comment">-- =&gt; 2,3,4
+</span><span class="comment">-- =&gt; 3,4,5</span>
+</pre>
+
+
+<h3>pairwise (array)</h3>
+
+<p>Iterator returning sliding pairs of an array.</p>
+
+
+<pre>
+<span class="keyword">local</span> t = M.range(<span class="number">5</span>)
+<span class="keyword">for</span> p <span class="keyword">in</span> pairwise(t) <span class="keyword">do</span>
+  <span class="global">print</span>(<span class="global">table</span>.concat(p,<span class="string">','</span>))
+<span class="keyword">end</span>
+
+<span class="comment">-- =&gt; 1,2
+</span><span class="comment">-- =&gt; 2,3
+</span><span class="comment">-- =&gt; 3,4
+</span><span class="comment">-- =&gt; 4,5</span>
+</pre>
+
+
+<h3>permutation (array)</h3>
+<p>*Aliases: <code>perm</code>*.</p>
+
+<p>Returns an iterator function for permutations of a given array.</p>
+
+
+<pre>
+t = {<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>}
+<span class="keyword">for</span> p <span class="keyword">in</span> M.permutation(t) <span class="keyword">do</span>
+  <span class="global">print</span>(<span class="global">table</span>.concat(p))
+<span class="keyword">end</span>
+
+<span class="comment">-- =&gt; 'bca'
+</span><span class="comment">-- =&gt; 'cba'
+</span><span class="comment">-- =&gt; 'cab'
+</span><span class="comment">-- =&gt; 'acb'
+</span><span class="comment">-- =&gt; 'bac'
+</span><span class="comment">-- =&gt; 'abc'</span>
+</pre>
+
+
+<h3>invert (array)</h3>
+<p>*Aliases: <code>mirror</code>*.</p>
+
+<p>Switches <tt>key-value</tt> pairs:</p>
+
+
+<pre>
+M.invert {<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>} <span class="comment">-- =&gt; "{a=1, b=2, c=3}"</span>
+</pre>
+
+
+<h3>concat (array [, sep = '' [, i = 1 [, j = #array]]])</h3>
+<p>*Aliases: <code>join</code>*.</p>
+
+<p>Concatenates a given array values:</p>
+
+
+<pre>
+M.concat({<span class="string">'a'</span>,<span class="number">1</span>,<span class="number">0</span>,<span class="number">1</span>,<span class="string">'b'</span>}) <span class="comment">-- =&gt; 'a101b'</span>
+</pre>
+
+
+<h3>xprod (array, array2)</h3>
+
+<p>Returns all possible pairs built from given arrays.</p>
+
+
+<pre>
+<span class="keyword">local</span> t = M.xprod({<span class="number">1</span>,<span class="number">2</span>},{<span class="string">'a'</span>,<span class="string">'b'</span>})
+<span class="comment">-- =&gt; {{1,'a'},{1,'b'},{2,'a'},{2,'b'}}</span>
+</pre>
+
+
+<h3>sum (array)</h3>
+
+<p>Returns the sum of array values.</p>
+
+
+<pre>
+M.sum({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>}) <span class="comment">-- =&gt; 15</span>
+</pre>
+
+
+<h3>product (array)</h3>
+
+<p>Returns the product of array values.</p>
+
+
+<pre>
+M.product({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>}) <span class="comment">-- =&gt; 120</span>
+</pre>
+
+
+<h3>mean (array)</h3>
+
+<p>Returns the mean of array values.</p>
+
+
+<pre>
+M.mean({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>}) <span class="comment">-- =&gt; 3</span>
+</pre>
+
+
+<h3>median (array)</h3>
+
+<p>Returns the median of array values.</p>
+
+
+<pre>
+M.median({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>}) <span class="comment">-- =&gt; 3
+</span>M.median({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>}) <span class="comment">-- =&gt; 2.5</span>
+</pre>
+
+
+<p><strong><a href="#TOC">[⬆]</a></strong></p>
+
+<p><a name="_a_name__utility__Utility_functions__a_"></a></p>
+<h2><a name='utility'>Utility functions</a></h2>
+
+<h3>noop ()</h3>
+
+<p>The no-operation function. Takes nothing, returns nothing. It is being used internally.</p>
+
+
+<pre>
+M.noop() <span class="comment">-- =&gt; nil</span>
+</pre>
+
+
+<h3>identity (value)</h3>
+
+<p>Returns the passed-in value. <br/>
+This function is internally used as a default transformation function.</p>
+
+
+<pre>
+M.identity(<span class="number">1</span>)<span class="comment">-- =&gt; 1
+</span>M.identity(<span class="keyword">false</span>) <span class="comment">-- =&gt; false
+</span>M.identity(<span class="string">'hello!'</span>) <span class="comment">-- =&gt; 'hello!'</span>
+</pre>
+
+
+<h3>constant (value)</h3>
+
+<p>Creates a constant function. This function will continuously yield the same output.</p>
+
+
+<pre>
+<span class="keyword">local</span> pi = M.constant(<span class="global">math</span>.pi)
+pi(<span class="number">1</span>) <span class="comment">-- =&gt; 3.1415926535898
+</span>pi(<span class="number">2</span>) <span class="comment">-- =&gt; 3.1415926535898
+</span>pi(<span class="global">math</span>.pi) <span class="comment">-- =&gt; 3.1415926535898</span>
+</pre>
+
+
+<h3>applySpec (specs)</h3>
+
+<p>Returns a function which applies <code>specs</code> on args. This function will produce an object having the same structure than <code>specs</code> by mapping each property to the result of calling its associated function with the supplied arguments.</p>
+
+
+<pre>
+<span class="keyword">local</span> stats = M.applySpec({
+  min = <span class="keyword">function</span>(...) <span class="keyword">return</span> <span class="global">math</span>.min(...) <span class="keyword">end</span>,
+  max = <span class="keyword">function</span>(...) <span class="keyword">return</span> <span class="global">math</span>.max(...) <span class="keyword">end</span>,
+})
+
+stats(<span class="number">5</span>,<span class="number">4</span>,<span class="number">10</span>,<span class="number">1</span>,<span class="number">8</span>) <span class="comment">-- =&gt; {min = 1, max = 10}</span>
+</pre>
+
+
+<h3>memoize (f)</h3>
+<p>*Aliases: <code>cache</code>*.</p>
+
+<p>Memoizes a slow-running function. It caches the result for a specific input, so that the next time the function is called with the same input, it will lookup the result in its cache, instead of running again the function body.</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> fibonacci(n)
+  <span class="keyword">return</span> n &lt; <span class="number">2</span> <span class="keyword">and</span> n <span class="keyword">or</span> fibonacci(n-<span class="number">1</span>)+fibonacci(n-<span class="number">2</span>)
+<span class="keyword">end</span>
+<span class="keyword">local</span> mem_fibonacci = M.memoize(fibonacci)
+fibonacci(<span class="number">20</span>) <span class="comment">-- =&gt; 6765 (but takes some time)
+</span>mem_fibonacci(<span class="number">20</span>) <span class="comment">-- =&gt; 6765 (takes less time)</span>
+</pre>
+
+
+<h3>unfold (f, seed)</h3>
+
+<p>Builds a list from a seed value. Accepts an iterator function, which returns either nil to stop iteration or two values : the value to add to the list of results and the seed to be used in the next call to the iterator function.</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> f(v)
+  <span class="keyword">if</span> v &lt; <span class="number">100</span> <span class="keyword">then</span> <span class="keyword">return</span> v, v * <span class="number">2</span> <span class="keyword">end</span>
+<span class="keyword">end</span>
+<span class="keyword">local</span> t = M.unfold(f, <span class="number">10</span>) <span class="comment">-- =&gt; {10,20,40,80}</span>
+</pre>
+
+
+<h3>once (f)</h3>
+
+<p>Produces a function that runs only once. Successive calls to this function will still yield the same input.</p>
+
+
+<pre>
+<span class="keyword">local</span> sq = M.once(<span class="keyword">function</span>(a) <span class="keyword">return</span> a*a <span class="keyword">end</span>)
+sq(<span class="number">1</span>) <span class="comment">-- =&gt; 1
+</span>sq(<span class="number">2</span>) <span class="comment">-- =&gt; 1
+</span>sq(<span class="number">3</span>) <span class="comment">-- =&gt; 1
+</span>sq(<span class="number">4</span>) <span class="comment">-- =&gt; 1
+</span>sq(<span class="number">5</span>) <span class="comment">-- =&gt; 1</span>
+</pre>
+
+
+<h3>before (f, count)</h3>
+
+<p>Returns a version of <code>f</code> that will run no more than <a href="index.html#count">count</a> times. Next calls will keep yielding the results of the (n-th)-1 call.</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> greet(someone) <span class="keyword">return</span> <span class="string">'hello '</span>..someone <span class="keyword">end</span>
+<span class="keyword">local</span> greetOnly3people = M.before(greet, <span class="number">3</span>)
+greetOnly3people(<span class="string">'John'</span>) <span class="comment">-- =&gt; 'hello John'
+</span>greetOnly3people(<span class="string">'Moe'</span>) <span class="comment">-- =&gt; 'hello Moe'
+</span>greetOnly3people(<span class="string">'James'</span>) <span class="comment">-- =&gt; 'hello James'
+</span>greetOnly3people(<span class="string">'Joseph'</span>) <span class="comment">-- =&gt; 'hello James'
+</span>greetOnly3people(<span class="string">'Allan'</span>) <span class="comment">-- =&gt; 'hello James'</span>
+</pre>
+
+
+<h3>after (f, count)</h3>
+
+<p>Produces a function that will respond only after a given number of calls.</p>
+
+
+<pre>
+<span class="keyword">local</span> f = M.after(M.identity,<span class="number">3</span>)
+f(<span class="number">1</span>) <span class="comment">-- =&gt; nil
+</span>f(<span class="number">2</span>) <span class="comment">-- =&gt; nil
+</span>f(<span class="number">3</span>) <span class="comment">-- =&gt; 3
+</span>f(<span class="number">4</span>) <span class="comment">-- =&gt; 4</span>
+</pre>
+
+
+<h3>compose (...)</h3>
+
+<p>Composes functions. Each function consumes the return value of the one that follows.</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> f(x) <span class="keyword">return</span> x^<span class="number">2</span> <span class="keyword">end</span>
+<span class="keyword">local</span> <span class="keyword">function</span> g(x) <span class="keyword">return</span> x+<span class="number">1</span> <span class="keyword">end</span>
+<span class="keyword">local</span> <span class="keyword">function</span> h(x) <span class="keyword">return</span> x/<span class="number">2</span> <span class="keyword">end</span>
+<span class="keyword">local</span> compositae = M.compose(f,g,h)
+compositae(<span class="number">10</span>) <span class="comment">-- =&gt; 36
+</span>compositae(<span class="number">20</span>) <span class="comment">-- =&gt; 121</span>
+</pre>
+
+
+<h3>pipe (value, ...)</h3>
+
+<p>Pipes a value through a series of functions.</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> f(x) <span class="keyword">return</span> x^<span class="number">2</span> <span class="keyword">end</span>
+<span class="keyword">local</span> <span class="keyword">function</span> g(x) <span class="keyword">return</span> x+<span class="number">1</span> <span class="keyword">end</span>
+<span class="keyword">local</span> <span class="keyword">function</span> h(x) <span class="keyword">return</span> x/<span class="number">2</span> <span class="keyword">end</span>
+M.pipe(<span class="number">10</span>,f,g,h) <span class="comment">-- =&gt; 36
+</span>M.pipe(<span class="number">20</span>,f,g,h) <span class="comment">-- =&gt; 121</span>
+</pre>
+
+
+<h3>complement (f)</h3>
+
+<p>Returns a function which returns the logical complement of a given function.</p>
+
+
+<pre>
+M.complement(<span class="keyword">function</span>() <span class="keyword">return</span> <span class="keyword">true</span> <span class="keyword">end</span>)() <span class="comment">-- =&gt; false</span>
+</pre>
+
+
+<h3>juxtapose (value, ...)</h3>
+<p>*Aliases: <code>juxt</code>*.</p>
+
+<p>Calls a sequence of functions with the same input.</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> f(x) <span class="keyword">return</span> x^<span class="number">2</span> <span class="keyword">end</span>
+<span class="keyword">local</span> <span class="keyword">function</span> g(x) <span class="keyword">return</span> x+<span class="number">1</span> <span class="keyword">end</span>
+<span class="keyword">local</span> <span class="keyword">function</span> h(x) <span class="keyword">return</span> x/<span class="number">2</span> <span class="keyword">end</span>
+M.juxtapose(<span class="number">10</span>, f, g, h) <span class="comment">-- =&gt; 100, 11, 5</span>
+</pre>
+
+
+<h3>wrap (f, wrapper)</h3>
+
+<p>Wraps a function inside a wrapper. Allows the wrapper to execute code before and after function run.</p>
+
+
+<pre>
+<span class="keyword">local</span> greet = <span class="keyword">function</span>(name) <span class="keyword">return</span> <span class="string">"hi: "</span> .. name <span class="keyword">end</span>
+<span class="keyword">local</span> greet_backwards = M.wrap(greet, <span class="keyword">function</span>(f,arg)
+  <span class="keyword">return</span> f(arg) ..<span class="string">'\nhi: '</span> .. arg:reverse()
+<span class="keyword">end</span>)
+greet_backwards(<span class="string">'John'</span>)
+
+<span class="comment">-- =&gt; hi: John
+</span><span class="comment">-- =&gt; hi: nhoJ</span>
+</pre>
+
+
+<h3>times (iter [, n [, ...]])</h3>
+
+<p>Calls a given function <code>n</code> times.</p>
+
+
+<pre>
+<span class="keyword">local</span> f = (<span class="string">'Lua programming'</span>):gmatch(<span class="string">'.'</span>)
+M.times(f, <span class="number">3</span>) <span class="comment">-- =&gt; {'L','u','a'}</span>
+</pre>
+
+
+<h3>bind (f, v)</h3>
+
+<p>Binds a value to be the first argument to a function.</p>
+
+
+<pre>
+<span class="keyword">local</span> sqrt2 = M.bind(<span class="global">math</span>.sqrt,<span class="number">2</span>)
+sqrt2() <span class="comment">-- =&gt; 1.4142135623731</span>
+</pre>
+
+
+<h3>bind2 (f, v)</h3>
+
+<p>Binds a value to be the second argument to a function.</p>
+
+
+<pre>
+<span class="keyword">local</span> last2 = M.bind(M.last,<span class="number">2</span>)
+last2({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>}) <span class="comment">-- =&gt; {5,6}</span>
+</pre>
+
+
+<h3>bindn (f, ...)</h3>
+
+<p>Binds a variable number of values to be the first arguments to a function.</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> out(...) <span class="keyword">return</span> <span class="global">table</span>.concat {...} <span class="keyword">end</span>
+<span class="keyword">local</span> out = M.bindn(out,<span class="string">'OutPut'</span>,<span class="string">':'</span>,<span class="string">' '</span>)
+out(<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>) <span class="comment">-- =&gt; OutPut: 123
+</span>out(<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>,<span class="string">'d'</span>) <span class="comment">-- =&gt; OutPut: abcd</span>
+</pre>
+
+
+<h3>bindall (obj, ...)</h3>
+
+<p>Binds methods to object. As such, when calling any of these methods, they will receive object as a first argument.</p>
+
+
+<pre>
+<span class="keyword">local</span> window = {
+    setPos = <span class="keyword">function</span>(w,x,y) w.x, w.y = x, y <span class="keyword">end</span>,
+    setName = <span class="keyword">function</span>(w,name) w.name = name <span class="keyword">end</span>,
+    getName = <span class="keyword">function</span>(w) <span class="keyword">return</span> w.name <span class="keyword">end</span>,
+}
+window = M.bindall(window, <span class="string">'setPos'</span>, <span class="string">'setName'</span>, <span class="string">'getName'</span>)
+window.setPos(<span class="number">10</span>,<span class="number">15</span>)
+<span class="global">print</span>(window.x, window.y) <span class="comment">-- =&gt; 10,15
+</span>
+window.setName(<span class="string">'fooApp'</span>)
+<span class="global">print</span>(window.name) <span class="comment">-- =&gt; 'fooApp'
+</span>
+<span class="global">print</span>(window.getName()) <span class="comment">-- =&gt; 'fooApp'</span>
+</pre>
+
+
+<h3>cond (conds)</h3>
+
+<p>Returns a function which iterate over an array list of conditions. It invokes each predicate, passing it given values. It returns the value of the corresponding function of the first predicate to return a non-nil value</p>
+
+
+<pre>
+<span class="keyword">local</span> multipleOf = M.cond({
+  {<span class="keyword">function</span>(v) <span class="keyword">return</span> v%<span class="number">2</span>==<span class="number">0</span> <span class="keyword">end</span>, <span class="keyword">function</span>(v) <span class="keyword">return</span> v..<span class="string">' is multiple of 2'</span> <span class="keyword">end</span>},
+  {<span class="keyword">function</span>(v) <span class="keyword">return</span> v%<span class="number">3</span>==<span class="number">0</span> <span class="keyword">end</span>, <span class="keyword">function</span>(v) <span class="keyword">return</span> v..<span class="string">' is multiple of 3'</span> <span class="keyword">end</span>},
+  {<span class="keyword">function</span>(v) <span class="keyword">return</span> v%<span class="number">5</span>==<span class="number">0</span> <span class="keyword">end</span>, <span class="keyword">function</span>(v) <span class="keyword">return</span> v..<span class="string">' is multiple of 5'</span> <span class="keyword">end</span>},
+  {<span class="keyword">function</span>() <span class="keyword">return</span> <span class="keyword">true</span> <span class="keyword">end</span>, <span class="keyword">function</span>(v) <span class="keyword">return</span> <span class="string">'could not find an answer for '</span>..v <span class="keyword">end</span>}
+})
+<span class="keyword">for</span> i = <span class="number">15</span>, <span class="number">20</span> <span class="keyword">do</span>
+  <span class="global">print</span>(multipleOf(i))
+<span class="keyword">end</span>
+
+<span class="comment">-- =&gt; 15 is multiple of 3
+</span><span class="comment">-- =&gt; 16 is multiple of 2
+</span><span class="comment">-- =&gt; could not find an answer for 17
+</span><span class="comment">-- =&gt; 18 is multiple of 2
+</span><span class="comment">-- =&gt; could not find an answer for 19
+</span><span class="comment">-- =&gt; 20 is multiple of 2</span>
+</pre>
+
+
+<h3>uniqueId ([template [, ...]])</h3>
+<p>*Aliases: <code>uid</code>*.</p>
+
+<p>Returns an unique integer ID.</p>
+
+
+<pre>
+M.uniqueId() <span class="comment">-- =&gt; 1</span>
+</pre>
+
+
+<p>Can handle string templates for formatted output.</p>
+
+
+<pre>
+M.uniqueId(<span class="string">'ID%s'</span>) <span class="comment">-- =&gt; 'ID2'</span>
+</pre>
+
+
+<p>Or a function, for the same purpose.</p>
+
+
+<pre>
+<span class="keyword">local</span> formatter = <span class="keyword">function</span>(ID) <span class="keyword">return</span> <span class="string">'$'</span>..ID..<span class="string">'$'</span> <span class="keyword">end</span>
+M.uniqueId(formatter) <span class="comment">-- =&gt; '$ID1$'</span>
+</pre>
+
+
+<h3>iterator(f, value [, n])</h3>
+<p>*Aliases: <code>iter</code>*.</p>
+
+<p>Returns an iterator function which constinuously applies a function <code>f</code> onto an input <a href="index.html#obj:value">value</a>.
+For example, let us go through the powers of two using <a href="index.html#iterator">iterator</a>.</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> po2(x) <span class="keyword">return</span> x*<span class="number">2</span> <span class="keyword">end</span>
+<span class="keyword">local</span> <span class="keyword">function</span> iter_po2 = M.iterator(po2, <span class="number">1</span>)
+iter_po2() <span class="comment">-- =&gt; 2
+</span>iter_po2() <span class="comment">-- =&gt; 4
+</span>iter_po2() <span class="comment">-- =&gt; 8</span>
+</pre>
+
+
+<p>if <code>n</code> is supplied, it will run at maximum <code>n</code> times.</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> po2(x) <span class="keyword">return</span> x*<span class="number">2</span> <span class="keyword">end</span>
+<span class="keyword">local</span> <span class="keyword">function</span> iter_po2 = M.iterator(po2, <span class="number">1</span>, <span class="number">3</span>)
+iter_po2() <span class="comment">-- =&gt; 2
+</span>iter_po2() <span class="comment">-- =&gt; 4
+</span>iter_po2() <span class="comment">-- =&gt; 8
+</span>iter_po2() <span class="comment">-- =&gt; nil</span>
+</pre>
+
+
+<h3>array (...)</h3>
+<p>*Aliases: <code>tabulate</code>*.</p>
+
+<p>Iterates a given iterator function and returns its values packed in an array.</p>
+
+
+<pre>
+<span class="keyword">local</span> text = <span class="string">'letters'</span>
+<span class="keyword">local</span> chars = <span class="global">string</span>.gmatch(text, <span class="string">'.'</span>)
+<span class="keyword">local</span> letters = M.array(chars) <span class="comment">-- =&gt; {'l','e','t','t','e','r','s'}</span>
+</pre>
+
+
+<h3>castArray (value)</h3>
+
+<p>Casts the passed-in value to an array containing the value itself.</p>
+
+
+<pre>
+M.castArray(<span class="keyword">true</span>) <span class="comment">-- =&gt; {true}
+</span>M.castArray(<span class="number">2</span>) <span class="comment">-- =&gt; {2}</span>
+</pre>
+
+
+<p>It leaves the given value untouched in case it is already a table.</p>
+
+
+<pre>
+<span class="keyword">local</span> t = {<span class="number">1</span>}
+<span class="global">print</span>(M.castArray(t) == t) <span class="comment">-- =&gt; true</span>
+</pre>
+
+
+<h3>flip (f)</h3>
+
+<p>Creates a function of <code>f</code> with arguments flipped in reverse order.</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> f(...) <span class="keyword">return</span> <span class="global">table</span>.concat({...}) <span class="keyword">end</span>
+<span class="keyword">local</span> flipped = M.flip(f)
+flipped(<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>) <span class="comment">-- =&gt; 'cba'</span>
+</pre>
+
+
+<h3>nthArg(n)</h3>
+
+<p>Returns a function that gets the nth argument. </p>
+
+
+<pre>
+<span class="keyword">local</span> f = M.nthArg(<span class="number">3</span>)
+f(<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>) <span class="comment">-- =&gt; 'c'</span>
+</pre>
+
+
+<p>If n is negative, the nth argument from the end is returned.</p>
+
+
+<pre>
+<span class="keyword">local</span> f = M.nthArg(-<span class="number">2</span>)
+f(<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>) <span class="comment">-- =&gt; 'b'</span>
+</pre>
+
+
+<h3>unary (f)</h3>
+
+<p>Returns a function which accepts up to one argument. It ignores any additional arguments. </p>
+
+
+<pre>
+<span class="keyword">local</span> f = M.unary(<span class="keyword">function</span> (...) <span class="keyword">return</span> ... <span class="keyword">end</span>)
+f(<span class="string">'a'</span>) - ==&gt; <span class="string">'a'</span>
+f(<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>) <span class="comment">-- =&gt; 'a'</span>
+</pre>
+
+
+<h3>ary (f [, n = 1])</h3>
+<p>*Aliases: <code>nAry</code>*.</p>
+
+<p>Returns a function which accepts up to <code>n</code> args. It ignores any additional arguments.</p>
+
+
+<pre>
+<span class="keyword">local</span> f = M.ary(<span class="keyword">function</span> (...) <span class="keyword">return</span> ... <span class="keyword">end</span>, <span class="number">2</span>)
+f(<span class="number">1</span>,<span class="number">2</span>) - ==&gt; <span class="number">1</span>,<span class="number">2</span>
+f(<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>) <span class="comment">-- =&gt; 1,2</span>
+</pre>
+
+
+<p>If <code>n</code> is not given, it defaults to <code>1</code>.</p>
+
+
+<pre>
+<span class="keyword">local</span> f = M.unary(<span class="keyword">function</span> (...) <span class="keyword">return</span> ... <span class="keyword">end</span>)
+f(<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>) <span class="comment">-- =&gt; 'a'</span>
+</pre>
+
+
+<h3>rearg (f, indexes)</h3>
+
+<p>Returns a function which runs with arguments arranged according to given <code>indexes</code>.</p>
+
+
+<pre>
+<span class="keyword">local</span> f = M.rearg(<span class="keyword">function</span> (...) <span class="keyword">return</span> ... <span class="keyword">end</span>, {<span class="number">5</span>,<span class="number">4</span>,<span class="number">3</span>,<span class="number">2</span>,<span class="number">1</span>})
+f(<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>,<span class="string">'d'</span>,<span class="string">'e'</span>) <span class="comment">-- =&gt; 'e','d','c','b','a'</span>
+</pre>
+
+
+<h3>over (...)</h3>
+
+<p>Creates a function that invokes a set of transforms with the arguments it receives.<br/>
+One can use use for example to get the tuple of min and max values from a set of values</p>
+
+
+<pre>
+<span class="keyword">local</span> minmax = M.over(<span class="global">math</span>.min, <span class="global">math</span>.max)
+minmax(<span class="number">5</span>,<span class="number">10</span>,<span class="number">12</span>,<span class="number">4</span>,<span class="number">3</span>) <span class="comment">-- =&gt; {3,12}</span>
+</pre>
+
+
+<h3>overEvery (...)</h3>
+
+<p>Creates a validation function. The returned function checks if all of the given predicates return truthy when invoked with the arguments it receives.</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> alleven(...)
+    <span class="keyword">for</span> i, v <span class="keyword">in</span> <span class="global">ipairs</span>({...}) <span class="keyword">do</span>
+        <span class="keyword">if</span> v%<span class="number">2</span>~=<span class="number">0</span> <span class="keyword">then</span> <span class="keyword">return</span> <span class="keyword">false</span> <span class="keyword">end</span>
+    <span class="keyword">end</span>
+    <span class="keyword">return</span> <span class="keyword">true</span>
+<span class="keyword">end</span>
+
+<span class="keyword">local</span> <span class="keyword">function</span> allpositive(...)
+    <span class="keyword">for</span> i, v <span class="keyword">in</span> <span class="global">ipairs</span>({...}) <span class="keyword">do</span>
+        <span class="keyword">if</span> v &lt; <span class="number">0</span> <span class="keyword">then</span> <span class="keyword">return</span> <span class="keyword">false</span> <span class="keyword">end</span>
+    <span class="keyword">end</span>
+    <span class="keyword">return</span> <span class="keyword">true</span>
+<span class="keyword">end</span>
+
+<span class="keyword">local</span> allok = M.overEvery(alleven, allpositive)
+
+allok(<span class="number">2</span>,<span class="number">4</span>,-<span class="number">1</span>,<span class="number">8</span>) <span class="comment">-- =&gt; false
+</span>allok(<span class="number">10</span>,<span class="number">3</span>,<span class="number">2</span>,<span class="number">6</span>) <span class="comment">-- =&gt; false
+</span>allok(<span class="number">8</span>,<span class="number">4</span>,<span class="number">6</span>,<span class="number">10</span>) <span class="comment">-- =&gt; true</span>
+</pre>
+
+
+<h3>overSome (...)</h3>
+
+<p>Creates a validation function. The returned function checks if any of the given predicates return truthy when invoked with the arguments it receives.</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> alleven(...)
+    <span class="keyword">for</span> i, v <span class="keyword">in</span> <span class="global">ipairs</span>({...}) <span class="keyword">do</span>
+        <span class="keyword">if</span> v%<span class="number">2</span>~=<span class="number">0</span> <span class="keyword">then</span> <span class="keyword">return</span> <span class="keyword">false</span> <span class="keyword">end</span>
+    <span class="keyword">end</span>
+    <span class="keyword">return</span> <span class="keyword">true</span>
+<span class="keyword">end</span>
+
+<span class="keyword">local</span> <span class="keyword">function</span> allpositive(...)
+    <span class="keyword">for</span> i, v <span class="keyword">in</span> <span class="global">ipairs</span>({...}) <span class="keyword">do</span>
+        <span class="keyword">if</span> v &lt; <span class="number">0</span> <span class="keyword">then</span> <span class="keyword">return</span> <span class="keyword">false</span> <span class="keyword">end</span>
+    <span class="keyword">end</span>
+    <span class="keyword">return</span> <span class="keyword">true</span>
+<span class="keyword">end</span>
+
+<span class="keyword">local</span> anyok = M.overSome(alleven,allpositive)
+
+anyok(<span class="number">2</span>,<span class="number">4</span>,-<span class="number">1</span>,<span class="number">8</span>) <span class="comment">-- =&gt; false
+</span>anyok(<span class="number">10</span>,<span class="number">3</span>,<span class="number">2</span>,<span class="number">6</span>) <span class="comment">-- =&gt; true
+</span>anyok(-<span class="number">1</span>,-<span class="number">5</span>,-<span class="number">3</span>) <span class="comment">-- =&gt; false</span>
+</pre>
+
+
+<h3>overArgs (f, ...)</h3>
+
+<p>Creates a function that invokes <code>f</code> with its arguments transformed</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> f(x, y) <span class="keyword">return</span> x, y <span class="keyword">end</span>
+<span class="keyword">local</span> <span class="keyword">function</span> triple(x) retun x*<span class="number">3</span> <span class="keyword">end</span>
+<span class="keyword">local</span> <span class="keyword">function</span> square(x) retun x^<span class="number">2</span> <span class="keyword">end</span>
+<span class="keyword">local</span> new_f = M.overArgs(f, triple, square)
+
+new_f(<span class="number">1</span>,<span class="number">2</span>) <span class="comment">-- =&gt; 3, 4
+</span>new_f(<span class="number">10</span>,<span class="number">10</span>) <span class="comment">-- =&gt; 30, 100</span>
+</pre>
+
+
+<p>In case the number of arguments is greater than the number of transforms, the remaining args will be left as-is.</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> f(x, y, z) <span class="keyword">return</span> x, y, z <span class="keyword">end</span>
+<span class="keyword">local</span> <span class="keyword">function</span> triple(x) retun x*<span class="number">3</span> <span class="keyword">end</span>
+<span class="keyword">local</span> <span class="keyword">function</span> square(x) retun x^<span class="number">2</span> <span class="keyword">end</span>
+<span class="keyword">local</span> new_f = M.overArgs(f, triple, square)
+
+new_f(<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>) <span class="comment">-- =&gt; 3, 4, 3
+</span>new_f(<span class="number">10</span>,<span class="number">10</span>,<span class="number">10</span>) <span class="comment">-- =&gt; 30, 100, 10</span>
+</pre>
+
+
+<h3>converge (f, g, h)</h3>
+
+<p>Converges two functions into one.</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> pow2(x) <span class="keyword">return</span> x*x <span class="keyword">end</span>
+<span class="keyword">local</span> <span class="keyword">function</span> pow3(x) <span class="keyword">return</span> x*x*x <span class="keyword">end</span>
+<span class="keyword">local</span> <span class="keyword">function</span> sum(a,b) <span class="keyword">return</span> a+b <span class="keyword">end</span>
+<span class="keyword">local</span> poly = M.converge(sum, pow2, pow3)
+poly(<span class="number">5</span>) <span class="comment">-- =&gt; 150 (ie. 5*5 + 5*5*5)</span>
+</pre>
+
+
+<h3>partial (f, ...)</h3>
+
+<p>Partially apply a function by filling in any number of its arguments. </p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> diff(a, b) <span class="keyword">return</span> a - b <span class="keyword">end</span>
+<span class="keyword">local</span> diffFrom20 = M.partial(diff, <span class="number">20</span>) <span class="comment">-- arg 'a' will be 20 by default
+</span>diffFrom20(<span class="number">5</span>) <span class="comment">-- =&gt; 15</span>
+</pre>
+
+
+<p>The string <code>&apos;_&apos;</code> can be used as a placeholder in the list of arguments to specify an argument that should not be pre-filled, but is rather left open to be supplied at call-time.</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> diff(a, b) <span class="keyword">return</span> a - b <span class="keyword">end</span>
+<span class="keyword">local</span> remove5 = M.partial(diff, <span class="string">'_'</span>, <span class="number">5</span>) <span class="comment">-- arg 'a' will be given at call-time, but 'b' is set to 5
+</span>remove5(<span class="number">20</span>) <span class="comment">-- =&gt; 15</span>
+</pre>
+
+
+<h3>partialRight (f, ...)</h3>
+
+<p>Like <code>M.partial</code>, it partially applies a function by filling in any number of its arguments, but from the right.</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> concat(...) <span class="keyword">return</span> <span class="global">table</span>.concat({...},<span class="string">','</span>) <span class="keyword">end</span>
+<span class="keyword">local</span> concat_right = M.partialRight(concat,<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>)
+concat_right(<span class="string">'d'</span>) <span class="comment">-- =&gt; d,a,b,c
+</span>
+concat_right = M.partialRight(concat,<span class="string">'a'</span>,<span class="string">'b'</span>)
+concat_right(<span class="string">'c'</span>,<span class="string">'d'</span>) <span class="comment">-- =&gt; c,d,a,b
+</span>
+concat_right = M.partialRight(concat,<span class="string">'a'</span>)
+concat_right(<span class="string">'b'</span>,<span class="string">'c'</span>,<span class="string">'d'</span>) <span class="comment">-- =&gt; b,c,d,a</span>
+</pre>
+
+
+<p>The string <code>&apos;_&apos;</code>, as always, can be used as a placeholder in the list of arguments to specify an argument that should not be pre-filled, but is rather left open to be supplied at call-time.
+In that case, the first args supplied at runtime will be used to fill the initial list of args while the remaining will be prepended.</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> concat(...) <span class="keyword">return</span> <span class="global">table</span>.concat({...},<span class="string">','</span>) <span class="keyword">end</span>
+<span class="keyword">local</span> concat_right = M.partialRight(concat,<span class="string">'a'</span>,<span class="string">'_'</span>,<span class="string">'c'</span>)
+concat_right(<span class="string">'d'</span>,<span class="string">'b'</span>) <span class="comment">-- =&gt; b,a,d,c
+</span>
+concat_right = M.partialRight(concat,<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'_'</span>)
+concat_right(<span class="string">'c'</span>,<span class="string">'d'</span>) <span class="comment">-- =&gt; d,a,b,c
+</span>
+concat_right = M.partialRight(concat,<span class="string">'_'</span>,<span class="string">'a'</span>)
+concat_right(<span class="string">'b'</span>,<span class="string">'c'</span>,<span class="string">'d'</span>) <span class="comment">-- =&gt; c,d,b,a</span>
+</pre>
+
+
+<h3>curry (f [, n_args = 2])</h3>
+
+<p>Curries a function. If the given function <code>f</code> takes multiple arguments, it returns another version of <code>f</code> that takes a single argument
+(the first of the arguments to the original function) and returns a new function that takes the remainder of the arguments and returns the result.</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> sumOf3args(x,y,z) <span class="keyword">return</span> x + y + z <span class="keyword">end</span>
+<span class="keyword">local</span> curried_sumOf3args = M.curry(sumOf3args, <span class="number">3</span>)
+sumOf3args(<span class="number">1</span>)(<span class="number">2</span>)(<span class="number">3</span>)) <span class="comment">-- =&gt; 6
+</span>sumOf3args(<span class="number">0</span>)(<span class="number">6</span>)(<span class="number">9</span>)) <span class="comment">-- =&gt; 15</span>
+</pre>
+
+
+<p><code>n_args</code> defaults to 2.</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> product(x,y) <span class="keyword">return</span> x * y <span class="keyword">end</span>
+<span class="keyword">local</span> curried_product = M.curry(product)
+curried_product(<span class="number">5</span>)(<span class="number">4</span>) <span class="comment">-- =&gt; 20
+</span>curried_product(<span class="number">3</span>)(-<span class="number">5</span>) <span class="comment">-- =&gt; -15
+</span>curried_product(<span class="number">0</span>)(<span class="number">1</span>) <span class="comment">-- =&gt; 0</span>
+</pre>
+
+
+<h3>time (f [, ...])</h3>
+
+<p>Returns the execution time of <code>f (...)</code> in seconds and its results.</p>
+
+
+<pre>
+<span class="keyword">local</span> <span class="keyword">function</span> wait_count(n)
+    <span class="keyword">local</span> i = <span class="number">0</span>
+    <span class="keyword">while</span> i &lt; n <span class="keyword">do</span> i = i + <span class="number">1</span> <span class="keyword">end</span>
+    <span class="keyword">return</span> i
+<span class="keyword">end</span>
+
+<span class="keyword">local</span> time, i = M.time(wait_count, <span class="number">1e6</span>) <span class="comment">-- =&gt; 0.002 1000000
+</span><span class="keyword">local</span> time, i = M.time(wait_count, <span class="number">1e7</span>) <span class="comment">-- =&gt; 0.018 10000000</span>
+</pre>
+
+
+<p><strong><a href="#TOC">[⬆]</a></strong></p>
+
+<p><a name="_a_name__object__Object_functions__a_"></a></p>
+<h2><a name='object'>Object functions</a></h2>
+
+<h3>keys (obj)</h3>
+
+<p>Collects the names of an object attributes.</p>
+
+
+<pre>
+M.keys({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>}) <span class="comment">-- =&gt; "{1,2,3}"
+</span>M.keys({x = <span class="number">0</span>, y = <span class="number">1</span>}) <span class="comment">-- =&gt; "{'y','x'}"</span>
+</pre>
+
+
+<h3>values (obj)</h3>
+
+<p>Collects the values of an object attributes.</p>
+
+
+<pre>
+M.values({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>}) <span class="comment">-- =&gt; "{1,2,3}"
+</span>M.values({x = <span class="number">0</span>, y = <span class="number">1</span>}) <span class="comment">-- =&gt; "{1,0}"</span>
+</pre>
+
+
+<h3>path (obj, ...)</h3>
+
+<p>Returns the value at a given path in an object.</p>
+
+
+<pre>
+<span class="keyword">local</span> entity = {
+  pos = {x = <span class="number">1</span>, y = <span class="number">2</span>},
+  engine = {
+    left = {status = <span class="string">'active'</span>, damage = <span class="number">5</span>},
+    right = {status = <span class="string">'off'</span>, damage = <span class="number">10</span>}
+  },
+  boost = <span class="keyword">false</span>
+}
+
+M.path(entity,<span class="string">'pos'</span>,<span class="string">'x'</span>) <span class="comment">-- =&gt; 1
+</span>M.path(entity,<span class="string">'pos'</span>,<span class="string">'y'</span>) <span class="comment">-- =&gt; 2
+</span>M.path(entity,<span class="string">'engine'</span>,<span class="string">'left'</span>,<span class="string">'status'</span>) <span class="comment">-- =&gt; 'active'
+</span>M.path(entity,<span class="string">'engine'</span>,<span class="string">'right'</span>,<span class="string">'damage'</span>) <span class="comment">-- =&gt; 10
+</span>M.path(entity,<span class="string">'boost'</span>) <span class="comment">-- =&gt; false</span>
+</pre>
+
+
+<h3>kvpairs (obj)</h3>
+
+<p>Converts an object to an array-list of key-value pairs.</p>
+
+
+<pre>
+<span class="keyword">local</span> obj = {x = <span class="number">1</span>, y = <span class="number">2</span>, z = <span class="number">3</span>}
+M.each(M.kvpairs(obj), <span class="keyword">function</span>(v,k)
+    <span class="global">print</span>(k, <span class="global">table</span>.concat(v,<span class="string">','</span>))
+<span class="keyword">end</span>)
+
+<span class="comment">-- =&gt; 1    y,2
+</span><span class="comment">-- =&gt; 2 x,1
+</span><span class="comment">-- =&gt; 3 z,3</span>
+</pre>
+
+
+<h3>toObj (kvpairs)</h3>
+
+<p>Converts an array list of <a href="index.html#kvpairs">kvpairs</a> to an object where keys are taken from the 1rst column in the <a href="index.html#kvpairs">kvpairs</a> sequence, associated with values in the 2nd column.</p>
+
+
+<pre>
+<span class="keyword">local</span> list_pairs = {{<span class="string">'x'</span>,<span class="number">1</span>},{<span class="string">'y'</span>,<span class="number">2</span>},{<span class="string">'z'</span>,<span class="number">3</span>}}
+obj = M.toObj(list_pairs)
+
+<span class="comment">-- =&gt; {x = 1, y = 2, z = 3}</span>
+</pre>
+
+
+<h3>property (key)</h3>
+
+<p>Returns a function that will return the key property of any passed-in object.</p>
+
+
+<pre>
+<span class="keyword">local</span> who = M.property(<span class="string">'name'</span>)
+<span class="keyword">local</span> people = {name = <span class="string">'Henry'</span>}
+who(people) <span class="comment">-- =&gt; 'Henry'</span>
+</pre>
+
+
+<h3>propertyOf (obj)</h3>
+
+<p>Returns a function that will return the key property of any passed-in object.</p>
+
+
+<pre>
+<span class="keyword">local</span> people = {name = <span class="string">'Henry'</span>}
+<span class="global">print</span>(M.propertyOf(people)(<span class="string">'name'</span>)) <span class="comment">-- =&gt; 'Henry'</span>
+</pre>
+
+
+<h3>toBoolean (value)</h3>
+
+<p>Converts a given value to a boolean.</p>
+
+
+<pre>
+M.toBoolean(<span class="keyword">true</span>) <span class="comment">-- =&gt; true
+</span>M.toBoolean(<span class="keyword">false</span>) <span class="comment">-- =&gt; false
+</span>M.toBoolean(<span class="keyword">nil</span>) <span class="comment">-- =&gt; false
+</span>M.toBoolean({}) <span class="comment">-- =&gt; true
+</span>M.toBoolean(<span class="number">1</span>) <span class="comment">-- =&gt; true</span>
+</pre>
+
+
+<h3>extend (destObj, ...)</h3>
+
+<p>Extends a destination object with the properties of some source objects.</p>
+
+
+<pre>
+M.extend({},{a = <span class="string">'b'</span>, c = <span class="string">'d'</span>}) <span class="comment">-- =&gt; "{a = 'b', c = 'd'}"</span>
+</pre>
+
+
+<h3>functions (obj [, recurseMt])</h3>
+<p>*Aliases: <code>methods</code>*.</p>
+
+<p>Returns all functions names within an object.</p>
+
+
+<pre>
+M.functions(<span class="global">coroutine</span>)
+<span class="comment">-- =&gt; "{'yield','wrap','status','resume','running','create'}"</span>
+</pre>
+
+
+<p>When given <code>recurseMt</code>, will also include <code>obj</code> metatable's functions.</p>
+
+
+<pre>
+<span class="keyword">local</span> mt = {<span class="global">print</span> = <span class="global">print</span>}
+<span class="keyword">local</span> t = {<span class="global">assert</span> = <span class="global">assert</span>}
+<span class="global">setmetatable</span>(t, {__index = mt})
+M.functions(t, <span class="keyword">true</span>) <span class="comment">-- =&gt; "{'assert','print'}"</span>
+</pre>
+
+
+<h3>clone (obj [, shallow])</h3>
+
+<p>Clones a given object.</p>
+
+
+<pre>
+<span class="keyword">local</span> obj = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>}
+<span class="keyword">local</span> obj2 = M.clone(obj)
+<span class="global">print</span>(obj2 == obj) <span class="comment">-- =&gt; false
+</span><span class="global">print</span>(M.isEqual(obj2, obj)) <span class="comment">-- =&gt; true</span>
+</pre>
+
+
+<h3>tap (obj, f [, ...])</h3>
+
+<p>Invokes a given interceptor function on some object, and then returns the object itself. Useful to tap into method chaining to hook intermediate results.
+The passed-in interceptor should be prototyped as <code>f(obj,...)</code>.</p>
+
+
+<pre>
+<span class="keyword">local</span> v = M.chain({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>,<span class="number">7</span>,<span class="number">8</span>,<span class="number">9</span>,<span class="number">10</span>})
+  :filter(<span class="keyword">function</span>(v) <span class="keyword">return</span> v%<span class="number">2</span>~=<span class="number">0</span> <span class="keyword">end</span>) <span class="comment">-- retain odd values
+</span>  :tap(<span class="keyword">function</span>(v) <span class="global">print</span>(<span class="string">'Max is'</span>, M.max(v) <span class="keyword">end</span>) <span class="comment">-- Tap max value
+</span>  :map(<span class="keyword">function</span>(v) <span class="keyword">return</span> v^<span class="number">2</span> <span class="keyword">end</span>)
+  :value() <span class="comment">-- =&gt;    Max is 89</span>
+</pre>
+
+
+<h3>has (obj, key)</h3>
+
+<p>Checks if an object has a given attribute.</p>
+
+
+<pre>
+M.has(_,<span class="string">'has'</span>) <span class="comment">-- =&gt; true
+</span>M.has(<span class="global">coroutine</span>,<span class="string">'resume'</span>) <span class="comment">-- =&gt; true
+</span>M.has(<span class="global">math</span>,<span class="string">'random'</span>) <span class="comment">-- =&gt; true</span>
+</pre>
+
+
+<h3>pick (obj, ...)</h3>
+<p>*Aliases: <code>choose</code>*.</p>
+
+<p>Collects whilelisted properties of a given object.</p>
+
+
+<pre>
+<span class="keyword">local</span> object = {a = <span class="number">1</span>, b = <span class="number">2</span>, c = <span class="number">3</span>}
+M.pick(object,<span class="string">'a'</span>,<span class="string">'c'</span>) <span class="comment">-- =&gt; "{a = 1, c = 3}"</span>
+</pre>
+
+
+<h3>omit (obj, ...)</h3>
+<p>*Aliases: <code>drop</code>*.</p>
+
+<p>Omits blacklisted properties of a given object.</p>
+
+
+<pre>
+<span class="keyword">local</span> object = {a = <span class="number">1</span>, b = <span class="number">2</span>, c = <span class="number">3</span>}
+M.omit(object,<span class="string">'a'</span>,<span class="string">'c'</span>) <span class="comment">-- =&gt; "{b = 2}"</span>
+</pre>
+
+
+<h3>template (obj [, template])</h3>
+<p>*Aliases: <code>defaults</code>*.</p>
+
+<p>Applies a template on an object, preserving existing properties.</p>
+
+
+<pre>
+<span class="keyword">local</span> obj = {a = <span class="number">0</span>}
+M.template(obj,{a = <span class="number">1</span>, b = <span class="number">2</span>, c = <span class="number">3</span>}) <span class="comment">-- =&gt; "{a=0, c=3, b=2}"</span>
+</pre>
+
+
+<h3>isEqual (objA, objB [, useMt])</h3>
+<p>*Aliases: <code>compare</code>, <code>M.matches</code>*.</p>
+
+<p>Compares objects:</p>
+
+
+<pre>
+M.isEqual(<span class="number">1</span>,<span class="number">1</span>) <span class="comment">-- =&gt; true
+</span>M.isEqual(<span class="keyword">true</span>,<span class="keyword">false</span>) <span class="comment">-- =&gt; false
+</span>M.isEqual(<span class="number">3.14</span>,<span class="global">math</span>.pi) <span class="comment">-- =&gt; false
+</span>M.isEqual({<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>},{<span class="number">3</span>,<span class="number">4</span>,{<span class="number">5</span>}}) <span class="comment">-- =&gt; false</span>
+</pre>
+
+
+<h3>result (obj, method [, ...])</h3>
+
+<p>Calls an object method, passing it as a first argument the object itself.</p>
+
+
+<pre>
+M.result(<span class="string">'abc'</span>,<span class="string">'len'</span>) <span class="comment">-- =&gt; 3
+</span>M.result({<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>},<span class="global">table</span>.concat) <span class="comment">-- =&gt; 'abc'</span>
+</pre>
+
+
+<h3>isTable (t)</h3>
+
+<p>Is the given argument an object (i.e a table) ?</p>
+
+
+<pre>
+M.isTable({}) <span class="comment">-- =&gt; true
+</span>M.isTable(<span class="global">math</span>) <span class="comment">-- =&gt; true
+</span>M.isTable(<span class="global">string</span>) <span class="comment">-- =&gt; true</span>
+</pre>
+
+
+<h3>isCallable (obj)</h3>
+
+<p>Is the given argument callable ?</p>
+
+
+<pre>
+M.isCallable(<span class="global">print</span>) <span class="comment">-- =&gt; true
+</span>M.isCallable(<span class="keyword">function</span>() <span class="keyword">end</span>) <span class="comment">-- =&gt; true
+</span>M.isCallable(<span class="global">setmetatable</span>({},{__index = <span class="global">string</span>}).upper) <span class="comment">-- =&gt; true
+</span>M.isCallable(<span class="global">setmetatable</span>({},{__call = <span class="keyword">function</span>() <span class="keyword">return</span> <span class="keyword">end</span>})) <span class="comment">-- =&gt; true</span>
+</pre>
+
+
+<h3>isArray (obj)</h3>
+
+<p>Is the given argument an array (i.e. a sequence) ?</p>
+
+
+<pre>
+M.isArray({}) <span class="comment">-- =&gt; true
+</span>M.isArray({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>}) <span class="comment">-- =&gt; true
+</span>M.isArray({<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>}) <span class="comment">-- =&gt; true</span>
+</pre>
+
+
+<h3>isIterable (obj)</h3>
+
+<p>Checks if the given object is iterable with <a href="https://www.lua.org/manual/5.1/manual.html#pdf-pairs">pairs</a>.</p>
+
+
+<pre>
+M.isIterable({}) <span class="comment">-- =&gt; true
+</span>M.isIterable(<span class="keyword">function</span>() <span class="keyword">end</span>) <span class="comment">-- =&gt; false
+</span>M.isIterable(<span class="keyword">false</span>) <span class="comment">-- =&gt; false
+</span>M.isIterable(<span class="number">1</span>) <span class="comment">-- =&gt; false</span>
+</pre>
+
+
+<h3>isEmpty ([obj])</h3>
+
+<p>Is the given argument empty ?</p>
+
+
+<pre>
+M.isEmpty(<span class="string">''</span>) <span class="comment">-- =&gt; true
+</span>M.isEmpty({})  <span class="comment">-- =&gt; true
+</span>M.isEmpty({<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>}) <span class="comment">-- =&gt; false</span>
+</pre>
+
+
+<h3>isString (obj)</h3>
+
+<p>Is the given argument a string ?</p>
+
+
+<pre>
+M.isString(<span class="string">''</span>) <span class="comment">-- =&gt; true
+</span>M.isString(<span class="string">'Hello'</span>) <span class="comment">-- =&gt; false
+</span>M.isString({}) <span class="comment">-- =&gt; false</span>
+</pre>
+
+
+<h3>isFunction (obj)</h3>
+
+<p>Is the given argument a function ?</p>
+
+
+<pre>
+M.isFunction(<span class="global">print</span>) <span class="comment">-- =&gt; true
+</span>M.isFunction(<span class="keyword">function</span>() <span class="keyword">end</span>) <span class="comment">-- =&gt; true
+</span>M.isFunction({}) <span class="comment">-- =&gt; false</span>
+</pre>
+
+
+<h3>isNil (obj)</h3>
+
+<p>Is the given argument nil ?</p>
+
+
+<pre>
+M.isNil(<span class="keyword">nil</span>) <span class="comment">-- =&gt; true
+</span>M.isNil() <span class="comment">-- =&gt; true
+</span>M.isNil({}) <span class="comment">-- =&gt; false</span>
+</pre>
+
+
+<h3>isNumber (obj)</h3>
+
+<p>Is the given argument a number ?</p>
+
+
+<pre>
+M.isNumber(<span class="global">math</span>.pi) <span class="comment">-- =&gt; true
+</span>M.isNumber(<span class="global">math</span>.huge) <span class="comment">-- =&gt; true
+</span>M.isNumber(<span class="number">0</span>/<span class="number">0</span>) <span class="comment">-- =&gt; true
+</span>M.isNumber() <span class="comment">-- =&gt; false</span>
+</pre>
+
+
+<h3>isNaN (obj)</h3>
+
+<p>Is the given argument NaN ?</p>
+
+
+<pre>
+M.isNaN(<span class="number">1</span>) <span class="comment">-- =&gt; false
+</span>M.isNaN(<span class="number">0</span>/<span class="number">0</span>) <span class="comment">-- =&gt; true</span>
+</pre>
+
+
+<h3>isFinite (obj)</h3>
+
+<p>Is the given argument a finite number ?</p>
+
+
+<pre>
+M.isFinite(<span class="number">99e99</span>) <span class="comment">-- =&gt; true
+</span>M.isFinite(<span class="global">math</span>.pi) <span class="comment">-- =&gt; true
+</span>M.isFinite(<span class="global">math</span>.huge) <span class="comment">-- =&gt; false
+</span>M.isFinite(<span class="number">1</span>/<span class="number">0</span>) <span class="comment">-- =&gt; false
+</span>M.isFinite(<span class="number">0</span>/<span class="number">0</span>) <span class="comment">-- =&gt; false</span>
+</pre>
+
+
+<h3>isBoolean (obj)</h3>
+
+<p>Is the given argument a boolean ?</p>
+
+
+<pre>
+M.isBoolean(<span class="keyword">true</span>) <span class="comment">-- =&gt; true
+</span>M.isBoolean(<span class="keyword">false</span>) <span class="comment">-- =&gt; true
+</span>M.isBoolean(<span class="number">1</span>==<span class="number">1</span>) <span class="comment">-- =&gt; true
+</span>M.isBoolean(<span class="global">print</span>) <span class="comment">-- =&gt; false</span>
+</pre>
+
+
+<h3>isInteger (obj)</h3>
+
+<p>Is the given argument an integer ?</p>
+
+
+<pre>
+M.isInteger(<span class="global">math</span>.pi) <span class="comment">-- =&gt; false
+</span>M.isInteger(<span class="number">1</span>) <span class="comment">-- =&gt; true
+</span>M.isInteger(-<span class="number">1</span>) <span class="comment">-- =&gt; true</span>
+</pre>
+
+
+<p><strong><a href="#TOC">[⬆]</a></strong></p>
+
+<p><a name="_a_name__chaining__Chaining__a_"></a></p>
+<h2><a name='chaining'>Chaining</a></h2>
+
+<p><em>Method chaining</em> (also known as <em>name parameter idiom</em>), is a technique for invoking consecutively method calls in object-oriented style.
+Each method returns an object, and method calls are chained together.
+Moses offers chaining for your perusal. <br/></p>
+
+<p>Let's use chaining to get the count of evey single word in some lyrics (case won't matter here).</p>
+
+
+
+<pre>
+<span class="keyword">local</span> lyrics = {
+  <span class="string">"I am a lumberjack and I am okay"</span>,
+  <span class="string">"I sleep all night and I work all day"</span>,
+  <span class="string">"He is a lumberjack and he is okay"</span>,
+  <span class="string">"He sleeps all night and he works all day"</span>
+}
+
+<span class="comment">-- split a text into words
+</span><span class="keyword">local</span> <span class="keyword">function</span> words(line)
+  <span class="keyword">local</span> t = {}
+  <span class="keyword">for</span> w <span class="keyword">in</span> line:gmatch(<span class="string">'(%w+)'</span>) <span class="keyword">do</span> t[#t+<span class="number">1</span>] = w <span class="keyword">end</span>
+  <span class="keyword">return</span> t
+<span class="keyword">end</span>
+
+<span class="keyword">local</span> stats = M.chain(lyrics)
+  :map(words)
+  :flatten()
+  :countBy(<span class="global">string</span>.lower)
+  :value()
+
+<span class="comment">-- =&gt; "{
+</span><span class="comment">-- =&gt;    sleep = 1, night = 2, works = 1, am = 2, is = 2,
+</span><span class="comment">-- =&gt;    he = 2, and = 4, I = 4, he = 2, day = 2, a = 2,
+</span><span class="comment">-- =&gt;    work = 1, all = 4, okay = 2
+</span><span class="comment">-- =&gt;  }"</span>
+</pre>
+
+
+<p>For convenience, you can also use <code>M(value)</code> to start chaining methods, instead of <code>M.chain(value)</code>.</p>
+
+<p>Note that one can use <code>:value()</code> to unwrap a chained object.</p>
+
+
+<pre>
+<span class="keyword">local</span> t = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>}
+<span class="global">print</span>(_(t):value() == t) <span class="comment">-- =&gt; true</span>
+</pre>
+
+
+<p><strong><a href="#TOC">[⬆]</a></strong></p>
+
+<p><a name="_a_name__import__Import__a_"></a></p>
+<h2><a name='import'>Import</a></h2>
+
+<p>All library functions can be imported in a context using <a href="index.html#import">import</a> into a specified context.</p>
+
+
+<pre>
+<span class="keyword">local</span> context = {}
+M.import(context)
+
+context.each({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>},<span class="global">print</span>)
+
+<span class="comment">-- =&gt; 1 1
+</span><span class="comment">-- =&gt; 2 2
+</span><span class="comment">-- =&gt; 3 3</span>
+</pre>
+
+
+<p>When no <code>context</code> was provided, it defaults to the current environment, <code>_ENV</code> or <code>_G</code>.</p>
+
+
+<pre>
+M.import()
+
+each({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>},<span class="global">print</span>)
+
+<span class="comment">-- =&gt; 1 1
+</span><span class="comment">-- =&gt; 2 2
+</span><span class="comment">-- =&gt; 3 3</span>
+</pre>
+
+
+<p>Passing <code>noConflict</code> argument leaves untouched conflicting keys while importing into the context.</p>
+
+
+<pre>
+<span class="keyword">local</span> context = {each = <span class="number">1</span>}
+M.import(context, <span class="keyword">true</span>)
+
+<span class="global">print</span>(context.each) <span class="comment">-- =&gt; 1
+</span>context.eachi({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>},<span class="global">print</span>)
+
+<span class="comment">-- =&gt; 1 1
+</span><span class="comment">-- =&gt; 2 2
+</span><span class="comment">-- =&gt; 3 3</span>
+</pre>
+
+
+<p><strong><a href="#TOC">[⬆]</a></strong>
+
+</div> <!-- id="content" -->
+</div> <!-- id="main" -->
+<div id="about">
+<i>generated by <a href="http://github.com/stevedonovan/LDoc">LDoc 1.4.6</a></i>
+<i style="float:right;">Last updated 2018-08-23 10:16:23 </i>
+</div> <!-- id="about" -->
+</div> <!-- id="container" -->
+</body>
+</html>
diff -pruN 1.6.1+git20170613-2/doc/topics/tutorial.md.html 2.0.0-3/doc/topics/tutorial.md.html
--- 1.6.1+git20170613-2/doc/topics/tutorial.md.html	2017-06-03 16:42:55.000000000 +0000
+++ 2.0.0-3/doc/topics/tutorial.md.html	1970-01-01 00:00:00.000000000 +0000
@@ -1,2349 +0,0 @@
-<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
-   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
-<html>
-<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
-<head>
-    <title>Moses documentation</title>
-    <link rel="stylesheet" href="../ldoc.css" type="text/css" />
-</head>
-<body>
-
-<div id="container">
-
-<div id="product">
-	<div id="product_logo"></div>
-	<div id="product_name"><big><b></b></big></div>
-	<div id="product_description"></div>
-</div> <!-- id="product" -->
-
-
-<div id="main">
-
-
-<!-- Menu -->
-
-<div id="navigation">
-<br/>
-<h1>Moses</h1>
-
-
-<h2>Contents</h2>
-<ul>
-<li><a href="#_a_name__table__Table_functions__a_"><a name='table'>Table functions</a> </a></li>
-<li><a href="#_a_name__array__Array_functions__a_"><a name='array'>Array functions</a> </a></li>
-<li><a href="#_a_name__utility__Utility_functions__a_"><a name='utility'>Utility functions</a> </a></li>
-<li><a href="#_a_name__object__Object_functions__a_"><a name='object'>Object functions</a> </a></li>
-<li><a href="#_a_name__chaining__Chaining__a_"><a name='chaining'>Chaining</a> </a></li>
-<li><a href="#_a_name__import__Import__a_"><a name='import'>Import</a> </a></li>
-</ul>
-
-
-<h2>Topics</h2>
-<ul class="">
-  <li><strong>tutorial</strong></li>
-</ul>
-<h2>Modules</h2>
-<ul class="nowrap">
-  <li><a href="../index.html">moses</a></li>
-</ul>
-
-</div>
-
-<div id="content">
-
-    <em>Moses: a utility-belt library for functional programming in Lua</em></p>
-
-<p><strong>Moses</strong> is a Lua utility library which provides support for functional programming.
-It complements built-in Lua functions, making easier common operations on tables, arrays, lists, collections, objects, and a lot more.<br/>
-<strong>Moses</strong> was deeply inspired by <a href="http://documentcloud.github.com/underscore/">Underscore.js</a>. </p>
-
-<h1><a name='TOC'>Table of Contents</a></h1>
-
-<ul>
-<li><a href="#adding">Adding <em>Moses</em> to your project</a></li>
-<li><a href="#table">Table functions</a></li>
-<li><a href="#array">Array functions</a></li>
-<li><a href="#utility">Utility functions</a></li>
-<li><a href="#object">Object functions</a></li>
-<li><a href="#chaining">Chaining</a></li>
-<li><a href="#import">Import</a></li>
-</ul>
-
-
-<h1><a name='adding'>Adding <em>Moses</em> to your project</a></h1>
-
-<p>Drop the file <a href="http://github.com/Yonaba/Moses/blob/master/moses.lua">moses.lua</a> into your project and add it to your code with the <em>require</em> function:</p>
-
-<pre>
-<span class="keyword">local</span> _ = <span class="global">require</span> (<span class="string">"moses"</span>)
-</pre>
-
-
-<p><em>Note: Lua purists tend to use &ldquo;_&rdquo; to design a &ldquo;dummy variable&rdquo;. Here, the usage of this underscore is quite idiomatic and refers to the name <a href="http://documentcloud.github.com/underscore/">Underscore</a>, the JS library from which </em>Moses<em> takes inspiration</em>.</p>
-
-<p><em>Moses</em>&lsquo; provides a large set of functions that can be classified into four categories:</p>
-
-<ul>
-<li><strong>Table functions</strong>, which are mostly meant for tables, i.e Lua tables which contains both an array-part and a hash-part,</li>
-<li><strong>Array functions</strong>, meant for array lists (or sequences),</li>
-<li><strong>Utility functions</strong>,</li>
-<li><strong>Object functions</strong>.</li>
-</ul>
-
-
-<p><strong><a href="#TOC">[⬆]</a></strong></p>
-
-<p><a name="_a_name__table__Table_functions__a_"></a></p>
-
-<h2><a name='table'>Table functions</a></h2>
-
-<h3>clear (t)</h3>
-
-<p>Clears a table. All its values becomes nil. It returns the passed-in table.</p>
-
-<pre>
-<span class="keyword">local</span> t = _.clear({<span class="number">1</span>,<span class="number">2</span>,<span class="string">'hello'</span>,<span class="keyword">true</span>}) <span class="comment">-- =&gt; {}</span>
-</pre>
-
-
-<h3>each (t, f, &hellip;)</h3>
-
-<p><em>Aliases: <code>_.forEach</code></em>.</p>
-
-<p>Iterates over each key-value pair in table.</p>
-
-<pre>
-_.each({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>},<span class="global">print</span>)
-
-<span class="comment">-- =&gt; 1 1
-</span><span class="comment">-- =&gt; 2 2
-</span><span class="comment">-- =&gt; 3 3</span>
-</pre>
-
-
-<p>The table can be map-like (array part and hash-part).</p>
-
-<pre>
-_.each({one = <span class="number">1</span>, two = <span class="number">2</span>, three = <span class="number">3</span>},<span class="global">print</span>)
-
-<span class="comment">-- =&gt; one 1
-</span><span class="comment">-- =&gt; two 2
-</span><span class="comment">-- =&gt; three 3</span>
-</pre>
-
-
-<p>Can index and assign in an outer table or in the passed-in table:</p>
-
-<pre>
-t = {<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>}
-_.each(t,<span class="keyword">function</span>(i,v)
-  t[i] = v:rep(<span class="number">2</span>)
-  <span class="global">print</span>(t[i])
-<span class="keyword">end</span>)
-
-<span class="comment">-- =&gt; 1 aa
-</span><span class="comment">-- =&gt; 2 bb
-</span><span class="comment">-- =&gt; 3 cc</span>
-</pre>
-
-
-<h3>eachi (t, f, &hellip;)</h3>
-
-<p><em>Aliases: <code>_.forEachi</code></em>.</p>
-
-<p>Iterates only on integer keys in a sparse array table.</p>
-
-<pre>
-_.eachi({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>},<span class="global">print</span>)
-
-<span class="comment">-- =&gt; 1 1
-</span><span class="comment">-- =&gt; 2 2
-</span><span class="comment">-- =&gt; 3 3</span>
-</pre>
-
-
-<p>The given array can be sparse, or even have a hash-like part.</p>
-
-<pre>
-<span class="keyword">local</span> t = {a = <span class="number">1</span>, b = <span class="number">2</span>, [<span class="number">0</span>] = <span class="number">1</span>, [-<span class="number">1</span>] = <span class="number">6</span>, <span class="number">3</span>, x = <span class="number">4</span>, <span class="number">5</span>}
-_.eachi(t,<span class="keyword">function</span>(i,v)
-  <span class="global">print</span>(i,v)
-<span class="keyword">end</span>)
-
-<span class="comment">-- =&gt; -1 6
-</span><span class="comment">-- =&gt; 0 1
-</span><span class="comment">-- =&gt; 1 3
-</span><span class="comment">-- =&gt; 2 5</span>
-</pre>
-
-
-<h3>at (t, &hellip;)</h3>
-
-<p>Collects all values at some specific keys and returns them in an array.</p>
-
-<pre>
-<span class="keyword">local</span> t = {<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>}
-_.at(t,<span class="number">1</span>,<span class="number">3</span>) <span class="comment">-- =&gt; "{4,6}"
-</span>
-<span class="keyword">local</span> t = {a = <span class="number">4</span>, bb = <span class="keyword">true</span>, ccc = <span class="keyword">false</span>}
-_.at(t,<span class="string">'a'</span>, <span class="string">'ccc'</span>) <span class="comment">-- =&gt; "{4, false}"</span>
-</pre>
-
-
-<h3>count (t, value)</h3>
-
-<p>Counts the number of occurences of a given value in a table.</p>
-
-<pre>
-_.count({<span class="number">1</span>,<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">3</span>,<span class="number">3</span>,<span class="number">2</span>,<span class="number">4</span>,<span class="number">3</span>,<span class="number">2</span>},<span class="number">1</span>) <span class="comment">-- =&gt; 2
-</span>_.count({<span class="number">1</span>,<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">3</span>,<span class="number">3</span>,<span class="number">2</span>,<span class="number">4</span>,<span class="number">3</span>,<span class="number">2</span>},<span class="number">2</span>) <span class="comment">-- =&gt; 2
-</span>_.count({<span class="number">1</span>,<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">3</span>,<span class="number">3</span>,<span class="number">2</span>,<span class="number">4</span>,<span class="number">3</span>,<span class="number">2</span>},<span class="number">3</span>) <span class="comment">-- =&gt; 4
-</span>_.count({<span class="keyword">false</span>, <span class="keyword">false</span>, <span class="keyword">true</span>},<span class="keyword">false</span>) <span class="comment">-- =&gt; 2
-</span>_.count({<span class="keyword">false</span>, <span class="keyword">false</span>, <span class="keyword">true</span>},<span class="keyword">true</span>) <span class="comment">-- =&gt; 1</span>
-</pre>
-
-
-<p>Returns the size of the list in case no value was provided.</p>
-
-<pre>
-_.count({<span class="number">1</span>,<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">3</span>}) <span class="comment">-- =&gt; 5</span>
-</pre>
-
-
-<h3>countf (t, f, &hellip;)</h3>
-
-<p>Count the number of occurences of all values passing an iterator test.</p>
-
-<pre>
-_.countf({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>}, <span class="keyword">function</span>(i,v)
-  <span class="keyword">return</span> v%<span class="number">2</span>==<span class="number">0</span>
-<span class="keyword">end</span>) <span class="comment">-- =&gt; 3
-</span>
-_.countf({<span class="global">print</span>, <span class="global">pairs</span>, <span class="global">os</span>, <span class="global">assert</span>, <span class="global">ipairs</span>}, <span class="keyword">function</span>(i,v)
-  <span class="keyword">return</span> <span class="global">type</span>(v)==<span class="string">'function'</span>
-<span class="keyword">end</span>) <span class="comment">-- =&gt; 4</span>
-</pre>
-
-
-<h3>cycle (t, n)</h3>
-
-<p><em>Aliases: <code>_.loop</code></em>.</p>
-
-<p>Returns a function which iterates on each key-value pair in a given table (similarly to <code>_.each</code>), except that it restarts iterating again <code>n</code> times.
-If <code>n</code> is not provided, it defaults to 1.</p>
-
-<pre>
-<span class="keyword">local</span> t = {<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>}
-<span class="keyword">for</span> k,v <span class="keyword">in</span> _.cycle(t, <span class="number">2</span>) <span class="keyword">do</span>
-  <span class="global">print</span>(k,v)
-<span class="keyword">end</span>
-
-<span class="comment">-- =&gt; 1 'a'
-</span><span class="comment">-- =&gt; 2 'b'
-</span><span class="comment">-- =&gt; 3 'c'
-</span><span class="comment">-- =&gt; 1 'a'
-</span><span class="comment">-- =&gt; 2 'b'
-</span><span class="comment">-- =&gt; 3 'c'</span>
-</pre>
-
-
-<p>Supports array-like tables and map-like tables.</p>
-
-<pre>
-<span class="keyword">local</span> t = {x = <span class="number">1</span>, y = <span class="number">2</span>, z = <span class="number">3</span>}
-<span class="keyword">for</span> k,v <span class="keyword">in</span> _.cycle(t) <span class="keyword">do</span>
-  <span class="global">print</span>(k,v)
-<span class="keyword">end</span>
-
-<span class="comment">-- =&gt; y    2
-</span><span class="comment">-- =&gt; x 1
-</span><span class="comment">-- =&gt; z 3</span>
-</pre>
-
-
-<h3>map (t, f, &hellip;)</h3>
-
-<p><em>Aliases: <code>_.collect</code></em>.</p>
-
-<p>Executes a function on each key-value pairs.</p>
-
-<pre>
-_.map({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>},<span class="keyword">function</span>(i,v)
-  <span class="keyword">return</span> v+<span class="number">10</span>
-<span class="keyword">end</span>) <span class="comment">-- =&gt; "{11,12,13}"</span>
-</pre>
-
-
-<pre>
-_.map({a = <span class="number">1</span>, b = <span class="number">2</span>},<span class="keyword">function</span>(k,v)
-  <span class="keyword">return</span> k..v
-<span class="keyword">end</span>) <span class="comment">-- =&gt; "{a = 'a1', b = 'b2'}"</span>
-</pre>
-
-
-<p>It also maps key-value pairs to key-value pairs</p>
-
-<pre>
-_.map({a = <span class="number">1</span>, b = <span class="number">2</span>},<span class="keyword">function</span>(k,v)
-  <span class="keyword">return</span> k..k, v*<span class="number">2</span>
-<span class="keyword">end</span>) <span class="comment">-- =&gt; "{aa = 2, bb = 4}"</span>
-</pre>
-
-
-<h3>reduce (t, f, state)</h3>
-
-<p><em>Aliases: <code>_.inject</code>, <code>_.foldl</code></em>.</p>
-
-<p>Can sums all values in a table.</p>
-
-<pre>
-_.reduce({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>},<span class="keyword">function</span>(memo,v)
-  <span class="keyword">return</span> memo+v
-<span class="keyword">end</span>) <span class="comment">-- =&gt; 10</span>
-</pre>
-
-
-<p>Or concatenates all values.</p>
-
-<pre>
-_.reduce({<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>,<span class="string">'d'</span>},<span class="keyword">function</span>(memo,v)
-  <span class="keyword">return</span> memo..v
-<span class="keyword">end</span>) <span class="comment">-- =&gt; abcd    </span>
-</pre>
-
-
-<h3>reduceby (t, f, state, pred, &hellip;)</h3>
-
-<p>Reduces a table considering only values matching a predicate.
-For example,let us define a set of values.</p>
-
-<pre>
-<span class="keyword">local</span> val = {-<span class="number">1</span>, <span class="number">8</span>, <span class="number">0</span>, -<span class="number">6</span>, <span class="number">3</span>, -<span class="number">1</span>, <span class="number">7</span>, <span class="number">1</span>, -<span class="number">9</span>}
-</pre>
-
-
-<p>We can also define some predicate functions.</p>
-
-<pre>
-<span class="comment">-- predicate for negative values
-</span><span class="keyword">local</span> <span class="keyword">function</span> neg(_, v) <span class="keyword">return</span> v&lt;=<span class="number">0</span> <span class="keyword">end</span>
-
-<span class="comment">-- predicate for positive values
-</span><span class="keyword">local</span> <span class="keyword">function</span> pos(_, v) <span class="keyword">return</span> v&gt;=<span class="number">0</span> <span class="keyword">end</span>
-</pre>
-
-
-<p>Then we can perform reduction considering only negative values :</p>
-
-<pre>
-_.reduceby(val, <span class="keyword">function</span>(memo,v)
-  <span class="keyword">return</span> memo+v
-<span class="keyword">end</span>, <span class="number">0</span>, neg) <span class="comment">-- =&gt; -17</span>
-</pre>
-
-
-<p>Or only positive values :</p>
-
-<pre>
-_.reduceby(val, <span class="keyword">function</span>(memo,v)
-  <span class="keyword">return</span> memo+v
-<span class="keyword">end</span>, <span class="number">0</span>, pos) <span class="comment">-- =&gt; 19</span>
-</pre>
-
-
-<h3>reduceRight (t, f, state)</h3>
-
-<p><em>Aliases: <code>_.injectr</code>, <code>_.foldr</code></em>.</p>
-
-<p>Similar to <code>_.reduce</code>, but performs from right to left.</p>
-
-<pre>
-<span class="keyword">local</span> initial_state = <span class="number">256</span>
-_.reduceRight({<span class="number">1</span>,<span class="number">2</span>,<span class="number">4</span>,<span class="number">16</span>},<span class="keyword">function</span>(memo,v)
-  <span class="keyword">return</span> memo/v
-<span class="keyword">end</span>,initial_state) <span class="comment">-- =&gt; 2</span>
-</pre>
-
-
-<h3>mapReduce (t, f, state)</h3>
-
-<p><em>Aliases: <code>_.mapr</code></em>.</p>
-
-<p>Reduces while saving intermediate states.</p>
-
-<pre>
-_.mapReduce({<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>},<span class="keyword">function</span>(memo,v)
-  <span class="keyword">return</span> memo..v
-<span class="keyword">end</span>) <span class="comment">-- =&gt; "{'a', 'ab', 'abc'}"</span>
-</pre>
-
-
-<h3>mapReduceRight (t, f, state)</h3>
-
-<p><em>Aliases: <code>_.maprr</code></em>.</p>
-
-<p>Reduces from right to left, while saving intermediate states.</p>
-
-<pre>
-_.mapReduceRight({<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>},<span class="keyword">function</span>(memo,v)
-  <span class="keyword">return</span> memo..v
-<span class="keyword">end</span>) <span class="comment">-- =&gt; "{'c', 'cb', 'cba'}"</span>
-</pre>
-
-
-<h3>include (t, value)</h3>
-
-<p><em>Aliases: <code>_.any</code>, <code>_.some</code>, <code>_.contains</code></em>.</p>
-
-<p>Looks for a value in a table.</p>
-
-<pre>
-_.include({<span class="number">6</span>,<span class="number">8</span>,<span class="number">10</span>,<span class="number">16</span>,<span class="number">29</span>},<span class="number">16</span>) <span class="comment">-- =&gt; true
-</span>_.include({<span class="number">6</span>,<span class="number">8</span>,<span class="number">10</span>,<span class="number">16</span>,<span class="number">29</span>},<span class="number">1</span>) <span class="comment">-- =&gt; false
-</span>
-<span class="keyword">local</span> complex_table = {<span class="number">18</span>,{<span class="number">2</span>,{<span class="number">3</span>}}}
-<span class="keyword">local</span> collection = {<span class="number">6</span>,{<span class="number">18</span>,{<span class="number">2</span>,<span class="number">6</span>}},<span class="number">10</span>,{<span class="number">18</span>,{<span class="number">2</span>,{<span class="number">3</span>}}},<span class="number">29</span>}
-_.include(collection, complex_table) <span class="comment">-- =&gt; true</span>
-</pre>
-
-
-<p>Handles iterator functions.</p>
-
-<pre>
-<span class="keyword">local</span> <span class="keyword">function</span> isUpper(v) <span class="keyword">return</span> v:upper()== v <span class="keyword">end</span>
-_.include({<span class="string">'a'</span>,<span class="string">'B'</span>,<span class="string">'c'</span>},isUpper) <span class="comment">-- =&gt; true</span>
-</pre>
-
-
-<h3>detect (t, value)</h3>
-
-<p>Returns the index of a value in a table.</p>
-
-<pre>
-_.detect({<span class="number">6</span>,<span class="number">8</span>,<span class="number">10</span>,<span class="number">16</span>},<span class="number">8</span>) <span class="comment">-- =&gt; 2
-</span>_.detect({<span class="keyword">nil</span>,<span class="keyword">true</span>,<span class="number">0</span>,<span class="keyword">true</span>,<span class="keyword">true</span>},<span class="keyword">false</span>) <span class="comment">-- =&gt; nil
-</span>
-<span class="keyword">local</span> complex_table = {<span class="number">18</span>,{<span class="number">2</span>,<span class="number">6</span>}}
-<span class="keyword">local</span> collection = {<span class="number">6</span>,{<span class="number">18</span>,{<span class="number">2</span>,<span class="number">6</span>}},<span class="number">10</span>,{<span class="number">18</span>,{<span class="number">2</span>,{<span class="number">3</span>}}},<span class="number">29</span>}
-_.detect(collection, complex_table) <span class="comment">-- =&gt; 2</span>
-</pre>
-
-
-<p>Handles iterator functions.</p>
-
-<pre>
-<span class="keyword">local</span> <span class="keyword">function</span> isUpper(v)
-  <span class="keyword">return</span> v:upper()==v
-<span class="keyword">end</span>
-_.detect({<span class="string">'a'</span>,<span class="string">'B'</span>,<span class="string">'c'</span>},isUpper) <span class="comment">-- =&gt; 2</span>
-</pre>
-
-
-<h3>where (t, props)</h3>
-
-<p>Looks through a table and returns all the values that matches all of the key-value pairs listed in <code>props</code>. </p>
-
-<pre>
-<span class="keyword">local</span> tA = {a = <span class="number">1</span>, b = <span class="number">2</span>, c = <span class="number">0</span>}
-<span class="keyword">local</span> tB = {a = <span class="number">1</span>, b = <span class="number">4</span>, c = <span class="number">1</span>}
-<span class="keyword">local</span> tC = {a = <span class="number">4</span>, b = <span class="number">4</span>, c = <span class="number">3</span>}
-<span class="keyword">local</span> tD = {a = <span class="number">1</span>, b = <span class="number">2</span>, c = <span class="number">3</span>}
-<span class="keyword">local</span> found = _.where({tA, tB, tC, tD}, {a = <span class="number">1</span>})
-
-<span class="comment">-- =&gt; found = {tA, tB, tD}
-</span>
-found = _.where({tA, tB, tC, tD}, {b = <span class="number">4</span>})
-
-<span class="comment">-- =&gt; found = {tB, tC}
-</span>
-found = _.where({tA, tB, tC, tD}, {b = <span class="number">4</span>, c = <span class="number">3</span>})
-
-<span class="comment">-- =&gt; found = {tC}</span>
-</pre>
-
-
-<h3>findWhere (t, props)</h3>
-
-<p>Looks through a table and returns the first value that matches all of the key-value pairs listed in <code>props</code>. </p>
-
-<pre>
-<span class="keyword">local</span> a = {a = <span class="number">1</span>, b = <span class="number">2</span>, c = <span class="number">3</span>}
-<span class="keyword">local</span> b = {a = <span class="number">2</span>, b = <span class="number">3</span>, d = <span class="number">4</span>}
-<span class="keyword">local</span> c = {a = <span class="number">3</span>, b = <span class="number">4</span>, e = <span class="number">5</span>}
-_.findWhere({a, b, c}, {a = <span class="number">3</span>, b = <span class="number">4</span>}) == c <span class="comment">-- =&gt; true</span>
-</pre>
-
-
-<h3>select (t, f, &hellip;)</h3>
-
-<p><em>Aliases: <code>_.filter</code></em>.</p>
-
-<p>Collects values passing a validation test.</p>
-
-<pre>
-<span class="comment">-- Even values
-</span>_.<span class="global">select</span>({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>,<span class="number">7</span>}, <span class="keyword">function</span>(key,value)
-  <span class="keyword">return</span> (value%<span class="number">2</span>==<span class="number">0</span>)
-<span class="keyword">end</span>) <span class="comment">-- =&gt; "{2,4,6}"
-</span>
-<span class="comment">-- Odd values
-</span>_.<span class="global">select</span>({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>,<span class="number">7</span>}, <span class="keyword">function</span>(key,value)
-  <span class="keyword">return</span> (value%<span class="number">2</span>~=<span class="number">0</span>)
-<span class="keyword">end</span>) <span class="comment">-- =&gt; "{1,3,5,7}"</span>
-</pre>
-
-
-<h3>reject (t, f, &hellip;)</h3>
-
-<p><em>Aliases: <code>_.reject</code></em>.</p>
-
-<p>Removes all values failing a validation test:</p>
-
-<pre>
-_.reject({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>,<span class="number">7</span>}, <span class="keyword">function</span>(key,value)
-  <span class="keyword">return</span> (value%<span class="number">2</span>==<span class="number">0</span>)
-<span class="keyword">end</span>) <span class="comment">-- =&gt; "{1,3,5,7}"
-</span>
-_.reject({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>,<span class="number">7</span>}, <span class="keyword">function</span>(key,value)
-  <span class="keyword">return</span> (value%<span class="number">2</span>~=<span class="number">0</span>)
-<span class="keyword">end</span>) <span class="comment">-- =&gt; "{2,4,6}"</span>
-</pre>
-
-
-<h3>all (t, f, &hellip;)</h3>
-
-<p><em>Aliases: <code>_.every</code></em>.</p>
-
-<p>Checks whether or not all elements pass a validation test.</p>
-
-<pre>
-_.all({<span class="number">2</span>,<span class="number">4</span>,<span class="number">6</span>}, <span class="keyword">function</span>(key,value)
-  <span class="keyword">return</span> (value%<span class="number">2</span>==<span class="number">0</span>)
-<span class="keyword">end</span>) <span class="comment">-- =&gt; true</span>
-</pre>
-
-
-<h3>invoke (t, method, &hellip;)</h3>
-
-<p>Invokes a given function on each value in a table</p>
-
-<pre>
-_.invoke({<span class="string">'a'</span>,<span class="string">'bea'</span>,<span class="string">'cdhza'</span>},<span class="global">string</span>.len) <span class="comment">-- =&gt; "{1,3,5}"</span>
-</pre>
-
-
-<p>Can reference the method of the same name in each value.</p>
-
-<pre>
-<span class="keyword">local</span> a = {}
-<span class="keyword">function</span> a:call() <span class="keyword">return</span> <span class="string">'a'</span> <span class="keyword">end</span>
-<span class="keyword">local</span> b, c, d = {}, {}, {}
-b.call, c.call, d.call = a.call, a.call, a.call
-
-_.invoke({a,b,c,d},<span class="string">'call'</span>) <span class="comment">-- =&gt; "{'a','a','a','a'}"</span>
-</pre>
-
-
-<h3>pluck (t, property)</h3>
-
-<p>Fetches all values indexed with specific key in a table of objects.</p>
-
-<pre>
-<span class="keyword">local</span> peoples = {
-  {name = <span class="string">'John'</span>, age = <span class="number">23</span>},{name = <span class="string">'Peter'</span>, age = <span class="number">17</span>},
-  {name = <span class="string">'Steve'</span>, age = <span class="number">15</span>},{age = <span class="number">33</span>}}
-
-_.pluck(peoples,<span class="string">'age'</span>) <span class="comment">-- =&gt; "{23,17,15,33}"
-</span>_.pluck(peoples,<span class="string">'name'</span>) <span class="comment">-- =&gt; "{'John', 'Peter', 'Steve'}"</span>
-</pre>
-
-
-<h3>max (t, transform, &hellip;)</h3>
-
-<p>Returns the maximum value in a collection.</p>
-
-<pre>
-_.max {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>} <span class="comment">-- =&gt; 3
-</span>_.max {<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>} <span class="comment">-- =&gt; 'c'</span>
-</pre>
-
-
-<p>Can take an iterator function to extract a specific property.</p>
-
-<pre>
-<span class="keyword">local</span> peoples = {
-  {name = <span class="string">'John'</span>, age = <span class="number">23</span>},{name = <span class="string">'Peter'</span>, age = <span class="number">17</span>},
-  {name = <span class="string">'Steve'</span>, age = <span class="number">15</span>},{age = <span class="number">33</span>}}
-_.max(peoples,<span class="keyword">function</span>(people) <span class="keyword">return</span> people.age <span class="keyword">end</span>) <span class="comment">-- =&gt; 33</span>
-</pre>
-
-
-<h3>min (t, transform, &hellip;)</h3>
-
-<p>Returns the minimum value in a collection.</p>
-
-<pre>
-_.min {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>} <span class="comment">-- =&gt; 1
-</span>_.min {<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>} <span class="comment">-- =&gt; 'a'</span>
-</pre>
-
-
-<p>Can take an iterator function to extract a specific property.</p>
-
-<pre>
-<span class="keyword">local</span> peoples = {
-  {name = <span class="string">'John'</span>, age = <span class="number">23</span>},{name = <span class="string">'Peter'</span>, age = <span class="number">17</span>},
-  {name = <span class="string">'Steve'</span>, age = <span class="number">15</span>},{age = <span class="number">33</span>}}
-_.min(peoples,<span class="keyword">function</span>(people) <span class="keyword">return</span> people.age <span class="keyword">end</span>) <span class="comment">-- =&gt; 15</span>
-</pre>
-
-
-<h3>shuffle (t, seed)</h3>
-
-<p>Shuffles a collection.</p>
-
-<pre>
-<span class="keyword">local</span> list = _.shuffle {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>} <span class="comment">-- =&gt; "{3,2,6,4,1,5}"
-</span>_.each(list,<span class="global">print</span>)
-</pre>
-
-
-<h3>same (a, b)</h3>
-
-<p>Tests whether or not all values in each of the passed-in tables exists in both tables.</p>
-
-<pre>
-<span class="keyword">local</span> a = {<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>,<span class="string">'d'</span>}
-<span class="keyword">local</span> b = {<span class="string">'b'</span>,<span class="string">'a'</span>,<span class="string">'d'</span>,<span class="string">'c'</span>}
-_.same(a,b) <span class="comment">-- =&gt; true
-</span>
-b[#b+<span class="number">1</span>] = <span class="string">'e'</span>
-_.same(a,b) <span class="comment">-- =&gt; false</span>
-</pre>
-
-
-<h3>sort (t, comp)</h3>
-
-<p>Sorts a collection.</p>
-
-<pre>
-_.sort({<span class="string">'b'</span>,<span class="string">'a'</span>,<span class="string">'d'</span>,<span class="string">'c'</span>}) <span class="comment">-- =&gt; "{'a','b','c','d'}"</span>
-</pre>
-
-
-<p>Handles custom comparison functions.</p>
-
-<pre>
-_.sort({<span class="string">'b'</span>,<span class="string">'a'</span>,<span class="string">'d'</span>,<span class="string">'c'</span>}, <span class="keyword">function</span>(a,b)
-  <span class="keyword">return</span> a:byte() &gt; b:byte()
-<span class="keyword">end</span>) <span class="comment">-- =&gt; "{'d','c','b','a'}"</span>
-</pre>
-
-
-<h3>sortBy (t, transform, comp)</h3>
-
-<p>Sorts items in a collection based on the result of running a transform function through every item in the collection.</p>
-
-<pre>
-<span class="keyword">local</span> r = _.sortBy({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>}, <span class="global">math</span>.sin)
-<span class="global">print</span>(<span class="global">table</span>.concat(r,<span class="string">','</span>))
-
-<span class="comment">-- =&gt; {5,4,3,1,2}</span>
-</pre>
-
-
-<p>The transform function can also be a string name property.</p>
-
-<pre>
-<span class="keyword">local</span> people ={
-    {name = <span class="string">'albert'</span>, age = <span class="number">40</span>},
-    {name = <span class="string">'louis'</span>, age = <span class="number">55</span>},
-    {name = <span class="string">'steve'</span>, age = <span class="number">35</span>},
-    {name = <span class="string">'henry'</span>, age = <span class="number">19</span>},
-}
-<span class="keyword">local</span> r = _.sortBy(people, <span class="string">'age'</span>)
-_.each(r, <span class="keyword">function</span>(__,v) <span class="global">print</span>(v.age, v.name)  <span class="keyword">end</span>)
-
-<span class="comment">-- =&gt; 19   henry
-</span><span class="comment">-- =&gt; 35    steve
-</span><span class="comment">-- =&gt; 40    albert
-</span><span class="comment">-- =&gt; 55    louis</span>
-</pre>
-
-
-<p>As seen above, the defaut comparison function is the &lsquo;&lt;&rsquo; operator. For example, let us supply a different one to sort
-the list of people by decreasing age order :</p>
-
-<pre>
-<span class="keyword">local</span> people ={
-    {name = <span class="string">'albert'</span>, age = <span class="number">40</span>},
-    {name = <span class="string">'louis'</span>, age = <span class="number">55</span>},
-    {name = <span class="string">'steve'</span>, age = <span class="number">35</span>},
-    {name = <span class="string">'henry'</span>, age = <span class="number">19</span>},
-}
-<span class="keyword">local</span> r = _.sortBy(people, <span class="string">'age'</span>, <span class="keyword">function</span>(a,b) <span class="keyword">return</span> a &gt; b <span class="keyword">end</span>)
-_.each(r, <span class="keyword">function</span>(__,v) <span class="global">print</span>(v.age, v.name)  <span class="keyword">end</span>)
-
-<span class="comment">-- =&gt; 55   louis
-</span><span class="comment">-- =&gt; 40    albert
-</span><span class="comment">-- =&gt; 35    steve
-</span><span class="comment">-- =&gt; 19    henry</span>
-</pre>
-
-
-<p>The <code>transform</code> function defaults to <code>_.indentity</code> and in that case, <code>_.sortBy</code> behaves like <code>_.sort</code>.</p>
-
-<pre>
-<span class="keyword">local</span> r = _.sortBy({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>})
-<span class="global">print</span>(<span class="global">table</span>.concat(r,<span class="string">','</span>))
-
-<span class="comment">-- =&gt; {1,2,3,4,5}</span>
-</pre>
-
-
-<h3>groupBy (t, iter, &hellip;)</h3>
-
-<p>Groups values in a collection depending on their return value when passed to a predicate test.</p>
-
-<pre>
-_.groupBy({<span class="number">0</span>,<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>},<span class="keyword">function</span>(i,value)
-  <span class="keyword">return</span> value%<span class="number">2</span>==<span class="number">0</span> <span class="keyword">and</span> <span class="string">'even'</span> <span class="keyword">or</span> <span class="string">'odd'</span>
-<span class="keyword">end</span>) <span class="comment">-- =&gt; "{odd = {1,3,5}, even = {0,2,4,6}}"
-</span>
-_.groupBy({<span class="number">0</span>,<span class="string">'a'</span>,<span class="keyword">true</span>, <span class="keyword">false</span>,<span class="keyword">nil</span>,b,<span class="number">0.5</span>},<span class="keyword">function</span>(i,value)
-  <span class="keyword">return</span> <span class="global">type</span>(value)
-<span class="keyword">end</span>) <span class="comment">-- =&gt; "{number = {0,0.5}, string = {'a'}, boolean = {true, false}}"      </span>
-</pre>
-
-
-<h3>countBy (t, iter, &hellip;)</h3>
-
-<p>Splits a table in subsets and provide the count for each subset.</p>
-
-<pre>
-_.countBy({<span class="number">0</span>,<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>},<span class="keyword">function</span>(i,value)
-  <span class="keyword">return</span> value%<span class="number">2</span>==<span class="number">0</span> <span class="keyword">and</span> <span class="string">'even'</span> <span class="keyword">or</span> <span class="string">'odd'</span>
-<span class="keyword">end</span>) <span class="comment">-- =&gt; "{odd = 3, even = 4}"</span>
-</pre>
-
-
-<h3>size (&hellip;)</h3>
-
-<p>When given a table, provides the count for the very number of values in that table.</p>
-
-<pre>
-_.size {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>} <span class="comment">-- =&gt; 3
-</span>_.size {one = <span class="number">1</span>, two = <span class="number">2</span>} <span class="comment">-- =&gt; 2</span>
-</pre>
-
-
-<p>When given a vararg list of argument, returns the count of these arguments.</p>
-
-<pre>
-_.size(<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>) <span class="comment">-- =&gt; 3
-</span>_.size(<span class="string">'a'</span>,<span class="string">'b'</span>,{}, <span class="keyword">function</span>() <span class="keyword">end</span>) <span class="comment">-- =&gt; 4</span>
-</pre>
-
-
-<h3>containsKeys (t, other)</h3>
-
-<p>Checks whether a table has all the keys existing in another table.</p>
-
-<pre>
-_.contains({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>},{<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>}) <span class="comment">-- =&gt; true
-</span>_.contains({<span class="number">1</span>,<span class="number">2</span>,<span class="string">'d'</span>,<span class="string">'b'</span>},{<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">5</span>}) <span class="comment">-- =&gt; true
-</span>_.contains({x = <span class="number">1</span>, y = <span class="number">2</span>, z = <span class="number">3</span>},{x = <span class="number">1</span>, y = <span class="number">2</span>}) <span class="comment">-- =&gt; true</span>
-</pre>
-
-
-<h3>sameKeys (tA, tB)</h3>
-
-<p>Checks whether both tables features the same keys:</p>
-
-<pre>
-_.sameKeys({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>},{<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>}) <span class="comment">-- =&gt; false
-</span>_.sameKeys({<span class="number">1</span>,<span class="number">2</span>,<span class="string">'d'</span>,<span class="string">'b'</span>},{<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">5</span>}) <span class="comment">-- =&gt; true
-</span>_.sameKeys({x = <span class="number">1</span>, y = <span class="number">2</span>, z = <span class="number">3</span>},{x = <span class="number">1</span>, y = <span class="number">2</span>}) <span class="comment">-- =&gt; false</span>
-</pre>
-
-
-<p><strong><a href="#TOC">[⬆]</a></strong></p>
-
-<p><a name="_a_name__array__Array_functions__a_"></a></p>
-
-<h2><a name='array'>Array functions</a></h2>
-
-<h3>sample (array, n, seed)</h3>
-
-<p>Samples <code>n</code> values from array.</p>
-
-<pre>
-<span class="keyword">local</span> array = _.range(<span class="number">1</span>,<span class="number">20</span>)
-<span class="keyword">local</span> sample = _.sample(array, <span class="number">3</span>)
-<span class="global">print</span>(<span class="global">table</span>.concat(sample,<span class="string">','</span>))
-
-<span class="comment">-- =&gt; {12,11,15}</span>
-</pre>
-
-
-<p><code>n</code> defaults to 1. In that case, a single value will be returned.</p>
-
-<pre>
-<span class="keyword">local</span> array = _.range(<span class="number">1</span>,<span class="number">20</span>)
-<span class="keyword">local</span> sample = _.sample(array)
-<span class="global">print</span>(sample)
-
-<span class="comment">-- =&gt; 12</span>
-</pre>
-
-
-<p>An optional 3rd argument <code>seed</code> can be passed for deterministic random sampling.</p>
-
-<h3>sampleProb (array, prob, seed)</h3>
-
-<p>Returns an array of values randomly selected from a given array.
-In case <code>seed</code> is provided, it is used for deterministic sampling.</p>
-
-<pre>
-<span class="keyword">local</span> array = _.range(<span class="number">1</span>,<span class="number">20</span>)
-<span class="keyword">local</span> sample = _.sampleProb(array, <span class="number">0.2</span>)
-<span class="global">print</span>(<span class="global">table</span>.concat(sample,<span class="string">','</span>))
-
-<span class="comment">-- =&gt; 5,11,12,15
-</span>
-sample = _.sampleProb(array, <span class="number">0.2</span>, <span class="global">os</span>.time())
-<span class="global">print</span>(<span class="global">table</span>.concat(sample,<span class="string">','</span>))
-
-<span class="comment">-- =&gt; 1,6,10,12,15,20 (or similar)</span>
-</pre>
-
-
-<h3>toArray (&hellip;)</h3>
-
-<p>Converts a vararg list of arguments to an array.</p>
-
-<pre>
-_.toArray(<span class="number">1</span>,<span class="number">2</span>,<span class="number">8</span>,<span class="string">'d'</span>,<span class="string">'a'</span>,<span class="number">0</span>) <span class="comment">-- =&gt; "{1,2,8,'d','a',0}"</span>
-</pre>
-
-
-<h3>find (array, value, from)</h3>
-
-<p>Looks for a value in a given array and returns the position of the first occurence.</p>
-
-<pre>
-_.find({{<span class="number">4</span>},{<span class="number">3</span>},{<span class="number">2</span>},{<span class="number">1</span>}},{<span class="number">3</span>}) <span class="comment">-- =&gt; 2</span>
-</pre>
-
-
-<p>It can also start the search at a specific position in the array:</p>
-
-<pre>
-<span class="comment">-- search value 4 starting from index 3
-</span>_.find({<span class="number">1</span>,<span class="number">4</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>},<span class="number">4</span>,<span class="number">3</span>) <span class="comment">-- =&gt; 5</span>
-</pre>
-
-
-<h3>reverse (array)</h3>
-
-<p>Reverses an array.</p>
-
-<pre>
-_.reverse({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="string">'d'</span>}) <span class="comment">-- =&gt; "{'d',3,2,1}"</span>
-</pre>
-
-
-<h3>fill (array, value, i, j)</h3>
-
-<p>Replaces all elements in a given array with a given value.</p>
-
-<pre>
-<span class="keyword">local</span> array = _.range(<span class="number">1</span>,<span class="number">5</span>)
-_.fill(array, <span class="number">0</span>) <span class="comment">-- =&gt; {0,0,0,0,0}</span>
-</pre>
-
-
-<p>It can start replacing value at a specific index.</p>
-
-<pre>
-<span class="keyword">local</span> array = _.range(<span class="number">1</span>,<span class="number">5</span>)
-_.fill(array,<span class="number">0</span>,<span class="number">3</span>) <span class="comment">-- =&gt; {1,2,0,0,0}</span>
-</pre>
-
-
-<p>It can replace only values within a specific range.</p>
-
-<pre>
-<span class="keyword">local</span> array = _.range(<span class="number">1</span>,<span class="number">5</span>)
-_.fill(array,<span class="number">0</span>,<span class="number">2</span>,<span class="number">4</span>) <span class="comment">-- =&gt; {1,0,0,0,5}</span>
-</pre>
-
-
-<p>In case the upper bound index i greather than the array size, it will enlarge the array.</p>
-
-<pre>
-<span class="keyword">local</span> array = _.range(<span class="number">1</span>,<span class="number">5</span>)
-_.fill(array,<span class="number">0</span>,<span class="number">5</span>,<span class="number">10</span>) <span class="comment">-- =&gt; {1,2,3,4,0,0,0,0,0,0}</span>
-</pre>
-
-
-<h3>selectWhile (array, f, &hellip;</h3>
-
-<p><em>Aliases: <code>_.takeWhile</code></em>.</p>
-
-<p>Collects values as long as they pass a given test. Stops on the first non-passing test.</p>
-
-<pre>
-_.selectWhile({<span class="number">2</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">8</span>}, <span class="keyword">function</span>(i,v)
-  <span class="keyword">return</span> v%<span class="number">2</span>==<span class="number">0</span>
-<span class="keyword">end</span>) <span class="comment">-- =&gt; "{2,4}"</span>
-</pre>
-
-
-<h3>dropWhile (array, f, &hellip;</h3>
-
-<p><em>Aliases: <code>_.rejectWhile</code></em>.</p>
-
-<p>Removes values as long as they pass a given test. Stops on the first non-passing test.</p>
-
-<pre>
-_.dropWhile({<span class="number">2</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">8</span>}, <span class="keyword">function</span>(i,v)
-  <span class="keyword">return</span> v%<span class="number">2</span>==<span class="number">0</span>
-<span class="keyword">end</span>) <span class="comment">-- =&gt; "{5,8}"</span>
-</pre>
-
-
-<h3>sortedIndex (array, value, comp, sort)</h3>
-
-<p>Returns the index at which a value should be inserted to preserve order.</p>
-
-<pre>
-_.sortedIndex({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>},<span class="number">4</span>) <span class="comment">-- =&gt; 4</span>
-</pre>
-
-
-<p>Can take a custom comparison functions.</p>
-
-<pre>
-<span class="keyword">local</span> comp = <span class="keyword">function</span>(a,b) <span class="keyword">return</span> a&lt;b <span class="keyword">end</span>
-_.sortedIndex({-<span class="number">5</span>,<span class="number">0</span>,<span class="number">4</span>,<span class="number">4</span>},<span class="number">3</span>,comp) <span class="comment">-- =&gt; 3</span>
-</pre>
-
-
-<h3>indexOf (array, value)</h3>
-
-<p>Returns the index of a value in an array.</p>
-
-<pre>
-_.indexOf({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>},<span class="number">2</span>) <span class="comment">-- =&gt; 2</span>
-</pre>
-
-
-<h3>lastIndexOf (array, value)</h3>
-
-<p>Returns the index of the last occurence of a given value in an array.</p>
-
-<pre>
-_.lastIndexOf({<span class="number">1</span>,<span class="number">2</span>,<span class="number">2</span>,<span class="number">3</span>},<span class="number">2</span>) <span class="comment">-- =&gt; 3</span>
-</pre>
-
-
-<h3>findIndex (array, predicate, &hellip;)</h3>
-
-<p>Returns the first index at which a predicate passes a truth test.</p>
-
-<pre>
-<span class="keyword">local</span> array = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>}
-<span class="keyword">local</span> <span class="keyword">function</span> multipleOf3(__,v) <span class="keyword">return</span> v%<span class="number">3</span>==<span class="number">0</span> <span class="keyword">end</span>
-_.findIndex(array, multipleOf3) <span class="comment">-- =&gt; 3</span>
-</pre>
-
-
-<h3>findLastIndex (array, predicate, &hellip;)</h3>
-
-<p>Returns the last index at which a predicate passes a truth test.</p>
-
-<pre>
-<span class="keyword">local</span> array = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>}
-<span class="keyword">local</span> <span class="keyword">function</span> multipleOf3(__,v) <span class="keyword">return</span> v%<span class="number">3</span>==<span class="number">0</span> <span class="keyword">end</span>
-_.findLastIndex(array, multipleOf3) <span class="comment">-- =&gt; 6</span>
-</pre>
-
-
-<h3>addTop (array, &hellip;)</h3>
-
-<p>Adds given values at the top of an array. The latter values bubbles at the top.</p>
-
-<pre>
-<span class="keyword">local</span> array = {<span class="number">1</span>}
-_.addTop(array,<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>) <span class="comment">-- =&gt; "{4,3,2,1,1}"</span>
-</pre>
-
-
-<h3>push (array, &hellip;)</h3>
-
-<p>Adds given values at the end of an array.</p>
-
-<pre>
-<span class="keyword">local</span> array = {<span class="number">1</span>}
-_.push(array,<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>) <span class="comment">-- =&gt; "{1,1,2,3,4}"</span>
-</pre>
-
-
-<h3>pop (array, n)</h3>
-
-<p><em>Aliases: <code>_.shift</code></em>.</p>
-
-<p>Removes and returns the first value in an array.</p>
-
-<pre>
-<span class="keyword">local</span> array = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>}
-<span class="keyword">local</span> pop = _.pop(array) <span class="comment">-- =&gt; "pop = 1", "array = {2,3}"</span>
-</pre>
-
-
-<h3>unshift (array, n)</h3>
-
-<p>Removes and returns the last value in an array.</p>
-
-<pre>
-<span class="keyword">local</span> array = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>}
-<span class="keyword">local</span> value = _.unshift(array) <span class="comment">-- =&gt; "value = 3", "array = {1,2}"</span>
-</pre>
-
-
-<h3>pull (array, &hellip;)</h3>
-
-<p><em>Aliases: <code>_.remove</code></em>.</p>
-
-<p>Removes all provided values from a given array.</p>
-
-<pre>
-_.pull({<span class="number">1</span>,<span class="number">2</span>,<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">3</span>},<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>) <span class="comment">-- =&gt; "{4}"</span>
-</pre>
-
-
-<h3>removeRange (array, start, finish)</h3>
-
-<p><em>Aliases: <code>_.rmRange</code>, <code>_.chop</code></em>.</p>
-
-<p>Trims out all values index within a range.</p>
-
-<pre>
-<span class="keyword">local</span> array = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>,<span class="number">7</span>,<span class="number">8</span>,<span class="number">9</span>}
-_.removeRange(array, <span class="number">3</span>,<span class="number">8</span>) <span class="comment">-- =&gt; "{1,2,9}"</span>
-</pre>
-
-
-<h3>chunk (array, f, &hellip;)</h3>
-
-<p>Iterates over an array aggregating consecutive values in subsets tables, on the basis of the return
-value of <code>f(key,value,&hellip;)</code>. Consecutive elements which return the same value are aggregated together.</p>
-
-<pre>
-<span class="keyword">local</span> t = {<span class="number">1</span>,<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">3</span>,<span class="number">4</span>}
-_.chunk(t, <span class="keyword">function</span>(k,v) <span class="keyword">return</span> v%<span class="number">2</span>==<span class="number">0</span> <span class="keyword">end</span>) <span class="comment">-- =&gt; "{{1,1},{2},{3,3},{4}}"</span>
-</pre>
-
-
-<h3>slice (array, start, finish)</h3>
-
-<p><em>Aliases: <code>_.sub</code></em>.</p>
-
-<p>Slices and returns a part of an array.</p>
-
-<pre>
-<span class="keyword">local</span> array = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>,<span class="number">7</span>,<span class="number">8</span>,<span class="number">9</span>}
-_.slice(array, <span class="number">3</span>,<span class="number">6</span>) <span class="comment">-- =&gt; "{3,4,5,6}"</span>
-</pre>
-
-
-<h3>first (array, n)</h3>
-
-<p><em>Aliases: <code>_.head</code>, <code>_.take</code></em>.</p>
-
-<p>Returns the first N elements in an array.</p>
-
-<pre>
-<span class="keyword">local</span> array = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>,<span class="number">7</span>,<span class="number">8</span>,<span class="number">9</span>}
-_.first(array,<span class="number">3</span>) <span class="comment">-- =&gt; "{1,2,3}"</span>
-</pre>
-
-
-<h3>initial (array, n)</h3>
-
-<p>Excludes the last N elements in an array.</p>
-
-<pre>
-<span class="keyword">local</span> array = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>,<span class="number">7</span>,<span class="number">8</span>,<span class="number">9</span>}
-_.initial(array,<span class="number">5</span>) <span class="comment">-- =&gt; "{1,2,3,4}"</span>
-</pre>
-
-
-<h3>last (array, n)</h3>
-
-<p><em>Aliases: <code>_.skip</code></em>.</p>
-
-<p>Returns the last N elements in an array.</p>
-
-<pre>
-<span class="keyword">local</span> array = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>,<span class="number">7</span>,<span class="number">8</span>,<span class="number">9</span>}
-_.last(array,<span class="number">3</span>) <span class="comment">-- =&gt; "{7,8,9}"</span>
-</pre>
-
-
-<h3>rest (array, index)</h3>
-
-<p><em>Aliases: <code>_.tail</code></em>.</p>
-
-<p>Trims out all values indexed before <em>index</em>.</p>
-
-<pre>
-<span class="keyword">local</span> array = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>,<span class="number">7</span>,<span class="number">8</span>,<span class="number">9</span>}
-_.rest(array,<span class="number">6</span>) <span class="comment">-- =&gt; "{6,7,8,9}"</span>
-</pre>
-
-
-<h3>nth (array, index)</h3>
-
-<p>Returns the value at <em>index</em>.</p>
-
-<pre>
-<span class="keyword">local</span> array = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>}
-_.nth(array,<span class="number">3</span>) <span class="comment">-- =&gt; "3"</span>
-</pre>
-
-
-<h3>compact (array)</h3>
-
-<p>Trims out all falsy values.</p>
-
-<pre>
-_.compact {a,<span class="string">'aa'</span>,<span class="keyword">false</span>,<span class="string">'bb'</span>,<span class="keyword">true</span>} <span class="comment">-- =&gt; "{'aa','bb',true}"</span>
-</pre>
-
-
-<h3>flatten (array, shallow)</h3>
-
-<p>Flattens a nested array.</p>
-
-<pre>
-_.flatten({<span class="number">1</span>,{<span class="number">2</span>,<span class="number">3</span>},{<span class="number">4</span>,<span class="number">5</span>,{<span class="number">6</span>,<span class="number">7</span>}}}) <span class="comment">-- =&gt; "{1,2,3,4,5,6,7}"</span>
-</pre>
-
-
-<p>When given arg &ldquo;shallow&rdquo;, flatten only at the first level.</p>
-
-<pre>
-_.flatten({<span class="number">1</span>,{<span class="number">2</span>},{{<span class="number">3</span>}}},<span class="keyword">true</span>) <span class="comment">-- =&gt; "{1,{2},{{3}}}"</span>
-</pre>
-
-
-<h3>difference (array, array2)</h3>
-
-<p><em>Aliases: <code>_.without</code>, <code>_.diff</code></em>.</p>
-
-<p>Returns values in the given array not present in a second array.</p>
-
-<pre>
-<span class="keyword">local</span> array = {<span class="number">1</span>,<span class="number">2</span>,<span class="string">'a'</span>,<span class="number">4</span>,<span class="number">5</span>}
-_.difference(array,{<span class="number">1</span>,<span class="string">'a'</span>}) <span class="comment">-- =&gt; "{2,4,5}"</span>
-</pre>
-
-
-<h3>union (&hellip;)</h3>
-
-<p>Produces a duplicate-free union of all passed-in arrays.</p>
-
-<pre>
-<span class="keyword">local</span> A = {<span class="string">'a'</span>}
-<span class="keyword">local</span> B = {<span class="string">'a'</span>,<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>}
-<span class="keyword">local</span> C = {<span class="number">2</span>,<span class="number">10</span>}
-_.union(A,B,C) <span class="comment">-- =&gt; "{'a',1,2,3,10}"</span>
-</pre>
-
-
-<h3>intersection (array, &hellip;)</h3>
-
-<p>Returns the intersection (common-part) of all passed-in arrays:</p>
-
-<pre>
-<span class="keyword">local</span> A = {<span class="string">'a'</span>}
-<span class="keyword">local</span> B = {<span class="string">'a'</span>,<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>}
-<span class="keyword">local</span> C = {<span class="number">2</span>,<span class="number">10</span>,<span class="number">1</span>,<span class="string">'a'</span>}
-_.intersection(A,B,C) <span class="comment">-- =&gt; "{'a',2,1}"</span>
-</pre>
-
-
-<h3>symmetricDifference (array, array2)</h3>
-
-<p><em>Aliases: <code>_.symdiff</code>,<code>_.xor</code></em>.</p>
-
-<p>Returns values in the first array not present in the second and also values in the second array not present in the first one.</p>
-
-<pre>
-<span class="keyword">local</span> array = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>}
-<span class="keyword">local</span> array2 = {<span class="number">1</span>,<span class="number">4</span>,<span class="number">5</span>}
-_.symmetricDifference(array, array2) <span class="comment">-- =&gt; "{2,3,4,5}"</span>
-</pre>
-
-
-<h3>unique (array)</h3>
-
-<p><em>Aliases: <code>_.uniq</code></em>.</p>
-
-<p>Makes an array duplicate-free.</p>
-
-<pre>
-_.unique {<span class="number">1</span>,<span class="number">1</span>,<span class="number">2</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">4</span>,<span class="number">4</span>,<span class="number">5</span>} <span class="comment">-- =&gt; "{1,2,3,4,5}"</span>
-</pre>
-
-
-<h3>isunique (array)</h3>
-
-<p><em>Aliases: <code>_.isuniq</code></em>.</p>
-
-<p>Checks if a given array contains no duplicate value.</p>
-
-<pre>
-_.isunique({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>}) <span class="comment">-- =&gt; true
-</span>_.isunique({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">4</span>}) <span class="comment">-- =&gt; false</span>
-</pre>
-
-
-<h3>zip (&hellip;)</h3>
-
-<p><em>Aliases: <code>_.transpose</code></em>.</p>
-
-<p>Zips values from different arrays, on the basis on their common keys.</p>
-
-<pre>
-<span class="keyword">local</span> names = {<span class="string">'Bob'</span>,<span class="string">'Alice'</span>,<span class="string">'James'</span>}
-<span class="keyword">local</span> ages = {<span class="number">22</span>, <span class="number">23</span>}
-_.zip(names,ages) <span class="comment">-- =&gt; "{{'Bob',22},{'Alice',23},{'James'}}"</span>
-</pre>
-
-
-<h3>append (array, other)</h3>
-
-<p>Appends two arrays.</p>
-
-<pre>
-_.append({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>},{<span class="string">'a'</span>,<span class="string">'b'</span>}) <span class="comment">-- =&gt; "{1,2,3,'a','b'}"</span>
-</pre>
-
-
-<h3>interleave (&hellip;)</h3>
-
-<p>Interleaves values from passed-in arrays.</p>
-
-<pre>
-t1 = {<span class="number">1</span>, <span class="number">2</span>, <span class="number">3</span>}
-t2 = {<span class="string">'a'</span>, <span class="string">'b'</span>, <span class="string">'c'</span>}
-_.interleave(t1, t2) <span class="comment">-- =&gt; "{1,'a',2,'b',3,'c'}"</span>
-</pre>
-
-
-<h3>interpose (value, array)</h3>
-
-<p>Interposes a value between consecutive values in an arrays.</p>
-
-<pre>
-_.interleave(<span class="string">'a'</span>, {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>}) <span class="comment">-- =&gt; "{1,'a',2,'a',3}"</span>
-</pre>
-
-
-<h3>range (&hellip;)</h3>
-
-<p>Generates an arithmetic sequence.</p>
-
-<pre>
-_.range(<span class="number">1</span>,<span class="number">4</span>) <span class="comment">-- =&gt; "{1,2,3,4}"</span>
-</pre>
-
-
-<p>In case a single value is provided, it generates a sequence from 0 to that value.</p>
-
-<pre>
-_.range(<span class="number">3</span>) <span class="comment">-- =&gt; "{0,1,2,3}"</span>
-</pre>
-
-
-<p>The incremental step can also be provided as third argument.</p>
-
-<pre>
-_.range(<span class="number">0</span>,<span class="number">2</span>,<span class="number">0.7</span>) <span class="comment">-- =&gt; "{0,0.7,1.4}"</span>
-</pre>
-
-
-<h3>rep (value, n)</h3>
-
-<p>Generates a list of n repetitions of a value.</p>
-
-<pre>
-_.rep(<span class="number">4</span>,<span class="number">3</span>) <span class="comment">-- =&gt; "{4,4,4}"</span>
-</pre>
-
-
-<h3>partition (array, n, pad)</h3>
-
-<p><em>Aliases: <code>_.part</code></em>.</p>
-
-<p>Returns an iterator function for partitions of a given array.</p>
-
-<pre>
-<span class="keyword">local</span> t = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>}
-<span class="keyword">for</span> p <span class="keyword">in</span> _.partition(t,<span class="number">2</span>) <span class="keyword">do</span>
-  <span class="global">print</span>(<span class="global">table</span>.concat(p, <span class="string">','</span>))
-<span class="keyword">end</span>
-
-<span class="comment">-- =&gt; 1,2
-</span><span class="comment">-- =&gt; 3,4
-</span><span class="comment">-- =&gt; 5,6
-</span>
-<span class="keyword">local</span> t = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>}
-<span class="keyword">for</span> p <span class="keyword">in</span> _.partition(t,<span class="number">4</span>) <span class="keyword">do</span>
-  <span class="global">print</span>(<span class="global">table</span>.concat(p, <span class="string">','</span>))
-<span class="keyword">end</span>
-
-<span class="comment">-- =&gt; 1,2,3,4
-</span><span class="comment">-- =&gt; 5,6</span>
-</pre>
-
-
-<p>In case the last partition has less elements than desired, a 3rd argument can be supplied to adjust the partition size.</p>
-
-<pre>
-<span class="keyword">local</span> t = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>}
-<span class="keyword">for</span> p <span class="keyword">in</span> _.partition(t,<span class="number">4</span>,<span class="number">0</span>) <span class="keyword">do</span>
-  <span class="global">print</span>(<span class="global">table</span>.concat(p, <span class="string">','</span>))
-<span class="keyword">end</span>
-
-<span class="comment">-- =&gt; 1,2,3,4
-</span><span class="comment">-- =&gt; 5,6,0,0</span>
-</pre>
-
-
-<h3>sliding (array, n, pad)</h3>
-
-<p>Returns an iterator function which provides overlapping subsequences of a given array.</p>
-
-<pre>
-<span class="keyword">local</span> t = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>,<span class="number">7</span>}
-<span class="keyword">for</span> p <span class="keyword">in</span> _.sliding(t,<span class="number">3</span>) <span class="keyword">do</span>
-    <span class="global">print</span>(<span class="global">table</span>.concat(p,<span class="string">','</span>))
-<span class="keyword">end</span>
-
-<span class="comment">-- =&gt; 1,2,3
-</span><span class="comment">-- =&gt; 3,4,5
-</span><span class="comment">-- =&gt; 5,6,7
-</span>
-<span class="keyword">for</span> p <span class="keyword">in</span> _.sliding(t,<span class="number">4</span>) <span class="keyword">do</span>
-    <span class="global">print</span>(<span class="global">table</span>.concat(p,<span class="string">','</span>))
-<span class="keyword">end</span>
-
-<span class="comment">-- =&gt; 1,2,3,4
-</span><span class="comment">-- =&gt; 4,5,6,7
-</span>
-<span class="keyword">for</span> p <span class="keyword">in</span> _.sliding(t,<span class="number">5</span>) <span class="keyword">do</span>
-    <span class="global">print</span>(<span class="global">table</span>.concat(p,<span class="string">','</span>))
-<span class="keyword">end</span>
-
-<span class="comment">-- =&gt; 1,2,3,4,5
-</span><span class="comment">-- =&gt; 5,6,7</span>
-</pre>
-
-
-<p>In case the last subsequence wil not match the exact desired length, it can be adjusted with a 3rd argument <code>pad</code>.</p>
-
-<pre>
-<span class="keyword">local</span> t = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>,<span class="number">7</span>}
-<span class="keyword">for</span> p <span class="keyword">in</span> _.sliding(t,<span class="number">5</span>,<span class="number">0</span>) <span class="keyword">do</span>
-    <span class="global">print</span>(<span class="global">table</span>.concat(p,<span class="string">','</span>))
-<span class="keyword">end</span>
-
-<span class="comment">-- =&gt; 1,2,3,4,5
-</span><span class="comment">-- =&gt; 5,6,7,0,0</span>
-</pre>
-
-
-<h3>permutation (array)</h3>
-
-<p><em>Aliases: <code>_.perm</code></em>.</p>
-
-<p>Returns an iterator function for permutations of a given array.</p>
-
-<pre>
-t = {<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>}
-<span class="keyword">for</span> p <span class="keyword">in</span> _.permutation(t) <span class="keyword">do</span>
-  <span class="global">print</span>(<span class="global">table</span>.concat(p))
-<span class="keyword">end</span>
-
-<span class="comment">-- =&gt; 'bca'
-</span><span class="comment">-- =&gt; 'cba'
-</span><span class="comment">-- =&gt; 'cab'
-</span><span class="comment">-- =&gt; 'acb'
-</span><span class="comment">-- =&gt; 'bac'
-</span><span class="comment">-- =&gt; 'abc'</span>
-</pre>
-
-
-<h3>invert (array)</h3>
-
-<p><em>Aliases: <code>_.mirror</code></em>.</p>
-
-<p>Switches <tt>key-value</tt> pairs:</p>
-
-<pre>
-_.invert {<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>} <span class="comment">-- =&gt; "{a=1, b=2, c=3}"</span>
-</pre>
-
-
-<h3>concat (array, sep, i, j)</h3>
-
-<p><em>Aliases: <code>_.join</code></em>.</p>
-
-<p>Concatenates a given array values:</p>
-
-<pre>
-_.concat({<span class="string">'a'</span>,<span class="number">1</span>,<span class="number">0</span>,<span class="number">1</span>,<span class="string">'b'</span>}) <span class="comment">-- =&gt; 'a101b'</span>
-</pre>
-
-
-<p><strong><a href="#TOC">[⬆]</a></strong></p>
-
-<p><a name="_a_name__utility__Utility_functions__a_"></a></p>
-
-<h2><a name='utility'>Utility functions</a></h2>
-
-<h3>noop ()</h3>
-
-<p>The no-operation function. Takes nothing, returns nothing. It is being used internally.</p>
-
-<pre>
-_.noop() <span class="comment">-- =&gt; nil</span>
-</pre>
-
-
-<h3>identity (value)</h3>
-
-<p>Returns the passed-in value. <br/>
-This function is internally used as a default transformation function.</p>
-
-<pre>
-_.identity(<span class="number">1</span>)<span class="comment">-- =&gt; 1
-</span>_.identity(<span class="keyword">false</span>) <span class="comment">-- =&gt; false
-</span>_.identity(<span class="string">'hello!'</span>) <span class="comment">-- =&gt; 'hello!'</span>
-</pre>
-
-
-<h3>constant (value)</h3>
-
-<p>Creates a constant function. This function will continuously yield the same output.</p>
-
-<pre>
-<span class="keyword">local</span> pi = _.constant(<span class="global">math</span>.pi)
-pi(<span class="number">1</span>) <span class="comment">-- =&gt; 3.1415926535898
-</span>pi(<span class="number">2</span>) <span class="comment">-- =&gt; 3.1415926535898
-</span>pi(<span class="global">math</span>.pi) <span class="comment">-- =&gt; 3.1415926535898</span>
-</pre>
-
-
-<h3>memoize (f, hash)</h3>
-
-<p><em>Aliases: <code>_.cache</code></em>.</p>
-
-<p>Memoizes a slow-running function. It caches the result for a specific input, so that the next time the function is called with the same input, it will lookup the result in its cache, instead of running again the function body.</p>
-
-<pre>
-<span class="keyword">local</span> <span class="keyword">function</span> fibonacci(n)
-  <span class="keyword">return</span> n &lt; <span class="number">2</span> <span class="keyword">and</span> n <span class="keyword">or</span> fibonacci(n-<span class="number">1</span>)+fibonacci(n-<span class="number">2</span>)
-<span class="keyword">end</span>
-<span class="keyword">local</span> mem_fibonacci = _.memoize(fibonacci)
-fibonacci(<span class="number">20</span>) <span class="comment">-- =&gt; 6765 (but takes some time)
-</span>mem_fibonacci(<span class="number">20</span>) <span class="comment">-- =&gt; 6765 (takes less time)</span>
-</pre>
-
-
-<h3>once (f)</h3>
-
-<p>Produces a function that runs only once. Successive calls to this function will still yield the same input.</p>
-
-<pre>
-<span class="keyword">local</span> sq = _.once(<span class="keyword">function</span>(a) <span class="keyword">return</span> a*a <span class="keyword">end</span>)
-sq(<span class="number">1</span>) <span class="comment">-- =&gt; 1
-</span>sq(<span class="number">2</span>) <span class="comment">-- =&gt; 1
-</span>sq(<span class="number">3</span>) <span class="comment">-- =&gt; 1
-</span>sq(<span class="number">4</span>) <span class="comment">-- =&gt; 1
-</span>sq(<span class="number">5</span>) <span class="comment">-- =&gt; 1</span>
-</pre>
-
-
-<h3>before (f, count)</h3>
-
-<p>Returns a version of <code>f</code> that will run no more than <a href="../index.html#count">count</a> times. Next calls will keep yielding the results of the (n-th)-1 call.</p>
-
-<pre>
-<span class="keyword">local</span> <span class="keyword">function</span> greet(someone) <span class="keyword">return</span> <span class="string">'hello '</span>..someone <span class="keyword">end</span>
-<span class="keyword">local</span> greetOnly3people = _.before(greet, <span class="number">3</span>)
-greetOnly3people(<span class="string">'John'</span>) <span class="comment">-- =&gt; 'hello John'
-</span>greetOnly3people(<span class="string">'Moe'</span>) <span class="comment">-- =&gt; 'hello Moe'
-</span>greetOnly3people(<span class="string">'James'</span>) <span class="comment">-- =&gt; 'hello James'
-</span>greetOnly3people(<span class="string">'Joseph'</span>) <span class="comment">-- =&gt; 'hello James'
-</span>greetOnly3people(<span class="string">'Allan'</span>) <span class="comment">-- =&gt; 'hello James'</span>
-</pre>
-
-
-<h3>after (f, count)</h3>
-
-<p>Produces a function that will respond only after a given number of calls.</p>
-
-<pre>
-<span class="keyword">local</span> f = _.after(_.identity,<span class="number">3</span>)
-f(<span class="number">1</span>) <span class="comment">-- =&gt; nil
-</span>f(<span class="number">2</span>) <span class="comment">-- =&gt; nil
-</span>f(<span class="number">3</span>) <span class="comment">-- =&gt; 3
-</span>f(<span class="number">4</span>) <span class="comment">-- =&gt; 4</span>
-</pre>
-
-
-<h3>compose (&hellip;)</h3>
-
-<p>Composes functions. Each function consumes the return value of the one that follows.</p>
-
-<pre>
-<span class="keyword">local</span> <span class="keyword">function</span> f(x) <span class="keyword">return</span> x^<span class="number">2</span> <span class="keyword">end</span>
-<span class="keyword">local</span> <span class="keyword">function</span> g(x) <span class="keyword">return</span> x+<span class="number">1</span> <span class="keyword">end</span>
-<span class="keyword">local</span> <span class="keyword">function</span> h(x) <span class="keyword">return</span> x/<span class="number">2</span> <span class="keyword">end</span>
-<span class="keyword">local</span> compositae = _.compose(f,g,h)
-compositae(<span class="number">10</span>) <span class="comment">-- =&gt; 36
-</span>compositae(<span class="number">20</span>) <span class="comment">-- =&gt; 121</span>
-</pre>
-
-
-<h3>pipe (value, &hellip;)</h3>
-
-<p>Pipes a value through a series of functions.</p>
-
-<pre>
-<span class="keyword">local</span> <span class="keyword">function</span> f(x) <span class="keyword">return</span> x^<span class="number">2</span> <span class="keyword">end</span>
-<span class="keyword">local</span> <span class="keyword">function</span> g(x) <span class="keyword">return</span> x+<span class="number">1</span> <span class="keyword">end</span>
-<span class="keyword">local</span> <span class="keyword">function</span> h(x) <span class="keyword">return</span> x/<span class="number">2</span> <span class="keyword">end</span>
-_.pipe(<span class="number">10</span>,f,g,h) <span class="comment">-- =&gt; 36
-</span>_.pipe(<span class="number">20</span>,f,g,h) <span class="comment">-- =&gt; 121</span>
-</pre>
-
-
-<h3>complement (f)</h3>
-
-<p>Returns a function which returns the logical complement of a given function.</p>
-
-<pre>
-_.complement(<span class="keyword">function</span>() <span class="keyword">return</span> <span class="keyword">true</span> <span class="keyword">end</span>)() <span class="comment">-- =&gt; false</span>
-</pre>
-
-
-<h3>juxtapose (value, &hellip;)</h3>
-
-<p><em>Aliases: <code>_.juxt</code></em>.</p>
-
-<p>Calls a sequence of functions with the same input.</p>
-
-<pre>
-<span class="keyword">local</span> <span class="keyword">function</span> f(x) <span class="keyword">return</span> x^<span class="number">2</span> <span class="keyword">end</span>
-<span class="keyword">local</span> <span class="keyword">function</span> g(x) <span class="keyword">return</span> x+<span class="number">1</span> <span class="keyword">end</span>
-<span class="keyword">local</span> <span class="keyword">function</span> h(x) <span class="keyword">return</span> x/<span class="number">2</span> <span class="keyword">end</span>
-_.juxtapose(<span class="number">10</span>, f, g, h) <span class="comment">-- =&gt; 100, 11, 5</span>
-</pre>
-
-
-<h3>wrap (f, wrapper)</h3>
-
-<p>Wraps a function inside a wrapper. Allows the wrapper to execute code before and after function run.</p>
-
-<pre>
-<span class="keyword">local</span> greet = <span class="keyword">function</span>(name) <span class="keyword">return</span> <span class="string">"hi: "</span> .. name <span class="keyword">end</span>
-<span class="keyword">local</span> greet_backwards = _.wrap(greet, <span class="keyword">function</span>(f,arg)
-  <span class="keyword">return</span> f(arg) ..<span class="string">'\nhi: '</span> .. arg:reverse()
-<span class="keyword">end</span>)
-greet_backwards(<span class="string">'John'</span>)
-
-<span class="comment">-- =&gt; hi: John
-</span><span class="comment">-- =&gt; hi: nhoJ</span>
-</pre>
-
-
-<h3>times (n, iter, &hellip;)</h3>
-
-<p>Calls a given function <code>n</code> times.</p>
-
-<pre>
-<span class="keyword">local</span> f = (<span class="string">'Lua programming'</span>):gmatch(<span class="string">'.'</span>)
-_.times(<span class="number">3</span>,f) <span class="comment">-- =&gt; {'L','u','a'}</span>
-</pre>
-
-
-<h3>bind (f, v)</h3>
-
-<p>Binds a value to be the first argument to a function.</p>
-
-<pre>
-<span class="keyword">local</span> sqrt2 = _.bind(<span class="global">math</span>.sqrt,<span class="number">2</span>)
-sqrt2() <span class="comment">-- =&gt; 1.4142135623731</span>
-</pre>
-
-
-<h3>bind2 (f, v)</h3>
-
-<p>Binds a value to be the second argument to a function.</p>
-
-<pre>
-<span class="keyword">local</span> last2 = _.bind(_.last,<span class="number">2</span>)
-last2({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>}) <span class="comment">-- =&gt; {5,6}</span>
-</pre>
-
-
-<h3>bindn (f, &hellip;)</h3>
-
-<p>Binds a variable number of values to be the first arguments to a function.</p>
-
-<pre>
-<span class="keyword">local</span> <span class="keyword">function</span> out(...) <span class="keyword">return</span> <span class="global">table</span>.concat {...} <span class="keyword">end</span>
-<span class="keyword">local</span> out = _.bindn(out,<span class="string">'OutPut'</span>,<span class="string">':'</span>,<span class="string">' '</span>)
-out(<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>) <span class="comment">-- =&gt; OutPut: 123
-</span>out(<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>,<span class="string">'d'</span>) <span class="comment">-- =&gt; OutPut: abcd</span>
-</pre>
-
-
-<h3>bindAll (obj, &hellip;)</h3>
-
-<p>Binds methods to object. As such, when calling any of these methods, they will receive object as a first argument.</p>
-
-<pre>
-<span class="keyword">local</span> window = {
-    setPos = <span class="keyword">function</span>(w,x,y) w.x, w.y = x, y <span class="keyword">end</span>,
-    setName = <span class="keyword">function</span>(w,name) w.name = name <span class="keyword">end</span>,
-    getName = <span class="keyword">function</span>(w) <span class="keyword">return</span> w.name <span class="keyword">end</span>,
-}
-window = _.bindAll(window, <span class="string">'setPos'</span>, <span class="string">'setName'</span>, <span class="string">'getName'</span>)
-window.setPos(<span class="number">10</span>,<span class="number">15</span>)
-<span class="global">print</span>(window.x, window.y) <span class="comment">-- =&gt; 10,15
-</span>
-window.setName(<span class="string">'fooApp'</span>)
-<span class="global">print</span>(window.name) <span class="comment">-- =&gt; 'fooApp'
-</span>
-<span class="global">print</span>(window.getName()) <span class="comment">-- =&gt; 'fooApp'</span>
-</pre>
-
-
-<h3>uniqueId (template, &hellip;)</h3>
-
-<p><em>Aliases: <code>_.uid</code></em>.</p>
-
-<p>Returns an unique integer ID.</p>
-
-<pre>
-_.uniqueId() <span class="comment">-- =&gt; 1</span>
-</pre>
-
-
-<p>Can handle string templates for formatted output.</p>
-
-<pre>
-_.uniqueId(<span class="string">'ID%s'</span>) <span class="comment">-- =&gt; 'ID2'</span>
-</pre>
-
-
-<p>Or a function, for the same purpose.</p>
-
-<pre>
-<span class="keyword">local</span> formatter = <span class="keyword">function</span>(ID) <span class="keyword">return</span> <span class="string">'$'</span>..ID..<span class="string">'$'</span> <span class="keyword">end</span>
-_.uniqueId(formatter) <span class="comment">-- =&gt; '$ID1$'</span>
-</pre>
-
-
-<h3>iterator(f, x)</h3>
-
-<p><em>Aliases: <code>_.iter</code></em>.</p>
-
-<p>Returns an iterator function which constinuously applies a function <code>f</code> onto an input <code>x</code>.
-For example, let us go through the powers of two.</p>
-
-<pre>
-<span class="keyword">local</span> <span class="keyword">function</span> po2(x) <span class="keyword">return</span> x*<span class="number">2</span> <span class="keyword">end</span>
-<span class="keyword">local</span> <span class="keyword">function</span> iter_po2 = _.iterator(po2, <span class="number">1</span>)
-iter_po2() <span class="comment">-- =&gt; 2
-</span>iter_po2() <span class="comment">-- =&gt; 4
-</span>iter_po2() <span class="comment">-- =&gt; 8</span>
-</pre>
-
-
-<h3>array (&hellip;)</h3>
-
-<p>Iterates a given iterator function and returns its values packed in an array.</p>
-
-<pre>
-<span class="keyword">local</span> text = <span class="string">'letters'</span>
-<span class="keyword">local</span> chars = <span class="global">string</span>.gmatch(text, <span class="string">'.'</span>)
-<span class="keyword">local</span> letters = _.array(chars) <span class="comment">-- =&gt; {'l','e','t','t','e','r','s'}</span>
-</pre>
-
-
-<h3>flip (f)</h3>
-
-<p>Creates a function of <code>f</code> with arguments flipped in reverse order.</p>
-
-<pre>
-<span class="keyword">local</span> <span class="keyword">function</span> f(...) <span class="keyword">return</span> <span class="global">table</span>.concat({...}) <span class="keyword">end</span>
-<span class="keyword">local</span> flipped = _.flip(f)
-flipped(<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>) <span class="comment">-- =&gt; 'cba'</span>
-</pre>
-
-
-<h3>over (&hellip;)</h3>
-
-<p>Creates a function that invokes a set of transforms with the arguments it receives.<br/>
-One can use use for example to get the tuple of min and max values from a set of values</p>
-
-<pre>
-<span class="keyword">local</span> minmax = _.over(<span class="global">math</span>.min, <span class="global">math</span>.max)
-minmax(<span class="number">5</span>,<span class="number">10</span>,<span class="number">12</span>,<span class="number">4</span>,<span class="number">3</span>) <span class="comment">-- =&gt; {3,12}</span>
-</pre>
-
-
-<h3>overEvery (&hellip;)</h3>
-
-<p>Creates a validation function. The returned function checks if all of the given predicates return truthy when invoked with the arguments it receives.</p>
-
-<pre>
-<span class="keyword">local</span> <span class="keyword">function</span> alleven(...)
-    <span class="keyword">for</span> i, v <span class="keyword">in</span> <span class="global">ipairs</span>({...}) <span class="keyword">do</span>
-        <span class="keyword">if</span> v%<span class="number">2</span>~=<span class="number">0</span> <span class="keyword">then</span> <span class="keyword">return</span> <span class="keyword">false</span> <span class="keyword">end</span>
-    <span class="keyword">end</span>
-    <span class="keyword">return</span> <span class="keyword">true</span>
-<span class="keyword">end</span>
-
-<span class="keyword">local</span> <span class="keyword">function</span> allpositive(...)
-    <span class="keyword">for</span> i, v <span class="keyword">in</span> <span class="global">ipairs</span>({...}) <span class="keyword">do</span>
-        <span class="keyword">if</span> v &lt; <span class="number">0</span> <span class="keyword">then</span> <span class="keyword">return</span> <span class="keyword">false</span> <span class="keyword">end</span>
-    <span class="keyword">end</span>
-    <span class="keyword">return</span> <span class="keyword">true</span>
-<span class="keyword">end</span>
-
-<span class="keyword">local</span> allok = _.overEvery(alleven, allpositive)
-
-allok(<span class="number">2</span>,<span class="number">4</span>,-<span class="number">1</span>,<span class="number">8</span>) <span class="comment">-- =&gt; false
-</span>allok(<span class="number">10</span>,<span class="number">3</span>,<span class="number">2</span>,<span class="number">6</span>) <span class="comment">-- =&gt; false
-</span>allok(<span class="number">8</span>,<span class="number">4</span>,<span class="number">6</span>,<span class="number">10</span>) <span class="comment">-- =&gt; true</span>
-</pre>
-
-
-<h3>overSome (&hellip;)</h3>
-
-<p>Creates a validation function. The returned function checks if any of the given predicates return truthy when invoked with the arguments it receives.</p>
-
-<pre>
-<span class="keyword">local</span> <span class="keyword">function</span> alleven(...)
-    <span class="keyword">for</span> i, v <span class="keyword">in</span> <span class="global">ipairs</span>({...}) <span class="keyword">do</span>
-        <span class="keyword">if</span> v%<span class="number">2</span>~=<span class="number">0</span> <span class="keyword">then</span> <span class="keyword">return</span> <span class="keyword">false</span> <span class="keyword">end</span>
-    <span class="keyword">end</span>
-    <span class="keyword">return</span> <span class="keyword">true</span>
-<span class="keyword">end</span>
-
-<span class="keyword">local</span> <span class="keyword">function</span> allpositive(...)
-    <span class="keyword">for</span> i, v <span class="keyword">in</span> <span class="global">ipairs</span>({...}) <span class="keyword">do</span>
-        <span class="keyword">if</span> v &lt; <span class="number">0</span> <span class="keyword">then</span> <span class="keyword">return</span> <span class="keyword">false</span> <span class="keyword">end</span>
-    <span class="keyword">end</span>
-    <span class="keyword">return</span> <span class="keyword">true</span>
-<span class="keyword">end</span>
-
-<span class="keyword">local</span> anyok = _.overSome(alleven,allpositive)
-
-anyok(<span class="number">2</span>,<span class="number">4</span>,-<span class="number">1</span>,<span class="number">8</span>) <span class="comment">-- =&gt; false
-</span>anyok(<span class="number">10</span>,<span class="number">3</span>,<span class="number">2</span>,<span class="number">6</span>) <span class="comment">-- =&gt; true
-</span>anyok(-<span class="number">1</span>,-<span class="number">5</span>,-<span class="number">3</span>) <span class="comment">-- =&gt; false</span>
-</pre>
-
-
-<h3>overArgs (f, &hellip;)</h3>
-
-<p>Creates a function that invokes <code>f</code> with its arguments transformed</p>
-
-<pre>
-<span class="keyword">local</span> <span class="keyword">function</span> f(x, y) <span class="keyword">return</span> x, y <span class="keyword">end</span>
-<span class="keyword">local</span> <span class="keyword">function</span> triple(x) retun x*<span class="number">3</span> <span class="keyword">end</span>
-<span class="keyword">local</span> <span class="keyword">function</span> square(x) retun x^<span class="number">2</span> <span class="keyword">end</span>
-<span class="keyword">local</span> new_f = _.overArgs(f, triple, square)
-
-new_f(<span class="number">1</span>,<span class="number">2</span>) <span class="comment">-- =&gt; 3, 4
-</span>new_f(<span class="number">10</span>,<span class="number">10</span>) <span class="comment">-- =&gt; 30, 100</span>
-</pre>
-
-
-<p>In case the number of arguments is greater than the number of transforms, the remaining args will be left as-is.</p>
-
-<pre>
-<span class="keyword">local</span> <span class="keyword">function</span> f(x, y, z) <span class="keyword">return</span> x, y, z <span class="keyword">end</span>
-<span class="keyword">local</span> <span class="keyword">function</span> triple(x) retun x*<span class="number">3</span> <span class="keyword">end</span>
-<span class="keyword">local</span> <span class="keyword">function</span> square(x) retun x^<span class="number">2</span> <span class="keyword">end</span>
-<span class="keyword">local</span> new_f = _.overArgs(f, triple, square)
-
-new_f(<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>) <span class="comment">-- =&gt; 3, 4, 3
-</span>new_f(<span class="number">10</span>,<span class="number">10</span>,<span class="number">10</span>) <span class="comment">-- =&gt; 30, 100, 10</span>
-</pre>
-
-
-<h3>partial (f, &hellip;)</h3>
-
-<p>Partially apply a function by filling in any number of its arguments. </p>
-
-<pre>
-<span class="keyword">local</span> <span class="keyword">function</span> diff(a, b) <span class="keyword">return</span> a - b <span class="keyword">end</span>
-<span class="keyword">local</span> diffFrom20 = _.partial(diff, <span class="number">20</span>) <span class="comment">-- arg 'a' will be 20 by default
-</span>diffFrom20(<span class="number">5</span>) <span class="comment">-- =&gt; 15</span>
-</pre>
-
-
-<p>The string <code>&apos;_&apos;</code> can be used as a placeholder in the list of arguments to specify an argument that should not be pre-filled, but is rather left open to be supplied at call-time.</p>
-
-<pre>
-<span class="keyword">local</span> <span class="keyword">function</span> diff(a, b) <span class="keyword">return</span> a - b <span class="keyword">end</span>
-<span class="keyword">local</span> remove5 = _.partial(diff, <span class="string">'_'</span>, <span class="number">5</span>) <span class="comment">-- arg 'a' will be given at call-time, but 'b' is set to 5
-</span>remove5(<span class="number">20</span>) <span class="comment">-- =&gt; 15</span>
-</pre>
-
-
-<h3>partialRight (f, &hellip;)</h3>
-
-<p>Like <code>_.partial</code>, it partially applies a function by filling in any number of its arguments, but from the right.</p>
-
-<pre>
-<span class="keyword">local</span> <span class="keyword">function</span> concat(...) <span class="keyword">return</span> <span class="global">table</span>.concat({...},<span class="string">','</span>) <span class="keyword">end</span>
-<span class="keyword">local</span> concat_right = _.partialRight(concat,<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>)
-concat_right(<span class="string">'d'</span>) <span class="comment">-- =&gt; d,a,b,c
-</span>
-concat_right = _.partialRight(concat,<span class="string">'a'</span>,<span class="string">'b'</span>)
-concat_right(<span class="string">'c'</span>,<span class="string">'d'</span>) <span class="comment">-- =&gt; c,d,a,b
-</span>
-concat_right = _.partialRight(concat,<span class="string">'a'</span>)
-concat_right(<span class="string">'b'</span>,<span class="string">'c'</span>,<span class="string">'d'</span>) <span class="comment">-- =&gt; b,c,d,a</span>
-</pre>
-
-
-<p>The string <code>&apos;_&apos;</code>, as always, can be used as a placeholder in the list of arguments to specify an argument that should not be pre-filled, but is rather left open to be supplied at call-time.
-In that case, the first args supplied at runtime will be used to fill the initial list of args while the remaining will be prepended.</p>
-
-<pre>
-<span class="keyword">local</span> <span class="keyword">function</span> concat(...) <span class="keyword">return</span> <span class="global">table</span>.concat({...},<span class="string">','</span>) <span class="keyword">end</span>
-<span class="keyword">local</span> concat_right = _.partialRight(concat,<span class="string">'a'</span>,<span class="string">'_'</span>,<span class="string">'c'</span>)
-concat_right(<span class="string">'d'</span>,<span class="string">'b'</span>) <span class="comment">-- =&gt; b,a,d,c
-</span>
-concat_right = _.partialRight(concat,<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'_'</span>)
-concat_right(<span class="string">'c'</span>,<span class="string">'d'</span>) <span class="comment">-- =&gt; d,a,b,c
-</span>
-concat_right = _.partialRight(concat,<span class="string">'_'</span>,<span class="string">'a'</span>)
-concat_right(<span class="string">'b'</span>,<span class="string">'c'</span>,<span class="string">'d'</span>) <span class="comment">-- =&gt; c,d,b,a</span>
-</pre>
-
-
-<h3>curry (f, n_args)</h3>
-
-<p>Curries a function. If the given function <code>f</code> takes multiple arguments, it returns another version of <code>f</code> that takes a single argument
-(the first of the arguments to the original function) and returns a new function that takes the remainder of the arguments and returns the result.</p>
-
-<pre>
-<span class="keyword">local</span> <span class="keyword">function</span> sumOf3args(x,y,z) <span class="keyword">return</span> x + y + z <span class="keyword">end</span>
-<span class="keyword">local</span> curried_sumOf3args = _.curry(sumOf3args, <span class="number">3</span>)
-sumOf3args(<span class="number">1</span>)(<span class="number">2</span>)(<span class="number">3</span>) <span class="comment">-- =&gt; 6
-</span>sumOf3args(<span class="number">0</span>)(<span class="number">6</span>)(<span class="number">9</span>) <span class="comment">-- =&gt; 15</span>
-</pre>
-
-
-<p><code>n_args</code> defaults to 2.</p>
-
-<pre>
-<span class="keyword">local</span> <span class="keyword">function</span> product(x,y) <span class="keyword">return</span> x * y <span class="keyword">end</span>
-<span class="keyword">local</span> curried_product = _.curry(product)
-curried_product(<span class="number">5</span>)(<span class="number">4</span>) <span class="comment">-- =&gt; 20
-</span>curried_product(<span class="number">3</span>)(-<span class="number">5</span>) <span class="comment">-- =&gt; -15
-</span>curried_product(<span class="number">0</span>)(<span class="number">1</span>) <span class="comment">-- =&gt; 0</span>
-</pre>
-
-
-<h3>time (f, &hellip;)</h3>
-
-<p>Returns the execution time of <code>f (&hellip;)</code> in seconds and its results.</p>
-
-<pre>
-<span class="keyword">local</span> <span class="keyword">function</span> wait_count(n)
-    <span class="keyword">local</span> i = <span class="number">0</span>
-    <span class="keyword">while</span> i &lt; n <span class="keyword">do</span> i = i + <span class="number">1</span> <span class="keyword">end</span>
-    <span class="keyword">return</span> i
-<span class="keyword">end</span>
-
-<span class="keyword">local</span> time, i = _.time(wait_count, <span class="number">1e6</span>) <span class="comment">-- =&gt; 0.002 1000000
-</span><span class="keyword">local</span> time, i = _.time(wait_count, <span class="number">1e7</span>) <span class="comment">-- =&gt; 0.018 10000000</span>
-</pre>
-
-
-<p><strong><a href="#TOC">[⬆]</a></strong></p>
-
-<p><a name="_a_name__object__Object_functions__a_"></a></p>
-
-<h2><a name='object'>Object functions</a></h2>
-
-<h3>keys (obj)</h3>
-
-<p>Collects the names of an object attributes.</p>
-
-<pre>
-_.keys({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>}) <span class="comment">-- =&gt; "{1,2,3}"
-</span>_.keys({x = <span class="number">0</span>, y = <span class="number">1</span>}) <span class="comment">-- =&gt; "{'y','x'}"</span>
-</pre>
-
-
-<h3>values (obj)</h3>
-
-<p>Collects the values of an object attributes.</p>
-
-<pre>
-_.values({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>}) <span class="comment">-- =&gt; "{1,2,3}"
-</span>_.values({x = <span class="number">0</span>, y = <span class="number">1</span>}) <span class="comment">-- =&gt; "{1,0}"</span>
-</pre>
-
-
-<h3>kvpairs (obj)</h3>
-
-<p>Converts an object to an array-list of key-value pairs.</p>
-
-<pre>
-<span class="keyword">local</span> obj = {x = <span class="number">1</span>, y = <span class="number">2</span>, z = <span class="number">3</span>}
-_.each(_.kvpairs(obj), <span class="keyword">function</span>(k,v)
-    <span class="global">print</span>(k, <span class="global">table</span>.concat(v,<span class="string">','</span>))
-<span class="keyword">end</span>)
-
-<span class="comment">-- =&gt; 1    y,2
-</span><span class="comment">-- =&gt; 2 x,1
-</span><span class="comment">-- =&gt; 3 z,3</span>
-</pre>
-
-
-<h3>toObj</h3>
-
-<p>Converts an array list of <a href="../index.html#kvpairs">kvpairs</a> to an object where keys are taken from the 1rst column in the <a href="../index.html#kvpairs">kvpairs</a> sequence, associated with values in the 2nd column.</p>
-
-<pre>
-<span class="keyword">local</span> list_pairs = {{<span class="string">'x'</span>,<span class="number">1</span>},{<span class="string">'y'</span>,<span class="number">2</span>},{<span class="string">'z'</span>,<span class="number">3</span>}}
-obj = _.toObj(list_pairs)
-
-<span class="comment">-- =&gt; {x = 1, y = 2, z = 3}</span>
-</pre>
-
-
-<h3>property (key)</h3>
-
-<p>Returns a function that will return the key property of any passed-in object.</p>
-
-<pre>
-<span class="keyword">local</span> who = _.property(<span class="string">'name'</span>)
-<span class="keyword">local</span> people = {name = <span class="string">'Henry'</span>}
-who(people) <span class="comment">-- =&gt; 'Henry'</span>
-</pre>
-
-
-<h3>propertyOf (obj)</h3>
-
-<p>Returns a function that will return the key property of any passed-in object.</p>
-
-<pre>
-<span class="keyword">local</span> people = {name = <span class="string">'Henry'</span>}
-<span class="global">print</span>(_.propertyOf(people)(<span class="string">'name'</span>)) <span class="comment">-- =&gt; 'Henry'</span>
-</pre>
-
-
-<h3>toBoolean (value)</h3>
-
-<p>Converts a given value to a boolean.</p>
-
-<pre>
-_.toBoolean(<span class="keyword">true</span>) <span class="comment">-- =&gt; true
-</span>_.toBoolean(<span class="keyword">false</span>) <span class="comment">-- =&gt; false
-</span>_.toBoolean(<span class="keyword">nil</span>) <span class="comment">-- =&gt; false
-</span>_.toBoolean({}) <span class="comment">-- =&gt; true
-</span>_.toBoolean(<span class="number">1</span>) <span class="comment">-- =&gt; true</span>
-</pre>
-
-
-<h3>extend (destObj, &hellip;)</h3>
-
-<p>Extends a destination object with the properties of some source objects.</p>
-
-<pre>
-_.extend({},{a = <span class="string">'b'</span>, c = <span class="string">'d'</span>}) <span class="comment">-- =&gt; "{a = 'b', c = 'd'}"</span>
-</pre>
-
-
-<h3>functions (obj, recurseMt)</h3>
-
-<p><em>Aliases: <code>_.methods</code></em>.</p>
-
-<p>Returns all functions names within an object.</p>
-
-<pre>
-_.functions(<span class="global">coroutine</span>) <span class="comment">-- =&gt; "{'create','resume','running','status','wrap','yield'}"</span>
-</pre>
-
-
-<h3>clone (obj, shallow)</h3>
-
-<p>Clones a given object.</p>
-
-<pre>
-<span class="keyword">local</span> obj = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>}
-<span class="keyword">local</span> obj2 = _.clone(obj)
-<span class="global">print</span>(obj2 == obj) <span class="comment">-- =&gt; false
-</span><span class="global">print</span>(_.isEqual(obj2, obj)) <span class="comment">-- =&gt; true</span>
-</pre>
-
-
-<h3>tap (obj, f, &hellip;)</h3>
-
-<p>Invokes a given interceptor function on some object, and then returns the object itself. Useful to tap into method chaining to hook intermediate results.
-The pased-interceptor is prototyped as <code>f(obj,&hellip;)</code>.</p>
-
-<pre>
-<span class="keyword">local</span> v = _.chain({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>,<span class="number">6</span>,<span class="number">7</span>,<span class="number">8</span>,<span class="number">9</span>,<span class="number">10</span>)
-  :filter(<span class="keyword">function</span>(k,v) <span class="keyword">return</span> v%<span class="number">2</span>~=<span class="number">0</span> <span class="keyword">end</span>) <span class="comment">-- filters even values
-</span>  :tap(<span class="keyword">function</span>(v) <span class="global">print</span>(<span class="string">'Max is'</span>, _.max(v) <span class="keyword">end</span>) <span class="comment">-- Tap max values
-</span>  :map(<span class="keyword">function</span>(k,v) <span class="keyword">return</span> k^<span class="number">2</span>)
-  :value() <span class="comment">-- =&gt;    Max is 9</span>
-</pre>
-
-
-<h3>has (obj, key)</h3>
-
-<p>Checks if an object has a given attribute.</p>
-
-<pre>
-_.has(_,<span class="string">'has'</span>) <span class="comment">-- =&gt; true
-</span>_.has(<span class="global">coroutine</span>,<span class="string">'resume'</span>) <span class="comment">-- =&gt; true
-</span>_.has(<span class="global">math</span>,<span class="string">'random'</span>) <span class="comment">-- =&gt; true</span>
-</pre>
-
-
-<h3>pick (obj, &hellip;)</h3>
-
-<p><em>Aliases: <code>_.choose</code></em>.</p>
-
-<p>Collects whilelisted properties of a given object.</p>
-
-<pre>
-<span class="keyword">local</span> object = {a = <span class="number">1</span>, b = <span class="number">2</span>, c = <span class="number">3</span>}
-_.pick(object,<span class="string">'a'</span>,<span class="string">'c'</span>) <span class="comment">-- =&gt; "{a = 1, c = 3}"</span>
-</pre>
-
-
-<h3>omit (obj, &hellip;)</h3>
-
-<p><em>Aliases: <code>_.drop</code></em>.</p>
-
-<p>Omits blacklisted properties of a given object.</p>
-
-<pre>
-<span class="keyword">local</span> object = {a = <span class="number">1</span>, b = <span class="number">2</span>, c = <span class="number">3</span>}
-_.omit(object,<span class="string">'a'</span>,<span class="string">'c'</span>) <span class="comment">-- =&gt; "{b = 2}"</span>
-</pre>
-
-
-<h3>template (obj, template)</h3>
-
-<p><em>Aliases: <code>_.defaults</code></em>.</p>
-
-<p>Applies a template on an object, preserving existing properties.</p>
-
-<pre>
-<span class="keyword">local</span> obj = {a = <span class="number">0</span>}
-_.template(obj,{a = <span class="number">1</span>, b = <span class="number">2</span>, c = <span class="number">3</span>}) <span class="comment">-- =&gt; "{a=0, c=3, b=2}"</span>
-</pre>
-
-
-<h3>isEqual (objA, objB, useMt)</h3>
-
-<p><em>Aliases: <code>_.compare</code></em>.</p>
-
-<p>Compares objects:</p>
-
-<pre>
-_.isEqual(<span class="number">1</span>,<span class="number">1</span>) <span class="comment">-- =&gt; true
-</span>_.isEqual(<span class="keyword">true</span>,<span class="keyword">false</span>) <span class="comment">-- =&gt; false
-</span>_.isEqual(<span class="number">3.14</span>,<span class="global">math</span>.pi) <span class="comment">-- =&gt; false
-</span>_.isEqual({<span class="number">3</span>,<span class="number">4</span>,<span class="number">5</span>},{<span class="number">3</span>,<span class="number">4</span>,{<span class="number">5</span>}}) <span class="comment">-- =&gt; false</span>
-</pre>
-
-
-<h3>result (obj, method, &hellip;)</h3>
-
-<p>Calls an object method, passing it as a first argument the object itself.</p>
-
-<pre>
-_.result(<span class="string">'abc'</span>,<span class="string">'len'</span>) <span class="comment">-- =&gt; 3
-</span>_.result({<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>},<span class="global">table</span>.concat) <span class="comment">-- =&gt; 'abc'</span>
-</pre>
-
-
-<h3>isTable (t)</h3>
-
-<p>Is the given argument an object (i.e a table) ?</p>
-
-<pre>
-_.isTable({}) <span class="comment">-- =&gt; true
-</span>_.isTable(<span class="global">math</span>) <span class="comment">-- =&gt; true
-</span>_.isTable(<span class="global">string</span>) <span class="comment">-- =&gt; true</span>
-</pre>
-
-
-<h3>isCallable (obj)</h3>
-
-<p>Is the given argument callable ?</p>
-
-<pre>
-_.isCallable(<span class="global">print</span>) <span class="comment">-- =&gt; true
-</span>_.isCallable(<span class="keyword">function</span>() <span class="keyword">end</span>) <span class="comment">-- =&gt; true
-</span>_.isCallable(<span class="global">setmetatable</span>({},{__index = <span class="global">string</span>}).upper) <span class="comment">-- =&gt; true
-</span>_.isCallable(<span class="global">setmetatable</span>({},{__call = <span class="keyword">function</span>() <span class="keyword">return</span> <span class="keyword">end</span>})) <span class="comment">-- =&gt; true</span>
-</pre>
-
-
-<h3>isArray (obj)</h3>
-
-<p>Is the given argument an array (i.e. a sequence) ?</p>
-
-<pre>
-_.isArray({}) <span class="comment">-- =&gt; true
-</span>_.isArray({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>}) <span class="comment">-- =&gt; true
-</span>_.isArray({<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>}) <span class="comment">-- =&gt; true</span>
-</pre>
-
-
-<h3>isIterable (obj)</h3>
-
-<p>Checks if the given object is iterable with <a href="https://www.lua.org/manual/5.1/manual.html#pdf-pairs">pairs</a>.</p>
-
-<pre>
-_.isIterable({}) <span class="comment">-- =&gt; true
-</span>_.isIterable(<span class="keyword">function</span>() <span class="keyword">end</span>) <span class="comment">-- =&gt; false
-</span>_.isIterable(<span class="keyword">false</span>) <span class="comment">-- =&gt; false
-</span>_.isIterable(<span class="number">1</span>) <span class="comment">-- =&gt; false</span>
-</pre>
-
-
-<h3>isEmpty (obj)</h3>
-
-<p>Is the given argument empty ?</p>
-
-<pre>
-_.isEmpty(<span class="string">''</span>) <span class="comment">-- =&gt; true
-</span>_.isEmpty({})  <span class="comment">-- =&gt; true
-</span>_.isEmpty({<span class="string">'a'</span>,<span class="string">'b'</span>,<span class="string">'c'</span>}) <span class="comment">-- =&gt; false</span>
-</pre>
-
-
-<h3>isString (obj)</h3>
-
-<p>Is the given argument a string ?</p>
-
-<pre>
-_.isString(<span class="string">''</span>) <span class="comment">-- =&gt; true
-</span>_.isString(<span class="string">'Hello'</span>) <span class="comment">-- =&gt; false
-</span>_.isString({}) <span class="comment">-- =&gt; false</span>
-</pre>
-
-
-<h3>isFunction (obj)</h3>
-
-<p>Is the given argument a function ?</p>
-
-<pre>
-_.isFunction(<span class="global">print</span>) <span class="comment">-- =&gt; true
-</span>_.isFunction(<span class="keyword">function</span>() <span class="keyword">end</span>) <span class="comment">-- =&gt; true
-</span>_.isFunction({}) <span class="comment">-- =&gt; false</span>
-</pre>
-
-
-<h3>isNil (obj)</h3>
-
-<p>Is the given argument nil ?</p>
-
-<pre>
-_.isNil(<span class="keyword">nil</span>) <span class="comment">-- =&gt; true
-</span>_.isNil() <span class="comment">-- =&gt; true
-</span>_.isNil({}) <span class="comment">-- =&gt; false</span>
-</pre>
-
-
-<h3>isNumber (obj)</h3>
-
-<p>Is the given argument a number ?</p>
-
-<pre>
-_.isNumber(<span class="global">math</span>.pi) <span class="comment">-- =&gt; true
-</span>_.isNumber(<span class="global">math</span>.huge) <span class="comment">-- =&gt; true
-</span>_.isNumber(<span class="number">0</span>/<span class="number">0</span>) <span class="comment">-- =&gt; true
-</span>_.isNumber() <span class="comment">-- =&gt; false</span>
-</pre>
-
-
-<h3>isNaN (obj)</h3>
-
-<p>Is the given argument NaN ?</p>
-
-<pre>
-_.isNaN(<span class="number">1</span>) <span class="comment">-- =&gt; false
-</span>_.isNaN(<span class="number">0</span>/<span class="number">0</span>) <span class="comment">-- =&gt; true</span>
-</pre>
-
-
-<h3>isFinite (obj)</h3>
-
-<p>Is the given argument a finite number ?</p>
-
-<pre>
-_.isFinite(<span class="number">99e99</span>) <span class="comment">-- =&gt; true
-</span>_.isFinite(<span class="global">math</span>.pi) <span class="comment">-- =&gt; true
-</span>_.isFinite(<span class="global">math</span>.huge) <span class="comment">-- =&gt; false
-</span>_.isFinite(<span class="number">1</span>/<span class="number">0</span>) <span class="comment">-- =&gt; false
-</span>_.isFinite(<span class="number">0</span>/<span class="number">0</span>) <span class="comment">-- =&gt; false</span>
-</pre>
-
-
-<h3>isBoolean (obj)</h3>
-
-<p>Is the given argument a boolean ?</p>
-
-<pre>
-_.isBoolean(<span class="keyword">true</span>) <span class="comment">-- =&gt; true
-</span>_.isBoolean(<span class="keyword">false</span>) <span class="comment">-- =&gt; true
-</span>_.isBoolean(<span class="number">1</span>==<span class="number">1</span>) <span class="comment">-- =&gt; true
-</span>_.isBoolean(<span class="global">print</span>) <span class="comment">-- =&gt; false</span>
-</pre>
-
-
-<h3>isInteger (obj)</h3>
-
-<p>Is the given argument an integer ?</p>
-
-<pre>
-_.isInteger(<span class="global">math</span>.pi) <span class="comment">-- =&gt; false
-</span>_.isInteger(<span class="number">1</span>) <span class="comment">-- =&gt; true
-</span>_.isInteger(-<span class="number">1</span>) <span class="comment">-- =&gt; true</span>
-</pre>
-
-
-<p><strong><a href="#TOC">[⬆]</a></strong></p>
-
-<p><a name="_a_name__chaining__Chaining__a_"></a></p>
-
-<h2><a name='chaining'>Chaining</a></h2>
-
-<p><em>Method chaining</em> (also known as <em>name parameter idiom</em>), is a technique for invoking consecutively method calls in object-oriented style.
-Each method returns an object, and methods calls are chained together.
-Moses offers chaining for your perusal. <br/>
-Let&rsquo;s use chaining to get the count of every single word in some lyrics (case will not matter here).</p>
-
-<pre>
-<span class="keyword">local</span> lyrics = {
-  <span class="string">"I am a lumberjack and I am okay"</span>,
-  <span class="string">"I sleep all night and I work all day"</span>,
-  <span class="string">"He is a lumberjack and he is okay"</span>,
-  <span class="string">"He sleeps all night and he works all day"</span>
-}
-
-<span class="keyword">local</span> stats = _.chain(lyrics)
-  :map(<span class="keyword">function</span>(k,line)
-    <span class="keyword">local</span> t = {}
-    <span class="keyword">for</span> w <span class="keyword">in</span> line:gmatch(<span class="string">'(%w+)'</span>) <span class="keyword">do</span>
-      t[#t+<span class="number">1</span>] = w
-    <span class="keyword">end</span>
-    <span class="keyword">return</span> t
-  <span class="keyword">end</span>)
-  :flatten()
-  :countBy(<span class="keyword">function</span>(i,v) <span class="keyword">return</span> v:lower() <span class="keyword">end</span>)
-  :value()
-
-<span class="comment">-- =&gt; "{
-</span><span class="comment">-- =&gt;    sleep = 1, night = 2, works = 1, am = 2, is = 2,
-</span><span class="comment">-- =&gt;    he = 2, and = 4, I = 4, he = 2, day = 2, a = 2,
-</span><span class="comment">-- =&gt;    work = 1, all = 4, okay = 2
-</span><span class="comment">-- =&gt;  }"</span>
-</pre>
-
-
-<p>For convenience, you can also use <code>_(value)</code> to start chaining methods, instead of <code>_.chain(value)</code>.</p>
-
-<p>Note that one can use <code>:value()</code> to unwrap a chained object.</p>
-
-<pre>
-<span class="keyword">local</span> t = {<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>}
-<span class="global">print</span>(_(t):value() == t) <span class="comment">-- =&gt; true</span>
-</pre>
-
-
-<p><strong><a href="#TOC">[⬆]</a></strong></p>
-
-<p><a name="_a_name__import__Import__a_"></a></p>
-
-<h2><a name='import'>Import</a></h2>
-
-<p>All library functions can be imported in a context using <a href="../index.html#import">import</a> into a specified context.</p>
-
-<pre>
-<span class="keyword">local</span> context = {}
-_.import(context)
-
-context.each({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>},<span class="global">print</span>)
-
-<span class="comment">-- =&gt; 1 1
-</span><span class="comment">-- =&gt; 2 2
-</span><span class="comment">-- =&gt; 3 3</span>
-</pre>
-
-
-<p>When no <code>context</code> was provided, it defaults to the global environment <code>_G</code>.</p>
-
-<pre>
-_.import()
-
-each({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>},<span class="global">print</span>)
-
-<span class="comment">-- =&gt; 1 1
-</span><span class="comment">-- =&gt; 2 2
-</span><span class="comment">-- =&gt; 3 3</span>
-</pre>
-
-
-<p>Passing <code>noConflict</code> argument leaves untouched conflicting keys while importing into the context.</p>
-
-<pre>
-<span class="keyword">local</span> context = {each = <span class="number">1</span>}
-_.import(context, <span class="keyword">true</span>)
-
-<span class="global">print</span>(context.each) <span class="comment">-- =&gt; 1
-</span>context.eachi({<span class="number">1</span>,<span class="number">2</span>,<span class="number">3</span>},<span class="global">print</span>)
-
-<span class="comment">-- =&gt; 1 1
-</span><span class="comment">-- =&gt; 2 2
-</span><span class="comment">-- =&gt; 3 3</span>
-</pre>
-
-
-<p><strong><a href="#TOC">[⬆]</a></strong>
-
-</div> <!-- id="content" -->
-</div> <!-- id="main" -->
-<div id="about">
-<i>generated by <a href="http://github.com/stevedonovan/LDoc">LDoc 1.4.6</a></i>
-<i style="float:right;">Last updated 2017-05-03 14:08:34 </i>
-</div> <!-- id="about" -->
-</div> <!-- id="container" -->
-</body>
-</html>
diff -pruN 1.6.1+git20170613-2/doc/tutorial.md 2.0.0-3/doc/tutorial.md
--- 1.6.1+git20170613-2/doc/tutorial.md	2017-06-03 16:42:55.000000000 +0000
+++ 2.0.0-3/doc/tutorial.md	2018-08-23 16:26:20.000000000 +0000
@@ -1,10 +1,11 @@
 *Moses: a utility-belt library for functional programming in Lua*
 
 __Moses__ is a Lua utility library which provides support for functional programming. 
-It complements built-in Lua functions, making easier common operations on tables, arrays, lists, collections, objects, and a lot more.<br/>
-__Moses__ was deeply inspired by [Underscore.js](http://documentcloud.github.com/underscore/). 
+It complements built-in Lua functions, making easier common operations on tables, arrays, lists, collections, objects, and a lot more.
+<br/>
+<br/>
 
-# <a name='TOC'>Table of Contents</a>
+# <a name='TOC'>Sections</a>
 
 
 * [Adding *Moses* to your project](#adding)
@@ -14,23 +15,21 @@ __Moses__ was deeply inspired by [Unders
 * [Object functions](#object)
 * [Chaining](#chaining)
 * [Import](#import)
-
+<br/><br/>
 # <a name='adding'>Adding *Moses* to your project</a>
 
 Drop the file [moses.lua](http://github.com/Yonaba/Moses/blob/master/moses.lua) into your project and add it to your code with the *require* function:
 
 ```lua
-local _ = require ("moses")
+local M = require ("moses")
 ````
 
-*Note: Lua purists tend to use "\_" to design a "dummy variable". Here, the usage of this underscore is quite idiomatic and refers to the name [Underscore](http://documentcloud.github.com/underscore/), the JS library from which *Moses* takes inspiration*.
-
-*Moses*' provides a large set of functions that can be classified into four categories:
+*Moses* provides a large set of functions that can be classified into four categories:
 
-* __Table functions__, which are mostly meant for tables, i.e Lua tables which contains both an array-part and a hash-part,
-* __Array functions__, meant for array lists (or sequences),
-* __Utility functions__,
-* __Object functions__.
+* [__Table functions__](#table), which are mostly meant for tables, i.e Lua tables which contains both an array-part and a hash-part,
+* [__Array functions__](#array), meant for array lists (or sequences),
+* [__Utility functions__](#utility),
+* [__Object functions__](#object).
 
 **[[⬆]](#TOC)**
 
@@ -38,198 +37,208 @@ local _ = require ("moses")
 
 ### clear (t)
 
-Clears a table. All its values becomes nil. It returns the passed-in table.
+Clears a table. All its values becomes nil. Returns the passed-in table.
 
 ```lua
-local t = _.clear({1,2,'hello',true}) -- => {}
+M.clear({1,2,'hello',true}) -- => {}
 ````
 
-### each (t, f, ...)
-*Aliases: `_.forEach`*.
+### each (t, f [, ...])
+*Aliases: `forEach`*.
 
-Iterates over each key-value pair in table.
+Iterates over each value-key pair in the passed-in table.
 
 ```lua
-_.each({1,2,3},print)
+M.each({4,2,1},print)
 
--- => 1 1
+-- => 4 1
 -- => 2 2
--- => 3 3
+-- => 1 3
 ````
 
-The table can be map-like (array part and hash-part).
+The table can be map-like (both array part and hash part).
 
 ```lua
-_.each({one = 1, two = 2, three = 3},print)
+M.each({one = 1, two = 2, three = 3},print)
 
--- => one 1
--- => two 2
--- => three 3
+-- => 1 one
+-- => 2 two
+-- => 3 three
 ````
 
 Can index and assign in an outer table or in the passed-in table:
 
 ```lua
 t = {'a','b','c'}
-_.each(t,function(i,v)
+M.each(t,function(v,i)
   t[i] = v:rep(2)
   print(t[i])
 end)
 
--- => 1 aa
--- => 2 bb
--- => 3 cc
+-- => aa
+-- => bb
+-- => cc
 ````
 
-### eachi (t, f, ...)
-*Aliases: `_.forEachi`*.
+### eachi (t, f [, ...])
+*Aliases: `forEachi`*.
 
-Iterates only on integer keys in a sparse array table.
+Iterates only on integer keys in an array table. It returns value-key pairs.
 
 ```lua
-_.eachi({1,2,3},print)
+M.eachi({4,2,1},print)
 
--- => 1 1
+-- => 4 1
 -- => 2 2
--- => 3 3
+-- => 1 3
 ````
 
 The given array can be sparse, or even have a hash-like part.
 
 ```lua
 local t = {a = 1, b = 2, [0] = 1, [-1] = 6, 3, x = 4, 5}
-_.eachi(t,function(i,v)
-  print(i,v)
-end)
+M.eachi(t,print)
 
--- => -1 6
--- => 0	1
--- => 1	3
--- => 2	5
+-- => 6 -1
+-- => 1 0
+-- => 3 1	
+-- => 5 2
 ````
 
 ### at (t, ...)
 
-Collects all values at some specific keys and returns them in an array.
+Collects values at given keys and returns them in an array.
 
 ```lua
 local t = {4,5,6}
-_.at(t,1,3) -- => "{4,6}"
+M.at(t,1,3) -- => "{4,6}"
 
 local t = {a = 4, bb = true, ccc = false}
-_.at(t,'a', 'ccc') -- => "{4, false}"
+M.at(t,'a', 'ccc') -- => "{4, false}"
 ````
 
-### count (t, value)
+### adjust (t, key, f [, ...])
+
+Adjusts the value at a given key using a function or a value. In case `f` is a function, it should be prototyped `f(v, ...)`. It does not mutate the given table, but rather returns a new array.
+
+```lua
+local t = {1,2,3}
+M.adjust(t, 2, math.sin) -- => {1, 0.90929, 3}
+
+local v = {x = 1}
+ M.adjust(t, 'x', 4) -- => {x = 4}
+````
+
+In case the given `key` does not exist in `t`, it throws an error.
+
+### count (t [, val])
 
 Counts the number of occurences of a given value in a table.
 
 ```lua
-_.count({1,1,2,3,3,3,2,4,3,2},1) -- => 2
-_.count({1,1,2,3,3,3,2,4,3,2},2) -- => 2
-_.count({1,1,2,3,3,3,2,4,3,2},3) -- => 4
-_.count({false, false, true},false) -- => 2
-_.count({false, false, true},true) -- => 1
+M.count({1,1,2,3,3,3,2,4,3,2},1) -- => 2
+M.count({1,1,2,3,3,3,2,4,3,2},2) -- => 3
+M.count({1,1,2,3,3,3,2,4,3,2},3) -- => 4
+M.count({false, false, true},false) -- => 2
+M.count({false, false, true},true) -- => 1
 ````
 
 Returns the size of the list in case no value was provided.
 
 ```lua
-_.count({1,1,2,3,3}) -- => 5
+M.count({1,1,2,3,3}) -- => 5
 ````
 
-### countf (t, f, ...)
+### countf (t, f [, ...])
 
-Count the number of occurences of all values passing an iterator test.
+Counts the number of values passing an iterator test.
 
 ```lua
-_.countf({1,2,3,4,5,6}, function(i,v)
+M.countf({1,2,3,4,5,6}, function(v)
   return v%2==0
 end) -- => 3
 
-_.countf({print, pairs, os, assert, ipairs}, function(i,v)
+M.countf({print, pairs, os, assert, ipairs}, function(v)
   return type(v)=='function'
 end) -- => 4
 ````
 
-### cycle (t, n)
-*Aliases: `_.loop`*.
+### cycle (t [, n = 1])
+*Aliases: `loop`*.
 
-Returns a function which iterates on each key-value pair in a given table (similarly to `_.each`), except that it restarts iterating again `n` times.
+Returns a function which iterates on each value-key pair in a given table (similarly to `M.each`), except that it restarts iterating again `n` times.
 If `n` is not provided, it defaults to 1.
 
 ```lua
 local t = {'a','b','c'}
-for k,v in _.cycle(t, 2) do
-  print(k,v)
+for v in M.cycle(t, 2) do
+  print(v)
 end
 
--- => 1 'a'
--- => 2 'b'
--- => 3 'c'
--- => 1 'a'
--- => 2 'b'
--- => 3 'c'
+-- => 'a'
+-- => 'b'
+-- => 'c'
+-- => 'a'
+-- => 'b'
+-- => 'c'
 ````
 
 Supports array-like tables and map-like tables.
 
 ```lua
 local t = {x = 1, y = 2, z = 3}
-for k,v in _.cycle(t) do
-  print(k,v)
+for v in M.cycle(t) do
+  print(v)
 end
 
--- => y	2
--- => x	1
--- => z	3
+-- => 2
+-- => 1
+-- => 3
 ````
 
-### map (t, f, ...)
-*Aliases: `_.collect`*.
+### map (t, f [, ...])
+*Aliases: `collect`*.
 
-Executes a function on each key-value pairs.
+Executes a function on each value in a given array.
 
 ```lua
-_.map({1,2,3},function(i,v) 
+M.map({1,2,3},function(v) 
   return v+10 
 end) -- => "{11,12,13}"
 ````
 
 ```lua
-_.map({a = 1, b = 2},function(k,v) 
+M.map({a = 1, b = 2},function(v, k) 
   return k..v 
 end) -- => "{a = 'a1', b = 'b2'}"
 ````
 
-It also maps key-value pairs to key-value pairs
+It also maps both keys and values.
 
 ```lua
-_.map({a = 1, b = 2},function(k,v) 
+M.map({a = 1, b = 2},function(v, k) 
   return k..k, v*2 
 end) -- => "{aa = 2, bb = 4}"
 ````
 
-### reduce (t, f, state)
-*Aliases: `_.inject`, `_.foldl`*.
+### reduce (t, f [, state = next(t)])
+*Aliases: `inject`, `foldl`*.
 
-Can sums all values in a table.
+Can sum all values in a table. In case `state` is not provided, it defaults to the first value in the given table `t`.
 
 ```lua
-_.reduce({1,2,3,4},function(memo,v)
-  return memo+v 
-end) -- => 10
+local function add(a,b) return a+b end
+M.reduce({1,2,3,4},add) -- => 10
 ````
 
 Or concatenates all values.
 
-```lua	
-_.reduce({'a','b','c','d'},function(memo,v) 
-  return memo..v 
-end) -- => abcd	 
+```lua
+local function concat(a,b) return a..b end	
+M.reduce({'a','b','c','d'},concat) -- => abcd	 
 ````
 
-### reduceby (t, f, state, pred, ...)
+### reduceby (t, f, pred [, state = next(t) [, ...]])
 
 Reduces a table considering only values matching a predicate.
 For example,let us define a set of values.
@@ -237,85 +246,87 @@ For example,let us define a set of value
 ```lua
 local val = {-1, 8, 0, -6, 3, -1, 7, 1, -9}
 ````
+
+And a reduction function which will add up values.
+
+```lua
+local function add(a,b) return a+b end
+````
+ 
 We can also define some predicate functions.
 
 ```lua
 -- predicate for negative values
-local function neg(_, v) return v<=0 end
+local function neg(v) return v<=0 end
 
 -- predicate for positive values
-local function pos(_, v) return v>=0 end
+local function pos(v) return v>=0 end
 ````
 
-Then we can perform reduction considering only negative values :
+Then we can perform reduction considering only negative or positive values :
 
 ```lua
-_.reduceby(val, function(memo,v)
-  return memo+v
-end, 0, neg) -- => -17
+M.reduceby(val, add, neg) -- => -17
+M.reduceby(val, add, pos) -- => 19
 ````
 
-Or only positive values :
+An initial state can be passed in.
 
 ```lua
-_.reduceby(val, function(memo,v)
-  return memo+v
-end, 0, pos) -- => 19
+M.reduceby(val, add, neg, 17) -- => 0
+M.reduceby(val, add, pos, -19) -- => 0
 ````
 
-### reduceRight (t, f, state)
-*Aliases: `_.injectr`, `_.foldr`*.
+### reduceRight (t, f [, state = next(t)])
+*Aliases: `injectr`, `foldr`*.
 
-Similar to `_.reduce`, but performs from right to left.
+Similar to `M.reduce`, but performs from right to left.
 
 ```lua
 local initial_state = 256
-_.reduceRight({1,2,4,16},function(memo,v) 
-  return memo/v 
-end,initial_state) -- => 2
+local function div(a,b) return a/b end
+M.reduceRight({1,2,4,16},div,initial_state) -- => 2
 ````
 
-### mapReduce (t, f, state)
-*Aliases: `_.mapr`*.
+### mapReduce (t, f [, state = next(t)])
+*Aliases: `mapr`*.
 
 Reduces while saving intermediate states.
 
 ```lua
-_.mapReduce({'a','b','c'},function(memo,v) 
-  return memo..v 
-end) -- => "{'a', 'ab', 'abc'}"
+local function concat(a,b) return a..b end
+M.mapReduce({'a','b','c'},concat) -- => "{'a', 'ab', 'abc'}"
 ````
 
-### mapReduceRight (t, f, state)
-*Aliases: `_.maprr`*.
+### mapReduceRight (t, f [, state = next(t)])
+*Aliases: `maprr`*.
 
 Reduces from right to left, while saving intermediate states.
 
 ```lua
-_.mapReduceRight({'a','b','c'},function(memo,v) 
-  return memo..v 
-end) -- => "{'c', 'cb', 'cba'}"
+local function concat(a,b) return a..b end
+M.mapReduceRight({'a','b','c'},concat) -- => "{'c', 'cb', 'cba'}"
 ````
 
 ### include (t, value)
-*Aliases: `_.any`, `_.some`, `_.contains`*.
+*Aliases: `any`, `some`, `contains`*.
 
 Looks for a value in a table.
 
 ```lua
-_.include({6,8,10,16,29},16) -- => true
-_.include({6,8,10,16,29},1) -- => false
+M.include({6,8,10,16,29},16) -- => true
+M.include({6,8,10,16,29},1) -- => false
 
 local complex_table = {18,{2,{3}}}
 local collection = {6,{18,{2,6}},10,{18,{2,{3}}},29}
-_.include(collection, complex_table) -- => true
+M.include(collection, complex_table) -- => true
 ````
 
 Handles iterator functions.
 
 ```lua
 local function isUpper(v) return v:upper()== v end
-_.include({'a','B','c'},isUpper) -- => true
+M.include({'a','B','c'},isUpper) -- => true
 ````
 
 ### detect (t, value)
@@ -323,12 +334,12 @@ _.include({'a','B','c'},isUpper) -- => t
 Returns the index of a value in a table.
 
 ```lua
-_.detect({6,8,10,16},8) -- => 2
-_.detect({nil,true,0,true,true},false) -- => nil
+M.detect({6,8,10,16},8) -- => 2
+M.detect({nil,true,0,true,true},false) -- => nil
 
 local complex_table = {18,{2,6}}
 local collection = {6,{18,{2,6}},10,{18,{2,{3}}},29}
-_.detect(collection, complex_table) -- => 2
+M.detect(collection, complex_table) -- => 2
 ````
 
 Handles iterator functions.
@@ -337,7 +348,7 @@ Handles iterator functions.
 local function isUpper(v)
   return v:upper()==v
 end
-_.detect({'a','B','c'},isUpper) -- => 2
+M.detect({'a','B','c'},isUpper) -- => 2
 ````
 
 ### where (t, props)
@@ -345,94 +356,79 @@ _.detect({'a','B','c'},isUpper) -- => 2
 Looks through a table and returns all the values that matches all of the key-value pairs listed in `props`. 
 
 ```lua
-local tA = {a = 1, b = 2, c = 0}
-local tB = {a = 1, b = 4, c = 1}
-local tC = {a = 4, b = 4, c = 3}
-local tD = {a = 1, b = 2, c = 3}
-local found = _.where({tA, tB, tC, tD}, {a = 1})
-
--- => found = {tA, tB, tD}
-
-found = _.where({tA, tB, tC, tD}, {b = 4})
-
--- => found = {tB, tC}
-
-found = _.where({tA, tB, tC, tD}, {b = 4, c = 3})
-
--- => found = {tC}
+local items = {
+  {height = 10, weight = 8, price = 500},
+  {height = 10, weight = 15, price = 700},
+  {height = 15, weight = 15, price = 3000},
+  {height = 10, weight = 8, price = 3000},
+}
+M.where(items, {height = 10}) -- => {items[1], items[2], items[4]}
+M.where(items, {weight = 15}) -- => {items[2], items[3]}
+M.where(items, {prince = 3000}) -- => {items[3], items[4]}
+M.where(items, {height = 10, weight = 15, prince = 700}) -- => {items[2]}
 ````
 
 ### findWhere (t, props)
 
-Looks through a table and returns the first value that matches all of the key-value pairs listed in `props`. 
+Looks through a table and returns the first value found that matches all of the key-value pairs listed in `props`. 
 
 ```lua
 local a = {a = 1, b = 2, c = 3}
 local b = {a = 2, b = 3, d = 4}
 local c = {a = 3, b = 4, e = 5}
-_.findWhere({a, b, c}, {a = 3, b = 4}) == c -- => true
+M.findWhere({a, b, c}, {a = 3, b = 4}) == c -- => true
 ````
 
-### select (t, f, ...)
-*Aliases: `_.filter`*.
+### select (t, f [, ...])
+*Aliases: `filter`*.
 
 Collects values passing a validation test.
 
 ```lua
--- Even values
-_.select({1,2,3,4,5,6,7}, function(key,value) 
-  return (value%2==0)
-end) -- => "{2,4,6}"
+local function isEven(v) return v%2==0 end
+local function isOdd(v) return v%2~=0 end
 
--- Odd values
-_.select({1,2,3,4,5,6,7}, function(key,value) 
-  return (value%2~=0)
-end) -- => "{1,3,5,7}"
+M.select({1,2,3,4,5,6,7}, isEven) -- => "{2,4,6}"
+M.select({1,2,3,4,5,6,7}, isOdd) -- => "{1,3,5,7}"
 ````
 
-### reject (t, f, ...)
-*Aliases: `_.reject`*.
+### reject (t, f [, ...])
+*Aliases: `reject`*.
 
-Removes all values failing a validation test:
+Removes all values failing (returning false or nil) a validation test:
 
 ```lua
-_.reject({1,2,3,4,5,6,7}, function(key,value) 
-  return (value%2==0)
-end) -- => "{1,3,5,7}"
+local function isEven(v) return v%2==0 end
+local function isOdd(v) return v%2~=0 end
 
-_.reject({1,2,3,4,5,6,7}, function(key,value) 
-  return (value%2~=0)
-end) -- => "{2,4,6}"
+M.reject({1,2,3,4,5,6,7}, isEven) -- => "{1,3,5,7}"
+M.reject({1,2,3,4,5,6,7}, isOdd) -- => "{2,4,6}"
 ````
 
-### all (t, f, ...)
-*Aliases: `_.every`*.
+### all (t, f [, ...])
+*Aliases: `every`*.
 
 Checks whether or not all elements pass a validation test.
 
 ```lua
-_.all({2,4,6}, function(key,value) 
-  return (value%2==0)
-end) -- => true
+local function isEven(v) return v%2==0 end
+M.all({2,4,6}, isEven) -- => true
 ````
 
-### invoke (t, method, ...)
+### invoke (t, method [, ...])
 
-Invokes a given function on each value in a table
+Invokes a given function on each value in a table.
 
 ```lua
-_.invoke({'a','bea','cdhza'},string.len) -- => "{1,3,5}"
+M.invoke({'a','bea','cdhza'},string.len) -- => "{1,3,5}"
 ````
 
 Can reference the method of the same name in each value.
 
 ```lua
-local a = {}
-function a:call() return 'a' end
-local b, c, d = {}, {}, {}
-b.call, c.call, d.call = a.call, a.call, a.call
-
-_.invoke({a,b,c,d},'call') -- => "{'a','a','a','a'}"
+local a, b, c, d = {id = 'a'}, {id = 'b'}, {id = 'c'}, {id = 'd'}
+local function call(self) return self.id end
+M.invoke({a,b,c,d},call) -- => "{'a','b','c','d'}"
 ````
 
 ### pluck (t, property)
@@ -444,17 +440,17 @@ local peoples = {
   {name = 'John', age = 23},{name = 'Peter', age = 17},
   {name = 'Steve', age = 15},{age = 33}}
 
-_.pluck(peoples,'age') -- => "{23,17,15,33}"
-_.pluck(peoples,'name') -- => "{'John', 'Peter', 'Steve'}"
+M.pluck(peoples,'age') -- => "{23,17,15,33}"
+M.pluck(peoples,'name') -- => "{'John', 'Peter', 'Steve'}"
 ````
 
-### max (t, transform, ...)
+### max (t [, transform [, ...]])
 
 Returns the maximum value in a collection.
 
 ```lua
-_.max {1,2,3} -- => 3
-_.max {'a','b','c'} -- => 'c'
+M.max {1,2,3} -- => 3
+M.max {'a','b','c'} -- => 'c'
 ````
 
 Can take an iterator function to extract a specific property.
@@ -463,16 +459,16 @@ Can take an iterator function to extract
 local peoples = {
   {name = 'John', age = 23},{name = 'Peter', age = 17},
   {name = 'Steve', age = 15},{age = 33}}
-_.max(peoples,function(people) return people.age end) -- => 33
+M.max(peoples,function(people) return people.age end) -- => 33
 ````
 
-### min (t, transform, ...)
+### min (t [, transform [, ...]])
 
 Returns the minimum value in a collection.
 
 ```lua
-_.min {1,2,3} -- => 1
-_.min {'a','b','c'} -- => 'a'
+M.min {1,2,3} -- => 1
+M.min {'a','b','c'} -- => 'a'
 ````
 
 Can take an iterator function to extract a specific property.
@@ -481,16 +477,7 @@ Can take an iterator function to extract
 local peoples = {
   {name = 'John', age = 23},{name = 'Peter', age = 17},
   {name = 'Steve', age = 15},{age = 33}}
-_.min(peoples,function(people) return people.age end) -- => 15
-````
-
-### shuffle (t, seed)
-
-Shuffles a collection.
-
-```lua
-local list = _.shuffle {1,2,3,4,5,6} -- => "{3,2,6,4,1,5}"
-_.each(list,print)
+M.min(peoples,function(people) return people.age end) -- => 15
 ````
 
 ### same (a, b)
@@ -500,34 +487,34 @@ Tests whether or not all values in each
 ```lua
 local a = {'a','b','c','d'}      
 local b = {'b','a','d','c'}
-_.same(a,b) -- => true
+M.same(a,b) -- => true
 
 b[#b+1] = 'e'
-_.same(a,b) -- => false
+M.same(a,b) -- => false
 ````
 
-### sort (t, comp)
+### sort (t [, comp = math.min])
 
 Sorts a collection.
 
 ```lua
-_.sort({'b','a','d','c'}) -- => "{'a','b','c','d'}"
+M.sort({'b','a','d','c'}) -- => "{'a','b','c','d'}"
 ````
 
 Handles custom comparison functions.
 
 ```lua
-_.sort({'b','a','d','c'}, function(a,b) 
+M.sort({'b','a','d','c'}, function(a,b) 
   return a:byte() > b:byte() 
 end) -- => "{'d','c','b','a'}"
 ````
 
-### sortBy (t, transform, comp)
+### sortBy (t [, transform [, comp = math.min]])
 
 Sorts items in a collection based on the result of running a transform function through every item in the collection.
 
 ```lua
-local r = _.sortBy({1,2,3,4,5}, math.sin)
+local r = M.sortBy({1,2,3,4,5}, math.sin)
 print(table.concat(r,','))
 
 -- => {5,4,3,1,2}
@@ -536,14 +523,14 @@ print(table.concat(r,','))
 The transform function can also be a string name property.
 
 ```lua
-local people ={
+local people = {
 	{name = 'albert', age = 40},
 	{name = 'louis', age = 55},
 	{name = 'steve', age = 35},
 	{name = 'henry', age = 19},
 }
-local r = _.sortBy(people, 'age')
-_.each(r, function(__,v) print(v.age, v.name)	end)
+local r = M.sortBy(people, 'age')
+M.each(r, function(v) print(v.age, v.name)	end)
 
 -- => 19	henry
 -- => 35	steve
@@ -551,18 +538,17 @@ _.each(r, function(__,v) print(v.age, v.
 -- => 55	louis
 ````
 
-As seen above, the defaut comparison function is the '<' operator. For example, let us supply a different one to sort
-the list of people by decreasing age order :
+As seen above, the defaut comparison function is the '<' operator. For example, let us supply a different one to sort the list of people by decreasing age order :
 
 ```lua
-local people ={
+local people = {
 	{name = 'albert', age = 40},
 	{name = 'louis', age = 55},
 	{name = 'steve', age = 35},
 	{name = 'henry', age = 19},
 }
-local r = _.sortBy(people, 'age', function(a,b) return a > b end)
-_.each(r, function(__,v) print(v.age, v.name)	end)
+local r = M.sortBy(people, 'age', function(a,b) return a > b end)
+M.each(r, function(v) print(v.age, v.name)	end)
 
 -- => 55	louis
 -- => 40	albert
@@ -570,36 +556,36 @@ _.each(r, function(__,v) print(v.age, v.
 -- => 19	henry
 ````
 
-The `transform` function defaults to `_.indentity` and in that case, `_.sortBy` behaves like `_.sort`.
+The `transform` function defaults to `M.indentity` and in that case, `M.sortBy` behaves like `M.sort`.
 
 ```lua
-local r = _.sortBy({1,2,3,4,5})
+local r = M.sortBy({1,2,3,4,5})
 print(table.concat(r,','))
 
 -- => {1,2,3,4,5}
 ````
 
-### groupBy (t, iter, ...)
+### groupBy (t, iter [, ...])
 
 Groups values in a collection depending on their return value when passed to a predicate test.
 
 ```lua
-_.groupBy({0,1,2,3,4,5,6},function(i,value) 
-  return value%2==0 and 'even' or 'odd'
-end) -- => "{odd = {1,3,5}, even = {0,2,4,6}}"
+M.groupBy({0,1,2,3,4,5,6},function(v) 
+  return v%2==0 and 'even' or 'odd'
+end)
+-- => "{odd = {1,3,5}, even = {0,2,4,6}}"
 
-_.groupBy({0,'a',true, false,nil,b,0.5},function(i,value) 
-  return type(value) 
-end) -- => "{number = {0,0.5}, string = {'a'}, boolean = {true, false}}"		
+M.groupBy({0,'a',true, false,nil,b,0.5},type) 
+-- => "{number = {0,0.5}, string = {'a'}, boolean = {true, false}}"		
 ````
 
-### countBy (t, iter, ...)
+### countBy (t [, iter [, ...]])
 
 Splits a table in subsets and provide the count for each subset.
 
 ```lua
-_.countBy({0,1,2,3,4,5,6},function(i,value) 
-  return value%2==0 and 'even' or 'odd'
+M.countBy({0,1,2,3,4,5,6},function(v) 
+  return v%2==0 and 'even' or 'odd'
 end) -- => "{odd = 3, even = 4}"
 ````
 
@@ -608,15 +594,15 @@ end) -- => "{odd = 3, even = 4}"
 When given a table, provides the count for the very number of values in that table.
 
 ```lua
-_.size {1,2,3} -- => 3
-_.size {one = 1, two = 2} -- => 2
+M.size {1,2,3} -- => 3
+M.size {one = 1, two = 2} -- => 2
 ````
 
-When given a vararg list of argument, returns the count of these arguments.
+When given a vararg list of arguments, returns the count of these arguments.
 
 ```lua
-_.size(1,2,3) -- => 3
-_.size('a','b',{}, function() end) -- => 4
+M.size(1,2,3) -- => 3
+M.size('a','b',{}, function() end) -- => 4
 ````
 
 ### containsKeys (t, other)
@@ -624,9 +610,9 @@ _.size('a','b',{}, function() end) -- =>
 Checks whether a table has all the keys existing in another table.
 
 ```lua
-_.contains({1,2,3,4},{1,2,3}) -- => true
-_.contains({1,2,'d','b'},{1,2,3,5}) -- => true
-_.contains({x = 1, y = 2, z = 3},{x = 1, y = 2}) -- => true
+M.contains({1,2,3,4},{1,2,3}) -- => true
+M.contains({1,2,'d','b'},{1,2,3,5}) -- => true
+M.contains({x = 1, y = 2, z = 3},{x = 1, y = 2}) -- => true
 ````
 
 ### sameKeys (tA, tB)
@@ -634,22 +620,22 @@ _.contains({x = 1, y = 2, z = 3},{x = 1,
 Checks whether both tables features the same keys:
 
 ```lua
-_.sameKeys({1,2,3,4},{1,2,3}) -- => false
-_.sameKeys({1,2,'d','b'},{1,2,3,5}) -- => true
-_.sameKeys({x = 1, y = 2, z = 3},{x = 1, y = 2}) -- => false
+M.sameKeys({1,2,3,4},{1,2,3}) -- => false
+M.sameKeys({1,2,'d','b'},{1,2,3,5}) -- => true
+M.sameKeys({x = 1, y = 2, z = 3},{x = 1, y = 2}) -- => false
 ````
 
 **[[⬆]](#TOC)**
 
 ## <a name='array'>Array functions</a>
 
-### sample (array, n, seed)
+### sample (array [, n = 1 [, seed]])
 
 Samples `n` values from array.
 
 ```lua
-local array = _.range(1,20)
-local sample = _.sample(array, 3)
+local array = M.range(1,20)
+local sample = M.sample(array, 3)
 print(table.concat(sample,','))
 
 -- => {12,11,15}
@@ -658,8 +644,8 @@ print(table.concat(sample,','))
 `n` defaults to 1. In that case, a single value will be returned.
 
 ```lua
-local array = _.range(1,20)
-local sample = _.sample(array)
+local array = M.range(1,20)
+local sample = M.sample(array)
 print(sample)
 
 -- => 12
@@ -667,45 +653,55 @@ print(sample)
 
 An optional 3rd argument `seed` can be passed for deterministic random sampling.
 
-### sampleProb (array, prob, seed)
+### sampleProb (array, prob [, seed])
 
 Returns an array of values randomly selected from a given array.
 In case `seed` is provided, it is used for deterministic sampling.
 
 ```lua
-local array = _.range(1,20)
-local sample = _.sampleProb(array, 0.2)
+local array = M.range(1,20)
+local sample = M.sampleProb(array, 0.2)
 print(table.concat(sample,','))
 
 -- => 5,11,12,15
 
-sample = _.sampleProb(array, 0.2, os.time())
+sample = M.sampleProb(array, 0.2, os.time())
 print(table.concat(sample,','))
 
 -- => 1,6,10,12,15,20 (or similar)
 ````
 
+### shuffle (array [, seed])
+
+Shuffles a given array.
+
+```lua
+local list = M.shuffle {1,2,3,4,5,6} -- => "{3,2,6,4,1,5}"
+M.each(list,print)
+````
+
 ### toArray (...)
 
 Converts a vararg list of arguments to an array.
 
 ```lua
-_.toArray(1,2,8,'d','a',0) -- => "{1,2,8,'d','a',0}"
+M.toArray(1,2,8,'d','a',0) -- => "{1,2,8,'d','a',0}"
 ````
 
-### find (array, value, from)
+### find (array, value [, from = 1])
 
 Looks for a value in a given array and returns the position of the first occurence.
 
 ```lua
-_.find({{4},{3},{2},{1}},{3}) -- => 2
+local value = {3}
+M.find({{4},{3},{2},{1}},value) -- => 2
 ````
 
 It can also start the search at a specific position in the array:
 
 ```lua
 -- search value 4 starting from index 3
-_.find({1,4,2,3,4,5},4,3) -- => 5
+M.find({1,4,2,3,4,5},4,3) -- => 5
 ````
 
 ### reverse (array)
@@ -713,74 +709,98 @@ _.find({1,4,2,3,4,5},4,3) -- => 5
 Reverses an array.
 
 ```lua
-_.reverse({1,2,3,'d'}) -- => "{'d',3,2,1}"
+M.reverse({1,2,3,'d'}) -- => "{'d',3,2,1}"
 ````
 
-### fill (array, value, i, j)
+### fill (array, value [, i = 1 [, j = #array]])
 
 Replaces all elements in a given array with a given value.
 
 ```lua
-local array = _.range(1,5)
-_.fill(array, 0) -- => {0,0,0,0,0}
+local array = M.range(1,5)
+M.fill(array, 0) -- => {0,0,0,0,0}
 ````
 
 It can start replacing value at a specific index.
 
 ```lua
-local array = _.range(1,5)
-_.fill(array,0,3) -- => {1,2,0,0,0}
+local array = M.range(1,5)
+M.fill(array,0,3) -- => {1,2,0,0,0}
 ````
 
 It can replace only values within a specific range.
 
 ```lua
-local array = _.range(1,5)
-_.fill(array,0,2,4) -- => {1,0,0,0,5}
+local array = M.range(1,5)
+M.fill(array,0,2,4) -- => {1,0,0,0,5}
 ````
 
 In case the upper bound index i greather than the array size, it will enlarge the array.
 
 ```lua
-local array = _.range(1,5)
-_.fill(array,0,5,10) -- => {1,2,3,4,0,0,0,0,0,0}
+local array = M.range(1,5)
+M.fill(array,0,5,10) -- => {1,2,3,4,0,0,0,0,0,0}
+````
+
+### zeros (n)
+
+Returns an array of `n` zeros.
+
+```lua 
+M.zeros(4) -- => {0,0,0,0}
+````
+
+### ones (n)
+
+Returns an array of `n` 1's.
+
+```lua 
+M.ones(3) -- => {1,1,1}
+````
+
+### vector (value, n)
+
+Returns an array of `n` times a given value.
+
+```lua 
+M.vector(10, 4) -- => {10,10,10,10}
 ````
 
-### selectWhile (array, f, ...
-*Aliases: `_.takeWhile`*.
+### selectWhile (array, f [, ...])
+*Aliases: `takeWhile`*.
 
 Collects values as long as they pass a given test. Stops on the first non-passing test.
 
 ```lua
-_.selectWhile({2,4,5,8}, function(i,v)
+M.selectWhile({2,4,5,8}, function(v)
   return v%2==0
 end) -- => "{2,4}"
 ````
 
-### dropWhile (array, f, ...
-*Aliases: `_.rejectWhile`*.
+### dropWhile (array, f [, ...])
+*Aliases: `rejectWhile`*.
 
 Removes values as long as they pass a given test. Stops on the first non-passing test.
 
 ```lua
-_.dropWhile({2,4,5,8}, function(i,v)
+M.dropWhile({2,4,5,8}, function(v)
   return v%2==0
 end) -- => "{5,8}"
 ````
 
-### sortedIndex (array, value, comp, sort)
+### sortedIndex (array, value [, comp = math.min [, sort = nil]])
 
 Returns the index at which a value should be inserted to preserve order.
 
 ```lua
-_.sortedIndex({1,2,3},4) -- => 4
+M.sortedIndex({1,2,3},4) -- => 4
 ````
 
 Can take a custom comparison functions.
 
 ```lua
 local comp = function(a,b) return a<b end
-_.sortedIndex({-5,0,4,4},3,comp) -- => 3
+M.sortedIndex({-5,0,4,4},3,comp) -- => 3
 ````
 
 ### indexOf (array, value)
@@ -788,7 +808,7 @@ _.sortedIndex({-5,0,4,4},3,comp) -- => 3
 Returns the index of a value in an array.
 
 ```lua
-_.indexOf({1,2,3},2) -- => 2
+M.indexOf({1,2,3},2) -- => 2
 ````
 
 ### lastIndexOf (array, value)
@@ -796,27 +816,27 @@ _.indexOf({1,2,3},2) -- => 2
 Returns the index of the last occurence of a given value in an array.
 
 ```lua
-_.lastIndexOf({1,2,2,3},2) -- => 3
+M.lastIndexOf({1,2,2,3},2) -- => 3
 ````
 
-### findIndex (array, predicate, ...)
+### findIndex (array, predicate [, ...])
 
 Returns the first index at which a predicate passes a truth test.
 
 ```lua
 local array = {1,2,3,4,5,6}
-local function multipleOf3(__,v) return v%3==0 end
-_.findIndex(array, multipleOf3) -- => 3
+local function multipleOf3(v) return v%3==0 end
+M.findIndex(array, multipleOf3) -- => 3
 ````
 
-### findLastIndex (array, predicate, ...)
+### findLastIndex (array, predicate [, ...])
 
-Returns the last index at which a predicate passes a truth test.
+Returns the last index at which a predicate passes a truthy test.
 
 ```lua
 local array = {1,2,3,4,5,6}
-local function multipleOf3(__,v) return v%3==0 end
-_.findLastIndex(array, multipleOf3) -- => 6
+local function multipleOf3(v) return v%3==0 end
+M.findLastIndex(array, multipleOf3) -- => 6
 ````
 
 ### addTop (array, ...)
@@ -825,7 +845,16 @@ Adds given values at the top of an array
 
 ```lua
 local array = {1}
-_.addTop(array,1,2,3,4) -- => "{4,3,2,1,1}"
+M.addTop(array,1,2,3,4) -- => "{4,3,2,1,1}"
+````
+
+### prepend (array, ...)
+
+Adds given values at the top of an array, preserving the order at which elements are passed-in.
+
+```lua
+local array = {'old_val'}
+M.prepend(array,1,2,3,4) -- => "{1,2,3,4,'old_val'}"
 ````
 
 ### push (array, ...)
@@ -834,104 +863,109 @@ Adds given values at the end of an array
 
 ```lua
 local array = {1}
-_.push(array,1,2,3,4) -- => "{1,1,2,3,4}"
+M.push(array,1,2,3,4) -- => "{1,1,2,3,4}"
 ````
 
-### pop (array, n)
-*Aliases: `_.shift`*.
+### shift (array [, n = 1])
+*Aliases: `pop`*.
 
 Removes and returns the first value in an array.
 
 ```lua
 local array = {1,2,3}
-local pop = _.pop(array) -- => "pop = 1", "array = {2,3}"
+local shift = M.shift(array) -- => "shift = 1", "array = {2,3}"
 ````
+If `n` is supplied, returns `n` values.
 
-### unshift (array, n)
+```lua
+local array = {1,2,3,4,5}
+local a, b = M.shift(array, 2) -- => "a = 1, b = 2", "array = {3,4,5}"
+````
+
+### unshift (array [, n = 1])
 
 Removes and returns the last value in an array.
 
 ```lua
 local array = {1,2,3}
-local value = _.unshift(array) -- => "value = 3", "array = {1,2}"
+local value = M.unshift(array) -- => "value = 3", "array = {1,2}"
 ````
 
 ### pull (array, ...)
-*Aliases: `_.remove`*.
+*Aliases: `remove`*.
 
 Removes all provided values from a given array.
 
 ```lua
-_.pull({1,2,1,2,3,4,3},1,2,3) -- => "{4}"
+M.pull({1,2,1,2,3,4,3},1,2,3) -- => "{4}"
 ````
 
-### removeRange (array, start, finish)
-*Aliases: `_.rmRange`, `_.chop`*.
+### removeRange (array [, start = 1 [, finish = #array]])
+*Aliases: `rmRange`, `M.chop`*.
 
 Trims out all values index within a range.
 
 ```lua
 local array = {1,2,3,4,5,6,7,8,9}
-_.removeRange(array, 3,8) -- => "{1,2,9}"
+M.removeRange(array, 3,8) -- => "{1,2,9}"
 ````
 
-### chunk (array, f, ...)
+### chunk (array, f [, ...])
 
-Iterates over an array aggregating consecutive values in subsets tables, on the basis of the return
-value of `f(key,value,...)`. Consecutive elements which return the same value are aggregated together.
+Iterates over an array aggregating consecutive values in subsets tables, on the basis of the return value of `f(v, k, ...)`. Consecutive elements which return the same value are chunked together.
 
 ```lua
 local t = {1,1,2,3,3,4}
-_.chunk(t, function(k,v) return v%2==0 end) -- => "{{1,1},{2},{3,3},{4}}"
+M.chunk(t, function(v) return v%2==0 end) -- => "{{1,1},{2},{3,3},{4}}"
 ````
 
-### slice (array, start, finish)
-*Aliases: `_.sub`*.
+### slice (array [, start = 1 [, finish = #array]])
+*Aliases: `sub`*.
 
 Slices and returns a part of an array.
 
 ```lua
 local array = {1,2,3,4,5,6,7,8,9}
-_.slice(array, 3,6) -- => "{3,4,5,6}"
+M.slice(array, 3,6) -- => "{3,4,5,6}"
 ````
 
-### first (array, n)
-*Aliases: `_.head`, `_.take`*.
+### first (array [, n = 1])
+*Aliases: `head`, `M.take`*.
 
 Returns the first N elements in an array.
 
 ```lua
 local array = {1,2,3,4,5,6,7,8,9}
-_.first(array,3) -- => "{1,2,3}"
+M.first(array,3) -- => "{1,2,3}"
 ````
 
-### initial (array, n)
+### initial (array [, n = #array])
 
 Excludes the last N elements in an array.
 
 ```lua
 local array = {1,2,3,4,5,6,7,8,9}
-_.initial(array,5) -- => "{1,2,3,4}"
+M.initial(array,5) -- => "{1,2,3,4}"
 ````
 
-### last (array, n)
-*Aliases: `_.skip`*.
+### last (array [, n = #array])
+*Aliases: `skip`*.
 
 Returns the last N elements in an array.
 
 ```lua
 local array = {1,2,3,4,5,6,7,8,9}
-_.last(array,3) -- => "{7,8,9}"
+M.last(array,3) -- => "{7,8,9}"
 ````
 
-### rest (array, index)
-*Aliases: `_.tail`*.
+### rest (array [, index = 1])
+*Aliases: `tail`*.
 
-Trims out all values indexed before *index*.
+Returns all values after *index*, including the given *index* itself.
 
 ```lua
 local array = {1,2,3,4,5,6,7,8,9}
-_.rest(array,6) -- => "{6,7,8,9}"
+M.rest(array,6) -- => "{6,7,8,9}"
 ````
 
 ### nth (array, index)
@@ -940,7 +974,7 @@ Returns the value at *index*.
 
 ```lua
 local array = {1,2,3,4,5,6}
-_.nth(array,3) -- => "3"
+M.nth(array,3) -- => "3"
 ````
 
 ### compact (array)
@@ -948,31 +982,31 @@ _.nth(array,3) -- => "3"
 Trims out all falsy values.
 
 ```lua
-_.compact {a,'aa',false,'bb',true} -- => "{'aa','bb',true}"
+M.compact {a,'aa',false,'bb',true} -- => "{'aa','bb',true}"
 ````
 
-### flatten (array, shallow)
+### flatten (array [, shallow = false])
 
 Flattens a nested array.
 
 ```lua
-_.flatten({1,{2,3},{4,5,{6,7}}}) -- => "{1,2,3,4,5,6,7}"
+M.flatten({1,{2,3},{4,5,{6,7}}}) -- => "{1,2,3,4,5,6,7}"
 ````
 
-When given arg "shallow", flatten only at the first level.
+When given arg `shallow`, flatten only at the first level.
 
 ```lua
-_.flatten({1,{2},{{3}}},true) -- => "{1,{2},{{3}}}"
+M.flatten({1,{2},{{3}}},true) -- => "{1,{2},{{3}}}"
 ````
 
 ### difference (array, array2)
-*Aliases: `_.without`, `_.diff`*.
+*Aliases: `without`, `diff`*.
 
 Returns values in the given array not present in a second array.
 
 ```lua
 local array = {1,2,'a',4,5}
-_.difference(array,{1,'a'}) -- => "{2,4,5}"
+M.difference(array,{1,'a'}) -- => "{2,4,5}"
 ````
 
 ### union (...)
@@ -983,7 +1017,7 @@ Produces a duplicate-free union of all p
 local A = {'a'}
 local B = {'a',1,2,3}
 local C = {2,10}
-_.union(A,B,C) -- => "{'a',1,2,3,10}"
+M.union(A,B,C) -- => "{'a',1,2,3,10}"
 ````
 
 ### intersection (array, ...)
@@ -994,48 +1028,65 @@ Returns the intersection (common-part) o
 local A = {'a'}
 local B = {'a',1,2,3}
 local C = {2,10,1,'a'}
-_.intersection(A,B,C) -- => "{'a',2,1}"
+M.intersection(A,B,C) -- => "{'a',2,1}"
 ````
 
 ### symmetricDifference (array, array2)
-*Aliases: `_.symdiff`,`_.xor`*.
+*Aliases: `symdiff`,`xor`*.
 
 Returns values in the first array not present in the second and also values in the second array not present in the first one.
 
 ```lua
 local array = {1,2,3}
 local array2 = {1,4,5}
-_.symmetricDifference(array, array2) -- => "{2,3,4,5}"
+M.symmetricDifference(array, array2) -- => "{2,3,4,5}"
 ````
 
 ### unique (array)
-*Aliases: `_.uniq`*.
+*Aliases: `uniq`*.
 
 Makes an array duplicate-free.
 
 ```lua
-_.unique {1,1,2,2,3,3,4,4,4,5} -- => "{1,2,3,4,5}"
+M.unique {1,1,2,2,3,3,4,4,4,5} -- => "{1,2,3,4,5}"
 ````
 
 ### isunique (array)
-*Aliases: `_.isuniq`*.
+*Aliases: `isuniq`*.
 
 Checks if a given array contains no duplicate value.
 
 ```lua
-_.isunique({1,2,3,4,5}) -- => true
-_.isunique({1,2,3,4,4}) -- => false
+M.isunique({1,2,3,4,5}) -- => true
+M.isunique({1,2,3,4,4}) -- => false
 ````
 
 ### zip (...)
-*Aliases: `_.transpose`*.
+*Aliases: `transpose`*.
 
 Zips values from different arrays, on the basis on their common keys.
 
 ```lua
 local names = {'Bob','Alice','James'}
 local ages = {22, 23}
-_.zip(names,ages) -- => "{{'Bob',22},{'Alice',23},{'James'}}"
+M.zip(names,ages) -- => "{{'Bob',22},{'Alice',23},{'James'}}"
+````
+
+### zipWith (f, ...)
+*Aliases: `transposeWith`*.
+      
+Merges values using a given function. Only values indexed with the same key in the given arrays are merged in the same subset.
+Function `f` is used to combine values.
+
+```lua
+local names = {'Bob','Alice','James'}; local ages = {22, 23, 25}
+local function introduce(name, age) return 'I am '..name..' and I am '..age..' years old.' end
+local t = M.zipWith(introduce,names,ages)
+-- => {
+-- =>  'I am Bob and I am 22 years old.'
+-- =>  'I am Alice and I am 23 years old.'
+-- =>  'I am James and I am 25 years old.'
+-- => }
 ````
 
 ### append (array, other)
@@ -1043,7 +1094,7 @@ _.zip(names,ages) -- => "{{'Bob',22},{'A
 Appends two arrays.
 
 ```lua
-_.append({1,2,3},{'a','b'}) -- => "{1,2,3,'a','b'}"
+M.append({1,2,3},{'a','b'}) -- => "{1,2,3,'a','b'}"
 ````
 
 ### interleave (...)
@@ -1053,35 +1104,43 @@ Interleaves values from passed-in arrays
 ```lua
 t1 = {1, 2, 3}
 t2 = {'a', 'b', 'c'}
-_.interleave(t1, t2) -- => "{1,'a',2,'b',3,'c'}"
+M.interleave(t1, t2) -- => "{1,'a',2,'b',3,'c'}"
 ````
 
-### interpose (value, array)
+### interpose (array, value)
+*Aliases: `intersperce`*.
 
 Interposes a value between consecutive values in an arrays.
 
 ```lua
-_.interleave('a', {1,2,3}) -- => "{1,'a',2,'a',3}"
+M.interleave('a', {1,2,3}) -- => "{1,'a',2,'a',3}"
 ````
 
-### range (...)
+### range ([from [, to [, step]]])
 
 Generates an arithmetic sequence.
 
 ```lua
-_.range(1,4) -- => "{1,2,3,4}"
+M.range(1,4) -- => "{1,2,3,4}"
 ````
 
-In case a single value is provided, it generates a sequence from 0 to that value.
+In case a single value is provided, it generates a sequence from 1 to that value.
 
 ````
-_.range(3) -- => "{0,1,2,3}"
+M.range(3) -- => "{1,2,3}"
 ````
 
 The incremental step can also be provided as third argument.
 
 ```lua
-_.range(0,2,0.7) -- => "{0,0.7,1.4}"
+M.range(0,2,0.7) -- => "{0,0.7,1.4}"
+````
+
+It also handles negative progressions.
+
+```lua
+M.range(-5) -- => "{-1,-2,-3,-4,-5}"
+M.range(5,1) -- => "{5,4,3,2,1}"
 ````
 
 ### rep (value, n)
@@ -1089,17 +1148,25 @@ _.range(0,2,0.7) -- => "{0,0.7,1.4}"
 Generates a list of n repetitions of a value.
 
 ```lua
-_.rep(4,3) -- => "{4,4,4}"
+M.rep(4,3) -- => "{4,4,4}"
+````
+
+### powerset (array)
+
+Returns the powerset of an array.
+
+```lua
+M.powerset {1,2,3} -- => "{{1},{2},{3},{1,2},{2,3},{1,2,3}}"
 ````
 
-### partition (array, n, pad)
-*Aliases: `_.part`*.
+### partition (array [, n = 1 [, pad]])
+*Aliases: `part`*.
 
 Returns an iterator function for partitions of a given array.
 
 ```lua
 local t = {1,2,3,4,5,6}
-for p in _.partition(t,2) do
+for p in M.partition(t,2) do
   print(table.concat(p, ','))
 end
 
@@ -1108,7 +1175,7 @@ end
 -- => 5,6
 
 local t = {1,2,3,4,5,6}
-for p in _.partition(t,4) do
+for p in M.partition(t,4) do
   print(table.concat(p, ','))
 end
 
@@ -1120,7 +1187,7 @@ In case the last partition has less elem
 
 ```lua
 local t = {1,2,3,4,5,6}
-for p in _.partition(t,4,0) do
+for p in M.partition(t,4,0) do
   print(table.concat(p, ','))
 end
 
@@ -1128,13 +1195,13 @@ end
 -- => 5,6,0,0
 ````
 
-### sliding (array, n, pad)
+### overlapping (array [, n = 2 [, pad]])
 
 Returns an iterator function which provides overlapping subsequences of a given array.
 
 ```lua
 local t = {1,2,3,4,5,6,7}
-for p in _.sliding(t,3) do
+for p in M.overlapping(t,3) do
 	print(table.concat(p,','))
 end
 
@@ -1142,14 +1209,14 @@ end
 -- => 3,4,5
 -- => 5,6,7
 
-for p in _.sliding(t,4) do
+for p in M.overlapping(t,4) do
 	print(table.concat(p,','))
 end
 
 -- => 1,2,3,4
 -- => 4,5,6,7
 
-for p in _.sliding(t,5) do
+for p in M.overlapping(t,5) do
 	print(table.concat(p,','))
 end
 
@@ -1161,7 +1228,7 @@ In case the last subsequence wil not mat
 
 ```lua
 local t = {1,2,3,4,5,6,7}
-for p in _.sliding(t,5,0) do
+for p in M.overlapping(t,5,0) do
 	print(table.concat(p,','))
 end
 
@@ -1169,14 +1236,53 @@ end
 -- => 5,6,7,0,0
 ````
 
+### aperture (array [, n = 2])
+*Aliases: `sliding`*.
+
+Returns an iterator function which provides sliding partitions of a given array.
+
+```lua
+local t = {1,2,3,4,5}
+for p in M.aperture(t,4) do
+  print(table.concat(p,','))
+end
+
+-- => 1,2,3,4
+-- => 2,3,4,5
+
+for p in M.aperture(t,3) do
+  print(table.concat(p,','))
+end
+
+-- => 1,2,3
+-- => 2,3,4
+-- => 3,4,5
+````
+
+### pairwise (array)
+
+Iterator returning sliding pairs of an array.
+
+```lua
+local t = M.range(5)
+for p in pairwise(t) do
+  print(table.concat(p,','))
+end
+
+-- => 1,2
+-- => 2,3
+-- => 3,4
+-- => 4,5
+````
+
 ### permutation (array)
-*Aliases: `_.perm`*.
+*Aliases: `perm`*.
 
 Returns an iterator function for permutations of a given array.
 
 ```lua
 t = {'a','b','c'}
-for p in _.permutation(t) do
+for p in M.permutation(t) do
   print(table.concat(p))
 end
 
@@ -1189,21 +1295,63 @@ end
 ````
 
 ### invert (array)
-*Aliases: `_.mirror`*.
+*Aliases: `mirror`*.
 
 Switches <tt>key-value</tt> pairs:
 
 ```lua
-_.invert {'a','b','c'} -- => "{a=1, b=2, c=3}"
+M.invert {'a','b','c'} -- => "{a=1, b=2, c=3}"
 ````
 
-### concat (array, sep, i, j)
-*Aliases: `_.join`*.
+### concat (array [, sep = '' [, i = 1 [, j = #array]]])
+*Aliases: `join`*.
 
 Concatenates a given array values:
 
 ```lua
-_.concat({'a',1,0,1,'b'}) -- => 'a101b'
+M.concat({'a',1,0,1,'b'}) -- => 'a101b'
+````
+
+### xprod (array, array2)
+
+Returns all possible pairs built from given arrays.
+
+```lua
+local t = M.xprod({1,2},{'a','b'})
+-- => {{1,'a'},{1,'b'},{2,'a'},{2,'b'}}
+````
+
+### sum (array)
+
+Returns the sum of array values.
+
+```lua
+M.sum({1,2,3,4,5}) -- => 15
+````
+
+### product (array)
+
+Returns the product of array values.
+
+```lua
+M.product({1,2,3,4,5}) -- => 120
+````
+
+### mean (array)
+
+Returns the mean of array values.
+
+```lua
+M.mean({1,2,3,4,5}) -- => 3
+````
+
+### median (array)
+
+Returns the median of array values.
+
+```lua
+M.median({1,2,3,4,5}) -- => 3
+M.median({1,2,3,4}) -- => 2.5
 ````
 
 **[[⬆]](#TOC)**
@@ -1215,7 +1363,7 @@ _.concat({'a',1,0,1,'b'}) -- => 'a101b'
 The no-operation function. Takes nothing, returns nothing. It is being used internally.
 
 ```lua
-_.noop() -- => nil
+M.noop() -- => nil
 ````
 
 ### identity (value)
@@ -1224,9 +1372,9 @@ Returns the passed-in value. <br/>
 This function is internally used as a default transformation function.
 
 ```lua
-_.identity(1)-- => 1
-_.identity(false) -- => false
-_.identity('hello!') -- => 'hello!'
+M.identity(1)-- => 1
+M.identity(false) -- => false
+M.identity('hello!') -- => 'hello!'
 ````
 
 ### constant (value)
@@ -1234,14 +1382,27 @@ _.identity('hello!') -- => 'hello!'
 Creates a constant function. This function will continuously yield the same output.
 
 ```lua
-local pi = _.constant(math.pi)
+local pi = M.constant(math.pi)
 pi(1) -- => 3.1415926535898
 pi(2) -- => 3.1415926535898
 pi(math.pi) -- => 3.1415926535898
 ````
 
-### memoize (f, hash)
-*Aliases: `_.cache`*.
+### applySpec (specs)
+
+Returns a function which applies `specs` on args. This function will produce an object having the same structure than `specs` by mapping each property to the result of calling its associated function with the supplied arguments.
+
+```lua
+local stats = M.applySpec({
+  min = function(...) return math.min(...) end,
+  max = function(...) return math.max(...) end,
+})
+
+stats(5,4,10,1,8) -- => {min = 1, max = 10}
+````
+
+### memoize (f)
+*Aliases: `cache`*.
 
 Memoizes a slow-running function. It caches the result for a specific input, so that the next time the function is called with the same input, it will lookup the result in its cache, instead of running again the function body.
 
@@ -1249,17 +1410,28 @@ Memoizes a slow-running function. It cac
 local function fibonacci(n)
   return n < 2 and n or fibonacci(n-1)+fibonacci(n-2)
 end  
-local mem_fibonacci = _.memoize(fibonacci)
+local mem_fibonacci = M.memoize(fibonacci)
 fibonacci(20) -- => 6765 (but takes some time)
 mem_fibonacci(20) -- => 6765 (takes less time)
 ````
 
+### unfold (f, seed)
+
+Builds a list from a seed value. Accepts an iterator function, which returns either nil to stop iteration or two values : the value to add to the list of results and the seed to be used in the next call to the iterator function.
+
+```lua
+local function f(v)
+  if v < 100 then return v, v * 2 end
+end
+local t = M.unfold(f, 10) -- => {10,20,40,80}
+````
+
 ### once (f)
 
 Produces a function that runs only once. Successive calls to this function will still yield the same input.
 
 ```lua
-local sq = _.once(function(a) return a*a end)
+local sq = M.once(function(a) return a*a end)
 sq(1) -- => 1
 sq(2) -- => 1
 sq(3) -- => 1
@@ -1273,7 +1445,7 @@ Returns a version of `f` that will run n
 
 ```lua
 local function greet(someone) return 'hello '..someone end
-local greetOnly3people = _.before(greet, 3)
+local greetOnly3people = M.before(greet, 3)
 greetOnly3people('John') -- => 'hello John'
 greetOnly3people('Moe') -- => 'hello Moe'
 greetOnly3people('James') -- => 'hello James'
@@ -1286,7 +1458,7 @@ greetOnly3people('Allan') -- => 'hello J
 Produces a function that will respond only after a given number of calls.
 
 ```lua
-local f = _.after(_.identity,3)
+local f = M.after(M.identity,3)
 f(1) -- => nil
 f(2) -- => nil
 f(3) -- => 3
@@ -1301,7 +1473,7 @@ Composes functions. Each function consum
 local function f(x) return x^2 end
 local function g(x) return x+1 end
 local function h(x) return x/2 end
-local compositae = _.compose(f,g,h)
+local compositae = M.compose(f,g,h)
 compositae(10) -- => 36
 compositae(20) -- => 121
 ````
@@ -1314,8 +1486,8 @@ Pipes a value through a series of functi
 local function f(x) return x^2 end
 local function g(x) return x+1 end
 local function h(x) return x/2 end
-_.pipe(10,f,g,h) -- => 36
-_.pipe(20,f,g,h) -- => 121
+M.pipe(10,f,g,h) -- => 36
+M.pipe(20,f,g,h) -- => 121
 ````
 
 ### complement (f)
@@ -1323,11 +1495,11 @@ _.pipe(20,f,g,h) -- => 121
 Returns a function which returns the logical complement of a given function.
 
 ```lua
-_.complement(function() return true end)() -- => false
+M.complement(function() return true end)() -- => false
 ````
 
 ### juxtapose (value, ...)
-*Aliases: `_.juxt`*.
+*Aliases: `juxt`*.
 
 Calls a sequence of functions with the same input.
 
@@ -1335,7 +1507,7 @@ Calls a sequence of functions with the s
 local function f(x) return x^2 end
 local function g(x) return x+1 end
 local function h(x) return x/2 end
-_.juxtapose(10, f, g, h) -- => 100, 11, 5
+M.juxtapose(10, f, g, h) -- => 100, 11, 5
 ````
 
 ### wrap (f, wrapper)
@@ -1344,7 +1516,7 @@ Wraps a function inside a wrapper. Allow
 
 ```lua
 local greet = function(name) return "hi: " .. name end
-local greet_backwards = _.wrap(greet, function(f,arg)
+local greet_backwards = M.wrap(greet, function(f,arg)
   return f(arg) ..'\nhi: ' .. arg:reverse()
 end) 
 greet_backwards('John')
@@ -1353,13 +1525,13 @@ greet_backwards('John')
 -- => hi: nhoJ
 ````
 
-### times (n, iter, ...)
+### times (iter [, n [, ...]])
 
 Calls a given function `n` times.
 
 ```lua
 local f = ('Lua programming'):gmatch('.')
-_.times(3,f) -- => {'L','u','a'}
+M.times(f, 3) -- => {'L','u','a'}
 ````
 
 ### bind (f, v)
@@ -1367,7 +1539,7 @@ _.times(3,f) -- => {'L','u','a'}
 Binds a value to be the first argument to a function.
 
 ```lua
-local sqrt2 = _.bind(math.sqrt,2)
+local sqrt2 = M.bind(math.sqrt,2)
 sqrt2() -- => 1.4142135623731
 ````
 
@@ -1376,7 +1548,7 @@ sqrt2() -- => 1.4142135623731
 Binds a value to be the second argument to a function.
 
 ```lua
-local last2 = _.bind(_.last,2)
+local last2 = M.bind(M.last,2)
 last2({1,2,3,4,5,6}) -- => {5,6}
 ````
 
@@ -1386,12 +1558,12 @@ Binds a variable number of values to be
 
 ```lua
 local function out(...) return table.concat {...} end
-local out = _.bindn(out,'OutPut',':',' ')
+local out = M.bindn(out,'OutPut',':',' ')
 out(1,2,3) -- => OutPut: 123
 out('a','b','c','d') -- => OutPut: abcd
 ````
 
-### bindAll (obj, ...)
+### bindall (obj, ...)
 
 Binds methods to object. As such, when calling any of these methods, they will receive object as a first argument.
 
@@ -1401,7 +1573,7 @@ local window = {
 	setName = function(w,name) w.name = name end,
 	getName = function(w) return w.name end,
 }
-window = _.bindAll(window, 'setPos', 'setName', 'getName')
+window = M.bindall(window, 'setPos', 'setName', 'getName')
 window.setPos(10,15)
 print(window.x, window.y) -- => 10,15
 
@@ -1411,50 +1583,101 @@ print(window.name) -- => 'fooApp'
 print(window.getName()) -- => 'fooApp'
 ````
 
-### uniqueId (template, ...)
-*Aliases: `_.uid`*.
+### cond (conds)
+
+Returns a function which iterate over an array list of conditions. It invokes each predicate, passing it given values. It returns the value of the corresponding function of the first predicate to return a non-nil value
+
+```lua
+local multipleOf = M.cond({
+  {function(v) return v%2==0 end, function(v) return v..' is multiple of 2' end},
+  {function(v) return v%3==0 end, function(v) return v..' is multiple of 3' end},
+  {function(v) return v%5==0 end, function(v) return v..' is multiple of 5' end},
+  {function() return true end, function(v) return 'could not find an answer for '..v end}
+})
+for i = 15, 20 do
+  print(multipleOf(i))
+end
+
+-- => 15 is multiple of 3
+-- => 16 is multiple of 2
+-- => could not find an answer for 17
+-- => 18 is multiple of 2
+-- => could not find an answer for 19
+-- => 20 is multiple of 2
+````
+
+### uniqueId ([template [, ...]])
+*Aliases: `uid`*.
 
 Returns an unique integer ID.
 
 ```lua
-_.uniqueId() -- => 1
+M.uniqueId() -- => 1
 ````
 
 Can handle string templates for formatted output.
 
 ```lua
-_.uniqueId('ID%s') -- => 'ID2'
+M.uniqueId('ID%s') -- => 'ID2'
 ````
 
 Or a function, for the same purpose.
 
 ```lua
 local formatter = function(ID) return '$'..ID..'$' end
-_.uniqueId(formatter) -- => '$ID1$'
+M.uniqueId(formatter) -- => '$ID1$'
 ````
 
-### iterator(f, x)
-*Aliases: `_.iter`*.
+### iterator(f, value [, n])
+*Aliases: `iter`*.
 
-Returns an iterator function which constinuously applies a function `f` onto an input `x`.
-For example, let us go through the powers of two.
+Returns an iterator function which constinuously applies a function `f` onto an input `value`.
+For example, let us go through the powers of two using `iterator`.
 
 ```lua
 local function po2(x) return x*2 end
-local function iter_po2 = _.iterator(po2, 1)
+local function iter_po2 = M.iterator(po2, 1)
 iter_po2() -- => 2
 iter_po2() -- => 4
 iter_po2() -- => 8
 ````
 
+if `n` is supplied, it will run at maximum `n` times.
+
+```lua
+local function po2(x) return x*2 end
+local function iter_po2 = M.iterator(po2, 1, 3)
+iter_po2() -- => 2
+iter_po2() -- => 4
+iter_po2() -- => 8
+iter_po2() -- => nil
+````
+
 ### array (...)
+*Aliases: `tabulate`*.
 
 Iterates a given iterator function and returns its values packed in an array.
 
 ```lua
 local text = 'letters'
 local chars = string.gmatch(text, '.')
-local letters = _.array(chars) -- => {'l','e','t','t','e','r','s'}
+local letters = M.array(chars) -- => {'l','e','t','t','e','r','s'}
+````
+
+### castArray (value)
+
+Casts the passed-in value to an array containing the value itself.
+
+```lua
+M.castArray(true) -- => {true}
+M.castArray(2) -- => {2}
+````
+
+It leaves the given value untouched in case it is already a table.
+
+```lua
+local t = {1}
+print(M.castArray(t) == t) -- => true
 ````
 
 ### flip (f)
@@ -1463,17 +1686,70 @@ Creates a function of `f` with arguments
 
 ```lua
 local function f(...) return table.concat({...}) end
-local flipped = _.flip(f)
+local flipped = M.flip(f)
 flipped('a','b','c') -- => 'cba'
 ````
 
+### nthArg(n)
+
+Returns a function that gets the nth argument. 
+
+```lua
+local f = M.nthArg(3)
+f('a','b','c') -- => 'c'
+````
+
+If n is negative, the nth argument from the end is returned.
+
+```lua
+local f = M.nthArg(-2)
+f('a','b','c') -- => 'b'
+````
+
+### unary (f)
+
+Returns a function which accepts up to one argument. It ignores any additional arguments. 
+
+```lua
+local f = M.unary(function (...) return ... end)
+f('a') - ==> 'a'
+f('a','b','c') -- => 'a'
+````
+
+### ary (f [, n = 1])
+*Aliases: `nAry`*.
+
+Returns a function which accepts up to `n` args. It ignores any additional arguments.
+
+```lua
+local f = M.ary(function (...) return ... end, 2)
+f(1,2) - ==> 1,2
+f(1,2,3,4) -- => 1,2
+````
+
+If `n` is not given, it defaults to `1`.
+
+```lua
+local f = M.unary(function (...) return ... end)
+f('a','b','c') -- => 'a'
+````
+
+### rearg (f, indexes)
+
+Returns a function which runs with arguments arranged according to given `indexes`.
+
+```lua
+local f = M.rearg(function (...) return ... end, {5,4,3,2,1})
+f('a','b','c','d','e') -- => 'e','d','c','b','a'
+````
+
 ### over (...)
 
 Creates a function that invokes a set of transforms with the arguments it receives.<br/>
 One can use use for example to get the tuple of min and max values from a set of values
 
 ```lua
-local minmax = _.over(math.min, math.max)
+local minmax = M.over(math.min, math.max)
 minmax(5,10,12,4,3) -- => {3,12}
 ````
 
@@ -1496,7 +1772,7 @@ local function allpositive(...)
 	return true 	
 end
 
-local allok = _.overEvery(alleven, allpositive)
+local allok = M.overEvery(alleven, allpositive)
 
 allok(2,4,-1,8) -- => false
 allok(10,3,2,6) -- => false
@@ -1522,7 +1798,7 @@ local function allpositive(...)
 	return true 	
 end
 
-local anyok = _.overSome(alleven,allpositive)
+local anyok = M.overSome(alleven,allpositive)
 
 anyok(2,4,-1,8) -- => false
 anyok(10,3,2,6) -- => true
@@ -1537,7 +1813,7 @@ Creates a function that invokes `f` with
 local function f(x, y) return x, y end
 local function triple(x) retun x*3 end
 local function square(x) retun x^2 end
-local new_f = _.overArgs(f, triple, square)
+local new_f = M.overArgs(f, triple, square)
 
 new_f(1,2) -- => 3, 4
 new_f(10,10) -- => 30, 100
@@ -1549,19 +1825,31 @@ In case the number of arguments is great
 local function f(x, y, z) return x, y, z end
 local function triple(x) retun x*3 end
 local function square(x) retun x^2 end
-local new_f = _.overArgs(f, triple, square)
+local new_f = M.overArgs(f, triple, square)
 
 new_f(1,2,3) -- => 3, 4, 3
 new_f(10,10,10) -- => 30, 100, 10
 ````
 
+### converge (f, g, h)
+
+Converges two functions into one.
+
+```lua
+local function pow2(x) return x*x end
+local function pow3(x) return x*x*x end
+local function sum(a,b) return a+b end
+local poly = M.converge(sum, pow2, pow3)
+poly(5) -- => 150 (ie. 5*5 + 5*5*5)
+````
+
 ### partial (f, ...)
 
 Partially apply a function by filling in any number of its arguments. 
 
 ```lua
 local function diff(a, b) return a - b end
-local diffFrom20 = _.partial(diff, 20) -- arg 'a' will be 20 by default
+local diffFrom20 = M.partial(diff, 20) -- arg 'a' will be 20 by default
 diffFrom20(5) -- => 15
 ````
 
@@ -1569,23 +1857,23 @@ The string `'_'` can be used as a placeh
 
 ```lua
 local function diff(a, b) return a - b end
-local remove5 = _.partial(diff, '_', 5) -- arg 'a' will be given at call-time, but 'b' is set to 5
+local remove5 = M.partial(diff, '_', 5) -- arg 'a' will be given at call-time, but 'b' is set to 5
 remove5(20) -- => 15
 ````
 
 ### partialRight (f, ...)
 
-Like `_.partial`, it partially applies a function by filling in any number of its arguments, but from the right.
+Like `M.partial`, it partially applies a function by filling in any number of its arguments, but from the right.
 
 ```lua
 local function concat(...) return table.concat({...},',') end
-local concat_right = _.partialRight(concat,'a','b','c')
+local concat_right = M.partialRight(concat,'a','b','c')
 concat_right('d') -- => d,a,b,c
 
-concat_right = _.partialRight(concat,'a','b')
+concat_right = M.partialRight(concat,'a','b')
 concat_right('c','d') -- => c,d,a,b
 
-concat_right = _.partialRight(concat,'a')
+concat_right = M.partialRight(concat,'a')
 concat_right('b','c','d') -- => b,c,d,a
 ```
 
@@ -1594,39 +1882,39 @@ In that case, the first args supplied at
 
 ```lua
 local function concat(...) return table.concat({...},',') end
-local concat_right = _.partialRight(concat,'a','_','c')
+local concat_right = M.partialRight(concat,'a','_','c')
 concat_right('d','b') -- => b,a,d,c
 
-concat_right = _.partialRight(concat,'a','b','_')
+concat_right = M.partialRight(concat,'a','b','_')
 concat_right('c','d') -- => d,a,b,c
 
-concat_right = _.partialRight(concat,'_','a')
+concat_right = M.partialRight(concat,'_','a')
 concat_right('b','c','d') -- => c,d,b,a
 ````
 
-### curry (f, n_args)
+### curry (f [, n_args = 2])
 
 Curries a function. If the given function `f` takes multiple arguments, it returns another version of `f` that takes a single argument 
 (the first of the arguments to the original function) and returns a new function that takes the remainder of the arguments and returns the result.
 
 ```lua
 local function sumOf3args(x,y,z) return x + y + z end
-local curried_sumOf3args = _.curry(sumOf3args, 3)
-sumOf3args(1)(2)(3) -- => 6
-sumOf3args(0)(6)(9) -- => 15
+local curried_sumOf3args = M.curry(sumOf3args, 3)
+sumOf3args(1)(2)(3)) -- => 6
+sumOf3args(0)(6)(9)) -- => 15
 ````
 
 `n_args` defaults to 2.
 
 ```lua
 local function product(x,y) return x * y end
-local curried_product = _.curry(product)
+local curried_product = M.curry(product)
 curried_product(5)(4) -- => 20
 curried_product(3)(-5) -- => -15
 curried_product(0)(1) -- => 0
 ````
 
-### time (f, ...)
+### time (f [, ...])
 
 Returns the execution time of `f (...)` in seconds and its results.
 
@@ -1637,8 +1925,8 @@ local function wait_count(n)
 	return i
 end
 
-local time, i = _.time(wait_count, 1e6) -- => 0.002 1000000
-local time, i = _.time(wait_count, 1e7) -- => 0.018 10000000
+local time, i = M.time(wait_count, 1e6) -- => 0.002 1000000
+local time, i = M.time(wait_count, 1e7) -- => 0.018 10000000
 ````
 
 **[[⬆]](#TOC)**
@@ -1650,8 +1938,8 @@ local time, i = _.time(wait_count, 1e7)
 Collects the names of an object attributes.
 
 ```lua
-_.keys({1,2,3}) -- => "{1,2,3}"
-_.keys({x = 0, y = 1}) -- => "{'y','x'}"
+M.keys({1,2,3}) -- => "{1,2,3}"
+M.keys({x = 0, y = 1}) -- => "{'y','x'}"
 ````
 
 ### values (obj)
@@ -1659,8 +1947,29 @@ _.keys({x = 0, y = 1}) -- => "{'y','x'}"
 Collects the values of an object attributes.
 
 ```lua
-_.values({1,2,3}) -- => "{1,2,3}"
-_.values({x = 0, y = 1}) -- => "{1,0}"
+M.values({1,2,3}) -- => "{1,2,3}"
+M.values({x = 0, y = 1}) -- => "{1,0}"
+````
+
+### path (obj, ...)
+
+Returns the value at a given path in an object.
+
+```lua
+local entity = {
+  pos = {x = 1, y = 2},
+  engine = {
+    left = {status = 'active', damage = 5},
+    right = {status = 'off', damage = 10}
+  },
+  boost = false
+}
+
+M.path(entity,'pos','x') -- => 1
+M.path(entity,'pos','y') -- => 2
+M.path(entity,'engine','left','status') -- => 'active'
+M.path(entity,'engine','right','damage') -- => 10
+M.path(entity,'boost') -- => false
 ````
 
 ### kvpairs (obj)
@@ -1669,7 +1978,7 @@ Converts an object to an array-list of k
 
 ```lua
 local obj = {x = 1, y = 2, z = 3}
-_.each(_.kvpairs(obj), function(k,v)
+M.each(M.kvpairs(obj), function(v,k)
 	print(k, table.concat(v,','))	
 end)
 
@@ -1678,13 +1987,13 @@ end)
 -- => 3	z,3
 ````
 
-### toObj
+### toObj (kvpairs)
 
 Converts an array list of `kvpairs` to an object where keys are taken from the 1rst column in the `kvpairs` sequence, associated with values in the 2nd column.
 
 ```lua
 local list_pairs = {{'x',1},{'y',2},{'z',3}}
-obj = _.toObj(list_pairs)
+obj = M.toObj(list_pairs)
 
 -- => {x = 1, y = 2, z = 3}
 ````
@@ -1694,7 +2003,7 @@ obj = _.toObj(list_pairs)
 Returns a function that will return the key property of any passed-in object.
 
 ```lua
-local who = _.property('name')
+local who = M.property('name')
 local people = {name = 'Henry'}
 who(people) -- => 'Henry'
 ````
@@ -1705,7 +2014,7 @@ Returns a function that will return the
 
 ```lua
 local people = {name = 'Henry'}
-print(_.propertyOf(people)('name')) -- => 'Henry'
+print(M.propertyOf(people)('name')) -- => 'Henry'
 ````
 
 ### toBoolean (value)
@@ -1713,11 +2022,11 @@ print(_.propertyOf(people)('name')) -- =
 Converts a given value to a boolean.
 
 ```lua
-_.toBoolean(true) -- => true
-_.toBoolean(false) -- => false
-_.toBoolean(nil) -- => false
-_.toBoolean({}) -- => true
-_.toBoolean(1) -- => true
+M.toBoolean(true) -- => true
+M.toBoolean(false) -- => false
+M.toBoolean(nil) -- => false
+M.toBoolean({}) -- => true
+M.toBoolean(1) -- => true
 ````
 
 ### extend (destObj, ...)
@@ -1725,40 +2034,50 @@ _.toBoolean(1) -- => true
 Extends a destination object with the properties of some source objects.
 
 ```lua
-_.extend({},{a = 'b', c = 'd'}) -- => "{a = 'b', c = 'd'}"
+M.extend({},{a = 'b', c = 'd'}) -- => "{a = 'b', c = 'd'}"
 ````
 
-### functions (obj, recurseMt)
-*Aliases: `_.methods`*.
+### functions (obj [, recurseMt])
+*Aliases: `methods`*.
 
 Returns all functions names within an object.
 
 ```lua
-_.functions(coroutine) -- => "{'create','resume','running','status','wrap','yield'}"
+M.functions(coroutine) 
+-- => "{'yield','wrap','status','resume','running','create'}"
 ````
 
-### clone (obj, shallow)
+When given `recurseMt`, will also include `obj` metatable's functions.
+
+````lua
+local mt = {print = print}
+local t = {assert = assert}
+setmetatable(t, {__index = mt})
+M.functions(t, true) -- => "{'assert','print'}"
+````
+
+### clone (obj [, shallow])
 
 Clones a given object.
 
 ```lua
 local obj = {1,2,3}
-local obj2 = _.clone(obj)
+local obj2 = M.clone(obj)
 print(obj2 == obj) -- => false
-print(_.isEqual(obj2, obj)) -- => true
+print(M.isEqual(obj2, obj)) -- => true
 ````
 
-### tap (obj, f, ...)
+### tap (obj, f [, ...])
 
 Invokes a given interceptor function on some object, and then returns the object itself. Useful to tap into method chaining to hook intermediate results.
-The pased-interceptor is prototyped as `f(obj,...)`.
+The passed-in interceptor should be prototyped as `f(obj,...)`.
 
 ```lua
-local v = _.chain({1,2,3,4,5,6,7,8,9,10)
-  :filter(function(k,v) return v%2~=0 end) -- filters even values
-  :tap(function(v) print('Max is', _.max(v) end) -- Tap max values 
-  :map(function(k,v) return k^2)
-  :value() -- =>	 Max is 9
+local v = M.chain({1,2,3,4,5,6,7,8,9,10})
+  :filter(function(v) return v%2~=0 end) -- retain odd values
+  :tap(function(v) print('Max is', M.max(v) end) -- Tap max value 
+  :map(function(v) return v^2 end)
+  :value() -- =>	 Max is 89
 ````
 
 ### has (obj, key)
@@ -1766,60 +2085,60 @@ local v = _.chain({1,2,3,4,5,6,7,8,9,10)
 Checks if an object has a given attribute.
 
 ```lua
-_.has(_,'has') -- => true
-_.has(coroutine,'resume') -- => true
-_.has(math,'random') -- => true
+M.has(_,'has') -- => true
+M.has(coroutine,'resume') -- => true
+M.has(math,'random') -- => true
 ````
 
 ### pick (obj, ...)
-*Aliases: `_.choose`*.
+*Aliases: `choose`*.
 
 Collects whilelisted properties of a given object.
 
 ```lua
 local object = {a = 1, b = 2, c = 3}
-_.pick(object,'a','c') -- => "{a = 1, c = 3}"
+M.pick(object,'a','c') -- => "{a = 1, c = 3}"
 ````
 
 ### omit (obj, ...)
-*Aliases: `_.drop`*.
+*Aliases: `drop`*.
 
 Omits blacklisted properties of a given object.
 
 ```lua
 local object = {a = 1, b = 2, c = 3}
-_.omit(object,'a','c') -- => "{b = 2}"
+M.omit(object,'a','c') -- => "{b = 2}"
 ````
 
-### template (obj, template)
-*Aliases: `_.defaults`*.
+### template (obj [, template])
+*Aliases: `defaults`*.
 
 Applies a template on an object, preserving existing properties.
 
 ```lua
 local obj = {a = 0}
-_.template(obj,{a = 1, b = 2, c = 3}) -- => "{a=0, c=3, b=2}"
+M.template(obj,{a = 1, b = 2, c = 3}) -- => "{a=0, c=3, b=2}"
 ````
 
-### isEqual (objA, objB, useMt)
-*Aliases: `_.compare`*.
+### isEqual (objA, objB [, useMt])
+*Aliases: `compare`, `M.matches`*.
 
 Compares objects:
 
 ```lua
-_.isEqual(1,1) -- => true
-_.isEqual(true,false) -- => false
-_.isEqual(3.14,math.pi) -- => false
-_.isEqual({3,4,5},{3,4,{5}}) -- => false
+M.isEqual(1,1) -- => true
+M.isEqual(true,false) -- => false
+M.isEqual(3.14,math.pi) -- => false
+M.isEqual({3,4,5},{3,4,{5}}) -- => false
 ````
 
-### result (obj, method, ...)
+### result (obj, method [, ...])
 
 Calls an object method, passing it as a first argument the object itself.
 
 ```lua
-_.result('abc','len') -- => 3
-_.result({'a','b','c'},table.concat) -- => 'abc'
+M.result('abc','len') -- => 3
+M.result({'a','b','c'},table.concat) -- => 'abc'
 ````
 
 ### isTable (t)
@@ -1827,9 +2146,9 @@ _.result({'a','b','c'},table.concat) --
 Is the given argument an object (i.e a table) ?
 
 ```lua
-_.isTable({}) -- => true
-_.isTable(math) -- => true
-_.isTable(string) -- => true
+M.isTable({}) -- => true
+M.isTable(math) -- => true
+M.isTable(string) -- => true
 ````
 
 ### isCallable (obj)
@@ -1837,10 +2156,10 @@ _.isTable(string) -- => true
 Is the given argument callable ?
 
 ```lua
-_.isCallable(print) -- => true
-_.isCallable(function() end) -- => true
-_.isCallable(setmetatable({},{__index = string}).upper) -- => true
-_.isCallable(setmetatable({},{__call = function() return end})) -- => true
+M.isCallable(print) -- => true
+M.isCallable(function() end) -- => true
+M.isCallable(setmetatable({},{__index = string}).upper) -- => true
+M.isCallable(setmetatable({},{__call = function() return end})) -- => true
 ````
 
 ### isArray (obj)
@@ -1848,9 +2167,9 @@ _.isCallable(setmetatable({},{__call = f
 Is the given argument an array (i.e. a sequence) ?
 
 ```lua
-_.isArray({}) -- => true
-_.isArray({1,2,3}) -- => true
-_.isArray({'a','b','c'}) -- => true
+M.isArray({}) -- => true
+M.isArray({1,2,3}) -- => true
+M.isArray({'a','b','c'}) -- => true
 ````
 
 ### isIterable (obj)
@@ -1858,20 +2177,20 @@ _.isArray({'a','b','c'}) -- => true
 Checks if the given object is iterable with `pairs`.
 
 ```lua
-_.isIterable({}) -- => true
-_.isIterable(function() end) -- => false
-_.isIterable(false) -- => false
-_.isIterable(1) -- => false
+M.isIterable({}) -- => true
+M.isIterable(function() end) -- => false
+M.isIterable(false) -- => false
+M.isIterable(1) -- => false
 ````
 
-### isEmpty (obj)
+### isEmpty ([obj])
 
 Is the given argument empty ?
 
 ```lua
-_.isEmpty('') -- => true
-_.isEmpty({})  -- => true
-_.isEmpty({'a','b','c'}) -- => false
+M.isEmpty('') -- => true
+M.isEmpty({})  -- => true
+M.isEmpty({'a','b','c'}) -- => false
 ````
 
 ### isString (obj)
@@ -1879,9 +2198,9 @@ _.isEmpty({'a','b','c'}) -- => false
 Is the given argument a string ?
 
 ```lua
-_.isString('') -- => true
-_.isString('Hello') -- => false
-_.isString({}) -- => false
+M.isString('') -- => true
+M.isString('Hello') -- => false
+M.isString({}) -- => false
 ````
 
 ### isFunction (obj)
@@ -1889,9 +2208,9 @@ _.isString({}) -- => false
 Is the given argument a function ?
 
 ```lua
-_.isFunction(print) -- => true
-_.isFunction(function() end) -- => true
-_.isFunction({}) -- => false
+M.isFunction(print) -- => true
+M.isFunction(function() end) -- => true
+M.isFunction({}) -- => false
 ````
 
 ### isNil (obj)
@@ -1899,9 +2218,9 @@ _.isFunction({}) -- => false
 Is the given argument nil ?
 
 ```lua
-_.isNil(nil) -- => true
-_.isNil() -- => true
-_.isNil({}) -- => false
+M.isNil(nil) -- => true
+M.isNil() -- => true
+M.isNil({}) -- => false
 ````
 
 ### isNumber (obj)
@@ -1909,10 +2228,10 @@ _.isNil({}) -- => false
 Is the given argument a number ?
 
 ```lua
-_.isNumber(math.pi) -- => true
-_.isNumber(math.huge) -- => true
-_.isNumber(0/0) -- => true
-_.isNumber() -- => false
+M.isNumber(math.pi) -- => true
+M.isNumber(math.huge) -- => true
+M.isNumber(0/0) -- => true
+M.isNumber() -- => false
 ````
 
 ### isNaN (obj)
@@ -1920,8 +2239,8 @@ _.isNumber() -- => false
 Is the given argument NaN ?
 
 ```lua
-_.isNaN(1) -- => false
-_.isNaN(0/0) -- => true
+M.isNaN(1) -- => false
+M.isNaN(0/0) -- => true
 ````
 
 ### isFinite (obj)
@@ -1929,11 +2248,11 @@ _.isNaN(0/0) -- => true
 Is the given argument a finite number ?
 
 ```lua
-_.isFinite(99e99) -- => true
-_.isFinite(math.pi) -- => true
-_.isFinite(math.huge) -- => false
-_.isFinite(1/0) -- => false
-_.isFinite(0/0) -- => false
+M.isFinite(99e99) -- => true
+M.isFinite(math.pi) -- => true
+M.isFinite(math.huge) -- => false
+M.isFinite(1/0) -- => false
+M.isFinite(0/0) -- => false
 ````
 
 ### isBoolean (obj)
@@ -1941,10 +2260,10 @@ _.isFinite(0/0) -- => false
 Is the given argument a boolean ?
 
 ```lua
-_.isBoolean(true) -- => true
-_.isBoolean(false) -- => true
-_.isBoolean(1==1) -- => true
-_.isBoolean(print) -- => false
+M.isBoolean(true) -- => true
+M.isBoolean(false) -- => true
+M.isBoolean(1==1) -- => true
+M.isBoolean(print) -- => false
 ````
 
 ### isInteger (obj)
@@ -1952,9 +2271,9 @@ _.isBoolean(print) -- => false
 Is the given argument an integer ?
 
 ```lua
-_.isInteger(math.pi) -- => false
-_.isInteger(1) -- => true
-_.isInteger(-1) -- => true
+M.isInteger(math.pi) -- => false
+M.isInteger(1) -- => true
+M.isInteger(-1) -- => true
 ````
 
 **[[⬆]](#TOC)**
@@ -1962,9 +2281,10 @@ _.isInteger(-1) -- => true
 ## <a name='chaining'>Chaining</a>
 
 *Method chaining* (also known as *name parameter idiom*), is a technique for invoking consecutively method calls in object-oriented style.
-Each method returns an object, and methods calls are chained together.
+Each method returns an object, and method calls are chained together.
 Moses offers chaining for your perusal. <br/>
-Let's use chaining to get the count of every single word in some lyrics (case will not matter here).
+
+Let's use chaining to get the count of evey single word in some lyrics (case won't matter here).
 
 
 ```lua
@@ -1975,16 +2295,17 @@ local lyrics = {
   "He sleeps all night and he works all day"
 }
 
-local stats = _.chain(lyrics)
-  :map(function(k,line)
-	local t = {}
-	for w in line:gmatch('(%w+)') do
-	  t[#t+1] = w
-	end
-	return t
-  end)
+-- split a text into words
+local function words(line)
+  local t = {}
+  for w in line:gmatch('(%w+)') do t[#t+1] = w end
+  return t
+end
+
+local stats = M.chain(lyrics)
+  :map(words)
   :flatten()
-  :countBy(function(i,v) return v:lower() end)
+  :countBy(string.lower)
   :value() 
 
 -- => "{
@@ -1994,7 +2315,7 @@ local stats = _.chain(lyrics)
 -- =>  }"
 ````
 
-For convenience, you can also use `_(value)` to start chaining methods, instead of `_.chain(value)`.
+For convenience, you can also use `M(value)` to start chaining methods, instead of `M.chain(value)`.
 
 Note that one can use `:value()` to unwrap a chained object.
 
@@ -2011,7 +2332,7 @@ All library functions can be imported in
 
 ```lua
 local context = {}
-_.import(context)
+M.import(context)
 
 context.each({1,2,3},print)
 
@@ -2020,10 +2341,10 @@ context.each({1,2,3},print)
 -- => 3 3
 ````
 
-When no `context` was provided, it defaults to the global environment `_G`.
+When no `context` was provided, it defaults to the current environment, `_ENV` or `_G`.
 
 ```lua
-_.import()
+M.import()
 
 each({1,2,3},print)
 
@@ -2036,7 +2357,7 @@ Passing `noConflict` argument leaves unt
 
 ```lua
 local context = {each = 1}
-_.import(context, true)
+M.import(context, true)
 
 print(context.each) -- => 1
 context.eachi({1,2,3},print)
diff -pruN 1.6.1+git20170613-2/.gitignore 2.0.0-3/.gitignore
--- 1.6.1+git20170613-2/.gitignore	2017-06-03 16:42:55.000000000 +0000
+++ 2.0.0-3/.gitignore	2018-08-23 16:26:20.000000000 +0000
@@ -1,10 +1,10 @@
 *.bat
 tsc*
 ldoc*
-telescope*
-LuaMin*
+LuaMinify*
 *.ld
 luacov*
 *.exe
 *.dll
-test*
\ No newline at end of file
+test*
+bust*
\ No newline at end of file
diff -pruN 1.6.1+git20170613-2/LICENSE 2.0.0-3/LICENSE
--- 1.6.1+git20170613-2/LICENSE	2017-06-03 16:42:55.000000000 +0000
+++ 2.0.0-3/LICENSE	2018-08-23 16:26:20.000000000 +0000
@@ -1,4 +1,4 @@
-Copyright (c) 2012-2014 Roland Yonaba
+Copyright (c) 2012-2018 Roland Yonaba
 
 Permission is hereby granted, free of charge, to any person obtaining a
 copy of this software and associated documentation files (the
diff -pruN 1.6.1+git20170613-2/.luacov 2.0.0-3/.luacov
--- 1.6.1+git20170613-2/.luacov	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.0-3/.luacov	2018-08-23 16:26:20.000000000 +0000
@@ -0,0 +1,52 @@
+--- Global configuration file. Copy, customize and store in your
+-- project folder as '.luacov' for project specific configuration
+-- @class module
+-- @name luacov.defaults
+return {
+
+  -- default filename to load for config options if not provided
+  -- only has effect in 'luacov.defaults.lua'
+  ['configfile'] = '.luacov',
+
+  -- filename to store stats collected
+  ['statsfile'] = 'luacov.stats.out',
+
+  -- filename to store report
+  ['reportfile'] = 'luacov.report.out',
+
+  -- Run reporter on completion? (won't work for ticks)
+  runreport = true,
+
+  -- Delete stats file after reporting?
+  deletestats = false,
+
+  -- Patterns for files to include when reporting
+  -- all will be included if nothing is listed
+  -- (exclude overrules include, do not include
+  -- the .lua extension)
+  ['include'] = {
+	'moses'
+  },
+
+  -- Patterns for files to exclude when reporting
+  -- all will be included if nothing is listed
+  -- (exclude overrules include, do not include
+  -- the .lua extension)
+  ['exclude'] = {
+    'luacov$',
+    'luacov.reporter$',
+    'luacov.defaults$',
+    'luacov.runner$',
+    'luacov.stats$',
+    'luacov.tick$',
+	'mediator.*$',
+	'busted$',
+	'busted.*$',
+	'luassert.*$',
+	'pl.*$',
+	'say.*$',
+	'spec.*$'
+  },
+
+
+}
diff -pruN 1.6.1+git20170613-2/moses.lua 2.0.0-3/moses.lua
--- 1.6.1+git20170613-2/moses.lua	2017-06-03 16:42:55.000000000 +0000
+++ 2.0.0-3/moses.lua	2018-08-23 16:26:20.000000000 +0000
@@ -1,33 +1,34 @@
 --- Utility-belt library for functional programming in Lua ([source](http://github.com/Yonaba/Moses))
 -- @author [Roland Yonaba](http://github.com/Yonaba)
--- @copyright 2012-2017
+-- @copyright 2012-2018
 -- @license [MIT](http://www.opensource.org/licenses/mit-license.php)
--- @release 1.6.1
+-- @release 2.0.0
 -- @module moses
+-- @set sort=true
 
-local _MODULEVERSION = '1.6.1'
+local _MODULEVERSION = '2.0.0'
 
 -- Internalisation
-local next, type, select, pcall  = next, type, select, pcall
+local next, type, pcall          = next, type, pcall
 local setmetatable, getmetatable = setmetatable, getmetatable
 local t_insert, t_sort           = table.insert, table.sort
 local t_remove,t_concat          = table.remove, table.concat
 local randomseed, random, huge   = math.randomseed, math.random, math.huge
-local floor, max, min            = math.floor, math.max, math.min
+local floor, max, min, ceil      = math.floor, math.max, math.min, math.ceil
+local wrap                       = coroutine.wrap
+local yield                      = coroutine.yield
 local rawget                     = rawget
 local unpack                     = table.unpack or unpack
 local pairs,ipairs               = pairs,ipairs
+local error                      = error
 local clock                      = os.clock
-local _                          = {}
+local M                          = {}
 
 
 -- ======== Private helpers
 
 local function f_max(a,b) return a>b end
 local function f_min(a,b) return a<b end
-local function clamp(var,a,b) return (var<a) and a or (var>b and b or var) end
-local function isTrue(_,value) return value and true end
-local function iNot(value) return not value end
 
 local function count(t)  -- raw count of items in an map-table
   local i = 0
@@ -36,18 +37,13 @@ local function count(t)  -- raw count of
 end
 
 local function extract(list,comp,transform,...) -- extracts value from a list
-  local _ans, prev, curr
-  local transform = transform or _.identity
-  for index, value in pairs(list) do
-    if not _ans then 
-      _ans = value
-      prev = transform(value,...)
+  transform = transform or M.identity
+  local _ans  
+  for k,v in pairs(list) do
+    if not _ans then _ans = transform(v,...)
     else
-      curr = transform(value,...)
-      if comp(curr, prev) then
-        _ans = value
-        prev = curr
-      end
+      local val = transform(v,...)
+      _ans = comp(_ans,val) and _ans or val
     end
   end
   return _ans
@@ -55,7 +51,7 @@ end
 
 local function partgen(t, n, f, pad) -- generates array partitions
   for i = 0, #t, n do
-    local s = _.slice(t, i+1, i+n)
+    local s = M.slice(t, i+1, i+n)
     if #s>0 then 
 			while (#s < n and pad) do s[#s+1] = pad end			
 			f(s)
@@ -63,9 +59,9 @@ local function partgen(t, n, f, pad) --
   end
 end
 
-local function partgen2(t, n, f, pad) -- generates sliding array partitions
+local function partgen2(t, n, f, pad) -- generates overlapping array partitions
   for i = 0, #t, n-1 do
-    local s = _.slice(t, i+1, i+n)
+    local s = M.slice(t, i+1, i+n)
     if #s>0 and i+1<#t then 
 			while (#s < n and pad) do s[#s+1] = pad end
 			f(s)
@@ -73,6 +69,16 @@ local function partgen2(t, n, f, pad) --
   end
 end
 
+local function partgen3(t, n, f, pad) -- generates sliding array partitions
+  for i = 0, #t, 1 do
+    local s = M.slice(t, i+1, i+n)
+    if #s>0 and i+n<=#t then 
+			while (#s < n and pad) do s[#s+1] = pad end
+			f(s)
+		end
+  end
+end
+
 local function permgen(t, n, f) -- taken from PiL: http://www.lua.org/pil/9.3.html
   if n == 0 then f(t) end
   for i = 1,n do
@@ -82,9 +88,158 @@ local function permgen(t, n, f) -- taken
   end
 end
 
+local function signum(a) return a>=0 and 1 or -1 end
+
 -- Internal counter for unique ids generation
 local unique_id_counter = -1
 
+--- Operator functions
+-- @section Operator functions
+
+M.operator = {}
+--- Returns a + b. <em>Aliased as `op.add`</em>.
+-- @name operator.add
+-- @param a a value
+-- @param b a value
+-- @return a + b
+M.operator.add = function(a,b) return a + b end
+
+--- Returns a - b. <em>Aliased as `op.sub`</em>.
+-- @name operator.sub
+-- @param a a value
+-- @param b a value
+-- @return a - b
+M.operator.sub = function(a,b) return a - b end
+
+--- Returns a * b. <em>Aliased as `op.mul`</em>.
+-- @name operator.mul
+-- @param a a value
+-- @param b a value
+-- @return a * b
+M.operator.mul = function(a,b) return a * b end
+
+--- Returns a / b. <em>Aliased as `op.div`</em>.
+-- @name operator.div
+-- @param a a value
+-- @param b a value
+-- @return a / b
+M.operator.div = function(a,b) return a / b end
+
+--- Returns a % b. <em>Aliased as `op.mod`</em>.
+-- @name operator.mod
+-- @param a a value
+-- @param b a value
+-- @return a % b
+M.operator.mod = function(a,b) return a % b end
+
+--- Returns a ^ b. <em>Aliased as `op.exp`, `op.pow`</em>.
+-- @name operator.exp
+-- @param a a value
+-- @param b a value
+-- @return a ^ b
+M.operator.exp = function(a,b) return a ^ b end
+M.operator.pow = M.operator.exp
+
+--- Returns -a. <em>Aliased as `op.unm`, `op.neg`</em>.
+-- @name operator.unm
+-- @param a a value
+-- @return -a
+M.operator.unm = function(a) return -a end
+M.operator.neg = M.operator.unm
+
+--- Performs floor division (//) between `a` and `b`. It rounds the quotient towards minus infinity.
+-- <em>Aliased as `op.floordiv`</em>.
+-- @name operator.floordiv
+-- @param a a value
+-- @param b a value
+-- @return a // b
+M.operator.floordiv = function(a, b) return floor(a/b) end 
+
+--- Performs integer division between `a` and `b`. <em>Aliased as `op.intdiv`</em>.
+-- @name operator.intdiv
+-- @param a a value
+-- @param b a value
+-- @return a / b
+M.operator.intdiv = function(a,b)
+  return a>=0 and floor(a/b) or ceil(a/b) 
+end
+
+--- Checks if a equals b. <em>Aliased as `op.eq`</em>.
+-- @name operator.eq
+-- @param a a value
+-- @param b a value
+-- @return a == b
+M.operator.eq = function(a,b) return a == b end
+
+--- Checks if a not equals b. <em>Aliased as `op.neq`</em>.
+-- @name operator.neq
+-- @param a a value
+-- @param b a value
+-- @return a ~= b
+M.operator.neq = function(a,b) return a ~= b end
+
+--- Checks if a is strictly less than b. <em>Aliased as `op.lt`</em>.
+-- @name operator.lt
+-- @param a a value
+-- @param b a value
+-- @return a < b
+M.operator.lt = function(a,b) return a < b end
+
+--- Checks if a is strictly greater than b. <em>Aliased as `op.gt`</em>.
+-- @name operator.gt
+-- @param a a value
+-- @param b a value
+-- @return a > b
+M.operator.gt = function(a,b) return a > b end
+
+--- Checks if a is less or equal to b. <em>Aliased as `op.le`</em>.
+-- @name operator.le
+-- @param a a value
+-- @param b a value
+-- @return a <= b
+M.operator.le = function(a,b) return a <= b end
+
+--- Checks if a is greater or equal to b. <em>Aliased as `op.ge`</em>.
+-- @name operator.ge
+-- @param a a value
+-- @param b a value
+-- @return a >= b
+M.operator.ge = function(a,b) return a >= b end
+
+--- Returns logical a and b. <em>Aliased as `op.land`</em>.
+-- @name operator.ge
+-- @param a a value
+-- @param b a value
+-- @return a and b
+M.operator.land = function(a,b) return a and b end
+
+--- Returns logical a or b. <em>Aliased as `op.lor`</em>.
+-- @name operator.lor
+-- @param a a value
+-- @param b a value
+-- @return a or b
+M.operator.lor = function(a,b) return a or b end
+
+--- Returns logical not a. <em>Aliased as `op.lnot`</em>.
+-- @name operator.lnot
+-- @param a a value
+-- @return not a
+M.operator.lnot = function(a) return not a end
+
+--- Returns concatenation of a and b. <em>Aliased as `op.concat`</em>.
+-- @name operator.concat
+-- @param a a value
+-- @param b a value
+-- @return a .. b
+M.operator.concat = function(a,b) return a..b end
+
+--- Returns the length of a. <em>Aliased as `op.len`</em>.
+-- @name operator.length
+-- @param a a value
+-- @return #a
+M.operator.length = function(a) return #a end
+M.operator.len = M.operator.length
+
 --- Table functions
 -- @section Table functions
 
@@ -92,39 +247,39 @@ local unique_id_counter = -1
 -- @name clear
 -- @param t a table
 -- @return the given table, cleared.
-function _.clear(t)
+function M.clear(t)
 	for k in pairs(t) do t[k] = nil end
 	return t
 end
 
---- Iterates on key-value pairs, calling `f (k, v)` at every step.
+
+
+--- Iterates on key-value pairs, calling `f (v, k)` at every step.
 -- <br/><em>Aliased as `forEach`</em>.
 -- @name each
 -- @param t a table
--- @param f a function, prototyped as `f (k, v, ...)`
+-- @param f a function, prototyped as `f (v, k, ...)`
 -- @param[opt] ... Optional args to be passed to `f`
 -- @see eachi
-function _.each(t, f, ...)
+function M.each(t, f, ...)
   for index,value in pairs(t) do
-    f(index,value,...)
+    f(value, index, ...)
   end
 end
 
---- Iterates on integer key-value pairs, calling `f(k, v)` every step. 
+--- Iterates on integer key-value pairs, calling `f(v, k)` every step. 
 -- Only applies to values located at integer keys. The table can be a sparse array. 
 -- Iteration will start from the lowest integer key found to the highest one.
 -- <br/><em>Aliased as `forEachi`</em>.
 -- @name eachi
 -- @param t a table
--- @param f a function, prototyped as `f (k, v, ...)`
+-- @param f a function, prototyped as `f (v, k, ...)`
 -- @param[opt] ... Optional args to be passed to `f`
 -- @see each
-function _.eachi(t, f, ...)
-  local lkeys = _.sort(_.select(_.keys(t), function(k,v)
-    return _.isInteger(v)
-  end))
+function M.eachi(t, f, ...)
+  local lkeys = M.sort(M.select(M.keys(t), M.isInteger))
   for k, key in ipairs(lkeys) do
-    f(key, t[key],...)
+    f(t[key], key, ...)
   end
 end
 
@@ -133,41 +288,57 @@ end
 -- @param t a table
 -- @param ... A variable number of keys to collect values
 -- @return an array-list of values
-function _.at(t, ...)
+function M.at(t, ...)
   local values = {}
-  for i, key in ipairs({...}) do
-    if _.has(t, key) then values[#values+1] = t[key] end
-  end
+  for i, key in ipairs({...}) do values[#values+1] = t[key] end
   return values
 end
 
+--- Adjusts the value at a given key using a function or a value. In case `f` is a function, 
+-- it should be prototyped `f(v, ...)`. It does not mutate the given table, but rather
+-- returns a new array. In case the given `key` does not exist in `t`, it throws an error.
+-- @param t a table
+-- @param key a key
+-- @param f a function, prototyped as `f(v, ...)` or a value
+-- @param[opt] ... Optional args to be passed to `f`
+function M.adjust(t, key, f, ...)
+  if (t[key] == nil) then error("key not existing in table") end
+  local _t = M.clone(t)
+  _t[key] = type(f) == 'function' and f(_t[key], ...) or f
+  return _t
+end
+
 --- Counts occurrences of a given value in a table. Uses @{isEqual} to compare values.
 -- @name count
 -- @param t a table
--- @param[opt] value a value to be searched in the table. If not given, the @{size} of the table will be returned
+-- @param[opt] val a value to be searched in the table. If not given, the @{size} of the table will be returned
 -- @return the count of occurrences of the given value
 -- @see countf
 -- @see size
-function _.count(t, value)
-  if _.isNil(value) then return _.size(t) end
+function M.count(t, val)
+  if val == nil then return M.size(t) end
   local count = 0
-  _.each(t, function(k,v)
-    if _.isEqual(v, value) then count = count + 1 end
-  end)
+  for k, v in pairs(t) do
+    if M.isEqual(v, val) then count = count + 1 end
+  end
   return count
 end
 
---- Counts occurrences validating a predicate. Same as @{count}, but uses an iterator. 
--- Returns the count for values passing the test `f (k, v, ...)`
+--- Counts the number of values passing a predicate test. Same as @{count}, but uses an iterator. 
+-- Returns the count for values passing the test `f (v, k, ...)`
 -- @name countf
 -- @param t a table
--- @param f an iterator function, prototyped as `f (k, v, ...)`
+-- @param f an iterator function, prototyped as `f (v, k, ...)`
 -- @param[opt] ... Optional args to be passed to `f`
 -- @return the count of values validating the predicate
 -- @see count
 -- @see size
-function _.countf(t, f, ...)
-  return _.count(_.map(t, f, ...), true)
+function M.countf(t, f, ...)
+  local count = 0
+  for k, v in pairs(t) do
+    if f(v, k, ...) then count = count + 1 end
+  end
+  return count
 end
 
 --- Loops `n` times through a table. In case `n` is omitted, it will loop forever.
@@ -175,11 +346,11 @@ end
 -- <br/><em>Aliased as `loop`</em>.
 -- @name cycle
 -- @param t a table
--- @param n the number of loops
--- @return an iterator function yielding key-value pairs from the passed-in table.
-function _.cycle(t, n)
+-- @param[opt] n the number of loops
+-- @return an iterator function yielding value-key pairs from the passed-in table.
+function M.cycle(t, n)
   n = n or 1
-  if n<=0 then return _.noop end
+  if n<=0 then return M.noop end
   local k, fk
   local i = 0
   while true do
@@ -192,22 +363,22 @@ function _.cycle(t, n)
           return
         end
       end
-      return k, t[k]
+      return t[k], k
     end
   end
 end
 
---- Maps `f (k, v)` on key-value pairs, collects and returns the results.
+--- Maps `f (v, k)` on value-key pairs, collects and returns the results.
 -- <br/><em>Aliased as `collect`</em>.
 -- @name map
 -- @param t a table
--- @param f  an iterator function, prototyped as `f (k, v, ...)`
+-- @param f  an iterator function, prototyped as `f (v, k, ...)`
 -- @param[opt] ... Optional args to be passed to `f`
 -- @return a table of results
-function _.map(t, f, ...)
+function M.map(t, f, ...)
   local _t = {}
   for index,value in pairs(t) do
-    local k, kv, v = index, f(index,value,...)
+    local k, kv, v = index, f(value, index, ...)
     _t[v and kv or k] = v or kv
   end
   return _t
@@ -224,8 +395,8 @@ end
 -- @return the final state of reduction
 -- @see reduceRight
 -- @see reduceby
-function _.reduce(t, f, state)
-  for __,value in pairs(t) do
+function M.reduce(t, f, state)
+  for k,value in pairs(t) do
     if state == nil then state = value
     else state = f(state,value)
     end
@@ -238,13 +409,13 @@ end
 -- @name reduceby
 -- @param t a table
 -- @param f an iterator function, prototyped as `f (state, value)`
--- @param state an initial state of reduction.
--- @param pred a predicate function `pred (k, v, ...)` to select values to be considered for reduction
--- @param[opt] ... optional args to be passed to `pred`
+-- @param pred a predicate function `pred (v, k, ...)` to select values to be considered for reduction
+-- @param[opt] state an initial state of reduction. Defaults to the first value in the table of selected values.
+-- @param[optchain] ... optional args to be passed to `pred`
 -- @return the final state of reduction
 -- @see reduce
-function _.reduceby(t, f, state, pred, ...)
-	return _.reduce(_.select(t, pred, ...), f, state)
+function M.reduceby(t, f, pred, state, ...)
+	return M.reduce(M.select(t, pred, ...), f, state)
 end
 
 --- Reduces a table, right-to-left. Folds the table from the last element to the first element 
@@ -257,8 +428,8 @@ end
 -- @param[opt] state an initial state of reduction. Defaults to the last value in the table.
 -- @return the final state of reduction
 -- @see reduce
-function _.reduceRight(t, f, state)
-  return _.reduce(_.reverse(t),f,state)
+function M.reduceRight(t, f, state)
+  return M.reduce(M.reverse(t),f,state)
 end
 
 --- Reduces a table while saving intermediate states. Folds the table left-to-right
@@ -271,7 +442,7 @@ end
 -- @param[opt] state an initial state of reduction. Defaults to the first value in the table.
 -- @return an array of states
 -- @see mapReduceRight
-function _.mapReduce(t, f, state)
+function M.mapReduce(t, f, state)
   local _t = {}
   for i,value in pairs(t) do
     _t[i] = not state and value or f(state,value)
@@ -290,8 +461,8 @@ end
 -- @param[opt] state an initial state of reduction. Defaults to the last value in the table.
 -- @return an array of states
 -- @see mapReduce
-function _.mapReduceRight(t, f, state)
-  return _.mapReduce(_.reverse(t),f,state)
+function M.mapReduceRight(t, f, state)
+  return M.mapReduce(M.reverse(t),f,state)
 end
 
 --- Performs a linear search for a value in a table. It does not work for nested tables.
@@ -303,9 +474,9 @@ end
 -- @param value a value to search for
 -- @return a boolean : `true` when found, `false` otherwise
 -- @see detect
-function _.include(t, value)
-  local _iter = _.isFunction(value) and value or _.isEqual
-  for __,v in pairs(t) do
+function M.include(t, value)
+  local _iter = (type(value) == 'function') and value or M.isEqual
+  for k,v in pairs(t) do
     if _iter(v,value) then return true end
   end
   return false
@@ -313,14 +484,16 @@ end
 
 --- Performs a linear search for a value in a table. Returns the key of the value if found.
 -- The given value can be a function prototyped as `f (v, value)` which should return true when
--- any v in the table equals the value being searched. 
+-- any v in the table equals the value being searched. This function is similar to @{find}, 
+-- which is mostly meant to work with array.
 -- @name detect
 -- @param t a table
 -- @param value a value to search for
 -- @return the key of the value when found or __nil__
 -- @see include
-function _.detect(t, value)
-  local _iter = _.isFunction(value) and value or _.isEqual
+-- @see find
+function M.detect(t, value)
+  local _iter = (type(value) == 'function') and value or M.isEqual
   for key,arg in pairs(t) do
     if _iter(arg,value) then return key end
   end
@@ -332,8 +505,8 @@ end
 -- @param props a set of keys
 -- @return an array of values from the passed-in table
 -- @see findWhere
-function _.where(t, props)
-	local r = _.select(t, function(__,v)
+function M.where(t, props)
+	local r = M.select(t, function(v)
 		for key in pairs(props) do
 			if v[key] ~= props[key] then return false end
 		end
@@ -348,8 +521,8 @@ end
 -- @param props a set of keys
 -- @return a value from the passed-in table
 -- @see where
-function _.findWhere(t, props)
-  local index = _.detect(t, function(v)
+function M.findWhere(t, props)
+  local index = M.detect(t, function(v)
     for key in pairs(props) do
       if props[key] ~= v[key] then return false end
     end
@@ -362,14 +535,14 @@ end
 -- <br/><em>Aliased as `filter`</em>.
 -- @name select
 -- @param t a table
--- @param f an iterator function, prototyped as `f (k, v, ...)`
+-- @param f an iterator function, prototyped as `f (v, k, ...)`
 -- @param[opt] ... Optional args to be passed to `f`
 -- @return the selected values
 -- @see reject
-function _.select(t, f, ...)
+function M.select(t, f, ...)
   local _t = {}
   for index,value in pairs(t) do
-    if f(index, value,...) then _t[#_t+1] = value end
+    if f(value,index,...) then _t[#_t+1] = value end
   end
   return _t
 end
@@ -378,15 +551,14 @@ end
 -- <br/><em>Aliased as `discard`</em>
 -- @name reject
 -- @param t a table
--- @param f an iterator function, prototyped as `f (k, v, ...)`
+-- @param f an iterator function, prototyped as `f (v, k, ...)`
 -- @param[opt] ... Optional args to be passed to `f`
 -- @return the remaining values
 -- @see select
-function _.reject(t, f, ...)
-  local _mapped = _.map(t,f,...)
+function M.reject(t, f, ...)
   local _t = {}
-  for index,value in pairs (_mapped) do
-    if not value then _t[#_t+1] = t[index] end
+  for index,value in pairs (t) do
+    if not f(value,index,...) then _t[#_t+1] = value end
   end
   return _t
 end
@@ -395,11 +567,14 @@ end
 -- <br/><em>Aliased as `every`</em>
 -- @name all
 -- @param t a table
--- @param f an iterator function, prototyped as `f (k, v, ...)`
+-- @param f an iterator function, prototyped as `f (v, k, ...)`
 -- @param[opt] ... Optional args to be passed to `f`
 -- @return `true` if all values passes the predicate, `false` otherwise
-function _.all(t, f, ...)
-  return ((#_.select(_.map(t,f,...), isTrue)) == count(t))
+function M.all(t, f, ...)
+  for index,value in pairs(t) do
+    if not f(value,index,...) then return false end
+  end
+  return true
 end
 
 --- Invokes a method on each value in a table.
@@ -409,22 +584,22 @@ end
 -- @param[opt] ... Optional args to be passed to `method`
 -- @return the result of the call `f (v, ...)`
 -- @see pluck
-function _.invoke(t, method, ...)
+function M.invoke(t, method, ...)
   local args = {...}
-  return _.map(t, function(__,v)
-    if _.isTable(v) then
-      if _.has(v,method) then
-        if _.isCallable(v[method]) then
+  return M.map(t, function(v)
+    if (type(v) == 'table') then
+      if v[method] then
+        if M.isCallable(v[method]) then
           return v[method](v,unpack(args))
         else
           return v[method]
         end
       else
-        if _.isCallable(method) then
+        if M.isCallable(method) then
           return method(v,unpack(args))
         end
       end
-    elseif _.isCallable(method) then
+    elseif M.isCallable(method) then
       return method(v,unpack(args))
     end
   end)
@@ -435,13 +610,15 @@ end
 -- @param t a table
 -- @param key a key, will be used to index in each value: `value[key]`
 -- @return an array of values having the given key
-function _.pluck(t, key)
-  return _.reject(_.map(t,function(__,value)
-      return value[key]
-    end), iNot)
+function M.pluck(t, key)
+  local _t = {}
+  for k, v in pairs(t) do
+    if v[key] then _t[#_t+1] = v[key] end
+  end
+  return _t
 end
 
---- Returns the max value in a collection. If an transformation function is passed, it will
+--- Returns the max value in a collection. If a `transform` function is passed, it will
 -- be used to evaluate values by which all objects will be sorted.
 -- @name max
 -- @param t a table
@@ -449,11 +626,11 @@ end
 -- @param[optchain] ... Optional args to be passed to `transform`
 -- @return the max value found
 -- @see min
-function _.max(t, transform, ...)
+function M.max(t, transform, ...)
   return extract(t, f_max, transform, ...)
 end
 
---- Returns the min value in a collection. If an transformation function is passed, it will
+--- Returns the min value in a collection. If a `transform` function is passed, it will
 -- be used to evaluate values by which all objects will be sorted.
 -- @name min
 -- @param t a table
@@ -461,45 +638,28 @@ end
 -- @param[optchain] ... Optional args to be passed to `transform`
 -- @return the min value found
 -- @see max
-function _.min(t, transform, ...)
+function M.min(t, transform, ...)
   return extract(t, f_min, transform, ...)
 end
 
---- Returns a shuffled copy of a given collection. If a seed is provided, it will
--- be used to init the pseudo random number generator (using `math.randomseed`).
--- @name shuffle
--- @param t a table
--- @param[opt] seed a seed
--- @return a shuffled copy of the given table
-function _.shuffle(t, seed)
-  if seed then randomseed(seed) end
-  local _shuffled = {}
-  _.each(t,function(index,value)
-     local randPos = floor(random()*index)+1
-    _shuffled[index] = _shuffled[randPos]
-    _shuffled[randPos] = value
-  end)
-  return _shuffled
-end
-
 --- Checks if two tables are the same. It compares if both tables features the same values,
 -- but not necessarily at the same keys.
 -- @name same
 -- @param a a table
 -- @param b another table
 -- @return `true` or `false`
-function _.same(a, b)
-  return _.all(a, function (i,v) return _.include(b,v) end) 
-     and _.all(b, function (i,v) return _.include(a,v) end)
+function M.same(a, b)
+  return M.all(a, function(v) return M.include(b,v) end) 
+     and M.all(b, function(v) return M.include(a,v) end)
 end
 
 --- Sorts a table, in-place. If a comparison function is given, it will be used to sort values.
 -- @name sort
 -- @param t a table
 -- @param[opt] comp a comparison function prototyped as `comp (a, b)`, defaults to <tt><</tt> operator.
--- @return the initial table, sorted.
+-- @return the given table, sorted.
 -- @see sortBy
-function _.sort(t, comp)
+function M.sort(t, comp)
   t_sort(t, comp)
   return t
 end
@@ -510,54 +670,49 @@ end
 -- @name sortBy
 -- @param t a table
 -- @param[opt] transform a `transform` function to sort elements prototyped as `transform (v)`. Defaults to @{identity}
--- @param[optchain] comp a comparision function, defaults to the `<` operator
+-- @param[optchain] comp a comparison function, defaults to the `<` operator
 -- @return a new array of sorted values
 -- @see sort
-function _.sortBy(t, transform, comp)
-	local f = transform or _.identity
-	if _.isString(transform) then
+function M.sortBy(t, transform, comp)
+	local f = transform or M.identity
+	if (type(transform) == 'string') then
 		f = function(t) return t[transform] end
 	end
 	comp = comp or f_min	
-	local _t = {}
-	_.each(t, function(__,v)
-		_t[#_t+1] = {value = v, transform = f(v)}
-	end)
-	t_sort(_t, function(a,b) return comp(a.transform, b.transform) end)
-	return _.pluck(_t, 'value')
+	t_sort(t, function(a,b) return comp(f(a), f(b)) end)
+	return t
 end
 
 --- Splits a table into subsets groups.
 -- @name groupBy
 -- @param t a table
--- @param iter an iterator function, prototyped as `iter (k, v, ...)`
+-- @param iter an iterator function, prototyped as `iter (v, k, ...)`
 -- @param[opt] ... Optional args to be passed to `iter`
 -- @return a table of subsets groups
-function _.groupBy(t, iter, ...)
+function M.groupBy(t, iter, ...)
   local vararg = {...}
   local _t = {}
-  _.each(t, function(i,v)
-      local _key = iter(i,v, unpack(vararg))
-      if _t[_key] then _t[_key][#_t[_key]+1] = v
-      else _t[_key] = {v}
-      end
-    end)
+  for k,v in pairs(t) do
+    local _key = iter(v,k, unpack(vararg))
+    if _t[_key] then _t[_key][#_t[_key]+1] = v
+    else _t[_key] = {v}
+    end
+  end
   return _t
 end
 
 --- Groups values in a collection and counts them.
 -- @name countBy
 -- @param t a table
--- @param iter an iterator function, prototyped as `iter (k, v, ...)`
+-- @param iter an iterator function, prototyped as `iter (v, k, ...)`
 -- @param[opt] ... Optional args to be passed to `iter`
 -- @return a table of subsets groups names paired with their count
-function _.countBy(t, iter, ...)
-  local vararg = {...}
+function M.countBy(t, iter, ...)
   local stats = {}
-  _.each(t,function(i,v)
-      local key = iter(i,v,unpack(vararg))
-      stats[key] = (stats[key] or 0) +1
-    end)
+  for i,v in pairs(t) do
+    local key = iter(v,i,...)
+    stats[key] = (stats[key] or 0) +1
+  end
   return stats
 end
 
@@ -568,14 +723,10 @@ end
 -- @return a count
 -- @see count
 -- @see countf
-function _.size(...)
+function M.size(...)
   local args = {...}
   local arg1 = args[1]
-  if _.isTable(arg1) then
-    return count(args[1])
-  else
-    return count(args)
-  end
+  return (type(arg1) == 'table') and count(args[1]) or count(args)
 end
 
 --- Checks if all the keys of `other` table exists in table `t`. It does not
@@ -586,7 +737,7 @@ end
 -- @param other another table
 -- @return `true` or `false`
 -- @see sameKeys
-function _.containsKeys(t, other)
+function M.containsKeys(t, other)
   for key in pairs(other) do
     if not t[key] then return false end
   end
@@ -599,7 +750,7 @@ end
 -- @param tB another table
 -- @return `true` or `false`
 -- @see containsKeys
-function _.sameKeys(tA, tB)
+function M.sameKeys(tA, tB)
   for key in pairs(tA) do
     if not tB[key] then return false end
   end
@@ -619,16 +770,16 @@ end
 -- @param array an array
 -- @param[opt] n a number of elements to be sampled. Defaults to 1.
 -- @param[optchain] seed an optional seed for shuffling 
--- @return an array of selected values or a single value when `n` == 1
+-- @return an array of selected values
 -- @see sampleProb
-function _.sample(array, n, seed)
-	n = n or 1
-	if n < 1 then return end
+function M.sample(array, n, seed)
+  n = n or 1    
+  if n == 0 then return {} end
 	if n == 1 then
 		if seed then randomseed(seed) end
-		return array[random(1, #array)]
+		return {array[random(1, #array)]}
 	end
-	return _.slice(_.shuffle(array, seed), 1, n)
+	return M.slice(M.shuffle(array, seed), 1, n)
 end
 
 --- Return elements from a sequence with a given probability. It considers each value independently. 
@@ -640,16 +791,37 @@ end
 -- @param[opt] seed an optional seed for deterministic sampling
 -- @return an array of selected values
 -- @see sample
-function _.sampleProb(array, prob, seed)
+function M.sampleProb(array, prob, seed)
 	if seed then randomseed(seed) end
-	return _.select(array, function(_,v) return random() < prob end)
+  local t = {}
+  for k, v in ipairs(array) do
+    if random() < prob then t[#t+1] = v end
+  end
+	return t
+end
+
+--- Returns a shuffled copy of a given array. If a seed is provided, it will
+-- be used to init the built-in pseudo random number generator (using `math.randomseed`).
+-- @name shuffle
+-- @param array an array
+-- @param[opt] seed a seed
+-- @return a shuffled copy of the given array
+function M.shuffle(array, seed)
+  if seed then randomseed(seed) end
+  local _shuffled = {}
+  for index, value in ipairs(array) do
+    local randPos = floor(random()*index)+1
+    _shuffled[index] = _shuffled[randPos]
+    _shuffled[randPos] = value
+  end
+  return _shuffled
 end
 
 --- Converts a list of arguments to an array.
 -- @name toArray
 -- @param ... a list of arguments
 -- @return an array of all passed-in args
-function _.toArray(...) return {...} end
+function M.toArray(...) return {...} end
 
 --- Looks for the first occurrence of a given value in an array. Returns the value index if found.
 -- Uses @{isEqual} to compare values.
@@ -658,9 +830,10 @@ function _.toArray(...) return {...} end
 -- @param value a value to lookup for
 -- @param[opt] from the index from where the search will start. Defaults to 1.
 -- @return the index of the value if found in the array, `nil` otherwise.
-function _.find(array, value, from)
+-- @see detect
+function M.find(array, value, from)
   for i = from or 1, #array do
-    if _.isEqual(array[i], value) then return i end
+    if M.isEqual(array[i], value) then return i end
   end
 end
 
@@ -668,7 +841,7 @@ end
 -- @name reverse
 -- @param array an array
 -- @return a reversed array
-function _.reverse(array)
+function M.reverse(array)
   local _array = {}
   for i = #array,1,-1 do
     _array[#_array+1] = array[i]
@@ -677,33 +850,58 @@ function _.reverse(array)
 end
 
 --- Replaces elements in a given array with a given value. In case `i` and `j` are given
--- it will only replaces values at indexes between `[i,j]`. In case `j` is greather than the array
--- size, it will append new values, increasing the array.
+-- it will only replaces values at indexes between `[i,j]`. In case `j` is greater than the array
+-- size, it will append new values, increasing the array size.
 -- @name fill
 -- @param array an array
 -- @param value a value
 -- @param[opt] i the index from which to start replacing values. Defaults to 1.
 -- @param[optchain] j the index where to stop replacing values. Defaults to the array size.
 -- @return the original array with values changed
-function _.fill(array, value, i, j)
-	j = j or _.size(array)
+function M.fill(array, value, i, j)
+	j = j or M.size(array)
 	for i = i or 1, j do array[i] = value end
 	return array
 end
 
+--- Returns an array of `n` zeros.
+-- @name zeros
+-- @param n a number
+-- @return an array
+-- @see ones
+-- @see vector
+function M.zeros(n) return M.fill({}, 0, 1, n) end
+
+--- Returns an array of `n` 1's.
+-- @name ones
+-- @param n a number
+-- @return an array
+-- @see zeros
+-- @see vector
+function M.ones(n) return M.fill({}, 1, 1, n) end
+
+--- Returns an array of `n` times a given value.
+-- @name vector
+-- @param value a value
+-- @param n a number
+-- @return an array
+-- @see zeros
+-- @see ones
+function M.vector(value, n) return M.fill({}, value, 1, n) end
+
 --- Collects values from a given array. The passed-in array should not be sparse.
 -- This function collects values as long as they satisfy a given predicate and returns on the first falsy test.
 -- <br/><em>Aliased as `takeWhile`</em>
 -- @name selectWhile
 -- @param array an array
--- @param f an iterator function prototyped as `f (k, v, ...)`
+-- @param f an iterator function prototyped as `f (v, k, ...)`
 -- @param[opt] ... Optional args to be passed to `f`
 -- @return a new table containing all values collected
 -- @see dropWhile
-function _.selectWhile(array, f, ...)
+function M.selectWhile(array, f, ...)
   local t = {}
   for i,v in ipairs(array) do
-    if f(i,v,...) then t[i] = v else break end
+    if f(v,i,...) then t[i] = v else break end
   end
   return t
 end
@@ -713,20 +911,20 @@ end
 -- <br/><em>Aliased as `rejectWhile`</em>
 -- @name dropWhile
 -- @param array an array
--- @param f an iterator function prototyped as `f (k,v, ...)`
+-- @param f an iterator function prototyped as `f (v, k, ...)`
 -- @param[opt] ... Optional args to be passed to `f`
 -- @return a new table containing all values collected
--- @selectWhile
-function _.dropWhile(array, f, ...)
+-- @see selectWhile
+function M.dropWhile(array, f, ...)
   local _i
   for i,v in ipairs(array) do
-    if not f(i,v,...) then
+    if not f(v, i, ...) then
       _i = i
       break
     end
   end
-  if _.isNil(_i) then return {} end
-  return _.rest(array,_i)
+  if (_i == nil) then return {} end
+  return M.rest(array,_i)
 end
 
 --- Returns the index at which a value should be inserted. This index is evaluated so 
@@ -738,22 +936,22 @@ end
 -- @param[opt] comp an comparison function prototyped as `f (a, b)`, defaults to <tt><</tt> operator.
 -- @param[optchain] sort whether or not the passed-in array should be sorted
 -- @return number the index at which the passed-in value should be inserted
-function _.sortedIndex(array, value, comp, sort)
+function M.sortedIndex(array, value, comp, sort)
   local _comp = comp or f_min
-  if sort then _.sort(array,_comp) end
+  if (sort == true) then t_sort(array,_comp) end
   for i = 1,#array do
     if not _comp(array[i],value) then return i end
   end
   return #array+1
 end
 
---- Returns the index of the first occurence of value in an array.
+--- Returns the index of the first occurrence of value in an array.
 -- @name indexOf
 -- @param array an array
 -- @param value the value to search for
 -- @return the index of the passed-in value
 -- @see lastIndexOf
-function _.indexOf(array, value)
+function M.indexOf(array, value)
   for k = 1,#array do
     if array[k] == value then return k end
   end
@@ -765,21 +963,21 @@ end
 -- @param value the value to search for
 -- @return the index of the last occurrence of the passed-in value or __nil__
 -- @see indexOf
-function _.lastIndexOf(array, value)
-  local key = _.indexOf(_.reverse(array),value)
+function M.lastIndexOf(array, value)
+  local key = M.indexOf(M.reverse(array),value)
   if key then return #array-key+1 end
 end
 
 --- Returns the first index at which a predicate returns true.
 -- @name findIndex
 -- @param array an array
--- @param predicate a predicate function prototyped as `predicate (k, v, ...)`
+-- @param predicate a predicate function prototyped as `predicate (v, k, ...)`
 -- @param[opt] ... optional arguments to `pred`
 -- @return the index found or __nil__
 -- @see findLastIndex
-function _.findIndex(array, predicate, ...)
+function M.findIndex(array, predicate, ...)
 	for k = 1, #array do
-		if predicate(k,array[k],...) then return k end
+		if predicate(array[k],k,...) then return k end
 	end
 end
 
@@ -790,8 +988,8 @@ end
 -- @param[opt] ... optional arguments to `pred`
 -- @return the index found or __nil__
 -- @see findIndex
-function _.findLastIndex(array, predicate, ...)
-  local key = _.findIndex(_.reverse(array),predicate,...)
+function M.findLastIndex(array, predicate, ...)
+  local key = M.findIndex(M.reverse(array),predicate,...)
   if key then return #array-key+1 end
 end
 
@@ -801,31 +999,50 @@ end
 -- @param array an array
 -- @param ... a variable number of arguments
 -- @return the passed-in array with new values added
+-- @see prepend
 -- @see push
-function _.addTop(array, ...)
-  _.each({...},function(i,v) t_insert(array,1,v) end)
+function M.addTop(array, ...)
+  for k,v in ipairs({...}) do
+    t_insert(array,1,v)
+  end
   return array
 end
 
+--- Adds all passed-in values at the top of an array. As opposed to @{addTop}, it preserves the order
+-- of the passed in elements.
+-- @name prepend
+-- @param array an array
+-- @param ... a variable number of arguments
+-- @return the passed-in array with new values added
+-- @see addTop
+-- @see push
+function M.prepend(array, ...)
+  return M.append({...}, array)
+end
+
 --- Pushes all passed-in values at the end of an array.
 -- @name push
 -- @param array an array
 -- @param ... a variable number of arguments
 -- @return the passed-in array with new added values
 -- @see addTop
-function _.push(array, ...)
-  _.each({...}, function(i,v) array[#array+1] = v end)
+-- @see prepend
+function M.push(array, ...)
+  local args = {...}
+  for k,v in ipairs({...}) do
+    array[#array+1] = v
+  end
   return array
 end
 
 --- Removes and returns the values at the top of a given array.
--- <br/><em>Aliased as `shift`</em>
--- @name pop
+-- <br/><em>Aliased as `pop`</em>
+-- @name shift
 -- @param array an array
 -- @param[opt] n the number of values to be popped. Defaults to 1.
 -- @return the popped values
 -- @see unshift
-function _.pop(array, n)
+function M.shift(array, n)
   n = min(n or 1, #array)
   local ret = {}
   for i = 1, n do 
@@ -841,8 +1058,8 @@ end
 -- @param array an array
 -- @param[opt] n the number of values to be unshifted. Defaults to 1.
 -- @return the values
--- @see pop
-function _.unshift(array, n)
+-- @see shift
+function M.unshift(array, n)
   n = min(n or 1, #array)
   local ret = {}
   for i = 1, n do
@@ -859,10 +1076,10 @@ end
 -- @param array an array
 -- @param ... a variable number of values to be removed from the array
 -- @return the passed-in array with values removed
-function _.pull(array, ...)
-  for __, rmValue in ipairs({...}) do
+function M.pull(array, ...)
+  for k, rmValue in ipairs({...}) do
     for i = #array, 1, -1 do
-      if _.isEqual(array[i], rmValue) then
+      if M.isEqual(array[i], rmValue) then
         t_remove(array, i)
       end
     end
@@ -870,28 +1087,21 @@ function _.pull(array, ...)
   return array
 end
 
---- Removes values at index within the range `[start, finish]`.
+--- Removes values at an index within the range `[start, finish]`.
 -- <br/><em>Aliased as `rmRange`, `chop`</em>
 -- @name removeRange
 -- @param array an array
 -- @param[opt] start the lower bound index, defaults to the first index in the array.
 -- @param[optchain] finish the upper bound index, defaults to the array length.
 -- @return the passed-in array with values removed
-function _.removeRange(array, start, finish)
-  local array = _.clone(array)
-  local i,n = (next(array)),#array
-  if n < 1 then return array end
-
-  start = clamp(start or i,i,n)
-  finish = clamp(finish or n,i,n)
-
-  if finish < start then return array end
-
-  local count = finish - start + 1
-  local i = start
-  while count > 0 do
-    t_remove(array,i)
-    count = count - 1
+function M.removeRange(array, start, finish)
+  start = start or 1
+  finish = finish or #array
+  if start > finish then 
+    error("start cannot be greater than finish.")
+  end  
+  for i = finish, start, -1 do
+    t_remove(array, i)
   end
   return array
 end
@@ -901,42 +1111,43 @@ end
 -- the same value are chunked together. Leaves the first argument untouched if it is not an array.
 -- @name chunk
 -- @param array an array
--- @param f an iterator function prototyped as `f (k, v, ...)`
+-- @param f an iterator function prototyped as `f (v, k, ...)`
 -- @param[opt] ... Optional args to be passed to `f`
 -- @return a table of chunks (arrays)
 -- @see zip
-function _.chunk(array, f, ...)
-  if not _.isArray(array) then return array end
-  local ch, ck, prev = {}, 0
-  local mask = _.map(array, f,...)
-  _.each(mask, function(k,v)
-    prev = (prev==nil) and v or prev
-    ck = ((v~=prev) and (ck+1) or ck)
+function M.chunk(array, f, ...)
+  local ch, ck, prev, val = {}, 0
+  for k,v in ipairs(array) do
+    val = f(v, k,...)
+    prev = (prev==nil) and val or prev
+    ck = ((val~=prev) and (ck+1) or ck)
     if not ch[ck] then
       ch[ck] = {array[k]}
     else
       ch[ck][#ch[ck]+1] = array[k]
     end
-    prev = v
-  end)
+    prev = val
+  end
   return ch
 end
 
 --- Slices values indexed within `[start, finish]` range.
--- <br/><em>Aliased as `_.sub`</em>
+-- <br/><em>Aliased as `M.sub`</em>
 -- @name slice
 -- @param array an array
 -- @param[opt] start the lower bound index, defaults to the first index in the array.
 -- @param[optchain] finish the upper bound index, defaults to the array length.
 -- @return a new array of sliced values
-function _.slice(array, start, finish)
-  return _.select(array, function(index)
-      return (index >= (start or next(array)) and index <= (finish or #array))
-    end)
+function M.slice(array, start, finish)
+  local t = {}
+  for k = start or 1, finish or #array do
+    t[#t+1] = array[k]
+  end
+  return t
 end
 
 --- Returns the first N values in an array.
--- <br/><em>Aliased as `head`, `take`</em>
+-- <br/><em>Aliased as `head`, `take` </em>
 -- @name first
 -- @param array an array
 -- @param[opt] n the number of values to be collected, defaults to 1.
@@ -944,9 +1155,13 @@ end
 -- @see initial
 -- @see last
 -- @see rest
-function _.first(array, n)
-  local n = n or 1
-  return _.slice(array,1, min(n,#array))
+function M.first(array, n)
+  n = n or 1
+  local t = {}
+  for k = 1, n do
+    t[k] = array[k]
+  end
+  return t
 end
 
 --- Returns all values in an array excluding the last N values.
@@ -957,9 +1172,14 @@ end
 -- @see first
 -- @see last
 -- @see rest
-function _.initial(array, n)
-  if n and n < 0 then return end
-  return _.slice(array,1, n and #array-(min(n,#array)) or #array-1)
+function M.initial(array, n)
+  local l = #array
+  n = n and l-(min(n,l)) or l-1
+  local t = {}
+  for k = 1, n do
+    t[k] = array[k]
+  end
+  return t
 end
 
 --- Returns the last N values in an array.
@@ -970,12 +1190,17 @@ end
 -- @see first
 -- @see initial
 -- @see rest
-function _.last(array, n)
-  if n and n <= 0 then return end
-  return _.slice(array,n and #array-min(n-1,#array-1) or 2,#array)
+function M.last(array, n)
+  local l = #array
+  n = n and l-min(n-1,l-1) or 2 
+  local t = {}
+  for k = n, l do
+    t[#t+1] = array[k]
+  end
+  return t
 end
 
---- Removes all values before index.
+--- Returns all values after index.
 -- <br/><em>Aliased as `tail`</em>
 -- @name rest
 -- @param array an array
@@ -984,9 +1209,12 @@ end
 -- @see first
 -- @see initial
 -- @see last
-function _.rest(array,index)
-  if index and index > #array then return {} end
-  return _.slice(array,index and max(1,min(index,#array)) or 1,#array)
+function M.rest(array, index)
+  local t = {}
+  for k = index or 1, #array do
+    t[#t+1] = array[k]
+  end
+  return t
 end
 
 --- Returns the value at a given index.
@@ -994,33 +1222,35 @@ end
 -- @param array an array
 -- @param index an index
 -- @return the value at the given index
-function _.nth(array, index)
+function M.nth(array, index)
   return array[index]
 end
 
---- Removes all falsy (false and nil) values.
+--- Returns all truthy values (removes `falses` and `nils`).
 -- @name compact
 -- @param array an array
 -- @return a new array
-function _.compact(array)
-  return _.reject(array, function (_,value)
-    return not value
-  end)
+function M.compact(array)
+  local t = {}
+  for k,v in pairs(array) do
+    if v then t[#t+1] = v end
+  end
+  return t
 end
 
 --- Flattens a nested array. Passing `shallow` will only flatten at the first level.
 -- @name flatten
 -- @param array an array
--- @param[opt] shallow specifies the flattening depth
--- @return a new array, flattened
-function _.flatten(array, shallow)
-  local shallow = shallow or false
+-- @param[opt] shallow specifies the flattening depth. Defaults to `false`.`
+-- @return a flattened array
+function M.flatten(array, shallow)
+  shallow = shallow or false
   local new_flattened
   local _flat = {}
-  for key,value in pairs(array) do
-    if _.isTable(value) then
-      new_flattened = shallow and value or _.flatten (value)
-      _.each(new_flattened, function(_,item) _flat[#_flat+1] = item end)
+  for key,value in ipairs(array) do
+    if type(value) == 'table' then
+      new_flattened = shallow and value or M.flatten (value)
+      for k,item in ipairs(new_flattened) do _flat[#_flat+1] = item end
     else _flat[#_flat+1] = value
     end
   end
@@ -1036,11 +1266,11 @@ end
 -- @see union
 -- @see intersection
 -- @see symmetricDifference
-function _.difference(array, array2)
-  if not array2 then return _.clone(array) end
-  return _.select(array,function(i,value)
-      return not _.include(array2,value)
-    end)
+function M.difference(array, array2)
+  if not array2 then return M.clone(array) end
+  return M.select(array,function(value)
+    return not M.include(array2,value)
+  end)
 end
 
 --- Returns the duplicate-free union of all passed in arrays.
@@ -1050,8 +1280,8 @@ end
 -- @see difference
 -- @see intersection
 -- @see symmetricDifference
-function _.union(...)
-  return _.uniq(_.flatten({...}))
+function M.union(...)
+  return M.unique(M.flatten({...}))
 end
 
 --- Returns the  intersection of all passed-in arrays.
@@ -1063,14 +1293,12 @@ end
 -- @see difference
 -- @see union
 -- @see symmetricDifference
-function _.intersection(array, ...)
+function M.intersection(array, ...)
   local arg = {...}
   local _intersect = {}
   for i,value in ipairs(array) do
-    if _.all(arg,function(i,v)
-          return _.include(v,value)
-        end) then
-      t_insert(_intersect,value)
+    if M.all(arg,function(v) return M.include(v,value) end) then
+      _intersect[#_intersect+1] = value
     end
   end
   return _intersect
@@ -1086,10 +1314,10 @@ end
 -- @see difference
 -- @see union
 -- @see intersection
-function _.symmetricDifference(array, array2)
-  return _.difference(
-    _.union(array, array2),
-    _.intersection(array,array2)
+function M.symmetricDifference(array, array2)
+  return M.difference(
+    M.union(array, array2),
+    M.intersection(array,array2)
   )
 end
 
@@ -1099,10 +1327,10 @@ end
 -- @param array an array
 -- @return a new array, duplicate-free
 -- @see isunique
-function _.unique(array)
+function M.unique(array)
   local ret = {}
   for i = 1, #array do
-    if not _.find(ret, array[i]) then
+    if not M.find(ret, array[i]) then
       ret[#ret+1] = array[i]
     end
   end
@@ -1116,8 +1344,8 @@ end
 -- @param array an array
 -- @return `true` if the given array is unique, `false` otherwise.
 -- @see unique
-function _.isunique(array)
-  return _.isEqual(array, _.unique(array))
+function M.isunique(array)
+  return #array == #(M.unique(array))
 end
 
 --- Merges values of each of the passed-in arrays in subsets.
@@ -1126,24 +1354,45 @@ end
 -- @name zip
 -- @param ... a variable number of array arguments
 -- @return a new array
-function _.zip(...)
-  local arg = {...}
-  local _len = _.max(_.map(arg,function(i,v)
-      return #v
-    end))
+-- @see zipWith
+function M.zip(...)
+  local args = {...}
+  local n = M.max(args, function(array) return #array end)
   local _ans = {}
-  for i = 1,_len do
-    _ans[i] = _.pluck(arg,i)
+  for i = 1,n do
+    if not _ans[i] then _ans[i] = {} end    
+    for k, array in ipairs(args) do
+      if array[i] then _ans[i][#_ans[i]+1] = array[i] end
+    end
   end
   return _ans
 end
 
---- Clones `array` and appends `other` values.
+--- Merges values using a given function.
+-- Only values indexed with the same key in the given arrays are merged in the same subset.
+-- Function `f` is used to combine values.
+-- <br/><em>Aliased as `transposeWith`</em>
+-- @name zipWith
+-- @param f a function
+-- @param ... a variable number of array arguments
+-- @return a flat array of results
+-- @see zip
+function M.zipWith(f, ...)
+  local args = {...}
+  local n = M.max(args, function(array) return #array end)
+  local _ans = {}
+  for i = 1,n do    
+    _ans[i] = f(unpack(M.pluck(args,i)))
+  end
+  return _ans
+end
+
+--- Clones array and appends values from another array.
 -- @name append
 -- @param array an array
 -- @param other an array
 -- @return a new array
-function _.append(array, other)
+function M.append(array, other)
   local t = {}
   for i,v in ipairs(array) do t[i] = v end
   for i,v in ipairs(other) do t[#t+1] = v end
@@ -1156,39 +1405,51 @@ end
 -- @param ... a variable list of arrays
 -- @return a new array
 -- @see interpose
-function _.interleave(...) return _.flatten(_.zip(...)) end
+function M.interleave(...) 
+  local args = {...}
+  local n = M.max(args, M.size)
+  local t = {}
+  for i = 1, n do  
+    for k, array in ipairs(args) do
+      if array[i] then t[#t+1] = array[i] end
+    end
+  end
+  return t
+end
 
---- Interposes value in-between consecutive pair of values in `array`.
+--- Interposes value in-between consecutive pair of values in array.
+-- <br/><em>Aliased as `intersperse`</em>
 -- @name interpose
--- @param value a value
 -- @param array an array
+-- @param value a value
 -- @return a new array
 -- @see interleave
-function _.interpose(value, array)
-  return _.flatten(_.zip(array, _.rep(value, #array-1)))
+function M.interpose(array, value)
+  for k = #array, 2,-1 do
+    t_insert(array, k, value)
+  end
+  return array
 end
 
---- Produces a flexible list of numbers. If one positive value is passed, will count from 0 to that value,
--- with a default step of 1. If two values are passed, will count from the first one to the second one, with the
--- same default step of 1. A third value passed will be considered a step value.
+--- Produces a flexible list of numbers. If one value is passed, will count from 1 to that value,
+-- with a default step of 1 (or -1). If two values are passed, will count from the first one to the second one,
+-- using a default step of 1 (or -1). A third value passed will be considered a step value.
 -- @name range
 -- @param[opt] from the initial value of the range
 -- @param[optchain] to the final value of the range
--- @param[optchain] step the step of count
+-- @param[optchain] step the step of count. Defaults to 1 or -1.
 -- @return a new array of numbers
-function _.range(...)
-  local arg = {...}
-  local _start,_stop,_step
-  if #arg==0 then return {}
-  elseif #arg==1 then _stop,_start,_step = arg[1],0,1
-  elseif #arg==2 then _start,_stop,_step = arg[1],arg[2],1
-  elseif #arg == 3 then _start,_stop,_step = arg[1],arg[2],arg[3]
-  end
-  if (_step and _step==0) then return {} end
-  local _ranged = {}
-  local _steps = max(floor((_stop-_start)/_step),0)
-  for i=1,_steps do _ranged[#_ranged+1] = _start+_step*i end
-  if #_ranged>0 then t_insert(_ranged,1,_start) end
+function M.range(from, to, step)
+  if (from == nil) and (to == nil) and (step ==nil) then
+    return {}
+  elseif (from ~= nil) and (to == nil) and (step == nil) then
+    from, to, step = signum(from), from, signum(from)
+  elseif (from ~= nil) and (to ~= nil) and (step == nil) then
+    step = signum(to - from)
+  end
+  local _ranged = {from}
+  local steps = max(floor((to-from)/step),0)
+  for i=1,steps do _ranged[#_ranged+1] = from+step*i end
   return _ranged
 end
 
@@ -1197,50 +1458,94 @@ end
 -- @param value a value to be repeated
 -- @param n the number of repetitions of value.
 -- @return a new array of `n` values
-function _.rep(value, n)
+function M.rep(value, n)
   local ret = {}
-  for i = 1, n do ret[#ret+1] = value end
+  for i = 1, n do ret[i] = value end
   return ret
 end
 
+--- Returns the powerset of array values. For instance, when given the set {1,2,3},
+-- returns `{{1},{2},{3},{1,2},{2,3},{1,2,3}}`.
+-- @name powerset
+-- @param array an array
+-- @return an array
+function M.powerset(array)
+  local n = #array
+  if n == 0 then return {{}} end
+  local t = {}
+  for l = 1, n do  
+    for s = 1, n-l+1 do
+      t[#t+1] = M.slice(array,s,s+l-1)
+    end
+  end
+  return t
+end
+
 --- Iterator returning partitions of an array. It returns arrays of length `n` 
 -- made of values from the given array. If the last partition has lower elements than `n` and 
 -- `pad` is supplied, it will be adjusted to `n` of elements with `pad` value.
 -- @name partition
 -- @param array an array
--- @param[opt] n the size of partitions. Should be greater than 0. Defaults to 1.
--- @param[optchain] pad a value to adjust the last subsequence to the `n` elements
+-- @param[opt] n the size of partitions. Defaults to 1.
+-- @param[optchain] pads a value to adjust the last subsequence to the `n` elements
 -- @return an iterator function
-function _.partition(array, n, pad)
+-- @see overlapping
+-- @see aperture
+function M.partition(array, n, pad)
 	if n<=0 then return end
-  return coroutine.wrap(function()
-    partgen(array, n or 1, coroutine.yield, pad)
+  return wrap(function()
+    partgen(array, n or 1, yield, pad)
   end)
 end
 
---- Iterator returning sliding partitions of an array. It returns overlapping subsequences
--- of length `n`. If the last subsequence has lower elements than `n` and `pad` is 
+--- Iterator returning overlapping partitions of an array. 
+-- If the last subsequence has lower elements than `n` and `pad` is 
 -- supplied, it will be adjusted to `n` elements with `pad` value.
--- @name sliding.
+-- @name overlapping
 -- @param array an array
--- @param[opt] n the size of partitions. Should be greater than 1. Defaults to 2.
--- @param[optchain] pad a value to adjust the last subsequence to the `n` elements
+-- @param[opt] n the size of partitions. Defaults to 2.
+-- @param[optchain] pads a value to adjust the last subsequence to the `n` elements
 -- @return an iterator function
-function _.sliding(array, n, pad)
+-- @see partition
+-- @see aperture
+function M.overlapping(array, n, pad)
 	if n<=1 then return end
-  return coroutine.wrap(function()
-    partgen2(array, n or 2, coroutine.yield, pad)
+  return wrap(function()
+    partgen2(array, n or 2, yield, pad)
   end)
 end
 
+--- Iterator returning sliding partitions of an array.
+-- <br/><em>Aliased as `sliding`</em>
+-- @name aperture
+-- @param array an array
+-- @param[opt] n the size of partitions. Defaults to 2 (and then behaves like @{pairwise})
+-- @return an iterator function
+-- @see partition
+-- @see overlapping
+-- @see pairwise
+function M.aperture(array, n)
+	if n<=1 then return end
+  return wrap(function()
+    partgen3(array, n or 2, yield)
+  end)
+end
+
+--- Iterator returning sliding pairs of an array.
+-- @name pairwise
+-- @param array an array
+-- @return an iterator function
+-- @see overlapping
+function M.pairwise(array) return M.aperture(array, 2) end
+
 --- Iterator returning the permutations of an array. It returns arrays made of all values
 -- from the passed-in array, with values permuted.
 -- @name permutation
 -- @param array an array
 -- @return an iterator function
-function _.permutation(array)
-  return coroutine.wrap(function() 
-    permgen(array, #array, coroutine.yield)
+function M.permutation(array)
+  return wrap(function() 
+    permgen(array, #array, yield)
   end)
 end
 
@@ -1250,9 +1555,11 @@ end
 -- @name invert
 -- @param array a given array
 -- @return a new array
-function _.invert(array)
+function M.invert(array)
   local _ret = {}
-  _.each(array,function(i,v) _ret[v] = i end)
+  for k, v in ipairs(array) do
+    _ret[v] = k
+  end
   return _ret
 end
 
@@ -1266,54 +1573,148 @@ end
 -- @param[optchain] i the starting index, defaults to 1.
 -- @param[optchain] j the final index, defaults to the array length.
 -- @return a string
-function _.concat(array, sep, i, j)
-  local _array = _.map(array,function(i,v)
-    return tostring(v)
-  end)
-  return t_concat(_array,sep,i or 1,j or #array)
+function M.concat(array, sep, i, j)
+  return t_concat(M.map(array,tostring),sep,i,j)
+end
+
+--- Returns all possible pairs built from given arrays.
+-- @name xprod
+-- @param array a first array
+-- @param array2 a second array
+-- @return an array list of all pairs
+function M.xprod(array, array2)
+  local p = {}
+  for i, v1 in ipairs(array) do
+    for j, v2 in ipairs(array2) do
+      p[#p+1] = {v1, v2}
+    end
+  end
+  return p
+end
+
+--- Returns the sum of array values.
+-- @name sum
+-- @param array a given array
+-- @return the sum of array values
+function M.sum(array)
+  local s = 0
+  for k, v in ipairs(array) do s = s + v end
+  return s
+end
 
+--- Returns the product of array values.
+-- @name product
+-- @param array a given array
+-- @return the product of array values
+function M.product(array)
+  local p = 1
+  for k, v in ipairs(array) do p = p * v end
+  return p
+end
+
+--- Returns the mean of an array of numbers.
+-- <br/><em>Aliased as `average`</em>
+-- @name mean
+-- @param array an array of numbers
+-- @return a number
+-- @see sum
+-- @see product
+-- @see median
+function M.mean(array)
+  return M.sum(array)/(#array)
+end
+
+--- Returns the median of an array of numbers.
+-- @name median
+-- @param array an array of numbers
+-- @return a number
+-- @see sum
+-- @see product
+-- @see mean
+function M.median(array)
+  local t = M.sort(M.clone(array))
+  local n = #t
+  if n == 0 then 
+    return 
+  elseif n==1 then 
+    return t[1]
+  end
+  local mid = ceil(n/2)
+  return n%2==0 and (t[mid] + t[mid+1])/2 or t[mid]
 end
 
 --- Utility functions
 -- @section Utility functions
 
---- The no-operation function.
+--- The no operation function.
 -- @name noop
 -- @return nothing
-function _.noop() return end
+function M.noop() return end
 
 --- Returns the passed-in value. This function is used internally
 -- as a default iterator.
 -- @name identity
 -- @param value a value
 -- @return the passed-in value
-function _.identity(value) return value end
+function M.identity(value) return value end
 
 --- Creates a constant function which returns the same output on every call.
+-- <br/><em>Aliased as `always`</em>
 -- @name constant
 -- @param value a constant value
 -- @return a constant function
-function _.constant(value) return function() return value end end
+function M.constant(value) 
+  return function() return value end 
+end
+
+--- Returns a function which applies `specs` on args. This function produces an object having
+-- the same structure than `specs` by mapping each property to the result of calling its 
+-- associated function with the supplied arguments
+-- @name applySpec
+-- @param specs a table
+-- @return a function
+function M.applySpec(specs)
+  return function (...)
+    local spec = {}
+    for i, f in pairs(specs) do spec[i] = f(...) end
+    return spec
+  end
+end
 
 --- Memoizes a given function by caching the computed result.
--- Useful for speeding-up slow-running functions. If a `hash` function is passed,
--- it will be used to compute hash keys for a set of input values for caching.
+-- Useful for speeding-up slow-running functions.
 -- <br/><em>Aliased as `cache`</em>
 -- @name memoize
 -- @param f a function
--- @param[opt] hash a hash function, defaults to @{identity}
 -- @return a new function
-function _.memoize(f, hash)
+function M.memoize(f)
   local _cache = setmetatable({},{__mode = 'kv'})
-  local _hasher = hash or _.identity
-  return function (...)
-      local _hashKey = _hasher(...)
-      local _result = _cache[_hashKey]
-      if not _result then _cache[_hashKey] = f(...) end
-      return _cache[_hashKey]
+  return function (key)
+      if (_cache[key] == nil) then
+        _cache[key] = f(key)
+      end
+      return _cache[key]
     end
 end
 
+--- Builds a list from a seed value. Accepts an iterator function, which 
+-- returns either nil to stop iteration or two values : the value to add to the list
+-- of results and the seed to be used in the next call to the iterator function.
+-- @name unfold
+-- @param f an iterator function
+-- @param seed a seed value
+-- @return an array of values
+function M.unfold(f, seed)
+  local t, result = {}
+  while true do
+    result, seed = f(seed)
+    if result ~= nil then t[#t+1] = result
+    else break
+    end
+  end 
+  return t
+end
+
 --- Returns a version of `f` that runs only once. Successive calls to `f`
 -- will keep yielding the same output, no matter what the passed-in arguments are. 
 -- It can be used to initialize variables.
@@ -1322,7 +1723,7 @@ end
 -- @return a new function
 -- @see before
 -- @see after
-function _.once(f)
+function M.once(f)
   local _internal = 0
   local _args = {}
   return function(...)
@@ -1332,7 +1733,7 @@ function _.once(f)
   end
 end
 
---- Returns a version of `f` that will run no more than `count` times. Next calls will
+--- Returns a version of `f` that will run no more than <em>count</em> times. Next calls will
 -- keep yielding the results of the count-th call.
 -- @name before
 -- @param f a function
@@ -1340,7 +1741,7 @@ end
 -- @return a new function
 -- @see once
 -- @see after
-function _.before(f, count)
+function M.before(f, count)
   local _internal = 0
   local _args = {}
   return function(...)
@@ -1358,7 +1759,7 @@ end
 -- @return a new function
 -- @see once
 -- @see before
-function _.after(f, count)
+function M.after(f, count)
   local _limit,_internal = count, 0
   return function(...)
 		_internal = _internal+1
@@ -1372,9 +1773,9 @@ end
 -- @param ... a variable number of functions
 -- @return a new function
 -- @see pipe
-function _.compose(...)
+function M.compose(...)
 	-- See: https://github.com/Yonaba/Moses/pull/15#issuecomment-139038895
-  local f = _.reverse {...}
+  local f = M.reverse {...}
   return function (...)
 		local first, _temp = true
 		for i, func in ipairs(f) do
@@ -1396,8 +1797,8 @@ end
 -- @param ... a variable number of functions
 -- @return the result of the composition of function calls.
 -- @see compose
-function _.pipe(value, ...)
-  return _.compose(...)(value)
+function M.pipe(value, ...)
+  return M.compose(...)(value)
 end
 
 --- Returns the logical complement of a given function. For a given input, the returned 
@@ -1406,7 +1807,7 @@ end
 -- @name complement
 -- @param f a function
 -- @return  the logical complement of the given function `f`.
-function _.complement(f)
+function M.complement(f)
   return function(...) return not f(...) end
 end
 
@@ -1417,9 +1818,11 @@ end
 -- @param value a value
 -- @param ... a variable number of functions
 -- @return a list of results
-function _.juxtapose(value, ...)
+function M.juxtapose(value, ...)
   local res = {}
-  _.each({...}, function(_,f) res[#res+1] = f(value) end)
+  for i, func in ipairs({...}) do
+    res[i] = func(value) 
+  end
   return unpack(res)
 end
 
@@ -1430,19 +1833,19 @@ end
 -- @param f a function to be wrapped, prototyped as `f (...)`
 -- @param wrapper a wrapper function, prototyped as `wrapper (f, ...)`
 -- @return the results
-function _.wrap(f, wrapper)
+function M.wrap(f, wrapper)
   return function (...) return  wrapper(f,...) end
 end
 
 --- Runs `iter` function `n` times. Collects the results of each run and returns them in an array.
 -- @name times
--- @param n the number of times `iter` should be called
 -- @param  iter an iterator function, prototyped as `iter (i, ...)`
--- @param ... args to be passed to `iter` function
+-- @param[opt] n the number of times `iter` should be called. Defaults to 1.
+-- @param[optchain] ... args to be passed to `iter` function
 -- @return table an array of results
-function _.times(n, iter, ...)
+function M.times(iter, n, ...)
   local results = {}
-  for i = 1,n do
+  for i = 1, (n or 1) do
     results[i] = iter(i,...)
   end
   return results
@@ -1455,11 +1858,11 @@ end
 -- @return a function
 -- @see bind2
 -- @see bindn
--- @see bindAll
-function _.bind(f, v)
+-- @see bindall
+function M.bind(f, v)
   return function (...)
-      return f(v,...)
-    end
+    return f(v,...)
+  end
 end
 
 --- Binds `v` to be the second argument to `f`. Calling `f (a, ...)` will result to `f (a, v, ...)`.
@@ -1469,8 +1872,8 @@ end
 -- @return a function
 -- @see bind
 -- @see bindn
--- @see bindAll
-function _.bind2(f, v)
+-- @see bindall
+function M.bind2(f, v)
   return function (t, ...)
     return f(t, v, ...)
   end
@@ -1484,32 +1887,48 @@ end
 -- @return a function
 -- @see bind
 -- @see bind2
--- @see bindAll
-function _.bindn(f, ...)
-  local iArg = {...}
+-- @see bindall
+function M.bindn(f, ...)
+  local args = {...}
   return function (...)
-      return f(unpack(_.append(iArg,{...})))
+      return f(unpack(M.append(args,{...})))
     end
 end
 
 --- Binds methods to object. As such, whenever any of these methods is invoked, it 
 -- always receives the object as its first argument.
--- @name bindAll
+-- @name bindall
 -- @param obj an abject
 -- @param ... a variable number of method names
 -- @return the passed-in object with all methods bound to the object itself.
 -- @see bind
 -- @see bind2
 -- @see bindn
-function _.bindAll(obj, ...)
+function M.bindall(obj, ...)
 	local methodNames = {...}
-	for __, methodName in ipairs(methodNames) do
+	for i, methodName in ipairs(methodNames) do
 		local method = obj[methodName]
-		if method then obj[methodName] = _.bind(method, obj) end
+		if method then obj[methodName] = M.bind(method, obj) end
 	end
 	return obj
 end
 
+--- Returns a function which iterate over a set of conditions. It invokes each predicate,
+-- passing it given values. It returns the value of the corresponding function of the first 
+-- predicate to return a non-nil value.
+-- @name cond
+-- @param conds an array list of predicate-function pairs
+-- @return the result of invoking `f(...)` of the first predicate to return a non-nil value
+function M.cond(conds)
+  return function(...)
+    for k, condset in ipairs(conds) do
+      if condset[1](...) then 
+        return condset[2](...) 
+      end
+    end
+  end
+end
+
 --- Generates an unique ID for the current session. If given a string `template`, it
 -- will use this template for output formatting. Otherwise, if `template` is a function, it
 -- will evaluate `template (id, ...)`.
@@ -1518,12 +1937,12 @@ end
 -- @param[opt] template either a string or a function template to format the ID
 -- @param[optchain] ... a variable number of arguments to be passed to `template`, in case it is a function.
 -- @return value an ID
-function _.uniqueId(template, ...)
+function M.uniqueId(template, ...)
   unique_id_counter = unique_id_counter + 1
   if template then
-    if _.isString(template) then
+    if type(template) == 'string' then
       return template:format(unique_id_counter)
-    elseif _.isFunction(template) then
+    elseif type(template) == 'function' then
       return template(unique_id_counter,...)
     end
   end
@@ -1531,39 +1950,108 @@ function _.uniqueId(template, ...)
 end
 
 --- Produces an iterator which repeatedly apply a function `f` onto an input. 
--- Yields x, then f(x), then f(f(x)), continuously.
+-- Yields `value`, then `f(value)`, then `f(f(value))`, continuously.
+-- <br/><em>Aliased as `iter`</em>.
 -- @name iterator
 -- @param f a function 
--- @param x an initial input to `f`
--- @return an iterator fnction
--- <br/><em>Aliased as `iter`</em>.
-function _.iterator(f, x)
+-- @param value an initial input to `f`
+-- @param[opt] n the number of times the iterator should run
+-- @return an iterator function
+function M.iterator(f, value, n)
+  local cnt = 0
 	return function()
-		x = f(x)
-		return x
+    cnt = cnt + 1
+    if n and cnt > n then return end
+		value = f(value)
+		return value
 	end
 end
 
---- Iterates an iterator and returns its values in an array.
+--- Iterates over an iterator and returns its values in an array.
+-- <br/><em>Aliased as `tabulate`</em>.
 -- @name array
--- @param ... an iterator (a function, a table and a value)
+-- @param ... an iterator function (returning a generator, a state and a value)
 -- @return an array of results
-function _.array(...)
+function M.array(...)
 	local r = {}
 	for v in ... do r[#r+1] = v end
 	return r
 end
 
+--- Casts vaue as an array if it is not one.
+-- @name castArray
+-- @param value a value
+-- @return an array containing the given value
+function M.castArray(value)
+  return (type(value)~='table') and {value} or value
+end
+
 --- Creates a function of `f` with arguments flipped in reverse order.
 -- @name flip
 -- @param f a function 
 -- @return a function
-function _.flip(f)
+function M.flip(f)
 	return function(...)
-		return f(unpack(_.reverse({...})))
+		return f(unpack(M.reverse({...})))
 	end
 end
 
+--- Returns a function that gets the nth argument. 
+-- If n is negative, the nth argument from the end is returned.
+-- @name nthArg
+-- @param n a number 
+-- @return a function
+function M.nthArg(n)
+  return function (...)
+    local args = {...}
+    return args[(n < 0) and (#args + n + 1) or n]
+  end
+end
+
+--- Returns a function which accepts up to one arg. It ignores any additional arguments.
+-- @name unary
+-- @param f a function
+-- @return a function
+-- @see ary
+function M.unary(f)
+  return function (...)
+    local args = {...}
+    return f(args[1])
+  end
+end
+
+--- Returns a function which accepts up to `n` args. It ignores any additional arguments.
+-- <br/><em>Aliased as `nAry`</em>.
+-- @name ary
+-- @param f a function
+-- @param[opt] n a number. Defaults to 1.
+-- @return a function
+-- @see unary
+function M.ary(f, n)
+  n = n or 1
+  return function (...)
+    local args = {...}
+    local fargs = {}
+    for i = 1, n do fargs[i] = args[i] end
+    return f(unpack(fargs))
+  end
+end
+
+--- Returns a function which runs with arguments rearranged. Arguments are passed to the 
+-- returned function in the order of supplied `indexes` at call-time.
+-- @name rearg
+-- @param f a function
+-- @param indexes an array list of indexes
+-- @return a function
+function M.rearg(f, indexes)
+  return function(...)
+    local args = {...}
+    local reargs = {}
+    for i, arg in ipairs(indexes) do reargs[i] = args[arg] end
+    return f(unpack(reargs))
+  end
+end
+
 --- Creates a function that runs transforms on all arguments it receives.
 -- @name over
 -- @param ... a set of functions which will receive all arguments to the returned function
@@ -1571,11 +2059,11 @@ end
 -- @see overEvery
 -- @see overSome
 -- @see overArgs
-function _.over(...)
+function M.over(...)
 	local transforms = {...}
 	return function(...)
 		local r = {}
-		for __,transform in ipairs(transforms) do
+		for i,transform in ipairs(transforms) do
 			r[#r+1] = transform(...)
 		end
 		return r
@@ -1590,10 +2078,10 @@ end
 -- @see over
 -- @see overSome
 -- @see overArgs
-function _.overEvery(...)
-	local f = _.over(...)
+function M.overEvery(...)
+	local f = M.over(...)
 	return function(...)
-		return _.reduce(f(...),function(state,v) return state and v end)
+		return M.reduce(f(...),function(state,v) return state and v end)
 	end
 end
 
@@ -1605,10 +2093,10 @@ end
 -- @see over
 -- @see overEvery
 -- @see overArgs
-function _.overSome(...)
-	local f = _.over(...)
+function M.overSome(...)
+	local f = M.over(...)
 	return function(...)
-		return _.reduce(f(...),function(state,v) return state or v end)
+		return M.reduce(f(...),function(state,v) return state or v end)
 	end
 end
 
@@ -1621,20 +2109,28 @@ end
 -- @see over
 -- @see overEvery
 -- @see overSome
-function _.overArgs(f,...)
+function M.overArgs(f,...)
 	local _argf = {...}
 	return function(...)
 		local _args = {...}
 		for i = 1,#_argf do
-			local f = _argf[i]
-			if _args[i] then _args[i] = f(_args[i]) end
+			local func = _argf[i]
+			if _args[i] then _args[i] = func(_args[i]) end
 		end
 		return f(unpack(_args))
 	end
 end
 
+--- Converges two functions into one.
+-- @name converge
+-- @param f a function
+-- @param g a function
+-- @param h a function
+-- @return a new version of function f 
+function M.converge(f, g, h) return function(...) return f(g(...),h(...)) end end
+
 --- Partially apply a function by filling in any number of its arguments. 
--- One may pass a string `'_'` as a placeholder in the list of arguments to specify an argument 
+-- One may pass a string `'M'` as a placeholder in the list of arguments to specify an argument 
 -- that should not be pre-filled, but left open to be supplied at call-time. 
 -- @name partial
 -- @param f a function
@@ -1642,15 +2138,15 @@ end
 -- @return a new version of function f having some of it original arguments filled
 -- @see partialRight
 -- @see curry
-function _.partial(f,...)
+function M.partial(f,...)
 	local partial_args = {...}
 	return function (...)
 		local n_args = {...}	
 		local f_args = {}
 		for k,v in ipairs(partial_args) do
-			f_args[k] = (v == '_') and _.pop(n_args) or v
+			f_args[k] = (v == '_') and M.shift(n_args) or v
 		end
-		return f(unpack(_.append(f_args,n_args)))
+		return f(unpack(M.append(f_args,n_args)))
 	end
 end
 
@@ -1661,15 +2157,15 @@ end
 -- @return a new version of function f having some of it original arguments filled
 -- @see partialRight
 -- @see curry
-function _.partialRight(f,...)
+function M.partialRight(f,...)
 	local partial_args = {...}
 	return function (...)
 		local n_args = {...}	
 		local f_args = {}
 		for k = 1,#partial_args do
-			f_args[k] = (partial_args[k] == '_') and _.pop(n_args) or partial_args[k]
+			f_args[k] = (partial_args[k] == '_') and M.shift(n_args) or partial_args[k]
 		end
-		return f(unpack(_.append(n_args, f_args)))
+		return f(unpack(M.append(n_args, f_args)))
 	end
 end
 
@@ -1682,7 +2178,7 @@ end
 -- @return a curried version of `f`
 -- @see partial
 -- @see partialRight
-function _.curry(f, n_args)
+function M.curry(f, n_args)
 	n_args = n_args or 2
 	local _args = {}
 	local function scurry(v)
@@ -1704,7 +2200,7 @@ end
 -- @param f a function
 -- @param[opt] ... optional args to `f`
 -- @return the execution time and the results of `f (...)`
-function _.time(f, ...)
+function M.time(f, ...)
 	local stime = clock()
 	local r = {f(...)}
 	return clock() - stime, unpack(r)
@@ -1717,43 +2213,58 @@ end
 -- @name keys
 -- @param obj an object
 -- @return an array
-function _.keys(obj)
-  local _oKeys = {}
-  _.each(obj,function(key) _oKeys[#_oKeys+1]=key end)
-  return _oKeys
+function M.keys(obj)
+  local keys = {}
+  for key in pairs(obj) do keys[#keys+1] = key end
+  return keys
 end
 
 --- Returns the values of the object properties.
 -- @name values
 -- @param obj an object
--- @return an array
-function _.values(obj)
-  local _oValues = {}
-  _.each(obj,function(_,value) _oValues[#_oValues+1]=value end)
-  return _oValues
+-- @return an array of values
+function M.values(obj)
+  local values = {}
+  for key, value in pairs(obj) do values[#values+1] = value end
+  return values
+end
+
+--- Returns the value at a given path in an object. 
+-- Path is given as a vararg list of keys.
+-- @name path
+-- @param obj an object
+-- @param ... a vararg list of keys
+-- @return a value or nil
+function M.path(obj, ...)
+  local value, path = obj, {...}
+  for i, p in ipairs(path) do
+    if (value[p] == nil) then return end
+    value = value[p]
+  end
+  return value
 end
 
---- Converts keys and values a an array-list of [k, v].
+--- Converts key-value pairs to an array-list of `[k, v]` pairs.
 -- @name kvpairs
 -- @param obj an object
--- @return an array list of key-values pairs
+-- @return an array list of key-value pairs
 -- @see toObj
-function _.kvpairs(obj)
+function M.kvpairs(obj)
 	local t = {}
-	_.each(obj, function(k,v) t[#t+1] = {k,v} end)
+	for k,v in pairs(obj) do t[#t+1] = {k,v} end
 	return t
 end
 
---- Converts an array list of `kvpairs` to an object. Keys are taken
--- from the 1rst column in the `kvpairs` sequence, associated with values in the 2nd
--- column
+--- Converts an array list of `[k,v]` pairs to an object. Keys are taken
+-- from the 1rst column in the `[k,v]` pairs sequence, associated with values in the 2nd
+-- column.
 -- @name toObj
--- @param kvpairs an array-list of `kvpairs`
+-- @param kvpairs an array-list of `[k,v]` pairs
 -- @return an object
 -- @see kvpairs
-function _.toObj(kvpairs)
+function M.toObj(kvpairs)
 	local obj = {}
-	for __, v in ipairs(kvpairs) do
+	for k, v in ipairs(kvpairs) do
 		obj[v[1]] = v[2]
 	end
 	return obj
@@ -1764,7 +2275,7 @@ end
 -- @param key a key property name
 -- @return a function which should accept an object as argument
 -- @see propertyOf
-function _.property(key)
+function M.property(key)
 	return function(obj) return obj[key] end
 end
 
@@ -1773,7 +2284,7 @@ end
 -- @param obj an object
 -- @return a function which should accept a key property argument
 -- @see property
-function _.propertyOf(obj)
+function M.propertyOf(obj)
 	return function(key) return obj[key] end
 end
 
@@ -1781,7 +2292,7 @@ end
 -- @name toBoolean
 -- @param value a value. Can be of any type
 -- @return `true` if value is true, `false` otherwise (false or nil).
-function _.toBoolean(value)
+function M.toBoolean(value)
   return not not value
 end
 
@@ -1792,15 +2303,13 @@ end
 -- @param destObj a destination object
 -- @param ... a list of objects
 -- @return the destination object extended
-function _.extend(destObj, ...)
+function M.extend(destObj, ...)
   local sources = {...}
-  _.each(sources,function(__,source)
-    if _.isTable(source) then
-      _.each(source,function(key,value)
-        destObj[key] = value
-      end)
+  for k, source in ipairs(sources) do
+    if type(source) == 'table' then
+      for key, value in pairs(source) do destObj[key] = value end
     end
-  end)
+  end
   return destObj
 end
 
@@ -1811,25 +2320,24 @@ end
 -- @name functions
 -- @param[opt] obj an object. Defaults to Moses library functions.
 -- @return an array-list of methods names
-function _.functions(obj, recurseMt)
-  obj = obj or _
+function M.functions(obj, recurseMt)
+  obj = obj or M
   local _methods = {}
-  _.each(obj,function(key,value)
-    if _.isFunction(value) then
-      _methods[#_methods+1]=key
+  for key, value in pairs(obj) do
+    if type(value) == 'function' then
+      _methods[#_methods+1] = key
     end
-  end)
-  if not recurseMt then 
-    return _.sort(_methods)
   end
-  local mt = getmetatable(obj)
-  if mt and mt.__index then
-    local mt_methods = _.functions(mt.__index)
-    _.each(mt_methods, function(k,fn)
-      _methods[#_methods+1] = fn
-    end)
+  if recurseMt then
+    local mt = getmetatable(obj)
+    if mt and mt.__index then
+      local mt_methods = M.functions(mt.__index, recurseMt)
+      for k, fn in ipairs(mt_methods) do
+        _methods[#_methods+1] = fn
+      end
+    end
   end
-  return _.sort(_methods)
+  return _methods
 end
 
 --- Clones a given object properties. If `shallow` is passed will also clone nested array properties.
@@ -1837,19 +2345,19 @@ end
 -- @param obj an object
 -- @param[opt] shallow whether or not nested array-properties should be cloned, defaults to false.
 -- @return a copy of the passed-in object
-function _.clone(obj, shallow)
-  if not _.isTable(obj) then return obj end
+function M.clone(obj, shallow)
+  if type(obj) ~= 'table' then return obj end
   local _obj = {}
-  _.each(obj,function(i,v)
-    if _.isTable(v) then
+  for i,v in pairs(obj) do
+    if type(v) == 'table' then
       if not shallow then
-        _obj[i] = _.clone(v,shallow)
+        _obj[i] = M.clone(v,shallow)
       else _obj[i] = v
       end
     else
       _obj[i] = v
     end
-  end)
+  end
   return _obj
 end
 
@@ -1861,7 +2369,7 @@ end
 -- @param f an interceptor function, should be prototyped as `f (obj, ...)`
 -- @param[opt] ... args to be passed to `f`
 -- @return the passed-in object
-function _.tap(obj, f, ...)
+function M.tap(obj, f, ...)
   f(obj,...)
   return obj
 end
@@ -1871,7 +2379,7 @@ end
 -- @param obj an object
 -- @param key a key property to be checked
 -- @return `true` or `false`
-function _.has(obj, key)
+function M.has(obj, key)
   return obj[key]~=nil
 end
 
@@ -1881,14 +2389,14 @@ end
 -- @param obj an object
 -- @param ... a variable number of string keys
 -- @return the filtered object
-function _.pick(obj, ...)
-  local whitelist = _.flatten {...}
+function M.pick(obj, ...)
+  local whitelist = M.flatten {...}
   local _picked = {}
-  _.each(whitelist,function(key,property)
-      if not _.isNil(obj[property]) then
-        _picked[property] = obj[property]
-      end
-    end)
+  for key, property in pairs(whitelist) do
+    if (obj[property])~=nil then
+      _picked[property] = obj[property]
+    end
+  end
   return _picked
 end
 
@@ -1898,14 +2406,14 @@ end
 -- @param obj an object
 -- @param ... a variable number of string keys
 -- @return the filtered object
-function _.omit(obj, ...)
-  local blacklist = _.flatten {...}
+function M.omit(obj, ...)
+  local blacklist = M.flatten {...}
   local _picked = {}
-  _.each(obj,function(key,value)
-      if not _.include(blacklist,key) then
-        _picked[key] = value
-      end
-    end)
+  for key, value in pairs(obj) do
+    if not M.include(blacklist,key) then
+      _picked[key] = value
+    end
+  end
   return _picked
 end
 
@@ -1913,12 +2421,13 @@ end
 -- <br/><em>Aliased as `defaults`</em>.
 -- @name template
 -- @param obj an object
--- @param[opt] template a template object. Defaults to an empty table `{}`.
+-- @param[opt] template a template object. If `nil`, leaves `obj` untouched.
 -- @return the passed-in object filled
-function _.template(obj, template)
-  _.each(template or {},function(i,v)
-  if not obj[i] then obj[i] = v end
-  end)
+function M.template(obj, template)
+  if not template then return obj end
+  for i, v in pairs(template) do
+    if not obj[i] then obj[i] = v end
+  end
   return obj
 end
 
@@ -1926,13 +2435,13 @@ end
 -- (by reference), nil, booleans. Compares tables by reference or by values. If `useMt` 
 -- is passed, the equality operator `==` will be used if one of the given objects has a 
 -- metatable implementing `__eq`.
--- <br/><em>Aliased as `_.compare`</em>
+-- <br/><em>Aliased as `M.compare`, `M.matches`</em>
 -- @name isEqual
 -- @param objA an object
 -- @param objB another object
 -- @param[opt] useMt whether or not `__eq` should be used, defaults to false.
 -- @return `true` or `false`
-function _.isEqual(objA, objB, useMt)
+function M.isEqual(objA, objB, useMt)
   local typeObjA = type(objA)
   local typeObjB = type(objB)
 
@@ -1948,16 +2457,16 @@ function _.isEqual(objA, objB, useMt)
     end
   end
 
-  if _.size(objA)~=_.size(objB) then return false end
-
-  for i,v1 in pairs(objA) do
-    local v2 = objB[i]
-    if _.isNil(v2) or not _.isEqual(v1,v2,useMt) then return false end
+  if M.size(objA)~=M.size(objB) then return false end
+  
+  local vB
+  for i,vA in pairs(objA) do
+    vB = objB[i]
+    if vB == nil or not M.isEqual(vA, vB, useMt) then return false end
   end
 
-  for i,v1 in pairs(objB) do
-    local v2 = objA[i]
-    if _.isNil(v2) then return false end
+  for i in pairs(objB) do
+    if objA[i] == nil then return false end
   end
 
   return true
@@ -1970,14 +2479,14 @@ end
 -- @param method a string key to index in object `obj`.
 -- @param[opt] ... Optional args to be passed to `method`
 -- @return the returned value of `method (obj, ...)` call
-function _.result(obj, method, ...)
+function M.result(obj, method, ...)
   if obj[method] then
-    if _.isCallable(obj[method]) then
+    if M.isCallable(obj[method]) then
       return obj[method](obj,...)
     else return obj[method]
     end
   end
-  if _.isCallable(method) then
+  if M.isCallable(method) then
     return method(obj,...)
   end
 end
@@ -1986,7 +2495,7 @@ end
 -- @name isTable
 -- @param t a value to be tested
 -- @return `true` or `false`
-function _.isTable(t)
+function M.isTable(t)
   return type(t) == 'table'
 end
 
@@ -1995,10 +2504,11 @@ end
 -- @name isCallable
 -- @param obj an object
 -- @return `true` or `false`
-function _.isCallable(obj)
-  return (_.isFunction(obj) or
-     (_.isTable(obj) and getmetatable(obj)
-                   and getmetatable(obj).__call~=nil) or false)
+function M.isCallable(obj)
+  return 
+    ((type(obj) == 'function') or
+    ((type(obj) == 'table') and getmetatable(obj) and getmetatable(obj).__call~=nil) or
+    false)
 end
 
 --- Checks if the given argument is an array. Assumes `obj` is an array
@@ -2006,14 +2516,14 @@ end
 -- @name isArray
 -- @param obj an object
 -- @return `true` or `false`
-function _.isArray(obj)
-  if not _.isTable(obj) then return false end
+function M.isArray(obj)
+  if not (type(obj) == 'table') then return false end
   -- Thanks @Wojak and @Enrique García Cota for suggesting this
   -- See : http://love2d.org/forums/viewtopic.php?f=3&t=77255&start=40#p163624
   local i = 0
-  for __ in pairs(obj) do
+  for k in pairs(obj) do
      i = i + 1
-     if _.isNil(obj[i]) then return false end
+     if obj[i] == nil then return false end
   end
   return true
 end
@@ -2022,8 +2532,8 @@ end
 -- @name isIterable
 -- @param obj an object
 -- @return `true` if the object can be iterated with `pairs` (or `ipairs`), `false` otherwise
-function _.isIterable(obj)
-  return _.toBoolean((pcall(pairs, obj)))
+function M.isIterable(obj)
+  return M.toBoolean((pcall(pairs, obj)))
 end
 
 --- Checks if the given pbject is empty. If `obj` is a string, will return `true`
@@ -2032,10 +2542,10 @@ end
 -- @name isEmpty
 -- @param[opt] obj an object
 -- @return `true` or `false`
-function _.isEmpty(obj)
-  if _.isNil(obj) then return true end
-  if _.isString(obj) then return #obj==0 end
-  if _.isTable(obj) then return next(obj)==nil end
+function M.isEmpty(obj)
+  if (obj == nil) then return true end
+  if type(obj) == 'string' then return #obj==0 end
+  if type(obj) == 'table' then return next(obj)==nil end
   return true
 end
 
@@ -2043,7 +2553,7 @@ end
 -- @name isString
 -- @param obj an object
 -- @return `true` or `false`
-function _.isString(obj)
+function M.isString(obj)
   return type(obj) == 'string'
 end
 
@@ -2051,7 +2561,7 @@ end
 -- @name isFunction
 -- @param obj an object
 -- @return `true` or `false`
-function _.isFunction(obj)
+function M.isFunction(obj)
    return type(obj) == 'function'
 end
 
@@ -2059,7 +2569,7 @@ end
 -- @name isNil
 -- @param obj an object
 -- @return `true` or `false`
-function _.isNil(obj)
+function M.isNil(obj)
   return obj==nil
 end
 
@@ -2068,7 +2578,7 @@ end
 -- @param obj an object
 -- @return `true` or `false`
 -- @see isNaN
-function _.isNumber(obj)
+function M.isNumber(obj)
   return type(obj) == 'number'
 end
 
@@ -2077,16 +2587,16 @@ end
 -- @param obj an object
 -- @return `true` or `false`
 -- @see isNumber
-function _.isNaN(obj)
-  return _.isNumber(obj) and obj~=obj
+function M.isNaN(obj)
+  return type(obj) == 'number' and obj~=obj
 end
 
 --- Checks if the given argument is a finite number.
 -- @name isFinite
 -- @param obj an object
 -- @return `true` or `false`
-function _.isFinite(obj)
-  if not _.isNumber(obj) then return false end
+function M.isFinite(obj)
+  if type(obj) ~= 'number' then return false end
   return obj > -huge and obj < huge
 end
 
@@ -2094,7 +2604,7 @@ end
 -- @name isBoolean
 -- @param obj an object
 -- @return `true` or `false`
-function _.isBoolean(obj)
+function M.isBoolean(obj)
   return type(obj) == 'boolean'
 end
 
@@ -2102,8 +2612,8 @@ end
 -- @name isInteger
 -- @param obj an object
 -- @return `true` or `false`
-function _.isInteger(obj)
-  return _.isNumber(obj) and floor(obj)==obj
+function M.isInteger(obj)
+  return type(obj) == 'number' and floor(obj)==obj
 end
 
 -- Aliases
@@ -2111,60 +2621,69 @@ end
 do
 
   -- Table functions aliases
-  _.forEach     = _.each
-  _.forEachi    = _.eachi
-  _.loop        = _.cycle
-  _.collect     = _.map
-  _.inject      = _.reduce
-  _.foldl       = _.reduce
-  _.injectr     = _.reduceRight
-  _.foldr       = _.reduceRight
-  _.mapr        = _.mapReduce
-  _.maprr       = _.mapReduceRight
-  _.any         = _.include
-  _.some        = _.include
-  _.contains    = _.include
-  _.filter      = _.select
-  _.discard     = _.reject
-  _.every       = _.all
+  M.forEach       = M.each
+  M.forEachi      = M.eachi
+  M.update        = M.adjust
+  M.loop          = M.cycle
+  M.collect       = M.map
+  M.inject        = M.reduce
+  M.foldl         = M.reduce
+  M.injectr       = M.reduceRight
+  M.foldr         = M.reduceRight
+  M.mapr          = M.mapReduce
+  M.maprr         = M.mapReduceRight
+  M.any           = M.include
+  M.some          = M.include
+  M.contains      = M.include
+  M.filter        = M.select
+  M.discard       = M.reject
+  M.every         = M.all
   
   -- Array functions aliases
-  _.takeWhile   = _.selectWhile
-  _.rejectWhile = _.dropWhile
-  _.shift       = _.pop
-  _.remove      = _.pull
-  _.rmRange     = _.removeRange
-  _.chop        = _.removeRange
-  _.sub         = _.slice
-  _.head        = _.first
-  _.take        = _.first
-  _.tail        = _.rest
-  _.skip        = _.last
-  _.without     = _.difference
-  _.diff        = _.difference
-  _.symdiff     = _.symmetricDifference
-  _.xor         = _.symmetricDifference
-  _.uniq        = _.unique
-  _.isuniq      = _.isunique
-	_.transpose   = _.zip
-  _.part        = _.partition
-  _.perm        = _.permutation
-  _.mirror      = _.invert
-  _.join        = _.concat
+  M.takeWhile     = M.selectWhile
+  M.rejectWhile   = M.dropWhile
+  M.pop           = M.shift
+  M.remove        = M.pull
+  M.rmRange       = M.removeRange
+  M.chop          = M.removeRange
+  M.sub           = M.slice
+  M.head          = M.first
+  M.take          = M.first
+  M.tail          = M.rest
+  M.skip          = M.last
+  M.without       = M.difference
+  M.diff          = M.difference
+  M.symdiff       = M.symmetricDifference
+  M.xor           = M.symmetricDifference
+  M.uniq          = M.unique
+  M.isuniq        = M.isunique
+	M.transpose     = M.zip
+  M.part          = M.partition
+  M.perm          = M.permutation
+  M.transposeWith = M.zipWith
+  M.intersperse   = M.interpose
+  M.sliding       = M.aperture
+  M.mirror        = M.invert
+  M.join          = M.concat
+  M.average       = M.mean
   
   -- Utility functions aliases
-  _.cache       = _.memoize
-  _.juxt        = _.juxtapose
-  _.uid         = _.uniqueId
-  _.iter        = _.iterator
-	
-  -- Object functions aliases
-  _.methods     = _.functions
-  _.choose      = _.pick
-  _.drop        = _.omit
-  _.defaults    = _.template
-  _.compare     = _.isEqual
+  M.always        = M.constant
+  M.cache         = M.memoize
+  M.juxt          = M.juxtapose
+  M.uid           = M.uniqueid
+  M.iter          = M.iterator
+	M.tabulate      = M.array
+  M.nAry          = M.ary
   
+  -- Object functions aliases
+  M.methods       = M.functions
+  M.choose        = M.pick
+  M.drop          = M.omit
+  M.defaults      = M.template
+  M.compare       = M.isEqual
+  M.matches       = M.isEqual
+
 end
 
 -- Setting chaining and building interface
@@ -2175,27 +2694,26 @@ do
   local f = {}
 
   -- Will be returned upon requiring, indexes into the wrapper
-  local __ = {}
-  __.__index = f
+  local Moses = {}
+  Moses.__index = f
 
   -- Wraps a value into an instance, and returns the wrapped object
   local function new(value)
-    local i = {_value = value, _wrapped = true}
-    return setmetatable(i, __)
+    return setmetatable({_value = value, _wrapped = true}, Moses)
   end
 
-  setmetatable(__,{
+  setmetatable(Moses,{
     __call  = function(self,v) return new(v) end, -- Calls returns to instantiation
     __index = function(t,key,...) return f[key] end  -- Redirects to the wrapper
   })
 
   --- Returns a wrapped object. Calling library functions as methods on this object
-  -- will continue to return wrapped objects until @{obj:value} is used. Can be aliased as `_(value)`.
+  -- will continue to return wrapped objects until @{obj:value} is used. Can be aliased as `M(value)`.
   -- @class function
   -- @name chain
   -- @param value a value to be wrapped
   -- @return a wrapped object
-  function __.chain(value)
+  function Moses.chain(value)
     return new(value)
   end
 
@@ -2203,53 +2721,59 @@ do
   -- @class function
   -- @name obj:value
   -- @return the value previously wrapped
-  function __:value()
+  function Moses:value()
     return self._value
   end
 
   -- Register chaining methods into the wrapper
-  f.chain, f.value = __.chain, __.value
+  f.chain, f.value = Moses.chain, Moses.value
 
   -- Register all functions into the wrapper
-  for fname,fct in pairs(_) do
-    f[fname] = function(v, ...)
-      local wrapped = _.isTable(v) and v._wrapped or false
-      if wrapped then
-        local _arg = v._value
-        local _rslt = fct(_arg,...)
-        return new(_rslt)
-      else
-        return fct(v,...)
+  for fname,fct in pairs(M) do
+    if fname ~= 'operator' then -- Prevents from wrapping op functions
+      f[fname] = function(v, ...)
+        local wrapped = type(v) == 'table' and rawget(v,'_wrapped') or false
+        if wrapped then
+          local _arg = v._value
+          local _rslt = fct(_arg,...)
+          return new(_rslt)
+        else
+          return fct(v,...)
+        end
       end
     end
   end
+  
+  -- Exports all op functions
+  f.operator = M.operator
+  f.op       = M.operator
 
   --- Imports all library functions into a context.
   -- @name import
-  -- @param[opt] context a context. Defaults to `_G` (global environment) when not given.
-  -- @param[optchain] noConflict if supplied, will not import functions having a key existing in the destination context.
+  -- @param[opt] context a context. Defaults to `_ENV or `_G`` (current environment).
+  -- @param[optchain] noConflict if supplied, will not import conflicting functions in the destination context.
   -- @return the passed-in context
   f.import = function(context, noConflict)
     context = context or _ENV or _G
-    local funcs = _.functions()
-    _.each(funcs, function(k, fname)  
-      if rawget(context, fname) then
+    local funcs = M.functions()
+    for k, fname in ipairs(funcs) do
+      if rawget(context, fname)~= nil then
         if not noConflict then
-          context[fname] = _[fname]        
+          rawset(context, fname, M[fname])
         end
       else
-        context[fname] = _[fname]
+        rawset(context, fname, M[fname])
       end
-    end)
+    end
     return context
   end
 
   -- Descriptive tags
-  __._VERSION     = 'Moses v'.._MODULEVERSION
-  __._URL         = 'http://github.com/Yonaba/Moses'
-  __._LICENSE     = 'MIT <http://raw.githubusercontent.com/Yonaba/Moses/master/LICENSE>'
-  __._DESCRIPTION = 'utility-belt library for functional programming in Lua'
-  
-  return __
+  Moses._VERSION     = 'Moses v'.._MODULEVERSION
+  Moses._URL         = 'http://github.com/Yonaba/Moses'
+  Moses._LICENSE     = 'MIT <http://raw.githubusercontent.com/Yonaba/Moses/master/LICENSE>'
+  Moses._DESCRIPTION = 'utility-belt library for functional programming in Lua'
   
+  return Moses
+
 end
diff -pruN 1.6.1+git20170613-2/moses_min.lua 2.0.0-3/moses_min.lua
--- 1.6.1+git20170613-2/moses_min.lua	2017-06-03 16:42:55.000000000 +0000
+++ 2.0.0-3/moses_min.lua	2018-08-23 16:26:20.000000000 +0000
@@ -1,364 +1,511 @@
-local _ba='1.6.1'local aba,bba,cba,dba=next,type,select,pcall;local _ca,aca=setmetatable,getmetatable
-local bca,cca=table.insert,table.sort;local dca,_da=table.remove,table.concat
-local ada,bda,cda=math.randomseed,math.random,math.huge;local dda,__b,a_b=math.floor,math.max,math.min;local b_b=rawget
-local c_b=table.unpack or unpack;local d_b,_ab=pairs,ipairs;local aab=os.clock;local bab={}
-local function cab(dcb,_db)return dcb>_db end;local function dab(dcb,_db)return dcb<_db end
-local function _bb(dcb,_db,adb)return(dcb<_db)and _db or
-(dcb>adb and adb or dcb)end;local function abb(dcb,_db)return _db and true end
-local function bbb(dcb)return not dcb end
-local function cbb(dcb)local _db=0;for adb,bdb in d_b(dcb)do _db=_db+1 end;return _db end
-local function dbb(dcb,_db,adb,...)local bdb;local cdb=adb or bab.identity;for ddb,__c in d_b(dcb)do
-if not bdb then bdb=cdb(__c,...)else
-local a_c=cdb(__c,...)bdb=_db(bdb,a_c)and bdb or a_c end end;return bdb end
-local function _cb(dcb,_db,adb,bdb)for i=0,#dcb,_db do local cdb=bab.slice(dcb,i+1,i+_db)
-if#cdb>0 then while
-(#cdb<_db and bdb)do cdb[#cdb+1]=bdb end;adb(cdb)end end end
-local function acb(dcb,_db,adb,bdb)
-for i=0,#dcb,_db-1 do local cdb=bab.slice(dcb,i+1,i+_db)if
-#cdb>0 and i+1 <#dcb then while(#cdb<_db and bdb)do cdb[#cdb+1]=bdb end
-adb(cdb)end end end
-local function bcb(dcb,_db,adb)if _db==0 then adb(dcb)end
-for i=1,_db do dcb[_db],dcb[i]=dcb[i],dcb[_db]bcb(dcb,_db-
-1,adb)dcb[_db],dcb[i]=dcb[i],dcb[_db]end end;local ccb=-1
-function bab.clear(dcb)for _db in d_b(dcb)do dcb[_db]=nil end;return dcb end
-function bab.each(dcb,_db,...)for adb,bdb in d_b(dcb)do _db(adb,bdb,...)end end
-function bab.eachi(dcb,_db,...)
-local adb=bab.sort(bab.select(bab.keys(dcb),function(bdb,cdb)return bab.isInteger(cdb)end))for bdb,cdb in _ab(adb)do _db(cdb,dcb[cdb],...)end end
-function bab.at(dcb,...)local _db={}for adb,bdb in _ab({...})do
-if bab.has(dcb,bdb)then _db[#_db+1]=dcb[bdb]end end;return _db end
-function bab.count(dcb,_db)if bab.isNil(_db)then return bab.size(dcb)end;local adb=0
-bab.each(dcb,function(bdb,cdb)if
-bab.isEqual(cdb,_db)then adb=adb+1 end end)return adb end
-function bab.countf(dcb,_db,...)return bab.count(bab.map(dcb,_db,...),true)end
-function bab.cycle(dcb,_db)_db=_db or 1;if _db<=0 then return bab.noop end;local adb,bdb;local cdb=0
+local SWFtRywD='2.0.0'local e,v,l6Sm5=next,type,pcall;local oUA,QFKEzBf=setmetatable,getmetatable
+local odpE,p=table.insert,table.sort;local lIpFkbLI,JdUtcU=table.remove,table.concat
+local GQLN,toXyq,S9TO=math.randomseed,math.random,math.huge;local pS78Y,BCf7,RlMSrmdD,VCD=math.floor,math.max,math.min,math.ceil
+local OV7=coroutine.wrap;local X83a=coroutine.yield;local PizLA9mj=rawget
+local hUL=table.unpack or unpack;local l,kyWtqIf0=pairs,ipairs;local zupvsz=error;local Mw=os.clock;local S1wg_DG={}local function sf0(cmWo_v,RoXZEsn)
+return cmWo_v>RoXZEsn end
+local function qxZa6ozV(BKLwtAVx,BMZNmf0)return BKLwtAVx<BMZNmf0 end
+local function hgW2H5(qL9C)local Colg=0;for ex2xo17,I in l(qL9C)do Colg=Colg+1 end;return Colg end
+local function z5i2i(K66,Tq,jmB,...)jmB=jmB or S1wg_DG.identity;local bjO;for QoYPziln,Hj in l(K66)do
+if not bjO then bjO=jmB(Hj,...)else
+local KBlIVi=jmB(Hj,...)bjO=Tq(bjO,KBlIVi)and bjO or KBlIVi end end;return bjO end
+local function MGSnnzOI(OR8it1,GAqAsa,Oc_,Qj)
+for Ybp8=0,#OR8it1,GAqAsa do
+local ZmzyNm=S1wg_DG.slice(OR8it1,Ybp8+1,Ybp8+GAqAsa)
+if#ZmzyNm>0 then while(#ZmzyNm<GAqAsa and Qj)do
+ZmzyNm[#ZmzyNm+1]=Qj end;Oc_(ZmzyNm)end end end
+local function B0o5xpg7(akG0mUnS,iy,gc7SaW,FnbJWd2)
+for cpdLk=0,#akG0mUnS,iy-1 do
+local FbQX=S1wg_DG.slice(akG0mUnS,cpdLk+1,cpdLk+iy)if#FbQX>0 and cpdLk+1 <#akG0mUnS then while
+(#FbQX<iy and FnbJWd2)do FbQX[#FbQX+1]=FnbJWd2 end
+gc7SaW(FbQX)end end end
+local function VQT(ejMVLYZd,eS0X,XDQS4ASf,IiNU)
+for gUfudNUg=0,#ejMVLYZd,1 do
+local d3=S1wg_DG.slice(ejMVLYZd,gUfudNUg+1,gUfudNUg+eS0X)
+if#d3 >0 and gUfudNUg+eS0X<=#ejMVLYZd then while
+(#d3 <eS0X and IiNU)do d3[#d3+1]=IiNU end;XDQS4ASf(d3)end end end
+local function Id(gTOcAHv,vY_4HT1n,DzPbzg)if vY_4HT1n==0 then DzPbzg(gTOcAHv)end
+for UMD=1,vY_4HT1n do
+gTOcAHv[vY_4HT1n],gTOcAHv[UMD]=gTOcAHv[UMD],gTOcAHv[vY_4HT1n]Id(gTOcAHv,vY_4HT1n-1,DzPbzg)
+gTOcAHv[vY_4HT1n],gTOcAHv[UMD]=gTOcAHv[UMD],gTOcAHv[vY_4HT1n]end end;local function Ub(K3ZE7Ou)return K3ZE7Ou>=0 and 1 or-1 end
+local qJExeUn2=-1;S1wg_DG.operator={}
+S1wg_DG.operator.add=function(fBI,wMSY)return fBI+wMSY end
+S1wg_DG.operator.sub=function(_nD2rl,aVh8xSly)return _nD2rl-aVh8xSly end
+S1wg_DG.operator.mul=function(i,P_NNVDyt)return i*P_NNVDyt end
+S1wg_DG.operator.div=function(cVEyN,uj2AiF)return cVEyN/uj2AiF end
+S1wg_DG.operator.mod=function(W,lbHN2)return W%lbHN2 end
+S1wg_DG.operator.exp=function(PwgW3lfq,z)return PwgW3lfq^z end;S1wg_DG.operator.pow=S1wg_DG.operator.exp;S1wg_DG.operator.unm=function(K)return
+-K end
+S1wg_DG.operator.neg=S1wg_DG.operator.unm
+S1wg_DG.operator.floordiv=function(xx,aYb)return pS78Y(xx/aYb)end
+S1wg_DG.operator.intdiv=function(JM2,bmAjLT)return JM2 >=0 and pS78Y(JM2/bmAjLT)or
+VCD(JM2/bmAjLT)end
+S1wg_DG.operator.eq=function(eExYnwnh,XMBmJyiP)return eExYnwnh==XMBmJyiP end
+S1wg_DG.operator.neq=function(nowqEU6m,iKD8V)return nowqEU6m~=iKD8V end
+S1wg_DG.operator.lt=function(YtRS,A)return YtRS<A end
+S1wg_DG.operator.gt=function(mHJ,Q57BJ)return mHJ>Q57BJ end
+S1wg_DG.operator.le=function(vM,JeGCDX)return vM<=JeGCDX end
+S1wg_DG.operator.ge=function(A,UFZlp)return A>=UFZlp end
+S1wg_DG.operator.land=function(VsrKM,uhIq)return VsrKM and uhIq end
+S1wg_DG.operator.lor=function(EEOUzhy,hbrt)return EEOUzhy or hbrt end;S1wg_DG.operator.lnot=function(D)return not D end;S1wg_DG.operator.concat=function(Q,mRqle)return
+Q..mRqle end;S1wg_DG.operator.length=function(sBEZ8)return
+#sBEZ8 end
+S1wg_DG.operator.len=S1wg_DG.operator.length;function S1wg_DG.clear(WhHB0ygh)for rYSD0 in l(WhHB0ygh)do WhHB0ygh[rYSD0]=nil end
+return WhHB0ygh end
+function S1wg_DG.each(BIL5,GQLlkH,...)for aN4J2zRQ,eWca in l(BIL5)do
+GQLlkH(eWca,aN4J2zRQ,...)end end
+function S1wg_DG.eachi(AGUR2QK,FK,...)
+local _=S1wg_DG.sort(S1wg_DG.select(S1wg_DG.keys(AGUR2QK),S1wg_DG.isInteger))
+for YQZ729qQ,rZh2wG in kyWtqIf0(_)do FK(AGUR2QK[rZh2wG],rZh2wG,...)end end;function S1wg_DG.at(sef4eW6Q,...)local Z={}
+for UacO6D,FdnzjW in kyWtqIf0({...})do Z[#Z+1]=sef4eW6Q[FdnzjW]end;return Z end
+function S1wg_DG.adjust(o,lMAL,CpQ,...)
+if(
+o[lMAL]==nil)then zupvsz("key not existing in table")end;local L=S1wg_DG.clone(o)L[lMAL]=
+v(CpQ)=='function'and CpQ(L[lMAL],...)or CpQ;return L end
+function S1wg_DG.count(HnQS_Z,rib)
+if rib==nil then return S1wg_DG.size(HnQS_Z)end;local hgW2H5=0;for w,YT6wZ in l(HnQS_Z)do
+if S1wg_DG.isEqual(YT6wZ,rib)then hgW2H5=hgW2H5+1 end end;return hgW2H5 end
+function S1wg_DG.countf(VYv,gU,...)local hgW2H5=0;for JzG8W4Ya,dZ54oc in l(VYv)do
+if gU(dZ54oc,JzG8W4Ya,...)then hgW2H5=hgW2H5+1 end end;return hgW2H5 end
+function S1wg_DG.cycle(v_LoR,gRY)gRY=gRY or 1;if gRY<=0 then return S1wg_DG.noop end;local z,ad
+local Ui0Qa=0
 while true do
 return
-function()adb=adb and
-aba(dcb,adb)or aba(dcb)
-bdb=not bdb and adb or bdb;if _db then cdb=(adb==bdb)and cdb+1 or cdb
-if cdb>_db then return end end;return adb,dcb[adb]end end end
-function bab.map(dcb,_db,...)local adb={}
-for bdb,cdb in d_b(dcb)do local ddb,__c,a_c=bdb,_db(bdb,cdb,...)adb[a_c and __c or ddb]=
-a_c or __c end;return adb end;function bab.reduce(dcb,_db,adb)
-for bdb,cdb in d_b(dcb)do if adb==nil then adb=cdb else adb=_db(adb,cdb)end end;return adb end;function bab.reduceby(dcb,_db,adb,bdb,...)return
-bab.reduce(bab.select(dcb,bdb,...),_db,adb)end;function bab.reduceRight(dcb,_db,adb)return
-bab.reduce(bab.reverse(dcb),_db,adb)end
-function bab.mapReduce(dcb,_db,adb)
-local bdb={}for cdb,ddb in d_b(dcb)do bdb[cdb]=not adb and ddb or _db(adb,ddb)
-adb=bdb[cdb]end;return bdb end;function bab.mapReduceRight(dcb,_db,adb)
-return bab.mapReduce(bab.reverse(dcb),_db,adb)end
-function bab.include(dcb,_db)local adb=
-bab.isFunction(_db)and _db or bab.isEqual;for bdb,cdb in d_b(dcb)do if adb(cdb,_db)then
-return true end end;return false end
-function bab.detect(dcb,_db)
-local adb=bab.isFunction(_db)and _db or bab.isEqual;for bdb,cdb in d_b(dcb)do if adb(cdb,_db)then return bdb end end end
-function bab.where(dcb,_db)
-local adb=bab.select(dcb,function(bdb,cdb)
-for ddb in d_b(_db)do if cdb[ddb]~=_db[ddb]then return false end end;return true end)return#adb>0 and adb or nil end
-function bab.findWhere(dcb,_db)
-local adb=bab.detect(dcb,function(bdb)for cdb in d_b(_db)do
-if _db[cdb]~=bdb[cdb]then return false end end;return true end)return adb and dcb[adb]end
-function bab.select(dcb,_db,...)local adb={}for bdb,cdb in d_b(dcb)do
-if _db(bdb,cdb,...)then adb[#adb+1]=cdb end end;return adb end
-function bab.reject(dcb,_db,...)local adb=bab.map(dcb,_db,...)local bdb={}for cdb,ddb in d_b(adb)do if not ddb then
-bdb[#bdb+1]=dcb[cdb]end end;return bdb end
-function bab.all(dcb,_db,...)return( (#bab.select(bab.map(dcb,_db,...),abb))==
-cbb(dcb))end
-function bab.invoke(dcb,_db,...)local adb={...}
+function()z=z and e(v_LoR,z)or e(v_LoR)
+ad=not ad and z or ad;if gRY then Ui0Qa=(z==ad)and Ui0Qa+1 or Ui0Qa
+if Ui0Qa>gRY then return end end;return v_LoR[z],z end end end
+function S1wg_DG.map(g,Itx,...)local JpoaGH={}for cyAcCT,RCA in l(g)do local L46S,GKTYT,hXSTz8FJ=cyAcCT,Itx(RCA,cyAcCT,...)
+JpoaGH[hXSTz8FJ and
+GKTYT or L46S]=hXSTz8FJ or GKTYT end
+return JpoaGH end;function S1wg_DG.reduce(C24r7o4G,b_4Q38cU,N)
+for JbPw,j in l(C24r7o4G)do if N==nil then N=j else N=b_4Q38cU(N,j)end end;return N end
+function S1wg_DG.reduceby(S,cg4FV7bl,flf9sWX,uNoS,...)return
+S1wg_DG.reduce(S1wg_DG.select(S,flf9sWX,...),cg4FV7bl,uNoS)end
+function S1wg_DG.reduceRight(ZWoH9V08,RWo,GWBQL)return
+S1wg_DG.reduce(S1wg_DG.reverse(ZWoH9V08),RWo,GWBQL)end
+function S1wg_DG.mapReduce(PCldTUn9,sO_,ALbdmINL)local b={}
+for DUgF0E,vGxJ6f in l(PCldTUn9)do b[DUgF0E]=not ALbdmINL and vGxJ6f or
+sO_(ALbdmINL,vGxJ6f)ALbdmINL=b[DUgF0E]end;return b end
+function S1wg_DG.mapReduceRight(a4ga2I,syGyB_,VO)return
+S1wg_DG.mapReduce(S1wg_DG.reverse(a4ga2I),syGyB_,VO)end
+function S1wg_DG.include(J1r,iBcU3_7D)local N=(v(iBcU3_7D)=='function')and iBcU3_7D or
+S1wg_DG.isEqual;for M4V,_feve in l(J1r)do if
+N(_feve,iBcU3_7D)then return true end end;return false end
+function S1wg_DG.detect(OPz_7bk,H64aD)
+local ny7=(v(H64aD)=='function')and H64aD or S1wg_DG.isEqual
+for QDj6GAX,k6pXzd in l(OPz_7bk)do if ny7(k6pXzd,H64aD)then return QDj6GAX end end end
+function S1wg_DG.where(hsLwu,R)
+local JKZ=S1wg_DG.select(hsLwu,function(yHbsh)for d4z in l(R)do
+if yHbsh[d4z]~=R[d4z]then return false end end;return true end)return#JKZ>0 and JKZ or nil end
+function S1wg_DG.findWhere(i,HyEk4lbh)
+local PhU=S1wg_DG.detect(i,function(rWwbNge)for SKxD in l(HyEk4lbh)do if HyEk4lbh[SKxD]~=rWwbNge[SKxD]then
+return false end end
+return true end)return PhU and i[PhU]end
+function S1wg_DG.select(o3uQKvJ,vAZm,...)local q={}for fFuE,KypMW in l(o3uQKvJ)do
+if vAZm(KypMW,fFuE,...)then q[#q+1]=KypMW end end;return q end
+function S1wg_DG.reject(JJT4nKO,TFLF,...)local hEoAa={}
+for PGN,K2_kF5 in l(JJT4nKO)do if not TFLF(K2_kF5,PGN,...)then
+hEoAa[#hEoAa+1]=K2_kF5 end end;return hEoAa end
+function S1wg_DG.all(YpimJ,Gg7Ttui,...)for _,EGeAf in l(YpimJ)do
+if not Gg7Ttui(EGeAf,_,...)then return false end end;return true end
+function S1wg_DG.invoke(ymP,z5pHKyoa,...)local h={...}
 return
-bab.map(dcb,function(bdb,cdb)
-if bab.isTable(cdb)then
-if bab.has(cdb,_db)then
+S1wg_DG.map(ymP,function(xwT)
+if(v(xwT)=='table')then
+if xwT[z5pHKyoa]then
 if
-bab.isCallable(cdb[_db])then return cdb[_db](cdb,c_b(adb))else return cdb[_db]end else
-if bab.isCallable(_db)then return _db(cdb,c_b(adb))end end elseif bab.isCallable(_db)then return _db(cdb,c_b(adb))end end)end
-function bab.pluck(dcb,_db)return
-bab.reject(bab.map(dcb,function(adb,bdb)return bdb[_db]end),bbb)end;function bab.max(dcb,_db,...)return dbb(dcb,cab,_db,...)end;function bab.min(dcb,_db,...)return
-dbb(dcb,dab,_db,...)end
-function bab.shuffle(dcb,_db)if _db then ada(_db)end
-local adb={}
-bab.each(dcb,function(bdb,cdb)local ddb=dda(bda()*bdb)+1;adb[bdb]=adb[ddb]
-adb[ddb]=cdb end)return adb end
-function bab.same(dcb,_db)
+S1wg_DG.isCallable(xwT[z5pHKyoa])then return xwT[z5pHKyoa](xwT,hUL(h))else return xwT[z5pHKyoa]end else
+if S1wg_DG.isCallable(z5pHKyoa)then return z5pHKyoa(xwT,hUL(h))end end elseif S1wg_DG.isCallable(z5pHKyoa)then return z5pHKyoa(xwT,hUL(h))end end)end
+function S1wg_DG.pluck(y33ux,Ut)local GOijBp={}for oUi,b2a3 in l(y33ux)do if b2a3[Ut]then
+GOijBp[#GOijBp+1]=b2a3[Ut]end end;return GOijBp end
+function S1wg_DG.max(xer,SQHAAR,...)return z5i2i(xer,sf0,SQHAAR,...)end
+function S1wg_DG.min(qybRcP1,z,...)return z5i2i(qybRcP1,qxZa6ozV,z,...)end
+function S1wg_DG.same(N0NaR,FBfW)
 return
-bab.all(dcb,function(adb,bdb)return bab.include(_db,bdb)end)and
-bab.all(_db,function(adb,bdb)return bab.include(dcb,bdb)end)end;function bab.sort(dcb,_db)cca(dcb,_db)return dcb end
-function bab.sortBy(dcb,_db,adb)
-local bdb=_db or bab.identity
-if bab.isString(_db)then bdb=function(ddb)return ddb[_db]end end;adb=adb or dab;local cdb={}
-bab.each(dcb,function(ddb,__c)
-cdb[#cdb+1]={value=__c,transform=bdb(__c)}end)
-cca(cdb,function(ddb,__c)return adb(ddb.transform,__c.transform)end)return bab.pluck(cdb,'value')end
-function bab.groupBy(dcb,_db,...)local adb={...}local bdb={}
-bab.each(dcb,function(cdb,ddb)local __c=_db(cdb,ddb,c_b(adb))
+S1wg_DG.all(N0NaR,function(lnM4)return S1wg_DG.include(FBfW,lnM4)end)and
+S1wg_DG.all(FBfW,function(_oDmX_)return S1wg_DG.include(N0NaR,_oDmX_)end)end;function S1wg_DG.sort(tK,ppm021I)p(tK,ppm021I)return tK end
+function S1wg_DG.sortBy(ASUXhD,KCm,u)local fDk=KCm or
+S1wg_DG.identity;if(v(KCm)=='string')then
+fDk=function(ASUXhD)return ASUXhD[KCm]end end;u=u or qxZa6ozV
+p(ASUXhD,function(gxYY,sVMxk)return
+u(fDk(gxYY),fDk(sVMxk))end)return ASUXhD end
+function S1wg_DG.groupBy(SyD,v4,...)local j7siW={...}local Hl={}
+for AP060rq,DIEKD10 in l(SyD)do
+local lLJ=v4(DIEKD10,AP060rq,hUL(j7siW))if Hl[lLJ]then Hl[lLJ][#Hl[lLJ]+1]=DIEKD10 else
+Hl[lLJ]={DIEKD10}end end;return Hl end
+function S1wg_DG.countBy(EicsS,JubU,...)local L={}for JKci,SsBe in l(EicsS)do local o=JubU(SsBe,JKci,...)
+L[o]=(L[o]or 0)+1 end;return L end
+function S1wg_DG.size(...)local ZOmcmO={...}local _G19JrRB=ZOmcmO[1]return
+
+(v(_G19JrRB)=='table')and hgW2H5(ZOmcmO[1])or hgW2H5(ZOmcmO)end;function S1wg_DG.containsKeys(m0r3_J,MLrs)
+for hP5 in l(MLrs)do if not m0r3_J[hP5]then return false end end;return true end
+function S1wg_DG.sameKeys(oqjhEZb0,Pha)for G in
+l(oqjhEZb0)do if not Pha[G]then return false end end
+for MOrzq4 in l(Pha)do if not
+oqjhEZb0[MOrzq4]then return false end end;return true end
+function S1wg_DG.sample(bEMp,dd,MOQN)dd=dd or 1;if dd==0 then return{}end
+if dd==1 then
+if MOQN then GQLN(MOQN)end;return{bEMp[toXyq(1,#bEMp)]}end
+return S1wg_DG.slice(S1wg_DG.shuffle(bEMp,MOQN),1,dd)end
+function S1wg_DG.sampleProb(O,FEpet,P)if P then GQLN(P)end;local G={}for EcLLM,wo in kyWtqIf0(O)do if toXyq()<FEpet then
+G[#G+1]=wo end end;return G end
+function S1wg_DG.shuffle(ur,XTX)if XTX then GQLN(XTX)end;local wc8hjKp1={}for f,Hjag in kyWtqIf0(ur)do local Yg=
+pS78Y(toXyq()*f)+1;wc8hjKp1[f]=wc8hjKp1[Yg]
+wc8hjKp1[Yg]=Hjag end;return wc8hjKp1 end;function S1wg_DG.toArray(...)return{...}end;function S1wg_DG.find(uc,bw,ad)
+for EG344W=ad or 1,#uc do if
+S1wg_DG.isEqual(uc[EG344W],bw)then return EG344W end end end;function S1wg_DG.reverse(MVlUhPEM)
+local LT={}
+for pfiWYrg=#MVlUhPEM,1,-1 do LT[#LT+1]=MVlUhPEM[pfiWYrg]end;return LT end
+function S1wg_DG.fill(smnX9H6,FzRhHR,mMBxOoQa,xYSLIT)xYSLIT=
+xYSLIT or S1wg_DG.size(smnX9H6)for mMBxOoQa=mMBxOoQa or 1,xYSLIT do
+smnX9H6[mMBxOoQa]=FzRhHR end;return smnX9H6 end
+function S1wg_DG.zeros(Eae7ILmk)return S1wg_DG.fill({},0,1,Eae7ILmk)end
+function S1wg_DG.ones(Jy23ZRAA)return S1wg_DG.fill({},1,1,Jy23ZRAA)end
+function S1wg_DG.vector(V8IWw,uyYdf)return S1wg_DG.fill({},V8IWw,1,uyYdf)end
+function S1wg_DG.selectWhile(K,ZX,...)local tbdC={}for VaY3,HK7Mbgze in kyWtqIf0(K)do
+if ZX(HK7Mbgze,VaY3,...)then tbdC[VaY3]=HK7Mbgze else break end end;return tbdC end
+function S1wg_DG.dropWhile(VXPfx,j3Qk,...)local X1;for GpruB,r in kyWtqIf0(VXPfx)do
+if not j3Qk(r,GpruB,...)then X1=GpruB;break end end;if(X1 ==nil)then return{}end;return
+S1wg_DG.rest(VXPfx,X1)end
+function S1wg_DG.sortedIndex(V7YqV,JbvH7,Cqk9Luq,PeAP9X)local vN5AF9=Cqk9Luq or qxZa6ozV;if(PeAP9X==true)then
+p(V7YqV,vN5AF9)end;for j=1,#V7YqV do
+if not vN5AF9(V7YqV[j],JbvH7)then return j end end;return#V7YqV+1 end;function S1wg_DG.indexOf(EOgmP,j)
+for mJof=1,#EOgmP do if EOgmP[mJof]==j then return mJof end end end
+function S1wg_DG.lastIndexOf(yz1Kuwby,KVE6TG)
+local YY=S1wg_DG.indexOf(S1wg_DG.reverse(yz1Kuwby),KVE6TG)if YY then return#yz1Kuwby-YY+1 end end;function S1wg_DG.findIndex(r9,mtUG,...)
+for PFRuf=1,#r9 do if mtUG(r9[PFRuf],PFRuf,...)then return PFRuf end end end
+function S1wg_DG.findLastIndex(KhK1gRj9,Xgj,...)
+local Ko=S1wg_DG.findIndex(S1wg_DG.reverse(KhK1gRj9),Xgj,...)if Ko then return#KhK1gRj9-Ko+1 end end;function S1wg_DG.addTop(A,...)
+for IU6Om,sKIIqz in kyWtqIf0({...})do odpE(A,1,sKIIqz)end;return A end;function S1wg_DG.prepend(wmhARqEa,...)return
+S1wg_DG.append({...},wmhARqEa)end;function S1wg_DG.push(_RT3,...)
+local V={...}
+for BTA,QVEYENaX in kyWtqIf0({...})do _RT3[#_RT3+1]=QVEYENaX end;return _RT3 end
+function S1wg_DG.shift(gxqa,q4)q4=RlMSrmdD(
+q4 or 1,#gxqa)local QyKi={}for _o3FE=1,q4 do local n=gxqa[1]
+QyKi[#QyKi+1]=n;lIpFkbLI(gxqa,1)end;return hUL(QyKi)end
+function S1wg_DG.unshift(WM,zb8b)zb8b=RlMSrmdD(zb8b or 1,#WM)local YBqeh={}
+for WRkIg=1,zb8b do
+local RH_vLUg=WM[#WM]YBqeh[#YBqeh+1]=RH_vLUg;lIpFkbLI(WM)end;return hUL(YBqeh)end
+function S1wg_DG.pull(aEH,...)
+for g20N7,puZN in kyWtqIf0({...})do for _Dy=#aEH,1,-1 do if S1wg_DG.isEqual(aEH[_Dy],puZN)then
+lIpFkbLI(aEH,_Dy)end end end;return aEH end
+function S1wg_DG.removeRange(MC,WOBSVeqF,A)WOBSVeqF=WOBSVeqF or 1;A=A or#MC;if WOBSVeqF>A then
+zupvsz("start cannot be greater than finish.")end
+for vqW6=A,WOBSVeqF,-1 do lIpFkbLI(MC,vqW6)end;return MC end
+function S1wg_DG.chunk(R4oRlgh,rBRXA,...)local qfFSJN,Va8fT08T,d778,aZT={},0
+for ni9je9bJ,uwwNE in kyWtqIf0(R4oRlgh)do
+aZT=rBRXA(uwwNE,ni9je9bJ,...)d778=(d778 ==nil)and aZT or d778
+Va8fT08T=(
+(aZT~=d778)and(Va8fT08T+1)or Va8fT08T)if not qfFSJN[Va8fT08T]then
+qfFSJN[Va8fT08T]={R4oRlgh[ni9je9bJ]}else
+qfFSJN[Va8fT08T][#qfFSJN[Va8fT08T]+1]=R4oRlgh[ni9je9bJ]end;d778=aZT end;return qfFSJN end
+function S1wg_DG.slice(X40cF,EW,asgq)local IQybL1={}for hYKT45=EW or 1,asgq or#X40cF do
+IQybL1[#IQybL1+1]=X40cF[hYKT45]end;return IQybL1 end
+function S1wg_DG.first(Rq7,LQ_EIcl)LQ_EIcl=LQ_EIcl or 1;local uaL={}for gujcrFp=1,LQ_EIcl do
+uaL[gujcrFp]=Rq7[gujcrFp]end;return uaL end
+function S1wg_DG.initial(ph06vXj,nH0LB4c)local ALwJ9=#ph06vXj
+nH0LB4c=nH0LB4c and
+ALwJ9- (RlMSrmdD(nH0LB4c,ALwJ9))or ALwJ9-1;local _X={}for ruXMob=1,nH0LB4c do _X[ruXMob]=ph06vXj[ruXMob]end
+return _X end
+function S1wg_DG.last(E,jcgjAE)local BZmaGN=#E
+jcgjAE=jcgjAE and
+BZmaGN-RlMSrmdD(jcgjAE-1,BZmaGN-1)or 2;local HSav={}for sDjMr=jcgjAE,BZmaGN do HSav[#HSav+1]=E[sDjMr]end;return
+HSav end;function S1wg_DG.rest(biQX3Ut,BLEXN_)local Ljc={}
+for fpN7T=BLEXN_ or 1,#biQX3Ut do Ljc[#Ljc+1]=biQX3Ut[fpN7T]end;return Ljc end;function S1wg_DG.nth(FNSk_,LmE)return
+FNSk_[LmE]end
+function S1wg_DG.compact(pZTFVP)local XL={}for L5vC0Jx,vpONJ in l(pZTFVP)do if vpONJ then
+XL[#XL+1]=vpONJ end end;return XL end
+function S1wg_DG.flatten(A,LN)LN=LN or false;local dA14qP;local JcQc={}
+for hDih6_D,QKbZ464i in kyWtqIf0(A)do
+if v(QKbZ464i)=='table'then
+dA14qP=
+LN and QKbZ464i or S1wg_DG.flatten(QKbZ464i)for F1TsZ,uF2 in kyWtqIf0(dA14qP)do JcQc[#JcQc+1]=uF2 end else JcQc[
+#JcQc+1]=QKbZ464i end end;return JcQc end
+function S1wg_DG.difference(T,pC_)if not pC_ then return S1wg_DG.clone(T)end;return
+S1wg_DG.select(T,function(ju)return
+not S1wg_DG.include(pC_,ju)end)end;function S1wg_DG.union(...)
+return S1wg_DG.unique(S1wg_DG.flatten({...}))end
+function S1wg_DG.intersection(deu1,...)local IgZ6={...}local kVRiv3F={}for kWMf,DawC in
+kyWtqIf0(deu1)do
 if
-bdb[__c]then bdb[__c][#bdb[__c]+1]=ddb else bdb[__c]={ddb}end end)return bdb end
-function bab.countBy(dcb,_db,...)local adb={...}local bdb={}
-bab.each(dcb,function(cdb,ddb)local __c=_db(cdb,ddb,c_b(adb))bdb[__c]=(
-bdb[__c]or 0)+1 end)return bdb end
-function bab.size(...)local dcb={...}local _db=dcb[1]if bab.isTable(_db)then return cbb(dcb[1])else
-return cbb(dcb)end end;function bab.containsKeys(dcb,_db)
-for adb in d_b(_db)do if not dcb[adb]then return false end end;return true end
-function bab.sameKeys(dcb,_db)for adb in
-d_b(dcb)do if not _db[adb]then return false end end;for adb in
-d_b(_db)do if not dcb[adb]then return false end end
-return true end
-function bab.sample(dcb,_db,adb)_db=_db or 1;if _db<1 then return end;if _db==1 then if adb then ada(adb)end;return
-dcb[bda(1,#dcb)]end;return
-bab.slice(bab.shuffle(dcb,adb),1,_db)end
-function bab.sampleProb(dcb,_db,adb)if adb then ada(adb)end;return
-bab.select(dcb,function(bdb,cdb)return bda()<_db end)end;function bab.toArray(...)return{...}end
-function bab.find(dcb,_db,adb)for i=adb or 1,#dcb do if
-bab.isEqual(dcb[i],_db)then return i end end end
-function bab.reverse(dcb)local _db={}for i=#dcb,1,-1 do _db[#_db+1]=dcb[i]end;return _db end;function bab.fill(dcb,_db,adb,bdb)bdb=bdb or bab.size(dcb)
-for i=adb or 1,bdb do dcb[i]=_db end;return dcb end
-function bab.selectWhile(dcb,_db,...)
-local adb={}
-for bdb,cdb in _ab(dcb)do if _db(bdb,cdb,...)then adb[bdb]=cdb else break end end;return adb end
-function bab.dropWhile(dcb,_db,...)local adb
-for bdb,cdb in _ab(dcb)do if not _db(bdb,cdb,...)then adb=bdb;break end end;if bab.isNil(adb)then return{}end;return bab.rest(dcb,adb)end
-function bab.sortedIndex(dcb,_db,adb,bdb)local cdb=adb or dab;if bdb then bab.sort(dcb,cdb)end;for i=1,#dcb do if not
-cdb(dcb[i],_db)then return i end end
-return#dcb+1 end
-function bab.indexOf(dcb,_db)for k=1,#dcb do if dcb[k]==_db then return k end end end
-function bab.lastIndexOf(dcb,_db)local adb=bab.indexOf(bab.reverse(dcb),_db)if adb then return
-#dcb-adb+1 end end;function bab.findIndex(dcb,_db,...)
-for k=1,#dcb do if _db(k,dcb[k],...)then return k end end end
-function bab.findLastIndex(dcb,_db,...)
-local adb=bab.findIndex(bab.reverse(dcb),_db,...)if adb then return#dcb-adb+1 end end;function bab.addTop(dcb,...)
-bab.each({...},function(_db,adb)bca(dcb,1,adb)end)return dcb end;function bab.push(dcb,...)bab.each({...},function(_db,adb)
-dcb[#dcb+1]=adb end)
-return dcb end
-function bab.pop(dcb,_db)
-_db=a_b(_db or 1,#dcb)local adb={}
-for i=1,_db do local bdb=dcb[1]adb[#adb+1]=bdb;dca(dcb,1)end;return c_b(adb)end
-function bab.unshift(dcb,_db)_db=a_b(_db or 1,#dcb)local adb={}for i=1,_db do local bdb=dcb[#dcb]
-adb[#adb+1]=bdb;dca(dcb)end;return c_b(adb)end
-function bab.pull(dcb,...)
-for _db,adb in _ab({...})do for i=#dcb,1,-1 do
-if bab.isEqual(dcb[i],adb)then dca(dcb,i)end end end;return dcb end
-function bab.removeRange(dcb,_db,adb)local bdb=bab.clone(dcb)local cdb,ddb=(aba(bdb)),#bdb
-if ddb<1 then return bdb end;_db=_bb(_db or cdb,cdb,ddb)
-adb=_bb(adb or ddb,cdb,ddb)if adb<_db then return bdb end;local __c=adb-_db+1;local a_c=_db;while __c>0 do
-dca(bdb,a_c)__c=__c-1 end;return bdb end
-function bab.chunk(dcb,_db,...)if not bab.isArray(dcb)then return dcb end;local adb,bdb,cdb={},0
-local ddb=bab.map(dcb,_db,...)
-bab.each(ddb,function(__c,a_c)cdb=(cdb==nil)and a_c or cdb;bdb=(
-(a_c~=cdb)and(bdb+1)or bdb)
-if not adb[bdb]then adb[bdb]={dcb[__c]}else adb[bdb][
-#adb[bdb]+1]=dcb[__c]end;cdb=a_c end)return adb end
-function bab.slice(dcb,_db,adb)return
-bab.select(dcb,function(bdb)return
-(bdb>= (_db or aba(dcb))and bdb<= (adb or#dcb))end)end;function bab.first(dcb,_db)local adb=_db or 1
-return bab.slice(dcb,1,a_b(adb,#dcb))end
-function bab.initial(dcb,_db)
-if _db and _db<0 then return end;return
-bab.slice(dcb,1,_db and#dcb- (a_b(_db,#dcb))or#dcb-1)end;function bab.last(dcb,_db)if _db and _db<=0 then return end
-return bab.slice(dcb,_db and
-#dcb-a_b(_db-1,#dcb-1)or 2,#dcb)end;function bab.rest(dcb,_db)if _db and
-_db>#dcb then return{}end
-return bab.slice(dcb,
-_db and __b(1,a_b(_db,#dcb))or 1,#dcb)end;function bab.nth(dcb,_db)
-return dcb[_db]end;function bab.compact(dcb)return
-bab.reject(dcb,function(_db,adb)return not adb end)end
-function bab.flatten(dcb,_db)local adb=
-_db or false;local bdb;local cdb={}
-for ddb,__c in d_b(dcb)do
-if bab.isTable(__c)then bdb=adb and __c or
-bab.flatten(__c)
-bab.each(bdb,function(a_c,b_c)cdb[#cdb+1]=b_c end)else cdb[#cdb+1]=__c end end;return cdb end
-function bab.difference(dcb,_db)if not _db then return bab.clone(dcb)end;return
-bab.select(dcb,function(adb,bdb)return not
-bab.include(_db,bdb)end)end
-function bab.union(...)return bab.uniq(bab.flatten({...}))end
-function bab.intersection(dcb,...)local _db={...}local adb={}
-for bdb,cdb in _ab(dcb)do if
-bab.all(_db,function(ddb,__c)return bab.include(__c,cdb)end)then bca(adb,cdb)end end;return adb end
-function bab.symmetricDifference(dcb,_db)return
-bab.difference(bab.union(dcb,_db),bab.intersection(dcb,_db))end
-function bab.unique(dcb)local _db={}for i=1,#dcb do if not bab.find(_db,dcb[i])then
-_db[#_db+1]=dcb[i]end end;return _db end
-function bab.isunique(dcb)return bab.isEqual(dcb,bab.unique(dcb))end
-function bab.zip(...)local dcb={...}
-local _db=bab.max(bab.map(dcb,function(bdb,cdb)return#cdb end))local adb={}for i=1,_db do adb[i]=bab.pluck(dcb,i)end;return adb end
-function bab.append(dcb,_db)local adb={}for bdb,cdb in _ab(dcb)do adb[bdb]=cdb end;for bdb,cdb in _ab(_db)do
-adb[#adb+1]=cdb end;return adb end
-function bab.interleave(...)return bab.flatten(bab.zip(...))end;function bab.interpose(dcb,_db)return
-bab.flatten(bab.zip(_db,bab.rep(dcb,#_db-1)))end
-function bab.range(...)
-local dcb={...}local _db,adb,bdb
-if#dcb==0 then return{}elseif#dcb==1 then adb,_db,bdb=dcb[1],0,1 elseif#dcb==2 then
-_db,adb,bdb=dcb[1],dcb[2],1 elseif#dcb==3 then _db,adb,bdb=dcb[1],dcb[2],dcb[3]end;if(bdb and bdb==0)then return{}end;local cdb={}
-local ddb=__b(dda((adb-_db)/bdb),0)for i=1,ddb do cdb[#cdb+1]=_db+bdb*i end;if#cdb>0 then
-bca(cdb,1,_db)end;return cdb end
-function bab.rep(dcb,_db)local adb={}for i=1,_db do adb[#adb+1]=dcb end;return adb end;function bab.partition(dcb,_db,adb)if _db<=0 then return end
-return coroutine.wrap(function()
-_cb(dcb,_db or 1,coroutine.yield,adb)end)end;function bab.sliding(dcb,_db,adb)if
-_db<=1 then return end
-return coroutine.wrap(function()
-acb(dcb,_db or 2,coroutine.yield,adb)end)end
-function bab.permutation(dcb)return
-coroutine.wrap(function()bcb(dcb,
-#dcb,coroutine.yield)end)end;function bab.invert(dcb)local _db={}
-bab.each(dcb,function(adb,bdb)_db[bdb]=adb end)return _db end
-function bab.concat(dcb,_db,adb,bdb)
-local cdb=bab.map(dcb,function(ddb,__c)return
-tostring(__c)end)return _da(cdb,_db,adb or 1,bdb or#dcb)end;function bab.noop()return end;function bab.identity(dcb)return dcb end;function bab.constant(dcb)return
-function()return dcb end end
-function bab.memoize(dcb,_db)
-local adb=_ca({},{__mode='kv'})local bdb=_db or bab.identity;return
-function(...)local cdb=bdb(...)local ddb=adb[cdb]if not ddb then
-adb[cdb]=dcb(...)end;return adb[cdb]end end;function bab.once(dcb)local _db=0;local adb={}
-return function(...)_db=_db+1;if _db<=1 then adb={...}end
-return dcb(c_b(adb))end end
-function bab.before(dcb,_db)
-local adb=0;local bdb={}return
-function(...)adb=adb+1;if adb<=_db then bdb={...}end;return dcb(c_b(bdb))end end
-function bab.after(dcb,_db)local adb,bdb=_db,0;return
-function(...)bdb=bdb+1;if bdb>=adb then return dcb(...)end end end
-function bab.compose(...)local dcb=bab.reverse{...}
-return function(...)local _db,adb=true
-for bdb,cdb in _ab(dcb)do if _db then _db=false
-adb=cdb(...)else adb=cdb(adb)end end;return adb end end
-function bab.pipe(dcb,...)return bab.compose(...)(dcb)end
-function bab.complement(dcb)return function(...)return not dcb(...)end end;function bab.juxtapose(dcb,...)local _db={}
-bab.each({...},function(adb,bdb)_db[#_db+1]=bdb(dcb)end)return c_b(_db)end
-function bab.wrap(dcb,_db)return function(...)return
-_db(dcb,...)end end
-function bab.times(dcb,_db,...)local adb={}for i=1,dcb do adb[i]=_db(i,...)end;return adb end
-function bab.bind(dcb,_db)return function(...)return dcb(_db,...)end end;function bab.bind2(dcb,_db)
-return function(adb,...)return dcb(adb,_db,...)end end;function bab.bindn(dcb,...)local _db={...}
-return function(...)return
-dcb(c_b(bab.append(_db,{...})))end end
-function bab.bindAll(dcb,...)local _db={...}
-for adb,bdb in
-_ab(_db)do local cdb=dcb[bdb]if cdb then dcb[bdb]=bab.bind(cdb,dcb)end end;return dcb end
-function bab.uniqueId(dcb,...)ccb=ccb+1
-if dcb then if bab.isString(dcb)then return dcb:format(ccb)elseif
-bab.isFunction(dcb)then return dcb(ccb,...)end end;return ccb end
-function bab.iterator(dcb,_db)return function()_db=dcb(_db)return _db end end
-function bab.array(...)local dcb={}for _db in...do dcb[#dcb+1]=_db end;return dcb end;function bab.flip(dcb)return
-function(...)return dcb(c_b(bab.reverse({...})))end end;function bab.over(...)
-local dcb={...}
-return function(...)local _db={}for adb,bdb in _ab(dcb)do _db[#_db+1]=bdb(...)end
-return _db end end;function bab.overEvery(...)
-local dcb=bab.over(...)
+S1wg_DG.all(IgZ6,function(cP)return S1wg_DG.include(cP,DawC)end)then kVRiv3F[#kVRiv3F+1]=DawC end end
+return kVRiv3F end
+function S1wg_DG.symmetricDifference(w,UZ)return
+S1wg_DG.difference(S1wg_DG.union(w,UZ),S1wg_DG.intersection(w,UZ))end
+function S1wg_DG.unique(tdH)local ymt={}for WxGA=1,#tdH do if not S1wg_DG.find(ymt,tdH[WxGA])then
+ymt[#ymt+1]=tdH[WxGA]end end;return
+ymt end;function S1wg_DG.isunique(jBuHkH)return
+#jBuHkH==# (S1wg_DG.unique(jBuHkH))end
+function S1wg_DG.zip(...)
+local E3={...}
+local CZi_zK=S1wg_DG.max(E3,function(PY3VqYZ8)return#PY3VqYZ8 end)local _6KCMph={}
+for V=1,CZi_zK do if not _6KCMph[V]then _6KCMph[V]={}end;for y,QF in kyWtqIf0(E3)do
+if
+QF[V]then _6KCMph[V][#_6KCMph[V]+1]=QF[V]end end end;return _6KCMph end
+function S1wg_DG.zipWith(hN,...)local hVflx4kh={...}
+local GP=S1wg_DG.max(hVflx4kh,function(RLaqM3)return#RLaqM3 end)local oCZYv2dT={}for PoH=1,GP do
+oCZYv2dT[PoH]=hN(hUL(S1wg_DG.pluck(hVflx4kh,PoH)))end;return oCZYv2dT end
+function S1wg_DG.append(xM709D,z50)local sAPD={}
+for AVFi,GGKI in kyWtqIf0(xM709D)do sAPD[AVFi]=GGKI end;for gWaGu,SFKM in kyWtqIf0(z50)do sAPD[#sAPD+1]=SFKM end
+return sAPD end
+function S1wg_DG.interleave(...)local j6jQmlbr={...}
+local m403CY=S1wg_DG.max(j6jQmlbr,S1wg_DG.size)local dL={}
+for PrTsHeT=1,m403CY do for eNI3MT7,Rfoo in kyWtqIf0(j6jQmlbr)do
+if Rfoo[PrTsHeT]then dL[#dL+1]=Rfoo[PrTsHeT]end end end;return dL end;function S1wg_DG.interpose(eUJhGD,wot8)
+for j9vJ=#eUJhGD,2,-1 do odpE(eUJhGD,j9vJ,wot8)end;return eUJhGD end
+function S1wg_DG.range(J6Qr27Mh,AwxW8Do,_u)
+if
+(
+J6Qr27Mh==nil)and(AwxW8Do==nil)and(_u==nil)then return{}elseif
+(J6Qr27Mh~=nil)and(AwxW8Do==nil)and(_u==nil)then J6Qr27Mh,AwxW8Do,_u=Ub(J6Qr27Mh),J6Qr27Mh,Ub(J6Qr27Mh)elseif
+(J6Qr27Mh~=nil)and(AwxW8Do~=nil)and(_u==nil)then _u=Ub(AwxW8Do-
+J6Qr27Mh)end;local B={J6Qr27Mh}
+local cdxFVpZw=BCf7(pS78Y((AwxW8Do-J6Qr27Mh)/_u),0)for Y=1,cdxFVpZw do B[#B+1]=J6Qr27Mh+_u*Y end;return B end;function S1wg_DG.rep(o9Uh,BuX1r)local Wyf83f2={}for P0olj=1,BuX1r do Wyf83f2[P0olj]=o9Uh end
+return Wyf83f2 end
+function S1wg_DG.powerset(z)
+local EHCCkt=#z;if EHCCkt==0 then return{{}}end;local x={}for xNWVmS=1,EHCCkt do
+for kGWnkgDu=1,EHCCkt-xNWVmS+1 do x[#x+1]=S1wg_DG.slice(z,kGWnkgDu,
+kGWnkgDu+xNWVmS-1)end end;return x end;function S1wg_DG.partition(Pkis6H28,tSE,abKH)if tSE<=0 then return end
+return OV7(function()
+MGSnnzOI(Pkis6H28,tSE or 1,X83a,abKH)end)end;function S1wg_DG.overlapping(LDp,GWouUlzZ,MqJhIr)if
+GWouUlzZ<=1 then return end
+return OV7(function()
+B0o5xpg7(LDp,GWouUlzZ or 2,X83a,MqJhIr)end)end;function S1wg_DG.aperture(Q9,c)if
+c<=1 then return end;return
+OV7(function()VQT(Q9,c or 2,X83a)end)end;function S1wg_DG.pairwise(qnZ81I)return
+S1wg_DG.aperture(qnZ81I,2)end
+function S1wg_DG.permutation(N9uN)return OV7(function()
+Id(N9uN,#N9uN,X83a)end)end;function S1wg_DG.invert(QGC)local K8iFU={}for gbU,h in kyWtqIf0(QGC)do K8iFU[h]=gbU end
+return K8iFU end
+function S1wg_DG.concat(hS7,KQjMKhN,R6PYgHHE,ZwCXrLO)return
+JdUtcU(S1wg_DG.map(hS7,tostring),KQjMKhN,R6PYgHHE,ZwCXrLO)end
+function S1wg_DG.xprod(lI,iMSMP5Lp)local WoARZdZ3={}
+for n,Uj in kyWtqIf0(lI)do for HpN_N,yP3QEJ in kyWtqIf0(iMSMP5Lp)do
+WoARZdZ3[#WoARZdZ3+1]={Uj,yP3QEJ}end end;return WoARZdZ3 end
+function S1wg_DG.sum(pwi)local QP=0;for Iy,O9P0mj in kyWtqIf0(pwi)do QP=QP+O9P0mj end;return QP end
+function S1wg_DG.product(eFGwPxi)local m4x8ZsD4=1
+for _witc0Pe,Y8E in kyWtqIf0(eFGwPxi)do m4x8ZsD4=m4x8ZsD4*Y8E end;return m4x8ZsD4 end
+function S1wg_DG.mean(h)return S1wg_DG.sum(h)/ (#h)end
+function S1wg_DG.median(EnMMG)
+local HzO7UpZ=S1wg_DG.sort(S1wg_DG.clone(EnMMG))local B=#HzO7UpZ;if B==0 then return elseif B==1 then return HzO7UpZ[1]end
+local RNTu=VCD(B/2)
+return B%2 ==0 and
+(HzO7UpZ[RNTu]+HzO7UpZ[RNTu+1])/2 or HzO7UpZ[RNTu]end;function S1wg_DG.noop()return end;function S1wg_DG.identity(Q_)return Q_ end;function S1wg_DG.constant(S8GB)return function()return
+S8GB end end
+function S1wg_DG.applySpec(W7yjGm)return
+function(...)
+local X={}for Y,qqvEf3 in l(W7yjGm)do X[Y]=qqvEf3(...)end;return X end end
+function S1wg_DG.memoize(Wriu)local I0Pxr5F=oUA({},{__mode='kv'})
+return function(ukGf_)if
+(I0Pxr5F[ukGf_]==nil)then I0Pxr5F[ukGf_]=Wriu(ukGf_)end;return
+I0Pxr5F[ukGf_]end end
+function S1wg_DG.unfold(uZpt01P,hJk0n8bR)local o9DTTJig,v4={}
+while true do v4,hJk0n8bR=uZpt01P(hJk0n8bR)if v4 ~=nil then o9DTTJig[
+#o9DTTJig+1]=v4 else break end end;return o9DTTJig end
+function S1wg_DG.once(Uaq2_Xzk)local S0DM=0;local GHasi5={}
+return function(...)S0DM=S0DM+1;if S0DM<=1 then GHasi5={...}end;return
+Uaq2_Xzk(hUL(GHasi5))end end
+function S1wg_DG.before(QeX_U9tm,hgW2H5)local Dp9m=0;local sJjNM={}return
+function(...)Dp9m=Dp9m+1
+if Dp9m<=hgW2H5 then sJjNM={...}end;return QeX_U9tm(hUL(sJjNM))end end
+function S1wg_DG.after(GnSs,hgW2H5)local XP,Sj=hgW2H5,0;return
+function(...)Sj=Sj+1;if Sj>=XP then return GnSs(...)end end end
+function S1wg_DG.compose(...)local yKj1=S1wg_DG.reverse{...}
+return
+function(...)local F9WZ,A5=true;for nY_O,QAJAyj5 in
+kyWtqIf0(yKj1)do
+if F9WZ then F9WZ=false;A5=QAJAyj5(...)else A5=QAJAyj5(A5)end end;return A5 end end
+function S1wg_DG.pipe(EZ,...)return S1wg_DG.compose(...)(EZ)end
+function S1wg_DG.complement(n)return function(...)return not n(...)end end
+function S1wg_DG.juxtapose(M,...)local AADiL1={}
+for Arw,b in kyWtqIf0({...})do AADiL1[Arw]=b(M)end;return hUL(AADiL1)end;function S1wg_DG.wrap(_ZM1Yj3,rmSU)
+return function(...)return rmSU(_ZM1Yj3,...)end end;function S1wg_DG.times(L2RHrI,XW7Y5Rz,...)local C={}for NhwEkTd=1,(XW7Y5Rz or 1)
+do C[NhwEkTd]=L2RHrI(NhwEkTd,...)end
+return C end
+function S1wg_DG.bind(XGz,Tf4P2eIf)return function(...)return
+XGz(Tf4P2eIf,...)end end;function S1wg_DG.bind2(TF3Htu,K5yUw1t)
+return function(Mi,...)return TF3Htu(Mi,K5yUw1t,...)end end;function S1wg_DG.bindn(WWyrqnSL,...)local gVTyP={...}
 return function(...)return
-bab.reduce(dcb(...),function(_db,adb)return _db and adb end)end end;function bab.overSome(...)
-local dcb=bab.over(...)
+WWyrqnSL(hUL(S1wg_DG.append(gVTyP,{...})))end end
+function S1wg_DG.bindall(Ck,...)
+local CRG={...}
+for dkz,zrCq in kyWtqIf0(CRG)do local azXMvVdM=Ck[zrCq]if azXMvVdM then
+Ck[zrCq]=S1wg_DG.bind(azXMvVdM,Ck)end end;return Ck end;function S1wg_DG.cond(CBgxHfbq)
+return function(...)
+for WO,H in kyWtqIf0(CBgxHfbq)do if H[1](...)then return H[2](...)end end end end
+function S1wg_DG.uniqueId(C28NuJ3,...)qJExeUn2=
+qJExeUn2+1;if C28NuJ3 then
+if v(C28NuJ3)=='string'then
+return C28NuJ3:format(qJExeUn2)elseif v(C28NuJ3)=='function'then return C28NuJ3(qJExeUn2,...)end end;return
+qJExeUn2 end
+function S1wg_DG.iterator(sz,qH,u)local uJ1Vn4uYP=0
+return function()uJ1Vn4uYP=uJ1Vn4uYP+1
+if u and uJ1Vn4uYP>u then return end;qH=sz(qH)return qH end end
+function S1wg_DG.array(...)local Z={}for pJ in...do Z[#Z+1]=pJ end;return Z end;function S1wg_DG.castArray(NAjg)return
+(v(NAjg)~='table')and{NAjg}or NAjg end;function S1wg_DG.flip(con)
 return function(...)return
-bab.reduce(dcb(...),function(_db,adb)return _db or adb end)end end
-function bab.overArgs(dcb,...)
-local _db={...}return
-function(...)local adb={...}for i=1,#_db do local bdb=_db[i]
-if adb[i]then adb[i]=bdb(adb[i])end end;return dcb(c_b(adb))end end
-function bab.partial(dcb,...)local _db={...}
+con(hUL(S1wg_DG.reverse({...})))end end;function S1wg_DG.nthArg(I)
+return function(...)local TxmZR6UE={...}return
+TxmZR6UE[(
+I<0)and(#TxmZR6UE+I+1)or I]end end;function S1wg_DG.unary(I1b4o)
+return function(...)
+local nAt={...}return I1b4o(nAt[1])end end
+function S1wg_DG.ary(pNJ,RQ)RQ=RQ or 1
+return function(...)
+local wnZcHKf={...}local Lv_8={}for UQ=1,RQ do Lv_8[UQ]=wnZcHKf[UQ]end
+return pNJ(hUL(Lv_8))end end
+function S1wg_DG.rearg(FG,vLzqjJw)return
+function(...)local v2dsC21={...}local O={}
+for wx,u in kyWtqIf0(vLzqjJw)do O[wx]=v2dsC21[u]end;return FG(hUL(O))end end
+function S1wg_DG.over(...)local V_84V={...}return
+function(...)local qF={}for IZbOX7TW,Dd6ZLpU in kyWtqIf0(V_84V)do
+qF[#qF+1]=Dd6ZLpU(...)end;return qF end end
+function S1wg_DG.overEvery(...)local MP=S1wg_DG.over(...)
+return function(...)
+return S1wg_DG.reduce(MP(...),function(w4c,C58)
+return w4c and C58 end)end end
+function S1wg_DG.overSome(...)local Jk6Nh=S1wg_DG.over(...)
+return function(...)
+return S1wg_DG.reduce(Jk6Nh(...),function(s1Ws,desLYv)return
+s1Ws or desLYv end)end end
+function S1wg_DG.overArgs(COq2NY9I,...)local aoBEg65S={...}
 return
-function(...)local adb={...}local bdb={}for cdb,ddb in _ab(_db)do bdb[cdb]=
-(ddb=='_')and bab.pop(adb)or ddb end;return
-dcb(c_b(bab.append(bdb,adb)))end end
-function bab.partialRight(dcb,...)local _db={...}
+function(...)local x6={...}
+for t3cNa2l=1,#aoBEg65S do local Ik=aoBEg65S[t3cNa2l]if
+x6[t3cNa2l]then x6[t3cNa2l]=Ik(x6[t3cNa2l])end end;return COq2NY9I(hUL(x6))end end
+function S1wg_DG.converge(SeHOs,P2rGsUx,c)return
+function(...)return SeHOs(P2rGsUx(...),c(...))end end
+function S1wg_DG.partial(v12AhMm,...)local F2uxGC={...}
 return
-function(...)local adb={...}local bdb={}
-for k=1,#_db do bdb[k]=
-(_db[k]=='_')and bab.pop(adb)or _db[k]end;return dcb(c_b(bab.append(adb,bdb)))end end
-function bab.curry(dcb,_db)_db=_db or 2;local adb={}
-local function bdb(cdb)if _db==1 then return dcb(cdb)end;if cdb~=nil then
-adb[#adb+1]=cdb end;if#adb<_db then return bdb else local ddb={dcb(c_b(adb))}adb={}return
-c_b(ddb)end end;return bdb end
-function bab.time(dcb,...)local _db=aab()local adb={dcb(...)}return aab()-_db,c_b(adb)end;function bab.keys(dcb)local _db={}
-bab.each(dcb,function(adb)_db[#_db+1]=adb end)return _db end;function bab.values(dcb)local _db={}
-bab.each(dcb,function(adb,bdb)_db[
-#_db+1]=bdb end)return _db end;function bab.kvpairs(dcb)local _db={}
-bab.each(dcb,function(adb,bdb)_db[
-#_db+1]={adb,bdb}end)return _db end
-function bab.toObj(dcb)local _db={}for adb,bdb in
-_ab(dcb)do _db[bdb[1]]=bdb[2]end;return _db end
-function bab.property(dcb)return function(_db)return _db[dcb]end end
-function bab.propertyOf(dcb)return function(_db)return dcb[_db]end end;function bab.toBoolean(dcb)return not not dcb end
-function bab.extend(dcb,...)local _db={...}
-bab.each(_db,function(adb,bdb)if
-bab.isTable(bdb)then
-bab.each(bdb,function(cdb,ddb)dcb[cdb]=ddb end)end end)return dcb end
-function bab.functions(dcb,_db)dcb=dcb or bab;local adb={}
-bab.each(dcb,function(cdb,ddb)if bab.isFunction(ddb)then
-adb[#adb+1]=cdb end end)if not _db then return bab.sort(adb)end;local bdb=aca(dcb)
-if
-bdb and bdb.__index then local cdb=bab.functions(bdb.__index)bab.each(cdb,function(ddb,__c)
-adb[#adb+1]=__c end)end;return bab.sort(adb)end
-function bab.clone(dcb,_db)if not bab.isTable(dcb)then return dcb end;local adb={}
-bab.each(dcb,function(bdb,cdb)if
-bab.isTable(cdb)then
-if not _db then adb[bdb]=bab.clone(cdb,_db)else adb[bdb]=cdb end else adb[bdb]=cdb end end)return adb end;function bab.tap(dcb,_db,...)_db(dcb,...)return dcb end;function bab.has(dcb,_db)return
-dcb[_db]~=nil end
-function bab.pick(dcb,...)local _db=bab.flatten{...}
-local adb={}
-bab.each(_db,function(bdb,cdb)
-if not bab.isNil(dcb[cdb])then adb[cdb]=dcb[cdb]end end)return adb end
-function bab.omit(dcb,...)local _db=bab.flatten{...}local adb={}
-bab.each(dcb,function(bdb,cdb)if
-not bab.include(_db,bdb)then adb[bdb]=cdb end end)return adb end;function bab.template(dcb,_db)
-bab.each(_db or{},function(adb,bdb)if not dcb[adb]then dcb[adb]=bdb end end)return dcb end
-function bab.isEqual(dcb,_db,adb)
-local bdb=bba(dcb)local cdb=bba(_db)if bdb~=cdb then return false end
-if bdb~='table'then return(dcb==_db)end;local ddb=aca(dcb)local __c=aca(_db)if adb then
-if
-(ddb or __c)and(ddb.__eq or __c.__eq)then return
-ddb.__eq(dcb,_db)or __c.__eq(_db,dcb)or(dcb==_db)end end;if bab.size(dcb)~=
-bab.size(_db)then return false end;for a_c,b_c in d_b(dcb)do local c_c=_db[a_c]
+function(...)local Xs0={...}local QK8ibF={}for TEio7k0z,u in kyWtqIf0(F2uxGC)do
+QK8ibF[TEio7k0z]=(u==
+'_')and S1wg_DG.shift(Xs0)or u end;return
+v12AhMm(hUL(S1wg_DG.append(QK8ibF,Xs0)))end end
+function S1wg_DG.partialRight(N,...)local O2YgxDc={...}
+return
+function(...)local VLsC67={...}local OHw4={}
+for FKZ=1,#O2YgxDc do OHw4[FKZ]=(O2YgxDc[FKZ]==
+'_')and S1wg_DG.shift(VLsC67)or
+O2YgxDc[FKZ]end
+return N(hUL(S1wg_DG.append(VLsC67,OHw4)))end end
+function S1wg_DG.curry(Fl,QhS8FvKI)QhS8FvKI=QhS8FvKI or 2;local FaZIJL={}
+local function sOT2O5(x)
+if QhS8FvKI==1 then return Fl(x)end;if x~=nil then FaZIJL[#FaZIJL+1]=x end;if
+#FaZIJL<QhS8FvKI then return sOT2O5 else local Wswd_OC={Fl(hUL(FaZIJL))}FaZIJL={}
+return hUL(Wswd_OC)end end;return sOT2O5 end
+function S1wg_DG.time(E,...)local A0Un=Mw()local nRHrI={E(...)}return Mw()-A0Un,hUL(nRHrI)end
+function S1wg_DG.keys(k)local Zp={}for A in l(k)do Zp[#Zp+1]=A end;return Zp end;function S1wg_DG.values(_L_)local WHpm={}
+for g,HiR3yiw in l(_L_)do WHpm[#WHpm+1]=HiR3yiw end;return WHpm end
+function S1wg_DG.path(KeKbiDqN,...)
+local WfrZqHH8,YX9s9O=KeKbiDqN,{...}for y64dF,sNSsH in kyWtqIf0(YX9s9O)do if(WfrZqHH8[sNSsH]==nil)then return end
+WfrZqHH8=WfrZqHH8[sNSsH]end;return WfrZqHH8 end;function S1wg_DG.kvpairs(K)local o8T={}
+for xeP,Tv_3VlmX in l(K)do o8T[#o8T+1]={xeP,Tv_3VlmX}end;return o8T end;function S1wg_DG.toObj(BT)
+local _y3z={}
+for rdl,NAP_5jYs in kyWtqIf0(BT)do _y3z[NAP_5jYs[1]]=NAP_5jYs[2]end;return _y3z end
+function S1wg_DG.property(BZnlpW)return function(isN)return
+isN[BZnlpW]end end;function S1wg_DG.propertyOf(yRADzw1v)
+return function(Jafp)return yRADzw1v[Jafp]end end;function S1wg_DG.toBoolean(XWh8Ee)
+return not not XWh8Ee end
+function S1wg_DG.extend(kpezL1e,...)local h={...}for R7yfz_l9,D35PFLu in kyWtqIf0(h)do
 if
-bab.isNil(c_c)or not bab.isEqual(b_c,c_c,adb)then return false end end
-for a_c,b_c in d_b(_db)do
-local c_c=dcb[a_c]if bab.isNil(c_c)then return false end end;return true end
-function bab.result(dcb,_db,...)
-if dcb[_db]then if bab.isCallable(dcb[_db])then return dcb[_db](dcb,...)else return
-dcb[_db]end end;if bab.isCallable(_db)then return _db(dcb,...)end end;function bab.isTable(dcb)return bba(dcb)=='table'end
-function bab.isCallable(dcb)return
+v(D35PFLu)=='table'then for wK,qeEwE in l(D35PFLu)do kpezL1e[wK]=qeEwE end end end;return kpezL1e end
+function S1wg_DG.functions(cbtvFnSa,fYKH_)cbtvFnSa=cbtvFnSa or S1wg_DG;local W={}for o,Mm99M in l(cbtvFnSa)do if
+v(Mm99M)=='function'then W[#W+1]=o end end
+if fYKH_ then
+local l6YH=QFKEzBf(cbtvFnSa)
+if l6YH and l6YH.__index then
+local gf2=S1wg_DG.functions(l6YH.__index,fYKH_)for F744Ew,zgxKF4 in kyWtqIf0(gf2)do W[#W+1]=zgxKF4 end end end;return W end
+function S1wg_DG.clone(UlvVvSBR,i2i)if v(UlvVvSBR)~='table'then return UlvVvSBR end
+local uRGAL={}
+for UUlqXyb6,fOR92g8 in l(UlvVvSBR)do if v(fOR92g8)=='table'then if not i2i then
+uRGAL[UUlqXyb6]=S1wg_DG.clone(fOR92g8,i2i)else uRGAL[UUlqXyb6]=fOR92g8 end else
+uRGAL[UUlqXyb6]=fOR92g8 end end;return uRGAL end
+function S1wg_DG.tap(jU26,WIPTsAPz,...)WIPTsAPz(jU26,...)return jU26 end;function S1wg_DG.has(DgUx8,imac)return DgUx8[imac]~=nil end
+function S1wg_DG.pick(xX,...)
+local Mfb6Kb=S1wg_DG.flatten{...}local RRjV={}for TDOaFo,tLo4 in l(Mfb6Kb)do
+if(xX[tLo4])~=nil then RRjV[tLo4]=xX[tLo4]end end;return RRjV end
+function S1wg_DG.omit(m72l,...)local npM3DSU=S1wg_DG.flatten{...}local HGp4e1={}for uzJt7E,sRe5S32N in l(m72l)do
+if not
+S1wg_DG.include(npM3DSU,uzJt7E)then HGp4e1[uzJt7E]=sRe5S32N end end;return HGp4e1 end;function S1wg_DG.template(Bp,rg)if not rg then return Bp end
+for S,Fem in l(rg)do if not Bp[S]then Bp[S]=Fem end end;return Bp end
+function S1wg_DG.isEqual(cHmVGY,g29sXR,Vat)
+local sfnkWAy8=v(cHmVGY)local hbJSGe9=v(g29sXR)if sfnkWAy8 ~=hbJSGe9 then return false end;if
+sfnkWAy8 ~='table'then return(cHmVGY==g29sXR)end
+local pI=QFKEzBf(cHmVGY)local B7jhm=QFKEzBf(g29sXR)
+if Vat then if(pI or B7jhm)and
+(pI.__eq or B7jhm.__eq)then
+return
+pI.__eq(cHmVGY,g29sXR)or B7jhm.__eq(g29sXR,cHmVGY)or(cHmVGY==g29sXR)end end
+if S1wg_DG.size(cHmVGY)~=S1wg_DG.size(g29sXR)then return false end;local hj3
+for FKxU4,UW in l(cHmVGY)do hj3=g29sXR[FKxU4]if hj3 ==nil or
+not S1wg_DG.isEqual(UW,hj3,Vat)then return false end end
+for tReY in l(g29sXR)do if cHmVGY[tReY]==nil then return false end end;return true end
+function S1wg_DG.result(lex,h79Pm,...)
+if lex[h79Pm]then if S1wg_DG.isCallable(lex[h79Pm])then return
+lex[h79Pm](lex,...)else return lex[h79Pm]end end
+if S1wg_DG.isCallable(h79Pm)then return h79Pm(lex,...)end end
+function S1wg_DG.isTable(vksQpy4)return v(vksQpy4)=='table'end
+function S1wg_DG.isCallable(gPCIWPt)return
 (
-bab.isFunction(dcb)or
-(bab.isTable(dcb)and aca(dcb)and aca(dcb).__call~=nil)or false)end
-function bab.isArray(dcb)if not bab.isTable(dcb)then return false end;local _db=0
-for adb in
-d_b(dcb)do _db=_db+1;if bab.isNil(dcb[_db])then return false end end;return true end
-function bab.isIterable(dcb)return bab.toBoolean((dba(d_b,dcb)))end
-function bab.isEmpty(dcb)if bab.isNil(dcb)then return true end;if bab.isString(dcb)then
-return#dcb==0 end
-if bab.isTable(dcb)then return aba(dcb)==nil end;return true end;function bab.isString(dcb)return bba(dcb)=='string'end;function bab.isFunction(dcb)return
-bba(dcb)=='function'end;function bab.isNil(dcb)
-return dcb==nil end
-function bab.isNumber(dcb)return bba(dcb)=='number'end
-function bab.isNaN(dcb)return bab.isNumber(dcb)and dcb~=dcb end
-function bab.isFinite(dcb)if not bab.isNumber(dcb)then return false end;return
-dcb>-cda and dcb<cda end;function bab.isBoolean(dcb)return bba(dcb)=='boolean'end
-function bab.isInteger(dcb)return
-bab.isNumber(dcb)and dda(dcb)==dcb end
-do bab.forEach=bab.each;bab.forEachi=bab.eachi;bab.loop=bab.cycle
-bab.collect=bab.map;bab.inject=bab.reduce;bab.foldl=bab.reduce
-bab.injectr=bab.reduceRight;bab.foldr=bab.reduceRight;bab.mapr=bab.mapReduce
-bab.maprr=bab.mapReduceRight;bab.any=bab.include;bab.some=bab.include;bab.contains=bab.include
-bab.filter=bab.select;bab.discard=bab.reject;bab.every=bab.all
-bab.takeWhile=bab.selectWhile;bab.rejectWhile=bab.dropWhile;bab.shift=bab.pop;bab.remove=bab.pull
-bab.rmRange=bab.removeRange;bab.chop=bab.removeRange;bab.sub=bab.slice;bab.head=bab.first
-bab.take=bab.first;bab.tail=bab.rest;bab.skip=bab.last;bab.without=bab.difference
-bab.diff=bab.difference;bab.symdiff=bab.symmetricDifference;bab.xor=bab.symmetricDifference
-bab.uniq=bab.unique;bab.isuniq=bab.isunique;bab.transpose=bab.zip;bab.part=bab.partition
-bab.perm=bab.permutation;bab.mirror=bab.invert;bab.join=bab.concat;bab.cache=bab.memoize
-bab.juxt=bab.juxtapose;bab.uid=bab.uniqueId;bab.iter=bab.iterator;bab.methods=bab.functions
-bab.choose=bab.pick;bab.drop=bab.omit;bab.defaults=bab.template;bab.compare=bab.isEqual end
-do local dcb={}local _db={}_db.__index=dcb;local function adb(bdb)local cdb={_value=bdb,_wrapped=true}
-return _ca(cdb,_db)end
-_ca(_db,{__call=function(bdb,cdb)return adb(cdb)end,__index=function(bdb,cdb,...)return
-dcb[cdb]end})function _db.chain(bdb)return adb(bdb)end
-function _db:value()return self._value end;dcb.chain,dcb.value=_db.chain,_db.value
-for bdb,cdb in d_b(bab)do
-dcb[bdb]=function(ddb,...)local __c=bab.isTable(ddb)and
-ddb._wrapped or false
-if __c then
-local a_c=ddb._value;local b_c=cdb(a_c,...)return adb(b_c)else return cdb(ddb,...)end end end
-dcb.import=function(bdb,cdb)bdb=bdb or _ENV or _G;local ddb=bab.functions()
-bab.each(ddb,function(__c,a_c)
+(v(gPCIWPt)=='function')or(
+(v(gPCIWPt)=='table')and QFKEzBf(gPCIWPt)and
+QFKEzBf(gPCIWPt).__call~=nil)or false)end
+function S1wg_DG.isArray(l4Byxa7)
+if not(v(l4Byxa7)=='table')then return false end;local Fn8OR=0;for X1Z0van in l(l4Byxa7)do Fn8OR=Fn8OR+1
+if l4Byxa7[Fn8OR]==nil then return false end end;return true end;function S1wg_DG.isIterable(C_ACFsd)
+return S1wg_DG.toBoolean((l6Sm5(l,C_ACFsd)))end
+function S1wg_DG.isEmpty(GC)
+if(GC==nil)then return true end;if v(GC)=='string'then return#GC==0 end;if v(GC)=='table'then
+return e(GC)==nil end;return true end
+function S1wg_DG.isString(SC7gSvMB)return v(SC7gSvMB)=='string'end;function S1wg_DG.isFunction(Ei)return v(Ei)=='function'end;function S1wg_DG.isNil(GFuK1ut)return
+GFuK1ut==nil end;function S1wg_DG.isNumber(SXmRY3i)return
+v(SXmRY3i)=='number'end;function S1wg_DG.isNaN(b)return
+v(b)=='number'and b~=b end;function S1wg_DG.isFinite(KApFr)if v(KApFr)~='number'then return
+false end
+return KApFr>-S9TO and KApFr<S9TO end;function S1wg_DG.isBoolean(jE)return v(jE)==
+'boolean'end
+function S1wg_DG.isInteger(yVVmXC)return
+v(yVVmXC)=='number'and pS78Y(yVVmXC)==yVVmXC end
+do S1wg_DG.forEach=S1wg_DG.each;S1wg_DG.forEachi=S1wg_DG.eachi
+S1wg_DG.update=S1wg_DG.adjust;S1wg_DG.loop=S1wg_DG.cycle;S1wg_DG.collect=S1wg_DG.map
+S1wg_DG.inject=S1wg_DG.reduce;S1wg_DG.foldl=S1wg_DG.reduce
+S1wg_DG.injectr=S1wg_DG.reduceRight;S1wg_DG.foldr=S1wg_DG.reduceRight
+S1wg_DG.mapr=S1wg_DG.mapReduce;S1wg_DG.maprr=S1wg_DG.mapReduceRight
+S1wg_DG.any=S1wg_DG.include;S1wg_DG.some=S1wg_DG.include;S1wg_DG.contains=S1wg_DG.include
+S1wg_DG.filter=S1wg_DG.select;S1wg_DG.discard=S1wg_DG.reject;S1wg_DG.every=S1wg_DG.all
+S1wg_DG.takeWhile=S1wg_DG.selectWhile;S1wg_DG.rejectWhile=S1wg_DG.dropWhile;S1wg_DG.pop=S1wg_DG.shift
+S1wg_DG.remove=S1wg_DG.pull;S1wg_DG.rmRange=S1wg_DG.removeRange
+S1wg_DG.chop=S1wg_DG.removeRange;S1wg_DG.sub=S1wg_DG.slice;S1wg_DG.head=S1wg_DG.first
+S1wg_DG.take=S1wg_DG.first;S1wg_DG.tail=S1wg_DG.rest;S1wg_DG.skip=S1wg_DG.last
+S1wg_DG.without=S1wg_DG.difference;S1wg_DG.diff=S1wg_DG.difference
+S1wg_DG.symdiff=S1wg_DG.symmetricDifference;S1wg_DG.xor=S1wg_DG.symmetricDifference
+S1wg_DG.uniq=S1wg_DG.unique;S1wg_DG.isuniq=S1wg_DG.isunique;S1wg_DG.transpose=S1wg_DG.zip
+S1wg_DG.part=S1wg_DG.partition;S1wg_DG.perm=S1wg_DG.permutation
+S1wg_DG.transposeWith=S1wg_DG.zipWith;S1wg_DG.intersperse=S1wg_DG.interpose
+S1wg_DG.sliding=S1wg_DG.aperture;S1wg_DG.mirror=S1wg_DG.invert;S1wg_DG.join=S1wg_DG.concat
+S1wg_DG.average=S1wg_DG.mean;S1wg_DG.always=S1wg_DG.constant;S1wg_DG.cache=S1wg_DG.memoize
+S1wg_DG.juxt=S1wg_DG.juxtapose;S1wg_DG.uid=S1wg_DG.uniqueid;S1wg_DG.iter=S1wg_DG.iterator
+S1wg_DG.tabulate=S1wg_DG.array;S1wg_DG.nAry=S1wg_DG.ary;S1wg_DG.methods=S1wg_DG.functions
+S1wg_DG.choose=S1wg_DG.pick;S1wg_DG.drop=S1wg_DG.omit;S1wg_DG.defaults=S1wg_DG.template
+S1wg_DG.compare=S1wg_DG.isEqual;S1wg_DG.matches=S1wg_DG.isEqual end
+do local MkxwoCeK={}local AT={}AT.__index=MkxwoCeK;local function _8KO(NI)
+return oUA({_value=NI,_wrapped=true},AT)end
+oUA(AT,{__call=function(PE,a)return _8KO(a)end,__index=function(GhVWeuQs,kQlY,...)return
+MkxwoCeK[kQlY]end})function AT.chain(xIl1shq)return _8KO(xIl1shq)end
+function AT:value()return self._value end;MkxwoCeK.chain,MkxwoCeK.value=AT.chain,AT.value
+for qv,pbEt6T in l(S1wg_DG)do
 if
-b_b(bdb,a_c)then if not cdb then bdb[a_c]=bab[a_c]end else bdb[a_c]=bab[a_c]end end)return bdb end;_db._VERSION='Moses v'.._ba
-_db._URL='http://github.com/Yonaba/Moses'
-_db._LICENSE='MIT <http://raw.githubusercontent.com/Yonaba/Moses/master/LICENSE>'_db._DESCRIPTION='utility-belt library for functional programming in Lua'return
-_db end
\ No newline at end of file
+qv~='operator'then
+MkxwoCeK[qv]=function(MBdHQ,...)local STXAhhM=
+v(MBdHQ)=='table'and PizLA9mj(MBdHQ,'_wrapped')or false;if STXAhhM then
+local assFn=MBdHQ._value;local EXpWzv=pbEt6T(assFn,...)return _8KO(EXpWzv)else
+return pbEt6T(MBdHQ,...)end end end end;MkxwoCeK.operator=S1wg_DG.operator
+MkxwoCeK.op=S1wg_DG.operator
+MkxwoCeK.import=function(kq,up)kq=kq or _ENV or _G
+local wlI_l=S1wg_DG.functions()for nK7J,xv in kyWtqIf0(wlI_l)do
+if PizLA9mj(kq,xv)~=nil then if not up then
+rawset(kq,xv,S1wg_DG[xv])end else rawset(kq,xv,S1wg_DG[xv])end end
+return kq end;AT._VERSION='Moses v'..SWFtRywD
+AT._URL='http://github.com/Yonaba/Moses'
+AT._LICENSE='MIT <http://raw.githubusercontent.com/Yonaba/Moses/master/LICENSE>'AT._DESCRIPTION='utility-belt library for functional programming in Lua'
+return AT end
\ No newline at end of file
diff -pruN 1.6.1+git20170613-2/README.md 2.0.0-3/README.md
--- 1.6.1+git20170613-2/README.md	2017-06-03 16:42:55.000000000 +0000
+++ 2.0.0-3/README.md	2018-08-23 16:26:20.000000000 +0000
@@ -1,15 +1,54 @@
 [![Build Status](https://travis-ci.org/Yonaba/Moses.png)](https://travis-ci.org/Yonaba/Moses)
 [![License](http://img.shields.io/badge/Licence-MIT-brightgreen.svg)](LICENSE)
 [![Lua](https://img.shields.io/badge/Lua-5.1%2C%205.2%2C%205.3%2C%20JIT-blue.svg)]()
-[![git-brag-stats](https://labs.turbo.run/git-brag?user=Yonaba&repo=Moses)](https://github.com/turbo/git-brag)
 
 A Lua utility-belt library for [functional programming](http://en.wikipedia.org/wiki/Functional_programming).<br/>
 
+## Examples
+
+How can I get the sum of all integers between 1 and 100 ?
+
+```lua
+local sum = M.sum(M.range(100))
+print(sum) -- 5050
+````
+Say I am looking for the length of the longest word in some array ?
+
+```lua
+local words = {'some','words','of','different','lengths'}
+print(M.max(words, M.op.length)) -- 9 letters
+````
+
+What is the sum of all fibonacci numbers for n below or equal 25 ?
+
+```lua
+local function fib(n) return n < 2 and n or fib(n - 1) + fib(n - 2) end
+local fibsum = M.sum(M.map(M.range(25), fib))
+print(fibsum) -- 196417
+````
+
+Or let us do the same, opbject-oriented style with chaining :
+
+```lua
+local function fib(n) return n < 2 and n or fib(n - 1) + fib(n - 2) end
+local fibsum = M.chain(M.range(25)):map(fib):sum():value()
+print(fibsum) -- 196417
+````
+
+Or even shorter :
+
+```lua
+local fibsum = M(M.range(25)):map(fib):sum():value()
+print(fibsum) -- 196417
+````
+
+Feel free to download and try it on your own!
+
 ## Download
 
 ### Archive
-* __zip__: [1.6.1 (stable)](http://github.com/Yonaba/Moses/archive/Moses-1.6.1-1.zip) | [dev](http://github.com/Yonaba/Moses/archive/master.zip) | [all releases](http://github.com/Yonaba/Moses/tags)
-* __tarball__: [1.6.1 (stable)](http://github.com/Yonaba/Moses/archive/Moses-1.6.1-1.tar.gz) | [dev](http://github.com/Yonaba/Moses/archive/master.tar.gz) | [all releases](http://github.com/Yonaba/Moses/tags)
+* __2.0.0__ *(latest stable)*: [zip](http://github.com/Yonaba/Moses/archive/Moses-2.0.0-1.zip) | [tar.gz](http://github.com/Yonaba/Moses/archive/Moses-2.0.0-1.tar.gz) 
+* __Previous versions__ : [tags](http://github.com/Yonaba/Moses/tags)
 
 ### Bash
 
@@ -18,23 +57,24 @@ git clone git://github.com/Yonaba/Moses.
 ````
 
 ### LuaRocks
-```
+
+````
 luarocks install moses
 ````
 
 ### MoonRocks
 
-```bash
+````
 moonrocks install moses
 ````
 
 ## Usage
 
 ```lua
-local _ = require "moses"
+local M = require "moses"
 ````
 
-*Note:* the full source [moses.lua](https://github.com/Yonaba/Moses/blob/master/moses.lua) is quite heavy (~70 kiB). You can alternatively use the [minified version](https://github.com/Yonaba/Moses/blob/master/moses_min.lua) (~22 kiB).
+*Note:* the full source [moses.lua](https://github.com/Yonaba/Moses/blob/master/moses.lua) is quite heavy (~83 kiB, 2780 LOC). You can alternatively use the [minified version](https://github.com/Yonaba/Moses/blob/master/moses_min.lua) (~32 kiB, 521 LOC).
 
 ## Tutorial
 
@@ -42,28 +82,28 @@ Find a complete set of code examples in
   
 ## Documentation
 
-* See *doc* folder : [doc](https://github.com/Yonaba/Moses/blob/master/doc)
-* Or browse it online : see [online doc](http://yonaba.github.io/Moses/doc).
+* Read it [online](http://yonaba.github.io/Moses/doc).
 
 ## Credits and Acknowledgement
 
 * [Jeremy Ashkenas](https://github.com/jashkenas), for the amazing [Underscore.js](http://documentcloud.github.com/underscore/)
-* [Marcus Irven](http://mirven.github.com/underscore.lua/)'s and [JTArchie](https://github.com/jtarchie/underscore-lua)'s 1-to-1 ports that also inspired this
+* [Marcus Irven](http://mirven.github.com/underscore.lua/)'s and [JT Archie](https://github.com/jtarchie/underscore-lua)'s 1-to-1 ports that also inspired this
 * [Matthew Rocklin](https://github.com/mrocklin)'s [Toolz](https://github.com/pytoolz/toolz/) from which I borrowed some ideas
-* [LDoc](https://github.com/stevedonovan/ldoc/) used to generate the current HTML documentation.
+* [Steve Donovan](https://github.com/stevedonovan)'s [LDoc](https://github.com/stevedonovan/ldoc/), used to generate the current HTML documentation.
+* [Mark Langen](https://github.com/stravant)'s [LuaMinify](https://github.com/stravant/LuaMinify/), used to generate a minified version of this library.
 
 ## Specification
 
-Run [spec tests](https://github.com/Yonaba/Moses/blob/master/spec) using [Telescope](https://github.com/norman/telescope) with the following command from the root folder:
+Run [spec tests](https://github.com/Yonaba/Moses/blob/master/spec) from Lua using [busted](https://github.com/Olivine-Labs/busted/) with the following command from the root folder:
 
 ````
-tsc -f spec/*
+busted
 ````
 
 ## License
 
 This work is under [MIT-LICENSE](http://www.opensource.org/licenses/mit-license.php)<br/>
-Copyright (c) 2012-2017 Roland Yonaba. <br/>
+Copyright (c) 2012-2018 Roland Yonaba. <br/>
 See [LICENSE](LICENSE).
 
 
diff -pruN 1.6.1+git20170613-2/rockspec/moses-2.0.0-1.rockspec 2.0.0-3/rockspec/moses-2.0.0-1.rockspec
--- 1.6.1+git20170613-2/rockspec/moses-2.0.0-1.rockspec	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.0-3/rockspec/moses-2.0.0-1.rockspec	2018-08-23 16:26:20.000000000 +0000
@@ -0,0 +1,26 @@
+package = "moses"
+version = "2.0.0-1"
+source = {
+   url = "https://github.com/Yonaba/Moses/archive/Moses-2.0.0-1.tar.gz",
+   dir = "Moses-Moses-2.0.0-1"
+}
+description = {
+   summary = "Utility-belt library for functional programming in Lua",
+   detailed = [[
+    A utility-belt library for functional programming, which complements the built-in 
+    Lua table library, making easier operations on arrays, lists, collections.
+   ]],
+   homepage = "http://yonaba.github.com/Moses/",
+   license = "MIT <http://www.opensource.org/licenses/mit-license.php>"
+}
+dependencies = {
+   "lua >= 5.1, < 5.4"
+}
+build = {
+  type = "builtin",
+  modules = {
+    ["moses"] = "moses.lua",
+    ["moses_min"] = "moses_min.lua",
+  },
+  copy_directories = {"doc","spec"}	
+}
\ No newline at end of file
diff -pruN 1.6.1+git20170613-2/spec/array_spec.lua 2.0.0-3/spec/array_spec.lua
--- 1.6.1+git20170613-2/spec/array_spec.lua	2017-06-03 16:42:55.000000000 +0000
+++ 2.0.0-3/spec/array_spec.lua	2018-08-23 16:26:20.000000000 +0000
@@ -1,713 +1,876 @@
 require 'luacov'
-local _ = require 'moses'
+local M = require 'moses'
 
-context('Array functions specs', function()
+describe('Array functions specs', function()
 
-  context('sample', function()
+  describe('sample', function()
   
-    test('samples n values from array', function()
-			local array = _.range(1,20)
-			local sample = _.sample(array, 5)
-			assert_equal(#sample, 5)
-			_.each(sample, function(__,v)
-				assert_true(_.include(array, v))
+    it('samples n values from array', function()
+			local array = M.range(1,20)
+			local sample = M.sample(array, 5)
+			assert.equal(#sample, 5)
+			M.each(sample, function(__,v)
+				assert.is_true(M.include(array, v))
 			end)
     end)	
     
-    test('when not given, n defaults to 1', function()
-			local array = _.range(1,20)
-			local sample = _.sample(array)
-			assert_true(_.include(array, sample))
+    it('when not given, n defaults to 1', function()
+			local array = M.range(1,20)
+			local sample = M.sample(array)
+      assert.equal(#sample, 1)
+			assert.is_true(M.include(array, sample[1]))
     end)
 		
+    it('if n == 0, returns an empty array', function()
+			local array = M.range(1,5)
+			local sample = M.sample(array, 0)
+			assert.is_true(#sample == 0)
+    end)
+    
+    it('if n < 0, returns an empty array', function()
+			local array = M.range(1,5)
+			assert.is_true(#M.sample(array, -1) == 0)
+    end)    
+    
   end)
 	
-  context('sampleProb', function()
+  describe('sampleProb', function()
   
-    test('returns a sample of an array values', function()
-			local array = _.range(1,20)
-			local sample = _.sampleProb(array, 0.2)
-			_.each(sample, function(__,v)
-				assert_true(_.include(array, v))
+    it('returns a sample of an array values', function()
+			local array = M.range(1,20)
+			local sample = M.sampleProb(array, 0.2)
+			M.each(sample, function(__,v)
+				assert.is_true(M.include(array, v))
 			end)
     end)	
     
   end)
 	
-  context('toArray', function()
+  describe('shuffle', function()
   
-    test('converts a vararg list to an array', function()
-      assert_true(_.isArray(_.toArray(1,2,3,4)))
-      assert_true(_.isEqual(_.toArray(1,2,8,'d','a',0),{1,2,8,'d','a',0}))      
+    it('shuffles values and objects in a collection', function()    
+      local values = {'a','b','c','d'}       
+      assert.is_true(M.same(M.shuffle (values),values))
     end)
+    
+    it('can accept a seed value to init randomization', function()    
+      local values = {'a','b','c','d'}
+      local seed = os.time()
+      assert.is_true(M.same(M.shuffle(values,seed),values))
+    end)   
 
-    test('preserves input order', function()
-      local args = _.toArray(1,2,3,4,5)
-      for i = 1, 5 do assert_equal(args[i], i) end
+    it('shuffled table has the same elements in a different order', function()    
+      local values = {'a','b','c','d'}
+      assert.is_true(M.same(M.shuffle(values),values))
+      assert.is_true(M.same(M.shuffle(values),values))
+    end)   
+  
+  end)
+  
+  describe('toArray', function()
+  
+    it('converts a vararg list to an array', function()
+      assert.is_true(M.isArray(M.toArray(1,2,3,4)))
+      assert.is_true(M.isEqual(M.toArray(1,2,8,'d','a',0),{1,2,8,'d','a',0}))      
+    end)
+
+    it('preserves input order', function()
+      local args = M.toArray(1,2,3,4,5)
+      for i = 1, 5 do assert.equal(args[i], i) end
     end)
     
   end)
 
-  context('find', function()
+  describe('find', function()
   
-    test('looks for a value in a given array and returns its position', function()
-      assert_equal(_.find({4,3,2,1},2), 3)
+    it('looks for a value in a given array and returns its position', function()
+      assert.equal(M.find({4,3,2,1},2), 3)
     end)
 
-    test('uses _.isEqual to compare values', function()
-      assert_equal(_.find({{4},{3},{2},{1}},{3}), 2)
+    it('uses M.isEqual to compare values', function()
+      assert.equal(M.find({{4},{3},{2},{1}},{3}), 2)
     end)
     
-    test('returns the index of the first occurence', function()
-      assert_equal(_.find({4,4,3,3,2,2,1,1},2),5)
+    it('returns the index of the first occurence', function()
+      assert.equal(M.find({4,4,3,3,2,2,1,1},2),5)
     end)
 
-    test('can start the search at a specific position', function()
-      assert_equal(_.find({4,4,3,3,2,1,2,1,1},2,6),7)
+    it('can start the search at a specific position', function()
+      assert.equal(M.find({4,4,3,3,2,1,2,1,1},2,6),7)
     end)
     
   end)
 
-  context('reverse', function()
+  describe('reverse', function()
   
-    test('reverse values and objects in a given array', function()
-      assert_true(_.isEqual(_.reverse({1,2,3,'d'}),{'d',3,2,1}))
+    it('reverse values and objects in a given array', function()
+      assert.is_true(M.isEqual(M.reverse({1,2,3,'d'}),{'d',3,2,1}))
     end)
     
   end)
   
-  context('fill', function()
+  describe('fill', function()
   
-    test('fills an array with a value', function()
-			local array = _.range(1,5)
-      assert_true(_.isEqual(_.fill(array,0),{0,0,0,0,0}))
+    it('fills an array with a value', function()
+			local array = M.range(1,5)
+      assert.is_true(M.isEqual(M.fill(array,0),{0,0,0,0,0}))
     end)
 		
-    test('fills an array starting from an index', function()
-			local array = _.range(1,5)
-      assert_true(_.isEqual(_.fill(array,0,4),{1,2,3,0,0}))
+    it('fills an array starting from an index', function()
+			local array = M.range(1,5)
+      assert.is_true(M.isEqual(M.fill(array,0,4),{1,2,3,0,0}))
     end)		
     
-    test('fills an array replacing values inside a range', function()
-			local array = _.range(1,5)
-      assert_true(_.isEqual(_.fill(array,0,3,4),{1,2,0,0,5}))
+    it('fills an array replacing values inside a range', function()
+			local array = M.range(1,5)
+      assert.is_true(M.isEqual(M.fill(array,0,3,4),{1,2,0,0,5}))
     end)
 		
-    test('enlarges the array when the last index is greater than array size', function()
-			local array = _.range(1,5)
-      assert_true(_.isEqual(_.fill(array,0,3,8),{1,2,0,0,0,0,0,0}))
+    it('enlarges the array when the last index is greater than array size', function()
+			local array = M.range(1,5)
+      assert.is_true(M.isEqual(M.fill(array,0,3,8),{1,2,0,0,0,0,0,0}))
     end)
 		
   end)
 	
-  context('selectWhile', function()
+  describe('zeros', function()
+    
+    it('returns an array of n zeros', function()
+      assert.is_true(M.isEqual(M.zeros(5), {0,0,0,0,0}))
+      assert.is_true(M.isEqual(M.zeros(2), {0,0}))
+      assert.is_true(M.isEqual(M.zeros(1), {0}))
+    end)
   
-    test('collect values from an array while they pass a thruth test', function()
-      assert_true(_.isEqual(_.selectWhile({2,4,6,8}, function(i,v)
-          return v%2==0
-        end),{2,4,6,8}))
+  end)
+  
+  describe('ones', function()
+    
+    it('returns an array of n zeros', function()
+      assert.is_true(M.isEqual(M.ones(5), {1,1,1,1,1}))
+      assert.is_true(M.isEqual(M.ones(3), {1,1,1}))
+      assert.is_true(M.isEqual(M.ones(1), {1}))
+    end)
+  
+  end)  
+  
+  describe('vector', function()
+    
+    it('returns an array of n times a given value', function()
+      assert.is_true(M.isEqual(M.vector(false,4), {false, false, false, false}))
+      local f = function() end
+      assert.is_true(M.isEqual(M.vector(f,2), {f, f}))
+    end)
+  
+  end)
+  
+  describe('selectWhile', function()
+  
+    it('collect values from an array while they pass a thruth test', function()
+      assert.is_true(M.isEqual(M.selectWhile({2,4,6,8}, function(v)return v%2==0 end),{2,4,6,8}))
     end)
     
-    test('breaks as soon as one value do not pass the test', function()
-      assert_true(_.isEqual(_.selectWhile({2,4,6,8,9,10,12}, function(i,v)
-          return v%2==0
-        end),{2,4,6,8}))
+    it('breaks as soon as one value do not pass the test', function()
+      assert.is_true(M.isEqual(M.selectWhile({2,4,6,8,9,10,12}, function(v) return v%2==0 end),{2,4,6,8}))
     end)
     
   end)  
    
-  context('dropWhile', function()
+  describe('dropWhile', function()
   
-    test('rejects values from an array while they pass a thruth test', function()
-      assert_true(_.isEqual(_.dropWhile({2,4,6,8}, function(i,v)
-          return v%2==0
-        end),{}))
+    it('rejects values from an array while they pass a thruth test', function()
+      assert.is_true(M.isEqual(M.dropWhile({2,4,6,8}, function(v) return v%2==0 end),{}))
     end)
     
-    test('breaks as soon as one value do not pass the test', function()
-      assert_true(_.isEqual(_.dropWhile({2,4,6,8,9,10,12}, function(i,v)
-          return v%2==0
-        end),{9,10,12}))
+    it('breaks as soon as one value do not pass the test', function()
+      assert.is_true(M.isEqual(M.dropWhile({2,4,6,8,9,10,12}, function(v) return v%2==0 end),{9,10,12}))
     end)
     
   end)  
 
-  context('sortedIndex', function()
+  describe('sortedIndex', function()
   
-    test('returns the index at which a value should be inserted to preserve order', function()
+    it('returns the index at which a value should be inserted to preserve order', function()
       local comp = function(a,b) return a<b end
-      assert_equal(_.sortedIndex({1,2,3},4,comp),4)
+      assert.equal(M.sortedIndex({1,2,3},4,comp),4)
     end)
     
-    test('the given array will be sorted before if boolean arg "sort" is given', function()
+    it('the given array will be sorted before if boolean arg "sort" is given', function()
       local comp = function(a,b) return a<b end
-      assert_equal(_.sortedIndex({0,10,3,-5},4,comp,true),4)
+      assert.equal(M.sortedIndex({0,10,3,-5},4,comp,true),4)
     end)   
     
-    test('when no comparison function is given, uses "<" operator', function()
-      assert_equal(_.sortedIndex({'a','d','e','z'},'b'),2)
+    it('when no comparison function is given, uses "<" operator', function()
+      assert.equal(M.sortedIndex({'a','d','e','z'},'b'),2)
     end)
     
   end)
   
-  context('indexOf', function()
+  describe('indexOf', function()
   
-    test('returns the index of a value in an array', function()
-      assert_equal(_.indexOf({1,2,3},2),2)
+    it('returns the index of a value in an array', function()
+      assert.equal(M.indexOf({1,2,3},2),2)
     end)
     
-    test('returns nil when value was not found', function()
-      assert_nil(_.indexOf({'a','b','c','d'},'e'))
+    it('returns nil when value was not found', function()
+      assert.is_nil(M.indexOf({'a','b','c','d'},'e'))
     end)  
     
-    test('will always return the index of the first occurence', function()
-      assert_equal(_.indexOf({'a','d','d','z'},'d'),2)
+    it('will always return the index of the first occurence', function()
+      assert.equal(M.indexOf({'a','d','d','z'},'d'),2)
     end)
     
   end)
 
-  context('lastIndexOf', function()
+  describe('lastIndexOf', function()
   
-    test('returns the index of the last occurence of a value in an array', function()
-      assert_equal(_.lastIndexOf({1,2,3},2),2)
-      assert_equal(_.lastIndexOf({'a','d','d','z'},'d'),3)
+    it('returns the index of the last occurence of a value in an array', function()
+      assert.equal(M.lastIndexOf({1,2,3},2),2)
+      assert.equal(M.lastIndexOf({'a','d','d','z'},'d'),3)
     end)
     
-    test('returns nil when value was not found', function()
-      assert_nil(_.lastIndexOf({'a','b','c','d'},'e'))
+    it('returns nil when value was not found', function()
+      assert.is_nil(M.lastIndexOf({'a','b','c','d'},'e'))
     end)  
     
   end)
 	
-  context('findIndex', function()
+  describe('findIndex', function()
   
-    test('returns the first index at which a predicate passes a truth test', function()
-      assert_equal(_.findIndex({1,2,3,4,5},function(__,v) return v%2==0 end),2)
+    it('returns the first index at which a predicate passes a truth test', function()
+      assert.equal(M.findIndex({1,2,3,4,5},function(__,v) return v%2==0 end),2)
     end)
     
-    test('returns nil when nothing was found', function()
-      assert_nil(_.findIndex({1,2,3,4,5},function(_,v) return v>5 end))
+    it('returns nil when nothing was found', function()
+      assert.is_nil(M.findIndex({1,2,3,4,5},function(_,v) return v>5 end))
     end)  
     
   end)	
 	
-  context('findLastIndex', function()
+  describe('findLastIndex', function()
   
-    test('returns the last index at which a predicate passes a truth test', function()
-      assert_equal(_.findLastIndex({1,2,3,4,5},function(_,v) return v%2==0 end),4)
+    it('returns the last index at which a predicate passes a truth test', function()
+      assert.equal(M.findLastIndex({1,2,3,4,5},function(_,v) return v%2==0 end),4)
     end)
     
-    test('returns nil when nothing was found', function()
-      assert_nil(_.findLastIndex({1,2,3,4,5},function(_,v) return v>5 end))
+    it('returns nil when nothing was found', function()
+      assert.is_nil(M.findLastIndex({1,2,3,4,5},function(_,v) return v>5 end))
     end)  
     
   end)
 	
-  context('addTop', function()
+  describe('addTop', function()
   
-    test('adds values at the top of an array', function()
-      assert_true(_.isEqual(_.addTop({},1,2,3),{3,2,1}))
-      assert_true(_.isEqual(_.addTop({},'a',true,3),{3,true,'a'}))
+    it('adds values at the top of an array', function()
+      assert.is_true(M.isEqual(M.addTop({},1,2,3),{3,2,1}))
+      assert.is_true(M.isEqual(M.addTop({},'a',true,3),{3,true,'a'}))
     end)
 
-    test('preserves the existing elements', function()
-      assert_true(_.isEqual(_.addTop({1,2},1,2,3),{3,2,1,1,2}))
-      assert_true(_.isEqual(_.addTop({'i','j'},'a',true,3),{3,true,'a','i','j'}))
+    it('preserves the existing elements', function()
+      assert.is_true(M.isEqual(M.addTop({1,2},1,2,3),{3,2,1,1,2}))
+      assert.is_true(M.isEqual(M.addTop({'i','j'},'a',true,3),{3,true,'a','i','j'}))
     end)    
     
   end)
 
-  context('push', function()
+  describe('prepend', function()
+  
+    it('adds values at the top of an array, preserving order', function()
+      assert.is_true(M.isEqual(M.prepend({},1,2,3),{1,2,3}))
+      assert.is_true(M.isEqual(M.prepend({},'a',true,3),{'a',true,3}))
+    end)
+
+    it('preserves the existing elements', function()
+      assert.is_true(M.isEqual(M.prepend({1,2},1,2,3),{1,2,3,1,2}))
+      assert.is_true(M.isEqual(M.prepend({'i','j'},'a',true,3),{'a',true,3,'i','j'}))
+    end)    
+    
+  end)
+  
+  describe('push', function()
   
-    test('appends values at the end of an array', function()
-      assert_true(_.isEqual(_.push({},1,2,3),{1,2,3}))
-      assert_true(_.isEqual(_.push({},'a',true,3),{'a',true,3}))
+    it('appends values at the end of an array', function()
+      assert.is_true(M.isEqual(M.push({},1,2,3),{1,2,3}))
+      assert.is_true(M.isEqual(M.push({},'a',true,3),{'a',true,3}))
     end) 
 
-    test('preserves the existing elements', function()
-      assert_true(_.isEqual(_.push({1,2},1,2,3),{1,2,1,2,3}))
-      assert_true(_.isEqual(_.push({'i','j'},'a',true,3),{'i','j','a',true,3}))
+    it('preserves the existing elements', function()
+      assert.is_true(M.isEqual(M.push({1,2},1,2,3),{1,2,1,2,3}))
+      assert.is_true(M.isEqual(M.push({'i','j'},'a',true,3),{'i','j','a',true,3}))
     end)      
     
   end)  
 
-  context('pop', function()
+  describe('shift', function()
   
-    test('returns the value at the top of a given array', function()
-        assert_equal(_.pop {1,7,9} ,1)
+    it('returns the value at the top of a given array', function()
+        assert.equal(M.shift {1,7,9} ,1)
     end) 
 
-    test('also removes this value from the given array', function()
+    it('also removes this value from the given array', function()
       local array = {1,7,9}
-      assert_equal(_.pop(array),1)
-      assert_true(_.isEqual(array,{7,9}))
+      assert.equal(M.shift(array),1)
+      assert.is_true(M.isEqual(array,{7,9}))
     end)  
     
   end)  
   
-  context('unshift', function()
+  describe('unshift', function()
   
-    test('returns the value at the end of a given array', function()
-        assert_equal(_.unshift {1,7,9} ,9)
+    it('returns the value at the end of a given array', function()
+        assert.equal(M.unshift {1,7,9} ,9)
     end) 
 
-    test('also removes this value from the given array', function()
+    it('also removes this value from the given array', function()
       local array = {1,7,9}
-      assert_equal(_.unshift(array),9)
-      assert_true(_.isEqual(array,{1,7}))
+      assert.equal(M.unshift(array),9)
+      assert.is_true(M.isEqual(array,{1,7}))
     end) 
     
   end)
 
-  context('pull', function()
+  describe('pull', function()
   
-    test('removes all listed values in a given array', function()
-      assert_true(_.same(_.pull({1,4,3,1,2,3},1),{4,3,2,3}))
-      assert_true(_.same(_.pull({1,4,3,1,2,3},1,3),{4,2}))
+    it('removes all listed values in a given array', function()
+      assert.is_true(M.same(M.pull({1,4,3,1,2,3},1),{4,3,2,3}))
+      assert.is_true(M.same(M.pull({1,4,3,1,2,3},1,3),{4,2}))
     end)
     
   end)
   
-  context('removeRange', function()
+  describe('removeRange', function()
   
-    test('removes all values within "start" and "finish" indexes', function()
-        assert_true(_.isEqual(_.removeRange({1,2,3,4,5,6},2,4),{1,5,6}))
+    it('removes all values within "start" and "finish" indexes', function()
+        assert.is_true(M.isEqual(M.removeRange({1,2,3,4,5,6},2,4),{1,5,6}))
     end) 
     
-    test('arg "finish" defaults to the end of the array when not given ', function()
-        assert_true(_.isEqual(_.removeRange({1,2,3,4,5,6},3),{1,2}))
+    it('arg "finish" defaults to the end of the array when not given ', function()
+        assert.is_true(M.isEqual(M.removeRange({1,2,3,4,5,6},3),{1,2}))
     end)    
     
-    test('arg "start" defaults to the initial index when not given ', function()
-        assert_true(_.isEqual(_.removeRange({1,2,3,4,5,6}),{}))
+    it('arg "start" defaults to the initial index when not given ', function()
+        assert.is_true(M.isEqual(M.removeRange({1,2,3,4,5,6}),{}))
     end)
-    
-    test('args "start" and "finish" are be clamped to the array bound ', function()
-        assert_true(_.isEqual(_.removeRange({1,2,3,4,5,6},0,100),{}))
-    end) 
 
-    test('leaves the array untouched when "finish" < "start"', function()
-        assert_true(_.isEqual(_.removeRange({1,2,3,4,5,6},4,2),{1,2,3,4,5,6}))
+    it('throws an error when "finish" < "start"', function()
+        assert.error(function()M.removeRange({1,2,3,4,5,6},4,2) end)
     end)     
     
   end)
 
-  context('chunk', function()
+  describe('chunk', function()
     
-    test('chunks in blocks consecutive values returning the same value from a given function', function()
+    it('chunks in blocks consecutive values returning the same value from a given function', function()
       local t = {1,2,2,3,3,4,4}
-      local v = _.chunk(t, function(k,v) return v%2==0 end)
-      assert_equal(#v, 4)
-      _.each(v[1], function(k)
-        assert_equal(v[1][k],1)
-      end)
-      assert_equal(#v[1],1)      
-      _.each(v[2], function(k)
-        assert_equal(v[2][k],2)
-      end)
-      assert_equal(#v[2],2)            
-      _.each(v[3], function(k)
-        assert_equal(v[3][k],3)
-      end)
-      assert_equal(#v[3],2)            
-      _.each(v[4], function(k)
-        assert_equal(v[4][k],4)
-      end)
-      assert_equal(#v[4],2)              
-    end)
-    
-    test('Returns the first argument in case it is not an array', function()
-      local t = {a = 1, b = 2}
-      assert_equal(_.chunk(t, function(k,v) return v%2==0 end), t)
+      local v = M.chunk(t, function(v) return v%2==0 end)
+      assert.equal(#v, 4)
+      assert.is_true(M.isEqual(v[1], {1}))
+      assert.is_true(M.isEqual(v[2], {2,2}))
+      assert.is_true(M.isEqual(v[3], {3,3}))
+      assert.is_true(M.isEqual(v[4], {4,4}))             
     end)  
     
   end)
   
-  context('slice',function()
+  describe('slice',function()
   
-    test('slices a portion of an array',function()
-      assert_true(_.isEqual(_.slice({'a','b','c','d','e'},2,3),{'b','c'}))
+    it('slices a portion of an array',function()
+      assert.is_true(M.isEqual(M.slice({'a','b','c','d','e'},2,3),{'b','c'}))
     end)
     
-    test('arg "right" bound defaults to the array length when not given',function()
-      assert_true(_.isEqual(_.slice({'a','b','c','d','e'},3),{'c','d','e'}))
+    it('arg "right" bound defaults to the array length when not given',function()
+      assert.is_true(M.isEqual(M.slice({'a','b','c','d','e'},3),{'c','d','e'}))
     end)
 
-    test('arg "left" bound defaults to the initial index when not given',function()
-      assert_true(_.isEqual(_.slice({'a','b','c','d','e'}),{'a','b','c','d','e'}))
+    it('arg "left" bound defaults to the initial index when not given',function()
+      assert.is_true(M.isEqual(M.slice({'a','b','c','d','e'}),{'a','b','c','d','e'}))
     end)     
   
   end)
   
-  context('first',function() 
+  describe('first',function() 
   
-    test('returns the n-first elements', function()
-      assert_true(_.isEqual(_.first({5,8,12,20},2),{5,8}))
+    it('returns the n-first elements', function()
+      assert.is_true(M.isEqual(M.first({5,8,12,20},2),{5,8}))
     end)
   
-    test('arg "n" defaults 1 when not given', function()
-      assert_true(_.isEqual(_.first({5,8,12,20}),{5}))
+    it('arg "n" defaults 1 when not given', function()
+      assert.is_true(M.isEqual(M.first({5,8,12,20}),{5}))
     end)    
     
   end)  
   
-  context('initial',function()  
+  describe('initial',function()  
  
-    test('exludes the last N elements', function()
-      assert_true(_.isEqual(_.initial({5,8,12,20},3),{5}))
-      assert_true(_.isEqual(_.initial({5,8,12,20},4),{}))
+    it('exludes the last N elements', function()
+      assert.is_true(M.isEqual(M.initial({5,8,12,20},3),{5}))
+      assert.is_true(M.isEqual(M.initial({5,8,12,20},4),{}))
     end)
   
-    test('returns all values but the last one if arg "n" was not given', function()
-      assert_true(_.isEqual(_.initial({5,8,12,20}),{5,8,12}))
+    it('returns all values but the last one if arg "n" was not given', function()
+      assert.is_true(M.isEqual(M.initial({5,8,12,20}),{5,8,12}))
     end)
     
-    test('passing "n" greather than the array size returns an empty', function()
-      assert_true(_.isEqual(_.initial({5,8,12,20},5),{}))
+    it('passing "n" greather than the array size returns an empty', function()
+      assert.is_true(M.isEqual(M.initial({5,8,12,20},5),{}))
     end)  
 
-    test('returns the whole array when "n" equals 0', function()
-      assert_true(_.isEqual(_.initial({5,8,12,20},0),{5,8,12,20}))
-    end) 
-
-    test('returns "nil" when arg "n" < 0', function()
-      assert_nil(_.initial({5,8,12,20},-1))
-    end)     
+    it('returns the whole array when "n" equals 0', function()
+      assert.is_true(M.isEqual(M.initial({5,8,12,20},0),{5,8,12,20}))
+    end)    
       
   end) 
 
-  context('last',function()
+  describe('last',function()
  
-    test('returns the last N elements', function()
-      assert_true(_.isEqual(_.last({5,8,12,20},3),{8,12,20}))
-      assert_true(_.isEqual(_.last({5,8,12,20},1),{20}))
-      assert_true(_.isEqual(_.last({5,8,12,20},2),{12,20}))
-      assert_true(_.isEqual(_.last({5,8,12,20},4),{5,8,12,20}))
+    it('returns the last N elements', function()
+      assert.is_true(M.isEqual(M.last({5,8,12,20},3),{8,12,20}))
+      assert.is_true(M.isEqual(M.last({5,8,12,20},1),{20}))
+      assert.is_true(M.isEqual(M.last({5,8,12,20},2),{12,20}))
+      assert.is_true(M.isEqual(M.last({5,8,12,20},4),{5,8,12,20}))
     end)
   
-    test('returns all values but the first one if arg "n" was not given', function()
-      assert_true(_.isEqual(_.last({5,8,12,20}),{8,12,20}))
+    it('returns all values but the first one if arg "n" was not given', function()
+      assert.is_true(M.isEqual(M.last({5,8,12,20}),{8,12,20}))
     end)
     
-    test('if arg "n" is lower than the array size, returns all values', function()
-      assert_true(_.isEqual(_.last({5,8,12,20},5),{5,8,12,20}))
-    end)
-
-    test('returns "nil" when arg "n" <= 0', function()
-      assert_nil(_.last({5,8,12,20},0))
-      assert_nil(_.last({5,8,12,20},-1))
-    end)  
+    it('if arg "n" is lower than the array size, returns all values', function()
+      assert.is_true(M.isEqual(M.last({5,8,12,20},5),{5,8,12,20}))
+    end) 
   
   end) 
 
-  context('rest',function()
+  describe('rest',function()
   
-    test('excludes all values before a given index', function()
-      assert_true(_.isEqual(_.rest({5,8,12,20},2),{8,12,20}))
-      assert_true(_.isEqual(_.rest({5,8,12,20},1),{5,8,12,20}))
-      assert_true(_.isEqual(_.rest({5,8,12,20},4),{20}))
+    it('excludes all values before a given index', function()
+      assert.is_true(M.isEqual(M.rest({5,8,12,20},2),{8,12,20}))
+      assert.is_true(M.isEqual(M.rest({5,8,12,20},1),{5,8,12,20}))
+      assert.is_true(M.isEqual(M.rest({5,8,12,20},4),{20}))
     end) 
 
-    test('returns an empty array when arg "index" > #array', function()
-      assert_true(_.isEqual(_.rest({5,8,12,20},5),{}))
+    it('returns an empty array when arg "index" > #array', function()
+      assert.is_true(M.isEqual(M.rest({5,8,12,20},5),{}))
     end) 
 
-    test('returns all values if arg "index" <= 0', function()
-      assert_true(_.isEqual(_.rest({5,8,12,20},0),{5,8,12,20}))
-      assert_true(_.isEqual(_.rest({5,8,12,20},-1),{5,8,12,20}))
+    it('returns all values if arg "index" <= 0', function()
+      assert.is_true(M.isEqual(M.rest({5,8,12,20},0),{5,8,12,20}))
+      assert.is_true(M.isEqual(M.rest({5,8,12,20},-1),{5,8,12,20}))
     end)     
   
   end)  
 
-  context('nth', function()
+  describe('nth', function()
 
-    test('returns the value at "index"', function()
-      assert_equal(3, _.nth({1,2,3,4,5,6}, 3))
+    it('returns the value at "index"', function()
+      assert.equal(3, M.nth({1,2,3,4,5,6}, 3))
     end)
     
   end)
   
-  context('compact',function() 
+  describe('compact',function() 
   
-    test('trims out all falsy values from an array', function()
-      assert_true(_.isEqual(_.compact({a,'a',false,'b',true}),{'a','b',true}))
+    it('trims out all falsy values from an array', function()
+      assert.is_true(M.isEqual(M.compact({a,'a',false,'b',true}),{'a','b',true}))
     end) 
     
   end)
   
-  context('flatten',function()  
+  describe('flatten',function()  
  
-    test('flattens nested arrays', function()
-      assert_true(_.isEqual(_.flatten({1,{2,3},{4,5,{6,7}}}),{1,2,3,4,5,6,7}))
+    it('flattens nested arrays', function()
+      assert.is_true(M.isEqual(M.flatten({1,{2,3},{4,5,{6,7}}}),{1,2,3,4,5,6,7}))
     end) 
     
-    test('when given arg "shallow", flatten only first level', function()
-      assert_true(_.isEqual(_.flatten({1,{2,3},{4,5,{6,7}}},true),{1,2,3,4,5,{6,7}}))
+    it('when given arg "shallow", flatten only first level', function()
+      assert.is_true(M.isEqual(M.flatten({1,{2,3},{4,5,{6,7}}},true),{1,2,3,4,5,{6,7}}))
     end)     
     
   end)
 
-  context('difference',function() 
+  describe('difference',function() 
   
-    test('returns values in the first array not present in the second array', function()
+    it('returns values in the first array not present in the second array', function()
       local array = {1,2,'a',4,5}
-      assert_true(_.isEqual(_.difference(array,{1,'a'}),{2,4,5}))
-      assert_true(_.isEqual(_.difference(array,{5}),{1,2,'a',4}))
+      assert.is_true(M.isEqual(M.difference(array,{1,'a'}),{2,4,5}))
+      assert.is_true(M.isEqual(M.difference(array,{5}),{1,2,'a',4}))
     end)   
     
-    test('ignores values in the second array not found in the first array', function()
+    it('ignores values in the second array not found in the first array', function()
       local array = {1,2,'a',4,5}
-      assert_true(_.isEqual(_.difference(array,{1,'a','b','c'}),{2,4,5}))
+      assert.is_true(M.isEqual(M.difference(array,{1,'a','b','c'}),{2,4,5}))
     end)
     
-    test('leaves array untouched when given no extra-args', function()
-      assert_true(_.isEqual(_.difference({1,2,'a',4,5}),{1,2,'a',4,5}))
+    it('leaves array untouched when given no extra-args', function()
+      assert.is_true(M.isEqual(M.difference({1,2,'a',4,5}),{1,2,'a',4,5}))
     end)
     
   end)
   
-  context('union',function()  
+  describe('union',function()  
   
-    test('returns the duplicate-free union of all passed-in arrays', function()   
+    it('returns the duplicate-free union of all passed-in arrays', function()   
       local a = {"a"}; local b = {1,2,3}; local c = {2,10}
-      assert_true(_.isEqual(_.union(a,b,c),{'a',1,2,3,10}))
+      assert.is_true(M.isEqual(M.union(a,b,c),{'a',1,2,3,10}))
     end) 
     
-    test('accepts nested arrays as well', function()   
+    it('accepts nested arrays as well', function()   
       local a = {"a",{"b","c"}}; local b = {1,{2},3}; local c = {2,10}
-      assert_true(_.isEqual(_.union(a,b,c),{'a','b','c',1,2,3,10}))
+      assert.is_true(M.isEqual(M.union(a,b,c),{'a','b','c',1,2,3,10}))
     end)     
     
   end)  
   
-  context('intersection',function() 
+  describe('intersection',function() 
   
-    test('returns the intersection of all passed-in arrays', function()   
+    it('returns the intersection of all passed-in arrays', function()   
       local a = {1,3}; local b = {4,2,3}; local c = {2,3,10}
-      assert_true(_.isEqual(_.intersection(a,b,c),{3}))
+      assert.is_true(M.isEqual(M.intersection(a,b,c),{3}))
     end) 
 
-    test('fails with nested arrays', function()   
+    it('fails with nested arrays', function()   
       local a = {1,{3}}; local b = {4,2,3}; local c = {2,3,10}
-      assert_true(_.isEqual(_.intersection(a,b,c),{}))
+      assert.is_true(M.isEqual(M.intersection(a,b,c),{}))
     end)  
     
   end)
   
-  context('symmetricDifference',function() 
+  describe('symmetricDifference',function() 
   
-    test('returns the symmetric difference from two arrays', function()   
+    it('returns the symmetric difference from two arrays', function()   
       local a = {1,3}; local b = {4,2,3}; local c = {2,3,10}
-      assert_true(_.same(_.symmetricDifference(a, b), {1,4,2}))
-      assert_true(_.same(_.symmetricDifference(a, c), {1,2,10}))
-      assert_true(_.same(_.symmetricDifference(b, c), {4,10}))
+      assert.is_true(M.same(M.symmetricDifference(a, b), {1,4,2}))
+      assert.is_true(M.same(M.symmetricDifference(a, c), {1,2,10}))
+      assert.is_true(M.same(M.symmetricDifference(b, c), {4,10}))
     end)
     
   end)
    
-  context('unique',function()  
+  describe('unique',function()  
     
-    test('returns a duplicate-free array',function()
-      assert_true(_.isEqual(_.unique({1,1,2,2,3,3,4,4,4,5}),{1,2,3,4,5}))
+    it('returns a duplicate-free array',function()
+      assert.is_true(M.isEqual(M.unique({1,1,2,2,3,3,4,4,4,5}),{1,2,3,4,5}))
     end)
     
   end)
   
-  context('isunique',function()  
+  describe('isunique',function()  
     
-    test('Checks if a given array is duplicate-free',function()
-      assert_true(_.isunique({1,2,3,4,5}))
-      assert_false(_.isunique({1,2,3,4,4}))
+    it('Checks if a given array is duplicate-free',function()
+      assert.is_true(M.isunique({1,2,3,4,5}))
+      assert.is_false(M.isunique({1,2,3,4,4}))
     end)
     
   end)
   
-  context('zip',function()  
-    test('zips together values from different arrays sharing the same index', function()   
+  describe('zip',function()  
+    it('zips together values from different arrays sharing the same index', function()   
       local names = {'Bob','Alice','James'}; local ages = {22, 23}
-      assert_true(_.isEqual(_.zip(names,ages),{{'Bob',22},{'Alice',23},{'James'}}))
+      assert.is_true(M.isEqual(M.zip(names,ages),{{'Bob',22},{'Alice',23},{'James'}}))
     end)     
   end)  
   
-  context('append',function()  
+  describe('zipWith',function()  
+    it('zips together values from different arrays sharing the same index using a function', function()   
+      local names = {'Bob','Alice','James'}; local ages = {22, 23, 25}
+      local function introduce(name, age) return 'My name is '..name..' and I am '..age..' years old.' end
+      local t = M.zipWith(introduce,names,ages)
+      assert.equal(t[1],'My name is Bob and I am 22 years old.')
+      assert.equal(t[2],'My name is Alice and I am 23 years old.')
+      assert.equal(t[3],'My name is James and I am 25 years old.')
+    end)     
+  end) 
+  
+  describe('append',function()  
     
-    test('appends two arrays together', function()
-      assert_true(_.isEqual(_.append({1,2,3},{'a','b'}),{1,2,3,'a','b'}))
+    it('appends two arrays together', function()
+      assert.is_true(M.isEqual(M.append({1,2,3},{'a','b'}),{1,2,3,'a','b'}))
     end)    
   
   end)  
   
-  context('interleave',function()  
+  describe('interleave',function()  
     
-    test('interleaves values from passed-in arrays', function()
-      assert_true(_.isEqual(_.interleave({1,2,3},{'a','b','c'}),{1,'a',2,'b',3,'c'}))
-      assert_true(_.isEqual(_.interleave({1},{'a','b','c'}),{1,'a','b','c'}))
+    it('interleaves values from passed-in arrays', function()
+      assert.is_true(M.isEqual(M.interleave({1,2,3},{'a','b','c'}),{1,'a',2,'b',3,'c'}))
+      assert.is_true(M.isEqual(M.interleave({1},{'a','b','c'}),{1,'a','b','c'}))
     end)    
   
   end)  
    
-  context('interpose',function()  
+  describe('interpose',function()  
     
-    test('interposes a value in-between values from a passed-in array', function()
-      assert_true(_.isEqual(_.interpose('a',{1,2,3}),{1,'a',2,'a',3}))
-      assert_true(_.isEqual(_.interpose(false,{5,5,5,5}),{5,false,5,false,5,false,5}))
-    end)    
+    it('interposes a value in-between values from a passed-in array', function()
+      assert.is_true(M.isEqual(M.interpose({1,2,3},'a'),{1,'a',2,'a',3}))
+      assert.is_true(M.isEqual(M.interpose({5,5,5,5}, false),{5,false,5,false,5,false,5}))
+    end)
+
+    it('leaves the array untouched if containing a single element', function()
+      assert.is_true(M.isEqual(M.interpose({1},'a'),{1}))
+    end)
   
   end)
   
-  context('range',function()  
+  describe('range',function()  
   
-    test('generate an arithmetic progression', function()
-      assert_true(_.isEqual(_.range(1,5,1),{1,2,3,4,5}))
-      assert_true(_.isEqual(_.range(-2,5,1),{-2,-1,0,1,2,3,4,5}))
-      assert_true(_.isEqual(_.range(1,5,2),{1,3,5}))      
-    end) 
-
-    test('arg "step" default to 1 when no given', function()
-      assert_true(_.isEqual(_.range(1,5),{1,2,3,4,5}))
+    it('generate an arithmetic progression', function()
+      assert.is_true(M.isEqual(M.range(1,5,1),{1,2,3,4,5}))
+      assert.is_true(M.isEqual(M.range(-2,5,1),{-2,-1,0,1,2,3,4,5}))
+      assert.is_true(M.isEqual(M.range(1,5,2),{1,3,5}))      
     end) 
 
-    test('when a limit cannot be reached via "step", returns an empty array', function()
-      assert_true(_.isEqual(_.range(1,5,0),{}))
-      assert_true(_.isEqual(_.range(1,5,-1),{}))
+    it('arg "step" default to 1 or -1 when no given', function()
+      assert.is_true(M.isEqual(M.range(1,5),{1,2,3,4,5}))
+      assert.is_true(M.isEqual(M.range(5,1),{5,4,3,2,1}))
     end)
 
-    test('handles real values as well', function()
-      assert_true(_.isEqual(_.range(3.2,5,0.5),{3.2,3.7,4.2,4.7}))
+    it('handles real values as well', function()
+      assert.is_true(M.isEqual(M.range(3.2,5,0.5),{3.2,3.7,4.2,4.7}))
     end) 
 
-    test('when only one arg is passed, counts from 0', function()
-      assert_true(_.isEqual(_.range(3),{0,1,2,3}))
+    it('when only one arg is passed, counts from 1', function()
+      assert.is_true(M.isEqual(M.range(3),{1,2,3}))
+      assert.is_true(M.isEqual(M.range(-3),{-1,-2,-3}))
     end)     
     
   end)  
   
-  context('rep',function()  
+  describe('rep',function()  
   
-    test('generates a list of n repetitions of a value', function()
-      assert_true(_.isEqual(_.rep('a',4),{'a','a','a','a'})) 
-      assert_true(_.isEqual(_.rep(false,3),{false, false, false})) 
+    it('generates a list of n repetitions of a value', function()
+      assert.is_true(M.isEqual(M.rep('a',4),{'a','a','a','a'})) 
+      assert.is_true(M.isEqual(M.rep(false,3),{false, false, false})) 
+    end)   
+    
+  end)
+
+  describe('powerset',function()  
+  
+    it('generates the powerset of a given array', function()
+      assert.is_true(M.isEqual(M.powerset({1,2,3}),{{1},{2},{3},{1,2},{2,3},{1,2,3}}))
+      assert.is_true(M.isEqual(M.powerset({1,2,3,4}),{{1},{2},{3},{4},{1,2},{2,3},{3,4},{1,2,3},{2,3,4},{1,2,3,4}}))
     end)   
     
   end)  
   
-  context('partition',function()  
+  describe('partition',function()  
   
-    test('iterates on partitions of a given array', function()
-      local array = _.range(1,10)
-      local split5 = {_.range(1,5), _.range(6,10)}
-      local split3 = {_.range(1,3), _.range(4,6), _.range(7,9), {10}}
+    it('iterates on partitions of a given array', function()
+      local array = M.range(1,10)
+      local split5 = {M.range(1,5), M.range(6,10)}
+      local split3 = {M.range(1,3), M.range(4,6), M.range(7,9), {10}}
       local i = 0
-      for p in _.partition(array,5) do
+      for p in M.partition(array,5) do
         i = i + 1
-        assert_true(_.isEqual(p, split5[i]))
+        assert.is_true(M.isEqual(p, split5[i]))
       end
       i = 0
-      for p in _.partition(array,3) do
+      for p in M.partition(array,3) do
         i = i + 1
-        assert_true(_.isEqual(p, split3[i]))
+        assert.is_true(M.isEqual(p, split3[i]))
       end      
     end)   
     
-    test('if a 3rd argument pad is supplied, will adjust the last partition', function()
-      local array = _.range(1,10)
+    it('if a 3rd argument pad is supplied, will adjust the last partition', function()
+      local array = M.range(1,10)
       local split4 = {{1,2,3,4},{5,6,7,8},{9,10,0,0}}
       local i = 0
-      for p in _.partition(array,4,0) do
+      for p in M.partition(array,4,0) do
         i = i + 1
-        assert_true(_.isEqual(p, split4[i]))
+        assert.is_true(M.isEqual(p, split4[i]))
       end     
     end)
 		
   end)
 	
-  context('sliding',function()  
+  describe('overlapping',function()  
   
-    test('returns overlapping subsequences', function()
-      local array = _.range(1,10)
+    it('returns overlapping subsequences', function()
+      local array = M.range(1,10)
 			local sliding2 = {{1,2},{2,3},{3,4},{4,5},{5,6},{6,7},{7,8},{8,9},{9,10}}
 			local sliding3 = {{1,2,3},{3,4,5},{5,6,7},{7,8,9},{9,10}}
 			local sliding5 = {{1,2,3,4,5},{5,6,7,8,9},{9,10}}
       local i = 0
-      for p in _.sliding(array,2) do
+      for p in M.overlapping(array,2) do
         i = i + 1
-        assert_true(_.isEqual(p, sliding2[i]))
+        assert.is_true(M.isEqual(p, sliding2[i]))
       end
       i = 0
-      for p in _.sliding(array,3) do
+      for p in M.overlapping(array,3) do
         i = i + 1
-        assert_true(_.isEqual(p, sliding3[i]))
+        assert.is_true(M.isEqual(p, sliding3[i]))
       end
       i = 0
-      for p in _.sliding(array,5) do
+      for p in M.overlapping(array,5) do
         i = i + 1
-        assert_true(_.isEqual(p, sliding5[i]))
+        assert.is_true(M.isEqual(p, sliding5[i]))
       end  			
     end)
 		
-    test('if a 3rd argument pad is supplied, will adjust the last subsequence', function()
-      local array = _.range(1,10)
+    it('if a 3rd argument pad is supplied, will adjust the last subsequence', function()
+      local array = M.range(1,10)
 			local sliding3 = {{1,2,3},{3,4,5},{5,6,7},{7,8,9},{9,10,0}}
 			local sliding5 = {{1,2,3,4,5},{5,6,7,8,9},{9,10,0,0,0}}
       local i = 0
-      for p in _.sliding(array,3,0) do
+      for p in M.overlapping(array,3,0) do
         i = i + 1
-        assert_true(_.isEqual(p, sliding3[i]))
+        assert.is_true(M.isEqual(p, sliding3[i]))
       end
       i = 0
-      for p in _.sliding(array,5,0) do
+      for p in M.overlapping(array,5,0) do
         i = i + 1
-        assert_true(_.isEqual(p, sliding5[i]))
+        assert.is_true(M.isEqual(p, sliding5[i]))
       end  			
     end)   		
     
-  end)	
+  end)
+
+  describe('aperture', function()
+  
+    it('returns sliding partitions of a given array', function()
+      local array = M.range(1,5)
+      local slides2 = {{1,2},{2,3},{3,4},{4,5}}
+      local slides3 = {{1,2,3},{2,3,4},{3,4,5}}
+      local slides4 = {{1,2,3,4},{2,3,4,5}}
+      local slides5 = {{1,2,3,4,5}}
+      
+      local i = 0
+      for p in M.aperture(array, 2) do
+        i = i + 1
+        assert.is_true(M.isEqual(p, slides2[i]))
+      end
+      
+      i = 0
+      for p in M.aperture(array, 3) do
+        i = i + 1
+        assert.is_true(M.isEqual(p, slides3[i]))
+      end
+      
+      i = 0
+      for p in M.aperture(array, 4) do
+        i = i + 1
+        assert.is_true(M.isEqual(p, slides4[i]))
+      end
+
+      i = 0
+      for p in M.aperture(array, 5) do
+        i = i + 1
+        assert.is_true(M.isEqual(p, slides5[i]))
+      end       
+    end)
+    
+  end)
+  
+  describe('pairwise', function()
+  
+    it('returns sliding partitions of a given array', function()
+      local array = M.range(1,5)
+      local pw = {{1,2},{2,3},{3,4},{4,5}}
+      
+      local i = 0
+      for p in M.pairwise(array) do
+        i = i + 1
+        assert.is_true(M.isEqual(p, pw[i]))
+      end
+    end)
+    
+  end)  
  
-  context('permutation',function()  
+  describe('permutation',function()  
   
-    test('iterates on permutations of a given array', function()
+    it('iterates on permutations of a given array', function()
       local array = {'a','b', 'c'}
       local perm = {'abc','acb', 'bac', 'bca', 'cab', 'cba'}
-      for p in _.permutation(array) do
-        local strp = _.concat(p)
-        _.pull(perm, strp)
+      for p in M.permutation(array) do
+        local strp = M.concat(p)
+        M.pull(perm, strp)
       end
-      assert_true(#perm == 0)
+      assert.is_true(#perm == 0)
     end)   
     
   end)  
  
-  context('invert',function()
+  describe('invert',function()
   
-    test('switches key-values pairs', function()
-      assert_true(_.isEqual(_.invert({1,2,3}),{1,2,3}))
-      assert_true(_.isEqual(_.invert({'a','b','c'}),{a = 1,b = 2,c = 3}))
+    it('switches key-values pairs', function()
+      assert.is_true(M.isEqual(M.invert({1,2,3}),{1,2,3}))
+      assert.is_true(M.isEqual(M.invert({'a','b','c'}),{a = 1,b = 2,c = 3}))
     end)     
     
   end) 
 
-  context('concat',function()  
+  describe('concat',function()  
     
-    test('concatenates an array contents', function()
-      assert_equal(_.concat({1,2,3,4}),'1234')
-      assert_equal(_.concat({'a',1,0,1,'b'}),'a101b')
+    it('concatenates an array contents', function()
+      assert.equal(M.concat({1,2,3,4}),'1234')
+      assert.equal(M.concat({'a',1,0,1,'b'}),'a101b')
     end) 
 
-    test('handles boolean values', function()
-      assert_equal(_.concat({1,true,3,false}),'1true3false')
+    it('handles boolean values', function()
+      assert.equal(M.concat({1,true,3,false}),'1true3false')
     end) 
 
-    test('when arg "sep" is given, uses "sep" as a separator', function()
-      assert_equal(_.concat({1,3,false,'A'},' '),'1 3 false A')
-      assert_equal(_.concat({1,3,false,'A'},', '),'1, 3, false, A')
+    it('when arg "sep" is given, uses "sep" as a separator', function()
+      assert.equal(M.concat({1,3,false,'A'},' '),'1 3 false A')
+      assert.equal(M.concat({1,3,false,'A'},', '),'1, 3, false, A')
     end) 
 
-    test('when args "i" and/or "j" are given, concats values within "i" and "j" indexes', function()
-      assert_equal(_.concat({1,3,false,'A'},' ',2,3),'3 false')
-      assert_equal(_.concat({1,3,false,'A'},', ',2,3),'3, false')
-      assert_equal(_.concat({1,3,false,'A','K'},' ',2),'3 false A K')
+    it('when args "i" and/or "j" are given, concats values within "i" and "j" indexes', function()
+      assert.equal(M.concat({1,3,false,'A'},' ',2,3),'3 false')
+      assert.equal(M.concat({1,3,false,'A'},', ',2,3),'3, false')
+      assert.equal(M.concat({1,3,false,'A','K'},' ',2),'3 false A K')
     end)  
   
+  end) 
+  
+  describe('xprod',function()
+  
+    it('returns all possible pairs', function()
+      local r = M.xprod({1,2,3},{'a','b'})
+      assert.is_true(M.isEqual(r[1],{1,'a'}))
+      assert.is_true(M.isEqual(r[2],{1,'b'}))
+      assert.is_true(M.isEqual(r[3],{2,'a'}))
+      assert.is_true(M.isEqual(r[4],{2,'b'}))
+      assert.is_true(M.isEqual(r[5],{3,'a'}))
+      assert.is_true(M.isEqual(r[6],{3,'b'}))
+    end)     
+    
+  end)
+  
+  describe('sum',function()
+  
+    it('returns the sum of array values', function()
+      assert.equal(M.sum {1,2,3,4,5}, 15)
+      assert.equal(M.sum {1,2,3,4}, 10)
+      assert.equal(M.sum {1,2,3}, 6)
+    end)     
+    
+  end)
+
+  describe('product',function()
+  
+    it('returns the product of array values', function()
+      assert.equal(M.product {1,2,3,4,5}, 120)
+      assert.equal(M.product {1,2,3,4}, 24)
+      assert.equal(M.product {1,2,3}, 6)
+    end)     
+    
+  end)
+
+  describe('mean',function()
+  
+    it('returns the mean of array values', function()
+      assert.equal(M.mean {1,2,3,4,5}, 3)
+      assert.equal(M.mean {1,2,3,4}, 2.5)
+    end)     
+    
+  end)
+
+  describe('meadian',function()
+  
+    it('returns the median of array values', function()
+      assert.equal(M.median {1,2,3,4,5}, 3)
+      assert.equal(M.median {1,2,3,4}, 2.5)
+    end)     
+    
   end)  
   
 end)
\ No newline at end of file
diff -pruN 1.6.1+git20170613-2/spec/chaining_spec.lua 2.0.0-3/spec/chaining_spec.lua
--- 1.6.1+git20170613-2/spec/chaining_spec.lua	2017-06-03 16:42:55.000000000 +0000
+++ 2.0.0-3/spec/chaining_spec.lua	2018-08-23 16:26:20.000000000 +0000
@@ -1,34 +1,34 @@
 require 'luacov'
-local _ = require 'moses'
+local M = require 'moses'
 
-context('Chaining specs', function()
+describe('Chaining specs', function()
 
-   context('chain', function()
+   describe('chain', function()
   
-    test('Chains a value',function()
-      local v = _.chain({1,2,3,4})
-        :filter(function(i,k) return k%2~=0 end)
+    it('Chains a value',function()
+      local v = M.chain({1,2,3,4})
+        :filter(function(k) return k%2~=0 end)
         :max()
         :value()
-      assert_equal(v, 3)
+      assert.equal(v, 3)
     end)
     
-    test('_(value) is the same as _.chain(value)', function()
-      local v = _({1,2,3,4})
-        :filter(function(i,k) return k%2~=0 end)
+    it('M(value) is the same as M.chain(value)', function()
+      local v = M({1,2,3,4})
+        :filter(function(k) return k%2~=0 end)
         :max()
         :value()
-      assert_equal(v, 3)    
+      assert.equal(v, 3)    
     end)
     
   end) 
   
-   context('value', function()
+   describe('value', function()
   
-    test('Unwraps a chained object',function()
+    it('Unwraps a chained object',function()
       local t = {1,2,3}
-      assert_equal(_.chain(t):value(), t)
-      assert_equal(_(t):value(), t)
+      assert.equal(M.chain(t):value(), t)
+      assert.equal(M(t):value(), t)
     end)
     
   end)   
diff -pruN 1.6.1+git20170613-2/spec/func_spec.lua 2.0.0-3/spec/func_spec.lua
--- 1.6.1+git20170613-2/spec/func_spec.lua	2017-06-03 16:42:55.000000000 +0000
+++ 2.0.0-3/spec/func_spec.lua	2018-08-23 16:26:20.000000000 +0000
@@ -1,537 +1,642 @@
 require 'luacov'
-local _ = require 'moses'
+local M = require 'moses'
 
-context('Utility functions specs', function()
+describe('Utility functions specs', function()
 
-  context('noop', function()
+  describe('noop', function()
   
-    test('the no-operation function',function()
-			assert_nil(_.noop())
-			assert_nil(_.noop(nil))
-			assert_nil(_.noop(false))
-			assert_nil(_.noop({}))
-			assert_nil(_.noop(function() end))
-			assert_nil(_.noop(_.noop))
+    it('the no-operation function',function()
+			assert.is_nil(M.noop())
+			assert.is_nil(M.noop(nil))
+			assert.is_nil(M.noop(false))
+			assert.is_nil(M.noop({}))
+			assert.is_nil(M.noop(function() end))
+			assert.is_nil(M.noop(M.noop))
     end)
     
   end)
 	
-  context('identity', function()
+  describe('identity', function()
   
-    test('returns the received value',function()
-      assert_equal(_.identity(1),1)
+    it('returns the received value',function()
+      assert.equal(M.identity(1),1)
       local v = {x = 0}      
-      assert_equal(_.identity(v),v)
-      assert_not_equal(v,{x = 0})
+      assert.equal(M.identity(v),v)
+      assert.is_not.equals(v,{x = 0})
     end)
     
   end)
 	
-  context('constant', function()
+  describe('constant', function()
   
-    test('creates a constant function',function()
-			local gravity = _.constant(9.81)
-			assert_equal(gravity(),9.81)
-			assert_equal(gravity(10), 9.81)
-			assert_equal(gravity(nil), 9.81)
+    it('creates a constant function',function()
+			local gravity = M.constant(9.81)
+			assert.equal(gravity(),9.81)
+			assert.equal(gravity(10), 9.81)
+			assert.equal(gravity(nil), 9.81)
     end)
     
   end)	
   
-	context('memoize', function()
+  describe('applySpec', function()
+  
+    it('returns a spec function which produces objects',function()
+      local stats = M.applySpec({
+        min = function(...) return math.min(...) end,
+        max = function(...) return math.max(...) end,
+      })
+
+			for i = 1, 10 do
+        local mn, mx = math.random(1,10), math.random(11,20)
+        local t = M.range(mn, mx)
+        table.sort(t)
+        local unpack = unpack or table.unpack
+        local r = stats(unpack(t))
+        assert.equal(r.min, t[1])
+        assert.equal(r.max, t[#t])
+      end
+    end)
+    
+  end)
+  
+	describe('memoize', function()
 
 	local fib_time, fib_value, mfib_time, mfib_value
 	local fib, mfib
 	
-		before(function()
-			local function fib(n)
-				return n < 2 and n or fib(n-1)+fib(n-2)
-			end      
-			local times = 10
-			local mfib = _.memoize(fib)
-			fib_time = os.clock()
-				for i = 1, times do fib_value = (fib_value or 0)+fib(20) end
-			fib_time = (os.clock()-fib_time)*1000
-			
-			mfib_time = os.clock()
-				for i = 1, times do mfib_value = (mfib_value or 0)+mfib(20) end
-			mfib_time = (os.clock()-mfib_time  )*1000    
-		end)
-	
-		test('memoizes an expensive function by caching its results',function()
-			assert_true(mfib_time<=fib_time)
-		end)
-	
-		test('can take a hash function to compute an unique output for multiple args',function()
-		
-			local function hash(a,b) return (a^13+b^19) end
-			local function fact(a) return a <= 1 and 1 or a*fact(a-1) end
-			local diffFact = function(a,b) return fact(a)-fact(b) end
-			local mdiffFact = _.memoize(function(a,b) return fact(a)-fact(b) end,hash)
-			local times, rep = 100, 10
-			
-			local time = os.clock()
-			for j = 1,times do 
-				for ai = 1,rep do
-					for aj = 1,rep do diffFact(ai,aj) end
-				end
-			end
-			time = (os.clock()-time)*1000
-
-			local mtime = os.clock()
-			for j = 1,times do 
-				for ai = 1,rep do
-					for aj = 1,rep do mdiffFact(ai,aj) end
-				end
-			end
-			mtime = (os.clock()-mtime)*1000
-
-			assert_true(mtime<=time)
-
-		end)
-	
-	end)  
+		it('memoizes an expensive function by caching its results',function()
+        local function fib(n) return n < 2 and n or fib(n-1)+fib(n-2) end
+        local mfib = M.memoize(fib)    
+        assert.equal(fib(10), mfib(10))
+        assert.equal(fib(15), mfib(15))
+        assert.equal(fib(8), mfib(8))
+        assert.equal(fib(13), mfib(13))
+		end)
+	
+	end) 
+  
+  describe('unfold', function()
+  
+    it('builds a list from a seed value using a iterator',function()
+      local function iter(seed) 
+        if seed < 100 then return seed, seed * 2 end
+      end
+      assert.is_true(M.isEqual(M.unfold(iter,1),{1,2,4,8,16,32,64}))
+      assert.is_true(M.isEqual(M.unfold(iter,5),{5, 10,20,40,80}))
+      assert.is_true(M.isEqual(M.unfold(iter,10),{10,20,40,80}))
+    end)
+    
+  end)  
 
-  context('once', function()
+  describe('once', function()
   
-    test('returns a version of a function that runs once',function()
-      local sq = _.once(function(a) return a*a end)
-      assert_equal(sq(2),4)
+    it('returns a version of a function that runs once',function()
+      local sq = M.once(function(a) return a*a end)
+      assert.equal(sq(2),4)
     end)
     
-    test('successive calls will keep yielding the original answer',function()
-      local sq = _.once(function(a) return a*a end)
+    it('successive calls will keep yielding the original answer',function()
+      local sq = M.once(function(a) return a*a end)
       for i = 1,10 do
-        assert_equal(sq(i),1)
+        assert.equal(sq(i),1)
       end
     end)    
     
   end)
 	
-  context('before', function()
+  describe('before', function()
   
-    test('returns a version of a function that runs no more than count-th calls',function()
+    it('returns a version of a function that runs no more than count-th calls',function()
       local function say(something) return something end
-			local speak3times = _.before(say, 3)
-      assert_equal(speak3times('a'), 'a')
-      assert_equal(speak3times('b'), 'b')
-      assert_equal(speak3times('c'), 'c')
-      assert_equal(speak3times('d'), 'c')
-      assert_equal(speak3times('e'), 'c')
-      assert_equal(speak3times('f'), 'c')
+			local speak3times = M.before(say, 3)
+      assert.equal(speak3times('a'), 'a')
+      assert.equal(speak3times('b'), 'b')
+      assert.equal(speak3times('c'), 'c')
+      assert.equal(speak3times('d'), 'c')
+      assert.equal(speak3times('e'), 'c')
+      assert.equal(speak3times('f'), 'c')
     end)
     
   end)	
 	
    
-  context('after', function()
+  describe('after', function()
   
-    test('returns a function that will respond on its count-th call',function()
+    it('returns a function that will respond on its count-th call',function()
       local function a(r) return (r) end
-      a = _.after(a,5)
+      a = M.after(a,5)
       for i = 1,10 do
         if i < 5 then 
-          assert_nil(a(i))
+          assert.is_nil(a(i))
         else 
-          assert_equal(a(i),i)
+          assert.equal(a(i),i)
         end
       end
     end)
     
   end) 
   
-  context('compose', function()
+  describe('compose', function()
     
-    test('can compose commutative functions',function()
+    it('can compose commutative functions',function()
       local greet = function(name) return "hi: " .. name end
       local exclaim = function(sentence) return sentence .. "!" end
-      assert_equal(_.compose(greet,exclaim)('moe'),'hi: moe!')
-      assert_equal(_.compose(exclaim,greet)('moe'),'hi: moe!')
+      assert.equal(M.compose(greet,exclaim)('moe'),'hi: moe!')
+      assert.equal(M.compose(exclaim,greet)('moe'),'hi: moe!')
     end)
     
-    test('composes mutiple functions',function()
+    it('composes mutiple functions',function()
       local function f(x) return x^2 end
       local function g(x) return x+1 end
       local function h(x) return x/2 end
-      local compositae = _.compose(f,g,h)
-      assert_equal(compositae(10),36)
-      assert_equal(compositae(20),121)
+      local compositae = M.compose(f,g,h)
+      assert.equal(compositae(10),36)
+      assert.equal(compositae(20),121)
     end)   
 
-    test('compose non commutative functions in reverse order',function()
+    it('compose non commutative functions in reverse order',function()
       local function f(s) return (s or '')..'f' end
       local function g(s) return (s or '')..'g' end
       local function h(s) return (s or '')..'h' end
-      assert_equal(_.compose(f,g,h)(),'hgf')
-      assert_equal(_.compose(h,g,f)(),'fgh')
-      assert_equal(_.compose(f,h,g)(),'ghf')
-      assert_equal(_.compose(g,h,f)(),'fhg')
+      assert.equal(M.compose(f,g,h)(),'hgf')
+      assert.equal(M.compose(h,g,f)(),'fgh')
+      assert.equal(M.compose(f,h,g)(),'ghf')
+      assert.equal(M.compose(g,h,f)(),'fhg')
     end) 		
     
   end) 
 
-  context('pipe', function()
+  describe('pipe', function()
     
-    test('pipes a value through a series of functions',function()
+    it('pipes a value through a series of functions',function()
       local function f(x) return x^2 end
       local function g(x) return x+1 end
       local function h(x) return x/2 end
-      assert_equal(_.pipe(10,f,g,h),36)
-      assert_equal(_.pipe(20,f,g,h),121)  
+      assert.equal(M.pipe(10,f,g,h),36)
+      assert.equal(M.pipe(20,f,g,h),121)  
     end) 
     
   end)
 
-  context('complement', function()
+  describe('complement', function()
     
-    test('returns a function which returns the logical complement of a given function',function()
-      assert_false(_.complement(function() return true end)())
-      assert_true(_.complement(function() return false end)())
-      assert_true(_.complement(function() return nil end)())
-      assert_false(_.complement(function() return 1 end)())
+    it('returns a function which returns the logical complement of a given function',function()
+      assert.is_false(M.complement(function() return true end)())
+      assert.is_true(M.complement(function() return false end)())
+      assert.is_true(M.complement(function() return nil end)())
+      assert.is_false(M.complement(function() return 1 end)())
     end) 
     
   end)
   
-  context('juxtapose', function()
+  describe('juxtapose', function()
     
-    test('calls a sequence of functions with the same set of args',function()
+    it('calls a sequence of functions with the same set of args',function()
       local function f(x) return x^2 end
       local function g(x) return x+1 end
       local function h(x) return x/2 end
-      local rf, rg, rh = _.juxtapose(10, f, g, h)
-      assert_equal(rf, 100)
-      assert_equal(rg, 11)
-      assert_equal(rh, 5)
+      local rf, rg, rh = M.juxtapose(10, f, g, h)
+      assert.equal(rf, 100)
+      assert.equal(rg, 11)
+      assert.equal(rh, 5)
     end) 
     
   end)
   
-  context('wrap', function()
+  describe('wrap', function()
   
-    test('wraps a function and passes args',function()
+    it('wraps a function and passes args',function()
       local greet = function(name) return "hi: " .. name end
-      local backwards = _.wrap(greet, function(f,arg)
+      local backwards = M.wrap(greet, function(f,arg)
           return f(arg) ..'\nhi: ' .. arg:reverse()
         end) 
-      assert_equal(backwards('john'),'hi: john\nhi: nhoj')
+      assert.equal(backwards('john'),'hi: john\nhi: nhoj')
     end)
     
   end)
   
-  context('times', function()
+  describe('times', function()
   
-    test('calls a given function n times',function()
+    it('calls a given function n times',function()
       local f = ('Lua programming'):gmatch('.')
-      local r = _.times(3,f)
-      assert_true(_.isEqual(r,{'L','u','a'}))
+      local r = M.times(f, 3)
+      assert.is_true(M.isEqual(r,{'L','u','a'}))
       
       local count = 0
       local function counter() count = count+1 end
-      _.times(10,counter)
-      assert_equal(count,10)
+      M.times(counter, 10)
+      assert.equal(count,10)
     end)
     
   end)  
   
-  context('bind', function()
+  describe('bind', function()
   
-    test('binds a value to the first arg of a function',function()
-      local sqrt2 = _.bind(math.sqrt,2)
-      assert_equal(sqrt2(),math.sqrt(2))
+    it('binds a value to the first arg of a function',function()
+      local sqrt2 = M.bind(math.sqrt,2)
+      assert.equal(sqrt2(),math.sqrt(2))
     end)
     
   end) 
 
-  context('bind2', function()
+  describe('bind2', function()
   
-    test('binds a value to the second arg of a function',function()
-      local last2 = _.bind2(_.last,2)
+    it('binds a value to the second arg of a function',function()
+      local last2 = M.bind2(M.last,2)
       local r = last2({1,2,3,4,5,6})
-      assert_true(_.isEqual(r, {5,6}))
+      assert.is_true(M.isEqual(r, {5,6}))
     end)
     
   end)
 
-  context('bindn', function()
+  describe('bindn', function()
   
-    test('binds n values to as the n-first args of a function',function()
+    it('binds n values to as the n-first args of a function',function()
       local function out(...)
         return table.concat {...}
       end
-      out = _.bindn(out,'OutPut',':',' ')
-      assert_equal(out(1,2,3),'OutPut: 123')
-      assert_equal(out('a','b','c','d'),'OutPut: abcd')
+      out = M.bindn(out,'OutPut',':',' ')
+      assert.equal(out(1,2,3),'OutPut: 123')
+      assert.equal(out('a','b','c','d'),'OutPut: abcd')
     end)
     
   end)
   
-  context('bindAll', function()
+  describe('bindall', function()
   
-    test('binds methods to object',function()
+    it('binds methods to object',function()
 			local window = {
 				setPos = function(w,x,y) w.x, w.y = x, y end, 
 				setName = function(w,name) w.name = name end,
 				getName = function(w) return w.name end,
 			}
-			window = _.bindAll(window, 'setPos', 'setName', 'getName')
+			window = M.bindall(window, 'setPos', 'setName', 'getName')
 			window.setPos(10,15)
 			window.setName('fooApp')
 			
-			assert_equal(window.x, 10)
-			assert_equal(window.y, 15)
-			assert_equal(window.name, 'fooApp')
-			assert_equal(window.getName(), 'fooApp')
+			assert.equal(window.x, 10)
+			assert.equal(window.y, 15)
+			assert.equal(window.name, 'fooApp')
+			assert.equal(window.getName(), 'fooApp')
+    end)
+    
+  end)
+
+  describe('cond', function()
+  
+    it('return a function which runs a set of predicates',function()
+      local multipleOf = M.cond({
+        {function(v) return v%2==0 end, function(v) return v..' is multiple of 2' end},
+        {function(v) return v%3==0 end, function(v) return v..' is multiple of 3' end},
+        {function(v) return v%5==0 end, function(v) return v..' is multiple of 5' end},
+        {function() return true end, function(v) return 'could not find an answer for '..v end}
+      })
+      for i = 15, 20 do
+        assert.equal(multipleOf(i), 
+          i%2 == 0 and i..' is multiple of 2' or 
+          i%3 == 0 and i..' is multiple of 3' or 
+          'could not find an answer for '..i)
+      end
     end)
     
   end)
 	
-  context('uniqueId', function()
+  describe('uniqueId', function()
   
-    test('returns an unique (for the current session) integer Id',function()
+    it('returns an unique (for the current session) integer Id',function()
       local ids = {}
       for i = 1,100 do
-        local newId = _.uniqueId()
-        assert_false(_.include(ids,newId))
-        _.push(ids,newId)
+        local newId = M.uniqueId()
+        assert.is_false(M.include(ids,newId))
+        M.push(ids,newId)
       end     
     end)
     
-    test('accepts a string template to format the returned id',function()
+    it('accepts a string template to format the returned id',function()
       local ids = {}
       for i = 1,100 do
-        local newId = _.uniqueId('ID:%s')
-        assert_equal(newId,'ID:'..newId:sub(4))
-        assert_false(_.include(ids,newId))
-        _.push(ids,newId)
+        local newId = M.uniqueId('ID:%s')
+        assert.equal(newId,'ID:'..newId:sub(4))
+        assert.is_false(M.include(ids,newId))
+        M.push(ids,newId)
       end        
     end)
     
-    test('accepts a function as argument to format the returned id',function()
+    it('accepts a function as argument to format the returned id',function()
       local ids = {}
       local formatter = function(ID) return '$'..ID..'$' end
       for i = 1,100 do
-        local newId = _.uniqueId(formatter)
-        assert_not_nil(newId:match('^%$%d+%$$'))
-        assert_false(_.include(ids,newId))
-        _.push(ids,newId)
+        local newId = M.uniqueId(formatter)
+        assert.is_true(newId:match('^%$%d+%$$') ~= nil)
+        assert.is_false(M.include(ids,newId))
+        M.push(ids,newId)
       end        
     end)
     
   end)  
   
-	context('iterator', function()
+	describe('iterator', function()
 
-		test('creates an iterator which continuously applies f on an input',function()
-			local next_even = _.iterator(function(x) return x + 2 end, 0)
-			assert_equal(next_even(), 2)
-			assert_equal(next_even(), 4)
-			assert_equal(next_even(), 6)
-			assert_equal(next_even(), 8)
-			assert_equal(next_even(),10)
-		end)
+		it('creates an iterator which continuously applies f on an input',function()
+			local next_even = M.iterator(function(x) return x + 2 end, 0)
+			assert.equal(next_even(), 2)
+			assert.equal(next_even(), 4)
+			assert.equal(next_even(), 6)
+			assert.equal(next_even(), 8)
+			assert.equal(next_even(),10)
+		end)
+    
+		it('can be set to run up to a maximum number of calls',function()
+			local next_even = M.iterator(function(x) return x + 2 end, 0, 3)
+			assert.equal(next_even(), 2)
+			assert.equal(next_even(), 4)
+			assert.equal(next_even(), 6)
+			assert.is_nil(next_even())
+		end)    
 		
 	end)
 	
-	context('array', function()
+	describe('array', function()
 
-		test('iterates a given iterator and returns its values in an array',function()
-			local letters = _.array(('Lua'):gmatch('.'))
-			assert_true(_.isEqual(letters,{'L','u','a'}))
+		it('iterates a given iterator and returns its values in an array',function()
+			local letters = M.array(('Lua'):gmatch('.'))
+			assert.is_true(M.isEqual(letters,{'L','u','a'}))
 			
-			local numbers = _.array(pairs(_.range(1,10)))
-			assert_true(_.isEqual(numbers,_.range(1,10)))			
+			local numbers = M.array(pairs(M.range(1,10)))
+			assert.is_true(M.isEqual(numbers,M.range(1,10)))			
 		end)
 		
-	end)	
+	end)
+  
+	describe('castArray', function()
+
+		it('converts value to an array',function()
+      assert.is_true(M.isEqual(M.castArray(1),{1}))
+      assert.is_true(M.isEqual(M.castArray(print),{print}))
+      assert.is_true(M.isEqual(M.castArray(true),{true}))
+		end)
+		
+		it('leaves given value untouched if it is an array',function()
+      local t1 = {1,2}
+      local t2 = {nil, true, false}
+      assert.is_true(M.isEqual(M.castArray(t1),t1))
+      assert.is_true(M.isEqual(M.castArray(t2),t2))
+		end)
+    
+	end)  
 	
-	context('flip', function()
+	describe('flip', function()
 
-		test('creates a function which runs f with arguments flipped',function()
+		it('creates a function which runs f with arguments flipped',function()
 			local function f(...) return table.concat({...}) end
-			local flipped = _.flip(f)
-			assert_equal(flipped('a','b','c'),'cba')
+			local flipped = M.flip(f)
+			assert.equal(flipped('a','b','c'),'cba')
 		end)
 		
-	end)		
+	end)
+
+	describe('nthArg', function()
+
+		it('creates a function which returns the nth arg',function()
+      local f2 = M.nthArg(2)
+      local f3 = M.nthArg(3)
+      local f4 = M.nthArg(4)
+			assert.equal(f2(4,8,5,4,6),8)
+			assert.equal(f3(4,8,5,4,6),5)
+			assert.equal(f4(4,8,5,4,6),4)
+		end)
+		
+		it('if n is negative, will count from the end',function()
+      local f2 = M.nthArg(-2)
+      local f3 = M.nthArg(-3)
+      local f4 = M.nthArg(-4)
+			assert.equal(f2(4,8,5,4,6),4)
+			assert.equal(f3(4,8,5,4,6),5)
+			assert.equal(f4(4,8,5,4,6),8)
+		end)
+    
+	end) 
+ 
+	describe('unary', function()
+
+		it('creates a function which accepts only one arg',function()
+      local f = M.unary(function(...) return ... end)
+      assert.equal(f(1),1)
+      assert.equal(f(1,2),1)
+      assert.equal(f(1,2,3),1)
+		end)
+    
+	end)
+  
+	describe('ary', function()
+
+		it('creates a function which accepts up to n args',function()
+      local f = M.ary(function(...) return ... end, 2)
+      assert.is_true(M.isEqual({f(1,2)},{1,2}))
+      assert.is_true(M.isEqual({f(1,2,3)},{1,2}))
+      assert.is_true(M.isEqual({f(1,2,3,4)},{1,2}))
+		end)
+    
+	end)  
+  
+	describe('rearg', function()
+
+		it('creates a function with args reordered',function()
+      local f = M.rearg(function(...) return ... end, {3,2,1})
+      assert.is_true(M.isEqual({f(1,2,3)},{3,2,1}))
+      assert.is_true(M.isEqual({f(2,1,3)},{3,1,2}))
+      assert.is_true(M.isEqual({f(3,2,1)},{1,2,3}))
+		end)
+    
+	end)   
 	
-	context('over', function()
+	describe('over', function()
 
-		test('returns a function which applies a set of transforms to its args',function()
-			local minmax = _.over(math.min, math.max)
-			local maxmin = _.over(math.max, math.min)
-			assert_true(_.isEqual(minmax(5,10,12,4,3),{3,12}))
-			assert_true(_.isEqual(maxmin(5,10,12,4,3),{12,3}))	
+		it('returns a function which applies a set of transforms to its args',function()
+			local minmax = M.over(math.min, math.max)
+			local maxmin = M.over(math.max, math.min)
+			assert.is_true(M.isEqual(minmax(5,10,12,4,3),{3,12}))
+			assert.is_true(M.isEqual(maxmin(5,10,12,4,3),{12,3}))	
 		end)
 		
 	end)		
 	
-	context('overEvery', function()
+	describe('overEvery', function()
 		
 		local alleven, allpositive
 		
-		before(function()
-			alleven = function(...) 
-				for i, v in ipairs({...}) do if v%2~=0 then return false end end 
-				return true 
-			end
-
-			allpositive = function(...)
-				for i, v in ipairs({...}) do if v < 0 then return false end end
-				return true 	
-			end		
-		end)
-		
-		test('checks if all predicates passes truth with args. ',function()
-			local allok = _.overEvery(alleven, allpositive)
-			assert_false(allok(2,4,-1,8))
-			assert_false(allok(10,3,2,6))
-			assert_true(allok(8,4,6,10))
+    alleven = function(...) 
+      for i, v in ipairs({...}) do if v%2~=0 then return false end end 
+      return true 
+    end
+
+    allpositive = function(...)
+      for i, v in ipairs({...}) do if v < 0 then return false end end
+      return true 	
+    end
+		
+		it('checks if all predicates passes truth with args. ',function()
+			local allok = M.overEvery(alleven, allpositive)
+			assert.is_false(allok(2,4,-1,8))
+			assert.is_false(allok(10,3,2,6))
+			assert.is_true(allok(8,4,6,10))
 		end)
 		
 	end)
 
-	context('overSome', function()
+	describe('overSome', function()
 		
 		local alleven, allpositive
 		
-		before(function()
-			alleven = function(...) 
-				for i, v in ipairs({...}) do if v%2~=0 then return false end end 
-				return true 
-			end
-
-			allpositive = function(...)
-				for i, v in ipairs({...}) do if v < 0 then return false end end
-				return true 	
-			end		
-		end)
-		
-		test('checks if all predicates passes truth with args. ',function()
-			local anyok = _.overSome(alleven, allpositive)
-			assert_false(anyok(2,4,-1,8))
-			assert_true(anyok(10,3,2,6))
-			assert_false(anyok(-1,-5,-3))
+    alleven = function(...) 
+      for i, v in ipairs({...}) do if v%2~=0 then return false end end 
+      return true 
+    end
+
+    allpositive = function(...)
+      for i, v in ipairs({...}) do if v < 0 then return false end end
+      return true 	
+    end
+		
+		it('checks if all predicates passes truth with args. ',function()
+			local anyok = M.overSome(alleven, allpositive)
+			assert.is_false(anyok(2,4,-1,8))
+			assert.is_true(anyok(10,3,2,6))
+			assert.is_false(anyok(-1,-5,-3))
 		end)
 		
 	end)	
 	
-	context('overArgs', function()
+	describe('overArgs', function()
 
-		test('Creates a function that invokes `f` with its arguments transformed',function()
+		it('Creates a function that invokes `f` with its arguments transformed',function()
 			local function f(x, y) return {x, y} end
 			local function triple(x) return x*3 end
 			local function square(x) return x^2 end
-			local new_f = _.overArgs(f, triple, square)
-			assert_true(_.isEqual(new_f(1,2), {3,4}))
-			assert_true(_.isEqual(new_f(10,10), {30,100}))			
+			local new_f = M.overArgs(f, triple, square)
+			assert.is_true(M.isEqual(new_f(1,2), {3,4}))
+			assert.is_true(M.isEqual(new_f(10,10), {30,100}))			
 		end)
 		
-		test('when supplied more args than transforms, remaining are left as-is',function()
+		it('when supplied more args than transforms, remaining are left as-is',function()
 			local function f(x, y, z, k) return {x, y, z, k} end
 			local function triple(x) return x*3 end
 			local function square(x) return x^2 end
-			local new_f = _.overArgs(f, triple, square)
-			assert_true(_.isEqual(new_f(1,2,3,4), {3,4,3,4}))
-			assert_true(_.isEqual(new_f(10,10,10,10), {30,100,10,10}))			
+			local new_f = M.overArgs(f, triple, square)
+			assert.is_true(M.isEqual(new_f(1,2,3,4), {3,4,3,4}))
+			assert.is_true(M.isEqual(new_f(10,10,10,10), {30,100,10,10}))			
 		end)		
 		
 	end)	
 	
-	context('partial', function()
+  describe('converge', function()
+  
+    it('', function()
+      local function pow2(x) return x*x end
+      local function pow3(x) return x*x*x end
+      local function sum(a,b) return a+b end
+      local poly = M.converge(sum, pow2, pow3)
+      assert.equal(poly(5), 150)
+      assert.equal(poly(1), 2)
+      assert.equal(poly(3), 36)
+    end)
+    
+  end)
+  
+	describe('partial', function()
 
-		test('applies partially f',function()
+		it('applies partially f',function()
 			local function diff(a, b) return a - b end
-			local diffFrom20 = _.partial(diff, 20)
-			assert_equal(diffFrom20(5), 15)
-			assert_equal(diffFrom20(10), 10)
-			assert_equal(diffFrom20(-5), 25)
+			local diffFrom20 = M.partial(diff, 20)
+			assert.equal(diffFrom20(5), 15)
+			assert.equal(diffFrom20(10), 10)
+			assert.equal(diffFrom20(-5), 25)
 		end)
 		
-		test('\'_\' can be used as a placeholder',function()
+		it('\'_\' can be used as a placeholder',function()
 			local function diff(a, b) return a - b end
-			local remove10 = _.partial(diff, '_',10)
-			assert_equal(remove10(5), -5)
-			assert_equal(remove10(10), 0)
-			assert_equal(remove10(15), 5)
+			local remove10 = M.partial(diff, '_',10)
+			assert.equal(remove10(5), -5)
+			assert.equal(remove10(10), 0)
+			assert.equal(remove10(15), 5)
 		end)
 		
 	end)
 	
-	context('partialRight', function()
+	describe('partialRight', function()
 
-		test('applies partial but from the right',function()
+		it('applies partial but from the right',function()
 			local function concat(a,b,c,d) return a..b..c..d end
-			assert_equal(_.partialRight(concat,'a','b','c')('d'), 'dabc')
-			assert_equal(_.partialRight(concat,'a','b')('c','d'), 'cdab')
-			assert_equal(_.partialRight(concat,'a')('b','c','d'), 'bcda')
+			assert.equal(M.partialRight(concat,'a','b','c')('d'), 'dabc')
+			assert.equal(M.partialRight(concat,'a','b')('c','d'), 'cdab')
+			assert.equal(M.partialRight(concat,'a')('b','c','d'), 'bcda')
 		end)
 		
-		test('\'_\' can be used as a placeholder',function()
+		it('\'_\' can be used as a placeholder',function()
 			local function concat(a,b,c,d) return a..b..c..d end		
-			assert_equal(_.partialRight(concat,'a','_','c')('d','b'), 'badc')
-			assert_equal(_.partialRight(concat,'a','b','_')('c','d'), 'dabc')
-			assert_equal(_.partialRight(concat,'_','a')('b','c','d'), 'cdba')
+			assert.equal(M.partialRight(concat,'a','_','c')('d','b'), 'badc')
+			assert.equal(M.partialRight(concat,'a','b','_')('c','d'), 'dabc')
+			assert.equal(M.partialRight(concat,'_','a')('b','c','d'), 'cdba')
 		end)
 		
 	end)	
 	
-	context('curry', function()
+	describe('curry', function()
 
-		test('curries a function for a specific number of args',function()
+		it('curries a function for a specific number of args',function()
 			local function sumOf5args(a,b,c,d,e) return a+b+c+d+e end
-			local curried_sumOf5args = _.curry(sumOf5args, 5)
-			assert_equal(curried_sumOf5args(1)(2)(3)(4)(5),15)
-			assert_equal(curried_sumOf5args(8)(-2)(4)(-10)(1),1)
+			local curried_sumOf5args = M.curry(sumOf5args, 5)
+			assert.equal(curried_sumOf5args(1)(2)(3)(4)(5),15)
+			assert.equal(curried_sumOf5args(8)(-2)(4)(-10)(1),1)
 		end)
 		
-		test('n_args defaults to 2 when not supplied',function()
+		it('n_args defaults to 2 when not supplied',function()
 			local function prod(x,y) return x*y end
-			local curried_prod = _.curry(prod)
-			assert_equal(curried_prod(2)(3), (_.curry(prod,2))(2)(3))
-			assert_equal(curried_prod(-2)(6), (_.curry(prod,2))(-2)(6))
+			local curried_prod = M.curry(prod)
+			assert.equal(curried_prod(2)(3), (M.curry(prod,2))(2)(3))
+			assert.equal(curried_prod(-2)(6), (M.curry(prod,2))(-2)(6))
 		end)
 
-		test('n_args can be equal to 1',function()
-			local curried_identity = _.curry(_.identity,1)
-			assert_equal(curried_identity('value'), 'value')
-			assert_equal(curried_identity(1), 1)
-			assert_equal(curried_identity(true), true)
-			assert_equal(curried_identity(false), false)
+		it('n_args can be equal to 1',function()
+			local curried_identity = M.curry(M.identity,1)
+			assert.equal(curried_identity('value'), 'value')
+			assert.equal(curried_identity(1), 1)
+			assert.equal(curried_identity(true), true)
+			assert.equal(curried_identity(false), false)
 		end)
 		
-		test('giving more args than n_args will raise an error',function()
+		it('giving more args than n_args will raise an error',function()
 			local function add(a,b) return a+b end
-			local curried_add = _.curry(add, 2)
-			assert_error(function() curried_add(1)(2)(3) end)
-			assert_error(function() curried_add(4)(5)(6)(7)(8) end)
+			local curried_add = M.curry(add, 2)
+			assert.error(function() curried_add(1)(2)(3) end)
+			assert.error(function() curried_add(4)(5)(6)(7)(8) end)
 		end)		
 		
-		test('When given less than n_args, it will wait for missing args',function()
+		it('When given less than n_args, it will wait for missing args',function()
 			local function add(a,b,c) return a+b+c end
-			local curried_add = _.curry(add, 3)
+			local curried_add = M.curry(add, 3)
 			local c1 = curried_add(1)
 			local c2 = c1(2)
 			local c3 = c2(3)
-			assert_type(c1, 'function')		
-			assert_type(c2, 'function')
-			assert_equal(c3, 6)
+			assert.equal(type(c1), 'function')		
+			assert.equal(type(c2), 'function')
+			assert.equal(c3, 6)
 		end)
 		
 	end)
 	
-	context('time', function()
+	describe('time', function()
 	
-		test('returns the execution time of a function and its results', function()
+		it('returns the execution time of a function and its results', function()
 			local function f(...) return ... end
 			
-			local duration, r = _.time(f, 'a')
-			assert_type(duration, 'number')
-			assert_equal(r, 'a')
+			local duration, r = M.time(f, 'a')
+			assert.equal(type(duration), 'number')
+			assert.equal(r, 'a')
 			
-			local duration, a, b, c = _.time(f, 1, 2, 3)
-			assert_type(duration, 'number')
-			assert_true(a == 1 and b == 2 and c == 3)	
+			local duration, a, b, c = M.time(f, 1, 2, 3)
+			assert.equal(type(duration), 'number')
+			assert.is_true(a == 1 and b == 2 and c == 3)	
 		end)
 	
 	end)
diff -pruN 1.6.1+git20170613-2/spec/import_spec.lua 2.0.0-3/spec/import_spec.lua
--- 1.6.1+git20170613-2/spec/import_spec.lua	2017-06-03 16:42:55.000000000 +0000
+++ 2.0.0-3/spec/import_spec.lua	2018-08-23 16:26:20.000000000 +0000
@@ -1,32 +1,20 @@
 require 'luacov'
-local _ = require 'moses'
+local M = require 'moses'
 
-context('Import specs', function()
+describe('Import specs', function()
   
-  test('imports all library function to a given context', function()
-    local funcs = _.functions()
-    local context = _.import({})
-    assert_true(_.all(funcs, function(k, n) return _.has(context, n) end))
+  it('imports all library function to a given context', function()
+    local funcs = M.functions()
+    local context = M.import({})
+    assert.is_true(M.all(funcs, function(n) return M.has(context, n) end))
   end)
 
-  test('passing "noConflict" will preserve already existing keys', function()
-    local funcs = _.functions()
-    local context = _.import({each = 1, all = 2}, true)
-    assert_true(_.all(funcs, function(k, n) return _.has(context, n) end))
-    assert_equal(context.each, 1)
-    assert_equal(context.all, 2)
-  end)
-    
-  test('The context will default to the global _G if not supplied', function()
-    local oldG = _.clone(_G,true)
-    assert_not_equal(_G, oldG)
-    _.import()
-    local funcs = _.functions()
-    _.each(funcs, function(__, fname)
-      assert_not_nil(_G[fname])
-      assert_true(type(_G[fname]) == 'function')
-    end)
-    _G = oldG
+  it('passing "noConflict" will preserve already existing keys', function()
+    local funcs = M.functions()
+    local context = M.import({each = 1, all = 2}, true)
+    assert.is_true(M.all(funcs, function(n) return M.has(context, n) end))
+    assert.equal(context.each, 1)
+    assert.equal(context.all, 2)
   end)
   
 end)
\ No newline at end of file
diff -pruN 1.6.1+git20170613-2/spec/object_spec.lua 2.0.0-3/spec/object_spec.lua
--- 1.6.1+git20170613-2/spec/object_spec.lua	2017-06-03 16:42:55.000000000 +0000
+++ 2.0.0-3/spec/object_spec.lua	2018-08-23 16:26:20.000000000 +0000
@@ -1,612 +1,630 @@
 require 'luacov'
-local _ = require 'moses'
+local M = require 'moses'
 
-context('Object functions specs', function()
+describe('Object functions specs', function()
 
-  context('keys', function()
+  describe('keys', function()
   
-    test('collects a given object attributes',function()
-      assert_true(_.isEqual(_.keys({1,2,3}),{1,2,3}))
-      assert_true(_.isEqual(_.keys({4,5,6}),{1,2,3}))
-      assert_true(_.same(_.keys({x = 1, y = 2, 3}),{'x','y',1}))
+    it('collects a given object attributes',function()
+      assert.is_true(M.isEqual(M.keys({1,2,3}),{1,2,3}))
+      assert.is_true(M.isEqual(M.keys({4,5,6}),{1,2,3}))
+      assert.is_true(M.same(M.keys({x = 1, y = 2, 3}),{'x','y',1}))
     end)
     
   end)
   
-  context('values', function()
+  describe('values', function()
   
-    test('collects an given object values',function()
-      assert_true(_.isEqual(_.values({1,2,3}),{1,2,3}))
-      assert_true(_.isEqual(_.values({4,5,6}),{4,5,6}))
-      assert_true(_.same(_.values({x = 1, y = 2, 3}),{1,2,3}))
+    it('collects an given object values',function()
+      assert.is_true(M.isEqual(M.values({1,2,3}),{1,2,3}))
+      assert.is_true(M.isEqual(M.values({4,5,6}),{4,5,6}))
+      assert.is_true(M.same(M.values({x = 1, y = 2, 3}),{1,2,3}))
     end)
    
-  end)  
+  end)
+  
+  describe('path', function()
+  
+    it('return the value at a given path in object',function()
+      local entity = {
+        pos = {x = 1},
+        engine = {
+          left = {status = 'active'},
+          right = {damage = 10}
+        },
+        boost = false
+      }
+      assert.equal(M.path(entity, 'pos','x'), 1)
+      assert.equal(M.path(entity, 'engine','left','status'), 'active')
+      assert.equal(M.path(entity, 'engine','right','damage'), 10)
+      assert.equal(M.path(entity, 'boost'), false)
+      assert.is_nil(M.path(entity, 'x'))
+    end)
+   
+  end)   
 	
-  context('kvpairs', function()
+  describe('kvpairs', function()
   
-    test('converts key-values pairs in object to array-list of k,v pairs',function()
-			local obj = _.kvpairs({x = 1, y = 2, z = 3})
+    it('converts key-values pairs in object to array-list of k,v pairs',function()
+			local obj = M.kvpairs({x = 1, y = 2, z = 3})
 			table.sort(obj, function(a,b) return a[1] < b[1] end)
-			assert_true(_.isEqual(obj[1],{'x',1}))
-			assert_true(_.isEqual(obj[2],{'y',2}))
-			assert_true(_.isEqual(obj[3],{'z',3}))
+			assert.is_true(M.isEqual(obj[1],{'x',1}))
+			assert.is_true(M.isEqual(obj[2],{'y',2}))
+			assert.is_true(M.isEqual(obj[3],{'z',3}))
     end)
    
   end)  	
 	
-  context('toObj', function()
+  describe('toObj', function()
   
-    test('converts an array-list of {k,v} pairs to an object',function()
-			local obj = _.toObj({{'x',1},{'y',2},{'z',3}})
-			assert_equal(obj.x,1)
-			assert_equal(obj.y,2)
-			assert_equal(obj.z,3)
+    it('converts an array-list of {k,v} pairs to an object',function()
+			local obj = M.toObj({{'x',1},{'y',2},{'z',3}})
+			assert.equal(obj.x,1)
+			assert.equal(obj.y,2)
+			assert.equal(obj.z,3)
     end)
    
   end)  	
   
-  context('property', function()
+  describe('property', function()
   
-    test('Returns a function that will return the key property of any passed-in object.',function()
-			assert_equal(_.property('sin')(math), math.sin)
-			assert_equal(_.property('find')(string), string.find)
-			assert_equal(_.property('insert')(table), table.insert)
-			assert_equal(_.property('yield')(coroutine), coroutine.yield)
+    it('Returns a function that will return the key property of any passed-in object.',function()
+			assert.equal(M.property('sin')(math), math.sin)
+			assert.equal(M.property('find')(string), string.find)
+			assert.equal(M.property('insert')(table), table.insert)
+			assert.equal(M.property('yield')(coroutine), coroutine.yield)
     end)
    
   end)  	
   
-  context('propertyOf', function()
+  describe('propertyOf', function()
   
-    test('Returns a function which will return the value of an object property.',function()
-			assert_equal(_.propertyOf(math)('cos'), math.cos)
-			assert_equal(_.propertyOf(string)('char'), string.char)
-			assert_equal(_.propertyOf(table)('remove'), table.remove)	
-			assert_equal(_.propertyOf(_)('propertyOf'), _.propertyOf)	
+    it('Returns a function which will return the value of an object property.',function()
+			assert.equal(M.propertyOf(math)('cos'), math.cos)
+			assert.equal(M.propertyOf(string)('char'), string.char)
+			assert.equal(M.propertyOf(table)('remove'), table.remove)	
+			assert.equal(M.propertyOf(M)('propertyOf'), M.propertyOf)	
     end)
    
   end)  	
   
 	
-  context('toBoolean', function()
+  describe('toBoolean', function()
   
-    test('converts a value to a boolean',function()
-      assert_true(type(_.toBoolean(true)) == 'boolean')
-      assert_true(type(_.toBoolean(1)) == 'boolean')
-      assert_true(type(_.toBoolean(false)) == 'boolean')
-      assert_true(type(_.toBoolean(nil)) == 'boolean')
-      assert_true(type(_.toBoolean({})) == 'boolean')
-      assert_true(type(_.toBoolean(1/0)) == 'boolean')
+    it('converts a value to a boolean',function()
+      assert.is_true(type(M.toBoolean(true)) == 'boolean')
+      assert.is_true(type(M.toBoolean(1)) == 'boolean')
+      assert.is_true(type(M.toBoolean(false)) == 'boolean')
+      assert.is_true(type(M.toBoolean(nil)) == 'boolean')
+      assert.is_true(type(M.toBoolean({})) == 'boolean')
+      assert.is_true(type(M.toBoolean(1/0)) == 'boolean')
       
-      assert_true(_.toBoolean(true))
-      assert_true(_.toBoolean(1))
-      assert_false(_.toBoolean(false))
-      assert_false(_.toBoolean(nil))
-      assert_true(_.toBoolean({}))
-      assert_true(_.toBoolean(1/0))      
+      assert.is_true(M.toBoolean(true))
+      assert.is_true(M.toBoolean(1))
+      assert.is_false(M.toBoolean(false))
+      assert.is_false(M.toBoolean(nil))
+      assert.is_true(M.toBoolean({}))
+      assert.is_true(M.toBoolean(1/0))      
     end)
   
   end)  
   
-  context('extend', function()
+  describe('extend', function()
   
-    test('extends a destination objects with key-values a source object',function()
-      assert_true(_.isEqual(_.extend({},{a = 'b'}),{a = 'b'}))
+    it('extends a destination objects with key-values a source object',function()
+      assert.is_true(M.isEqual(M.extend({},{a = 'b'}),{a = 'b'}))
     end)
     
-    test('source properties overrides destination properties',function()
-      assert_true(_.isEqual(_.extend({a = 'a'},{a = 'b'}),{a = 'b'}))
+    it('source properties overrides destination properties',function()
+      assert.is_true(M.isEqual(M.extend({a = 'a'},{a = 'b'}),{a = 'b'}))
     end)   
 
-    test('leaves source object untouched',function()
+    it('leaves source object untouched',function()
       local source = {i = 'i'}
-      assert_true(_.isEqual(_.extend({a = 'a'},source),{a = 'a',i = 'i'}))
-      assert_true(_.isEqual(source,{i = 'i'}))
+      assert.is_true(M.isEqual(M.extend({a = 'a'},source),{a = 'a',i = 'i'}))
+      assert.is_true(M.isEqual(source,{i = 'i'}))
     end)
 
-    test('can extend destination from multiple sources',function()
+    it('can extend destination from multiple sources',function()
       local sourceA = {a = 'a'}; local sourceBC = {b = 'b', c = 'c'} 
-      assert_true(_.isEqual(_.extend({},sourceA, sourceBC),{a = 'a', b = 'b', c = 'c'}))
+      assert.is_true(M.isEqual(M.extend({},sourceA, sourceBC),{a = 'a', b = 'b', c = 'c'}))
     end) 
 
-    test('extending from multiple source, latter properties overrides',function()
+    it('extending from multiple source, latter properties overrides',function()
       local sourceA = {a = 'a'}; local sourceBC = {b = 'b', a = 'c'} 
-      assert_true(_.isEqual(_.extend({},sourceA, sourceBC),{a = 'c', b = 'b'}))
+      assert.is_true(M.isEqual(M.extend({},sourceA, sourceBC),{a = 'c', b = 'b'}))
     end)     
     
-    test('will not copy nil values',function()
+    it('will not copy nil values',function()
       local sourceA = {a = nil}; local sourceBC = {b = 'b', c = nil} 
-      assert_true(_.isEqual(_.extend({},sourceA, sourceBC),{b = 'b'}))
+      assert.is_true(M.isEqual(M.extend({},sourceA, sourceBC),{b = 'b'}))
     end)    
   end)
   
-  context('functions', function()
+  describe('functions', function()
 
-    test('collects function names within an object',function()
+    it('collects function names within an object',function()
       local x = {}
       function x.a() return end; function x.b() return end    
-      assert_true(_.isEqual(_.functions(x),{'a','b'}))
+      assert.is_true(M.same(M.functions(x),{'a','b'}))
     end)
     
-    test('collects metatable functions if "recurseMt" arg is supplied',function()
+    it('collects metatable functions if "recurseMt" arg is supplied',function()
       local x = {} ; x.__index = x
       function x.a() return end; function x.b() return end
       local xx = setmetatable({},x)
       function xx.c() return end
-      assert_true(_.same(_.functions(xx),{'c'}))
-      assert_true(_.same(_.functions(xx,true),{'a','b','c'}))
+      assert.is_true(M.same(M.functions(xx),{'c'}))
+      assert.is_true(M.same(M.functions(xx,true),{'a','b','c'}))
     end)
 
-    test('when given no obj as argument, returns all library functions',function()
-      local functions = _.functions()
-      _.each(functions, function(k,v)
-        assert_true(_.isFunction(_[v]))
+    it('when given no obj as argument, returns all library functions',function()
+      local functions = M.functions()
+      M.each(functions, function(v)
+        assert.is_true(M.isFunction(M[v]))
       end)
     end)
     
   end)  
   
-  context('clone', function()
+  describe('clone', function()
   
-    test('clones the attributes of an object',function()
+    it('clones the attributes of an object',function()
       local vector = {x = 0, y = 0}
-      assert_true(_.isEqual(_.clone(vector),vector))
+      assert.is_true(M.isEqual(M.clone(vector),vector))
     end)
     
-    test('By default, cloning is deep (clones nested tables)',function()
+    it('By default, cloning is deep (clones nested tables)',function()
       local particle = {position = {x = 0,y=0},mass = 1}
-      local particle_clone = _.clone (particle)
-      assert_true(_.isEqual(particle_clone,particle))
+      local particle_clone = M.clone (particle)
+      assert.is_true(M.isEqual(particle_clone,particle))
       particle_clone.position.x = 3
-      assert_false(_.isEqual(particle_clone,particle))
+      assert.is_false(M.isEqual(particle_clone,particle))
     end)
  
-    test('Unless "shallow" arg is provided',function()
+    it('Unless "shallow" arg is provided',function()
       local particle = {position = {x = 0,y=0},mass = 1}
-      local particle_clone = _.clone (particle,true)
-      assert_true(_.isEqual(particle_clone,particle))
+      local particle_clone = M.clone (particle,true)
+      assert.is_true(M.isEqual(particle_clone,particle))
       particle_clone.position.x = 3
-      assert_true(_.isEqual(particle_clone,particle))
+      assert.is_true(M.isEqual(particle_clone,particle))
     end) 
     
-    test('Non objects are simply returned',function()
-      assert_equal(_.clone(1),1)
-      assert_equal(_.clone(false),false)
-      assert_equal(_.clone(true),true)
-      assert_equal(_.clone(nil),nil)
-      assert_equal(_.clone('hello'),'hello')
-      assert_equal(_.clone(print),print)
+    it('Non objects are simply returned',function()
+      assert.equal(M.clone(1),1)
+      assert.equal(M.clone(false),false)
+      assert.equal(M.clone(true),true)
+      assert.equal(M.clone(nil),nil)
+      assert.equal(M.clone('hello'),'hello')
+      assert.equal(M.clone(print),print)
     end)     
     
   end)
   
-  context('tap', function()
+  describe('tap', function()
     
-    test('tap-into a method chain', function()
+    it('tap-into a method chain', function()
       local t = {}
-      local catchMax = function(k) t[#t+1] = _.max(k) end
-      local catchMin = function(k) t[#t+1] = _.min(k) end
+      local catchMax = function(k) t[#t+1] = M.max(k) end
+      local catchMin = function(k) t[#t+1] = M.min(k) end
       
-      _.chain({1,2,3})
-        :map(function(i,j) return j*2 end)
+      M.chain({1,2,3})
+        :map(function(j) return j*2 end)
         :tap(catchMax)
-        :map(function(i,k) return k^2 end)
+        :map(function(k) return k^2 end)
         :tap(catchMin)
         :value()
         
-      assert_equal(t[1],6)
-      assert_equal(t[2],4)
+      assert.equal(t[1],6)
+      assert.equal(t[2],4)
     end)
   
   end)
 
-  context('has', function()
+  describe('has', function()
   
-    test('checks if an object has an attribute',function()
-      assert_true(_.has(_,'has'))
-      assert_true(_.has(table,'concat'))
-      assert_true(_.has(string,'format'))
-      assert_true(_.has(os,'time'))
-      assert_true(_.has(math,'random'))
+    it('checks if an object has an attribute',function()
+      assert.is_true(M.has(M,'has'))
+      assert.is_true(M.has(table,'concat'))
+      assert.is_true(M.has(string,'format'))
+      assert.is_true(M.has(os,'time'))
+      assert.is_true(M.has(math,'random'))
     end)
     
   end) 
   
-  context('pick', function()
+  describe('pick', function()
   
-    test('collect specified properties',function()
+    it('collect specified properties',function()
       local object = {a = 1, b = 2, c = 3}
-      assert_true(_.isEqual(_.pick(object,'a','c'),{a = 1, c = 3}))
+      assert.is_true(M.isEqual(M.pick(object,'a','c'),{a = 1, c = 3}))
     end)
     
-    test('given args can be nested as well',function()
+    it('given args can be nested as well',function()
       local object = {a = 1, b = 2, c = 3}
-      assert_true(_.isEqual(_.pick(object,{{'b','a'}},'c'),{a = 1,b = 2, c = 3}))
+      assert.is_true(M.isEqual(M.pick(object,{{'b','a'}},'c'),{a = 1,b = 2, c = 3}))
     end)
 
-    test('will ignore properties the object do not have',function()
+    it('will ignore properties the object do not have',function()
       local object = {a = 1, b = 2, c = 3}
-      assert_true(_.isEqual(_.pick(object,{{'k'}},'c'),{c = 3}))
+      assert.is_true(M.isEqual(M.pick(object,{{'k'}},'c'),{c = 3}))
     end) 
 
-    test('returns an empty table when given no properties to pick',function()
+    it('returns an empty table when given no properties to pick',function()
       local object = {a = 1, b = 2, c = 3}
-      assert_true(_.isEqual(_.pick(object),{}))
+      assert.is_true(M.isEqual(M.pick(object),{}))
     end)  
 
-    test('should also pick attributes having falsy values',function()
+    it('should also pick attributes having falsy values',function()
       local object = {a = false, b = false, c = true}
-      assert_true(_.isEqual(_.pick(object,'a','b'),{a = false,b = false}))
+      assert.is_true(M.isEqual(M.pick(object,'a','b'),{a = false,b = false}))
     end)  
     
   end)  
   
-  context('omit', function()
+  describe('omit', function()
   
-    test('collect all properties leaving those given as args',function()
+    it('collect all properties leaving those given as args',function()
       local object = {a = 1, b = 2, c = 3}
-      assert_true(_.isEqual(_.omit(object,'a','c'),{b=2}))
+      assert.is_true(M.isEqual(M.omit(object,'a','c'),{b=2}))
     end)
     
-    test('given args can be nested as well',function()
+    it('given args can be nested as well',function()
       local object = {a = 1, b = 2, c = 3}
-      assert_true(_.isEqual(_.omit(object,{{'b'}},'c'),{a = 1}))
+      assert.is_true(M.isEqual(M.omit(object,{{'b'}},'c'),{a = 1}))
     end)
 
-    test('will ignore properties the object do not have',function()
+    it('will ignore properties the object do not have',function()
       local object = {a = 1, b = 2, c = 3}
-      assert_true(_.isEqual(_.omit(object,{{'k'}},'c'),{a = 1, b=2}))
+      assert.is_true(M.isEqual(M.omit(object,{{'k'}},'c'),{a = 1, b=2}))
     end) 
 
-    test('returns the original object clone when given no properties to omit',function()
+    it('returns the original object clone when given no properties to omit',function()
       local object = {a = 1, b = 2, c = 3}
-      assert_true(_.isEqual(_.omit(object),{a = 1, b = 2, c = 3}))
+      assert.is_true(M.isEqual(M.omit(object),{a = 1, b = 2, c = 3}))
     end)
     
   end)
   
-  context('template', function()
+  describe('template', function()
   
-    test('applies a template on an object',function()
-      assert_true(_.isEqual(_.template({},{a = 1, b = 2, c = 3}),{a = 1, b = 2, c = 3}))
+    it('applies a template on an object',function()
+      assert.is_true(M.isEqual(M.template({},{a = 1, b = 2, c = 3}),{a = 1, b = 2, c = 3}))
     end)
     
-    test('does not override existing properies',function()
-      assert_true(_.isEqual(_.template({a = 10, b = 10},{a = 1, b = 2, c = 3}),{a = 10, b = 10, c = 3}))
+    it('does not override existing properies',function()
+      assert.is_true(M.isEqual(M.template({a = 10, b = 10},{a = 1, b = 2, c = 3}),{a = 10, b = 10, c = 3}))
     end)
 
-    test('returns the object when given no template arg',function()
-      assert_true(_.isEqual(_.template({a = 10, b = 10}),{a = 10, b = 10}))
+    it('returns the object when given no template arg',function()
+      assert.is_true(M.isEqual(M.template({a = 10, b = 10}),{a = 10, b = 10}))
     end)
     
   end) 
 
-  context('isEqual', function()
+  describe('isEqual', function()
   
-    test('compares values',function()
-      assert_true(_.isEqual(1,1))
-      assert_true(_.isEqual(1.0,1))
-      assert_false(_.isEqual(1,2))
-      assert_false(_.isEqual(2,2.0001))
+    it('compares values',function()
+      assert.is_true(M.isEqual(1,1))
+      assert.is_true(M.isEqual(1.0,1))
+      assert.is_false(M.isEqual(1,2))
+      assert.is_false(M.isEqual(2,2.0001))
     end)
     
-    test('compares objects by reference and components',function()
+    it('compares objects by reference and components',function()
       local oldprint = print
-      assert_true(_.isEqual(print,oldprint))
+      assert.is_true(M.isEqual(print,oldprint))
       
       local t = {}
       local v = t
-      assert_true(_.isEqual(t,v))
-      assert_true(_.isEqual({},{}))
+      assert.is_true(M.isEqual(t,v))
+      assert.is_true(M.isEqual({},{}))
       
-      assert_false(_.isEqual('a','b'))
+      assert.is_false(M.isEqual('a','b'))
       
-      assert_false(_.isEqual(true, false))
-      assert_false(_.isEqual(nil, false))
-      assert_false(_.isEqual(true, nil))       
+      assert.is_false(M.isEqual(true, false))
+      assert.is_false(M.isEqual(nil, false))
+      assert.is_false(M.isEqual(true, nil))       
     
     end)
 
-    test('compares nested properties',function()
-      assert_true(_.isEqual({x = 0,{x1 = 0,{x2 =0}}}, {x = 0,{x1 = 0,{x2 =0}}}))
-      assert_false(_.isEqual({x = 0,{x1 = 0,{x2 =0}}}, {x = 0,{x1 = 0,{x2 =1}}}))
+    it('compares nested properties',function()
+      assert.is_true(M.isEqual({x = 0,{x1 = 0,{x2 =0}}}, {x = 0,{x1 = 0,{x2 =0}}}))
+      assert.is_false(M.isEqual({x = 0,{x1 = 0,{x2 =0}}}, {x = 0,{x1 = 0,{x2 =1}}}))
     end)
 
-    test('can compare tables on the basis of their metatable',function()
+    it('can compare tables on the basis of their metatable',function()
       local a, b = {x = 1, y = 2}, {x = 2, y = 1}
       setmetatable(a,{__eq = function(a,b) return (a.x and b.x and a.y and b.y)~=nil end})
-      assert_false(_.isEqual(a, b))
-      assert_true(_.isEqual(a, b, true))
+      assert.is_false(M.isEqual(a, b))
+      assert.is_true(M.isEqual(a, b, true))
     end)
   
     
   end)
 
-  context('result', function()
+  describe('result', function()
   
-    test('calls an object method, passing it as a first arg the object itself',function()
-     assert_equal(_.result('a','len'),1)
-     assert_equal(_.result('hello','reverse'),'olleh')
-     assert_equal(_.result({'a','b','c'},table.concat),'abc')
+    it('calls an object method, passing it as a first arg the object itself',function()
+     assert.equal(M.result('a','len'),1)
+     assert.equal(M.result('hello','reverse'),'olleh')
+     assert.equal(M.result({'a','b','c'},table.concat),'abc')
     end)
     
-    test('handles extra-args to be passed to the so-called method',function()
-     assert_equal(_.result('Hello','match','%u'),'H')
-     assert_equal(_.result({'a','b','c'},table.concat,' '),'a b c')
+    it('handles extra-args to be passed to the so-called method',function()
+     assert.equal(M.result('Hello','match','%u'),'H')
+     assert.equal(M.result({'a','b','c'},table.concat,' '),'a b c')
     end)    
     
-    test('returns the property itself if not callable',function()
-     assert_equal(_.result({size = 0},'size'),0)
+    it('returns the property itself if not callable',function()
+     assert.equal(M.result({size = 0},'size'),0)
     end)
      
   end)
 
-  context('isTable', function()
+  describe('isTable', function()
   
-    test('returns "true" if arg is table or array',function()
-      assert_true(_.isTable({}))
-      assert_true(_.isTable({1,2}))
-      assert_true(_.isTable({x = 1, 2}))
-      assert_true(_.isTable(string))
-      assert_true(_.isTable(table))
-      assert_true(_.isTable(math))
+    it('returns "true" if arg is table or array',function()
+      assert.is_true(M.isTable({}))
+      assert.is_true(M.isTable({1,2}))
+      assert.is_true(M.isTable({x = 1, 2}))
+      assert.is_true(M.isTable(string))
+      assert.is_true(M.isTable(table))
+      assert.is_true(M.isTable(math))
       
     end)
     
-    test('returns "false" otherwise',function()
-      assert_false(_.isTable(1))
-      assert_false(_.isTable(''))
-      assert_false(_.isTable(function() end))
-      assert_false(_.isTable(print))
-      assert_false(_.isTable(false))
-      assert_false(_.isTable(nil))
-      assert_false(_.isTable(true))      
+    it('returns "false" otherwise',function()
+      assert.is_false(M.isTable(1))
+      assert.is_false(M.isTable(''))
+      assert.is_false(M.isTable(function() end))
+      assert.is_false(M.isTable(print))
+      assert.is_false(M.isTable(false))
+      assert.is_false(M.isTable(nil))
+      assert.is_false(M.isTable(true))      
     end)
     
   end) 
 
-  context('isCallable', function()
+  describe('isCallable', function()
   
-    test('returns "true" if arg is callable',function()
-      assert_true(_.isCallable(print))
-      assert_true(_.isCallable(function() end))
-      assert_true(_.isCallable(string.gmatch))
-      assert_true(_.isCallable(setmetatable({},{__index = string}).upper))      
-      assert_true(_.isCallable(setmetatable({},{__call = function() return end})))      
-    end)
-    
-    test('returns "false" otherwise',function()
-      assert_false(_.isCallable(1))
-      assert_false(_.isCallable(''))
-      assert_false(_.isCallable({}))
-      assert_false(_.isCallable(false))
-      assert_false(_.isCallable(nil))
-      assert_false(_.isCallable(true))      
+    it('returns "true" if arg is callable',function()
+      assert.is_true(M.isCallable(print))
+      assert.is_true(M.isCallable(function() end))
+      assert.is_true(M.isCallable(string.gmatch))
+      assert.is_true(M.isCallable(setmetatable({},{__index = string}).upper))      
+      assert.is_true(M.isCallable(setmetatable({},{__call = function() return end})))      
+    end)
+    
+    it('returns "false" otherwise',function()
+      assert.is_false(M.isCallable(1))
+      assert.is_false(M.isCallable(''))
+      assert.is_false(M.isCallable({}))
+      assert.is_false(M.isCallable(false))
+      assert.is_false(M.isCallable(nil))
+      assert.is_false(M.isCallable(true))      
     end)
     
   end) 
 
-  context('isArray', function()
+  describe('isArray', function()
   
-    test('returns "true" if arg is an array',function()
-      assert_true(_.isArray({}))
-      assert_true(_.isArray({1,2,3}))
-      assert_true(_.isArray({'a','b','c',{}}))
-      assert_true(_.isArray({false,true}))
-      assert_true(_.isArray({1,nil}))
+    it('returns "true" if arg is an array',function()
+      assert.is_true(M.isArray({}))
+      assert.is_true(M.isArray({1,2,3}))
+      assert.is_true(M.isArray({'a','b','c',{}}))
+      assert.is_true(M.isArray({false,true}))
+      assert.is_true(M.isArray({1,nil}))
     end)
    
-    test('returns "false" otherwise',function()
-      assert_false(_.isArray(1))
-      assert_false(_.isArray(''))
-      assert_false(_.isArray(false))
-      assert_false(_.isArray(nil))
-      assert_false(_.isArray(true))      
-      assert_false(_.isArray(print))
-      assert_false(_.isArray({a = 1, x = 1}))
-      assert_false(_.isArray({a = 1, 1, 2,3}))
-      assert_false(_.isArray({1,nil,2}))
-      assert_false(_.isArray({1,nil,3,k=4}))
-      assert_false(_.isArray({a=1}))
+    it('returns "false" otherwise',function()
+      assert.is_false(M.isArray(1))
+      assert.is_false(M.isArray(''))
+      assert.is_false(M.isArray(false))
+      assert.is_false(M.isArray(nil))
+      assert.is_false(M.isArray(true))      
+      assert.is_false(M.isArray(print))
+      assert.is_false(M.isArray({a = 1, x = 1}))
+      assert.is_false(M.isArray({a = 1, 1, 2,3}))
+      assert.is_false(M.isArray({1,nil,2}))
+      assert.is_false(M.isArray({1,nil,3,k=4}))
+      assert.is_false(M.isArray({a=1}))
     end)   
    
-    test('returns false on "sparse arrays"',function()
-      assert_false(_.isArray({[1] = true, [10] = false}))
+    it('returns false on "sparse arrays"',function()
+      assert.is_false(M.isArray({[1] = true, [10] = false}))
    end)   
   
   end)
   
-  context('isIterable', function()
+  describe('isIterable', function()
   
-    test('checks if the given object is iterable with pairs',function()
-      assert_true(_.isIterable({}))
-      assert_false(_.isIterable(function() end))
-      assert_false(_.isIterable(false))
-      assert_false(_.isIterable(1))
+    it('checks if the given object is iterable with pairs',function()
+      assert.is_true(M.isIterable({}))
+      assert.is_true(M.isIterable({1,2,3}))
     end)
     
   end)  
      
-  context('isEmpty', function()
+  describe('isEmpty', function()
   
-    test('returns "true" if arg is an empty array',function()
-      assert_true(_.isEmpty({}))      
+    it('returns "true" if arg is an empty array',function()
+      assert.is_true(M.isEmpty({}))      
     end)
     
-    test('returns "false" otherwise',function()
-      assert_false(_.isEmpty({1,2,3}))
-      assert_false(_.isEmpty({'a','b','c',{}}))
-      assert_false(_.isEmpty({nil,false,true}))
+    it('returns "false" otherwise',function()
+      assert.is_false(M.isEmpty({1,2,3}))
+      assert.is_false(M.isEmpty({'a','b','c',{}}))
+      assert.is_false(M.isEmpty({nil,false,true}))
     end)
 
-    test('booleans, nil and functions are considered empty',function()
-      assert_true(_.isEmpty(print))
-      assert_true(_.isEmpty(nil))
-      assert_true(_.isEmpty(false))
-      assert_true(_.isEmpty(true))
+    it('booleans, nil and functions are considered empty',function()
+      assert.is_true(M.isEmpty(print))
+      assert.is_true(M.isEmpty(nil))
+      assert.is_true(M.isEmpty(false))
+      assert.is_true(M.isEmpty(true))
     end)
     
-    test('handles strings',function()
-      assert_true(_.isEmpty(''))
-      assert_false(_.isEmpty('a'))
-      assert_false(_.isEmpty('bcd'))
-      assert_false(_.isEmpty(' '))
+    it('handles strings',function()
+      assert.is_true(M.isEmpty(''))
+      assert.is_false(M.isEmpty('a'))
+      assert.is_false(M.isEmpty('bcd'))
+      assert.is_false(M.isEmpty(' '))
     end)  
     
   end) 
 
-  context('isString', function()
+  describe('isString', function()
   
-    test('returns "true" if arg is a string',function()
-      assert_true(_.isString(''))
-      assert_true(_.isString('a'))
-      assert_true(_.isString(' '))
-      assert_true(_.isString(type(nil)))
+    it('returns "true" if arg is a string',function()
+      assert.is_true(M.isString(''))
+      assert.is_true(M.isString('a'))
+      assert.is_true(M.isString(' '))
+      assert.is_true(M.isString(type(nil)))
     end)
     
-    test('returns "false" otherwise',function()
-      assert_false(_.isString(false))
-      assert_false(_.isString(print))
-      assert_false(_.isString(nil))
-      assert_false(_.isString(true))
-      assert_false(_.isString({}))
+    it('returns "false" otherwise',function()
+      assert.is_false(M.isString(false))
+      assert.is_false(M.isString(print))
+      assert.is_false(M.isString(nil))
+      assert.is_false(M.isString(true))
+      assert.is_false(M.isString({}))
     end)
     
   end)
 
-  context('isFunction', function()
+  describe('isFunction', function()
   
-    test('returns "true" if arg is a function',function()
-      assert_true(_.isFunction(print))
-      assert_true(_.isFunction(string.match))
-      assert_true(_.isFunction(function() end))
+    it('returns "true" if arg is a function',function()
+      assert.is_true(M.isFunction(print))
+      assert.is_true(M.isFunction(string.match))
+      assert.is_true(M.isFunction(function() end))
     end)
 
-    test('returns "false" otherwise',function()
-      assert_false(_.isFunction({}))
-      assert_false(_.isFunction(nil))
-      assert_false(_.isFunction(false))
-      assert_false(_.isFunction(true))
-      assert_false(_.isFunction('a'))
+    it('returns "false" otherwise',function()
+      assert.is_false(M.isFunction({}))
+      assert.is_false(M.isFunction(nil))
+      assert.is_false(M.isFunction(false))
+      assert.is_false(M.isFunction(true))
+      assert.is_false(M.isFunction('a'))
     end)    
     
   end)
   
-  context('isNil', function()
+  describe('isNil', function()
   
-    test('returns "true" if arg is nil',function()
-      assert_true(_.isNil(nil))
-      assert_true(_.isNil())
-      assert_true(_.isNil(a))
+    it('returns "true" if arg is nil',function()
+      assert.is_true(M.isNil(nil))
+      assert.is_true(M.isNil())
+      assert.is_true(M.isNil(a))
     end)
     
-    test('returns "false" otherwise',function()
-      assert_false(_.isNil(false))
-      assert_false(_.isNil(true))
-      assert_false(_.isNil(table))
-      assert_false(_.isNil(function() end))
-      assert_false(_.isNil('a'))
+    it('returns "false" otherwise',function()
+      assert.is_false(M.isNil(false))
+      assert.is_false(M.isNil(true))
+      assert.is_false(M.isNil(table))
+      assert.is_false(M.isNil(function() end))
+      assert.is_false(M.isNil('a'))
     end)     
     
   end) 
 
-  context('isNumber', function()
+  describe('isNumber', function()
   
-    test('returns "true" if arg is a number',function()
-      assert_true(_.isNumber(1))
-      assert_true(_.isNumber(0.5))
-      assert_true(_.isNumber(math.pi))
-      assert_true(_.isNumber(1/0))
-      assert_true(_.isNumber(math.huge))
-      assert_true(_.isNumber(0/0))
-    end)
-    
-    test('returns "false" otherwise',function()
-      assert_false(_.isNumber(print))
-      assert_false(_.isNumber(nil))
-      assert_false(_.isNumber(true))
-      assert_false(_.isNumber(false))
-      assert_false(_.isNumber({1}))
-      assert_false(_.isNumber('1'))
+    it('returns "true" if arg is a number',function()
+      assert.is_true(M.isNumber(1))
+      assert.is_true(M.isNumber(0.5))
+      assert.is_true(M.isNumber(math.pi))
+      assert.is_true(M.isNumber(1/0))
+      assert.is_true(M.isNumber(math.huge))
+      assert.is_true(M.isNumber(0/0))
+    end)
+    
+    it('returns "false" otherwise',function()
+      assert.is_false(M.isNumber(print))
+      assert.is_false(M.isNumber(nil))
+      assert.is_false(M.isNumber(true))
+      assert.is_false(M.isNumber(false))
+      assert.is_false(M.isNumber({1}))
+      assert.is_false(M.isNumber('1'))
     end)    
     
   end)
 
-  context('isNaN', function()
+  describe('isNaN', function()
   
-    test('returns "true" if arg is NaN',function()
-      assert_true(_.isNaN(0/0))  
+    it('returns "true" if arg is NaN',function()
+      assert.is_true(M.isNaN(0/0))  
     end)
     
-    test('returns "false" for not NaN values',function()
-      assert_false(_.isNaN(1/0))  
-      assert_false(_.isNaN(math.huge))
-      assert_false(_.isNaN(math.pi))
-      assert_false(_.isNaN(1))
-      assert_false(_.isNaN(''))
-      assert_false(_.isNaN('0'))
-      assert_false(_.isNaN({}))
-      assert_false(_.isNaN(nil))
-      assert_false(_.isNaN(false))
-      assert_false(_.isNaN(true))
+    it('returns "false" for not NaN values',function()
+      assert.is_false(M.isNaN(1/0))  
+      assert.is_false(M.isNaN(math.huge))
+      assert.is_false(M.isNaN(math.pi))
+      assert.is_false(M.isNaN(1))
+      assert.is_false(M.isNaN(''))
+      assert.is_false(M.isNaN('0'))
+      assert.is_false(M.isNaN({}))
+      assert.is_false(M.isNaN(nil))
+      assert.is_false(M.isNaN(false))
+      assert.is_false(M.isNaN(true))
     end)    
     
   end) 
   
-  context('isFinite', function()
+  describe('isFinite', function()
   
-    test('returns "true" if arg is a finite number',function()
-      assert_true(_.isFinite(1))
-      assert_true(_.isFinite(0))
-      assert_true(_.isFinite(math.pi))
-      assert_true(_.isFinite(99e99))
+    it('returns "true" if arg is a finite number',function()
+      assert.is_true(M.isFinite(1))
+      assert.is_true(M.isFinite(0))
+      assert.is_true(M.isFinite(math.pi))
+      assert.is_true(M.isFinite(99e99))
     end)
     
-    test('returns "false" otherwise',function()
-      assert_false(_.isFinite(math.huge))
-      assert_false(_.isFinite(1/0))
-      assert_false(_.isFinite(0/0))
+    it('returns "false" otherwise',function()
+      assert.is_false(M.isFinite(math.huge))
+      assert.is_false(M.isFinite(1/0))
+      assert.is_false(M.isFinite(0/0))
     end) 
 
-    test('returns "false" for non-numbers',function()
-      assert_false(_.isFinite(''))
-      assert_false(_.isFinite(function() end))
-      assert_false(_.isFinite({}))
+    it('returns "false" for non-numbers',function()
+      assert.is_false(M.isFinite(''))
+      assert.is_false(M.isFinite(function() end))
+      assert.is_false(M.isFinite({}))
     end)    
     
   end)
 
-  context('isBoolean', function()
+  describe('isBoolean', function()
  
-    test('returns "true" if arg is a boolean or a thruthy statement',function()
-      assert_true(_.isBoolean(true))
-      assert_true(_.isBoolean(false))
-      assert_true(_.isBoolean(1==1))
-      assert_true(_.isBoolean(print==tostring))     
+    it('returns "true" if arg is a boolean or a thruthy statement',function()
+      assert.is_true(M.isBoolean(true))
+      assert.is_true(M.isBoolean(false))
+      assert.is_true(M.isBoolean(1==1))
+      assert.is_true(M.isBoolean(print==tostring))     
     end)
     
-    test('returns "false" otherwise',function()
-      assert_false(_.isBoolean(''))
-      assert_false(_.isBoolean(nil))
-      assert_false(_.isBoolean({}))
-      assert_false(_.isBoolean(function() end))
+    it('returns "false" otherwise',function()
+      assert.is_false(M.isBoolean(''))
+      assert.is_false(M.isBoolean(nil))
+      assert.is_false(M.isBoolean({}))
+      assert.is_false(M.isBoolean(function() end))
 
-      assert_false(_.isBoolean(0))
-      assert_false(_.isBoolean('1'))
+      assert.is_false(M.isBoolean(0))
+      assert.is_false(M.isBoolean('1'))
     end)    
     
   end)
   
-  context('isInteger', function()
+  describe('isInteger', function()
   
-    test('returns "true" if arg is a integer, "false" otherwise',function()
-      assert_true(_.isInteger(1))
-      assert_true(_.isInteger(0))
-      assert_false(_.isInteger(math.pi))
-      assert_true(_.isInteger(1/0))
-      assert_true(_.isInteger(math.huge))
-      assert_false(_.isInteger(0/0))
+    it('returns "true" if arg is a integer, "false" otherwise',function()
+      assert.is_true(M.isInteger(1))
+      assert.is_true(M.isInteger(0))
+      assert.is_false(M.isInteger(math.pi))
+      assert.is_true(M.isInteger(1/0))
+      assert.is_true(M.isInteger(math.huge))
+      assert.is_false(M.isInteger(0/0))
     end)  
     
   end)
diff -pruN 1.6.1+git20170613-2/spec/op_spec.lua 2.0.0-3/spec/op_spec.lua
--- 1.6.1+git20170613-2/spec/op_spec.lua	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.0-3/spec/op_spec.lua	2018-08-23 16:26:20.000000000 +0000
@@ -0,0 +1,162 @@
+require 'luacov'
+local M = require 'moses'
+
+describe('Operators specs', function()
+  
+  describe('Arithmetic operators', function()
+  
+    it('add returns a + b', function()
+      assert.equal(M.operator.add(1,2), 3)
+      assert.equal(M.operator.add(0,0), 0)
+      assert.equal(M.operator.add(0,-5), -5)
+    end)
+
+    it('sub returns a - b', function()
+      assert.equal(M.operator.sub(1,2), -1)
+      assert.equal(M.operator.sub(0,0), 0)
+      assert.equal(M.operator.sub(0,-5), 5)
+    end)
+    
+    it('mul returns a * b', function()
+      assert.equal(M.operator.mul(1,2), 2)
+      assert.equal(M.operator.mul(0,0), 0)
+      assert.equal(M.operator.mul(0,-5), 0)
+    end)  
+    
+    it('div returns a / b', function()
+      assert.equal(M.operator.div(1,2), 0.5)
+      assert.equal(M.operator.div(5,5), 1)
+      assert.equal(M.operator.div(8,-2), -4)
+    end)
+    
+    it('mod returns a % b', function()
+      assert.equal(M.operator.mod(6,3), 0)
+      assert.equal(M.operator.mod(5,2), 1)
+    end)
+
+    it('exp returns a ^ b', function()
+      assert.equal(M.operator.exp(3,3), 27)
+      assert.equal(M.operator.exp(5,2), 25)
+    end)
+    
+    it('unm returns -a', function()
+      assert.equal(M.operator.unm(3), -3)
+      assert.equal(M.operator.unm(-5), 5)
+    end)
+    
+    it('floordiv returns a//b', function()
+      assert.equal(M.operator.floordiv(5,2), 2)
+    end)
+    
+    it('intdiv performs integer division', function()
+      assert.equal(M.operator.intdiv(5,2), 2)
+      assert.equal(M.operator.intdiv(-5,2), -2)
+    end)
+    
+  end)
+  
+  describe('Relational operators', function()
+  
+    it('eq returns a == b', function()
+      assert.equal(M.operator.eq(5,5), true)
+      assert.equal(M.operator.eq(5,4.99), false)
+    end)
+    
+    it('neq returns a ~= b', function()
+      assert.equal(M.operator.neq(5,5), false)
+      assert.equal(M.operator.neq(5,4.99), true)
+    end)    
+    
+    it('lt returns a < b', function()
+      assert.equal(M.operator.lt(5,5), false)
+      assert.equal(M.operator.lt(4.99,5), true)
+    end)
+    
+    it('gt returns a > b', function()
+      assert.equal(M.operator.gt(5,5), false)
+      assert.equal(M.operator.gt(5,4.99), true)
+    end)    
+    
+    it('le returns a <= b', function()
+      assert.equal(M.operator.le(5,5), true)
+      assert.equal(M.operator.le(4.99,5), true)
+      assert.equal(M.operator.le(5,4.99), false)
+    end)
+    
+    it('ge returns a >= b', function()
+      assert.equal(M.operator.ge(5,5), true)
+      assert.equal(M.operator.ge(4.99,5), false)
+      assert.equal(M.operator.ge(5,4.99), true)
+    end)
+    
+  end)
+  
+  describe('Logical operators', function()
+  
+    it('land returns a and b', function()
+      assert.equal(M.operator.land(true, true),true)
+      assert.equal(M.operator.land(true, false),false)
+      assert.equal(M.operator.land(false, true),false)
+      assert.equal(M.operator.land(false, false),false)
+      assert.equal(M.operator.land(true, nil),nil)
+      assert.equal(M.operator.land(false, nil),false)
+    end)
+    
+    it('lor returns a or b', function()
+      assert.equal(M.operator.lor(true, true),true)
+      assert.equal(M.operator.lor(true, false),true)
+      assert.equal(M.operator.lor(false, true),true)
+      assert.equal(M.operator.lor(false, false),false)
+      assert.equal(M.operator.lor(true, nil),true)
+      assert.equal(M.operator.lor(false, nil),nil)
+    end)
+
+     it('lnot returns not a', function()
+      assert.equal(M.operator.lnot(true),false)
+      assert.equal(M.operator.lnot(false),true)
+      assert.equal(M.operator.lnot(nil),true)
+    end)   
+    
+  end)
+  
+  describe('Length operator', function()
+  
+    it('length returns #a', function()
+      assert.equal(M.operator.length({}),0)
+      assert.equal(M.operator.length({2}),1)
+      assert.equal(M.operator.length({3,5,3}),3)
+      assert.equal(M.operator.length('hello'),5)
+    end) 
+    
+  end)
+  
+  describe('Concatenation operator', function()
+  
+    it('concat returns a..b', function()
+      assert.equal(M.operator.concat('a','b'),'ab')
+      assert.equal(M.operator.concat('1','2'),'12')
+    end) 
+    
+  end)  
+  
+  describe('Aliases', function()
+  
+    it('op is an alias to operator', function()
+      assert.equal(M.operator, M.op)
+    end) 
+    
+    it('pow is an alias to exp', function()
+      assert.equal(M.operator.exp, M.operator.pow)
+    end)   
+    
+    it('neg is an alias to unm', function()
+      assert.equal(M.operator.neg, M.operator.unm)
+    end)
+    
+    it('len is alias to length', function()
+      assert.equal(M.operator.length,M.operator.len)
+    end)
+  
+  end)
+  
+end)
\ No newline at end of file
diff -pruN 1.6.1+git20170613-2/spec/table_spec.lua 2.0.0-3/spec/table_spec.lua
--- 1.6.1+git20170613-2/spec/table_spec.lua	2017-06-03 16:42:55.000000000 +0000
+++ 2.0.0-3/spec/table_spec.lua	2018-08-23 16:26:20.000000000 +0000
@@ -1,665 +1,655 @@
 require 'luacov'
-local _ = require 'moses'
+local M = require 'moses'
 
-context('Table functions specs', function()
+describe('Table functions specs', function()
 
-  context('clear', function()
+  describe('clear', function()
 	
-		test('', function()
-			local t = _.clear({'a', true, 'hello'})
-			assert_true(_.isEqual(t,{}))
-			assert_nil(next(t))
+		it('', function()
+			local t = M.clear({'a', true, 'hello'})
+			assert.is_true(M.isEqual(t,{}))
+			assert.is_nil(next(t))
 		end)
 	
 	end)
 	
-	context('each', function()
-  
-    test('provides values and iteration count ', function()
-      local t = {1,2,3}
-      local inc = 0
-      _.each(t,function(i,v)
-        inc = inc+1
-        assert_equal(i,inc)
-        assert_equal(t[i],v)
-      end)
-    end)  
-  
-    test('can reference the given table', function()
-      local t = {1,2,3}
-      _.each(t,function(i,v,mul)
-        t[i] = v*mul
-      end,5)
-      assert_true(_.isEqual(t,{5,10,15}))
-    end)
-    
-    test('iterates over non-numeric keys and objects', function()
-      local t = {one = 1, two = 2, three = 3}
-      local copy = {}
-      _.each(t,function(i,v) copy[i] = v end)
-      assert_true(_.isEqual(t,copy))
-    end)
-    
-  end)  
+	describe('each', function()
+
+		it('provides values and iteration count ', function()
+		  local t = {4,2,1}
+		  local inc = 0
+		  M.each(t,function(v, i)
+			inc = inc+1
+			assert.equal(i,inc)
+			assert.equal(t[i],v)
+		  end)
+		end)  
+	  
+		it('can reference the given table', function()
+		  local t = {1,2,3}
+		  M.each(t,function(v,i,mul)
+			t[i] = v*mul
+		  end,5)
+		  assert.is_true(M.isEqual(t,{5,10,15}))
+		end)
+		
+		it('iterates over non-numeric keys and objects', function()
+		  local t = {one = 1, two = 2, three = 3}
+		  local copy = {}
+		  M.each(t,function(v,i) copy[i] = v end)
+		  assert.is_true(M.isEqual(t,copy))
+		end)
+
+	end)  
 
-  context('eachi', function()
+  describe('eachi', function()
   
-    test('provides values and iteration count for integer keys only, in a sorted way', function()
-      local t = {1,2,3}
+    it('provides values and iteration count for integer keys only, in a sorted way', function()
+      local t = {4,2,1}
       local inc = 0
-      _.eachi(t,function(i,v)
+      M.eachi(t,function(v,i)
         inc = inc+1
-        assert_equal(i,inc)
-        assert_equal(t[i],v)
+        assert.equal(i,inc)
+        assert.equal(t[i],v)
       end)
     end)  
 
-    test('ignores non-integer keys', function()
+    it('ignores non-integer keys', function()
       local t = {a = 1, b = 2, [0] = 1, [-1] = 6, 3, x = 4, 5}
       local rk = {-1, 0, 1, 2}
       local rv = {6, 1, 3, 5}
       local inc = 0
-      _.eachi(t,function(i,v)
+      M.eachi(t,function(v,i)
         inc = inc+1
-        assert_equal(i,rk[inc])
-        assert_equal(v,rv[inc])
+        assert.equal(i,rk[inc])
+        assert.equal(v,rv[inc])
       end)
     end)  
     
   end)  
  
-  context('at', function()
+  describe('at', function()
   
-    test('returns an array of values at numeric keys', function()
+    it('returns an array of values at numeric keys', function()
       local t = {4,5,6}
-      local values = _.at(t,1,2,3)
-      assert_true(_.isEqual(values, t))
+      local values = M.at(t,1,2,3)
+      assert.is_true(M.isEqual(values, t))
       
       local t = {a = 4, bb = true, ccc = false}
-      local values = _.at(t,'a', 'ccc')
-      assert_true(_.isEqual(values, {4, false}))       
+      local values = M.at(t,'a', 'ccc')
+      assert.is_true(M.isEqual(values, {4, false}))       
     end)
     
   end)
   
-  context('count', function()
+  describe('adjust', function()
+  
+    it('adjusts a given value in a table using a function', function()
+      local double = function(v) return v * 2 end
+      local t = {1,2,3}
+      assert.is_true(M.isEqual(M.adjust(t,1,double),{2,2,3}))
+      assert.is_true(M.isEqual(M.adjust(t,2,double),{1,4,3}))
+      assert.is_true(M.isEqual(M.adjust(t,3,double),{1,2,6}))
+    end)
     
-    test('count the occurences of value in a list', function()
-      assert_equal(_.count({1,1,2,3,3,3,2,4,3,2},1),2)
-      assert_equal(_.count({1,1,2,3,3,3,2,4,3,2},2),3)
-      assert_equal(_.count({1,1,2,3,3,3,2,4,3,2},3),4)
-      assert_equal(_.count({1,1,2,3,3,3,2,4,3,2},4),1)
-      assert_equal(_.count({1,1,2,3,3,3,2,4,3,2},5),0)
-      assert_equal(_.count({false, false, true},false),2)
-      assert_equal(_.count({false, false, true},true),1)
-      assert_equal(_.count({{1,1},{1,1},{1,1},{2,2}},{1,1}),3)
-      assert_equal(_.count({{1,1},{1,1},{1,1},{2,2}},{2,2}),1)    
-    end)
-    
-    test('defaults to size when value is not given', function()
-      assert_equal(_.count({1,1,2,3,3,3,2,4,3,2}),_.size({1,1,2,3,3,3,2,4,3,2}))
-      assert_equal(_.count({false, false, true}),_.size({false, false, true}))  
+    it('adjusts a given value in a table using a value', function()
+      local t = {1,2,3}
+      assert.is_true(M.isEqual(M.adjust(t,1,5),{5,2,3}))
+      assert.is_true(M.isEqual(M.adjust(t,2,-2),{1,-2,3}))
     end)
-  end)
+    
+    it('throws an error if key is not found in table', function()
+      local double = function(v) return v * 2 end
+      local t = {x = 1}
+      assert.error(function() M.adjust(t,'y', 2) end)
+    end)    
+    
+  end)  
   
-  context('countf', function()
+  describe('count', function()
     
-    test('count the occurences of values passing an iterator test in a list', function()
-      assert_equal(_.countf({1,2,3,4,5,6}, function(i,v)
-        return v%2==0
-      end),3)
-      assert_equal(_.countf({print, pairs, os, assert, ipairs}, function(i,v)
-        return type(v)=='function'
-      end),4)      
+    it('count the occurences of value in a list', function()
+      assert.equal(M.count({1,1,2,3,3,3,2,4,3,2},1),2)
+      assert.equal(M.count({1,1,2,3,3,3,2,4,3,2},2),3)
+      assert.equal(M.count({1,1,2,3,3,3,2,4,3,2},3),4)
+      assert.equal(M.count({1,1,2,3,3,3,2,4,3,2},4),1)
+      assert.equal(M.count({1,1,2,3,3,3,2,4,3,2},5),0)
+      assert.equal(M.count({false, false, true},false),2)
+      assert.equal(M.count({false, false, true},true),1)
+      assert.equal(M.count({{1,1},{1,1},{1,1},{2,2}},{1,1}),3)
+      assert.equal(M.count({{1,1},{1,1},{1,1},{2,2}},{2,2}),1)    
+    end)
+    
+    it('defaults to size when value is not given', function()
+      assert.equal(M.count({1,1,2,3,3,3,2,4,3,2}),M.size({1,1,2,3,3,3,2,4,3,2}))
+      assert.equal(M.count({false, false, true}),M.size({false, false, true}))  
+    end)
+  end)
+  
+  describe('countf', function()
+    it('count the occurences of values passing an iterator test in a list', function()
+      assert.equal(M.countf({1,2,3,4,5,6}, function(v) return v%2==0 end),3)
+      assert.equal(M.countf({print, pairs, ipairs}, function(v) return type(v)=='function' end),3)
     end)
   end)
   
-  context('cycle', function()
+  describe('cycle', function()
     
-    test('loops n times on a list', function()
+    it('loops n times on a list', function()
       local times = 3
       local t = {1,2,3,4,5}
       local kv = {}
-      for k,v in _.cycle(t,times) do
-        assert_equal(t[k],v)
+      for v,k in M.cycle(t,times) do
+        assert.equal(t[k],v)
         kv[#kv+1] = v
       end
       for k,v in ipairs(kv) do
-        assert_equal(_.count(kv,v),times)
+        assert.equal(M.count(kv,v),times)
       end
     end)
     
-    test('support array-like and map-like tables', function()
+    it('support array-like and map-like tables', function()
       local times = 10
       local t = {x = 1, z = 2}
       local keys = {}
       local values = {}
-      for k,v in _.cycle(t,times) do
-        assert_equal(t[k],v)
+      for v,k in M.cycle(t,times) do
+        assert.equal(t[k],v)
         keys[#keys+1] = k
         values[#values+1] = v
       end
       for k,v in ipairs(keys) do
-        assert_equal(_.count(keys,v),times)
+        assert.equal(M.count(keys,v),times)
       end
       for k,v in ipairs(values) do
-        assert_equal(_.count(values,v),times)
+        assert.equal(M.count(values,v),times)
       end      
     end)
     
-    test('n defaults to 1, if not supplied', function()
+    it('n defaults to 1, if not supplied', function()
       local t = {1,2,3,4,5}
-      for k,v in _.cycle(t) do
+      for v,k in M.cycle(t) do
         t[k] = v + 1
       end
-      _.each(t, function(k, v)
-        assert_equal(v, k + 1)
+      M.each(t, function(v, k)
+        assert.equal(v, k + 1)
       end)
     end)   
     
-    test('if n is negative or equal to 0, it does nothing', function()
+    it('if n is negative or equal to 0, it does nothing', function()
       local t = {1,2,3,4,5}
-      for k,v in _.cycle(t, 0) do
+      for v,k in M.cycle(t, 0) do
         t[k] = v + 1
       end
-      for k,v in _.cycle(t, -2) do
+      for v,k in M.cycle(t, -2) do
         t[k] = v + 1
       end      
-      _.each(t, function(k, v)
-        assert_equal(v, k)
+      M.each(t, function(v, k)
+        assert.equal(v, k)
       end)
     end)     
   end)
   
-  context('map', function()
+  describe('map', function()
   
-    test('applies an iterator function over each key-value pair ', function()
-      assert_true(_.isEqual(_.map({1,2,3},function(i,v) 
+    it('applies an iterator function over each key-value pair ', function()
+      assert.is_true(M.isEqual(M.map({1,2,3},function(v) 
           return v+10 
         end),{11,12,13}))
     end)
 
-    test('iterates over non-numeric keys and objects', function()
-      assert_true(_.isEqual(_.map({a = 1, b = 2},function(k,v) 
+    it('iterates over non-numeric keys and objects', function()
+      assert.is_true(M.isEqual(M.map({a = 1, b = 2},function(v,k) 
           return k..v 
         end),{a = 'a1',b = 'b2'}))
     end)
 
-    test('maps key-value pairs to key-value pairs', function()
-      assert_true(_.isEqual(_.map({a = 1, b = 2}, function(k, v)
+    it('maps key-value pairs to key-value pairs', function()
+      assert.is_true(M.isEqual(M.map({a = 1, b = 2}, function(v, k)
           return k .. k, v + 10
         end), {aa = 11, bb = 12}))
     end)
     
   end)
   
-  context('reduce', function()
+  describe('reduce', function()
   
-    test('folds a collection (left to right) from an initial state', function()
-      assert_equal(_.reduce({1,2,3,4},function(memo,v) return memo+v end,0),10)
+    it('folds a collection (left to right) from an initial state', function()
+      assert.equal(M.reduce({1,2,3,4},function(memo,v) return memo+v end,0),10)
     end)
     
-    test('initial state defaults to the first value when not given', function()
-      assert_equal(_.reduce({'a','b','c'},function(memo,v) return memo..v end),'abc')
+    it('initial state defaults to the first value when not given', function()
+      assert.equal(M.reduce({'a','b','c'},function(memo,v) return memo..v end),'abc')
     end)    
   
-    test('supports arrays of booleans', function()
-      assert_equal(_.reduce({true, false, true, true},function(memo,v) return memo and v end), false)
-      assert_equal(_.reduce({true, true, true},function(memo,v) return memo and v end), true)
-      assert_equal(_.reduce({false, false, false},function(memo,v) return memo and v end), false)
-      assert_equal(_.reduce({false, false, true},function(memo,v) return memo or v end), true)
+    it('supports arrays of booleans', function()
+      assert.equal(M.reduce({true, false, true, true},function(memo,v) return memo and v end), false)
+      assert.equal(M.reduce({true, true, true},function(memo,v) return memo and v end), true)
+      assert.equal(M.reduce({false, false, false},function(memo,v) return memo and v end), false)
+      assert.equal(M.reduce({false, false, true},function(memo,v) return memo or v end), true)
     end)
     
   end)
 	
-  context('reduceby', function()
+  describe('reduceby', function()
   
-    test('folds a collection (left to right) for specific values', function()
-			local function even(_,v) return v%2==0 end
-			local function odd(_,v) return v%2~=0 end
-      assert_equal(_.reduceby({1,2,3,4},function(memo,v) return memo+v end,0,even), 6)
-      assert_equal(_.reduceby({1,2,3,4},function(memo,v) return memo+v end,0,odd), 4)
+    it('folds a collection (left to right) for specific values', function()
+			local function even(v) return v%2==0 end
+			local function odd(v) return v%2~=0 end
+      assert.equal(M.reduceby({1,2,3,4},function(memo,v) return memo+v end,even,0), 6)
+      assert.equal(M.reduceby({1,2,3,4},function(memo,v) return memo+v end,odd,0), 4)
     end)
    
   end)	
   
-  context('reduceRight', function()
+  describe('reduceRight', function()
   
-    test('folds a collection (right to left) from an initial state', function()
-      assert_equal(_.reduceRight({1,2,4,16},function(memo,v) return memo/v end,256),2)
+    it('folds a collection (right to left) from an initial state', function()
+      assert.equal(M.reduceRight({1,2,4,16},function(memo,v) return memo/v end,256),2)
     end)
     
-    test('initial state defaults to the first value when not given', function()
-      assert_equal(_.reduceRight({'a','b','c'},function(memo,v) return memo..v end),'cba')
+    it('initial state defaults to the first value when not given', function()
+      assert.equal(M.reduceRight({'a','b','c'},function(memo,v) return memo..v end),'cba')
     end)
     
   end)
 
-  context('mapReduce', function()
+  describe('mapReduce', function()
   
-    test('folds a collection (left to right) saving intermediate states', function()
-      assert_true(_.isEqual(_.mapReduce({1,2,4,16},function(memo,v) 
+    it('folds a collection (left to right) saving intermediate states', function()
+      assert.is_true(M.isEqual(M.mapReduce({1,2,4,16},function(memo,v) 
           return memo*v 
         end,0),{0,0,0,0}))
     end)
     
-    test('initial state defaults to the first value when not given', function()
-      assert_true(_.isEqual(_.mapReduce({'a','b','c'},function(memo,v) 
+    it('initial state defaults to the first value when not given', function()
+      assert.is_true(M.isEqual(M.mapReduce({'a','b','c'},function(memo,v) 
           return memo..v 
         end),{'a','ab','abc'}))
     end)  
   
   end)
 
-  context('mapReduceRight', function()
+  describe('mapReduceRight', function()
   
-    test('folds a collection (right to left) saving intermediate states', function()
-      assert_true(_.isEqual(_.mapReduceRight({1,2,4,16},function(memo,v) 
+    it('folds a collection (right to left) saving intermediate states', function()
+      assert.is_true(M.isEqual(M.mapReduceRight({1,2,4,16},function(memo,v) 
           return memo/v 
         end,256),{16,4,2,2}))
     end)
     
-    test('initial state defaults to the first value when not given', function()
-      assert_true(_.isEqual(_.mapReduceRight({'a','b','c'},function(memo,v) 
+    it('initial state defaults to the first value when not given', function()
+      assert.is_true(M.isEqual(M.mapReduceRight({'a','b','c'},function(memo,v) 
           return memo..v 
         end),{'c','cb','cba'}))
     end)
     
   end)  
 
-  context('include', function()
+  describe('include', function()
   
-    test('looks for a value in a collection, returns true when found', function()
-      assert_true(_.include({6,8,10,16,29},16))
+    it('looks for a value in a collection, returns true when found', function()
+      assert.is_true(M.include({6,8,10,16,29},16))
     end)
     
-    test('returns false when value was not found', function()
-      assert_false(_.include({6,8,10,16,29},1))
+    it('returns false when value was not found', function()
+      assert.is_false(M.include({6,8,10,16,29},1))
     end)
     
-    test('can lookup for a object', function()
-      assert_true(_.include({6,{18,{2,6}},10,{18,{2,{3}}},29},{18,{2,{3}}}))
+    it('can lookup for a object', function()
+      assert.is_true(M.include({6,{18,{2,6}},10,{18,{2,{3}}},29},{18,{2,{3}}}))
     end)    
     
-    test('given an iterator, return the first value passing a truth test', function()
-      assert_true(_.include({'a','B','c'}, function(array_value)
+    it('given an iterator, return the first value passing a truth test', function()
+      assert.is_true(M.include({'a','B','c'}, function(array_value)
         return (array_value:upper() == array_value)
       end))
     end) 
     
   end)  
     
-  context('detect', function()
+  describe('detect', function()
   
-    test('looks for the first occurence of value, returns the key where it was found', function()
-      assert_equal(_.detect({6,8,10,16},8),2)
+    it('looks for the first occurence of value, returns the key where it was found', function()
+      assert.equal(M.detect({6,8,10,16},8),2)
     end)
     
-    test('returns nil when value was not found', function()
-      assert_nil(_.detect({nil,true,0,true,true},false))
+    it('returns nil when value was not found', function()
+      assert.is_nil(M.detect({nil,true,0,true,true},false))
     end)
     
-    test('can lookup for a object', function()
-      assert_equal(_.detect({6,{18,{2,6}},10,{18,{2,{3}}},29},{18,{2,6}}),2)
+    it('can lookup for a object', function()
+      assert.equal(M.detect({6,{18,{2,6}},10,{18,{2,{3}}},29},{18,{2,6}}),2)
     end)    
     
-    test('given an iterator, return the key of the first value passing a truth test', function()
-      assert_equal(_.detect({'a','B','c'}, function(array_value)
+    it('given an iterator, return the key of the first value passing a truth test', function()
+      assert.equal(M.detect({'a','B','c'}, function(array_value)
         return (array_value:upper() == array_value)
       end),2)
     end)   
   
   end) 
  
-	context('where', function()
+	describe('where', function()
 	
-    test('Returns all values in a list having all of a given set of properties', function()
+    it('Returns all values in a list having all of a given set of properties', function()
       local set = {
 				{a = 1, b = 2},
 				{a = 2, b = 2},
 				{a = 2, b = 4},
 				{a = 3, b = 4}
 			}
-      assert_true(_.isEqual(_.where(set, {a = 2}), {set[2],set[3]}))
-      assert_true(_.isEqual(_.where(set, {b = 4}), {set[3],set[4]}))
-      assert_true(_.isEqual(_.where(set, {a = 2, b = 2}), {set[2]}))
+      assert.is_true(M.isEqual(M.where(set, {a = 2}), {set[2],set[3]}))
+      assert.is_true(M.isEqual(M.where(set, {b = 4}), {set[3],set[4]}))
+      assert.is_true(M.isEqual(M.where(set, {a = 2, b = 2}), {set[2]}))
     end)
     
-    test('returns nil when value was not found', function()
+    it('returns nil when value was not found', function()
       local set = {
 				{a = 1, b = 2},
 				{a = 2, b = 2},
 			}
-      assert_nil(_.where(set, {a = 3}))
-      assert_nil(_.where(set, {b = 1}))
+      assert.is_nil(M.where(set, {a = 3}))
+      assert.is_nil(M.where(set, {b = 1}))
     end) 	
 	
 	end)
 	
-  context('findWhere', function()
+  describe('findWhere', function()
   
-    test('Returns the first value in a list having all of a given set of properties', function()
+    it('Returns the first value in a list having all of a given set of properties', function()
       local a = {a = 1, b = 2}
       local b = {a = 2, b = 3}
       local c = {a = 3, b = 4}
-      assert_equal(_.findWhere({a, b, c}, {a = 3, b = 4}), c)
+      assert.equal(M.findWhere({a, b, c}, {a = 3, b = 4}), c)
     end)
     
-    test('returns nil when value was not found', function()
+    it('returns nil when value was not found', function()
       local a = {a = 1, b = 2}
       local b = {a = 2, b = 3}
       local c = {a = 3, b = 4}
-      assert_nil(_.findWhere({a, b, c}, {a = 3, b = 0}))
+      assert.is_nil(M.findWhere({a, b, c}, {a = 3, b = 0}))
     end) 
   
   end) 
    
-  context('select', function()
+  describe('select', function()
   
-    test('collects all values passing a truth test with an iterator', function()
-      assert_true(_.isEqual(_.select({1,2,3,4,5,6,7}, function(key,value) 
+    it('collects all values passing a truth test with an iterator', function()
+      assert.is_true(M.isEqual(M.select({7,6,5,4,3,2,1}, function(value) 
           return (value%2==0)
-        end),{2,4,6}))
+        end),{6,4,2}))
         
-      assert_true(_.isEqual(_.select({1,2,3,4,5,6,7}, function(key,value) 
+      assert.is_true(M.isEqual(M.select({7,6,5,4,3,2,1}, function(value) 
           return (value%2~=0)
-        end),{1,3,5,7}))        
+        end),{7,5,3,1}))        
     end)
     
   end) 
    
-  context('reject', function()
+  describe('reject', function()
   
-    test('collects all values failing a truth test with an iterator', function()
-      assert_true(_.isEqual(_.reject({1,2,3,4,5,6,7}, function(key,value) 
+    it('collects all values failing a truth test with an iterator', function()
+      assert.is_true(M.isEqual(M.reject({7,6,5,4,3,2,1}, function(value) 
           return (value%2==0)
-        end),{1,3,5,7}))
+        end),{7,5,3,1}))
         
-      assert_true(_.isEqual(_.reject({1,2,3,4,5,6,7}, function(key,value) 
+      assert.is_true(M.isEqual(M.reject({7,6,5,4,3,2,1}, function(value) 
           return (value%2~=0)
-        end),{2,4,6}))        
+        end),{6,4,2}))        
     end)
     
   end) 
     
-  context('all', function()
+  describe('all', function()
   
-    test('returns whether all elements matches a truth test', function()
-      assert_true(_.all({2,4,6}, function(key,value) 
+    it('returns whether all elements matches a truth test', function()
+      assert.is_true(M.all({2,4,6}, function(value) 
           return (value%2==0)
         end))
         
-      assert_false(_.all({false,true,false}, function(key,value) 
+      assert.is_false(M.all({false,true,false}, function(value) 
           return value == false
         end))        
     end) 
     
   end) 
  
-  context('invoke', function()
+  describe('invoke', function()
   
-    test('calls an iterator over each object, passing it as a first arg', function()
-      assert_true(_.isEqual(_.invoke({'a','bea','cdhza'},string.len),
+    it('calls an iterator over each object, passing it as a first arg', function()
+      assert.is_true(M.isEqual(M.invoke({'a','bea','cdhza'},string.len),
         {1,3,5}))
 
-      assert_true(_.isEqual(_.invoke({{2,3,2},{13,8,10},{0,-5}},_.sort),
+      assert.is_true(M.isEqual(M.invoke({{2,3,2},{13,8,10},{0,-5}},M.sort),
         {{2,2,3},{8,10,13},{-5,0}}))
         
-      assert_true(_.isEqual(_.invoke({{x = 1, y = 2},{x = 3, y=4}},'x'), {1,3}))
+      assert.is_true(M.isEqual(M.invoke({{x = 1, y = 2},{x = 3, y=4}},'x'), {1,3}))
     end)
    
-    test('given a string, calls the matching object property the same way', function()
+    it('given a string, calls the matching object property the same way', function()
       local a = {}; function a:call() return self end
       local b, c, d = {}, {}, {}
       b.call, c.call, d.call = a.call, a.call, a.call
-      assert_true(_.isEqual(_.invoke({a,b,c,d},'call'),
+      assert.is_true(M.isEqual(M.invoke({a,b,c,d},'call'),
         {a,b,c,d}))        
     end)      
     
   end) 
 
-  context('pluck', function()
+  describe('pluck', function()
   
-    test('fetches a property value in a collection of objects', function()
+    it('fetches a property value in a collection of objects', function()
     
       local peoples = {
         {name = 'John', age = 23},{name = 'Peter', age = 17},
         {name = 'Steve', age = 15},{age = 33}}
         
-      assert_true(_.isEqual(_.pluck(peoples,'age'),
+      assert.is_true(M.isEqual(M.pluck(peoples,'age'),
         {23,17,15,33}))
-      assert_true(_.isEqual(_.pluck(peoples,'name'),
+      assert.is_true(M.isEqual(M.pluck(peoples,'name'),
         {'John','Peter','Steve'}))
         
     end)
    
   end) 
    
-  context('max', function()
+  describe('max', function()
   
-    test('returns the maximum targetted property value in a collection of objects', function()    
+    it('returns the maximum targetted property value in a collection of objects', function()    
       local peoples = {
         {name = 'John', age = 23},{name = 'Peter', age = 17},
         {name = 'Steve', age = 15},{age = 33}}        
-      assert_equal(_.max(_.pluck(peoples,'age')),33)
-      assert_equal(_.max(peoples,function(people) return people.age end),peoples[4])        
+      assert.equal(M.max(M.pluck(peoples,'age')),33)
+      assert.equal(M.max(peoples,function(people) return people.age end),33)        
     end)
     
-    test('directly compares items when given no iterator', function()
-        assert_equal(_.max({'a','b','c'}),'c')        
+    it('directly compares items when given no iterator', function()
+        assert.equal(M.max({'a','b','c'}),'c')        
     end)    
    
   end) 
 
-  context('min', function()
+  describe('min', function()
   
-    test('returns the maximum targetted property value in a collection of objects', function()    
+    it('returns the maximum targetted property value in a collection of objects', function()    
       local peoples = {
         {name = 'John', age = 23},{name = 'Peter', age = 17},
         {name = 'Steve', age = 15},{age = 33}}        
-      assert_equal(_.min(_.pluck(peoples,'age')),15)
-      assert_equal(_.min(peoples,function(people) return people.age end),peoples[3])        
+      assert.equal(M.min(M.pluck(peoples,'age')),15)
+      assert.equal(M.min(peoples,function(people) return people.age end),15)        
     end)
     
-    test('directly compares items when given no iterator', function()
-        assert_equal(_.min({'a','b','c'}),'a')        
+    it('directly compares items when given no iterator', function()
+        assert.equal(M.min({'a','b','c'}),'a')        
     end)    
   
-  end)
-  
-  context('shuffle', function()
-  
-    test('shuffles values and objects in a collection', function()    
-      local values = {'a','b','c','d'}       
-      assert_true(_.same(_.shuffle (values),values))
-    end)
-    
-    test('can accept a seed value to init randomization', function()    
-      local values = {'a','b','c','d'}
-      local seed = os.time()
-      assert_true(_.same(_.shuffle(values,seed),values))
-    end)   
-
-    test('shuffled table has the same elements in a different order', function()    
-      local values = {'a','b','c','d'}
-      assert_true(_.same(_.shuffle(values),values))
-      assert_true(_.same(_.shuffle(values),values))
-    end)   
-  
   end)   
 
-  context('same', function()
+  describe('same', function()
   
-    test('returns whether all objects from both given tables exists in each other', function()    
+    it('returns whether all objects from both given tables exists in each other', function()    
       local a = {'a','b','c','d'}      
       local b = {'b','a','d','c'}      
-      assert_true(_.same(a,b))
+      assert.is_true(M.same(a,b))
       b[#b+1] = 'e'
-      assert_false(_.same(a,b))
+      assert.is_false(M.same(a,b))
     end)  
   
   end)   
    
-  context('sort', function()
+  describe('sort', function()
   
-    test('sorts a collection with respect to a given comparison function', function()            
-      assert_true(_.isEqual(_.sort({'b','a','d','c'}, function(a,b) 
+    it('sorts a collection with respect to a given comparison function', function()            
+      assert.is_true(M.isEqual(M.sort({'b','a','d','c'}, function(a,b) 
           return a:byte() < b:byte() 
         end),{'a','b','c','d'}))
     end)
 
-    test('uses "<" operator when no comparison function is given', function()            
-      assert_true(_.isEqual(_.sort({'b','a','d','c'}),{'a','b','c','d'}))
+    it('uses "<" operator when no comparison function is given', function()            
+      assert.is_true(M.isEqual(M.sort({'b','a','d','c'}),{'a','b','c','d'}))
     end)     
   
   end)
 
-	context('sortBy', function()
+	describe('sortBy', function()
 	
-		test('sort values on the result of a transform function', function()
-			assert_true(_.isEqual(_.sortBy({1,2,3,4,5}, math.sin), {5,4,3,1,2}))
+		it('sort values on the result of a transform function', function()
+			assert.is_true(M.isEqual(M.sortBy({1,2,3,4,5}, math.sin), {5,4,3,1,2}))
 		end)
 		
-		test('the transform function defaults to _.identity', function()
-			assert_true(_.isEqual(_.sortBy({1,2,3,4,5}), {1,2,3,4,5}))
+		it('the transform function defaults to M.identity', function()
+			assert.is_true(M.isEqual(M.sortBy({1,2,3,4,5}), {1,2,3,4,5}))
 		end)
 
-		test('transform function can be a string name property', function()
+		it('transform function can be a string name property', function()
 			local unsorted = {{item = 1, value = 10},{item = 2, value = 5},{item = 3, value = 8}}
 			local sorted = {{item = 2, value = 5},{item = 3, value = 8},{item = 1, value = 10}}
-			assert_true(_.isEqual(_.sortBy(unsorted, 'value'), sorted))
+			assert.is_true(M.isEqual(M.sortBy(unsorted, 'value'), sorted))
 		end)
 		
-		test('can use a custom comparison function', function()
+		it('can use a custom comparison function', function()
 			local unsorted = {{item = 1, value = 10},{item = 2, value = 5},{item = 3, value = 8}}
 			local sorted = {{item = 1, value = 10},{item = 3, value = 8},{item = 2, value = 5}}
 			local function comp(a,b) return a > b end
-			assert_true(_.isEqual(_.sortBy(unsorted, 'value', comp), sorted))
+			assert.is_true(M.isEqual(M.sortBy(unsorted, 'value', comp), sorted))
 		end)		
 	
 	end)
   
-  context('groupBy', function()
+  describe('groupBy', function()
   
-    test('splits a collection into subsets of items behaving the same', function()
+    it('splits a collection into subsets of items behaving the same', function()
 
-      assert_true(_.isEqual(_.groupBy({0,1,2,3,4,5,6},function(i,value) 
+      assert.is_true(M.isEqual(M.groupBy({0,1,2,3,4,5,6},function(value) 
           return value%2==0 and 'even' or 'odd'
         end),{even = {0,2,4,6},odd = {1,3,5}}))
         
-      assert_true(_.isEqual(_.groupBy({0,'a',true, false,nil,b,0.5},function(i,value) 
-          return type(value) 
-        end),{number = {0,0.5},string = {'a'},boolean = {true,false}}))
+      assert.is_true(M.isEqual(M.groupBy({0,'a',true, false,nil,b,0.5},type),{number = {0,0.5},string = {'a'},boolean = {true,false}}))
         
-      assert_true(_.isEqual(_.groupBy({'one','two','three','four','five'},function(i,value) 
-          return value:len()
-        end),{[3] = {'one','two'},[4] = {'four','five'},[5] = {'three'}}))
+      assert.is_true(M.isEqual(M.groupBy({'one','two','three','four','five'},string.len),{[3] = {'one','two'},[4] = {'four','five'},[5] = {'three'}}))
         
     end)
     
-    test('can takes extra-args', function()
+    it('can takes extra-args', function()
     
-      assert_true(_.isEqual(_.groupBy({3,9,10,12,15}, function(k,v,x) return v%x == 0 end,2), {[false] = {3,9,15}, [true] = {10,12}}))
-      assert_true(_.isEqual(_.groupBy({3,9,10,12,15}, function(k,v,x) return v%x == 0 end,3), {[false] = {10}, [true] = {3,9,12,15}}))
+      assert.is_true(M.isEqual(M.groupBy({3,9,10,12,15}, function(v,k,x) return v%x == 0 end,2), {[false] = {3,9,15}, [true] = {10,12}}))
+      assert.is_true(M.isEqual(M.groupBy({3,9,10,12,15}, function(v,k,x) return v%x == 0 end,3), {[false] = {10}, [true] = {3,9,12,15}}))
       
     end)
   
   end)   
 
-  context('countBy', function()
+  describe('countBy', function()
   
-    test('splits a collection in subsets and counts items inside', function()
+    it('splits a collection in subsets and counts items inside', function()
 
-      assert_true(_.isEqual(_.countBy({0,1,2,3,4,5,6},function(i,value) 
+      assert.is_true(M.isEqual(M.countBy({0,1,2,3,4,5,6},function(value) 
           return value%2==0 and 'even' or 'odd'
         end),{even = 4,odd = 3}))
         
-      assert_true(_.isEqual(_.countBy({0,'a',true, false,nil,b,0.5},function(i,value) 
-          return type(value) 
-        end),{number = 2,string = 1,boolean = 2}))
-        
-      assert_true(_.isEqual(_.countBy({'one','two','three','four','five'},function(i,value) 
-          return value:len()
-        end),{[3] = 2,[4] = 2,[5] = 1}))
+      assert.is_true(M.isEqual(M.countBy({0,'a',true, false,nil,b,0.5},type),{number = 2,string = 1,boolean = 2}))
+        
+      assert.is_true(M.isEqual(M.countBy({'one','two','three','four','five'},string.len),{[3] = 2,[4] = 2,[5] = 1}))
         
     end)     
   
   end)   
 
-  context('size', function()
+  describe('size', function()
   
-    test('counts the very number of objects in a collection', function()      
-      assert_equal(_.size {1,2,3},3)        
+    it('counts the very number of objects in a collection', function()      
+      assert.equal(M.size {1,2,3},3)        
     end)
     
-    test('counts nested tables elements as an unique value', function()      
-      assert_equal(_.size {1,2,3,{4,5}},4)        
+    it('counts nested tables elements as an unique value', function()      
+      assert.equal(M.size {1,2,3,{4,5}},4)        
     end)
 
-    test('leaves nil values', function()      
-      assert_equal(_.size {1,2,3,nil,8},4)        
+    it('leaves nil values', function()      
+      assert.equal(M.size {1,2,3,nil,8},4)        
     end)
     
-    test('counts objects', function()      
-      assert_equal(_.size {one = 1,2,b = 3, [{}] = 'nil', 'c', [function() end] = 'foo'},6)   
+    it('counts objects', function()      
+      assert.equal(M.size {one = 1,2,b = 3, [{}] = 'nil', 'c', [function() end] = 'foo'},6)   
     end)
     
-    test('returns the size of the first arg when it is a table', function()      
-      assert_equal(_.size ({1,2},3,4,5),2)   
+    it('returns the size of the first arg when it is a table', function()      
+      assert.equal(M.size ({1,2},3,4,5),2)   
     end)    
 
-    test('counts the number of non-nil args when the first one is not a table', function()      
-      assert_equal(_.size (1,3,4,5),4)
-      assert_equal(_.size (nil,1,3,4,5),4)
-      assert_equal(_.size (nil,1,3,4,nil,5),4)
+    it('counts the number of non-nil args when the first one is not a table', function()      
+      assert.equal(M.size (1,3,4,5),4)
+      assert.equal(M.size (nil,1,3,4,5),4)
+      assert.equal(M.size (nil,1,3,4,nil,5),4)
     end)  
  
-    test('handles nil', function()      
-      assert_equal(_.size(),0)
-      assert_equal(_.size(nil),0)
+    it('handles nil', function()      
+      assert.equal(M.size(),0)
+      assert.equal(M.size(nil),0)
     end)
 
 		
   end)   
 
-  context('containsKeys', function()
+  describe('containsKeys', function()
   
-    test('returns whether a table has all the keys from a given list', function()      
-      assert_true(_.containsKeys({1,2,3},{1,2,3}))
-      assert_true(_.containsKeys({x = 1, y = 2},{x = 1,y =2}))
+    it('returns whether a table has all the keys from a given list', function()      
+      assert.is_true(M.containsKeys({1,2,3},{1,2,3}))
+      assert.is_true(M.containsKeys({x = 1, y = 2},{x = 1,y =2}))
     end)
     
-    test('does not compare values', function()      
-      assert_true(_.containsKeys({1,2,3},{4,5,6}))
-      assert_true(_.containsKeys({x = 1, y = 2},{x = 4,y = -1}))
+    it('does not compare values', function()      
+      assert.is_true(M.containsKeys({1,2,3},{4,5,6}))
+      assert.is_true(M.containsKeys({x = 1, y = 2},{x = 4,y = -1}))
     end)
 
-    test('is not commutative', function()      
-      assert_true(_.containsKeys({1,2,3,4},{4,5,6}))      
-      assert_true(_.containsKeys({x = 1, y = 2,z = 5},{x = 4,y = -1}))
-      assert_false(_.containsKeys({1,2,3},{4,5,6,7}))
-      assert_false(_.containsKeys({x = 1, y = 2},{x = 4,y = -1,z = 0}))
+    it('is not commutative', function()      
+      assert.is_true(M.containsKeys({1,2,3,4},{4,5,6}))      
+      assert.is_true(M.containsKeys({x = 1, y = 2,z = 5},{x = 4,y = -1}))
+      assert.is_false(M.containsKeys({1,2,3},{4,5,6,7}))
+      assert.is_false(M.containsKeys({x = 1, y = 2},{x = 4,y = -1,z = 0}))
     end)
     
   end) 
 
-  context('sameKeys', function()
+  describe('sameKeys', function()
   
-    test('returns whether both tables features the same keys', function()      
-      assert_true(_.sameKeys({1,2,3},{1,2,3}))
-      assert_true(_.sameKeys({x = 1, y = 2},{x = 1,y =2}))
+    it('returns whether both tables features the same keys', function()      
+      assert.is_true(M.sameKeys({1,2,3},{1,2,3}))
+      assert.is_true(M.sameKeys({x = 1, y = 2},{x = 1,y =2}))
     end)
     
-    test('does not compare values', function()      
-      assert_true(_.sameKeys({1,2,3},{4,5,6}))
-      assert_true(_.sameKeys({x = 1, y = 2},{x = 4,y = -1}))
+    it('does not compare values', function()      
+      assert.is_true(M.sameKeys({1,2,3},{4,5,6}))
+      assert.is_true(M.sameKeys({x = 1, y = 2},{x = 4,y = -1}))
     end)
 
-    test('is commutative', function()      
-      assert_false(_.sameKeys({1,2,3,4},{4,5,6}))      
-      assert_false(_.sameKeys({x = 1, y = 2,z = 5},{x = 4,y = -1}))
-      assert_false(_.sameKeys({1,2,3},{4,5,6,7}))
-      assert_false(_.sameKeys({x = 1, y = 2},{x = 4,y = -1,z = 0}))
+    it('is commutative', function()      
+      assert.is_false(M.sameKeys({1,2,3,4},{4,5,6}))      
+      assert.is_false(M.sameKeys({x = 1, y = 2,z = 5},{x = 4,y = -1}))
+      assert.is_false(M.sameKeys({1,2,3},{4,5,6,7}))
+      assert.is_false(M.sameKeys({x = 1, y = 2},{x = 4,y = -1,z = 0}))
     end)
     
   end) 
diff -pruN 1.6.1+git20170613-2/.travis/platform.sh 2.0.0-3/.travis/platform.sh
--- 1.6.1+git20170613-2/.travis/platform.sh	2017-06-03 16:42:55.000000000 +0000
+++ 2.0.0-3/.travis/platform.sh	1970-01-01 00:00:00.000000000 +0000
@@ -1,15 +0,0 @@
-if [ -z "${PLATFORM:-}" ]; then
-  PLATFORM=$TRAVIS_OS_NAME;
-fi
-
-if [ "$PLATFORM" == "osx" ]; then
-  PLATFORM="macosx";
-fi
-
-if [ -z "$PLATFORM" ]; then
-  if [ "$(uname)" == "Linux" ]; then
-    PLATFORM="linux";
-  else
-    PLATFORM="macosx";
-  fi;
-fi
diff -pruN 1.6.1+git20170613-2/.travis/setenv_lua.sh 2.0.0-3/.travis/setenv_lua.sh
--- 1.6.1+git20170613-2/.travis/setenv_lua.sh	2017-06-03 16:42:55.000000000 +0000
+++ 2.0.0-3/.travis/setenv_lua.sh	1970-01-01 00:00:00.000000000 +0000
@@ -1,3 +0,0 @@
-export PATH=${PATH}:$HOME/.lua:$HOME/.local/bin:${TRAVIS_BUILD_DIR}/install/luarocks/bin
-bash .travis/setup_lua.sh
-eval `$HOME/.lua/luarocks path`
diff -pruN 1.6.1+git20170613-2/.travis/setup_lua.sh 2.0.0-3/.travis/setup_lua.sh
--- 1.6.1+git20170613-2/.travis/setup_lua.sh	2017-06-03 16:42:55.000000000 +0000
+++ 2.0.0-3/.travis/setup_lua.sh	1970-01-01 00:00:00.000000000 +0000
@@ -1,122 +0,0 @@
-#! /bin/bash
-
-# A script for setting up environment for travis-ci testing.
-# Sets up Lua and Luarocks.
-# LUA must be "lua5.1", "lua5.2" or "luajit".
-# luajit2.0 - master v2.0
-# luajit2.1 - master v2.1
-
-set -eufo pipefail
-
-LUAJIT_VERSION="2.0.4"
-LUAJIT_BASE="LuaJIT-$LUAJIT_VERSION"
-
-source .travis/platform.sh
-
-LUA_HOME_DIR=$TRAVIS_BUILD_DIR/install/lua
-
-LR_HOME_DIR=$TRAVIS_BUILD_DIR/install/luarocks
-
-mkdir $HOME/.lua
-
-LUAJIT="no"
-
-if [ "$PLATFORM" == "macosx" ]; then
-  if [ "$LUA" == "luajit" ]; then
-    LUAJIT="yes";
-  fi
-  if [ "$LUA" == "luajit2.0" ]; then
-    LUAJIT="yes";
-  fi
-  if [ "$LUA" == "luajit2.1" ]; then
-    LUAJIT="yes";
-  fi;
-elif [ "$(expr substr $LUA 1 6)" == "luajit" ]; then
-  LUAJIT="yes";
-fi
-
-mkdir -p "$LUA_HOME_DIR"
-
-if [ "$LUAJIT" == "yes" ]; then
-
-  if [ "$LUA" == "luajit" ]; then
-    curl --location https://github.com/LuaJIT/LuaJIT/archive/v$LUAJIT_VERSION.tar.gz | tar xz;
-  else
-    git clone https://github.com/LuaJIT/LuaJIT.git $LUAJIT_BASE;
-  fi
-
-  cd $LUAJIT_BASE
-
-  if [ "$LUA" == "luajit2.1" ]; then
-    git checkout v2.1;
-    # force the INSTALL_TNAME to be luajit
-    perl -i -pe 's/INSTALL_TNAME=.+/INSTALL_TNAME= luajit/' Makefile
-  fi
-
-  make && make install PREFIX="$LUA_HOME_DIR"
-
-  ln -s $LUA_HOME_DIR/bin/luajit $HOME/.lua/luajit
-  ln -s $LUA_HOME_DIR/bin/luajit $HOME/.lua/lua;
-
-else
-
-  if [ "$LUA" == "lua5.1" ]; then
-    curl http://www.lua.org/ftp/lua-5.1.5.tar.gz | tar xz
-    cd lua-5.1.5;
-  elif [ "$LUA" == "lua5.2" ]; then
-    curl http://www.lua.org/ftp/lua-5.2.4.tar.gz | tar xz
-    cd lua-5.2.4;
-  elif [ "$LUA" == "lua5.3" ]; then
-    curl http://www.lua.org/ftp/lua-5.3.2.tar.gz | tar xz
-    cd lua-5.3.2;
-  fi
-
-  # Build Lua without backwards compatibility for testing
-  perl -i -pe 's/-DLUA_COMPAT_(ALL|5_2)//' src/Makefile
-  make $PLATFORM
-  make INSTALL_TOP="$LUA_HOME_DIR" install;
-
-  ln -s $LUA_HOME_DIR/bin/lua $HOME/.lua/lua
-  ln -s $LUA_HOME_DIR/bin/luac $HOME/.lua/luac;
-
-fi
-
-cd $TRAVIS_BUILD_DIR
-
-lua -v
-
-LUAROCKS_BASE=luarocks-$LUAROCKS
-
-curl --location http://luarocks.org/releases/$LUAROCKS_BASE.tar.gz | tar xz
-
-cd $LUAROCKS_BASE
-
-if [ "$LUA" == "luajit" ]; then
-  ./configure --lua-suffix=jit --with-lua-include="$LUA_HOME_DIR/include/luajit-2.0" --prefix="$LR_HOME_DIR";
-elif [ "$LUA" == "luajit2.0" ]; then
-  ./configure --lua-suffix=jit --with-lua-include="$LUA_HOME_DIR/include/luajit-2.0" --prefix="$LR_HOME_DIR";
-elif [ "$LUA" == "luajit2.1" ]; then
-  ./configure --lua-suffix=jit --with-lua-include="$LUA_HOME_DIR/include/luajit-2.1" --prefix="$LR_HOME_DIR";
-else
-  ./configure --with-lua="$LUA_HOME_DIR" --prefix="$LR_HOME_DIR"
-fi
-
-make build && make install
-
-ln -s $LR_HOME_DIR/bin/luarocks $HOME/.lua/luarocks
-
-cd $TRAVIS_BUILD_DIR
-
-luarocks --version
-
-rm -rf $LUAROCKS_BASE
-
-if [ "$LUAJIT" == "yes" ]; then
-  rm -rf $LUAJIT_BASE;
-elif [ "$LUA" == "lua5.1" ]; then
-  rm -rf lua-5.1.5;
-elif [ "$LUA" == "lua5.2" ]; then
-  rm -rf lua-5.2.4;
-elif [ "$LUA" == "lua5.3" ]; then
-  rm -rf lua-5.3.2;
-fi
diff -pruN 1.6.1+git20170613-2/.travis.yml 2.0.0-3/.travis.yml
--- 1.6.1+git20170613-2/.travis.yml	2017-06-03 16:42:55.000000000 +0000
+++ 2.0.0-3/.travis.yml	2018-08-23 16:26:20.000000000 +0000
@@ -1,33 +1,32 @@
-language: c
-
+language: python
 sudo: false
 
 env:
-  global:
-    - LUAROCKS=2.3.0
-  matrix:
-    - LUA=lua5.1
-    - LUA=lua5.2
-    - LUA=lua5.3
-    - LUA=luajit     # latest stable version (2.0.4)
-    - LUA=luajit2.0  # current head of 2.0 branch
-    - LUA=luajit2.1  # current head of 2.1 branc
-
-branches:
-  only:
-    - master
+  - LUA="lua=5.1"
+  - LUA="lua=5.2"
+  - LUA="lua=5.3"
+  - LUA="luajit=2.0"
+  - LUA="luajit=2.1"
 
 before_install:
-  - source .travis/setenv_lua.sh
-  - pip install --user cpp-coveralls
-  - luarocks install Lua-cURL         --server=https://luarocks.org/dev
-  - luarocks install luacov-coveralls --server=https://luarocks.org/dev
-  - luarocks install telescope 0.6.0 --server=http://rocks.moonscript.org
+  - pip install hererocks
+  - hererocks lua_install -r^ --$LUA
+  - export PATH=$PATH:$PWD/lua_install/bin # Add directory with all installed binaries to PATH
+
+install:
+  - luarocks install busted
+  - luarocks install luacov
+  - luarocks install luacov-coveralls
 
-script: "tsc -f spec/*"
+script:
+  - busted --verbose --coverage
 
 after_success:
-  - luacov-coveralls -c specs/.luacov
+  - luacov-coveralls --exclude $TRAVIS_BUILD_DIR/lua_install
+
+branches:
+  except:
+    - gh-pages
 
 notifications:
   email:
